/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(G){for(var e=[],L=0,D=G.length;L<D;L++)e[L]=ne[G[L]];return e};define(ne[70],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const R=new Map,A=new Map,j=new Map,b=new Map;function h(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function c(f,E){const v=f.get(E.detail);v&&(v>=0||f.set(E.detail,v+E.timestamp))}let S=[];typeof G=="function"&&typeof G.getStats=="function"&&(S=G.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of S)switch(f.type){case 10:h(R,f);break;case 11:case 12:c(R,f);break;case 21:h(A,f);break;case 22:c(A,f);break;case 33:h(j,f);break;case 34:c(j,f);break;case 31:h(b,f);break;case 32:c(b,f);break}let I=0;j.forEach(f=>I+=f);function d(f){const E=[];return f.forEach((v,m)=>E.push([m,v])),E}return{amdLoad:d(R),amdInvoke:d(A),nodeRequire:d(j),nodeEval:d(b),nodeRequireTotal:I}}static toMarkdownTable(R,A){let j="";const b=[];return R.forEach((h,c)=>{b[c]=h.length}),A.forEach(h=>{h.forEach((c,S)=>{typeof c>"u"&&(c=h[S]="-");const I=c.toString().length;b[S]=Math.max(I,b[S])})}),R.forEach((h,c)=>{j+=`| ${h+" ".repeat(b[c]-h.toString().length)} `}),j+=`|
`,R.forEach((h,c)=>{j+=`| ${"-".repeat(b[c])} `}),j+=`|
`,A.forEach(h=>{h.forEach((c,S)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(b[S]-c.toString().length)} `)}),j+=`|
`}),j}}e.$U=L}),define(ne[52],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function L(j){return(b,h,c)=>{let S=null,I=null;if(typeof c.value=="function"?(S="value",I=c.value):typeof c.get=="function"&&(S="get",I=c.get),!I)throw new Error("not supported");c[S]=j(I,h)}}function D(j,b,h){let c=null,S=null;if(typeof h.value=="function"?(c="value",S=h.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",S=h.get),!S)throw new Error("not supported");const I=`$memoize$${b}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,d)}),this[I]}}e.$hh=D;function R(j,b,h){return L((c,S)=>{const I=`$debounce$${S}`,d=`$debounce$result$${S}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),b&&(this[d]=b(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},j)}})}e.$ih=R;function A(j,b,h){return L((c,S)=>{const I=`$throttle$timer$${S}`,d=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,E=`$throttle$pending$${S}`;return function(...v){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[d]=b(this[d],...v)),this[E])return;const m=this[f]+j;m<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},m-Date.now()))}})}e.$jh=A}),define(ne[71],re([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function D(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(h,c="Unreachable"){throw new Error(c)}e.$4c=R;function A(h){if(!h)throw new L.$cb("Assertion Failed")}e.$5c=A;function j(h){if(!h()){debugger;h(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$6c=j;function b(h,c){let S=0;for(;S<h.length-1;){const I=h[S],d=h[S+1];if(!c(I,d))return!1;S++}return!0}e.$7c=b}),define(ne[53],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,k=0;function y(te){let ae=0,ce=0;for(;ae<te;){const ie=s.charCodeAt(t);if(ie>=48&&ie<=57)ce=ce*16+ie-48;else if(ie>=65&&ie<=70)ce=ce*16+ie-65+10;else if(ie>=97&&ie<=102)ce=ce*16+ie-97+10;else break;t++,ae++}return ae<te&&(ce=-1),ce}function w(te){t=te,n="",r=0,l=16,k=0}function O(){const te=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(te,t);let ae=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ae=t}else k=3;return s.substring(te,ae)}function H(){let te="",ae=t;for(;;){if(t>=i){te+=s.substring(ae,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){te+=s.substring(ae,t),t++;break}if(ce===92){if(te+=s.substring(ae,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):k=4;break}default:k=5}ae=t;continue}if(ce>=0&&ce<=31)if(h(ce)){te+=s.substring(ae,t),k=2;break}else k=6;t++}return te}function _(){if(n="",k=0,r=t,t>=i)return r=i,l=17;let te=s.charCodeAt(t);if(b(te)){do t++,n+=String.fromCharCode(te),te=s.charCodeAt(t);while(b(te));return l=15}if(h(te))return t++,n+=String.fromCharCode(te),te===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(te){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=H(),l=10;case 47:{const ae=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ae,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let ie=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,k=1),n=s.substring(ae,t),l=13}return n+=String.fromCharCode(te),t++,l=16}case 45:if(n+=String.fromCharCode(te),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),l=11;default:for(;t<i&&x(te);)t++,te=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),t++,l=16}}function x(te){if(b(te)||h(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:w,getPosition:()=>t,scan:o?ue:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$Um=j;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(y,w,O,H){r.value=y,r.offset=w,r.length=O,r.type=H,r.colonOffset=void 0,n=r}try{N(s,{onObjectBegin:(y,w)=>{if(o<=y)throw i;n=void 0,l=o>y,t.push("")},onObjectProperty:(y,w,O)=>{if(o<w||(k(y,w,O,"property"),t[t.length-1]=y,o<=w+O))throw i},onObjectEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onArrayBegin:(y,w)=>{if(o<=y)throw i;n=void 0,t.push(0)},onArrayEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onLiteralValue:(y,w,O)=>{if(o<w||(k(y,w,O,P(y)),o<=w+O))throw i},onSeparator:(y,w,O)=>{if(o<=w)throw i;if(y===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(y===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(y){if(y!==i)throw y}return{path:t,previousNode:n,isAtPropertyKey:l,matches:y=>{let w=0;for(let O=0;w<y.length&&O<t.length;O++)if(y[w]===t[O]||y[w]==="*")w++;else if(y[w]!=="**")return!1;return w===y.length}}}e.$Vm=I;function d(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function l(y){Array.isArray(n)?n.push(y):i!==null&&(n[i]=y)}return N(s,{onObjectBegin:()=>{const y={};l(y),r.push(n),n=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(n),n=y,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(y,w,O)=>{o.push({error:y,offset:w,length:O})}},t),n[0]}e.$Wm=d;function f(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}N(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,w,O)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:w,length:O,parent:i})},onObjectEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onArrayBegin:(y,w)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onLiteralValue:(y,w,O)=>{r({type:P(y),offset:w,length:O,parent:i,value:y}),n(w+O)},onSeparator:(y,w,O)=>{i.type==="property"&&(y===":"?i.colonOffset=w:y===","&&n(w))},onError:(y,w,O)=>{o.push({error:y,offset:w,length:O})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$Xm=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Ym=E;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$Zm=v;function m(s){switch(s.type){case"array":return s.children.map(m);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=m(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=m;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$2m=u;function $(s,o,t=!1){if(u(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=$(i[n],o,t);if(r)return r}return s}}e.$3m=$;function N(s,o,t=A.DEFAULT){const i=j(s,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Q){return Q?K=>Q(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),k=r(o.onObjectProperty),y=n(o.onObjectEnd),w=n(o.onArrayBegin),O=n(o.onArrayEnd),H=r(o.onLiteralValue),_=r(o.onSeparator),x=n(o.onComment),ue=r(o.onError),te=t&&t.disallowComments,ae=t&&t.allowTrailingComma;function ce(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Q){case 12:case 13:te?ie(10):x();break;case 16:ie(1);break;case 15:case 14:break;default:return Q}}}function ie(Q,K=[],M=[]){if(ue(Q),K.length+M.length>0){let F=i.getToken();for(;F!==17;){if(K.indexOf(F)!==-1){ce();break}else if(M.indexOf(F)!==-1)break;F=ce()}}}function q(Q){const K=i.getTokenValue();return Q?H(K):k(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(ie(2),Q=0)}catch{ie(2)}H(Q);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),ce(),J()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),ce();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ie(4,[],[]),_(","),ce(),i.getToken()===2&&ae)break}else Q&&ie(6,[],[]);T()||ie(4,[],[2,5]),Q=!0}return y(),i.getToken()!==2?ie(7,[2],[]):ce(),!0}function B(){w(),ce();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ie(4,[],[]),_(","),ce(),i.getToken()===4&&ae)break}else Q&&ie(6,[],[]);J()||ie(4,[],[4,5]),Q=!0}return O(),i.getToken()!==4?ie(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):J()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$4m=N;function p(s,o){const t=j(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$5m=p;function P(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=P}),define(ne[72],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function L(b,h,c){return Math.min(Math.max(b,h),c)}e.$Ol=L;function D(b,h){return(h+b%h)%h}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=R;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=A;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=j}),function(){function G(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function j(h){A.push(h,Date.now())}function b(){const h=[];for(let c=0;c<A.length;c+=2)h.push({name:A[c],startTime:A[c+1]});return h}return{mark:j,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(R+j.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:G)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return G[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=G,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var j in D)L.d(A,j,function(b){return D[b]}.bind(null,j));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(G,e,L){(function(D){var R;e=G.exports=M,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],h=e.src=[],c=0,S=c++;h[S]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[S]+")\\.("+h[S]+")\\.("+h[S]+")";var E=c++;h[E]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var v=c++;h[v]="(?:"+h[S]+"|"+h[d]+")";var m=c++;h[m]="(?:"+h[I]+"|"+h[d]+")";var u=c++;h[u]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var $=c++;h[$]="(?:-?("+h[m]+"(?:\\."+h[m]+")*))";var N=c++;h[N]="[0-9A-Za-z-]+";var p=c++;h[p]="(?:\\+("+h[N]+"(?:\\."+h[N]+")*))";var P=c++,s="v?"+h[f]+h[u]+"?"+h[p]+"?";h[P]="^"+s+"$";var o="[v=\\s]*"+h[E]+h[$]+"?"+h[p]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[S]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[p]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[$]+")?"+h[p]+"?)?)?";var y=c++;h[y]="^"+h[i]+"\\s*"+h[l]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[k]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;h[H]="(?:~>?)";var _=c++;h[_]="(\\s*)"+h[H]+"\\s+",b[_]=new RegExp(h[_],"g");var x=c++;h[x]="^"+h[H]+h[l]+"$";var ue=c++;h[ue]="^"+h[H]+h[k]+"$";var te=c++;h[te]="(?:\\^)";var ae=c++;h[ae]="(\\s*)"+h[te]+"\\s+",b[ae]=new RegExp(h[ae],"g");var ce=c++;h[ce]="^"+h[te]+h[l]+"$";var ie=c++;h[ie]="^"+h[te]+h[k]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",b[T]=new RegExp(h[T],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var B=c++;h[B]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var J=c++;h[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)R(Q,h[Q]),b[Q]||(b[Q]=new RegExp(h[Q]));function K(V,Y){if(V instanceof M)return V;if(typeof V!="string"||V.length>A||!(Y?b[t]:b[P]).test(V))return null;try{return new M(V,Y)}catch{return null}}function M(V,Y){if(V instanceof M){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(V,Y);R("SemVer",V,Y),this.loose=Y;var ee=V.trim().match(Y?b[t]:b[P]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Y){var ee=K(V,Y);return ee?ee.version:null},e.clean=function(V,Y){var ee=K(V.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof M||(V=new M(V,this.loose)),this.compareMain(V)||this.comparePre(V)},M.prototype.compareMain=function(V){return V instanceof M||(V=new M(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},M.prototype.comparePre=function(V){if(V instanceof M||(V=new M(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],$e=V.prerelease[Y];if(R("prerelease compare",Y,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return a(ee,$e)}while(++Y)},M.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new M(V,ee).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Z(V,Y))return null;var ee=K(V),$e=K(Y);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(V,Y){var ee=F.test(V),$e=F.test(Y);return ee&&$e&&(V=+V,Y=+Y),ee&&!$e?-1:$e&&!ee?1:V<Y?-1:V>Y?1:0}function g(V,Y,ee){return new M(V,ee).compare(new M(Y,ee))}function z(V,Y,ee){return g(V,Y,ee)>0}function C(V,Y,ee){return g(V,Y,ee)<0}function Z(V,Y,ee){return g(V,Y,ee)===0}function W(V,Y,ee){return g(V,Y,ee)!==0}function le(V,Y,ee){return g(V,Y,ee)>=0}function oe(V,Y,ee){return g(V,Y,ee)<=0}function me(V,Y,ee,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Z(V,ee,$e);break;case"!=":ye=W(V,ee,$e);break;case">":ye=z(V,ee,$e);break;case">=":ye=le(V,ee,$e);break;case"<":ye=C(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);R("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Y){return a(Y,V)},e.major=function(V,Y){return new M(V,Y).major},e.minor=function(V,Y){return new M(V,Y).minor},e.patch=function(V,Y){return new M(V,Y).patch},e.compare=g,e.compareLoose=function(V,Y){return g(V,Y,!0)},e.rcompare=function(V,Y,ee){return g(Y,V,ee)},e.sort=function(V,Y){return V.sort(function(ee,$e){return e.compare(ee,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(ee,$e){return e.rcompare(ee,$e,Y)})},e.gt=z,e.lt=C,e.eq=Z,e.neq=W,e.gte=le,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,ee,$e,ye,Re,Se,Le,Ie,je,Ue,Ne,De){return((Y=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(je)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+je+1)+".0":Ne?"<="+Ie+"."+je+"."+Ue+"-"+Ne:"<="+Le)).trim()}function be(V,Y){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function ke(V,Y,ee){try{Y=new fe(Y,ee)}catch{return!1}return Y.test(V)}function Me(V,Y,ee,$e){var ye,Re,Se,Le,Ie;switch(V=new M(V,$e),Y=new fe(Y,$e),ee){case">":ye=z,Re=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,Re=le,Se=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Y,$e))return!1;for(var je=0;je<Y.set.length;++je){var Ue=Y.set[je],Ne=null,De=null;if(Ue.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Ne=Ne||ze,De=De||ze,ye(ze.semver,Ne.semver,$e)?Ne=ze:Se(ze.semver,De.semver,$e)&&(De=ze)}),Ne.operator===Le||Ne.operator===Ie||(!De.operator||De.operator===Le)&&Re(V,De.semver)||De.operator===Ie&&Se(V,De.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?b[q]:b[X],ee=V.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new M(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Y),ke(this.value,ee,Y);if(V.operator==="")return ee=new fe(this.value,Y),ke(V.semver,ee,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Re=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Re&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),R("range",V,Y);var ee=Y?b[B]:b[U];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),R("comparator trim",V,b[T]),V=(V=(V=V.replace(b[_],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=Y?b[q]:b[X],ye=V.split(" ").map(function(Re){return function(Se,Le){return R("comp",Se),Se=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,De){R("caret",Ne,De);var ze=De?b[ie]:b[ce];return Ne.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Fe;return R("caret",Ne,Ae,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(R("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Oe+" <"+(+ve+1)+".0.0"):(R("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",Fe),Fe})}(Ue,je)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,De){var ze=De?b[ue]:b[x];return Ne.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Fe;return R("tilde",Ne,Ae,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(R("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Ue,je)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,je){return R("replaceXRanges",Ie,je),Ie.split(/\s+/).map(function(Ue){return function(Ne,De){Ne=Ne.trim();var ze=De?b[w]:b[y];return Ne.replace(ze,function(Ae,ve,Ee,Pe,Oe,Fe){R("xRange",Ne,Ae,ve,Ee,Pe,Oe,Fe);var qe=he(Ee),Ce=qe||he(Pe),Te=Ce||he(Oe);return ve==="="&&Te&&(ve=""),qe?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(Pe=0),Te&&(Oe=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:Pe=+Pe+1),Ae=ve+Ee+"."+Pe+"."+Oe):Ce?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ae),Ae})}(Ue,je)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,je){return R("replaceStars",Ie,je),Ie.trim().replace(b[J],"")}(Se,Le),R("stars",Se),Se}(Re,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Re){return!!Re.match($e)})),ye=ye.map(function(Re){return new de(Re,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(Re){return $e.intersects(Re,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new M(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Re=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new M($e=Se,ee)))}),$e},e.minSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Re=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new M($e=Se,ee)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,ee){return Me(V,Y,"<",ee)},e.gtr=function(V,Y,ee){return Me(V,Y,">",ee)},e.outside=Me,e.prerelease=function(V,Y){var ee=K(V,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Y,ee){return V=new fe(V,ee),Y=new fe(Y,ee),V.intersects(Y)},e.coerce=function(V){if(V instanceof M)return V;if(typeof V!="string")return null;var Y=V.match(b[O]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(G,e){var L,D,R=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function b(m){if(L===setTimeout)return setTimeout(m,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(m,0);try{return L(m,0)}catch{try{return L.call(null,m,0)}catch{return L.call(this,m,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:j}catch{D=j}})();var h,c=[],S=!1,I=-1;function d(){S&&h&&(S=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!S){var m=b(d);S=!0;for(var u=c.length;u;){for(h=c,c=[];++I<u;)h&&h[I].run();I=-1,u=c.length}h=null,S=!1,function($){if(D===clearTimeout)return clearTimeout($);if((D===j||!D)&&clearTimeout)return D=clearTimeout,clearTimeout($);try{D($)}catch{try{return D.call(null,$)}catch{return D.call(this,$)}}}(m)}}function E(m,u){this.fun=m,this.array=u}function v(){}R.nextTick=function(m){var u=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)u[$-1]=arguments[$];c.push(new E(m,u)),c.length!==1||S||b(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function(m){return[]},R.binding=function(m){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(m){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class D{constructor(b,h,c){this.level=b,this.key=h,this.value=c,this.forward=[]}}const R=void 0;class A{constructor(b,h=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,h){return A.h(this,b,h,this.comparator)&&(this.f+=1),this}delete(b){const h=A.k(this,b,this.comparator);return h&&(this.f-=1),h}forEach(b,h){let c=this.e.forward[0];for(;c;)b.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this.e.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static g(b,h,c){let S=b.e;for(let I=b.d-1;I>=0;I--)for(;S.forward[I]&&c(S.forward[I].key,h)<0;)S=S.forward[I];if(S=S.forward[0],S&&c(S.key,h)===0)return S}static h(b,h,c,S){const I=[];let d=b.e;for(let f=b.d-1;f>=0;f--){for(;d.forward[f]&&S(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&S(d.key,h)===0)return d.value=c,!1;{const f=A.j(b);if(f>b.d){for(let E=b.d;E<f;E++)I[E]=b.e;b.d=f}d=new D(f,h,c);for(let E=0;E<f;E++)d.forward[E]=I[E].forward[E],I[E].forward[E]=d;return!0}}static j(b,h=.5){let c=1;for(;Math.random()<h&&c<b.c;)c+=1;return c}static k(b,h,c){const S=[];let I=b.e;for(let d=b.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];S[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<b.d&&S[d].forward[d]===I;d++)S[d].forward[d]=I.forward[d];for(;b.d>0&&b.e.forward[b.d-1]===R;)b.d-=1;return!0}}e.$yr=A}),define(ne[45],re([0,1,9,2]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function R(p){const P=p;return P?typeof P.read=="function":!1}e.$Yd=R;function A(p){const P=p;return P?[P.on,P.pause,P.resume,P.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function j(p){const P=p;return P?A(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.$1d=j;function b(p,P){return new h(p,P)}e.$2d=b;class h{constructor(P,s){this.e=P,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(s=>s(P))}h(P){this.c.error.length===0?(0,L.$1)(P):this.c.error.slice(0).forEach(s=>s(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,s){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(P,s){if(this.a.destroyed)return;let o;switch(P){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,P){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return P(s)}e.$3d=c;function S(p,P,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?P(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$4d=S;function I(p,P){return new Promise((s,o)=>{const t=[];d(p,{onData:i=>{P&&t.push(i)},onError:i=>{P?o(i):s(void 0)},onEnd:()=>{s(P?P(t):void 0)}})})}e.$5d=I;function d(p,P,s){p.on("error",o=>{s?.isCancellationRequested||P.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||P.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||P.onData(o)})}e.$6d=d;function f(p,P){return new Promise((s,o)=>{const t=new D.$Rc,i=[],n=k=>{if(i.push(k),i.length>P)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,D.$Qc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,D.$Qc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,D.$Qc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$7d=f;function E(p,P){const s=b(P);return s.end(p),s}e.$8d=E;function v(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.$9d=v;function m(p){let P=!1;return{read:()=>P?null:(P=!0,p)}}e.$0d=m;function u(p,P,s){const o=b(s);return d(p,{onData:t=>o.write(P.data(t)),onError:t=>o.error(P.error?P.error(t):t),onEnd:()=>o.end()}),o}e.$$d=u;function $(p,P,s){let o=!1;return{read:()=>{const t=P.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$_d=$;function N(p,P,s){let o=!1;const t=b(s);return d(P,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$ae=N}),define(ne[14],re([0,1,164,45]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const R=typeof Buffer<"u",A=new L.$V(()=>new Uint8Array(256));let j,b;class h{static alloc(O){return R?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return R&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,H){return!(H?.dontUseNodeBuffer||!1)&&R?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const H=h.alloc(O.length);for(let _=0,x=O.length;_<x;_++)H.buffer[_]=O[_];return H}static concat(O,H){if(typeof H>"u"){H=0;for(let ue=0,te=O.length;ue<te;ue++)H+=O[ue].byteLength}const _=h.alloc(H);let x=0;for(let ue=0,te=O.length;ue<te;ue++){const ae=O[ue];_.set(ae,x),x+=ae.byteLength}return _}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return R?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(O,H){return new h(this.buffer.subarray(O,H))}set(O,H){if(O instanceof h)this.buffer.set(O.buffer,H);else if(O instanceof Uint8Array)this.buffer.set(O,H);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),H);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return d(this.buffer,O)}writeUInt32BE(O,H){f(this.buffer,O,H)}readUInt32LE(O){return E(this.buffer,O)}writeUInt32LE(O,H){v(this.buffer,O,H)}readUInt8(O){return m(this.buffer,O)}writeUInt8(O,H){u(this.buffer,O,H)}indexOf(O,H=0){return c(this.buffer,O instanceof h?O.buffer:O,H)}}e.$be=h;function c(w,O,H=0){const _=O.byteLength,x=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(O[0]);if(_>x-H)return-1;const ue=A.value;ue.fill(O.length);for(let ie=0;ie<O.length;ie++)ue[O[ie]]=O.length-ie-1;let te=H+O.length-1,ae=te,ce=-1;for(;te<x;)if(w[te]===O[ae]){if(ae===0){ce=te;break}te--,ae--}else te+=Math.max(O.length-ae,ue[w[te]]),ae=O.length-1;return ce}e.$ce=c;function S(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0}e.$de=S;function I(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255}e.$ee=I;function d(w,O){return w[O]*2**24+w[O+1]*2**16+w[O+2]*2**8+w[O+3]}e.$fe=d;function f(w,O,H){w[H+3]=O,O=O>>>8,w[H+2]=O,O=O>>>8,w[H+1]=O,O=O>>>8,w[H]=O}e.$ge=f;function E(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0|w[O+2]<<16>>>0|w[O+3]<<24>>>0}e.$he=E;function v(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255,O=O>>>8,w[H+2]=O&255,O=O>>>8,w[H+3]=O&255}e.$ie=v;function m(w,O){return w[O]}e.$je=m;function u(w,O,H){w[H]=O}e.$ke=u;function $(w){return D.$3d(w,O=>h.concat(O))}e.$le=$;function N(w){return D.$0d(w)}e.$me=N;function p(w){return D.$5d(w,O=>h.concat(O))}e.$ne=p;async function P(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await p(w.stream)])}e.$oe=P;function s(w){return D.$8d(w,O=>h.concat(O))}e.$pe=s;function o(w){return D.$$d(w,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}e.$qe=o;function t(w){return D.$2d(O=>h.concat(O),w)}e.$re=t;function i(w,O){return D.$_d(w,O,H=>h.concat(H))}e.$se=i;function n(w,O){return D.$ae(w,O,H=>h.concat(H))}e.$te=n;function r(w){let O=0,H=0,_=0;const x=new Uint8Array(Math.floor(w.length/4*3)),ue=ae=>{switch(H){case 3:x[_++]=O|ae,H=0;break;case 2:x[_++]=O|ae>>>2,O=ae<<6,H=3;break;case 1:x[_++]=O|ae>>>4,O=ae<<4,H=2;break;default:O=ae<<2,H=1}};for(let ae=0;ae<w.length;ae++){const ce=w.charCodeAt(ae);if(ce>=65&&ce<=90)ue(ce-65);else if(ce>=97&&ce<=122)ue(ce-97+26);else if(ce>=48&&ce<=57)ue(ce-48+52);else if(ce===43||ce===45)ue(62);else if(ce===47||ce===95)ue(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ae]}`)}}const te=_;for(;H>0;)ue(0);return h.wrap(x).slice(0,te)}e.$ue=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:w},O=!0,H=!1){const _=H?k:l;let x="";const ue=w.byteLength%3;let te=0;for(;te<w.byteLength-ue;te+=3){const ae=w[te+0],ce=w[te+1],ie=w[te+2];x+=_[ae>>>2],x+=_[(ae<<4|ce>>>4)&63],x+=_[(ce<<2|ie>>>6)&63],x+=_[ie&63]}if(ue===1){const ae=w[te+0];x+=_[ae>>>2],x+=_[ae<<4&63],O&&(x+="==")}else if(ue===2){const ae=w[te+0],ce=w[te+1];x+=_[ae>>>2],x+=_[(ae<<4|ce>>>4)&63],x+=_[ce<<2&63],O&&(x+="=")}return x}e.$ve=y}),define(ne[41],re([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function D(u){return R(u,0)}e.$Di=D;function R(u,$){switch(typeof u){case"object":return u===null?A(349,$):Array.isArray(u)?h(u,$):c(u,$);case"string":return b(u,$);case"boolean":return j(u,$);case"number":return A(u,$);case"undefined":return A(937,$);default:return A(617,$)}}e.$Ei=R;function A(u,$){return($<<5)-$+u|0}e.$Fi=A;function j(u,$){return A(u?433:863,$)}function b(u,$){$=A(149417,$);for(let N=0,p=u.length;N<p;N++)$=A(u.charCodeAt(N),$);return $}e.$Gi=b;function h(u,$){return $=A(104579,$),u.reduce((N,p)=>R(p,N),$)}function c(u,$){return $=A(181387,$),Object.keys(u).sort().reduce((N,p)=>(N=b(p,N),R(u[p],N)),$)}class S{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=R($,this.g),this.g}}e.$Hi=S;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(u,$,N=32){const p=N-$,P=~((1<<p)-1);return(u<<$|(P&u)>>>p)>>>0}function f(u,$=0,N=u.byteLength,p=0){for(let P=0;P<N;P++)u[$+P]=p}function E(u,$,N="0"){for(;u.length<$;)u=N+u;return u}function v(u,$=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(N=>N.toString(16).padStart(2,"0")).join(""):E((u>>>0).toString(16),$/4)}e.$Ii=v;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const N=$.length;if(N===0)return;const p=this.p;let P=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=$.charCodeAt(0),t=0);;){let i=o;if(L.$6e(o))if(t+1<N){const n=$.charCodeAt(t+1);L.$7e(n)?(t++,i=L.$8e(o,n)):i=65533}else{s=o;break}else L.$7e(o)&&(i=65533);if(P=this.w(p,P,i),t++,t<N)o=$.charCodeAt(t);else break}this.r=P,this.u=s}w($,N,p){return p<128?$[N++]=p:p<2048?($[N++]=192|(p&1984)>>>6,$[N++]=128|(p&63)>>>0):p<65536?($[N++]=224|(p&61440)>>>12,$[N++]=128|(p&4032)>>>6,$[N++]=128|(p&63)>>>0):($[N++]=240|(p&1835008)>>>18,$[N++]=128|(p&258048)>>>12,$[N++]=128|(p&4032)>>>6,$[N++]=128|(p&63)>>>0),N>=64&&(this.y(),N-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),N}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=m.g,N=this.q;for(let l=0;l<64;l+=4)$.setUint32(l,N.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)$.setUint32(l,d($.getUint32(l-12,!1)^$.getUint32(l-32,!1)^$.getUint32(l-56,!1)^$.getUint32(l-64,!1),1),!1);let p=this.h,P=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=P&s|~P&o,n=1518500249):l<40?(i=P^s^o,n=1859775393):l<60?(i=P&s|P&o|s&o,n=2400959708):(i=P^s^o,n=3395469782),r=d(p,5)+i+t+n+$.getUint32(l*4,!1)&4294967295,t=o,o=s,s=d(P,30),P=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+P&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ji=m}),define(ne[54],re([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",j="warning",b="warn",h="info",c="ignore";function S(d){return d?L.$2e(A,d)?R.Error:L.$2e(j,d)||L.$2e(b,d)?R.Warning:L.$2e(h,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=S;function I(d){switch(d){case R.Error:return A;case R.Warning:return j;case R.Info:return h;default:return c}}R.toString=I}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const $=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([N,p])=>{$[N]=p&&typeof p=="object"?D(p):p}),$}e.$7m=D;function R(u){if(!u||typeof u!="object")return u;const $=[u];for(;$.length>0;){const N=$.shift();Object.freeze(N);for(const p in N)if(A.call(N,p)){const P=N[p];typeof P=="object"&&!Object.isFrozen(P)&&!(0,L.$Bf)(P)&&$.push(P)}}return u}e.$8m=R;const A=Object.prototype.hasOwnProperty;function j(u,$){return b(u,$,new Set)}e.$9m=j;function b(u,$,N){if((0,L.$Hf)(u))return u;const p=$(u);if(typeof p<"u")return p;if(Array.isArray(u)){const P=[];for(const s of u)P.push(b(s,$,N));return P}if((0,L.$Af)(u)){if(N.has(u))throw new Error("Cannot clone recursive data-structure");N.add(u);const P={};for(const s in u)A.call(u,s)&&(P[s]=b(u[s],$,N));return N.delete(u),P}return u}function h(u,$,N=!0){return(0,L.$Af)(u)?((0,L.$Af)($)&&Object.keys($).forEach(p=>{p in u?N&&((0,L.$Af)(u[p])&&(0,L.$Af)($[p])?h(u[p],$[p],N):u[p]=$[p]):u[p]=$[p]}),u):$}e.$0m=h;function c(u,$){if(u===$)return!0;if(u==null||$===null||$===void 0||typeof u!=typeof $||typeof u!="object"||Array.isArray(u)!==Array.isArray($))return!1;let N,p;if(Array.isArray(u)){if(u.length!==$.length)return!1;for(N=0;N<u.length;N++)if(!c(u[N],$[N]))return!1}else{const P=[];for(p in u)P.push(p);P.sort();const s=[];for(p in $)s.push(p);if(s.sort(),!c(P,s))return!1;for(N=0;N<P.length;N++)if(!c(u[P[N]],$[P[N]]))return!1}return!0}e.$$m=c;function S(u){const $=new Set;return JSON.stringify(u,(N,p)=>{if((0,L.$Af)(p)||Array.isArray(p)){if($.has(p))return"[Circular]";$.add(p)}return p})}e.$_m=S;function I(u,$){const N=Object.create(null);return!u||!$||Object.keys($).forEach(P=>{const s=u[P],o=$[P];c(s,o)||(N[P]=o)}),N}e.$an=I;function d(u,$){const N=$.toLowerCase(),p=Object.keys(u).find(P=>P.toLowerCase()===N);return p?u[p]:u[$]}e.$bn=d;function f(u,$){const N=Object.create(null);for(const[p,P]of Object.entries(u))$(p,P)&&(N[p]=P);return N}e.$cn=f;function E(u){let $=[];for(;Object.prototype!==u;)$=$.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return $}e.$dn=E;function v(u){const $=[];for(const N of E(u))typeof u[N]=="function"&&$.push(N);return $}e.$en=v;function m(u,$){const N=P=>function(){const s=Array.prototype.slice.call(arguments,0);return $(P,s)},p={};for(const P of u)p[P]=N(P);return p}e.$fn=m}),define(ne[28],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$dg=D,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),j=[];for(let b=0;b<256;b++)j.push(b.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,c="";return c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c}}()}),define(ne[74],re([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(j){const b=j.replace(/\-/g,":").toLowerCase();return!D.has(b)}function A(){const j=(0,L.networkInterfaces)();for(const b in j){const h=j[b];if(h){for(const{mac:c}of h)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=A}),define(ne[75],re([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[76],re([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const D=60,R=D*60,A=R*24,j=A*7,b=A*30,h=A*365;function c(I,d,f,E){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!E&&v<30)return(0,L.localize)(1,null);let m;return v<D?(m=v,d?m===1?f?(0,L.localize)(2,null,m):(0,L.localize)(3,null,m):f?(0,L.localize)(4,null,m):(0,L.localize)(5,null,m):m===1?f?(0,L.localize)(6,null,m):(0,L.localize)(7,null,m):f?(0,L.localize)(8,null,m):(0,L.localize)(9,null,m)):v<R?(m=Math.floor(v/D),d?m===1?f?(0,L.localize)(10,null,m):(0,L.localize)(11,null,m):f?(0,L.localize)(12,null,m):(0,L.localize)(13,null,m):m===1?f?(0,L.localize)(14,null,m):(0,L.localize)(15,null,m):f?(0,L.localize)(16,null,m):(0,L.localize)(17,null,m)):v<A?(m=Math.floor(v/R),d?m===1?f?(0,L.localize)(18,null,m):(0,L.localize)(19,null,m):f?(0,L.localize)(20,null,m):(0,L.localize)(21,null,m):m===1?f?(0,L.localize)(22,null,m):(0,L.localize)(23,null,m):f?(0,L.localize)(24,null,m):(0,L.localize)(25,null,m)):v<j?(m=Math.floor(v/A),d?m===1?(0,L.localize)(26,null,m):(0,L.localize)(27,null,m):m===1?(0,L.localize)(28,null,m):(0,L.localize)(29,null,m)):v<b?(m=Math.floor(v/j),d?m===1?f?(0,L.localize)(30,null,m):(0,L.localize)(31,null,m):f?(0,L.localize)(32,null,m):(0,L.localize)(33,null,m):m===1?f?(0,L.localize)(34,null,m):(0,L.localize)(35,null,m):f?(0,L.localize)(36,null,m):(0,L.localize)(37,null,m)):v<h?(m=Math.floor(v/b),d?m===1?f?(0,L.localize)(38,null,m):(0,L.localize)(39,null,m):f?(0,L.localize)(40,null,m):(0,L.localize)(41,null,m):m===1?f?(0,L.localize)(42,null,m):(0,L.localize)(43,null,m):f?(0,L.localize)(44,null,m):(0,L.localize)(45,null,m)):(m=Math.floor(v/h),d?m===1?f?(0,L.localize)(46,null,m):(0,L.localize)(47,null,m):f?(0,L.localize)(48,null,m):(0,L.localize)(49,null,m):m===1?f?(0,L.localize)(50,null,m):(0,L.localize)(51,null,m):f?(0,L.localize)(52,null,m):(0,L.localize)(53,null,m))}e.$dm=c;function S(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=S}),define(ne[77],re([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,77]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function A(I,d){return d&&(I.stack||I.stacktrace)?R.localize(0,null,b(I),j(I.stack)||j(I.stacktrace)):b(I)}function j(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function h(I=null,d=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const f=L.$Hb(I),E=h(f[0],d);return f.length>1?R.localize(4,null,E,f.length):E}if(D.$yf(I))return I;if(I.detail){const f=I.detail;if(f.error)return A(f.error,d);if(f.exception)return A(f.exception,d)}return I.stack?A(I,d):I.message?I.message:R.localize(5,null)}e.$Ai=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Bi=c;function S(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Ci=S}),define(ne[78],re([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[79],re([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$wp=D}),define(ne[55],re([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var D;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(b,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<S.length;f++)if(d.search(S[f])!==-1){delete b[d];break}})}e.$zl=A;function j(b){b&&(delete b.DEBUG,L.$k&&delete b.DYLD_LIBRARY_PATH,L.$l&&delete b.LD_PRELOAD)}e.$Al=j}),define(ne[80],re([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Zp=e.$Yp=e.$Xp=void 0;function D(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.$Xp=D;function R(c){const S=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),S.push(...d)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:I}}e.$Yp=R;function A(c){if(typeof c!="string")return A(R(c).stack);const S=c;if(S){const I=j(S),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$Zp=A;function j(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function b(c,S){const{args:I,stack:d}=R(c),f=typeof I[0]=="string"&&I.length===1;let E=j(d);E&&(E=`(${E.trim()})`);let v=[];if(typeof I[0]=="string"?E&&f?v=[`%c[${S}] %c${I[0]} %c${E}`,h("blue"),h(""),h("grey")]:v=[`%c[${S}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:v=[`%c[${S}]%`,h("blue"),...I],E&&!f&&v.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function h(c){return`color: ${c}`}}),define(ne[46],re([0,1,14,11]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function R(h){return JSON.stringify(h,j)}e.$kh=R;function A(h){let c=JSON.parse(h);return c=b(c),c}e.$lh=A;function j(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$be||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let S=0;S<h.length;++S)h[S]=b(h[S],c+1);else for(const S in h)Object.hasOwnProperty.call(h,S)&&(h[S]=b(h[S],c+1))}return h}e.$mh=b}),define(ne[81],re([0,1,70,15,13,11]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class j{constructor(d,f,E){this.id=d,this.dependencies=f,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,E)=>{typeof d!="string"&&(E=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new j(d,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,E)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const m=()=>{v.removeEventListener("load",u),v.removeEventListener("error",$)},u=N=>{m(),f(this.c.pop())},$=N=>{m(),E(N)};v.addEventListener("load",u),v.addEventListener("error",$),this.f&&(d=this.f.createScriptURL(d)),v.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(v)})}i(d){return new Promise((f,E)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(v){E(v)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,u=f.readFileSync(m).toString(),$=v.wrap(u.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function S(I,d,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const E=`${I}/${d}`;if(h.has(E))return h.get(E);let v;if(/^\w[\w\d+.-]*:\/\//.test(E))v=E;else{const N=`${f&&!R.$p?D.$_f:D.$$f}/${E}`;v=D.$cg.asBrowserUri(N).toString(!0)}const m=b.INSTANCE.load(v);return h.set(E,m),m}else return await new Promise((E,v)=>{G([I],E,v)})}e.$vC=S}),define(ne[82],re([0,1,33,47,28,74,13]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(d){return this.a||(this.a=D.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const E=(0,L.networkInterfaces)();for(const v in E){const m=E[v];if(m)for(const{mac:u,internal:$}of m)$||(f+=1,this.c(u.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let b;async function h(d){return b||(b=(async()=>await c(d)||R.$eg())()),b}e.$Sm=h;async function c(d){try{const f=await new Promise((v,m)=>{G(["crypto"],v,m)}),E=(0,A.$Qm)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){d(f);return}}const S="Software\\Microsoft\\SQMClient";async function I(d){if(j.$j){const f=await new Promise((E,v)=>{G(["@vscode/windows-registry"],E,v)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(E){return d(E),""}}return""}e.$Tm=I}),define(ne[83],re([0,1,33,16,24]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class I{constructor(P,s,o){this.exePath=P,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:P=!1}={}){const s=d({useAlternateBitness:p});if(!s)return null;const o=D.$jc(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(o)){let k=-1;if(P){const w=l.indexOf("-");if(w<0)continue;const O=l.substring(0,w);if(!A.test(O)||l.substring(w+1)!=="preview")continue;k=parseInt(O,10)}else{if(!A.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const y=D.$jc(o,l,"pwsh.exe");await R.SymlinkSupport.existsFile(y)&&(i=y,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=P?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const P=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(P))if(s.test(t)){const i=D.$jc(P,t,"pwsh.exe");return new I(i,o)}return null}function v(){const p=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new I(p,".NET Core PowerShell Global Tool")}function m(){const p=D.$jc(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(p,"Windows PowerShell",!0)}async function*u(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await E(),p&&(yield p),p=v(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await E({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*$(){for await(const p of u())await p.exists()&&(yield p)}e.$xl=$;async function N(){for await(const p of $())return p;return null}e.$yl=N}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(G,e,L,D,R,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(I=R.env){return I.comspec||"cmd.exe"}e.$Bl=h;function c(I){let d=[],f=!1;const E=function(v){if(f){d.push(v);return}(!I.send(v,u=>{if(u&&console.error(u),f=!1,d.length>0){const $=d.slice(0);d=[],$.forEach(N=>E(N))}})||D.$j)&&(f=!0)};return{send:E}}e.$Cl=c;var S;(function(I){async function d(f,E,v){if(L.$ic(f))return f;if(E===void 0&&(E=R.cwd()),L.$mc(f)!=="."||(v===void 0&&j.$yf(R.env.PATH)&&(v=R.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(E,f);async function u($){if(await b.Promises.exists($)){let N;try{N=await b.Promises.stat($)}catch(p){p.message.startsWith("EACCES")&&(N=await b.Promises.lstat($))}return N?!N.isDirectory():!1}return!1}for(const $ of v){let N;if(L.$ic($)?N=L.$jc($,f):N=L.$jc(E,$,f),await u(N))return N;let p=N+".com";if(await u(p)||(p=N+".exe",await u(p)))return p}return L.$jc(E,f)}I.findExecutable=d})(S||(e.win32=S={}))}),define(ne[84],re([0,1,33,13,83,56]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function j(I,d){return I===1?D.$j?S():A.$Bl(d):h(I,d)}e.$Dl=j;let b=null;function h(I,d){if(D.$l&&I===2||D.$k&&I===3)return"/bin/bash";if(!b){let f;if(D.$j)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}b=f}return b}let c=null;async function S(){return c||(c=(await(0,R.$yl)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,L,D);else for(var b=G.length-1;b>=0;b--)(j=G[b])&&(A=(R<3?j(A):R>3?j(e,L,A):j(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,D,R,A,j,b,h,c,S,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function m(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function $(T){let U=0;for(let B=0;;B+=7){const J=T.read(1);if(U|=(J.buffer[0]&127)<<B,!(J.buffer[0]&128))return U}}const N=t(0);function p(T,U){if(U===0){T.write(N);return}let B=0;for(let Q=U;Q!==0;Q=Q>>>7)B++;const J=R.$be.alloc(B);for(let Q=0;U!==0;Q++)J.buffer[Q]=U&127,U=U>>>7,U>0&&(J.buffer[Q]|=128);T.write(J)}class P{constructor(U){this.b=U,this.a=0}read(U){const B=this.b.slice(this.a,this.a+U);return this.a+=B.byteLength,B}}e.$nh=P;class s{constructor(){this.a=[]}get buffer(){return R.$be.concat(this.a)}write(U){this.a.push(U)}}e.$oh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=R.$be.alloc(1);return U.writeUInt8(T,0),U}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(i.Undefined);else if(typeof U=="string"){const B=R.$be.fromString(U);T.write(i.String),p(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(U)){const B=R.$be.wrap(U);T.write(i.Buffer),p(T,B.byteLength),T.write(B)}else if(U instanceof R.$be)T.write(i.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(i.Array),p(T,U.length);for(const B of U)r(T,B)}else if(typeof U=="number"&&(U|0)===U)T.write(i.Uint),p(T,U);else{const B=R.$be.fromString(JSON.stringify(U));T.write(i.Object),p(T,B.byteLength),T.write(B)}}e.$ph=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read($(T)).toString();case o.Buffer:return T.read($(T)).buffer;case o.VSBuffer:return T.read($(T));case o.Array:{const B=$(T),J=[];for(let Q=0;Q<B;Q++)J.push(l(T));return J}case o.Object:return JSON.parse(T.read($(T)).toString());case o.Int:return $(T)}}e.$qh=l;class k{constructor(U,B,J=null,Q=1e3){this.h=U,this.j=B,this.k=J,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,B){this.b.set(U,B),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const B=this.o([U.type]);this.k?.logOutgoing(B,0,1,m(U.type));return}case 201:case 202:case 204:case 203:{const B=this.o([U.type,U.id],U.data);this.k?.logOutgoing(B,U.id,1,m(U.type),U.data);return}}}o(U,B=void 0){const J=new s;return r(J,U),r(J,B),this.p(J.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const B=new P(U),J=l(B),Q=l(B),K=J[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Q),this.s({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 102:return this.k?.logIncoming(U.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Q),this.t({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 101:return this.k?.logIncoming(U.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]});case 103:return this.k?.logIncoming(U.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]})}}s(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const J=new A.$Xd;let Q;try{Q=B.call(this.j,U.name,U.arg,J.token)}catch(F){Q=Promise.reject(F)}const K=U.id;Q.then(F=>{this.m({id:K,data:F,type:201})},F=>{F instanceof Error?this.m({id:K,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:K,data:F,type:203})}).finally(()=>{M.dispose(),this.d.delete(U.id)});const M=(0,c.$Qc)(()=>J.cancel());this.d.set(U.id,M)}t(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const J=U.id,K=B.listen(this.j,U.name,U.arg)(M=>this.m({id:J,data:M,type:204}));this.d.set(U.id,K)}u(U){const B=this.d.get(U.id);B&&(B.dispose(),this.d.delete(U.id))}v(U){let B=this.g.get(U.channelName);B||(B=[],this.g.set(U.channelName,B));const J=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:U,timeoutTimer:J})}w(U){const B=this.g.get(U);if(B){for(const J of B)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$rh=k;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class w{constructor(U,B=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=B}getChannel(U){const B=this;return{call(J,Q,K){return B.a?Promise.reject(new b.$5):B.m(U,J,Q,K)},listen(J,Q){return B.a?h.Event.None:B.o(U,J,Q)}}}m(U,B,J,Q=A.CancellationToken.None){const K=this.g++,F={id:K,type:100,channelName:U,name:B,arg:J};if(Q.isCancellationRequested)return Promise.reject(new b.$5);let a;return new Promise((z,C)=>{if(Q.isCancellationRequested)return C(new b.$5);const Z=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),z(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(K),C(de.data);break}};this.f.set(K,me),this.p(F)};let W=null;this.b===u.Idle?Z():(W=(0,D.$Hg)(me=>this.u()),W.then(()=>{W=null,Z()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),C(new b.$5)},oe=Q.onCancellationRequested(le);a=(0,c.$Pc)((0,c.$Qc)(le),oe),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,B,J){const Q=this.g++,M={id:Q,type:102,channelName:U,name:B,arg:J};let F=null;const a=new h.$Nd({onWillAddFirstListener:()=>{F=(0,D.$Hg)(z=>this.u()),F.then(()=>{F=null,this.d.add(a),this.p(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(a),this.p({id:Q,type:103}))}}),g=z=>a.fire(z.data);return this.f.set(Q,g),a.event}p(U){switch(U.type){case 100:case 102:{const B=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(B,U.id,0,`${E(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.q([U.type,U.id]);this.j?.logOutgoing(B,U.id,0,E(U.type));return}}}q(U,B=void 0){const J=new s;return r(J,U),r(J,B),this.r(J.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const B=new P(U),J=l(B),Q=l(B),K=J[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,m(K)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,J[1],0,m(K),Q),this.t({type:J[0],id:J[1],data:Q})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$sh=w,pe([j.$hh],w.prototype,"onDidInitializePromise",null);class O{get connections(){const U=[];return this.f.forEach(B=>U.push(B)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$Nd,this.onDidAddConnection=this.g.event,this.h=new h.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(U(({protocol:B,onDidClientDisconnect:J})=>{const Q=h.Event.once(B.onMessage);this.j.add(Q(K=>{const M=new P(K),F=l(M),a=new k(B,F),g=new w(B);this.a.forEach((C,Z)=>a.registerChannel(Z,C));const z={channelServer:a,channelClient:g,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(J(()=>{a.dispose(),g.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,B){const J=this;return{call(Q,K,M){let F;if((0,d.$Mf)(B)){const g=(0,L.$4b)(J.connections.filter(B));F=g?Promise.resolve(g):h.Event.toPromise(h.Event.filter(J.onDidAddConnection,B))}else F=B.routeCall(J,Q,K);const a=F.then(g=>g.channelClient.getChannel(U));return _(a).call(Q,K,M)},listen(Q,K){if((0,d.$Mf)(B))return J.k(U,B,Q,K);const M=B.routeEvent(J,Q,K).then(F=>F.channelClient.getChannel(U));return _(M).listen(Q,K)}}}k(U,B,J,Q){const K=this;let M;const F=new h.$Nd({onWillAddFirstListener:()=>{M=new c.$Rc;const a=new h.$Td,g=new Map,z=Z=>{const le=Z.channelClient.getChannel(U).listen(J,Q),oe=a.add(le);g.set(Z,oe)},C=Z=>{const W=g.get(Z);W&&(W.dispose(),g.delete(Z))};K.connections.filter(B).forEach(z),h.Event.filter(K.onDidAddConnection,B)(z,void 0,M),K.onDidRemoveConnection(C,void 0,M),a.event(F.fire,F,M),M.add(a)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(U,B){this.a.set(U,B);for(const J of this.f)J.channelServer.registerChannel(U,B)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=O;class H{constructor(U,B,J=null){const Q=new s;r(Q,B),U.send(Q.buffer),this.a=new w(U,J),this.d=new k(U,B,J)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,B){this.d.registerChannel(U,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=H;function _(T){return{call(U,B,J){return T.then(Q=>Q.call(U,B,J))},listen(U,B){const J=new h.$Wd;return T.then(Q=>J.input=Q.listen(U,B)),J.event}}}e.$vh=_;function x(T){let U=!1;return{call(B,J,Q){return U?T.call(B,J,Q):(0,D.$Ug)(0).then(()=>U=!0).then(()=>T.call(B,J,Q))},listen(B,J){if(U)return T.listen(B,J);const Q=new h.$Wd;return(0,D.$Ug)(0).then(()=>U=!0).then(()=>Q.input=T.listen(B,J)),Q.event}}}e.$wh=x;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const B of U.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$xh=ue;var te;(function(T){function U(K,M,F){const a=K,g=F&&F.disableMarshalling,z=new Map;for(const C in a)J(C)&&z.set(C,h.Event.buffer(a[C],!0,void 0,M));return new class{listen(C,Z,W){const le=z.get(Z);if(le)return le;if(Q(Z)){const oe=a[Z];if(typeof oe=="function")return oe.call(a,W)}throw new b.$bb(`Event not found: ${Z}`)}call(C,Z,W){const le=a[Z];if(typeof le=="function"){if(!g&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,S.$mh)(W[me]);let oe=le.apply(a,W);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$bb(`Method not found: ${Z}`)}}}T.fromService=U;function B(K,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return M?.properties?.has(g)?M.properties.get(g):Q(g)?function(z){return K.listen(g,z)}:J(g)?K.listen(g):async function(...z){let C;M&&!(0,d.$Hf)(M.context)?C=[M.context,...z]:C=z;const Z=await K.call(g,C);return F?Z:(0,S.$mh)(Z)};throw new b.$bb(`Property not found: ${String(g)}`)}})}T.toService=B;function J(K){return K[0]==="o"&&K[1]==="n"&&I.$1e(K.charCodeAt(2))}function Q(K){return/^onDynamic/.test(K)&&I.$1e(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,U,B,J,Q,K,M){M=ie(M);const F=ae[Q],a=F[J%F.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(g=g.concat(M),g.push(")")):g.push(M),console.log.apply(console,g)}class X{constructor(U,B){this.d=U,this.f=B,this.a=0,this.b=0}logOutgoing(U,B,J,Q,K){this.b+=U,q(this.d,this.b,U,B,J,Q,K)}logIncoming(U,B,J,Q,K){this.a+=U,q(this.f,this.a,U,B,J,Q,K)}}e.$yh=X}),define(ne[85],re([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class E extends f.$rh{constructor(u){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",$=>R.$be.wrap(Buffer.from($,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$2p=E;class v{constructor(u,$){this.i=u,this.j=$,this.c=new Set,this.g=new Map,this.h=new h.$Nd,this.onDidProcessExit=this.h.event;const N=$&&$.timeout?$.timeout:6e4;this.b=new D.$Qg(N),this.d=null,this.f=null}getChannel(u){const $=this;return{call(N,p,P){return $.k(u,N,p,P)},listen(N,p){return $.l(u,N,p)}}}k(u,$,N,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const P=this.n(u),s=(0,D.$Hg)(i=>P.call($,N,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,$,N){if(!this.b)return h.Event.None;this.b.cancel();let p;const P=new h.$Nd({onWillAddFirstListener:()=>{p=this.n(u).listen($,N)(P.fire,P),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,S.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$Al)($.env),this.d=(0,L.fork)(this.i,u,$);const N=new h.$Nd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,j.$Xp)(n)){(0,j.log)(n,`IPC Library: ${this.j.serverName}`);return}N.fire(R.$be.wrap(Buffer.from(n,"base64")))});const P=this.j.useQueue?(0,I.$Cl)(this.d):this.d,s=n=>this.d&&this.d.connected&&P.send(n.buffer.toString("base64")),o=N.event,t={send:s,onMessage:o};this.f=new f.$sh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Nc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(u){let $=this.g.get(u);return $||($=this.m.getChannel(u),this.g.set(u,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$3p=v}),define(ne[86],re([0,1,8,4,2,46,3]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.StorageState=e.$1o=e.StorageHint=void 0;var b;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$1o=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class S extends R.$Sc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new D.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Rg(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,v)=>this.w(v,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===c.Closed)return;let v=!1;(0,j.$Hf)(E)?v=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const v=this.f.get(f);return(0,j.$Hf)(v)?E:v}getBoolean(f,E){const v=this.get(f);return(0,j.$Hf)(v)?E:v==="true"}getNumber(f,E){const v=this.get(f);return(0,j.$Hf)(v)?E:parseInt(v,10)}getObject(f,E){const v=this.get(f);return(0,j.$Hf)(v)?E:(0,A.$lh)(v)}async set(f,E,v=!1){if(this.c===c.Closed)return;if((0,j.$Hf)(E))return this.delete(f,v);const m=(0,j.$Af)(E)||Array.isArray(E)?(0,A.$kh)(E):String(E);if(this.f.get(f)!==m)return this.f.set(f,m),this.j.set(f,m),this.h.delete(f),this.b.fire({key:f,external:v}),this.D()}async delete(f,E=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$2o=S;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,v)=>this.a.set(v,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$3o=I}),define(ne[87],re([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,D.localize)(3,null),b=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:S}),this.f.push(f)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,I=!1,d=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(b);return}const E=this.c.charCodeAt(S);if(I)I=!1;else if(E===47&&!d){S++;break}else E===91?d=!0:E===92?I=!0:E===93&&(d=!1);S++}for(;S<this.c.length&&h.a.has(this.c.charCodeAt(S));)S++;this.e=S;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=h}),define(ne[109],re([0,1,76,52,15,16,35,17,11]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$mc)(R.$cg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$vg)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"argv.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$kc)(f):(0,A.$hc)((0,A.$jc)(R.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,A.$kc)(f)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$kc)(f);const E=j.env.VSCODE_EXTENSIONS;if(E)return E;const v=j.env.VSCODE_PORTABLE;return v?(0,A.$jc)(v,"extensions"):(0,b.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,A.$hc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,A.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$fm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const v=e.$fm.exec(E);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,b.$vg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"policy.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,v){this.a=f,this.b=E,this.c=v,this.editSessionId=this.args.editSessionId}}e.$gm=c,pe([D.$hh],c.prototype,"appRoot",null),pe([D.$hh],c.prototype,"userHome",null),pe([D.$hh],c.prototype,"userDataPath",null),pe([D.$hh],c.prototype,"appSettingsHome",null),pe([D.$hh],c.prototype,"tmpDir",null),pe([D.$hh],c.prototype,"cacheHome",null),pe([D.$hh],c.prototype,"stateResource",null),pe([D.$hh],c.prototype,"userRoamingDataHome",null),pe([D.$hh],c.prototype,"userDataSyncHome",null),pe([D.$hh],c.prototype,"sync",null),pe([D.$hh],c.prototype,"machineSettingsResource",null),pe([D.$hh],c.prototype,"workspaceStorageHome",null),pe([D.$hh],c.prototype,"localHistoryHome",null),pe([D.$hh],c.prototype,"keyboardLayoutResource",null),pe([D.$hh],c.prototype,"argvResource",null),pe([D.$hh],c.prototype,"isExtensionDevelopment",null),pe([D.$hh],c.prototype,"untitledWorkspacesHome",null),pe([D.$hh],c.prototype,"builtinExtensionsPath",null),pe([D.$hh],c.prototype,"extensionsPath",null),pe([D.$hh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$hh],c.prototype,"extensionDevelopmentKind",null),pe([D.$hh],c.prototype,"extensionTestsLocationURI",null),pe([D.$hh],c.prototype,"debugExtensionHost",null),pe([D.$hh],c.prototype,"logLevel",null),pe([D.$hh],c.prototype,"extensionLogLevel",null),pe([D.$hh],c.prototype,"serviceMachineIdResource",null),pe([D.$hh],c.prototype,"disableTelemetry",null),pe([D.$hh],c.prototype,"disableWorkspaceTrust",null),pe([D.$hh],c.prototype,"useInMemorySecretStorage",null),pe([D.$hh],c.prototype,"policyFile",null);function S(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$hm=S;function I(d,f,E,v,m,u){const N=Number(f||d)||(v?null:E),p=N?!!f:!1;let P;if(u)try{P=JSON.parse(u)}catch{}return{port:N,break:p,debugId:m,env:P}}e.$im=I}),function(){"use strict";function G(e,L,D){function R(j,b){const h=A(j,b),c=[h];return e.isAbsolute(h)||c.unshift(D),e.resolve(...c)}function A(j,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const S=j["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return G(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class A extends D.$gm{constructor(c,S){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,S.nameShort)},S)}}e.$jm=A;function j(h,c){return(0,D.$im)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$km=j;function b(h,c){return(0,D.$im)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$lm=b}),define(ne[112],re([0,1,3,94]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function R(j,b,h,c){try{A(j,b,h,c)}catch(S){j.error(S?.message??S)}return b}e.$xp=R;function A(j,b,h,c){const S=(I,d,f)=>{const E=I[d];if((0,L.$yf)(E)){const v=E,m=v.length;if(m>1&&v[0]==="%"&&v[m-1]==="%"){const u=v.substr(1,m-2);let $=h[u];$===void 0&&c&&($=c[u]);const N=typeof $=="string"?$:$?.message,p=c?.[u],P=typeof p=="string"?p:p?.message;if(!N){P||j.warn(`[${b.name}]: ${(0,D.localize)(0,null,u)}`);return}if(f&&(d==="title"||d==="category")&&P&&P!==N){const s={value:N,original:P};I[d]=s}else I[d]=N}}else if((0,L.$Af)(E))for(const v in E)E.hasOwnProperty(v)&&(v==="commands"?S(E,v,!0):S(E,v,f));else if(Array.isArray(E))for(let v=0;v<E.length;v++)S(E,v,f)};for(const I in b)b.hasOwnProperty(I)&&S(b,I)}}),define(ne[48],re([0,1,17,54,98,42]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||j.test(u)}e.$Lo=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=u.match(j);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}e.$Mo=c;function S(u){if(!u)return null;const $=u.majorBase,N=u.majorMustEqual,p=u.minorBase;let P=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&($===0||(P=!1),o=!1);let t=0;if(u.preRelease){const i=b.exec(u.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:$,majorMustEqual:N,minorBase:p,minorMustEqual:P,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$No=S;function I(u,$,N){let p;typeof u=="string"?p=S(c(u)):p=u;let P;$ instanceof Date?P=$.getTime():typeof $=="string"&&(P=new Date($).getTime());let s;if(typeof N=="string"?s=S(c(N)):s=N,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let y=s.majorMustEqual,w=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||P&&P<k?!1:i>=l:(o===1&&n===0&&(!y||!w||!O)&&(n=1,r=0,l=0,y=!0,w=!1,O=!1),o<n?!1:o>n?!y:t<r?!1:t>r?!w:i<l?!1:i>l?!O:!(P&&P<k))}e.$Oo=I;function d(u,$,N,p,P){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([D.default.Error,R.localize(0,null)]),s;if(typeof p.name!="string")return s.push([D.default.Error,R.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([D.default.Error,R.localize(2,null,"version")]),s;if(!p.engines)return s.push([D.default.Error,R.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([D.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return s.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return s.push([D.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([D.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$vg)(N,p.main);(0,L.$pg)(i,N)||s.push([D.default.Warning,R.localize(10,null,i.path,N.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([D.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$vg)(N,p.browser);(0,L.$pg)(i,N)||s.push([D.default.Warning,R.localize(12,null,i.path,N.path)])}}if(!A.valid(p.version))return s.push([D.default.Error,R.localize(13,null)]),s;const o=[];if(!f(u,$,p,P,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$Po=d;function f(u,$,N,p,P){return p||typeof N.main>"u"&&typeof N.browser>"u"?!0:v(u,$,N.engines.vscode,P)}e.$Qo=f;function E(u,$,N){return u==="*"||v($,N,u)}e.$Ro=E;function v(u,$,N,p=[]){const P=S(c(N));if(!P)return p.push(R.localize(14,null,N)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return p.push(R.localize(15,null,N)),!1}else if(!P.majorMustEqual)return p.push(R.localize(16,null,N)),!1;return I(u,$,P)?!0:(p.push(R.localize(17,null,u,N)),!1)}function m(u){if(!Array.isArray(u))return!1;for(let $=0,N=u.length;$<N;$++)if(typeof u[$]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;async function R(A,j,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const S=(await j.readFile(A.serviceMachineIdResource)).value.toString();h=(0,D.$dg)(S)?S:null}catch{h=null}if(!h){h=(0,D.$eg)();try{await j.writeFile(A.serviceMachineIdResource,L.$be.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.$_o=R}),define(ne[49],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class L{constructor(R,A=[],j=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Mh=L}),define(ne[114],re([0,1,49]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const D=[];var R;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(b,h,c){h instanceof L.$Mh||(h=new L.$Mh(h,[],!!c)),D.push([b,h])}e.$wr=A;function j(){return D}e.$xr=j}),define(ne[115],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$bq=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const b=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(j);b.outgoing.set(h.key,h),h.incoming.set(b.key,b)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const b of this.a.values())b.outgoing.delete(j),b.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let b=this.a.get(j);return b||(b=new L(j,A),this.a.set(j,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,b]of this.a)A.push(`${j}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const b=new Set([A]),h=this.c(j,b);if(h)return h}}c(A,j){for(const[b,h]of A.outgoing){if(j.has(b))return[...j,b].join(" -> ");j.add(b);const c=this.c(h,j);if(c)return c;j.delete(b)}}}e.$cq=D}),define(ne[25],re([0,1,3,11,10]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,R.$Ph)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$ki=A;function j(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$li=j;var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$ni=c;function S(u,$){const N=Object.create(null);for(const p in u)I(N,p,u[p],$);return N}e.$oi=S;function I(u,$,N,p){const P=$.split("."),s=P.pop();let o=u;for(let t=0;t<P.length;t++){const i=P[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${$} as ${P.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=N}catch{p(`Ignoring ${$} as ${P.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${$} as ${P.join(".")} is ${JSON.stringify(o)}`)}e.$pi=I;function d(u,$){const N=$.split(".");f(u,N)}e.$qi=d;function f(u,$){const N=$.shift();if($.length===0){delete u[N];return}if(Object.keys(u).indexOf(N)!==-1){const p=u[N];typeof p=="object"&&!Array.isArray(p)&&(f(p,$),Object.keys(p).length===0&&delete u[N])}}function E(u,$,N){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const P=$.split("."),s=p(u,P);return typeof s>"u"?N:s}e.$ri=E;function v(u,$,N){Object.keys($).forEach(p=>{p!=="__proto__"&&(p in u?L.$Af(u[p])&&L.$Af($[p])?v(u[p],$[p],N):N&&(u[p]=$[p]):u[p]=$[p])})}e.$si=v;function m(u){return u.replace(/[\[\]]/g,"")}e.$ti=m}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(G,e,L,D,R,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$k),h.set("isLinux",L.$l),h.set("isWindows",L.$j),h.set("isWeb",L.$p),h.set("isMacNative",L.$k&&!L.$p),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(F,a){if(h.get(F)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,a)}e.$Li=c;const S=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,j.localize)(0,null),E=(0,j.localize)(1,null),v=(0,j.localize)(2,null),m=(0,j.localize)(3,null),u=(0,j.localize)(4,null),$=(0,j.localize)(5,null),N=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class P{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new R.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const z=this.D(),C=z.type===17?$:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:R.$Ki.getLexeme(z),additionalInfo:C}),P.c}return g}catch(g){if(g!==P.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,m),g?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,m),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Z=C.lexeme,W=Z.lastIndexOf("/"),le=W===Z.length-1?void 0:this.w(Z.substring(W+1));let oe;try{oe=new RegExp(Z.substring(1,W),le)}catch{throw this.B("REGEX",C)}return ce.create(g,oe)}switch(C.type){case 10:case 19:{const Z=[C.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?le++:C.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:C.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Z.push(R.$Ki.getLexeme(W)),this.z(),W=this.D()}const oe=Z.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this.w(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this.B("REGEX",C)}return s.regex(g,ge)}case 18:{const Z=C.lexeme;this.z();let W=null;if(!(0,D.$Be)(Z)){const le=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(le!==oe&&le>=0){const me=Z.slice(le+1,oe),de=Z[oe+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",C)}}}if(W===null)throw this.B("REGEX",C);return ce.create(g,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const C=this.u();return s.notIn(g,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return s.equals(g,C);switch(C){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return s.notEquals(g,C);switch(C){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,C)}}case 5:return this.z(),te.create(g,this.u());case 6:return this.z(),ae.create(g,this.u());case 7:return this.z(),x.create(g,this.u());case 8:return this.z(),ue.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:N,offset:a.offset,lexeme:"",additionalInfo:p}),P.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,z){const C=(0,j.localize)(8,null,a,R.$Ki.getLexeme(g)),Z=g.offset,W=R.$Ki.getLexeme(g);return this.h.push({message:C,offset:Z,lexeme:W,additionalInfo:z}),P.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=P;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return k.create(a,g)}static notEquals(a,g){return O.create(a,g)}static regex(a,g){return ce.create(a,g)}static in(a,g){return y.create(a,g)}static notIn(a,g){return w.create(a,g)}static not(a){return H.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return x.create(a,g)}static greaterEquals(a,g){return ue.create(a,g)}static smaller(a,g){return te.create(a,g)}static smallerEquals(a,g){return ae.create(a,g)}static{this.c=new P({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Ni=s;function o(F){const a=new P({regexParsingWithErrorRecovery:!1});return F.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,j.localize)(9,null,z.additionalInfo):(0,j.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Oi=o;function t(F,a){const g=F?F.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!g&&!z?!0:!g||!z?!1:g.equals(z)}e.$Pi=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Qi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Ri=r;class l{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Si=l;class k{static create(a,g,z=null){if(typeof g=="boolean")return g?l.create(a,z):H.create(a,z);const C=h.get(a);return typeof C=="boolean"?g===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ti=k;class y{static create(a,g){return new y(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:J(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(g)?g.includes(z):typeof z=="string"&&typeof g=="object"&&g!==null?S.call(g,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Ui=y;class w{static create(a,g){return new w(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=y.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=w;class O{static create(a,g,z=null){if(typeof g=="boolean")return g?H.create(a,z):l.create(a,z);const C=h.get(a);return typeof C=="boolean"?g===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new O(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Wi=O;class H{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new H(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Xi=H;function _(F,a){if(typeof F=="string"){const g=parseFloat(F);isNaN(g)||(F=g)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class x{static create(a,g,z=null){return _(g,C=>new x(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Yi=x;class ue{static create(a,g,z=null){return _(g,C=>new ue(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Zi=ue;class te{static create(a,g,z=null){return _(g,C=>new te(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$1i=te;class ae{static create(a,g,z=null){return _(g,C=>new ae(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$2i=ae;class ce{static create(a,g){return new ce(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return g<z?-1:g>z?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&g===z}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$3i=ce;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$4i=ie;function q(F){let a=null;for(let g=0,z=F.length;g<z;g++){const C=F[g].substituteConstants();if(F[g]!==C&&a===null){a=[];for(let Z=0;Z<g;Z++)a[Z]=F[Z]}a!==null&&(a[g]=C)}return a===null?F:a}class X{static create(a,g,z){return X.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,z){const C=[];let Z=!1;for(const W of a)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){C.push(...W.expr);continue}C.push(W)}if(C.length===0&&Z)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];for(;C.length>1;){const W=C[C.length-1];if(W.type!==9)break;C.pop();const le=C.pop(),oe=C.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,oe);me&&(C.push(me),C.sort(i))}if(C.length===1)return C[0];if(z){for(let W=0;W<C.length;W++)for(let le=W+1;le<C.length;le++)if(C[W].negate().equals(C[le]))return n.INSTANCE;if(C.length===1)return C[0]}return new X(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new X(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$5i=X;class T{static create(a,g,z){return T.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,z){let C=[],Z=!1;if(a){for(let W=0,le=a.length;W<le;W++){const oe=a[W];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Z)return n.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];if(z){for(let W=0;W<C.length;W++)for(let le=W+1;le<C.length;le++)if(C[W].negate().equals(C[le]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),z=a.shift(),C=[];for(const Z of M(g))for(const W of M(z))C.push(X.create([Z,W],null,!1));a.unshift(T.create(C,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$6i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,g,z){super(a,null),this.f=g,typeof z=="object"?U.d.push({...z,key:a}):z!==!0&&U.d.push({key:a,description:z,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return O.create(this.key,a)}}e.$7i=U,e.$8i=(0,A.$Ph)("contextKeyService");function B(F,a){return F<a?-1:F>a?1:0}function J(F,a,g,z){return F<g?-1:F>g?1:a<z?-1:a>z?1:0}function Q(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?K(F.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Q(F,g))return!0;return!1}if(F.type===6){if(a.type===6)return K(a.expr,F.expr);for(const g of F.expr)if(Q(g,a))return!0;return!1}return F.equals(a)}e.$9i=Q;function K(F,a){let g=0,z=0;for(;g<F.length&&z<a.length;){const C=F[g].cmp(a[z]);if(C<0)return!1;C===0&&g++,z++}return g===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(ne[59],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On=(0,L.$Ph)("downloadService")}),define(ne[18],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,L.$Ph)("environmentService"),e.$Xh=(0,L.$Qh)(e.$Wh)}),define(ne[21],re([0,1,92,10]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=R;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=A;function j(u,$){switch(u){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=j;function b(u,$){return $==="web"&&!u.includes("web")}e.$7n=b;function h(u,$,N){return b($,N)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===N}e.$8n=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$9n=c;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var I;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$0n=(0,D.$Ph)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var v;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class m extends Error{constructor($,N){super($),this.code=N,this.name=N}}e.$$n=m,e.$_n=(0,D.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,D.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,D.$Ph)("IExtensionTipsService"),e.$eo=(0,L.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=void 0,e.$ep=(0,L.$Ph)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,j)=>G(["node-vsce-sign"],async b=>A(b),j))),this.a}async verify(A,j,b){let h;try{h=await this.b()}catch{return!1}return h.verify(A,j,b)}}e.$fp=D}),define(ne[61],re([0,1,14,9,100,12]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function j(S,I,d,f,E,v){let m;try{await b(S,I,d,f,E,v)}catch(u){m=u}finally{m&&E.errorTransformer&&(m=E.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}e.$Mp=j;async function b(S,I,d,f,E,v){h(v);const m=await S.open(I,{create:!1});try{h(v);let u=0,$=0,N=E&&typeof E.length=="number"?E.length:void 0,p=L.$be.alloc(Math.min(E.bufferSize,typeof N=="number"?N:E.bufferSize)),P=E&&typeof E.position=="number"?E.position:0,s=0;do $=await S.read(m,P,p.buffer,s,p.byteLength-s),P+=$,s+=$,u+=$,typeof N=="number"&&(N-=$),s===p.byteLength&&(await d.write(f(p)),p=L.$be.alloc(Math.min(E.bufferSize,typeof N=="number"?N:E.bufferSize)),s=0);while($>0&&(typeof N!="number"||N>0)&&h(v)&&c(u,E));if(s>0){let o=s;typeof N=="number"&&(o=Math.min(s,N)),d.write(f(p.slice(0,o)))}}catch(u){throw(0,A.$mk)(u)}finally{await S.close(m)}}function h(S){if(S.isCancellationRequested)throw(0,D.$6)();return!0}function c(S,I){if(typeof I?.limits?.size=="number"&&S>I.limits.size)throw(0,A.$lk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class b extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const S=this.j(c),I=S.filter(f=>{const E=this.c.get(f.path);return E?!(0,D.$Aj)(E.request.excludes,f.excludes)||!(0,D.$Aj)(E.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!S.find(E=>E.path===f.path&&(0,D.$Aj)(E.excludes,f.excludes)&&(0,D.$Aj)(E.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const S=new j.$9p(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:S};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const S=this.c.get(c);S&&(this.c.delete(c),S.instance.dispose())}j(c){const S=new Map;for(const I of c){const d=A.$l?I.path:I.path.toLowerCase();let f=S.get(I.correlationId);f||(f=new Map,S.set(I.correlationId,f)),f.set(d,I)}return Array.from(S.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,S]of this.c)S.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,S){return S?`[File Watcher (node.js)] ${c} (path: ${S.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$$p=b}),define(ne[118],re([0,1,62,117]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class R extends L.$Qp{constructor(j,b,h){super(j,b,h),this.s()}r(j){return j.add(new D.$$p)}}e.$_p=R}),define(ne[119],re([0,1,15,57,85,62]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class j extends A.$Rp{constructor(h,c,S){super(h,c,S),this.s()}r(h){const c=h.add(new R.$3p(L.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:S,signal:I})=>this.t(`terminated by itself with code ${S}, signal: ${I}`))),D.ProxyChannel.toService((0,D.$wh)(c.getChannel("watcher")))}}e.$4p=j}),define(ne[63],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,j]of R)this.set(A,j)}set(R,A){const j=this.a.get(R);return this.a.set(R,A),j}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Nh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const S=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new h.$Nh,u=!1,$,N=S){this.f=m,this.g=u,this.h=$,this.i=N,this.o=new Set,this.f.set(b.$Oh,this),this._globalGraph=N?$?._globalGraph??new j.$cq(p=>p):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...u){const $=E.traceInvocation(this.i,m);let N=!1;try{return m({get:P=>{if(N)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(P,$);if(!s)throw new Error(`[invokeFunction] unknown service '${P}'`);return s}},...u)}finally{N=!0,$.stop()}}createInstance(m,...u){let $,N;return m instanceof A.$Mh?($=E.traceCreation(this.i,m.ctor),N=this.j(m.ctor,m.staticArguments.concat(u),$)):($=E.traceCreation(this.i,m),N=this.j(m,u,$)),$.stop(),N}j(m,u=[],$){const N=b._util.getServiceDependencies(m).sort((s,o)=>s.index-o.index),p=[];for(const s of N){const o=this.m(s.id,$);o||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const P=N.length>0?N[0].index:u.length;if(u.length!==P){console.trace(`[createInstance] First service dependency of ${m.name} at position ${P+1} conflicts with ${u.length} static arguments`);const s=P-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,P)}return Reflect.construct(m,u.concat(p))}k(m,u){if(this.f.get(m)instanceof A.$Mh)this.f.set(m,u);else if(this.h)this.h.k(m,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const u=this.f.get(m);return!u&&this.h?this.h.l(m):u}m(m,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const $=this.l(m);return $ instanceof A.$Mh?this.q(m,$,u.branch(m,!0)):(u.branch(m,!1),$)}q(m,u,$){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,u,$)}finally{this.o.delete(m)}}r(m,u,$){const N=new j.$cq(s=>s.id.toString());let p=0;const P=[{id:m,desc:u,_trace:$}];for(;P.length;){const s=P.pop();if(N.lookupOrInsertNode(s),p++>1e3)throw new I(N);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Mh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};N.insertEdge(s,i),P.push(i)}}}for(;;){const s=N.roots();if(s.length===0){if(!N.isEmpty())throw new I(N);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Mh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}N.removeNode(o)}}return this.l(m)}s(m,u,$=[],N,p){if(this.f.get(m)instanceof A.$Mh)return this.t(m,u,$,N,p);if(this.h)return this.h.s(m,u,$,N,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(m,u,$=[],N,p){if(N){const P=new d(void 0,this.g,this,this.i);P.c=String(m);const s=new Map,o=new L.$$g(()=>{const t=P.j(u,$,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$2c,s.set(i,l)),(y,w,O)=>{const H=l.push([y,w,O]);return(0,R.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,$,p)}u(m,u){if(u&&console.warn(m),this.g)throw new Error(m)}}e.$dq=d;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,u){return m?new E(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(m,u){return m?new E(1,u.name):E.c}static{this.f=0}constructor(m,u){this.type=m,this.name=u,this.g=Date.now(),this.h=[]}branch(m,u){const $=new E(3,m.toString());return this.h.push([m,u,$]),$}stop(){const m=Date.now()-this.g;E.f+=m;let u=!1;function $(p,P){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of P.h)if(i&&n){u=!0,s.push(`${o}CREATES -> ${t}`);const r=$(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const N=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(m>2||u)&&E.all.add(N.join(`
`))}}e.$eq=E});var se=this&&this.__param||function(G,e){return function(L,D){e(L,D,G)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(G,e,L,D,R,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0;function h(S){return S.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$Rq=h,e.$Sq=(0,b.$Ph)("languagePackService");let c=class extends D.$Sc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$Xd;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const E=d.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(m=>m.startsWith("lp-"))).map(v=>{const m=v.properties.localizedLanguages?.[0],u=h(v);return{...this.f(u,m,v),extensionId:v.identifier.id,galleryExtension:v}});return E.push(this.f("en","English")),E}f(I,d,f){const E=d??I;let v;if(E!==I&&(v=`(${I})`),I.toLowerCase()===R.$w.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),f?.installCount){v??="";const m=f.installCount;let u;m>1e6?u=`${Math.floor(m/1e5)/10}M`:m>1e3?u=`${Math.floor(m/1e3)}K`:u=String(m),v+=` $(cloud-download) ${u}`}return{id:I,label:E,description:v}}};e.$Tq=c,e.$Tq=c=pe([se(0,j.$0n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(G,e,L,D,R,A,j,b,h,c,S,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,d.$Ph)("logService"),e.$$i=(0,d.$Ph)("loggerService");function f(){return new Date().toISOString()}function E(y){return(0,c.$Cf)(y)}e.$_i=E;var v;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$aj=v.Info;function m(y,w,O){switch(w){case v.Trace:y.trace(O);break;case v.Debug:y.debug(O);break;case v.Info:y.info(O);break;case v.Warning:y.warn(O);break;case v.Error:y.error(O);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=m;function u(y,w=!1){let O="";for(let H=0;H<y.length;H++){let _=y[H];if(_ instanceof Error&&(_=(0,L.$Ai)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}O+=(H>0?" ":"")+_}return O}class $ extends A.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new D.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$cj=$;class N extends ${constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...O){this.f(v.Trace)&&this.g(v.Trace,u([w,...O],!0))}debug(w,...O){this.f(v.Debug)&&this.g(v.Debug,u([w,...O]))}info(w,...O){this.f(v.Info)&&this.g(v.Info,u([w,...O]))}warn(w,...O){this.f(v.Warning)&&this.g(v.Warning,u([w,...O]))}error(w,...O){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,u(H))}else this.g(v.Error,u([w,...O]))}flush(){}}e.$dj=N;class p extends ${constructor(w=e.$aj){super(),this.setLevel(w),this.g=!b.$j}trace(w,...O){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...O):console.warn(`[main ${f()}]`,w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...O):console.error(`[main ${f()}]`,w,...O))}dispose(){}flush(){}}e.$ej=p;class P extends ${constructor(w=e.$aj,O=!0){super(),this.g=O,this.setLevel(w)}trace(w,...O){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}dispose(){}flush(){}}e.$fj=P;class s extends ${constructor(w,O=e.$aj){super(),this.g=w,this.setLevel(O)}trace(w,...O){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...O])}debug(w,...O){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...O])}info(w,...O){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...O])}warn(w,...O){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...O])}error(w,...O){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...O])}h(w){return typeof w=="string"?w:(0,L.$Ai)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$gj=s;class o extends ${constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.g)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const H of this.g)H.trace(w,...O)}debug(w,...O){for(const H of this.g)H.debug(w,...O)}info(w,...O){for(const H of this.g)H.info(w,...O)}warn(w,...O){for(const H of this.g)H.warn(w,...O)}error(w,...O){for(const H of this.g)H.error(w,...O)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$hj=o;class t extends A.$Sc{constructor(w,O,H){if(super(),this.h=w,this.j=O,this.b=new j.$Ac,this.c=this.B(new D.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeVisibility=this.g.event,H)for(const _ of H)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$yf)(w)?[...this.b.values()].find(O=>O.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,O){const H=this.n(w),_=(0,c.$yf)(w)?w:O?.id??(0,R.$Di)(H.toString()).toString(16);let x=this.b.get(H)?.logger;const ue=O?.logLevel==="always"?v.Trace:O?.logLevel;x||(x=this.s(H,ue??this.getLogLevel(H)??this.h,{...O,id:_}));const te={logger:x,info:{resource:H,id:_,logLevel:ue,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(te.info),this.b.set(H,te),x}n(w){return(0,c.$yf)(w)?(0,h.$vg)(this.j,`${w}.log`):w}setLogLevel(w,O){if(S.URI.isUri(w)){const H=w,_=O,x=this.b.get(H);x&&_!==x.info.logLevel&&(x.info.logLevel=_===this.h?void 0:_,x.logger?.setLevel(_),this.b.set(x.info.resource,x),this.f.fire([H,_]))}else{this.h=w;for(const[H,_]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,O){const H=this.m(w);H&&O!==!H.info.hidden&&(H.info.hidden=!O,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this.b.get(w)?.info.logLevel),O??this.h}registerLogger(w){const O=this.b.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this.b.get(w);O&&(O.logger&&O.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Nd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.$jj=i;class n extends i{}e.$kj=n;function r(y){if(y.verbose)return v.Trace;if(typeof y.logLevel=="string"){const w=k(y.logLevel.toLowerCase());if(w!==void 0)return w}return e.$aj}e.$lj=r;function l(y){switch(y){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$mj=l;function k(y){switch(y){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$nj=k,e.$oj=new I.$7i("logLevel",l(v.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class S extends j.$Sc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Rg(0)),this.w=[],this.y=this.B(new D.$Rg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},v=(0,L.$Ub)(this.j,E);return this.r(),(0,j.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Sp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$Op)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$Op)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},v=(0,L.$Ub)(this.w,E);return this.C(),(0,j.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$Sp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,b.$hc)(d.fsPath)}}e.$Wp=S}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;let P=class extends c.$Sc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new j.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Nd),this.Y=this.B(new j.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$3g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new m.$rk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$zg)(o))throw new m.$tk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new N.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,m.$ek)(t)||(0,m.$bk)(t)||(0,m.$fk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,m.$ek)(t)||(0,m.$bk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,m.$ok)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.$tk((0,v.localize)(2,null,this.sb(o)),1):(0,m.$mk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,y=await i.stat(o);let w;return this.t(i,o,y,void 0,!!k,(O,H)=>(w||(w=S.$Vh.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&l?H===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:k}=this.R(o),y={resource:t,name:k.basename(t),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&l(y,n)){try{const w=await o.readdir(t),O=await D.Promises.settled(w.map(async([H,_])=>{try{const x=k.joinPath(t,H),ue=r?await o.stat(x):{type:_};return await this.t(o,x,ue,w.length,r,l)}catch(x){return this.b.trace(x),null}}));y.children=(0,L.$Hb)(O)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new m.$tk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=R.$be.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new m.$qk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,m.$hk)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(l={...i,atomic:k})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let y;if((0,m.$bk)(n)&&!(t instanceof R.$be))if((0,E.$Zd)(t)){const w=await(0,E.$7d)(t,3);w.ended?y=R.$be.concat(w.buffer):y=w}else y=(0,E.$4d)(t,w=>R.$be.concat(w),3);else y=t;!(0,m.$ek)(n)||(0,m.$bk)(n)&&y instanceof R.$be||(0,m.$bk)(n)&&(0,m.$hk)(n)&&l?.atomic?await this.hb(n,o,l,y):await this.db(n,o,l,y instanceof R.$be?(0,R.$me)(y):y),this.r.fire(new m.$qk(o,4))}catch(k){throw new m.$tk((0,v.localize)(4,null,this.sb(o),(0,m.$mk)(k).toString()),(0,m.$pk)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$tk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.$Dk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,m.$Ek)({mtime:i.mtime,size:l.size}))throw new m.$tk((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){l(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.$ne)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$Xd(n);let l=i;(0,m.$gk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let y;try{return typeof l?.etag=="string"&&l.etag!==m.$Dk&&await k,l?.atomic&&(0,m.$gk)(o)||!((0,m.$ek)(o)||(0,m.$fk)(o))||(0,m.$bk)(o)&&l?.preferUnbuffered?y=this.I(o,t,l):(0,m.$fk)(o)?y=this.G(o,t,r.token,l):y=this.H(o,t,r.token,l),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await k,value:y}}catch(w){throw y&&await(0,E.$5d)(y),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,m.$mk)(o).toString());return o instanceof m.$vk?new m.$vk(n,o.stat,i):o instanceof m.$uk?new m.$uk(n,o.fileOperationResult,o.size,o.options):new m.$tk(n,(0,m.$pk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$$d)(r,{data:l=>l instanceof R.$be?l:R.$be.wrap(l),error:l=>this.F(l,t,n)},l=>R.$be.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,R.$re)();return(0,u.$Mp)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,E.$2d)(r=>R.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,m.$gk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(R.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.$tk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$Dk&&t.etag===i.etag)throw new m.$vk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new m.$uk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$qk(o,l==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$qk(o,l==="copy"?3:2,k)),k}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:y}=await this.Q(o,t,i,n,r,l);if(k&&!y&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,m.$ck)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,m.$ek)(o)&&(0,m.$ek)(i))return this.jb(o,t,i,n);if((0,m.$ek)(o)&&(0,m.$bk)(i))return this.pb(o,t,i,n);if((0,m.$bk)(o)&&(0,m.$ek)(i))return this.nb(o,t,i,n);if((0,m.$bk)(o)&&(0,m.$bk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:O}=this.R(o);if(O||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const y=await this.exists(n);if(y&&!k){if(!l)throw new m.$tk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$lg:f.$ng,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$qk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&m.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,m.$ok)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,m.$ok)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new m.$tk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,m.$ik)(i)&&!n?.atomic){const y=i.enforceAtomicDelete?.(o);y&&(n={...t,atomic:y})}const r=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new m.$qk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,m.$dk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,m.$ck)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Nc)(k):r=()=>(0,c.$Nc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new j.$Nd);return i.add(this.X.event(w=>{w.correlates(l)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Di)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$Zd)(n)||(0,E.$1d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,m.$mk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$1d)(i)){if(i.buffer.length>0){const l=R.$be.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,k)=>{(0,E.$6d)(r,{onData:async y=>{r.pause();try{await this.gb(o,t,y,y.byteLength,n,0)}catch(w){return k(w)}n+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>k(y),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let k=0;for(;k<n;){const y=await o.write(t,r+k,i.buffer,l+k,n-k);k+=y}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof R.$be?r=n:(0,E.$Zd)(n)?r=await(0,R.$ne)(n):(0,E.$1d)(n)?r=await(0,R.$oe)(n):r=(0,R.$le)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$be.alloc(this.a);let y=0,w=0,O=0;do O=await o.read(r,y,k.buffer,w,k.byteLength-w),await this.gb(i,l,k,O,y,w),y+=O,w+=O,w===k.byteLength&&(w=0);while(O>0)}catch(k){throw(0,m.$mk)(k)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,R.$be.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$mk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,R.$ne)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new m.$tk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$tk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$Np=P,e.$Np=P=p=pe([se(0,$.$0i)],P)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,N.$Ai)(o)}`)}})();class s extends $.$Wp{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Ac(n=>d.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,d.$vg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=m.FileType.Unknown:t.isFile()?n=m.FileType.File:t.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new R.$Sg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$2d)(l=>j.$be.concat(l.map(k=>j.$be.wrap(k))).buffer);return(0,u.$Mp)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$vg)((0,d.$ug)(t),`${(0,d.$sg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Rc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(k)){if(!n.overwrite)throw(0,m.$lk)((0,v.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$lk)((0,v.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,m.$_j)(i)&&!n&&(l=await this.O(t));let k;try{if((0,m.$_j)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let y;if((0,m.$_j)(i)){if(I.$j)try{await E.Promises.truncate(r,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";k=await E.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,m.$_j)(i)?await this.gb(t,y):this.fb(y)}if(this.U.set(k,0),(0,m.$_j)(i)&&this.X.set(k,t),l){const y=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),y.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const k=this.Z(t,i);let y=null;try{y=(await E.Promises.read(t,n,r,l,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,y)}return y}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,R.$_g)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const k=this.Z(t,i);let y=null;try{y=(await E.Promises.write(t,n,r,l,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,y)}return y}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,S.$jc)((0,S.$mc)(n),`${(0,S.$nc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:y}=await E.SymlinkSupport.stat(n);l=k.isDirectory()&&!y}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(2,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(3,null,(0,S.$nc)(r),(0,S.$nc)((0,S.$mc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const l=this.H(t),k=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,h.$Wf)(l,k,!0)),y){if(n==="copy")throw(0,m.$lk)((0,v.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.L(t);if(!O)throw(0,m.$lk)((0,v.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,m.$lk)((0,v.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);O.type&m.FileType.File&&H.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,h.$Wf)(r,l,!k))return;const y=new c.$Rc;try{y.add(await this.O(t)),y.add(await this.O(i)),n&&await E.Promises.mkdir((0,S.$mc)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{y.dispose()}}t(t,i,n){return new p.$4p(r=>t(r),r=>i(r),n)}F(t,i,n){return new P.$_p(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof m.$kk)return t;let i=t,n;switch(t.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$lk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,m.$lk)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$aq=s}),define(ne[126],re([0,1,2,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;class R extends L.$Sc{constructor(j,b=[]){super(),this.a=new D.$hj([j,...b]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...b){this.a.trace(j,...b)}debug(j,...b){this.a.debug(j,...b)}info(j,...b){this.a.info(j,...b)}warn(j,...b){this.a.warn(j,...b)}error(j,...b){this.a.error(j,...b)}flush(){this.a.flush()}}e.$IN=R}),define(ne[127],re([0,1,12,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,S,I,d,f){try{const E=await new Promise((m,u)=>{G(["@vscode/spdlog"],m,u)});E.setFlushOn(R.Trace);const v=await E.createAsyncRotatingLogger(c,S,I,d);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(E){console.error(E)}return null}function j(c,S,I){switch(S){case D.LogLevel.Trace:c.trace(I);break;case D.LogLevel.Debug:c.debug(I);break;case D.LogLevel.Info:c.info(I);break;case D.LogLevel.Warning:c.warn(I);break;case D.LogLevel.Error:c.error(I);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function b(c,S){switch(S){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class h extends D.$dj{constructor(S,I,d,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(S,I,d,f),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(S,I,d,f){const E=d?6:1,v=30/E*L.$Gk.MB,m=await A(S,I,v,E,f);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:u,message:$}of this.m)j(this.r,u,$);this.m=[]}}g(S,I){this.r?j(this.r,S,I):this.getLevel()<=S&&this.m.push({level:S,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$xN=h}),define(ne[128],re([0,1,28,6,127]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class A extends D.$ij{s(b,h,c){return new R.$xN((0,L.$eg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$yN=A}),define(ne[38],re([0,1,4,65,2,10]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,A.$Ph)("policy");class j extends R.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const S=Object.keys(this.f).length;return this.f={...c,...this.f},S!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[S,I])=>({...c,[S]:{definition:I,value:this.g.get(S)}}),{})}}e.$jn=j;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=b}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;function c(I,d){const f=[];for(const E of new Set(R.Iterable.concat(I.keys(),d.keys())))I.get(E)!==d.get(E)&&f.push(E);return f}let S=class extends h.$jn{constructor(d,f,E){super(),this.m=d,this.n=f,this.s=E,this.c=this.B(new L.$Rg(500));const v=D.Event.filter(f.onDidFilesChange,m=>m.affects(d));this.B(f.watch(d)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,A.$Af)(E))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(E))this.f[v]&&d.set(v,E[v])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$t8b=S,e.$t8b=S=pe([se(1,j.$$j),se(2,b.$0i)],S)}),define(ne[130],re([0,1,38,8,171,2,6]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0;let b=class extends L.$jn{constructor(c,S){super(),this.m=c,this.n=S,this.a=new D.$Ng,this.b=this.B(new A.$Tc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((S,I)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,d=>{this.t(d),S()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const S in c){const I=c[S];I===void 0?this.g.delete(S):this.g.set(S,I)}this.h.fire(Object.keys(c))}};e.$s8b=b,e.$s8b=b=pe([se(0,j.$0i)],b)}),define(ne[32],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,L.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class R{constructor(){this.a=new Map}add(j,b){L.ok(D.$yf(j)),L.ok(D.$Af(b)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,b)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$gn=new R}),define(ne[131],re([0,1,4,36]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new L.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[R(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;D.$gn.add(e.$hn.JSONContribution,j)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ln={Configuration:"base.contributions.configuration"};var S;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const I=h.$gn.as(b.$hn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$Nd,this.onDidSchemaChange=this.i.event,this.j=new D.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$vn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))k.set(H,n);const y={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:y,valuesSources:k});const w=(0,j.$ti)(r),O={type:"object",default:y,description:A.localize(1,null,w),$ref:e.$sn,defaultDefaultValue:y,source:R.$yf(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=O,this.b.properties[r]=O}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=R.$yf(i)?i:i?.id,k=R.$yf(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(n),this.a.delete(n),e.$vn.test(n))delete this.d[n],delete this.b.properties[n];else{const y=this.d[n];y&&(this.w(n,y),this.r(n,y))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=R.$Hf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const y in l){const w=l[y];if(o&&N(y,w)){delete l[y];continue}if(w.source=t,w.defaultDefaultValue=l[y].default,this.w(y,w),e.$vn.test(y)?w.scope=void 0:(w.scope=R.$Hf(w.scope)?n:w.scope,w.restricted=R.$Hf(w.restricted)?!!i?.includes(y):w.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const k=s.allOf;if(k)for(const y of k)this.p(y,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$mn.properties[s]=o,o.scope){case 1:e.$nn.properties[s]=o;break;case 2:e.$on.properties[s]=o;break;case 6:e.$pn.properties[s]=o;break;case 3:e.$qn.properties[s]=o;break;case 4:e.$rn.properties[s]=o;break;case 5:e.$rn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$mn.properties[s],o.scope){case 1:delete e.$nn.properties[s];break;case 2:delete e.$on.properties[s];break;case 6:delete e.$pn.properties[s];break;case 3:delete e.$qn.properties[s];break;case 4:case 5:delete e.$rn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$sn};this.w(o,t),e.$mn.properties[o]=t,e.$nn.properties[o]=t,e.$on.properties[o]=t,e.$pn.properties[o]=t,e.$qn.properties[o]=t,e.$rn.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=s,e.$nn.patternProperties[e.$un]=s,e.$on.patternProperties[e.$un]=s,e.$pn.patternProperties[e.$un]=s,e.$qn.patternProperties[e.$un]=s,e.$rn.patternProperties[e.$un]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Ff(i)&&(i=o.defaultDefaultValue,n=void 0),R.$Ff(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$un=`^(${f})+$`,e.$vn=new RegExp(e.$un);function v(P){const s=[];if(e.$vn.test(P)){let o=E.exec(P);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(P)}}return(0,L.$Mb)(s)}e.$wn=v;function m(P){return P.reduce((s,o)=>`${s}[${o}]`,"")}e.$xn=m;function u(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=u;const $=new d;h.$gn.add(e.$ln.Configuration,$);function N(P,s){return P.trim()?e.$vn.test(P)?A.localize(7,null,P):$.getConfigurationProperties()[P]!==void 0?A.localize(8,null,P):s.policy?.name&&$.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,P,s.policy?.name,$.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$zn=N;function p(){const P=[],s=$.getConfigurationProperties();for(const o of Object.keys(s))P.push([o,s[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.$An=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,D,R,A,j,b,h,c,S,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function f(o){return Object.isFrozen(o)?o:b.$8m(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,S.$ri)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,S.$ri)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$7m(this.contents),n=b.$7m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const y of k.overrides){const[w]=n.filter(O=>L.$ub(O.identifiers,y.identifiers));w?(this.h(w.contents,y.contents),w.keys.push(...y.keys),w.keys=L.$Mb(w.keys)):n.push(b.$7m(y))}for(const y of k.keys)r.indexOf(y)===-1&&r.push(y)}return new E(i,r,n,l.every(k=>k instanceof E)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const k=i[r];k&&(typeof l=="object"&&typeof k=="object"?(l=b.$7m(l),this.h(l,k)):l=k),n[r]=l}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Af(t[n])&&h.$Af(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$7m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$7m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,S.$qi)(this.contents,t),I.$vn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,I.$wn)(t))),1))}j(t,i,n){(0,S.$pi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$vn.test(t)&&this.overrides.push({identifiers:(0,I.$wn)(t),keys:Object.keys(this.contents[t]),contents:(0,S.$oi)(this.contents[t],r=>console.error(r))})}}e.$Bn=E;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Hf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:k,hasExcludedProperties:y}=this.h(t,i);this.b=new E(n,r,l,y?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const l=[],k=[];function y(O){Array.isArray(r)?r.push(O):n!==null&&(r[n]=O)}const w={onObjectBegin:()=>{const O={};y(O),l.push(r),r=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const O=[];y(O),l.push(r),r=O,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(O,H,_)=>{k.push({error:O,offset:H,length:_})}};if(t)try{R.$4m(t,w),i=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(t,i){const n=d.$gn.as(I.$ln.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,S.$oi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),y=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:k,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},y=[];for(const w in t)if(I.$vn.test(w)&&n){const O=this.i(t[w],i,!1,r);k[w]=O.raw,l=l||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=i[w],H=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&O?.restricted))?k[w]=t[w]:l=!0}return{raw:k,restricted:y,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$vn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];n.push({identifiers:(0,I.$wn)(r),keys:Object.keys(l),contents:(0,S.$oi)(l,i)})}return n}}e.$Cn=v;class m extends A.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=m;class u{constructor(t,i,n,r,l,k,y,w,O,H,_,x,ue){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=y,this.h=w,this.i=O,this.j=H,this.k=_,this.l=x,this.m=ue}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class ${constructor(t,i,n,r,l=new E,k=new E,y=new j.$Ac,w=new E,O=new j.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=k,this.j=y,this.l=w,this.m=O,this.a=null,this.b=new j.$Ac,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const w of r.overrides)for(const O of w.identifiers)r.getOverrideValue(t,O)!==void 0&&y.add(O);return new u(t,i,r.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:k}=P(this.c,t);i=[...r,...l,...k]}for(const r of i)for(const l of(0,I.$wn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),y=t.getKeysForOverrideIdentifier(l),w=[...y.filter(O=>k.indexOf(O)===-1),...k.filter(O=>y.indexOf(O)===-1),...k.filter(O=>!b.$$m(this.c.override(l).getValue(O),t.override(l).getValue(O)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=P(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=P(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=P(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=P(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=P(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:k,overrides:y}=P(n,i),w=[...r,...l,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:k}=P(i,void 0);return{keys:[...n,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),k=this.x(t.workspace),y=t.folders.reduce((w,O)=>(w.set(c.URI.revive(O[0]),this.x(O[1])),w),new j.$Ac);return new $(i,n,r,l,new E,k,y,new E,new j.$Ac)}static x(t){return new E(t.contents,t.keys,t.overrides)}}e.$En=$;function N(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const y=(0,j.$xc)(i,l,new Set);k.forEach(w=>y.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Fn=N;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=$.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$$m(y,w)}return!0}}e.$Gn=p;function P(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const w=y.filter(O=>!k.includes(O));for(const O of w)l.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const w=k.filter(O=>!y.includes(O));for(const O of w)l.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const w of k)if(y.includes(w)){const O=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,S.$ri)(t.contents,l),y=(0,S.$ri)(o.contents,l);b.$$m(k,y)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,D,R,A,j,b,h,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class d extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$gn.as(h.$ln.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(Array.from(m),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,u){this.h(m,I.$gn.as(h.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new b.$Bn;const m=I.$gn.as(h.$ln.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,u){const $=this.f();for(const N of m){const p=$[N],P=u[N];p!==void 0?this.b.addValue(N,p):P?this.b.addValue(N,P.default):this.b.removeValue(N)}}}e.$Hn=d;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new b.$Bn}async initialize(){return this.configurationModel}}e.$In=f;let E=class extends R.$Sc{get configurationModel(){return this.b}constructor(m,u,$){super(),this.c=m,this.f=u,this.g=$,this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},$=[],N=I.$gn.as(h.$ln.Configuration).getConfigurationProperties();for(const p of m){const P=N[p];if(!P){$.push(p);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}$.push(p),u[P.policy.name]={type:P.type}}}return(0,j.$Lf)(u)||await this.f.updatePolicyDefinitions(u),$}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=I.$gn.as(h.$ln.Configuration).getPolicyConfigurations(),$=(0,L.$Hb)(m.map(N=>u.get(N)));this.m($,!0)}m(m,u){this.g.trace("PolicyConfiguration#update",m);const $=I.$gn.as(h.$ln.Configuration).getConfigurationProperties(),N=[],p=this.b.isEmpty();for(const P of m){const s=$[P]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,A.$$m)(this.b.getValue(P),o))&&N.push([P,o])}else this.b.getValue(P)!==void 0&&N.push([P,void 0])}if(N.length){this.g.trace("PolicyConfiguration#changed",N);const P=this.b;this.b=new b.$Bn;for(const s of P.keys)this.b.setValue(s,P.getValue(s));for(const[s,o]of N)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Jn=E,e.$Jn=E=pe([se(1,S.$in),se(2,c.$0i)],E)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class S extends R.$Sc{constructor(d,f,E,v){super(),this.j=d,this.h=this.B(new D.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Hn),this.c=E instanceof c.$kn?new h.$In:this.B(new h.$Jn(this.b,E,v)),this.f=this.B(new b.$Dn(this.j,{},A.$mg,f)),this.a=new b.$En(this.b.configurationModel,this.c.configurationModel,new b.$Bn,new b.$Bn),this.g=this.B(new L.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:u})=>this.n(m,u))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$En(d,f,new b.$Bn,E)}getConfigurationData(){return this.a.toData()}getValue(d,f){const E=typeof d=="string"?d:void 0,v=(0,j.$ki)(d)?d:(0,j.$ki)(f)?f:{};return this.a.getValue(E,v,void 0)}updateValue(d,f,E,v){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(E,f,2)}n(d,f){const E=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(v,E,7)}r(d){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(d);this.s(E,f,7)}s(d,f,E){const v=new b.$Gn(d,{data:f},this.a);v.source=E,v.sourceConfig=this.t(E),this.h.fire(v)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=S}),define(ne[67],re([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Uk=D;function R(c){if(!c)return;const S=c.indexOf("+");return S<0?c:c.substr(0,S)}e.$Vk=R;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Wk=A;function j(c){const{host:S,port:I}=h(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:I}}e.$Xk=j;function b(c,S){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=S),{host:I,port:d}}e.$Yk=b;function h(c){const S=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$4l=A,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(j||(e.ExtensionType=j={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class h{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m>"u"||m===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){const $=typeof m=="string"?m:m.value,N=typeof u=="string"?u:u.value;return L.$2e($,N)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$6l=h;class c{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const u of m)this.add(u)}add(m){this.c.add(h.toKey(m))}delete(m){return this.c.delete(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}}e.$7l=c;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(h.toKey(m))}get(m){return this.c.get(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}set(m,u){this.c.set(h.toKey(m),u)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=S;function I(v){return d(v)}e.$9l=I;function d(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$0l=d;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$$l=f;function E(v,m){if(m){const u=`onResolveRemoteAuthority:${(0,R.$Vk)(m)}`;return!!v.activationEvents?.includes(u)}return!1}e.$_l=E,e.$am=(0,D.$Ph)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class A extends L.$Sc{constructor(b,h,c,S,I){super(),this.a=b,this.b=h,this.c=c,this.f=I,this.B(S.onDidInstallExtensions(d=>this.g(d))),this.B(S.onDidUninstallExtension(d=>this.h(d)))}g(b){for(const h of b)h.local&&this.invalidate(h.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,b)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,D.$Zl))}catch(h){(0,R.$pk)(h)!==1&&this.f.error(h)}}}e.$Gp=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$So=(0,b.$Ph)("requestService");class S{constructor(P){this.b=P}toJSON(){if(!this.a){const P=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?P[s]="*****":P[s]=this.b[s];this.a=P}return this.a}}class I extends R.$Sc{constructor(P){super(),this.b=0,this.a=P.createLogger("network",{name:(0,A.localize)(0,null),when:h.$oj.isEqualTo((0,h.$mj)(h.LogLevel.Trace)).serialize()})}async c(P,s,o){const t=`${P} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new S(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$0)(i)),i}}}e.$To=I;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Uo=d;function f(p){return p.res.statusCode===204}e.$Vo=f;async function E(p){return f(p)?null:(await(0,L.$ne)(p.stream)).toString()}e.$Wo=E;async function v(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.$Xo=v;async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(f(p))return null;const s=(await(0,L.$ne)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$Yo=m;function u(p){N(p)}e.$Zo=u;let $;function N(p){const P=c.$gn.as(j.$ln.Configuration),s=$;$={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},P.updateConfigurations({add:[$],remove:s?[s]:[]})}N(1)}),define(ne[135],re([0,1,20,15,12,44]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;let j=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,S=L.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,S);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,A.$Xo)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$XN=j,e.$XN=j=pe([se(0,A.$So),se(1,R.$$j)],j)}),define(ne[136],re([0,1,137,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;function R(j,b){return j.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:j.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(j,b,h={}){const c=(0,L.parse)(j),S=h.proxyUrl||R(c,b);if(!S)return null;const I=(0,L.parse)(S);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,D.$Ef)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,E)=>{G(["http-proxy-agent"],f,E)})).HttpProxyAgent(S,d):new(await new Promise((f,E)=>{G(["https-proxy-agent"],f,E)})).HttpsProxyAgent(S,d)}e.$Xq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let E;async function v(u,$,N,p){return N["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$Nl)(p)&&!N["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$Nl)(p)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=d.Promises.withAsyncBody(async(P,s)=>{const o=new A.$Xd;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$Ol)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{P(await m($,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,j.$Ai)(r)))):P({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$Tl=v;async function m(u,$){const N=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",N);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",p);const P=(0,c.$eg)().replace(/-/g,"").substr(0,12),s=new RegExp(P+"({.*})"+P),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,S.$Dl)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if($.isCancellationRequested)return n(new b.$5);const r=(0,D.$nc)(t);let l,k;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const w=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(w.kill(),n(new b.$5))),w.on("error",_=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,j.$Ai)(_)),n(_)});const O=[];w.stdout.on("data",_=>O.push(_));const H=[];w.stderr.on("data",_=>H.push(_)),w.on("close",(_,x)=>{const ue=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&u.trace("getUnixShellEnvironment#stderr",te),_||x)return n(new Error((0,R.localize)(2,null,_,x)));const ae=s.exec(ue),ce=ae?ae[1]:"{}";try{const ie=JSON.parse(ce);N?ie.ELECTRON_RUN_AS_NODE=N:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ie),i(ie)}catch(ie){u.error("getUnixShellEnvironment#errorCaught",(0,j.$Ai)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0,e.$zN=(0,L.$Ph)("stateReadService"),e.$AN=(0,L.$Ph)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=e.$BN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class S extends R.$Sc{constructor(E,v,m,u){super(),this.h=E,this.j=m,this.m=u,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=v===0?void 0:this.B(new L.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.j.error(E)}}getItem(E,v){const m=this.a[E];return(0,A.$Hf)(m)?v:m}setItem(E,v){this.setItems([{key:E,data:v}])}setItems(E){let v=!1;for(const{key:m,data:u}of E)this.a[m]!==u&&((0,A.$Hf)(u)?(0,A.$Ff)(this.a[m])||(this.a[m]=void 0,v=!0):(this.a[m]=u,v=!0));v&&this.r()}removeItem(E){(0,A.$Ff)(this.a[E])||(this.a[E]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.m.writeFile(this.h,D.$be.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(v){this.j.error(v)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$BN=S;let I=class extends R.$Sc{constructor(E,v,m,u){super(),this.a=this.B(new S(v.stateResource,E,m,u))}async init(){await this.a.init()}getItem(E,v){return this.a.getItem(E,v)}};e.$CN=I,e.$CN=I=pe([se(1,j.$Wh),se(2,h.$0i),se(3,b.$$j)],I);class d extends I{setItem(E,v){this.a.setItem(E,v)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$DN=d}),define(ne[69],re([0,1,13,35,28]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function A(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,c,S,I,d,f,E,v,m){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=E,u.sessionID=(0,R.$eg)()+Date.now(),u.commitHash=I,u.version=d,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$i)(L.$u),u["common.nodePlatform"]=D.$dc,u["common.nodeArch"]=S,u["common.product"]=m||"desktop",v&&(u["common.msftInternal"]=v);let $=0;const N=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-N,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),L.$m&&(u["common.snap"]="true");const p=A(c);return p&&(u["common.platformDetail"]=p),u}e.$ho=j;function b(h){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const S=c.toLowerCase();return h.some(I=>S===I)}e.$io=b}),define(ne[26],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,L.$Ph)("telemetryService"),e.$dl=(0,L.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$jo=c;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=S,e.$lo=new S;class I{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$mo=I,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const y=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$mi)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$qo=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$ro=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$so=E;function v(i){const n=i.getValue(h.$kl),r=i.getValue(h.$ll);if(i.getValue(h.$ml)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=v;function m(i){const n={},r={},l={};N(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const y=l[k];typeof y=="number"?r[k]=y:typeof y=="boolean"?r[k]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${y.length}`),n[k]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[k]=y)}return{properties:n,measurements:r}}e.$uo=m;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function $(i){if(!i)return"none";const n=(0,j.$Vk)(i);return u.has(n)?n:"other"}e.$vo=$;function N(i,n,r=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const y=i[k],w=l?l+k:k;Array.isArray(y)?n[w]=(0,L.$_m)(y):y instanceof Date?n[w]=y.toISOString():(0,D.$Af)(y)?r<2?N(y,n,r+1,w+"."):n[w]=(0,L.$_m)(y):n[w]=y}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$io)(r)||l}e.$wo=p;function P(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$xo=P;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const O of n)for(;;){const H=O.exec(i);if(!H)break;l.push([H.index,O.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const O=y.exec(i);if(!O)break;const H=l.some(([_,x])=>O.index<x&&_<y.lastIndex);!k.test(O[0])&&!H&&(r+=i.substring(w,O.index)+"<REDACTED: user-file-path>",w=y.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$9m)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=o(l),l}})}e.$yo=t}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function S(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$We)(t.id,i.id)===0}e.$zo=S;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ao=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[m(i[1]),i[2]]:[m(t),void 0]}e.$Bo=E;function v(t,i){return`${t}.${i}`}e.$Co=v;function m(t){return t.toLowerCase()}e.$Do=m;function u(t,i){return m(v(t??R.$2l,i))}e.$Eo=u;function $(t,i){const n=[],r=l=>{for(const k of n)if(k.some(y=>S(i(y),i(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):n.push([l])}return n}e.$Fo=$;function N(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Go=N;function p(t){return{id:new c.$jo(t.identifier.id),name:new c.$jo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Ho=p,e.$Io=new R.$6l("pprice.better-merge");function P(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(k=>!S(k.identifier,{id:l}))){const k=t.filter(y=>S(y.identifier,{id:l}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Jo=P;async function s(t,i){if(!A.$l)return!1;let n;try{n=(await t.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$6n)(n?"alpine":A.$u,h.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Ko=o}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(G,e,L,D,R,A,j,b,h,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;const d=m=>(0,h.localize)(0,null,m),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function E(m,u){return u?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let v=class{constructor(u,$,N){this.a=u,this.b=$,this.d=N}get f(){}async listExtensions(u,$,N){let p=await this.b.getInstalled(1,N);const P=I.$5l.map(o=>o.toLowerCase());if($&&$!==""){if(P.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),P.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(E(o.manifest,u)))}async installExtensions(u,$,N,p){const P=[];try{const s=[];u.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,l,k)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...N,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||N.installPreReleaseVersion}})};for(const r of u)if(r instanceof b.URI)o.push({vsix:r,installOptions:N});else{const[l,k]=(0,S.$Bo)(r);i(l,k,!1)}for(const r of $)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...N,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,S.$Bo)(r);i(l,k,!0)}const n=await this.b.getInstalled(1,N.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,p,n);k&&s.push(k)}catch(k){this.a.error(k),P.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const k=n.find(y=>(0,S.$zo)(y.identifier,{id:r}));if(k){if(!p&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,h.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const y=await this.j(l,k,n);y&&s.push(y)}catch(y){this.a.error(y.message||y.stack||y),P.push(l.id)}else this.a.error(`${d(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),P.push(l.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,D.$0)(s))),s}if(P.length)throw new Error((0,h.localize)(8,null,P.join(", ")))}async g(u,$,N,p){const P=await this.b.getManifest(u);if(!P)throw new Error("Invalid vsix");if(await this.l(P,N,$.profileLocation,p))try{return await this.b.install(u,$),this.a.info((0,h.localize)(9,null,(0,A.$sg)(u))),P}catch(o){if((0,D.$4)(o))return this.a.info((0,h.localize)(10,null,(0,A.$sg)(u))),null;throw o}return null}async h(u){const $=new Map,N=u.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),P=[];for(const s of u)c.$Yn.test(s.id)&&P.push({...s,preRelease:N});if(P.length){const s=await this.d.getExtensions(P,{targetPlatform:p},L.CancellationToken.None);for(const o of s)$.set(o.identifier.id.toLowerCase(),o)}return $}async j({id:u,version:$,installOptions:N},p,P){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=P.find(t=>(0,S.$zo)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,$?`${u}@${$}`:u)),null;this.a.info((0,h.localize)(12,null,u,p.version))}try{N.isBuiltin?this.a.info($?(0,h.localize)(13,null,u,$):(0,h.localize)(14,null,u)):this.a.info($?(0,h.localize)(15,null,u,$):(0,h.localize)(16,null,u));const t=await this.b.installFromGallery(p,{...N,installGivenVersion:!!$});return this.a.info((0,h.localize)(17,null,u,t.manifest.version)),s}catch(t){if((0,D.$4)(t))return this.a.info((0,h.localize)(18,null,u)),null;throw t}}k(u){return!0}async l(u,$,N,p){if(!$){const P={id:(0,S.$Eo)(u.publisher,u.name)},s=p.find(o=>(0,S.$zo)(P,o.identifier)&&(0,j.gt)(o.manifest.version,u.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,$,N){const p=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return E(o)}return s},P=[];for(const s of u){const o=await p(s),i=(await this.b.getInstalled(void 0,N)).filter(n=>(0,S.$zo)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!$&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:N}),P.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(u){const $=await this.b.getInstalled();u.forEach(N=>{$.forEach(p=>{if(p.identifier.id===N&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(u){return this.f?(0,h.localize)(25,null,u,this.f):(0,h.localize)(26,null,u)}};e.$gp=v,e.$gp=v=pe([se(1,c.$_n),se(2,c.$0n)],v)}),define(ne[141],re([0,1,4,2,31,27,37]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class b extends D.$Sc{constructor(c,S,I,d,f,E,v){super(),this.f=c,this.g=S,this.h=I,this.j=d,this.m=f,this.n=E,this.r=v,this.a=this.B(new L.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$1c),this.s().then(null,m=>v.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(S=>(this.c.set(S.id,(0,D.$Pc)(this.n.watch(this.m.extUri.dirname(S.extensionsResource)),this.n.watch(S.extensionsResource))),this.G(S.extensionsResource))))}catch(S){throw this.r.error(S),S}}async w(c){for(const S of c.extensions)this.I(this.L(S.identifier,S.version),c.profileLocation)}async y(c){for(const S of c.extensions){const I=this.L(S.identifier,S.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const S of c.extensions)this.J(this.L(S.identifier,S.version),c.profileLocation)}async C(c){const S=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(E=>{E?S.push(E):this.r.info("Extension not found at the location",d.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(I),S.length&&await this.H(S)}catch(d){this.r.error(d)}}D(c){for(const S of this.h.profiles)c.contains(S.extensionsResource,0,1)&&this.F(S.extensionsResource)}async F(c){const S=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,E=new Set;for(const[v,m]of this.b)m.has(c)&&E.add(v);for(const v of d){const m=this.L(v.identifier,v.version);f.add(m),E.has(m)||(S.push(v.identifier),this.I(m,c))}for(const v of E)if(!f.has(v)){const m=this.M(v);m&&(I.push(m.identifier),this.J(v,c))}(S.length||I.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const S=await this.j.scanProfileExtensions(c);for(const I of S)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,S){let I=this.b.get(c);I||this.b.set(c,I=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),I.add(S)}J(c,S){const I=this.b.get(c);I&&I.delete(S),I?.size||this.b.delete(c)}L(c,S){return`${j.$6l.toKey(c.id)}@${S}`}M(c){const[S,I]=(0,A.$Bo)(c);return I?{identifier:{id:S},version:I}:void 0}}e.$Hp=b}),define(ne[142],re([0,1,113,39]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function R(A,j,b,h,c,S,I){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,D.$ro)(j,b)&&(0,D.$to)(h)===3){const f=await(0,L.$_o)(b,c,S);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$ap=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let v=class extends f.$Tq{constructor(N,p,P,s){super(P),this.h=N,this.j=s,this.g=this.B(new m(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(N,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[N];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const N=await this.g.getLanguagePacks(),p=Object.keys(N).map(P=>{const s=N[P];return{...this.f(P,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((P,s)=>P.label.localeCompare(s.label)),p}async m(N){N&&N.manifest&&N.manifest.contributes&&N.manifest.contributes.localizations&&N.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",N.identifier.id),await this.update())}async n(N){const p=await this.g.getLanguagePacks();Object.keys(p).some(P=>p[P]&&p[P].extensions.some(s=>(0,I.$zo)(s.extensionIdentifier,N.identifier)))&&(this.j.info("Removing language packs from the extension",N.identifier.id),await this.update())}async update(){const[N,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(p);return!(0,D.$ub)(Object.keys(N),Object.keys(P))}};e.$Uq=v,e.$Uq=v=pe([se(0,S.$_n),se(1,c.$Xh),se(2,S.$0n),se(3,d.$0i)],v);let m=class extends A.$Sc{constructor(N,p){super(),this.j=p,this.c={},this.f=(0,b.$jc)(N.userDataPath,"languagepacks.json"),this.g=new R.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(N){return this.s(p=>{Object.keys(p).forEach(P=>delete p[P]),this.m(p,...N)}).then(()=>this.c)}m(N,...p){for(const P of p)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.n(N,P);Object.keys(N).forEach(P=>this.r(N[P]))}n(N,p){const P=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===j.Schemas.file&&u(o)){let t=N[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},N[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$zo)(n.extensionIdentifier,P))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:P,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(p.location.fsPath,n.path)}}r(N){if(N){const p=(0,L.createHash)("md5");for(const P of N.extensions)p.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);N.hash=p.digest("hex")}}s(N=()=>null){return this.g.queue(()=>{let p=null;return h.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(p=N(P),P)).then(P=>{for(const o of Object.keys(P))P[o]||delete P[o];this.c=P,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>p,P=>this.j.error(P))})}};m=pe([se(0,c.$Xh),se(1,d.$0i)],m);function u($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const N of $.translations)if(typeof N.id!="string"||typeof N.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(ne[144],re([0,1,81,9,30,39]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function h(S,I,d){const f=await(0,L.$vC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$vC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new f.AppInsightsCore,m=new E.PostChannel,u={instrumentationKey:S,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){u.extensionConfig={};const $={alwaysUseXhrOverride:!0,httpXHROverride:d};u.extensionConfig[m.identifier]=$}return v.initialize(u,[]),v.addTelemetryInitializer($=>{I&&($.ext=$.ext??{},$.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),v}class c{constructor(I,d,f,E,v){this.e=I,this.f=d,this.g=f,this.h=v,this.c=j,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,R.$0m)(d,this.g),d=(0,A.$uo)(d);const f=this.f+"/"+I;try{this.i(E=>{E.pluginVersionString=d?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$vN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,$,N){this.k=$,this.l=N,this.d={},this.i=new L.$Rc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Fe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$kl)||p.affectsConfiguration(d.$ml)||p.affectsConfiguration(d.$ll))&&this.m()}))}setExperimentProperty(u,$){this.d[u]=$}m(){let u=(0,f.$to)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const N=$.usage?3:$.error?2:0;u=Math.min(u,N)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,$,N){this.g<$||(N=(0,D.$0m)(N,this.d),N=(0,f.$yo)(N,this.j),N=(0,D.$0m)(N,this.c),this.b.forEach(p=>p.log(u,N)))}publicLog(u,$){this.n(u,3,$)}publicLog2(u,$){this.publicLog(u,$)}publicLogError(u,$){this.h&&this.n(u,2,$)}publicLogError2(u,$){this.publicLogError(u,$)}};e.$1q=E,e.$1q=E=pe([se(1,b.$ji),se(2,S.$pj)],E);function v(){const m=(0,j.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=R.$p?"":(0,j.localize)(3,null),N=(0,j.localize)(4,null),p=(0,j.localize)(5,null),P=(0,j.localize)(6,null),s=(0,j.localize)(7,null),o=`
|       | ${N} | ${p} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,j.localize)(8,null);return`
${m} ${u} ${$}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$gn.as(h.$ln.Configuration).registerConfiguration({id:d.$jl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[d.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$gn.as(h.$ln.Configuration).registerConfiguration({id:d.$jl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[d.$ml]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${d.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(G,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=void 0;async function j(S,I){const d=await I.request(S,D.CancellationToken.None),f=(await(0,L.$ne)(d.stream)).toString(),E=d.res.statusCode??200;return{headers:d.res.headers,statusCode:E,responseData:f}}async function b(S){const I={method:S.type,headers:S.headers};return new Promise((f,E)=>{const v=R.request(S.url??"",I,m=>{m.on("data",function(u){f({headers:m.headers,statusCode:m.statusCode??200,responseData:u.toString()})}),m.on("error",function(u){E(u)})});v.write(S.data,m=>{m&&E(m)}),v.end()})}async function h(S,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),E={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const v=S?await j(E,S):await b(E);d(v.statusCode,v.headers,v.responseData)}catch{d(0,{})}}class c extends A.$vN{constructor(I,d,f,E,v){const m={sendPOST:(u,$)=>{h(I,u,$)}};super(d,f,E,v,m)}}e.$wN=c}),define(ne[148],re([0,1,16,24]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=void 0;async function R(A,j){const b=Object.create(null),h=(S,I)=>{const d=JSON.parse(S);b[I]=d};if(j){const S=[],I=await D.Promises.readdir(j);for(const f of I)try{(await D.Promises.stat((0,L.$jc)(j,f))).isDirectory()&&S.push(f)}catch{}const d=[];for(const f of S)(await D.Promises.readdir((0,L.$jc)(j,f))).filter(v=>v==="telemetry.json").length===1&&d.push(f);for(const f of d){const E=(await D.Promises.readFile((0,L.$jc)(j,f,"telemetry.json"))).toString();h(E,f)}}let c=(await D.Promises.readFile((0,L.$jc)(A,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$jc)(A,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$Q8b=R}),define(ne[149],re([0,1,13,82,26]),function(G,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=void 0;async function A(b,h){let c=b.getItem(R.$hl);return(typeof c!="string"||L.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$Sm)(h.error.bind(h))),c}e.$97b=A;async function j(b,h){let c=b.getItem(R.$il);return typeof c!="string"&&(c=await(0,D.$Tm)(h.error.bind(h))),c}e.$07b=j}),define(ne[22],re([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,L.$Ph)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let S=class{constructor(d){this.g=d,this.c=new h.$Rc,this.f=2**16;const f=new Map,E=v=>{let m=f.get(v.scheme);return m===void 0&&(m=d.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,m)),m};this.c.add(b.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new A.$kg(E),this.d=new j.$yr((v,m)=>this.extUri.compare(v,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$wg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((E,v)=>E[1].time<v[1].time?1:E[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(d[E][0],d[E][1].touch())}};e.$zr=S,e.$zr=S=pe([se(0,R.$$j)],S),(0,D.$wr)(L.$Ik,S,1)}),define(ne[151],re([0,1,4,2,12,47,31]),function(G,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;class b extends D.$Sc{constructor(c,S,I,d,f,E){super(),this.f=c,this.g=S,this.h=I,this.j=d,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,S){return this.g.open(this.t(c),S)}close(c){return this.g.close(c)}read(c,S,I,d,f){return this.g.read(c,S,I,d,f)}write(c,S,I,d,f){return this.g.write(c,S,I,d,f)}watch(c,S){this.b.set(c,c);const I=this.g.watch(this.t(c),S);return(0,D.$Qc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,S,I){return this.g.rename(this.t(c),this.t(S),I)}readFile(c,S){return this.g.readFile(this.t(c),S)}readFileStream(c,S,I){return this.g.readFileStream(this.t(c),S,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,S,I){return this.g.writeFile(this.t(c),S,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,S){return this.g.delete(this.t(c),S)}copy(c,S,I){if((0,R.$ck)(this.g))return this.g.copy(this.t(c),this.t(S),I);throw new Error("copy not supported")}cloneFile(c,S){if((0,R.$dk)(this.g))return this.g.cloneFile(this.t(c),this.t(S));throw new Error("clone not supported")}s(c){const S=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&S.push({resource:d,type:I.type,cId:I.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$u8b=b}),define(ne[152],re([0,1,107,16,47,17,11,10,15]),function(G,e,L,D,R,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,b.$Ph)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.uri)}e.$Zh=c;function S(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$1h=S,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$2h:e.$3h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=I;function d(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.configPath)}e.$5h=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:j.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$6h=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=v;function m(i){const n=i;return!!(n&&typeof n=="object"&&j.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=m;class u{constructor(n,r,l,k,y){this.h=n,this.j=l,this.k=k,this.l=y,this.c=R.$Vh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=u;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=$;function N(i){return new $({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$$h=N,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,L.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function p(i,n){return A.$mg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$di=p;function P(i){let n;return j.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$ei=P,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function o(i,n){return!p(i,n)&&!P(i)}e.$hi=o;function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,A.$tg)(i))===e.$ai}e.$ii=t}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var N;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(N||(e.ProfileResourceType=N={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&j.URI.isUri(n.location)&&j.URI.isUri(n.globalStorageHome)&&j.URI.isUri(n.settingsResource)&&j.URI.isUri(n.keybindingsResource)&&j.URI.isUri(n.tasksResource)&&j.URI.isUri(n.snippetsHome)&&j.URI.isUri(n.extensionsResource))}e.$Jk=p,e.$Kk=(0,S.$Ph)("IUserDataProfilesService");function P(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:n}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=P;function s(i,n,r,l,k,y){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:y&&k?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$vg)(r,"globalStorage"),settingsResource:y&&k?.useDefaultFlags?.settings?y.settingsResource:(0,A.$vg)(r,"settings.json"),keybindingsResource:y&&k?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$vg)(r,"keybindings.json"),tasksResource:y&&k?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$vg)(r,"tasks.json"),snippetsHome:y&&k?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$vg)(r,"snippets"),extensionsResource:y&&k?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$vg)(r,"extensions.json"),cacheHome:(0,A.$vg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Mk=s;let o=class extends R.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,k){super(),this.t=n,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,$.$yf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,A.$sg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.y.error(y)}const l=new f.$Ac,k=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[w,O]of Object.entries(y.workspaces)){const H=j.URI.parse(w),_=r.find(x=>x.id===O);_&&l.set(H,_)}if(y.emptyWindows)for(const[w,O]of Object.entries(y.emptyWindows)){const H=r.find(_=>_.id===O);H&&k.set(w,H)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.$Fe)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const O=l.exec(w.name),H=O?parseInt(O[1]):0;k=H>k?H:k}const y=`${r} ${k+1}`;return this.createProfile((0,L.$Di)((0,m.$eg)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Di)((0,m.$eg)()).toString(16),n,r,l)}async createProfile(n,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(n,r,l);return k&&await this.setProfileForWorkspace(k,y),y}async F(n,r,l){if(!(0,$.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const y=this.profiles.find(H=>H.name===r||H.id===n);if(y)return y;const w=s(n,r,(0,A.$vg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const O=[];return this.j.fire({profile:w,join(H){O.push(H)}}),await v.Promises.settled(O),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$pk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$Zh)(n)?n.uri:(0,d.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const k=[...this.profiles,...n],y=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(O=>w.id===O.id)||(w=l.find(O=>w.id===O.id)??w,w.isTransient?this.s.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(y),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),y=l?this.s:this.C;j.URI.isUri(k)?(y.workspaces.delete(k),r&&y.workspaces.set(k,r)):(y.emptyWindows.delete(k),r&&y.emptyWindows.set(k,r)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[y,w]of Object.entries(n.workspaces)){const O=j.URI.parse(w);r[y]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}const k={};if(n.emptyWindows)for(const[y,w]of Object.entries(n.emptyWindows)){const O=j.URI.parse(w);k[y]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=o,e.$Nk=o=pe([se(0,h.$Wh),se(1,c.$$j),se(2,E.$Ik),se(3,I.$0i)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=t}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=void 0;let p=class extends b.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,k,y,w){super(),this.z=n,this.C=r,this.D=l,this.F=k,this.G=y,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Nd),this.s=this.B(new j.$Nd),this.t=this.B(new j.$Nd),this.u=this.B(new j.$Nd),this.w=this.B(new j.$Nd),this.y=[],this.B((0,b.$Qc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,d.$8n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:y})=>(0,f.$zo)(y,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$$n(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:y})=>{try{const w=await this.O(k,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...w,options:y})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!S.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Ho)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$9l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const y=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$zo)(w.identifier,n.identifier));y?this.w.fire(y):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l);r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$Eo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l}){const k=l.isApplicationScoped||l.isBuiltin||(0,E.$9l)(n),y={...l,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},w=te=>`${f.$Ao.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!S.URI.isUri(r)){const te=this.j.get(w(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const O=[],H=[],_=[],x=this.Z(n,r,y);S.URI.isUri(r)||this.j.set(w(r),{task:x,waitingTasks:[]}),this.n.fire({identifier:x.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",x.identifier.id),O.push({task:x,manifest:n});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ae=await this.N(x.identifier,n,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),ce=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[d.$3n]:!0}};for(const{gallery:q,manifest:X}of(0,L.$Mb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!X.extensionDependencies?.some(B=>(0,f.$zo)({id:B},x.identifier));const T=w(q),U=this.j.get(T);if(U){if(this.L(x,U.task)){const B=U.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,x.identifier.id),U.waitingTasks.push(x),H.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,J=>J.some(Q=>(0,f.$zo)(Q.identifier,B)))).then(J=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,x.identifier.id),!J.find(K=>(0,f.$zo)(K.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ce.some(({identifier:B})=>(0,f.$zo)(B,q.identifier))){const B=this.Z(X,q,ie);this.j.set(T,{task:B,waitingTasks:[x]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,x.identifier.id),O.push({task:B,manifest:X})}}}catch(ae){if(S.URI.isUri(x.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",x.identifier.id,ae.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",x.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ae}const te=O.reduce((ae,{task:ce,manifest:ie})=>(ae.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:ie}),ae),new Map);for(;te.size;){let ae;const ce=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));ce.length?ae=te.size===1?ce:ce.filter(({task:ie})=>!(ie===x&&!ue)):(this.F.info("Found extensions with circular dependencies",ce.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const X=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(X,ie.source,y,R.CancellationToken.None))),!S.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Ho)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),h.$p&&ie.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}_.push({local:X,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw S.URI.isUri(ie.source)||o(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Ho)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:X}),this.F.error("Error while installing the extension:",ie.identifier.id),X}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),_.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),_}catch(te){if(O.forEach(({task:ae})=>ae.cancel()),_.length)try{const ae=await Promise.allSettled(_.map(({local:ce})=>this.$(ce,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let ce=0;ce<ae.length;ce++){const ie=ae[ce],{identifier:q}=_[ce];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$0)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$0)(ae),_.map(({identifier:ce})=>ce.id))}return O.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of O)te.source&&!S.URI.isUri(te.source)&&this.j.delete(w(te.source))}}L(n,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(r)||k.some(y=>this.L(y,r)))||l===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],l=[],k=await Promise.allSettled(n);for(const y of k)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw P(l);return r}async N(n,r,l,k,y){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,y),O=[],H=[],_=async(x,ue)=>{O.push(x);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const ce=l?w.find(ie=>(0,f.$zo)(ie.identifier,x)):void 0;for(const ie of ue.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$zo)({id:q},{id:ie}))||ae.every(q=>!(0,f.$zo)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const ce=ae.filter(ie=>O.every(q=>!(0,f.$zo)(q,{id:ie})));if(ce.length){const ie=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of ie){if(O.find(U=>(0,f.$zo)(U,q.identifier)))continue;const X=te.some(U=>(0,f.$zo)({id:U},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(U){if(X)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$0)(U));continue}H.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),H}async O(n,r,l){let k;const y=await this.getExtensionsControlManifest();if(y.malicious.some(H=>(0,f.$zo)(n.identifier,H)))throw new d.$$n(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=y.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new d.$$n(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new d.$$n(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$4n)(H)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new d.$$n(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$$n(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,R.CancellationToken.None);if(O===null)throw new d.$$n(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(O.version!==k.version)throw new d.$$n(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:O}}async P(n,r,l){const k=await this.getTargetPlatform();let y=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(n,l,k)&&(y=n),y||(r?y=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(n,l,k)),y}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=x=>`${x.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(k(n.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const w=x=>{const ue=this.$(x,l);return this.m.set(k(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.t.fire({identifier:x.identifier,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped}),ue},O=(x,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Go)(x),error:ue}),this.u.fire({identifier:x.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped})},H=[],_=[];try{H.push(w(n));const x=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,x);for(const te of ue)this.m.has(k(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(w(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),x,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}O(ue.extension)}catch(te){const ae=te instanceof d.$$n?te:new d.$$n((0,A.$0)(te),d.ExtensionManagementErrorCode.Internal);throw O(ue.extension,ae),ae}finally{_.push(ue)}}))}catch(x){const ue=x instanceof d.$$n?x:new d.$$n((0,A.$0)(x),d.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}_.includes(te)||O(te.extension,ue)}throw ue}finally{for(const x of H)this.m.delete(k(x.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}R(n,r,l){for(const k of n){const y=this.W(k,r);if(y.length){const w=y.filter(O=>!n.some(H=>(0,f.$zo)(H.identifier,O.identifier)));if(w.length)throw new Error(this.S(k,w,l))}}}S(n,r,l){return l===n?r.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const y=r.filter(O=>!O.isBuiltin&&k.some(H=>(0,f.$zo)({id:H},O.identifier))),w=[];for(const O of y)w.push(...this.U(O,r,l));return[...y,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$zo)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$pp=p,e.$pp=p=pe([se(0,d.$0n),se(1,u.$cl),se(2,$.$Ik),se(3,v.$0i),se(4,m.$pj),se(5,N.$Kk)],p);function P(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$qp=P;function s(i){if(i instanceof d.$$n)return i;const n=new d.$$n(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$rp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:k,error:y,durationSinceUpdate:w}){let O,H;(0,c.$Gf)(l)&&(l===!0?l="Verified":(l===!1||(O=d.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),y&&(y instanceof d.$$n?(O=y.code,y.code===d.ExtensionManagementErrorCode.Signature&&(H=y.message)):O=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!y,duration:k,errorcode:O,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Hg)(n=>new Promise((r,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$sp=t}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class N extends Error{constructor(t,i){super(t),this.code=i}}e.$tp=N,e.$up=(0,I.$Ph)("IExtensionsProfileScannerService");let p=class extends R.$Sc{constructor(t,i,n,r,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=k,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const k=[];for(const y of l)t.some(([w])=>(0,c.$zo)(w.identifier,y.identifier)&&w.manifest.version!==y.version)?n.push(y):k.push(y);for(const[y,w]of t){const O=k.findIndex(_=>(0,c.$zo)(_.identifier,y.identifier)&&_.version===y.manifest.version),H={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:w};O===-1?(r.push(H),k.push(H)):k.splice(O,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const k of r){const y=t.find(([w])=>(0,c.$zo)(w.identifier,k.identifier)&&w.manifest.version===k.version);y&&(k.metadata={...k.metadata,...y[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const k of r)(0,c.$zo)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,S.$pk)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new N((0,m.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const y of l){P(y)||this.w(t);let w;if((0,v.$yf)(y.relativeLocation)&&y.relativeLocation)w=this.z(y.relativeLocation);else if((0,v.$yf)(y.location))w=this.z(y.location),k=!0,y.relativeLocation=y.location,y.location=w.toJSON();else{w=b.URI.revive(y.location);const O=this.y(w);O&&(k=!0,y.relativeLocation=O)}r.push({identifier:y.identifier,location:w,version:y.version,metadata:y.metadata})}k&&await this.m.writeFile(t,D.$be.fromString(JSON.stringify(l)))}if(i){r=i(r);const k=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(t,D.$be.fromString(JSON.stringify(k)))}return r})}w(t){const i=new N(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,S.$pk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>P(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$pk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$1g,this.h.set(t,i)),i}};e.$vp=p,e.$vp=p=pe([se(1,S.$$j),se(2,f.$Kk),se(3,E.$Ik),se(4,u.$cl),se(5,d.$0i)],p);function P(o){return(0,v.$Af)(o)&&(0,h.$9n)(o.identifier)&&(s(o.location)||(0,v.$yf)(o.location)&&o.location)&&((0,v.$Ff)(o.relativeLocation)||(0,v.$yf)(o.relativeLocation))&&o.version&&(0,v.$yf)(o.version)}function s(o){return o?(0,v.$yf)(o.path)&&(0,v.$yf)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N,p,P,s,o,t,i,n,r,l,k,y,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.Translations=void 0;var H;(function(ie){function q(X,T){if(X===T)return!0;const U=Object.keys(X),B=new Set;for(const J of Object.keys(T))B.add(J);if(U.length!==B.size)return!1;for(const J of U){if(X[J]!==T[J])return!1;B.delete(J)}return B.size===0}ie.equals=q})(H||(e.Translations=H={})),e.$yp=(0,t.$Ph)("IExtensionsScannerService");let _=class extends c.$Sc{constructor(q,X,T,U,B,J,Q,K,M,F,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=U,this.t=B,this.u=J,this.w=Q,this.y=K,this.z=M,this.C=F,this.D=a,this.F=g,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,f.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Ko)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[U,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),J=T?await this.scanExtensionsUnderDevelopment(q,[...U,...B]):[];return this.L(U,B,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(X);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let J;try{J=await B.scanExtensions(U)}catch(Q){if(Q instanceof k.$tp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await B.scanExtensions(U);else throw Q}return J=await this.J(J,1,q,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const B=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Q=>(Q.type=X.find(K=>(0,p.$zo)(K.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),B=await this.n.scanExtension(U);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(U);return this.J(B,X,T,!0)}async scanMetadata(q){const X=(0,f.$vg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$vg)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),B=JSON.parse(U);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,B.__metadata={...B.__metadata,...X},await this.w.writeFile((0,f.$vg)(q,"package.json"),A.$be.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$tp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(X){(0,o.$pk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,U){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,J)=>{const Q=I.$nc(B.location.fsPath),K=I.$nc(J.location.fsPath);return Q<K?-1:Q>K?1:0})}L(q,X,T,U,B){const J=(K,M,F)=>{if(K.isValid&&!M.isValid)return!1;if(K.isValid===M.isValid){if(B&&E.gt(K.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,M.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${K.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${M.location.path}.`),!0},Q=new P.$8l;return q?.forEach(K=>{const M=Q.get(K.identifier.id);(!M||J(M,K,!1))&&Q.set(K.identifier.id,K)}),X?.forEach(K=>{const M=Q.get(K.identifier.id);if(!M&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!M||J(M,K,!1))&&Q.set(K.identifier.id,K)}),T?.forEach(K=>{const M=Q.get(K.identifier.id);(!M||J(M,K,!0))&&Q.set(K.identifier.id,K),Q.set(K.identifier.id,K)}),[...Q.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=X?await this.O():{},B=[],J=u.URI.file(I.$hc(I.$jc(S.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const M=U[K.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":B.push((0,f.$vg)(J,K.name));break;default:B.push(u.URI.file(M));break}}const Q=await Promise.all(B.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,L.$Hb)(Q)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,U,B,J,Q){const K=await this.f(B??d.$w),M=await this.Q(q),F=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=F?await this.Q(F):void 0;return new x(q,M,F,a,X,Q,T,U,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,K)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$zp=_,e.$zp=_=pe([se(4,y.$Kk),se(5,k.$up),se(6,o.$$j),se(7,i.$0i),se(8,N.$Wh),se(9,n.$pj),se(10,w.$Ik),se(11,t.$Oh)],_);class x{constructor(q,X,T,U,B,J,Q,K,M,F,a,g,z,C,Z){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=B,this.profileScanOptions=J,this.type=Q,this.excludeObsolete=K,this.validate=M,this.productVersion=F,this.productDate=a,this.productCommit=g,this.devMode=z,this.language=C,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$og)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$og)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&R.$$m(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&H.equals(q.translations,X.translations)}}e.$Ap=x;let ue=class extends c.$Sc{constructor(q,X,T,U,B){super(),this.f=q,this.g=X,this.h=T,this.j=U,this.m=B}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,m.$Lf)(T)?X:X.filter(U=>!T[p.$Ao.create(U).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,f.$sg)(U.resource).indexOf(".")===0)return null;const B=new x(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Hb)(T).sort((U,B)=>U.location.path<B.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const B=await Promise.all(U.map(async J=>{if(X(J)){const Q=new x(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,L.$Hb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$vg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$0)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=P.$2l),X=X??T.__metadata,delete T.__metadata;const U=(0,p.$Eo)(T.publisher,T.name),B=X?.id?{id:U,uuid:X.id}:{id:U},J=X?.isSystem?0:q.type,Q=J===0||!!X?.isBuiltin;T=await this.t(q.location,T,x.createNlsConfiguration(q));const K={type:J,identifier:B,manifest:T,location:q.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const U=(0,s.$Po)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[B,J]of U)B===v.default.Error&&(T=!1,this.m.error(this.z(X.location,J)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const X=(0,f.$vg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(B){return(0,o.$pk)(B)!==1&&this.m.error(this.z(q,(0,$.localize)(0,null,X.path,B.message))),null}let U;try{U=JSON.parse(T)}catch{const J=[];(0,b.$Wm)(T,J);for(const Q of J)this.m.error(this.z(q,(0,$.localize)(1,null,X.path,Q.offset,Q.length,(0,h.$wp)(Q.error))));return null}return(0,b.$6m)(U)!=="object"?(this.m.error(this.z(q,(0,$.localize)(2,null,X.path))),null):U}async t(q,X,T){const U=await this.u(q,X,T);if(U)try{const B=[],J=await this.w(U.default,B);if(B.length>0)return B.forEach(K=>{this.m.error(this.z(q,(0,$.localize)(3,null,U.default?.path,(0,h.$wp)(K.error))))}),X;if((0,b.$6m)(U)!=="object")return this.m.error(this.z(q,(0,$.localize)(4,null,U.default?.path))),X;const Q=U.values||Object.create(null);return(0,O.$xp)(this.m,X,Q,J)}catch{}return X}async u(q,X,T){const U=(0,f.$vg)(q,"package.nls.json"),B=(M,F)=>{F.forEach(a=>{this.m.error(this.z(q,(0,$.localize)(5,null,M?.path,(0,h.$wp)(a.error))))})},J=M=>{this.m.error(this.z(q,(0,$.localize)(6,null,M?.path)))},Q=`${X.publisher}.${X.name}`,K=T.translations[Q];if(K)try{const M=u.URI.file(K),F=(await this.j.readFile(M)).value.toString(),a=[],g=(0,b.$Wm)(F,a);return a.length>0?(B(M,a),{values:void 0,default:U}):(0,b.$6m)(g)!=="object"?(J(M),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let F;try{F=await this.y(q,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.j.readFile(F.localized)).value.toString(),g=[],z=(0,b.$Wm)(a,g);return g.length>0?(B(F.localized,g),{values:void 0,default:F.original}):(0,b.$6m)(z)!=="object"?(J(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$Wm)(T,X)}catch{}}y(q,X){return new Promise((T,U)=>{const B=J=>{const Q=(0,f.$vg)(q,`package.nls.${J}.json`);this.j.exists(Q).then(K=>{K&&T({localized:Q,original:(0,f.$vg)(q,"package.nls.json")});const M=J.lastIndexOf("-");M===-1?T({localized:(0,f.$vg)(q,"package.nls.json"),original:null}):(J=J.substring(0,M),B(J))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$vg)(q,"package.nls.json"),original:null});B(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};ue=pe([se(1,k.$up),se(2,w.$Ik),se(3,o.$$j),se(4,i.$0i)],ue);let te=class extends ue{constructor(q,X,T,U,B,J,Q){super(X,U,B,J,Q),this.G=q,this.H=T,this.D=this.B(new D.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&x.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=u.URI.revive(B.location),B));const U=await super.scanExtensions(q);return await this.J(X,{input:q,result:U}),U}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$mh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$0)(X))}return null}async J(q,X){try{await this.j.writeFile(q,A.$be.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$$m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?P.$1l:P.$Zl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Kk),se(3,k.$up),se(4,w.$Ik),se(5,o.$$j),se(6,i.$0i)],te);function ae(ie,q){const X=(0,p.$Co)(ie.manifest.publisher,ie.manifest.name);return{id:X,identifier:new P.$6l(X),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$Bp=ae;class ce extends _{constructor(q,X,T,U,B,J,Q,K,M,F,a,g){super(q,X,(0,f.$vg)(T,".vscode-oss-dev","extensions","control.json"),U,B,J,Q,K,M,F,a,g),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(u.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Cp=ce}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,D,R,A,j,b,h,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let d=class extends j.$Sc{constructor(E,v){super(),this.b=E,this.f=v,this.a=new D.$Zg(5)}async postUninstall(E){const v=this.g(E,"uninstall");v&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(m)}}));try{await c.Promises.rm(this.m(E))}catch(m){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(m)}}g(E,v){const m=`vscode:${v}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[m]=="string"){const u=E.manifest.scripts[m].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${m} should be a node script`),null):{script:(0,h.$jc)(E.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(E,v,m,u,$){return new Promise((N,p)=>{const P=this.j(E,v,m,$);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):N(void 0)};P.on("error",t=>{o((0,R.$Ai)(t)||"Unknown")}),P.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,P.kill(),p("timed out")},5e3))})}j(E,v,m,u){const $={silent:!0,execArgv:void 0},N=(0,L.fork)(E,[`--type=extension-post-${v}`,...m],$);N.stdout.setEncoding("utf8"),N.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(N.stdout,"data"),P=A.Event.fromNodeEventEmitter(N.stderr,"data");p(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${v}`,t)),P(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${v}`,t));const s=A.Event.any(A.Event.map(p,t=>({data:`%c${t}`,format:[""]})),A.Event.map(P,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),N}m(E){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Ep=d,e.$Ep=d=pe([se(0,I.$Kk),se(1,S.$0i)],d)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;let S=class extends j.$vp{constructor(d,f,E,v,m,u){super(c.URI.file(d.extensionsPath),f,E,v,m,u)}};e.$HN=S,e.$HN=S=pe([se(0,h.$Xh),se(1,b.$$j),se(2,D.$Kk),se(3,R.$Ik),se(4,A.$cl),se(5,L.$0i)],S)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(G,e,L,D,R,A,j,b,h,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;let d=class extends A.$Cp{constructor(E,v,m,u,$,N,p,P){super(L.URI.file($.builtinExtensionsPath),L.URI.file($.extensionsPath),$.userHome,E.defaultProfile,E,v,m,u,$,N,p,P)}};e.$67b=d,e.$67b=d=pe([se(0,I.$Kk),se(1,R.$up),se(2,j.$$j),se(3,h.$0i),se(4,D.$Xh),se(5,c.$pj),se(6,S.$Ik),se(7,b.$Oh)],d)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$6o=e.$5o=e.$4o=void 0,e.$4o="__$__isNewStorageMarker",e.$5o="__$__targetStorageMarker",e.$6o=(0,h.$Ph)("storageService");var S;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var I;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f($){const N=$.get(e.$5o);if(N)try{return JSON.parse(N)}catch{}return Object.create(null)}e.$7o=f;class E extends R.$Sc{static{this.a=60*1e3}constructor(N={flushInterval:E.a}){super(),this.m=N,this.b=this.B(new D.$Qd),this.c=this.B(new D.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(N,p,P){return D.Event.filter(this.b.event,s=>s.scope===N&&(p===void 0||s.key===p),P)}n(){this.j.value=(0,L.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(N,p){const{key:P,external:s}=p;if(P===e.$5o){switch(N){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:N})}else this.b.fire({scope:N,key:P,target:this.J(N)[P],external:s})}w(N){this.f.fire({reason:N})}get(N,p,P){return this.P(p)?.get(N,P)}getBoolean(N,p,P){return this.P(p)?.getBoolean(N,P)}getNumber(N,p,P){return this.P(p)?.getNumber(N,P)}getObject(N,p,P){return this.P(p)?.getObject(N,P)}storeAll(N,p){this.y(()=>{for(const P of N)this.store(P.key,P.value,P.scope,P.target,p)})}store(N,p,P,s,o=!1){if((0,j.$Hf)(p)){this.remove(N,P,o);return}this.y(()=>{this.z(N,P,s),this.P(P)?.set(N,p,o)})}remove(N,p,P=!1){this.y(()=>{this.z(N,p,void 0),this.P(p)?.delete(N,P)})}y(N){this.b.pause(),this.c.pause();try{N()}finally{this.b.resume(),this.c.resume()}}keys(N,p){const P=[],s=this.J(N);for(const o of Object.keys(s))s[o]===p&&P.push(o);return P}z(N,p,P,s=!1){const o=this.J(p);typeof P=="number"?o[N]!==P&&(o[N]=P,this.P(p)?.set(e.$5o,JSON.stringify(o),s)):typeof o[N]=="number"&&(delete o[N],this.P(p)?.set(e.$5o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(N){switch(N){case-1:return this.I;case 0:return this.G;default:return this.D}}L(N){const p=this.P(N);return p?f(p):Object.create(null)}isNew(N){return this.getBoolean(e.$4o,N)===!0}async flush(N=S.NONE){this.f.fire({reason:N});const p=this.P(-1),P=this.P(0),s=this.P(1);switch(N){case S.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const N=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,P=this.P(1)?.items??new Map;return u(N,p,P,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(N){return await this.flush(),this.P(N)?.optimize()}async switch(N,p){return this.w(S.NONE),(0,c.$Jk)(N)?this.R(N,p):this.S(N,p)}M(N,p){return!(N.id===p.id||v(p)&&v(N))}N(N,p,P){this.y(()=>{const s=new Set;for(const[o,t]of N)s.add(o),p.get(o)!==t&&this.u(P,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(P,{key:o,external:!0})})}}e.$8o=E;function v($){return $.isDefault||!!$.useDefaultFlags?.globalState}e.$9o=v;class m extends E{constructor(){super(),this.U=this.B(new b.$2o(new b.$3o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$2o(new b.$3o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$2o(new b.$3o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(N=>this.u(1,N))),this.B(this.W.onDidChangeStorage(N=>this.u(0,N))),this.B(this.U.onDidChangeStorage(N=>this.u(-1,N)))}P(N){switch(N){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(N){switch(N){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(N){return!1}}e.$0o=m;async function u($,N,p,P,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;$.forEach((H,_)=>{i.set(_,H),n.set(_,t(H))});const r=new Map,l=new Map;N.forEach((H,_)=>{r.set(_,H),l.set(_,t(H))});const k=new Map,y=new Map;p.forEach((H,_)=>{k.set(_,H),y.set(_,t(H))}),console.group(P!==s?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const w=[];if(i.forEach((H,_)=>{w.push({key:_,value:H})}),console.table(w),console.groupEnd(),console.log(n),P!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((_,x)=>{H.push({key:x,value:_})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const O=[];k.forEach((H,_)=>{O.push({key:_,value:H})}),console.table(O),console.groupEnd(),console.log(y)}e.$$o=u}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=void 0;const s=A.$p?"web":(0,I.$6n)(A.$u,j.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((g,z)=>g|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(g=y){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,z=this.d.pageSize){return new w({...this.d,pageNumber:g,pageSize:z})}withFilter(g,...z){const C=[...this.d.criteria,...z.length?z.map(Z=>({filterType:g,value:Z})):[{filterType:g}]];return new w({...this.d,criteria:C})}withSortBy(g){return new w({...this.d,sortBy:g})}withSortOrder(g){return new w({...this.d,sortOrder:g})}withFlags(...g){return new w({...this.d,flags:g.reduce((z,C)=>z|C,0)})}withAssetTypes(...g){return new w({...this.d,assetTypes:g})}withSource(g){return new w({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:z,pageSize:C,sortBy:Z,sortOrder:W,flags:le,assetTypes:oe}=this.d;return{filters:[{criteria:g,pageNumber:z,pageSize:C,sortBy:Z,sortOrder:W}],assetTypes:oe,flags:le}}get searchText(){const g=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(a,g){const z=(a||[]).filter(C=>C.statisticName===g)[0];return z?z.value:0}function H(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(C=>C.assetType.indexOf(g)===0).reduce((C,Z)=>{const W=ue(a,Z.assetType);return W&&C.push([Z.assetType.substring(g.length),W]),C},[])}function _(a){if(a.properties){const g=a.properties.filter(Z=>Z.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=g.filter(Z=>z.test(Z.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(a,r.Repository)}function x(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function ue(a,g){return a.files.filter(C=>C.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,g){const z=a.properties?a.properties.filter(Z=>Z.key===g):[],C=z.length>0&&z[0].value;return C?C.split(",").map(Z=>(0,d.$Do)(Z)):[]}function ae(a){const g=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return g.length>0&&g[0].value||""}function ce(a){const g=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(a){const g=a.properties?a.properties.filter(C=>C.key===l.LocalizedLanguages):[],z=g.length>0&&g[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$5n)(a.targetPlatform):"undefined"}function U(a){const g=(0,L.$Mb)(a.versions.map(T)),z=!!a.tags?.includes(I.$Zn),C=g.indexOf("web");return z?C===-1&&g.push("web"):C!==-1&&g.splice(C,1),g}function B(a,g){for(let z=0;z<a.length;z++){const C=a[z];if(C.version===a[z-1]?.version){let Z=z;if(T(C)===g)for(;Z>0&&a[Z-1].version===C.version;)Z--;Z!==z&&(a.splice(z,1),a.splice(Z,0,C))}}return a}e.$bp=B;function J(a,g,z){a.telemetryData={index:g,querySource:z,queryActivityId:a.queryContext?.[o]}}function Q(a,g,z,C){const Z=a.versions[0],W={manifest:ue(g,r.Manifest),readme:ue(g,r.Details),changelog:ue(g,r.Changelog),license:ue(g,r.License),repository:_(g),download:x(g),icon:ue(g,r.Icon),signature:ue(g,r.Signature),coreTranslations:H(g)};return{identifier:{id:(0,d.$Eo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:a.shortDescription||"",installCount:O(a.statistics,"install"),rating:O(a.statistics,"averagerating"),ratingCount:O(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:te(g,l.Dependency),extensionPack:te(g,l.ExtensionPack),engine:ae(g),localizedLanguages:ie(g),targetPlatform:T(g),isPreReleaseVersion:ce(g)},hasPreReleaseVersion:ce(Z),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:C}}let K=class{constructor(g,z,C,Z,W,le,oe,me){this.k=z,this.l=C,this.n=Z,this.o=W,this.q=le,this.u=oe,this.w=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,$.$ap)(oe.version,oe,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,z,C){const Z=D.CancellationToken.isCancellationToken(z)?{}:z,W=D.CancellationToken.isCancellationToken(z)?z:C,le=[],oe=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?oe.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!le.length)return[];let fe=new w().withPage(1,g.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>J(we,be,Z.source)),he}async getCompatibleExtension(g,z,C){if((0,I.$7n)(g.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(g,z,C))return g;const Z=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:C,compatible:!0,includePreRelease:z},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(g,z,C){if(!(0,I.$8n)(g.properties.targetPlatform,g.allTargetPlatforms,C)||!z&&g.properties.isPreReleaseVersion)return!1;let Z=g.properties.engine;if(!Z){const W=await this.getManifest(g,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,f.$Ro)(Z,this.u.version,this.u.date)}async y(g,z,C,Z,W){if(!(0,I.$8n)(T(g),Z,W)||z!=="any"&&ce(g)!==(z==="prerelease"))return!1;if(C)try{const le=await this.E(g);if(!(0,f.$Ro)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,R.$0)(le)),!1}return!0}async query(g,z){let C=g.text||"";const Z=g.pageSize??50;let W=new w().withPage(1,Z);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),W=W.withFilter(n.SearchText,C)),W=W.withSortBy(0)):g.ids?W=W.withFilter(n.ExtensionId,...g.ids):g.names?W=W.withFilter(n.ExtensionName,...g.names):W=W.withSortBy(4),typeof g.sortBy=="number"&&(W=W.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(W=W.withSortOrder(g.sortOrder)),g.source&&(W=W.withSource(g.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,ke)=>J(be,(ge.pageNumber-1)*ge.pageSize+ke,g.source)),{extensions:he,total:we}},{extensions:oe,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$5;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:me,pageSize:W.pageSize,getPage:de}}async z(g,z,C){const Z=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:oe}=await this.B(g,C);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,oe);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Eo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Me=>(0,d.$zo)(Me,we))?.includePreRelease;if(z.compatible&&(0,I.$7n)(U(he),z.targetPlatform))continue;const ke=await this.A(he,z,oe);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new P.$Jd,he=new w().withFlags(Z&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(g,z,C){const Z={id:(0,d.$Eo)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},W=z.versions?.find(de=>(0,d.$zo)(de,Z))?.version,le=(0,b.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$zo)(de,Z))?.includePreRelease,oe=U(g),me=B(g.versions,z.targetPlatform);if(z.compatible&&(0,I.$7n)(oe,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,oe,z.targetPlatform))return Q(g,ge,oe,C);if(W&&ge.version===W)return null}}return W||z.compatible?null:Q(g,g.versions[0],oe)}async B(g,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const C=await this.j,Z=JSON.stringify(g.raw),W={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new P.$Jd;let oe,me,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},z),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$Yo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(Z.length),duration:le.elapsed(),success:!!oe&&(0,u.$Uo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,R.$4)(me)?"canceled":(0,R.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,z,C,Z){if(!this.isEnabled())return;const W=A.$p?this.x(`/itemName/${g}.${z}/version/${C}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${z}/${C}/stats?statType=${Z}`),le=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},D.CancellationToken.None)}catch{}}async download(g,z,C){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const Z=(0,d.$Ho)(g),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=C===2?"install":C===3?"update":"",me=oe?{uri:`${g.assets.download.uri}${h.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${h.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(g,z){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const C=await this.D(g.assets.signature);await this.q.writeFile(z,C.stream)}async getReadme(g,z){if(g.assets.readme){const C=await this.D(g.assets.readme,{},z);return await(0,u.$Xo)(C)||""}return""}async getManifest(g,z){if(g.assets.manifest){const C=await this.D(g.assets.manifest,{},z),Z=await(0,u.$Xo)(C);return Z?JSON.parse(Z):null}return null}async C(g,z){const C=ue(g,r.Manifest);if(!C)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(C,{headers:Z});return await(0,u.$Yo)(W)}async getCoreTranslation(g,z){const C=g.assets.coreTranslations.filter(Z=>Z[0]===z.toUpperCase())[0];if(C){const Z=await this.D(C[1]),W=await(0,u.$Xo)(Z);return W?JSON.parse(W):null}return null}async getChangelog(g,z){if(g.assets.changelog){const C=await this.D(g.assets.changelog,{},z);return await(0,u.$Xo)(C)||""}return""}async getAllCompatibleVersions(g,z,C){let Z=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?Z=Z.withFilter(n.ExtensionId,g.identifier.uuid):Z=Z.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:W}=await this.B(Z,D.CancellationToken.None);if(!W.length)return[];const le=U(W[0]);if((0,I.$7n)(le,C))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,C)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(oe,C))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(g,z={},C=D.CancellationToken.None){const Z=await this.j,W={type:"GET"},le={...Z,...z.headers||{}};z={...z,...W,headers:le};const oe=g.uri,me=g.fallbackUri,de={...z,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$Xo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$4)(ge))throw ge;const fe=(0,R.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...z,url:me};return this.k.request(he,C)}}async E(g){let z=ae(g);if(!z){const C=await this.C(g,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");z=C.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.$Yo)(g),C=[],Z={},W=[];if(z){for(const le of z.malicious)C.push({id:le});if(z.migrateToPreRelease)for(const[le,oe]of Object.entries(z.migrateToPreRelease))(!oe.engine||(0,f.$Ro)(oe.engine,this.u.version,this.u.date))&&(Z[le.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,oe]of Object.entries(z.deprecated))oe&&(Z[le.toLowerCase()]=(0,b.$Ef)(oe)?{}:oe);if(z.search)for(const le of z.search)W.push(le)}return{malicious:C,deprecated:Z,search:W}}};K=pe([se(1,u.$So),se(2,v.$0i),se(3,S.$Wh),se(4,p.$cl),se(5,E.$$j),se(6,m.$pj),se(7,c.$ji)],K);let M=class extends K{constructor(g,z,C,Z,W,le,oe,me){super(g,z,C,Z,W,le,oe,me)}};e.$cp=M,e.$cp=M=pe([se(0,N.$6o),se(1,u.$So),se(2,v.$0i),se(3,S.$Wh),se(4,p.$cl),se(5,E.$$j),se(6,m.$pj),se(7,c.$ji)],M);let F=class extends K{constructor(g,z,C,Z,W,le,oe){super(void 0,g,z,C,Z,W,le,oe)}};e.$dp=F,e.$dp=F=pe([se(0,u.$So),se(1,v.$0i),se(2,S.$Wh),se(3,p.$cl),se(4,E.$$j),se(5,m.$pj),se(6,c.$ji)],F)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,L,D,R,A,j,b,h,c,S){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=e.$FN=e.$EN=void 0;let f=class extends h.$Nk{static{I=this}static{this.a="profileAssociationsMigration"}constructor(u,$,N,p,P){super(N,p,$,P),this.U=u,this.W=N}O(){return this.U.getItem(I.b,[]).map($=>({...$,location:(0,c.$yf)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):L.URI.revive($.location)}))}Q(){const u=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$EN=f,e.$EN=f=I=pe([se(0,j.$zN),se(1,b.$Ik),se(2,D.$Xh),se(3,R.$$j),se(4,A.$0i)],f);let E=d=class extends f{constructor(u,$,N,p,P){super(u,$,N,p,P),this.$=u}P(u){u.length?this.$.setItem(d.b,u.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(d.c,u):this.$.removeItem(d.c)}Q(){const u="workspaceAndProfileInfo",$=this.$.getItem(u,void 0);if($){this.$.removeItem(u);const p=$.reduce((P,{workspace:s,profile:o})=>(P[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),P),{});this.$.setItem(d.c,{workspaces:p})}const N=super.Q();return this.$.getItem(d.a,!1)||(this.R(N),this.$.setItem(d.a,!0)),N}};e.$FN=E,e.$FN=E=d=pe([se(0,j.$AN),se(1,b.$Ik),se(2,D.$Xh),se(3,R.$$j),se(4,A.$0i)],E);let v=class extends E{constructor(u,$,N,p){super(new S.$DN(0,$,p,N),u,$,N,p)}async init(){return await this.$.init(),super.init()}};e.$GN=v,e.$GN=v=pe([se(0,b.$Ik),se(1,D.$Xh),se(2,R.$$j),se(3,A.$0i)],v)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(G,e,L,D,R,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.zip=e.$lp=e.$kp=void 0,e.$kp="end of central directory record signature not found";const S=new RegExp(e.$kp);class I extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$lp=I;function d(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function f(s){if(s instanceof I)return s;let o;return S.test(s.message)&&(o="CorruptZip"),new I(o,s)}function E(s,o,t,i,n,r){const l=R.$mc(o),k=R.$jc(i,l);if(!k.startsWith(i))return Promise.reject(new Error(b.localize(0,null,o)));const y=R.$jc(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(j.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((O,H)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(y,{mode:t}),w.once("close",()=>O()),w.once("error",H),s.once("error",H),s.pipe(w)}catch(_){H(_)}}))}function v(s,o,t,i){let n=(0,D.$Hg)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((k,y)=>{const w=new D.$Og,O=H=>{H.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?k():y(new I("Incomplete",new Error(b.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",H=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(H.fileName)){O(i);return}const _=H.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const te=R.$jc(o,_);n=(0,D.$Hg)(ae=>j.Promises.mkdir(te,{recursive:!0}).then(()=>O(ae)).then(void 0,y));return}const x=u(s,H),ue=d(H);n=(0,D.$Hg)(te=>w.queue(()=>x.then(ae=>E(ae,_,ue,o,t,te).then(()=>O(te)))).then(null,y))})}).finally(()=>l.dispose())}function m(s,o=!1){return new Promise((t,i)=>{(0,h.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(f(n)):t((0,A.$Jf)(r))})})}function u(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(f(n)):t((0,A.$Jf)(r))})})}function $(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=$;function N(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=m(s,!0);return t.overwrite&&(r=r.then(l=>j.Promises.rm(o).then(()=>l))),r.then(l=>v(l,o,{sourcePathRegex:n},i))}e.$np=N;function p(s,o){return m(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&u(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(b.localize(2,null,o))))}))}function P(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$op=P}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let p=class extends R.$Sc{static{N=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,j.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$$n(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===$.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$$n(I.$kp,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Ef)(o)?o:!0}async u(s){await this.g;const o=(0,j.$vg)(this.extensionsDownloadDir,`${this.z(s)}${N.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,j.$vg)(this.extensionsDownloadDir,`.${(0,c.$eg)()}`);await this.h.exists(i)||await t(i);try{await S.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(N.c))i.push(l.resource);else{const k=v.$Ao.parse(l.name);k&&t.push([k,l])}const n=(0,v.$Fo)(t,([l])=>l),r=[];for(const l of n)l.sort((k,y)=>b.rcompare(k[0].version,y[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$Ao.create(s).toString().toLowerCase():(0,c.$eg)()}};e.$Dp=p,e.$Dp=p=N=pe([se(0,f.$Xh),se(1,u.$$j),se(2,E.$0n),se(3,d.$ji),se(4,m.$ep),se(5,$.$0i)],p)}),define(ne[161],re([0,1,51,97]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;function R(A){return(0,L.$op)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Fp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N,p,P,s,o,t,i,n,r,l,k,y,w,O,H,_,x,ue,te,ae,ce,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Ip=(0,x.$Qh)(t.$_n);const q=".vsctmp";let X=class extends o.$pp{constructor(M,F,a,g,z,C,Z,W,le,oe,me,de){super(M,F,me,a,oe,de),this.fb=z,this.gb=C,this.hb=Z,this.ib=le,this.eb=new Map,this.rb=new S.$Bc;const ge=this.B(W.createInstance(k.$Ep));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Gp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Dp));const fe=this.B(new O.$Hp(this,this.fb,de,C,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Ko)(this.ib,this.F)),this.jb}async zip(M){this.F.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.pb(M),a=await(0,N.zip)((0,f.$vg)(this.db.extensionsDownloadDir,(0,u.$eg)()).fsPath,F);return m.URI.file(a)}async unzip(M){return this.F.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:a}=await this.lb(M),g=d.$kc(F.fsPath);try{return await(0,y.$Fp)(g)}finally{await a()}}getInstalled(M,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.bb.scanUserExtensionAtLocation(M)}async install(M,F={}){this.F.trace("ExtensionManagementService#install",M.toString());const{location:a,cleanup:g}=await this.lb(M);try{const z=await(0,y.$Fp)(d.$kc(a.fsPath)),C=(0,i.$Eo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,H.$Ro)(z.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:F}])).find(({identifier:le})=>(0,i.$zo)(le,{id:C}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$rp)(new Error(`Unknown error while installing extension ${C}`))}finally{await g()}}async installFromLocation(M,F){this.F.trace("ExtensionManagementService#installFromLocation",M.toString());const a=await this.bb.scanUserExtensionAtLocation(M);if(!a)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.ub([[a,void 0]],F),this.F.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(M,F,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),a.toString());const g=(await this.bb.scanExtensions(1,F)).filter(z=>M.some(C=>(0,i.$zo)(C,z.identifier)));if(g.length){const z=await Promise.all(g.map(C=>this.bb.scanMetadata(C,F)));await this.ub(g.map((C,Z)=>[C,z[Z]]),a),this.F.info("Successfully installed extensions",g.map(C=>C.identifier.id),a.toString())}return g}async updateMetadata(M,F,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.bb.updateMetadata(M,F,a),this.cb.invalidate(a),this.w.fire(M),M}async reinstallFromGallery(M){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(M);try{await this.bb.removeUninstalledExtension(M)}catch(g){throw new Error(p.localize(3,null,(0,A.$Ai)(g)))}return this.installFromGallery(a)}ab(M,F,a,g){return this.bb.copyExtension(M,F,a,g)}copyExtensions(M,F){return this.bb.copyExtensions(M,F)}markAsUninstalled(...M){return this.bb.setUninstalled(...M)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(M){this.F.error(M)}}async download(M,F,a){const{location:g}=await this.db.download(M,F,!a);return g}async lb(M){if(M.scheme===I.Schemas.file)return{location:M,async cleanup(){}};this.F.trace("Downloading extension from",M.toString());const F=(0,f.$vg)(this.db.extensionsDownloadDir,(0,u.$eg)());return await this.hb.download(M,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(M,F,a){if(m.URI.isUri(F))return new J(M,F,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=i.$Ao.create(F).toString();let z=this.eb.get(g);return z||(this.eb.set(g,z=new B(M,F,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),z}$(M,F){return new Q(M,F.profileLocation,this.gb)}async pb(M){const F=async g=>{let z=await $.Promises.readdir(g);z=z.map(W=>d.$jc(g,W));const C=await Promise.all(z.map(W=>$.Promises.stat(W)));let Z=Promise.resolve([]);return C.forEach((W,le)=>{const oe=z[le];W.isFile()&&(Z=Z.then(me=>[...me,oe])),W.isDirectory()&&(Z=Z.then(me=>F(oe).then(de=>[...me,...de])))}),Z};return(await F(M.location.fsPath)).map(g=>({path:`extension/${d.$lc(M.location.fsPath,g)}`,localPath:g}))}async qb({added:M,removed:F}){if(F){const a=M&&this.D.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(g=>M.extensions.every(z=>!(0,i.$zo)(z,g))):F.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,F.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:F.profileLocation})}if(M){const g=(await this.bb.scanExtensions(1,M.profileLocation)).filter(z=>M.extensions.some(C=>(0,i.$zo)(C,z.identifier)));this.s.fire(g.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,M.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:M.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const M=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(M){if(!M.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const a of M.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),F.push(g))}F.length&&(await this.ub(F.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async ub(M,F){const a=M.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(M,F),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:F})))}async vb(M){const F=await this.bb.getUninstalledExtensions();for(const a of M){const g=i.$Ao.create(a);F[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Jp=X,e.$Jp=X=pe([se(0,t.$0n),se(1,ae.$cl),se(2,ue.$0i),se(3,s.$Xh),se(4,r.$yp),se(5,n.$up),se(6,P.$On),se(7,x.$Oh),se(8,_.$$j),se(9,te.$pj),se(10,ce.$Ik),se(11,ie.$Kk)],X);let T=class extends c.$Sc{constructor(M,F,a,g,z,C){super(),this.j=M,this.m=F,this.n=a,this.s=g,this.t=z,this.u=C,this.h=this.B(new b.$Nd),this.onExtract=this.h.event,this.c=(0,f.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(M,F){const a={includeInvalid:!0,profileLocation:F};let g=[];return M===null||M===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):M===1&&g.push(...await this.n.scanUserExtensions(a)),g=M!==null?g.filter(z=>z.type===M):g,Promise.all(g.map(z=>this.F(z)))}async scanAllUserExtensions(M){const F=await this.n.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(a=>this.F(a)))}async scanUserExtensionAtLocation(M){try{const F=await this.n.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(M,F,a,g,z){const C=M.toString(),Z=m.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$eg)()}`)),W=m.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,C));let le=await this.m.exists(W);if(le&&g){try{await this.y(M.id,W,"removeExisting")}catch{throw new t.$$n(p.localize(4,null,W.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,N.$np)(F,Z.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,M.id)}catch(oe){let me=t.ExtensionManagementErrorCode.Extract;throw oe instanceof N.$lp&&(oe.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$$n(oe.message,me)}await this.n.updateMetadata(Z,a);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.u.info(`Rename failed because of ${(0,j.$0)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(W)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(M,F){return F?(await this.w(M,F))?.metadata:this.n.scanMetadata(M.location)}async w(M,F){return(await this.s.scanProfileExtensions(F)).find(g=>(0,i.$zo)(g.identifier,M.identifier))}async updateMetadata(M,F,a){return a?await this.s.updateMetadata([[M,F]],a):await this.n.updateMetadata(M.location,F),this.D(M.location,M.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...M){const F=M.map(a=>i.$Ao.create(a));await this.z(a=>F.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(M){await this.z(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.t.extUri.isEqualOrParent(M.location,this.n.userExtensionsLocation))return this.y(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.z(F=>delete F[i.$Ao.create(M).toString()])}async copyExtension(M,F,a,g){const z=await this.w(M,F),C=await this.w(M,a);return g={...z?.metadata,...g},C?await this.s.updateMetadata([[M,{...C.metadata,...g}]],a):await this.s.addExtensionsToProfile([[M,g]],a),this.D(M.location,M.type,a)}async copyExtensions(M,F){const a=await this.scanExtensions(1,M),g=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,M)]));await this.s.addExtensionsToProfile(g,F)}async y(M,F,a){this.u.trace(`Deleting ${a} extension from disk`,M,F.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$Di)((0,u.$eg)()).toString(16)}${q}`);await this.C(F.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,M,F.fsPath)}async z(M){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$pk)(g)!==1)throw g}let a={};if(F)try{a=JSON.parse(F)}catch{}return M&&(M(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$be.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(M,F){try{await $.Promises.rename(M,F,2*60*1e3)}catch(a){throw new t.$$n(a.message||p.localize(5,null,M,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(M,F,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(C=>this.t.extUri.isEqual(C.location,M));if(z)return this.F(z)}else{const g=await this.n.scanExistingExtension(M,F,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,M.path))}async F(M){const F=await this.m.resolve(M.location);let a,g;return F.children&&(a=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,g=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async G(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of F)M[i.$Ao.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Fo)(F,C=>C.identifier);await L.Promises.settled(z.map(async C=>{const Z=C.sort((W,le)=>E.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(z){this.u.error(z)}const g=F.filter(z=>z.metadata&&M[i.$Ao.create(z).toString()]);await Promise.allSettled(g.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,_.$pk)(F)!==1&&this.u.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,_.$pk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Kp=T,e.$Kp=T=pe([se(1,_.$$j),se(2,r.$yp),se(3,n.$up),se(4,ce.$Ik),se(5,ue.$0i)],T);class U extends o.$sp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(M,F,a,g,z,C,Z,W,le){super(),this.identifier=M,this.source=F,this.options=a,this.m=g,this.n=z,this.o=C,this.p=Z,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(M){const[F,a]=await this.x(M);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,a]],this.j),F}async u({zipPath:M,key:F,metadata:a},g,z){let C=await this.v(F);return C||(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,M,a,g,z),this.s.info("Extracting extension completed.",F.id)),C}async v(M){return await this.w(M)?(this.s.trace("Removing the extension from uninstalled list:",M.id),await this.m.setInstalled(M),this.s.info("Removed the extension from uninstalled list:",M.id),(await this.m.scanAllUserExtensions(!0)).find(g=>i.$Ao.create(g).equals(M))):void 0}async w(M){return!!(await this.m.getUninstalledExtensions())[M.toString()]}}class B extends U{constructor(M,F,a,g,z,C,Z,W,le,oe){super(F.identifier,F,a,z,C,Z,W,le,oe),this.y=F,this.z=g}async x(M){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,i.$zo)(Z.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:z,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Ao.create(this.y),metadata:g},!1,M),g]}catch(Z){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,j.$0)(W))}throw Z}}async B(M){try{await(0,y.$Fp)(M)}catch(F){throw new t.$$n((0,o.$qp)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Lp=B;class J extends U{constructor(M,F,a,g,z,C,Z,W,le,oe){super({id:(0,i.$Eo)(M.publisher,M.name)},F,a,z,C,Z,W,le,oe),this.y=M,this.z=F,this.A=g}async h(M){const F=await super.h(M);return this.D(F,M),F}async x(M){const F=new i.$Ao(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,i.$zo)(this.identifier,Z.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,F.equals(new i.$Ao(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const Z=await this.v(F);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:F,metadata:z},!0,M),z]}async D(M,F){try{let[a]=await this.A.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(a||([a]=await this.A.getExtensions([{id:M.identifier.id}],F)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(M,g,this.options.profileLocation)}}catch{}}}class Q extends o.$sp{constructor(M,F,a){super(),this.extension=M,this.j=F,this.k=a}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;let E=class extends I.$To{constructor($,N,p,P){super(P),this.m=$,this.n=N,this.r=p,this.s(),this.B($.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,N){const{f:p,g:P}=this;let s;try{s=await(0,c.$Tl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(i)))}const o={...process.env,...s},t=$.agent?$.agent:await(0,d.$Xq)($.url||"",o,{proxyUrl:p,strictSSL:P});return $.agent=t,$.strictSSL=P,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>m($,N))}async resolveProxy($){}};e.$Yq=E,e.$Yq=E=pe([se(0,b.$ji),se(1,h.$Xh),se(2,S.$0i),se(3,S.$$i)],E);async function v(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((p,P)=>{G(["https"],p,P)}):await new Promise((p,P)=>{G(["http"],p,P)})).request}async function m(u,$){return D.Promises.withAsyncBody(async(N,p)=>{const P=(0,L.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await v(u),o={hostname:P.hostname,port:P.port?parseInt(P.port):P.protocol==="https:"?443:80,protocol:P.protocol,path:P.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,j.$Ef)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const t=s(o,i=>{const n=(0,j.$Cf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)m({...u,url:i.headers.location,followRedirects:n-1},$).then(N,p);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),N({res:i,stream:(0,R.$qe)(r)})}});t.on("error",p),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),$.onCancellationRequested(()=>{t.abort(),p(new A.$5)})})}e.$Zq=m}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,L,D,R,A,j,b,h,c,S,I,d,f,E,v,m,u,$,N,p,P,s,o,t,i,n,r,l,k,y,w,O,H,_,x,ue,te,ae,ce,ie,q,X,T,U,B,J,Q,K,M,F,a,g,z,C,Z,W,le,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(x.$0i),Me=be.get(r.$$j),V=be.get(u.$Xh),Y=be.get(g.$Kk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Me,Y,he),await Promise.all(we.map(ee=>{(0,D.$Lg)(ee.flush(),1e3)}))})}async f(){const he=new O.$Nh,we={_serviceBrand:void 0,...ce.default};he.set(ie.$pj,we);const be=new $.$jm(this.b,we);he.set(u.$Xh,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const ke=new le.$yN((0,x.$lj)(be),be.logsHome);he.set(x.$$i,ke);const Me=this.B(ke.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];ke.getLogLevel()===x.LogLevel.Trace&&V.push(new x.$fj(ke.getLogLevel()));const Y=this.B(new W.$IN(Me,V));he.set(x.$0i,Y);const ee=this.B(new l.$Np(Y));he.set(r.$$j,ee);const $e=this.B(new k.$aq(Y));ee.registerProvider(b.Schemas.file,$e);const ye=new a.$zr(ee);he.set(F.$Ik,ye);const Re=new T.$CN(1,be,Y,ee),Se=new z.$EN(Re,ye,be,ee,Y);he.set(g.$Kk,Se),ee.registerProvider(b.Schemas.vscodeUserData,new me.$u8b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Se,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$s8b(Y,we.win32RegValueName)):be.policyFile?this.B(new ue.$t8b(be.policyFile,ee,Y)):new te.$kn;he.set(te.$in,Le);const Ie=this.B(new E.$Kn(Se.defaultProfile.settingsResource,ee,Le,Y));he.set(f.$ji,Ie),await Promise.all([Re.init(),Ie.initialize()]);let je;try{je=await(0,C.$97b)(Re,Y)}catch(Ae){Ae.code!=="ENOENT"&&Y.error(Ae)}const Ue=await(0,C.$07b)(Re,Y);Se.init(),he.set(F.$Ik,new a.$zr(ee));const Ne=new X.$Yq(Ie,be,Y,ke);he.set(q.$So,Ne),he.set(v.$On,new y.$Mh(m.$XN,void 0,!0)),he.set(o.$up,new y.$Mh(Z.$HN,void 0,!0)),he.set(t.$yp,new y.$Mh(n.$67b,void 0,!0)),he.set(P.$ep,new y.$Mh(P.$fp,void 0,!0)),he.set(i.$Ip,new y.$Mh(i.$Jp,void 0,!0)),he.set(p.$0n,new y.$Mh(N.$dp,void 0,!0)),he.set(H.$Sq,new y.$Mh(_.$Uq,void 0,!1));const De=[],ze=(0,Q.$wo)(we,Ie);if((0,Q.$ro)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&De.push(new K.$wN(Ne,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:De,sendErrorTelemetry:!1,commonProperties:(0,U.$ho)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,je,Ue,ze),piiPaths:(0,Q.$xo)(be)};he.set(B.$cl,new y.$Mh(J.$1q,[Ae],!1))}else he.set(B.$cl,Q.$lo);return[new w.$dq(he),De]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$Ai)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async h(he,we,be,ke){let Me;if(he.args.profile&&(Me=be.profiles.find(Y=>Y.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$gp,new x.$fj(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$gp,new x.$fj(x.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$gp,new x.$fj(x.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(s.$gp,new x.$fj(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$Q8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$ic)(we)?we:(0,h.$jc)((0,S.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8e11b537e3b091a8b52c7179fb623ecdeecaf4ea/core/vs/code/node/cliProcessMain.js.map
