/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/stopwatch","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],D=0,T=$e.length;D<T;D++)e[D]=De[$e[D]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const f=new Map,R=new Map,A=new Map,$=new Map;function E(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function w(y,k){const p=y.get(k.detail);p&&(p>=0||y.set(k.detail,p+k.timestamp))}let L=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(L=$e.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of L)switch(y.type){case 10:E(f,y);break;case 11:case 12:w(f,y);break;case 21:E(R,y);break;case 22:w(R,y);break;case 33:E(A,y);break;case 34:w(A,y);break;case 31:E($,y);break;case 32:w($,y);break}let I=0;A.forEach(y=>I+=y);function v(y){const k=[];return y.forEach((p,h)=>k.push([h,p])),k}return{amdLoad:v(f),amdInvoke:v(R),nodeRequire:v(A),nodeEval:v($),nodeRequireTotal:I}}static toMarkdownTable(f,R){let A="";const $=[];return f.forEach((E,w)=>{$[w]=E.length}),R.forEach(E=>{E.forEach((w,L)=>{typeof w>"u"&&(w=E[L]="-");const I=w.toString().length;$[L]=Math.max(I,$[L])})}),f.forEach((E,w)=>{A+=`| ${E+" ".repeat($[w]-E.toString().length)} `}),A+=`|
`,f.forEach((E,w)=>{A+=`| ${"-".repeat($[w])} `}),A+=`|
`,R.forEach(E=>{E.forEach((w,L)=>{typeof w<"u"&&(A+=`| ${w+" ".repeat($[L]-w.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(p,h,r){const s=T(p,h);if(s!==-1)return p[s]}e.$fb=D;function T(p,h,r=p.length-1){for(let s=r;s>=0;s--){const o=p[s];if(h(o))return s}return-1}e.$gb=T;function f(p,h){const r=R(p,h);return r===-1?void 0:p[r]}e.$hb=f;function R(p,h,r=0,s=p.length){let o=r,m=s;for(;o<m;){const u=Math.floor((o+m)/2);h(p[u])?o=u+1:m=u}return o-1}e.$ib=R;function A(p,h){const r=$(p,h);return r===p.length?void 0:p[r]}e.$jb=A;function $(p,h,r=0,s=p.length){let o=r,m=s;for(;o<m;){const u=Math.floor((o+m)/2);h(p[u])?m=u:o=u+1}return o}e.$kb=$;function E(p,h,r=0,s=p.length){const o=$(p,h,r,s);return o===p.length?-1:o}e.$lb=E;class w{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(w.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!h(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const r=R(this.e,h,this.c);return this.c=r+1,r===-1?void 0:this.e[r]}}e.$mb=w;function L(p,h){if(p.length===0)return;let r=p[0];for(let s=1;s<p.length;s++){const o=p[s];h(o,r)>0&&(r=o)}return r}e.$nb=L;function I(p,h){if(p.length===0)return;let r=p[0];for(let s=1;s<p.length;s++){const o=p[s];h(o,r)>=0&&(r=o)}return r}e.$ob=I;function v(p,h){return L(p,(r,s)=>-h(r,s))}e.$pb=v;function y(p,h){if(p.length===0)return-1;let r=0;for(let s=1;s<p.length;s++){const o=p[s];h(o,p[r])>0&&(r=s)}return r}e.$qb=y;function k(p,h){for(const r of p){const s=h(r);if(s!==void 0)return s}}e.$rb=k}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(A,$){const E=Object.create(null);for(const w of A){const L=$(w);let I=E[L];I||(I=E[L]=[]),I.push(w)}return E}e.$J=D;function T(A,$){const E=[],w=[];for(const L of A)$.has(L)||E.push(L);for(const L of $)A.has(L)||w.push(L);return{removed:E,added:w}}e.$K=T;function f(A,$){const E=[],w=[];for(const[L,I]of A)$.has(L)||E.push(I);for(const[L,I]of $)A.has(L)||w.push(I);return{removed:E,added:w}}e.$L=f;function R(A,$){const E=new Set;for(const w of $)A.has(w)&&E.add(w);return E}e.$M=R}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function D(A){return($,E,w)=>{let L=null,I=null;if(typeof w.value=="function"?(L="value",I=w.value):typeof w.get=="function"&&(L="get",I=w.get),!I)throw new Error("not supported");w[L]=A(I,E)}}function T(A,$,E){let w=null,L=null;if(typeof E.value=="function"?(w="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(w="get",L=E.get),!L)throw new Error("not supported");const I=`$memoize$${$}`;E[w]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[I]}}e.$hh=T;function f(A,$,E){return D((w,L)=>{const I=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...y){this[v]||(this[v]=E?E():void 0),clearTimeout(this[I]),$&&(this[v]=$(this[v],...y),y=[this[v]]),this[I]=setTimeout(()=>{w.apply(this,y),this[v]=E?E():void 0},A)}})}e.$ih=f;function R(A,$,E){return D((w,L)=>{const I=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,k=`$throttle$pending$${L}`;return function(...p){if(this[v]||(this[v]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),$&&(this[v]=$(this[v],...p)),this[k])return;const h=this[y]+A;h<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0},h-Date.now()))}})}e.$jh=R}),define(De[9],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?o.isErrorNoTelemetry(t)?new o(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function T(u){e.$X.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=T;function f(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function R(u){w(u)||e.$X.onUnexpectedError(u)}e.$1=R;function A(u){w(u)||e.$X.onUnexpectedExternalError(u)}e.$2=A;function $(u){if(u instanceof Error){const{name:t,message:n}=u,c=u.stacktrace||u.stack;return{$isError:!0,name:t,message:n,stack:c,noTelemetry:o.isErrorNoTelemetry(u)}}return u}e.$3=$;const E="Canceled";function w(u){return u instanceof L?!0:u instanceof Error&&u.name===E&&u.message===E}e.$4=w;class L extends Error{constructor(){super(E),this.name=this.message}}e.$5=L;function I(){const u=new Error(E);return u.name=u.message,u}e.$6=I;function v(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$7=v;function y(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$8=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function p(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$0=p;class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class r extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=r;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=s;class o extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof o)return t;const n=new o;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=o;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(De[19],Ce([1,0,9,118]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(Y,_=0){return Y[Y.length-(1+_)]}e.$sb=f;function R(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$tb=R;function A(Y,_,x=(ve,ae)=>ve===ae){if(Y===_)return!0;if(!Y||!_||Y.length!==_.length)return!1;for(let ve=0,ae=Y.length;ve<ae;ve++)if(!x(Y[ve],_[ve]))return!1;return!0}e.$ub=A;function $(Y,_){const x=Y.length-1;_<x&&(Y[_]=Y[x]),Y.pop()}e.$vb=$;function E(Y,_,x){return w(Y.length,ve=>x(Y[ve],_))}e.$wb=E;function w(Y,_){let x=0,ve=Y-1;for(;x<=ve;){const ae=(x+ve)/2|0,fe=_(ae);if(fe<0)x=ae+1;else if(fe>0)ve=ae-1;else return ae}return-(x+1)}e.$xb=w;function L(Y,_,x){if(Y=Y|0,Y>=_.length)throw new TypeError("invalid index");const ve=_[Math.floor(_.length*Math.random())],ae=[],fe=[],ee=[];for(const de of _){const be=x(de,ve);be<0?ae.push(de):be>0?fe.push(de):ee.push(de)}return Y<ae.length?L(Y,ae,x):Y<ae.length+ee.length?ee[0]:L(Y-(ae.length+ee.length),fe,x)}e.$yb=L;function I(Y,_){const x=[];let ve;for(const ae of Y.slice(0).sort(_))!ve||_(ve[0],ae)!==0?(ve=[ae],x.push(ve)):ve.push(ae);return x}e.$zb=I;function*v(Y,_){let x,ve;for(const ae of Y)ve!==void 0&&_(ve,ae)?x.push(ae):(x&&(yield x),x=[ae]),ve=ae;x&&(yield x)}e.$Ab=v;function y(Y,_){for(let x=0;x<=Y.length;x++)_(x===0?void 0:Y[x-1],x===Y.length?void 0:Y[x])}e.$Bb=y;function k(Y,_){for(let x=0;x<Y.length;x++)_(x===0?void 0:Y[x-1],Y[x],x+1===Y.length?void 0:Y[x+1])}e.$Cb=k;function p(Y,_,x){const ve=[];function ae(de,be,Pe){if(be===0&&Pe.length===0)return;const z=ve[ve.length-1];z&&z.start+z.deleteCount===de?(z.deleteCount+=be,z.toInsert.push(...Pe)):ve.push({start:de,deleteCount:be,toInsert:Pe})}let fe=0,ee=0;for(;;){if(fe===Y.length){ae(fe,0,_.slice(ee));break}if(ee===_.length){ae(fe,Y.length-fe,[]);break}const de=Y[fe],be=_[ee],Pe=x(de,be);Pe===0?(fe+=1,ee+=1):Pe<0?(ae(fe,1,[]),fe+=1):Pe>0&&(ae(fe,0,[be]),ee+=1)}return ve}e.$Db=p;function h(Y,_,x){const ve=p(Y,_,x),ae=[],fe=[];for(const ee of ve)ae.push(...Y.slice(ee.start,ee.start+ee.deleteCount)),fe.push(...ee.toInsert);return{removed:ae,added:fe}}e.$Eb=h;function r(Y,_,x){if(x===0)return[];const ve=Y.slice(0,x).sort(_);return o(Y,_,ve,x,Y.length),ve}e.top=r;function s(Y,_,x,ve,ae){return x===0?Promise.resolve([]):new Promise((fe,ee)=>{(async()=>{const de=Y.length,be=Y.slice(0,x).sort(_);for(let Pe=x,z=Math.min(x+ve,de);Pe<de;Pe=z,z=Math.min(z+ve,de)){if(Pe>x&&await new Promise(J=>setTimeout(J)),ae&&ae.isCancellationRequested)throw new D.$5;o(Y,_,be,Pe,z)}return be})().then(fe,ee)})}e.$Gb=s;function o(Y,_,x,ve,ae){for(const fe=x.length;ve<ae;ve++){const ee=Y[ve];if(_(ee,x[fe-1])<0){x.pop();const de=(0,T.$kb)(x,be=>_(ee,be)<0);x.splice(de,0,ee)}}}function m(Y){return Y.filter(_=>!!_)}e.$Hb=m;function u(Y){let _=0;for(let x=0;x<Y.length;x++)Y[x]&&(Y[_]=Y[x],_+=1);Y.length=_}e.$Ib=u;function t(Y,_,x){Y.splice(x,0,Y.splice(_,1)[0])}e.$Jb=t;function n(Y){return!Array.isArray(Y)||Y.length===0}e.$Kb=n;function c(Y){return Array.isArray(Y)&&Y.length>0}e.$Lb=c;function i(Y,_=x=>x){const x=new Set;return Y.filter(ve=>{const ae=_(ve);return x.has(ae)?!1:(x.add(ae),!0)})}e.$Mb=i;function a(Y){const _=new Set;return x=>{const ve=Y(x);return _.has(ve)?!1:(_.add(ve),!0)}}e.$Nb=a;function l(Y,_){return Y.length>0?Y[0]:_}e.$Ob=l;function C(Y,_){return Y.length>0?Y[Y.length-1]:_}e.$Pb=C;function S(Y,_,x=(ve,ae)=>ve===ae){let ve=0;for(let ae=0,fe=Math.min(Y.length,_.length);ae<fe&&x(Y[ae],_[ae]);ae++)ve++;return ve}e.$Qb=S;function b(Y){return[].concat(...Y)}e.$Rb=b;function g(Y,_){let x=typeof _=="number"?Y:0;typeof _=="number"?x=Y:(x=0,_=Y);const ve=[];if(x<=_)for(let ae=x;ae<_;ae++)ve.push(ae);else for(let ae=x;ae>_;ae--)ve.push(ae);return ve}e.$Sb=g;function d(Y,_,x){return Y.reduce((ve,ae)=>(ve[_(ae)]=x?x(ae):ae,ve),Object.create(null))}e.$Tb=d;function P(Y,_){return Y.push(_),()=>N(Y,_)}e.$Ub=P;function N(Y,_){const x=Y.indexOf(_);if(x>-1)return Y.splice(x,1),_}e.$Vb=N;function F(Y,_,x){const ve=Y.slice(0,_),ae=Y.slice(_);return ve.concat(x,ae)}e.$Wb=F;function M(Y,_){let x;if(typeof _=="number"){let ve=_;x=()=>{const ae=Math.sin(ve++)*179426549;return ae-Math.floor(ae)}}else x=Math.random;for(let ve=Y.length-1;ve>0;ve-=1){const ae=Math.floor(x()*(ve+1)),fe=Y[ve];Y[ve]=Y[ae],Y[ae]=fe}}e.$Xb=M;function U(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.unshift(_))}e.$Yb=U;function j(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.push(_))}e.$Zb=j;function O(Y,_){for(const x of _)Y.push(x)}e.$1b=O;function K(Y,_){return Array.isArray(Y)?Y.map(_):_(Y)}e.$2b=K;function V(Y){return Array.isArray(Y)?Y:[Y]}e.$3b=V;function me(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$4b=me;function te(Y,_,x){const ve=Q(Y,_),ae=Y.length,fe=x.length;Y.length=ae+fe;for(let ee=ae-1;ee>=ve;ee--)Y[ee+fe]=Y[ee];for(let ee=0;ee<fe;ee++)Y[ee+ve]=x[ee]}e.$5b=te;function G(Y,_,x,ve){const ae=Q(Y,_);let fe=Y.splice(ae,x);return fe===void 0&&(fe=[]),te(Y,ae,ve),fe}e.$6b=G;function Q(Y,_){return _<0?Math.max(_+Y.length,0):Math.min(_,Y.length)}var le;(function(Y){function _(fe){return fe<0}Y.isLessThan=_;function x(fe){return fe<=0}Y.isLessThanOrEqual=x;function ve(fe){return fe>0}Y.isGreaterThan=ve;function ae(fe){return fe===0}Y.isNeitherLessOrGreaterThan=ae,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function ie(Y,_){return(x,ve)=>_(Y(x),Y(ve))}e.$7b=ie;function ce(...Y){return(_,x)=>{for(const ve of Y){const ae=ve(_,x);if(!le.isNeitherLessOrGreaterThan(ae))return ae}return le.neitherLessOrGreaterThan}}e.$8b=ce;const pe=(Y,_)=>Y-_;e.$9b=pe;const H=(Y,_)=>(0,e.$9b)(Y?1:0,_?1:0);e.$0b=H;function B(Y){return(_,x)=>-Y(_,x)}e.$$b=B;class X{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let x=this.c;for(;x<this.g.length&&_(this.g[x]);)x++;const ve=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ve}takeFromEndWhile(_){let x=this.d;for(;x>=0&&_(this.g[x]);)x--;const ve=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ve}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const x=this.g.slice(this.c,this.c+_);return this.c+=_,x}}e.$_b=X;class re{static{this.empty=new re(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(x=>(_(x),!0))}toArray(){const _=[];return this.iterate(x=>(_.push(x),!0)),_}filter(_){return new re(x=>this.iterate(ve=>_(ve)?x(ve):!0))}map(_){return new re(x=>this.iterate(ve=>x(_(ve))))}some(_){let x=!1;return this.iterate(ve=>(x=_(ve),!x)),x}findFirst(_){let x;return this.iterate(ve=>_(ve)?(x=ve,!1):!0),x}findLast(_){let x;return this.iterate(ve=>(_(ve)&&(x=ve),!0)),x}findLastMaxBy(_){let x,ve=!0;return this.iterate(ae=>((ve||le.isGreaterThan(_(ae,x)))&&(ve=!1,x=ae),!0)),x}}e.$ac=re}),define(De[58],Ce([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(E,w){if(!E)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=T;function f(E,w="Unreachable"){throw new Error(w)}e.$4c=f;function R(E){if(!E)throw new D.$cb("Assertion Failed")}e.$5c=R;function A(E){if(!E()){debugger;E(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$6c=A;function $(E,w){let L=0;for(;L<E.length-1;){const I=E[L],v=E[L+1];if(!w(I,v))return!1;L++}return!0}e.$7c=$}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(T){const f=this;let R=!1,A;return function(){return R||(R=!0,A=T.apply(f,arguments)),A}}e.$db=D}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0;class D{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$qM=D,e.$rM=new D("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function f(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}T.is=f;const R=Object.freeze([]);function A(){return R}T.empty=A;function*$(u){yield u}T.single=$;function E(u){return f(u)?u:$(u)}T.wrap=E;function w(u){return u||R}T.from=w;function*L(u){for(let t=u.length-1;t>=0;t--)yield u[t]}T.reverse=L;function I(u){return!u||u[Symbol.iterator]().next().done===!0}T.isEmpty=I;function v(u){return u[Symbol.iterator]().next().value}T.first=v;function y(u,t){for(const n of u)if(t(n))return!0;return!1}T.some=y;function k(u,t){for(const n of u)if(t(n))return n}T.find=k;function*p(u,t){for(const n of u)t(n)&&(yield n)}T.filter=p;function*h(u,t){let n=0;for(const c of u)yield t(c,n++)}T.map=h;function*r(...u){for(const t of u)for(const n of t)yield n}T.concat=r;function s(u,t,n){let c=n;for(const i of u)c=t(c,i);return c}T.reduce=s;function*o(u,t,n=u.length){for(t<0&&(t+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);t<n;t++)yield u[t]}T.slice=o;function m(u,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,u];const c=u[Symbol.iterator]();for(let i=0;i<t;i++){const a=c.next();if(a.done)return[n,T.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return c}}]}T.consume=m})(D||(e.Iterable=D={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,n=!1){let c=0;const i=t.length;let a="",l=0,C=16,S=0;function b(U){let j=0,O=0;for(;j<U;){const K=t.charCodeAt(c);if(K>=48&&K<=57)O=O*16+K-48;else if(K>=65&&K<=70)O=O*16+K-65+10;else if(K>=97&&K<=102)O=O*16+K-97+10;else break;c++,j++}return j<U&&(O=-1),O}function g(U){c=U,a="",l=0,C=16,S=0}function d(){const U=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&w(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&w(t.charCodeAt(c)))for(c++;c<t.length&&w(t.charCodeAt(c));)c++;else return S=3,t.substring(U,c);let j=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&w(t.charCodeAt(c))){for(c++;c<t.length&&w(t.charCodeAt(c));)c++;j=c}else S=3;return t.substring(U,j)}function P(){let U="",j=c;for(;;){if(c>=i){U+=t.substring(j,c),S=2;break}const O=t.charCodeAt(c);if(O===34){U+=t.substring(j,c),c++;break}if(O===92){if(U+=t.substring(j,c),c++,c>=i){S=2;break}switch(t.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=b(4);V>=0?U+=String.fromCharCode(V):S=4;break}default:S=5}j=c;continue}if(O>=0&&O<=31)if(E(O)){U+=t.substring(j,c),S=2;break}else S=6;c++}return U}function N(){if(a="",S=0,l=c,c>=i)return l=i,C=17;let U=t.charCodeAt(c);if($(U)){do c++,a+=String.fromCharCode(U),U=t.charCodeAt(c);while($(U));return C=15}if(E(U))return c++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(c)===10&&(c++,a+=`
`),C=14;switch(U){case 123:return c++,C=1;case 125:return c++,C=2;case 91:return c++,C=3;case 93:return c++,C=4;case 58:return c++,C=6;case 44:return c++,C=5;case 34:return c++,a=P(),C=10;case 47:{const j=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<i&&!E(t.charCodeAt(c));)c++;return a=t.substring(j,c),C=12}if(t.charCodeAt(c+1)===42){c+=2;const O=i-1;let K=!1;for(;c<O;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,S=1),a=t.substring(j,c),C=13}return a+=String.fromCharCode(U),c++,C=16}case 45:if(a+=String.fromCharCode(U),c++,c===i||!w(t.charCodeAt(c)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=d(),C=11;default:for(;c<i&&F(U);)c++,U=t.charCodeAt(c);if(l!==c){switch(a=t.substring(l,c),a){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return a+=String.fromCharCode(U),c++,C=16}}function F(U){if($(U)||E(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:g,getPosition:()=>c,scan:n?M:N,getToken:()=>C,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>c-l,getTokenError:()=>S}}e.$Um=A;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,n){const c=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function S(b,g,d,P){l.value=b,l.offset=g,l.length=d,l.type=P,l.colonOffset=void 0,a=l}try{o(t,{onObjectBegin:(b,g)=>{if(n<=b)throw i;a=void 0,C=n>b,c.push("")},onObjectProperty:(b,g,d)=>{if(n<g||(S(b,g,d,"property"),c[c.length-1]=b,n<=g+d))throw i},onObjectEnd:(b,g)=>{if(n<=b)throw i;a=void 0,c.pop()},onArrayBegin:(b,g)=>{if(n<=b)throw i;a=void 0,c.push(0)},onArrayEnd:(b,g)=>{if(n<=b)throw i;a=void 0,c.pop()},onLiteralValue:(b,g,d)=>{if(n<g||(S(b,g,d,u(b)),n<=g+d))throw i},onSeparator:(b,g,d)=>{if(n<=g)throw i;if(b===":"&&a&&a.type==="property")a.colonOffset=g,C=!1,a=void 0;else if(b===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(C=!0,c[c.length-1]=""),a=void 0}}})}catch(b){if(b!==i)throw b}return{path:c,previousNode:a,isAtPropertyKey:C,matches:b=>{let g=0;for(let d=0;g<b.length&&d<c.length;d++)if(b[g]===c[d]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.$Vm=I;function v(t,n=[],c=R.DEFAULT){let i=null,a=[];const l=[];function C(b){Array.isArray(a)?a.push(b):i!==null&&(a[i]=b)}return o(t,{onObjectBegin:()=>{const b={};C(b),l.push(a),a=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const b=[];C(b),l.push(a),a=b,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:C,onError:(b,g,d)=>{n.push({error:b,offset:g,length:d})}},c),a[0]}e.$Wm=v;function y(t,n=[],c=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function l(b){return i.children.push(b),b}o(t,{onObjectBegin:b=>{i=l({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,g,d)=>{i=l({type:"property",offset:g,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:g,length:d,parent:i})},onObjectEnd:(b,g)=>{i.length=b+g-i.offset,i=i.parent,a(b+g)},onArrayBegin:(b,g)=>{i=l({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,g)=>{i.length=b+g-i.offset,i=i.parent,a(b+g)},onLiteralValue:(b,g,d)=>{l({type:u(b),offset:g,length:d,parent:i,value:b}),a(g+d)},onSeparator:(b,g,d)=>{i.type==="property"&&(b===":"?i.colonOffset=g:b===","&&a(g))},onError:(b,g,d)=>{n.push({error:b,offset:g,length:d})}},c);const S=i.children[0];return S&&delete S.parent,S}e.$Xm=y;function k(t,n){if(!t)return;let c=t;for(const i of n)if(typeof i=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let a=!1;for(const l of c.children)if(Array.isArray(l.children)&&l.children[0].value===i){c=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(c.type!=="array"||a<0||!Array.isArray(c.children)||a>=c.children.length)return;c=c.children[a]}return c}e.$Ym=k;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;n.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&n.push(c)}return n}e.$Zm=p;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const n=Object.create(null);for(const c of t.children){const i=c.children[1];i&&(n[c.children[0].value]=h(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$1m=h;function r(t,n,c=!1){return n>=t.offset&&n<t.offset+t.length||c&&n===t.offset+t.length}e.$2m=r;function s(t,n,c=!1){if(r(t,n,c)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=s(i[a],n,c);if(l)return l}return t}}e.$3m=s;function o(t,n,c=R.DEFAULT){const i=A(t,!1);function a(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(ie){return ie?ce=>ie(ce,i.getTokenOffset(),i.getTokenLength()):()=>!0}const C=a(n.onObjectBegin),S=l(n.onObjectProperty),b=a(n.onObjectEnd),g=a(n.onArrayBegin),d=a(n.onArrayEnd),P=l(n.onLiteralValue),N=l(n.onSeparator),F=a(n.onComment),M=l(n.onError),U=c&&c.disallowComments,j=c&&c.allowTrailingComma;function O(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:U||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ie){case 12:case 13:U?K(10):F();break;case 16:K(1);break;case 15:case 14:break;default:return ie}}}function K(ie,ce=[],pe=[]){if(M(ie),ce.length+pe.length>0){let H=i.getToken();for(;H!==17;){if(ce.indexOf(H)!==-1){O();break}else if(pe.indexOf(H)!==-1)break;H=O()}}}function V(ie){const ce=i.getTokenValue();return ie?P(ce):S(ce),O(),!0}function me(){switch(i.getToken()){case 11:{let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(K(2),ie=0)}catch{K(2)}P(ie);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function te(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(N(":"),O(),le()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function G(){C(),O();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||K(4,[],[]),N(","),O(),i.getToken()===2&&j)break}else ie&&K(6,[],[]);te()||K(4,[],[2,5]),ie=!0}return b(),i.getToken()!==2?K(7,[2],[]):O(),!0}function Q(){g(),O();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||K(4,[],[]),N(","),O(),i.getToken()===4&&j)break}else ie&&K(6,[],[]);le()||K(4,[],[4,5]),ie=!0}return d(),i.getToken()!==4?K(8,[4],[]):O(),!0}function le(){switch(i.getToken()){case 3:return Q();case 1:return G();case 10:return V(!0);default:return me()}}return O(),i.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):le()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$4m=o;function m(t,n){const c=A(t),i=[];let a,l=0,C;do switch(C=c.getPosition(),a=c.scan(),a){case 12:case 13:case 17:l!==C&&i.push(t.substring(l,C)),n!==void 0&&i.push(c.getTokenValue().replace(/[^\r\n]/g,n)),l=c.getPosition();break}while(a!==17);return i.join("")}e.$5m=m;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=u}),define(De[47],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(De[76],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let R=this.a;for(;R!==D.Undefined;){const A=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const $=new D(R);if(this.a===D.Undefined)this.a=$,this.b=$;else if(A){const w=this.b;this.b=$,$.prev=w,w.next=$}else{const w=this.a;this.a=$,$.next=w,w.prev=$}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e($))}}shift(){if(this.a!==D.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==D.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===D.Undefined&&R.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):R.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):R.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.$2c=T}),define(De[28],Ce([1,0]),function($e,e){"use strict";var D,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(s,o,m){let u=s.get(o);return u===void 0&&(u=m,s.set(o,u)),u}e.$xc=R;function A(s){const o=[];return s.forEach((m,u)=>{o.push(`${u} => ${m}`)}),`Map(${s.size}) {${o.join(", ")}}`}e.$yc=A;function $(s){const o=[];return s.forEach(m=>{o.push(m)}),`Set(${s.size}) {${o.join(", ")}}`}e.$zc=$;class E{constructor(o,m){this.uri=o,this.value=m}}function w(s){return Array.isArray(s)}class L{static{this.a=o=>o.toString()}constructor(o,m){if(this[D]="ResourceMap",o instanceof L)this.b=new Map(o.b),this.c=m??L.a;else if(w(o)){this.b=new Map,this.c=m??L.a;for(const[u,t]of o)this.set(u,t)}else this.b=new Map,this.c=o??L.a}set(o,m){return this.b.set(this.c(o),new E(o,m)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,m){typeof m<"u"&&(o=o.bind(m));for(const[u,t]of this.b)o(t.value,t.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$Ac=L;class I{constructor(o,m){this[T]="ResourceSet",!o||typeof o=="function"?this.a=new L(o):(this.a=new L(m),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,m){this.a.forEach((u,t)=>o.call(m,t,t,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var v;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,m=0){const u=this.a.get(o);if(u)return m!==0&&this.j(u,m),u.value}set(o,m,u=0){let t=this.a.get(o);if(t)t.value=m,u!==0&&this.j(t,u);else{switch(t={key:o,value:m,next:void 0,previous:void 0},u){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(o,t),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const m=this.a.get(o);if(m)return this.a.delete(o),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,m){const u=this.e;let t=this.b;for(;t;){if(m?o.bind(m)(t.value,t.key,this):o(t.value,t.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const o=this,m=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:u.key,done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}values(){const o=this,m=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:u.value,done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}entries(){const o=this,m=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:[u.key,u.value],done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let m=this.b,u=this.size;for(;m&&u>o;)this.a.delete(m.key),m=m.next,u--;this.b=m,this.d=u,m&&(m.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const m=o.next,u=o.previous;if(!m||!u)throw new Error("Invalid list");m.previous=u,u.next=m}o.next=void 0,o.previous=void 0,this.e++}j(o,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(o===this.b)return;const u=o.next,t=o.previous;o===this.c?(t.next=void 0,this.c=t):(u.previous=t,t.next=u),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(m===2){if(o===this.c)return;const u=o.next,t=o.previous;o===this.b?(u.previous=void 0,this.b=u):(u.previous=t,t.next=u),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((m,u)=>{o.push([u,m])}),o}fromJSON(o){this.clear();for(const[m,u]of o)this.set(m,u)}}e.$Cc=y;class k extends y{constructor(o,m=1){super(),this.k=o,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,m=2){return super.get(o,m)}peek(o){return super.get(o,0)}set(o,m){return super.set(o,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class p{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let m=this.a.get(o)||0;return m===0?!1:(m--,m===0?this.a.delete(o):this.a.set(o,m),!0)}has(o){return this.a.has(o)}}e.$Ec=p;class h{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[m,u]of o)this.set(m,u)}clear(){this.a.clear(),this.b.clear()}set(o,m){this.a.set(o,m),this.b.set(m,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const m=this.a.get(o);return m===void 0?!1:(this.a.delete(o),this.b.delete(m),!0)}forEach(o,m){this.a.forEach((u,t)=>{o.call(m,u,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=h;class r{constructor(){this.a=new Map}add(o,m){let u=this.a.get(o);u||(u=new Set,this.a.set(o,u)),u.add(m)}delete(o,m){const u=this.a.get(o);u&&(u.delete(m),u.size===0&&this.a.delete(o))}forEach(o,m){const u=this.a.get(o);u&&u.forEach(m)}get(o){const m=this.a.get(o);return m||new Set}}e.$Gc=r}),define(De[3],Ce([1,0,19,74,28,75,51]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const $=!1;let E=null;class w{constructor(){this.b=new Map}static{this.a=0}c(d){let P=this.b.get(d);return P||(P={parent:null,source:null,isSingleton:!1,value:d,idx:w.a++},this.b.set(d,P)),P}trackDisposable(d){const P=this.c(d);P.source||(P.source=new Error().stack)}setParent(d,P){const N=this.c(d);N.parent=P}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,P){const N=P.get(d);if(N)return N;const F=d.parent?this.f(this.c(d.parent),P):d;return P.set(d,F),F}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,d).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(d=10,P){let N;if(P)N=P;else{const O=new Map,K=[...this.b.values()].filter(me=>me.source!==null&&!this.f(me,O).isSingleton);if(K.length===0)return;const V=new Set(K.map(me=>me.value));if(N=K.filter(me=>!(me.parent&&V.has(me.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function F(O){function K(me,te){for(;me.length>0&&te.some(G=>typeof G=="string"?G===me[0]:me[0].match(G));)me.shift()}const V=O.source.split(`
`).map(me=>me.trim().replace("at ","")).filter(me=>me!=="");return K(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const M=new f.$Gc;for(const O of N){const K=F(O);for(let V=0;V<=K.length;V++)M.add(K.slice(0,V).join(`
`),O)}N.sort((0,D.$7b)(O=>O.idx,D.$9b));let U="",j=0;for(const O of N.slice(0,d)){j++;const K=F(O),V=[];for(let me=0;me<K.length;me++){let te=K[me];te=`(shared with ${M.get(K.slice(0,me+1).join(`
`)).size}/${N.length} leaks) at ${te}`;const Q=M.get(K.slice(0,me).join(`
`)),le=(0,T.$J)([...Q].map(ie=>F(ie)[me]),ie=>ie);delete le[K[me]];for(const[ie,ce]of Object.entries(le))V.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${ie}`);V.unshift(te)}U+=`


==================== Leaking disposable ${j}/${N.length}: ${O.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return N.length>d&&(U+=`


... and ${N.length-d} more leaking disposables

`),{leaks:N,details:U}}}e.$Hc=w;function L(g){E=g}if(e.$Ic=L,$){const g="__is_disposable_tracked__";L(new class{trackDisposable(d){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[g]||console.log(P)},3e3)}setParent(d,P){if(d&&d!==t.None)try{d[g]=!0}catch{}}markAsDisposed(d){if(d&&d!==t.None)try{d[g]=!0}catch{}}markAsSingleton(d){}})}function I(g){return E?.trackDisposable(g),g}e.$Jc=I;function v(g){E?.markAsDisposed(g)}e.$Kc=v;function y(g,d){E?.setParent(g,d)}function k(g,d){if(E)for(const P of g)E.setParent(P,d)}function p(g){return E?.markAsSingleton(g),g}e.$Lc=p;function h(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$Mc=h;function r(g){if(A.Iterable.is(g)){const d=[];for(const P of g)if(P)try{P.dispose()}catch(N){d.push(N)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$Nc=r;function s(g){for(const d of g)h(d)&&d.dispose();return[]}e.$Oc=s;function o(...g){const d=m(()=>r(g));return k(g,d),d}e.$Pc=o;function m(g){const d=I({dispose:(0,R.$db)(()=>{v(d),g()})});return d}e.$Qc=m;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return y(d,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),y(d,null))}}e.$Rc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,I(this),y(this.q,this)}dispose(){v(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Sc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&y(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&y(d,null),d}}e.$Tc=n;class c{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(d){let P=d;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,v(this))},this}}e.$Vc=i;class a{constructor(){this.a=new Map}acquire(d,...P){let N=this.a.get(d);N||(N={counter:0,object:this.b(d,...P)},this.a.set(d,N));const{object:F}=N,M=(0,R.$db)(()=>{--N.counter===0&&(this.c(d,N.object),this.a.delete(d))});return N.counter++,{object:F,dispose:M}}}e.$Wc=a;class l{constructor(d){this.a=d}async acquire(d,...P){const N=this.a.acquire(d,...P);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(F){throw N.dispose(),F}}}e.$Xc=l;class C{constructor(d){this.object=d}dispose(){}}e.$Yc=C;function S(g){const d=new u;try{g(d)}finally{d.dispose()}}e.$Zc=S;class b{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,P,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(d)?.dispose(),this.a.set(d,P)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=b}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(_,x){for(var ve=0;ve<x.length;ve++){var ae=x[ve];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(_,ae.key,ae)}}function D(_,x,ve){return x&&e(_.prototype,x),ve&&e(_,ve),Object.defineProperty(_,"prototype",{writable:!1}),_}function T(_,x){if(_){if(typeof _=="string")return f(_,x);var ve=Object.prototype.toString.call(_).slice(8,-1);if(ve==="Object"&&_.constructor&&(ve=_.constructor.name),ve==="Map"||ve==="Set")return Array.from(_);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return f(_,x)}}function f(_,x){(x==null||x>_.length)&&(x=_.length);for(var ve=0,ae=new Array(x);ve<x;ve++)ae[ve]=_[ve];return ae}function R(_,x){var ve=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(ve)return(ve=ve.call(_)).next.bind(ve);if(Array.isArray(_)||(ve=T(_))||x&&_&&typeof _.length=="number"){ve&&(_=ve);var ae=0;return function(){return ae>=_.length?{done:!0}:{done:!1,value:_[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function $(_){$e.defaults=_}var E=/[&<>"']/,w=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(x){return v[x]};function k(_,x){if(x){if(E.test(_))return _.replace(w,y)}else if(L.test(_))return _.replace(I,y);return _}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(_){return _.replace(p,function(x,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var r=/(^|[^\[])\^/g;function s(_,x){_=typeof _=="string"?_:_.source,x=x||"";var ve={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(r,"$1"),_=_.replace(fe,ee),ve},getRegex:function(){return new RegExp(_,x)}};return ve}var o=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(_,x,ve){if(_){var ae;try{ae=decodeURIComponent(h(ve)).replace(o,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}x&&!m.test(ve)&&(ve=a(x,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var t={},n=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(_,x){t[" "+_]||(n.test(_)?t[" "+_]=_+"/":t[" "+_]=b(_,"/",!0)),_=t[" "+_];var ve=_.indexOf(":")===-1;return x.substring(0,2)==="//"?ve?x:_.replace(c,"$1")+x:x.charAt(0)==="/"?ve?x:_.replace(i,"$1")+x:_+x}var l={exec:function(){}};function C(_){for(var x=1,ve,ae;x<arguments.length;x++){ve=arguments[x];for(ae in ve)Object.prototype.hasOwnProperty.call(ve,ae)&&(_[ae]=ve[ae])}return _}function S(_,x){var ve=_.replace(/\|/g,function(ee,de,be){for(var Pe=!1,z=de;--z>=0&&be[z]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ae=ve.split(/ \|/),fe=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>x)ae.splice(x);else for(;ae.length<x;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function b(_,x,ve){var ae=_.length;if(ae===0)return"";for(var fe=0;fe<ae;){var ee=_.charAt(ae-fe-1);if(ee===x&&!ve)fe++;else if(ee!==x&&ve)fe++;else break}return _.slice(0,ae-fe)}function g(_,x){if(_.indexOf(x[1])===-1)return-1;for(var ve=_.length,ae=0,fe=0;fe<ve;fe++)if(_[fe]==="\\")fe++;else if(_[fe]===x[0])ae++;else if(_[fe]===x[1]&&(ae--,ae<0))return fe;return-1}function d(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(_,x){if(x<1)return"";for(var ve="";x>1;)x&1&&(ve+=_),x>>=1,_+=_;return ve+_}function N(_,x,ve,ae){var fe=x.href,ee=x.title?k(x.title):null,de=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){ae.state.inLink=!0;var be={type:"link",raw:ve,href:fe,title:ee,text:de,tokens:ae.inlineTokens(de)};return ae.state.inLink=!1,be}return{type:"image",raw:ve,href:fe,title:ee,text:k(de)}}function F(_,x){var ve=_.match(/^(\s+)(?:```)/);if(ve===null)return x;var ae=ve[1];return x.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var de=ee[0];return de.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var M=function(){function _(ve){this.options=ve||$e.defaults}var x=_.prototype;return x.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},x.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:b(ee,`
`)}}},x.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var ee=fe[0],de=F(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:de}}},x.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var de=b(ee,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ee=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},x.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},x.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},x.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var ee,de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We=fe[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(je=!1,!(!(fe=it.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=fe[0],ae=ae.substring(ee.length),oe=fe[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=fe[1].length),J=!1,!oe&&/^ *$/.test(Z)&&(ee+=Z+`
`,ae=ae.substring(Z.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ae&&(ge=ae.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(oe)||qe.test(oe)||et.test(oe)||Ae.test(ae)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!J)Ee+=`
`+oe;else break;!J&&!oe.trim()&&(J=!0),ee+=ge+`
`,ae=ae.substring(ge.length+1)}Ye.loose||(se?Ye.loose=!0:/\n *\n *$/.test(ee)&&(se=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Ee),de&&(be=de[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!de,checked:be,loose:!1,text:Ee}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=Ee.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(z=0;z<Le;z++){this.lexer.state.top=!1,Ye.items[z].tokens=this.lexer.blockTokens(Ye.items[z].text,[]);var Xe=Ye.items[z].tokens.filter(function(ue){return ue.type==="space"}),he=Xe.every(function(ue){for(var Ie=ue.raw.split(""),Ve=0,ze=R(Ie),xe;!(xe=ze()).done;){var rt=xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&Xe.length&&he&&(Ye.loose=!0,Ye.items[z].loose=!0)}return Ye}},x.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]);ee.type="paragraph",ee.text=de,ee.tokens=this.lexer.inline(de)}return ee}},x.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},x.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var ee={type:"table",header:S(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var de=ee.align.length,be,Pe,z,J;for(be=0;be<de;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(de=ee.rows.length,be=0;be<de;be++)ee.rows[be]=S(ee.rows[be],ee.header.length).map(function(se){return{text:se}});for(de=ee.header.length,Pe=0;Pe<de;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(de=ee.rows.length,Pe=0;Pe<de;Pe++)for(J=ee.rows[Pe],z=0;z<J.length;z++)J[z].tokens=this.lexer.inline(J[z].text);return ee}}},x.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},x.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},x.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},x.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:k(fe[1])}},x.tag=function(ae){var fe=this.rules.inline.tag.exec(ae);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]}},x.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var de=b(ee.slice(0,-1),"\\");if((ee.length-de.length)%2===0)return}else{var be=g(fe[2],"()");if(be>-1){var Pe=fe[0].indexOf("!")===0?5:4,z=Pe+fe[1].length+be;fe[2]=fe[2].substring(0,be),fe[0]=fe[0].substring(0,z).trim(),fe[3]=""}}var J=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);oe&&(J=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),N(fe,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},x.reflink=function(ae,fe){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var de=(ee[2]||ee[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return N(ee,de,ee[0],this.lexer)}},x.emStrong=function(ae,fe,ee){ee===void 0&&(ee="");var de=this.rules.inline.emStrong.lDelim.exec(ae);if(de&&!(de[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=de[1]||de[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=de[0].length-1,z,J,se=Pe,oe=0,Z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,fe=fe.slice(-1*ae.length+Pe);(de=Z.exec(fe))!=null;)if(z=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!z){if(J=z.length,de[3]||de[4]){se+=J;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+J)%3)){oe+=J;continue}if(se-=J,!(se>0)){if(J=Math.min(J,J+se+oe),Math.min(Pe,J)%2){var ge=ae.slice(1,Pe+de.index+J);return{type:"em",raw:ae.slice(0,Pe+de.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var Ee=ae.slice(2,Pe+de.index+J-1);return{type:"strong",raw:ae.slice(0,Pe+de.index+J+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},x.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var ee=fe[2].replace(/\n/g," "),de=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return de&&be&&(ee=ee.substring(1,ee.length-1)),ee=k(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},x.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},x.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},x.autolink=function(ae,fe){var ee=this.rules.inline.autolink.exec(ae);if(ee){var de,be;return ee[2]==="@"?(de=k(this.options.mangle?fe(ee[1]):ee[1]),be="mailto:"+de):(de=k(ee[1]),be=de),{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.url=function(ae,fe){var ee;if(ee=this.rules.inline.url.exec(ae)){var de,be;if(ee[2]==="@")de=k(this.options.mangle?fe(ee[0]):ee[0]),be="mailto:"+de;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);de=k(ee[0]),ee[1]==="www."?be="http://"+de:be=de}return{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.inlineText=function(ae,fe){var ee=this.rules.inline.text.exec(ae);if(ee){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):k(ee[0]):ee[0]:de=k(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:de}}},_}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=s(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=s(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=s(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=s(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=s(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=s(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=C({},U),U.gfm=C({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=s(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=s(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=C({},U.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:s(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=s(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=s(U._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=s(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=s(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=s(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=s(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=s(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=s(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=s(j.reflink).replace("label",j._label).replace("ref",U._label).getRegex(),j.nolink=s(j.nolink).replace("ref",U._label).getRegex(),j.reflinkSearch=s(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=C({},j),j.pedantic=C({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=C({},j.normal,{escape:s(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=s(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=C({},j.gfm,{br:s(j.br).replace("{2,}","*").getRegex(),text:s(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(_){var x="",ve,ae,fe=_.length;for(ve=0;ve<fe;ve++)ae=_.charCodeAt(ve),Math.random()>.5&&(ae="x"+ae.toString(16)),x+="&#"+ae+";";return x}var V=function(){function _(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:U.normal,inline:j.normal};this.options.pedantic?(ae.block=U.pedantic,ae.inline=j.pedantic):this.options.gfm&&(ae.block=U.gfm,this.options.breaks?ae.inline=j.breaks:ae.inline=j.gfm),this.tokenizer.rules=ae}_.lex=function(ae,fe){var ee=new _(fe);return ee.lex(ae)},_.lexInline=function(ae,fe){var ee=new _(fe);return ee.inlineTokens(ae)};var x=_.prototype;return x.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},x.blockTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,oe,Z){return oe+"    ".repeat(Z.length)});for(var de,be,Pe,z;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(de=se.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ae)){ae=ae.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(de=this.tokenizer.fences(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ae.slice(1),Z=void 0;ee.options.extensions.startBlock.forEach(function(ge){Z=ge.call({lexer:this},oe),typeof Z=="number"&&Z>=0&&(se=Math.min(se,Z))}),se<1/0&&se>=0&&(Pe=ae.substring(0,se+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){be=fe[fe.length-1],z&&be.type==="paragraph"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de),z=Pe.length!==ae.length,ae=ae.substring(de.raw.length);continue}if(de=this.tokenizer.text(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(ae){var J="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,fe},x.inline=function(ae,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ae,tokens:fe}),fe},x.inlineTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]);var de,be,Pe,z=ae,J,se,oe;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)Z.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,J.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(de=Ee.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ae,z,oe)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ae,K)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ae,K))){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,je=ae.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ae.substring(0,Ee+1))}(),de=this.tokenizer.inlineText(Pe,O)){ae=ae.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),se=!0,be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(ae){var ge="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},D(_,null,[{key:"rules",get:function(){return{block:U,inline:j}}}]),_}(),me=function(){function _(ve){this.options=ve||$e.defaults}var x=_.prototype;return x.code=function(ae,fe,ee){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ae,de);be!=null&&be!==ae&&(ee=!0,ae=be)}return ae=ae.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(ee?ae:k(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:k(ae,!0))+`</code></pre>
`},x.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},x.html=function(ae){return ae},x.heading=function(ae,fe,ee,de){if(this.options.headerIds){var be=this.options.headerPrefix+de.slug(ee);return"<h"+fe+' id="'+be+'">'+ae+"</h"+fe+`>
`}return"<h"+fe+">"+ae+"</h"+fe+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(ae,fe,ee){var de=fe?"ol":"ul",be=fe&&ee!==1?' start="'+ee+'"':"";return"<"+de+be+`>
`+ae+"</"+de+`>
`},x.listitem=function(ae){return"<li>"+ae+`</li>
`},x.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(ae){return"<p>"+ae+`</p>
`},x.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},x.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},x.tablecell=function(ae,fe){var ee=fe.header?"th":"td",de=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return de+ae+("</"+ee+`>
`)},x.strong=function(ae){return"<strong>"+ae+"</strong>"},x.em=function(ae){return"<em>"+ae+"</em>"},x.codespan=function(ae){return"<code>"+ae+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(ae){return"<del>"+ae+"</del>"},x.link=function(ae,fe,ee){if(ae=u(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<a href="'+k(ae)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+ee+"</a>",de},x.image=function(ae,fe,ee){if(ae=u(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<img src="'+ae+'" alt="'+ee+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},x.text=function(ae){return ae},_}(),te=function(){function _(){}var x=_.prototype;return x.strong=function(ae){return ae},x.em=function(ae){return ae},x.codespan=function(ae){return ae},x.del=function(ae){return ae},x.html=function(ae){return ae},x.text=function(ae){return ae},x.link=function(ae,fe,ee){return""+ee},x.image=function(ae,fe,ee){return""+ee},x.br=function(){return""},_}(),G=function(){function _(){this.seen={}}var x=_.prototype;return x.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(ae,fe){var ee=ae,de=0;if(this.seen.hasOwnProperty(ee)){de=this.seen[ae];do de++,ee=ae+"-"+de;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[ae]=de,this.seen[ee]=0),ee},x.slug=function(ae,fe){fe===void 0&&(fe={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,fe.dryrun)},_}(),Q=function(){function _(ve){this.options=ve||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new G}_.parse=function(ae,fe){var ee=new _(fe);return ee.parse(ae)},_.parseInline=function(ae,fe){var ee=new _(fe);return ee.parseInline(ae)};var x=_.prototype;return x.parse=function(ae,fe){fe===void 0&&(fe=!0);var ee="",de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le=ae.length;for(de=0;de<Le;de++){if(Ee=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){ee+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,h(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(Z="",oe="",z=Ee.header.length,be=0;be<z;be++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[be].tokens),{header:!0,align:Ee.align[be]});for(Z+=this.renderer.tablerow(oe),ge="",z=Ee.rows.length,be=0;be<z;be++){for(se=Ee.rows[be],oe="",J=se.length,Pe=0;Pe<J;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:Ee.align[Pe]});ge+=this.renderer.tablerow(oe)}ee+=this.renderer.table(Z,ge);continue}case"blockquote":{ge=this.parse(Ee.tokens),ee+=this.renderer.blockquote(ge);continue}case"list":{for(je=Ee.ordered,We=Ee.start,_e=Ee.loose,z=Ee.items.length,ge="",be=0;be<z;be++)it=Ee.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Ye,Ae,et);ee+=this.renderer.list(ge,je,We);continue}case"html":{ee+=this.renderer.html(Ee.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ge=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;de+1<Le&&ae[de+1].type==="text";)Ee=ae[++de],ge+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);ee+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},x.parseInline=function(ae,fe){fe=fe||this.renderer;var ee="",de,be,Pe,z=ae.length;for(de=0;de<z;de++){if(be=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Pe||"";continue}switch(be.type){case"escape":{ee+=fe.text(be.text);break}case"html":{ee+=fe.html(be.text);break}case"link":{ee+=fe.link(be.href,be.title,this.parseInline(be.tokens,fe));break}case"image":{ee+=fe.image(be.href,be.title,be.text);break}case"strong":{ee+=fe.strong(this.parseInline(be.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(be.tokens,fe));break}case"codespan":{ee+=fe.codespan(be.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(be.tokens,fe));break}case"text":{ee+=fe.text(be.text);break}default:{var J='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},_}();function le(_,x,ve){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof x=="function"&&(ve=x,x=null),x=C({},le.defaults,x||{}),d(x),ve){var ae=x.highlight,fe;try{fe=V.lex(_,x)}catch(z){return ve(z)}var ee=function(J){var se;if(!J)try{x.walkTokens&&le.walkTokens(fe,x.walkTokens),se=Q.parse(fe,x)}catch(oe){J=oe}return x.highlight=ae,J?ve(J):ve(null,se)};if(!ae||ae.length<3||(delete x.highlight,!fe.length))return ee();var de=0;le.walkTokens(fe,function(z){z.type==="code"&&(de++,setTimeout(function(){ae(z.text,z.lang,function(J,se){if(J)return ee(J);se!=null&&se!==z.text&&(z.text=se,z.escaped=!0),de--,de===0&&ee()})},0))}),de===0&&ee();return}function be(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(z.message+"",!0)+"</pre>";throw z}try{var Pe=V.lex(_,x);if(x.walkTokens){if(x.async)return Promise.all(le.walkTokens(Pe,x.walkTokens)).then(function(){return Q.parse(Pe,x)}).catch(be);le.walkTokens(Pe,x.walkTokens)}return Q.parse(Pe,x)}catch(z){be(z)}}le.options=le.setOptions=function(_){return C(le.defaults,_),$(le.defaults),le},le.getDefaults=A,le.defaults=$e.defaults,le.use=function(){for(var _=arguments.length,x=new Array(_),ve=0;ve<_;ve++)x[ve]=arguments[ve];var ae=C.apply(void 0,[{}].concat(x)),fe=le.defaults.extensions||{renderers:{},childTokens:{}},ee;x.forEach(function(de){if(de.extensions&&(ee=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var z=fe.renderers?fe.renderers[Pe.name]:null;z?fe.renderers[Pe.name]=function(){for(var J=arguments.length,se=new Array(J),oe=0;oe<J;oe++)se[oe]=arguments[oe];var Z=Pe.renderer.apply(this,se);return Z===!1&&(Z=z.apply(this,se)),Z}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=le.defaults.renderer||new me,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),je=0;je<ge;je++)Ee[je]=arguments[je];var We=de.renderer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var J in de.renderer)z(J);ae.renderer=Pe}(),de.tokenizer&&function(){var Pe=le.defaults.tokenizer||new M,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),je=0;je<ge;je++)Ee[je]=arguments[je];var We=de.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var J in de.tokenizer)z(J);ae.tokenizer=Pe}(),de.walkTokens){var be=le.defaults.walkTokens;ae.walkTokens=function(Pe){var z=[];return z.push(de.walkTokens.call(this,Pe)),be&&(z=z.concat(be.call(this,Pe))),z}}ee&&(ae.extensions=fe),le.setOptions(ae)})},le.walkTokens=function(_,x){for(var ve=[],ae=function(){var be=ee.value;switch(ve=ve.concat(x.call(le,be)),be.type){case"table":{for(var Pe=R(be.header),z;!(z=Pe()).done;){var J=z.value;ve=ve.concat(le.walkTokens(J.tokens,x))}for(var se=R(be.rows),oe;!(oe=se()).done;)for(var Z=oe.value,ge=R(Z),Ee;!(Ee=ge()).done;){var je=Ee.value;ve=ve.concat(le.walkTokens(je.tokens,x))}break}case"list":{ve=ve.concat(le.walkTokens(be.items,x));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[be.type]?le.defaults.extensions.childTokens[be.type].forEach(function(We){ve=ve.concat(le.walkTokens(be[We],x))}):be.tokens&&(ve=ve.concat(le.walkTokens(be.tokens,x)))}},fe=R(_),ee;!(ee=fe()).done;)ae();return ve},le.parseInline=function(_,x){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");x=C({},le.defaults,x||{}),d(x);try{var ve=V.lexInline(_,x);return x.walkTokens&&le.walkTokens(ve,x.walkTokens),Q.parseInline(ve,x)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(ae.message+"",!0)+"</pre>";throw ae}},le.Parser=Q,le.parser=Q.parse,le.Renderer=me,le.TextRenderer=te,le.Lexer=V,le.lexer=V.lex,le.Tokenizer=M,le.Slugger=G,le.parse=le;var ie=le.options,ce=le.setOptions,pe=le.use,H=le.walkTokens,B=le.parseInline,X=le,re=Q.parse,Y=V.lex;$e.Lexer=V,$e.Parser=Q,$e.Renderer=me,$e.Slugger=G,$e.TextRenderer=te,$e.Tokenizer=M,$e.getDefaults=A,$e.lexer=Y,$e.marked=le,$e.options=ie,$e.parse=X,$e.parseInline=B,$e.parser=re,$e.setOptions=ce,$e.use=pe,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const T=new D.$Dc(1e4);function f(w){return E(w,"NFC",T)}e.$ol=f;const R=new D.$Dc(1e4);function A(w){return E(w,"NFD",R)}e.$pl=A;const $=/[^\u0000-\u0080]/;function E(w,L,I){if(!w)return w;const v=I.get(w);if(v)return v;let y;return $.test(w)?y=w.normalize(L):y=w,I.set(w,y),y}e.$ql=function(){const w=/[\u0300-\u036f]/g;return function(L){return A(L).replace(w,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function D($,E,w){return Math.min(Math.max($,E),w)}e.$Ol=D;function T($,E){return(E+$%E)%E}e.rot=T;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=f;class R{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=R;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const w=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function $e(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function A(E){R.push(E,Date.now())}function $(){const E=[];for(let w=0;w<R.length;w+=2)E.push({name:R[w],startTime:R[w+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(f+A.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:$e)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(T){if(e[T])return e[T].exports;var f=e[T]={i:T,l:!1,exports:{}};return $e[T].call(f.exports,f,f.exports,D),f.l=!0,f.exports}return D.m=$e,D.c=e,D.d=function(T,f,R){D.o(T,f)||Object.defineProperty(T,f,{enumerable:!0,get:R})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,f){if(1&f&&(T=D(T)),8&f||4&f&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&f&&typeof T!="string")for(var A in T)D.d(R,A,function($){return T[$]}.bind(null,A));return R},D.n=function(T){var f=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(f,"a",f),f},D.o=function(T,f){return Object.prototype.hasOwnProperty.call(T,f)},D.p="",D(D.s=0)}([function($e,e,D){(function(T){var f;e=$e.exports=pe,f=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],w=0,L=w++;E[L]="0|[1-9]\\d*";var I=w++;E[I]="[0-9]+";var v=w++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=w++;E[y]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var k=w++;E[k]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=w++;E[p]="(?:"+E[L]+"|"+E[v]+")";var h=w++;E[h]="(?:"+E[I]+"|"+E[v]+")";var r=w++;E[r]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var s=w++;E[s]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var o=w++;E[o]="[0-9A-Za-z-]+";var m=w++;E[m]="(?:\\+("+E[o]+"(?:\\."+E[o]+")*))";var u=w++,t="v?"+E[y]+E[r]+"?"+E[m]+"?";E[u]="^"+t+"$";var n="[v=\\s]*"+E[k]+E[s]+"?"+E[m]+"?",c=w++;E[c]="^"+n+"$";var i=w++;E[i]="((?:<|>)?=?)";var a=w++;E[a]=E[I]+"|x|X|\\*";var l=w++;E[l]=E[L]+"|x|X|\\*";var C=w++;E[C]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var S=w++;E[S]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[s]+")?"+E[m]+"?)?)?";var b=w++;E[b]="^"+E[i]+"\\s*"+E[C]+"$";var g=w++;E[g]="^"+E[i]+"\\s*"+E[S]+"$";var d=w++;E[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=w++;E[P]="(?:~>?)";var N=w++;E[N]="(\\s*)"+E[P]+"\\s+",$[N]=new RegExp(E[N],"g");var F=w++;E[F]="^"+E[P]+E[C]+"$";var M=w++;E[M]="^"+E[P]+E[S]+"$";var U=w++;E[U]="(?:\\^)";var j=w++;E[j]="(\\s*)"+E[U]+"\\s+",$[j]=new RegExp(E[j],"g");var O=w++;E[O]="^"+E[U]+E[C]+"$";var K=w++;E[K]="^"+E[U]+E[S]+"$";var V=w++;E[V]="^"+E[i]+"\\s*("+n+")$|^$";var me=w++;E[me]="^"+E[i]+"\\s*("+t+")$|^$";var te=w++;E[te]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[C]+")",$[te]=new RegExp(E[te],"g");var G=w++;E[G]="^\\s*("+E[C]+")\\s+-\\s+("+E[C]+")\\s*$";var Q=w++;E[Q]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var le=w++;E[le]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)f(ie,E[ie]),$[ie]||($[ie]=new RegExp(E[ie]));function ce(Z,ge){if(Z instanceof pe)return Z;if(typeof Z!="string"||Z.length>R||!(ge?$[c]:$[u]).test(Z))return null;try{return new pe(Z,ge)}catch{return null}}function pe(Z,ge){if(Z instanceof pe){if(Z.loose===ge)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof pe))return new pe(Z,ge);f("SemVer",Z,ge),this.loose=ge;var Ee=Z.trim().match(ge?$[c]:$[u]);if(!Ee)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,ge){var Ee=ce(Z,ge);return Ee?Ee.version:null},e.clean=function(Z,ge){var Ee=ce(Z.trim().replace(/^[=v]+/,""),ge);return Ee?Ee.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(Z){return f("SemVer.compare",this.version,this.loose,Z),Z instanceof pe||(Z=new pe(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},pe.prototype.compareMain=function(Z){return Z instanceof pe||(Z=new pe(Z,this.loose)),B(this.major,Z.major)||B(this.minor,Z.minor)||B(this.patch,Z.patch)},pe.prototype.comparePre=function(Z){if(Z instanceof pe||(Z=new pe(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ge=0;do{var Ee=this.prerelease[ge],je=Z.prerelease[ge];if(f("prerelease compare",ge,Ee,je),Ee===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==je)return B(Ee,je)}while(++ge)},pe.prototype.inc=function(Z,ge){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ge,Ee,je){typeof Ee=="string"&&(je=Ee,Ee=void 0);try{return new pe(Z,Ee).inc(ge,je).version}catch{return null}},e.diff=function(Z,ge){if(_(Z,ge))return null;var Ee=ce(Z),je=ce(ge);if(Ee.prerelease.length||je.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return We},e.compareIdentifiers=B;var H=/^[0-9]+$/;function B(Z,ge){var Ee=H.test(Z),je=H.test(ge);return Ee&&je&&(Z=+Z,ge=+ge),Ee&&!je?-1:je&&!Ee?1:Z<ge?-1:Z>ge?1:0}function X(Z,ge,Ee){return new pe(Z,Ee).compare(new pe(ge,Ee))}function re(Z,ge,Ee){return X(Z,ge,Ee)>0}function Y(Z,ge,Ee){return X(Z,ge,Ee)<0}function _(Z,ge,Ee){return X(Z,ge,Ee)===0}function x(Z,ge,Ee){return X(Z,ge,Ee)!==0}function ve(Z,ge,Ee){return X(Z,ge,Ee)>=0}function ae(Z,ge,Ee){return X(Z,ge,Ee)<=0}function fe(Z,ge,Ee,je){var We;switch(ge){case"===":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z===Ee;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z!==Ee;break;case"":case"=":case"==":We=_(Z,Ee,je);break;case"!=":We=x(Z,Ee,je);break;case">":We=re(Z,Ee,je);break;case">=":We=ve(Z,Ee,je);break;case"<":We=Y(Z,Ee,je);break;case"<=":We=ae(Z,Ee,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function ee(Z,ge){if(Z instanceof ee){if(Z.loose===ge)return Z;Z=Z.value}if(!(this instanceof ee))return new ee(Z,ge);f("comparator",Z,ge),this.loose=ge,this.parse(Z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Z,ge){return B(ge,Z)},e.major=function(Z,ge){return new pe(Z,ge).major},e.minor=function(Z,ge){return new pe(Z,ge).minor},e.patch=function(Z,ge){return new pe(Z,ge).patch},e.compare=X,e.compareLoose=function(Z,ge){return X(Z,ge,!0)},e.rcompare=function(Z,ge,Ee){return X(ge,Z,Ee)},e.sort=function(Z,ge){return Z.sort(function(Ee,je){return e.compare(Ee,je,ge)})},e.rsort=function(Z,ge){return Z.sort(function(Ee,je){return e.rcompare(Ee,je,ge)})},e.gt=re,e.lt=Y,e.eq=_,e.neq=x,e.gte=ve,e.lte=ae,e.cmp=fe,e.Comparator=ee;var de={};function be(Z,ge){if(Z instanceof be)return Z.loose===ge?Z:new be(Z.raw,ge);if(Z instanceof ee)return new be(Z.value,ge);if(!(this instanceof be))return new be(Z,ge);if(this.loose=ge,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function z(Z,ge,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le){return((ge=Pe(Ee)?"":Pe(je)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+je+".0":">="+ge)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function J(Z,ge){for(var Ee=0;Ee<Z.length;Ee++)if(!Z[Ee].test(ge))return!1;if(ge.prerelease.length){for(Ee=0;Ee<Z.length;Ee++)if(f(Z[Ee].semver),Z[Ee].semver!==de&&Z[Ee].semver.prerelease.length>0){var je=Z[Ee].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function se(Z,ge,Ee){try{ge=new be(ge,Ee)}catch{return!1}return ge.test(Z)}function oe(Z,ge,Ee,je){var We,_e,Ye,it,et;switch(Z=new pe(Z,je),ge=new be(ge,je),Ee){case">":We=re,_e=ae,Ye=Y,it=">",et=">=";break;case"<":We=Y,_e=ve,Ye=re,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Z,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Ne=ge.set[Ae],qe=null,Le=null;if(Ne.forEach(function(Xe){Xe.semver===de&&(Xe=new ee(">=0.0.0")),qe=qe||Xe,Le=Le||Xe,We(Xe.semver,qe.semver,je)?qe=Xe:Ye(Xe.semver,Le.semver,je)&&(Le=Xe)}),qe.operator===it||qe.operator===et||(!Le.operator||Le.operator===it)&&_e(Z,Le.semver)||Le.operator===et&&Ye(Z,Le.semver))return!1}return!0}ee.prototype.parse=function(Z){var ge=this.loose?$[V]:$[me],Ee=Z.match(ge);if(!Ee)throw new TypeError("Invalid comparator: "+Z);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new pe(Ee[2],this.loose):this.semver=de},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Z){return f("Comparator.test",Z,this.loose),this.semver===de||(typeof Z=="string"&&(Z=new pe(Z,this.loose)),fe(Z,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Z,ge){if(!(Z instanceof ee))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new be(Z.value,ge),se(this.value,Ee,ge);if(Z.operator==="")return Ee=new be(this.value,ge),se(Z.semver,Ee,ge);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=fe(this.semver,"<",Z.semver,ge)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),et=fe(this.semver,">",Z.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var ge=this.loose;Z=Z.trim(),f("range",Z,ge);var Ee=ge?$[Q]:$[G];Z=Z.replace(Ee,z),f("hyphen replace",Z),Z=Z.replace($[te],"$1$2$3"),f("comparator trim",Z,$[te]),Z=(Z=(Z=Z.replace($[N],"$1~")).replace($[j],"$1^")).split(/\s+/).join(" ");var je=ge?$[V]:$[me],We=Z.split(" ").map(function(_e){return function(Ye,it){return f("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){f("caret",qe,Le);var Xe=Le?$[K]:$[O];return qe.replace(Xe,function(he,ue,Ie,Ve,ze){var xe;return f("caret",qe,he,ue,Ie,Ve,ze),Pe(ue)?xe="":Pe(Ie)?xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?xe=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":ze?(f("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+ze+" <"+(+ue+1)+".0.0"):(f("no pr"),xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+" <"+(+ue+1)+".0.0"),f("caret return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),f("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){var Xe=Le?$[M]:$[F];return qe.replace(Xe,function(he,ue,Ie,Ve,ze){var xe;return f("tilde",qe,he,ue,Ie,Ve,ze),Pe(ue)?xe="":Pe(Ie)?xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?xe=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":ze?(f("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),xe=">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+(+Ie+1)+".0"):xe=">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0",f("tilde return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),f("tildes",Ye),Ye=function(et,Ae){return f("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(qe,Le){qe=qe.trim();var Xe=Le?$[g]:$[b];return qe.replace(Xe,function(he,ue,Ie,Ve,ze,xe){f("xRange",qe,he,ue,Ie,Ve,ze,xe);var rt=Pe(Ie),ot=rt||Pe(Ve),$t=ot||Pe(ze);return ue==="="&&$t&&(ue=""),rt?he=ue===">"||ue==="<"?"<0.0.0":"*":ue&&$t?(ot&&(Ve=0),$t&&(ze=0),ue===">"?(ue=">=",ot?(Ie=+Ie+1,Ve=0,ze=0):$t&&(Ve=+Ve+1,ze=0)):ue==="<="&&(ue="<",ot?Ie=+Ie+1:Ve=+Ve+1),he=ue+Ie+"."+Ve+"."+ze):ot?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":$t&&(he=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),f("xRange return",he),he})}(Ne,Ae)}).join(" ")}(Ye,it),f("xrange",Ye),Ye=function(et,Ae){return f("replaceStars",et,Ae),et.trim().replace($[le],"")}(Ye,it),f("stars",Ye),Ye}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,ge)})},be.prototype.intersects=function(Z,ge){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(je){return Z.set.some(function(We){return We.every(function(_e){return je.intersects(_e,ge)})})})})},e.toComparators=function(Z,ge){return new be(Z,ge).set.map(function(Ee){return Ee.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new pe(Z,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],Z))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Z,ge,Ee){var je=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new pe(je=Ye,Ee)))}),je},e.minSatisfying=function(Z,ge,Ee){var je=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new pe(je=Ye,Ee)))}),je},e.validRange=function(Z,ge){try{return new be(Z,ge).range||"*"}catch{return null}},e.ltr=function(Z,ge,Ee){return oe(Z,ge,"<",Ee)},e.gtr=function(Z,ge,Ee){return oe(Z,ge,">",Ee)},e.outside=oe,e.prerelease=function(Z,ge){var Ee=ce(Z,ge);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(Z,ge,Ee){return Z=new be(Z,Ee),ge=new be(ge,Ee),Z.intersects(ge)},e.coerce=function(Z){if(Z instanceof pe)return Z;if(typeof Z!="string")return null;var ge=Z.match($[d]);return ge==null?null:ce((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function($e,e){var D,T,f=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(h){if(D===setTimeout)return setTimeout(h,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(h,0);try{return D(h,0)}catch{try{return D.call(null,h,0)}catch{return D.call(this,h,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,w=[],L=!1,I=-1;function v(){L&&E&&(L=!1,E.length?w=E.concat(w):I=-1,w.length&&y())}function y(){if(!L){var h=$(v);L=!0;for(var r=w.length;r;){for(E=w,w=[];++I<r;)E&&E[I].run();I=-1,r=w.length}E=null,L=!1,function(s){if(T===clearTimeout)return clearTimeout(s);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(s);try{T(s)}catch{try{return T.call(null,s)}catch{return T.call(this,s)}}}(h)}}function k(h,r){this.fun=h,this.array=r}function p(){}f.nextTick=function(h){var r=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)r[s-1]=arguments[s];w.push(new k(h,r)),w.length!==1||L||$(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=p,f.addListener=p,f.once=p,f.off=p,f.removeListener=p,f.removeAllListeners=p,f.emit=p,f.prependListener=p,f.prependOnceListener=p,f.listeners=function(h){return[]},f.binding=function(h){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(h){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(De[35],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=T}),define(De[4],Ce([1,0,9,75,3,76,35]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const $=!1,E=!1;var w;(function(b){b.None=()=>f.$Sc.None;function g(fe){if(E){const{onDidAddListener:ee}=fe,de=k.create();let be=0;fe.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ee?.()}}}function d(fe,ee){return me(fe,()=>{},0,void 0,!0,void 0,ee)}b.defer=d;function P(fe){return(ee,de=null,be)=>{let Pe=!1,z;return z=fe(J=>{if(!Pe)return z?z.dispose():Pe=!0,ee.call(de,J)},null,be),Pe&&z.dispose(),z}}b.once=P;function N(fe,ee,de){return K((be,Pe=null,z)=>fe(J=>be.call(Pe,ee(J)),null,z),de)}b.map=N;function F(fe,ee,de){return K((be,Pe=null,z)=>fe(J=>{ee(J),be.call(Pe,J)},null,z),de)}b.forEach=F;function M(fe,ee,de){return K((be,Pe=null,z)=>fe(J=>ee(J)&&be.call(Pe,J),null,z),de)}b.filter=M;function U(fe){return fe}b.signal=U;function j(...fe){return(ee,de=null,be)=>{const Pe=(0,f.$Pc)(...fe.map(z=>z(J=>ee.call(de,J))));return V(Pe,be)}}b.any=j;function O(fe,ee,de,be){let Pe=de;return N(fe,z=>(Pe=ee(Pe,z),Pe),be)}b.reduce=O;function K(fe,ee){let de;const be={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};ee||g(be);const Pe=new o(be);return ee?.add(Pe),Pe.event}function V(fe,ee){return ee instanceof Array?ee.push(fe):ee&&ee.add(fe),fe}function me(fe,ee,de=100,be=!1,Pe=!1,z,J){let se,oe,Z,ge=0,Ee;const je={leakWarningThreshold:z,onWillAddFirstListener(){se=fe(_e=>{ge++,oe=ee(oe,_e),be&&!Z&&(We.fire(oe),oe=void 0),Ee=()=>{const Ye=oe;oe=void 0,Z=void 0,(!be||ge>1)&&We.fire(Ye),ge=0},typeof de=="number"?(clearTimeout(Z),Z=setTimeout(Ee,de)):Z===void 0&&(Z=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&ge>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,se.dispose()}};J||g(je);const We=new o(je);return J?.add(We),We.event}b.debounce=me;function te(fe,ee=0,de){return b.debounce(fe,(be,Pe)=>be?(be.push(Pe),be):[Pe],ee,void 0,!0,void 0,de)}b.accumulate=te;function G(fe,ee=(be,Pe)=>be===Pe,de){let be=!0,Pe;return M(fe,z=>{const J=be||!ee(z,Pe);return be=!1,Pe=z,J},de)}b.latch=G;function Q(fe,ee,de){return[b.filter(fe,ee,de),b.filter(fe,be=>!ee(be),de)]}b.split=Q;function le(fe,ee=!1,de=[],be){let Pe=de.slice(),z=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});be&&be.add(z);const J=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new o({onWillAddFirstListener(){z||(z=fe(oe=>se.fire(oe)),be&&be.add(z))},onDidAddFirstListener(){Pe&&(ee?setTimeout(J):J())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return be&&be.add(se),se.event}b.buffer=le;function ie(fe,ee){return(be,Pe,z)=>{const J=ee(new pe);return fe(function(se){const oe=J.evaluate(se);oe!==ce&&be.call(Pe,oe)},void 0,z)}}b.chain=ie;const ce=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(de=>(ee(de),de)),this}filter(ee){return this.f.push(de=>ee(de)?de:ce),this}reduce(ee,de){let be=de;return this.f.push(Pe=>(be=ee(be,Pe),be)),this}latch(ee=(de,be)=>de===be){let de=!0,be;return this.f.push(Pe=>{const z=de||!ee(Pe,be);return de=!1,be=Pe,z?Pe:ce}),this}evaluate(ee){for(const de of this.f)if(ee=de(ee),ee===ce)break;return ee}}function H(fe,ee,de=be=>be){const be=(...se)=>J.fire(de(...se)),Pe=()=>fe.on(ee,be),z=()=>fe.removeListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return J.event}b.fromNodeEventEmitter=H;function B(fe,ee,de=be=>be){const be=(...se)=>J.fire(de(...se)),Pe=()=>fe.addEventListener(ee,be),z=()=>fe.removeEventListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return J.event}b.fromDOMEventEmitter=B;function X(fe){return new Promise(ee=>P(fe)(ee))}b.toPromise=X;function re(fe){const ee=new o;return fe.then(de=>{ee.fire(de)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}b.fromPromise=re;function Y(fe,ee,de){return ee(de),fe(be=>ee(be))}b.runAndSubscribe=Y;function _(fe,ee){let de=null;function be(z){de?.dispose(),de=new f.$Rc,ee(z,de)}be(void 0);const Pe=fe(z=>be(z));return(0,f.$Qc)(()=>{Pe.dispose(),de?.dispose()})}b.runAndSubscribeWithStore=_;class x{constructor(ee,de){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};de||g(be),this.emitter=new o(be),de&&de.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,de){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(fe,ee){return new x(fe,ee).emitter.event}b.fromObservable=ve;function ae(fe){return ee=>{let de=0,be=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}b.fromObservableLight=ae})(w||(e.Event=w={}));class L{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${L.f++}`,L.all.add(this)}start(g){this.g=new A.$Jd,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Ld=L;let I=-1;function v(b){const g=I;return I=b,{dispose(){I=g}}}e.$Md=v;class y{constructor(g,d=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=d,this.g=0}dispose(){this.f?.clear()}check(g,d){const P=this.threshold;if(P<=0||d<P)return;this.f||(this.f=new Map);const N=this.f.get(g.value)||0;if(this.f.set(g.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let F,M=0;for(const[U,j]of this.f)(!F||M<j)&&(F=U,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(g.value)||0;this.f.set(g.value,F-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class h{constructor(g){this.value=g,this.id=p++}}const r=2,s=(b,g)=>{if(b instanceof h)g(b);else for(let d=0;d<b.length;d++){const P=b[d];P&&g(P)}};class o{constructor(g){this.w=0,this.f=g,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const g=this.t;queueMicrotask(()=>{s(g,d=>d.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,d,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Sc.None;if(this.m)return f.$Sc.None;d&&(g=g.bind(d));const N=new h(g);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),F=this.g.check(N.stack,this.w+1)),$&&(N.stack=M??k.create()),this.t?this.t instanceof h?(this.u??=new u,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,f.$Qc)(()=>{F?.(),this.x(N)});return P instanceof f.$Rc?P.add(U):Array.isArray(P)&&P.push(U),U},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const d=this.t,P=d.indexOf(g);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,d[P]=void 0;const N=this.u.current===this;if(this.w*r<=d.length){let F=0;for(let M=0;M<d.length;M++)d[M]?d[F++]=d[M]:N&&(this.u.end--,F<this.u.i&&this.u.i--);d.length=F}}y(g,d){if(!g)return;const P=this.f?.onListenerError||D.$1;if(!P){g.value(d);return}try{g.value(d)}catch(N){P(N)}}z(g){const d=g.current.t;for(;g.i<g.end;)this.y(d[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,g);else{const d=this.u;d.enqueue(this,g,this.t.length),this.z(d)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=o;const m=()=>new u;e.$Od=m;class u{constructor(){this.i=-1,this.end=0}enqueue(g,d,P){this.i=0,this.end=P,this.current=g,this.value=d}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends o{async fireAsync(g,d,P){if(this.t)for(this.h||(this.h=new R.$2c),s(this.t,N=>this.h.push([N.value,g]));this.h.size>0&&!d.isCancellationRequested;){const[N,F]=this.h.shift(),M=[],U={...F,token:d,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(j=P(j,N)),M.push(j)}};try{N(U)}catch(j){(0,D.$1)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const O of j)O.status==="rejected"&&(0,D.$1)(O.reason)})}}}e.$Pd=t;class n extends o{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new R.$2c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Qd=n;class c extends n{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$Rd=c;class i extends o{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(d=>super.fire(d)),this.h=[]}))}}e.$Sd=i;class a{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const d={event:g,listener:null};this.h.push(d),this.g&&this.m(d);const P=()=>{this.g&&this.o(d);const N=this.h.indexOf(d);this.h.splice(N,1)};return(0,f.$Qc)((0,T.$db)(P))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(d=>this.f.fire(d))}o(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.f.dispose()}}e.$Td=a;class l{constructor(g,d,P,N){this.f=new f.$Rc;const F=this.f.add(new a),M=this.f.add(new f.$1c);function U(j){M.set(j,F.add(N(j)))}for(const j of g)U(j);this.f.add(d(j=>{U(j)})),this.f.add(P(j=>{M.deleteAndDispose(j)})),this.event=F.event}dispose(){this.f.dispose()}}e.$Ud=l;class C{constructor(){this.f=[]}wrapEvent(g){return(d,P,N)=>g(F=>{const M=this.f[this.f.length-1];M?M.push(()=>d.call(P,F)):d.call(P,F)},void 0,N)}bufferEvents(g){const d=[];this.f.push(d);const P=g();return this.f.pop(),d.forEach(N=>N()),P}}e.$Vd=C;class S{constructor(){this.f=!1,this.g=w.None,this.h=f.$Sc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=S}),define(De[21],Ce([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const T=Object.freeze(function($,E){const w=setTimeout($.bind(E),0);return{dispose(){clearTimeout(w)}}});var f;(function($){function E(w){return w===$.None||w===$.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$Xd=A}),define(De[159],Ce([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class T{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new D.$Xd,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$we=T;class f{constructor($){this.c=$,this.a=void 0,this.b=void 0}get($){const E=JSON.stringify($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$xe=f;class R{get cachedValues(){return this.a}constructor($){this.b=$,this.a=new Map}get($){if(this.a.has($))return this.a.get($);const E=this.b($);return this.a.set($,E),E}}e.$ye=R}),define(De[96],Ce([1,0,9,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function f(m){const u=m;return u?typeof u.read=="function":!1}e.$Yd=f;function R(m){const u=m;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$Zd=R;function A(m){const u=m;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$1d=A;function $(m,u){return new E(m,u)}e.$2d=$;class E{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,D.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let n;switch(u){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const c=n.indexOf(t);c>=0&&n.splice(c,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(m,u){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return u(t)}e.$3d=w;function L(m,u,t){const n=[];let c;for(;(c=m.read())!==null&&n.length<t;)n.push(c);return c===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof c<"u"){const i=c;return c=void 0,i}return m.read()}}}e.$4d=L;function I(m,u){return new Promise((t,n)=>{const c=[];v(m,{onData:i=>{u&&c.push(i)},onError:i=>{u?n(i):t(void 0)},onEnd:()=>{t(u?u(c):void 0)}})})}e.$5d=I;function v(m,u,t){m.on("error",n=>{t?.isCancellationRequested||u.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||u.onData(n)})}e.$6d=v;function y(m,u){return new Promise((t,n)=>{const c=new T.$Rc,i=[],a=S=>{if(i.push(S),i.length>u)return c.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},l=S=>(c.dispose(),n(S)),C=()=>(c.dispose(),t({stream:m,buffer:i,ended:!0}));c.add((0,T.$Qc)(()=>m.removeListener("error",l))),m.on("error",l),c.add((0,T.$Qc)(()=>m.removeListener("end",C))),m.on("end",C),c.add((0,T.$Qc)(()=>m.removeListener("data",a))),m.on("data",a)})}e.$7d=y;function k(m,u){const t=$(u);return t.end(m),t}e.$8d=k;function p(){const m=$(()=>{throw new Error("not supported")});return m.end(),m}e.$9d=p;function h(m){let u=!1;return{read:()=>u?null:(u=!0,m)}}e.$0d=h;function r(m,u,t){const n=$(t);return v(m,{onData:c=>n.write(u.data(c)),onError:c=>n.error(u.error?u.error(c):c),onEnd:()=>n.end()}),n}e.$$d=r;function s(m,u,t){let n=!1;return{read:()=>{const c=u.read();return n?c:(n=!0,c!==null?t([m,c]):m)}}}e.$_d=s;function o(m,u,t){let n=!1;const c=$(t);return v(u,{onData:i=>n?c.write(i):(n=!0,c.write(t([m,i]))),onError:i=>c.error(i),onEnd:()=>{n||(n=!0,c.write(m)),c.end()}}),c}e.$ae=o}),define(De[22],Ce([1,0,47,96]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const f=typeof Buffer<"u",R=new D.$V(()=>new Uint8Array(256));let A,$;class E{static alloc(d){return f?new E(Buffer.allocUnsafe(d)):new E(new Uint8Array(d))}static wrap(d){return f&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new E(d)}static fromString(d,P){return!(P?.dontUseNodeBuffer||!1)&&f?new E(Buffer.from(d)):(A||(A=new TextEncoder),new E(A.encode(d)))}static fromByteArray(d){const P=E.alloc(d.length);for(let N=0,F=d.length;N<F;N++)P.buffer[N]=d[N];return P}static concat(d,P){if(typeof P>"u"){P=0;for(let M=0,U=d.length;M<U;M++)P+=d[M].byteLength}const N=E.alloc(P);let F=0;for(let M=0,U=d.length;M<U;M++){const j=d[M];N.set(j,F),F+=j.byteLength}return N}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=E.alloc(this.byteLength);return d.set(this),d}toString(){return f?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(d,P){return new E(this.buffer.subarray(d,P))}set(d,P){if(d instanceof E)this.buffer.set(d.buffer,P);else if(d instanceof Uint8Array)this.buffer.set(d,P);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),P);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return v(this.buffer,d)}writeUInt32BE(d,P){y(this.buffer,d,P)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,P){p(this.buffer,d,P)}readUInt8(d){return h(this.buffer,d)}writeUInt8(d,P){r(this.buffer,d,P)}indexOf(d,P=0){return w(this.buffer,d instanceof E?d.buffer:d,P)}}e.$be=E;function w(g,d,P=0){const N=d.byteLength,F=g.byteLength;if(N===0)return 0;if(N===1)return g.indexOf(d[0]);if(N>F-P)return-1;const M=R.value;M.fill(d.length);for(let K=0;K<d.length;K++)M[d[K]]=d.length-K-1;let U=P+d.length-1,j=U,O=-1;for(;U<F;)if(g[U]===d[j]){if(j===0){O=U;break}U--,j--}else U+=Math.max(d.length-j,M[g[U]]),j=d.length-1;return O}e.$ce=w;function L(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0}e.$de=L;function I(g,d,P){g[P+0]=d&255,d=d>>>8,g[P+1]=d&255}e.$ee=I;function v(g,d){return g[d]*2**24+g[d+1]*2**16+g[d+2]*2**8+g[d+3]}e.$fe=v;function y(g,d,P){g[P+3]=d,d=d>>>8,g[P+2]=d,d=d>>>8,g[P+1]=d,d=d>>>8,g[P]=d}e.$ge=y;function k(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0|g[d+2]<<16>>>0|g[d+3]<<24>>>0}e.$he=k;function p(g,d,P){g[P+0]=d&255,d=d>>>8,g[P+1]=d&255,d=d>>>8,g[P+2]=d&255,d=d>>>8,g[P+3]=d&255}e.$ie=p;function h(g,d){return g[d]}e.$je=h;function r(g,d,P){g[P]=d}e.$ke=r;function s(g){return T.$3d(g,d=>E.concat(d))}e.$le=s;function o(g){return T.$0d(g)}e.$me=o;function m(g){return T.$5d(g,d=>E.concat(d))}e.$ne=m;async function u(g){return g.ended?E.concat(g.buffer):E.concat([...g.buffer,await m(g.stream)])}e.$oe=u;function t(g){return T.$8d(g,d=>E.concat(d))}e.$pe=t;function n(g){return T.$$d(g,{data:d=>typeof d=="string"?E.fromString(d):E.wrap(d)},d=>E.concat(d))}e.$qe=n;function c(g){return T.$2d(d=>E.concat(d),g)}e.$re=c;function i(g,d){return T.$_d(g,d,P=>E.concat(P))}e.$se=i;function a(g,d){return T.$ae(g,d,P=>E.concat(P))}e.$te=a;function l(g){let d=0,P=0,N=0;const F=new Uint8Array(Math.floor(g.length/4*3)),M=j=>{switch(P){case 3:F[N++]=d|j,P=0;break;case 2:F[N++]=d|j>>>2,d=j<<6,P=3;break;case 1:F[N++]=d|j>>>4,d=j<<4,P=2;break;default:d=j<<2,P=1}};for(let j=0;j<g.length;j++){const O=g.charCodeAt(j);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${g[j]}`)}}const U=N;for(;P>0;)M(0);return E.wrap(F).slice(0,U)}e.$ue=l;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:g},d=!0,P=!1){const N=P?S:C;let F="";const M=g.byteLength%3;let U=0;for(;U<g.byteLength-M;U+=3){const j=g[U+0],O=g[U+1],K=g[U+2];F+=N[j>>>2],F+=N[(j<<4|O>>>4)&63],F+=N[(O<<2|K>>>6)&63],F+=N[K&63]}if(M===1){const j=g[U+0];F+=N[j>>>2],F+=N[j<<4&63],d&&(F+="==")}else if(M===2){const j=g[U+0],O=g[U+1];F+=N[j>>>2],F+=N[(j<<4|O>>>4)&63],F+=N[O<<2&63],d&&(F+="=")}return F}e.$ve=b}),define(De[15],Ce([1,0,159,47]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Be=f;const R=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(qe,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Ne.length?qe:Ne[Xe]})}e.$Ce=A;const $=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace($,(qe,Le)=>Ne[Le]??qe)}e.$De=E;function w(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ee=w;function L(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=L;function I(Ae,Ne){let qe=0;const Le=Ne.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&qe++;return qe}e.$Ge=I;function v(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$He=v;function y(Ae,Ne=" "){const qe=k(Ae,Ne);return p(qe,Ne)}e.$Ie=y;function k(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Je=k;function p(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Xe=Le,he=-1;for(;he=Ae.lastIndexOf(Ne,Xe-1),!(he===-1||he+qe!==Xe);){if(he===0)return"";Xe=he}return Ae.substring(0,Xe)}e.$Ke=p;function h(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=h;function r(Ae){return Ae.replace(/\*/g,"")}e.$Me=r;function s(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=L(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ne=s;function o(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Oe=o;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Pe=m;function u(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Qe=u;function t(Ae,Ne=0,qe=Ae.length){for(let Le=Ne;Le<qe;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,qe)}e.$Re=t;function n(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Se=n;function c(Ae,Ne,qe){const Le=[];let Xe=0;for(const he of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");Xe=he.index+he[0].length,Le.push(qe(he[0],...he.slice(1),he.index,Ae,he.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(he=>he.join(""))}e.$Te=c;function i(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ue=i;function a(Ae,Ne,qe=0,Le=Ae.length,Xe=0,he=Ne.length){for(;qe<Le&&Xe<he;qe++,Xe++){const Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Xe);if(Ve<ze)return-1;if(Ve>ze)return 1}const ue=Le-qe,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Ve=a;function l(Ae,Ne){return C(Ae,Ne,0,Ae.length,0,Ne.length)}e.$We=l;function C(Ae,Ne,qe=0,Le=Ae.length,Xe=0,he=Ne.length){for(;qe<Le&&Xe<he;qe++,Xe++){let Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Xe);if(Ve===ze)continue;if(Ve>=128||ze>=128)return a(Ae.toLowerCase(),Ne.toLowerCase(),qe,Le,Xe,he);b(Ve)&&(Ve-=32),b(ze)&&(ze-=32);const xe=Ve-ze;if(xe!==0)return xe}const ue=Le-qe,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Xe=C;function S(Ae){return Ae>=48&&Ae<=57}e.$Ye=S;function b(Ae){return Ae>=97&&Ae<=122}e.$Ze=b;function g(Ae){return Ae>=65&&Ae<=90}e.$1e=g;function d(Ae,Ne){return Ae.length===Ne.length&&C(Ae,Ne)===0}e.$2e=d;function P(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:C(Ae,Ne,0,qe)===0}e.$3e=P;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return qe}e.$4e=N;function F(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;const Xe=Ae.length-1,he=Ne.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Xe-Le)!==Ne.charCodeAt(he-Le))return Le;return qe}e.$5e=F;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$6e=M;function U(Ae){return 56320<=Ae&&Ae<=57343}e.$7e=U;function j(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$8e=j;function O(Ae,Ne,qe){const Le=Ae.charCodeAt(qe);if(M(Le)&&qe+1<Ne){const Xe=Ae.charCodeAt(qe+1);if(U(Xe))return j(Le,Xe)}return Le}e.$9e=O;function K(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(U(qe)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return j(Le,qe)}return qe}class V{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=K(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=O(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$0e=V;class me{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new V(Ne,qe)}nextGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,ue=Ne.getGraphemeBreakType(qe.nextCodePoint());if(oe(Xe,ue)){qe.setOffset(he);break}Xe=ue}return qe.offset-Le}prevGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,ue=Ne.getGraphemeBreakType(qe.prevCodePoint());if(oe(ue,Xe)){qe.setOffset(he);break}Xe=ue}return Le-qe.offset}eol(){return this.c.eol()}}e.$$e=me;function te(Ae,Ne){return new me(Ae,Ne).nextGraphemeLength()}e.$_e=te;function G(Ae,Ne){return new me(Ae,Ne).prevGraphemeLength()}e.$af=G;function Q(Ae,Ne){Ne>0&&U(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+te(Ae,Ne);return[qe-G(Ae,qe),qe]}e.$bf=Q;function le(Ae){const Ne=new me(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$cf=le;let ie;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(Ae){return ie||(ie=ce()),ie.test(Ae)}e.$df=pe;const H=/^[\t\n\r\x20-\x7E]*$/;function B(Ae){return H.test(Ae)}e.$ef=B,e.$ff=/[\u2028\u2029]/;function X(Ae){return e.$ff.test(Ae)}e.$gf=X;function re(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$hf=re;function Y(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$if=Y;function _(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$jf=_;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ve=/\x1b\].*?\x07/g;function ae(Ae){return Ae&&(Ae=Ae.replace(x,"").replace(ve,"")),Ae}e.$kf=ae,e.$lf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$mf=fe;function ee(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$nf=ee;function de(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Le=Ae.toLowerCase();let Xe=0,he=-1;for(;Xe<qe;){const ue=Le.indexOf(Ne[Xe],he+1);if(ue<0)return!1;he=ue,Xe++}return!0}e.$of=de;function be(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$pf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$qf=Pe;function z(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$rf=z;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$sf=J;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$tf=se;function oe(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=Ee()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Le=qe.length/3;let Xe=1;for(;Xe<=Le;)if(Ne<qe[3*Xe])Xe=2*Xe;else if(Ne>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Le=new V(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$uf=je;function We(Ae,Ne){const qe=new V(Ne,Ae);let Le=qe.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!Y(Le))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$vf="\xA0";class it{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$xe(Ne=>{function qe(xe){const rt=new Map;for(let ot=0;ot<xe.length;ot+=2)rt.set(xe[ot],xe[ot+1]);return rt}function Le(xe,rt){const ot=new Map(xe);for(const[$t,St]of rt)ot.set($t,St);return ot}function Xe(xe,rt){if(!xe)return rt;const ot=new Map;for(const[$t,St]of xe)rt.has($t)&&ot.set($t,St);return ot}const he=this.c.value;let ue=Ne.filter(xe=>!xe.startsWith("_")&&xe in he);ue.length===0&&(ue=["_default"]);let Ie;for(const xe of ue){const rt=qe(he[xe]);Ie=Xe(Ie,rt)}const Ve=qe(he._common),ze=Le(Ve,Ie);return new it(ze)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new T.$V(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$xf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function f(...ee){return function(de,be){for(let Pe=0,z=ee.length;Pe<z;Pe++){const J=ee[Pe](de,be);if(J)return J}return null}}e.or=f,e.$Cj=R.bind(void 0,!1),e.$Dj=R.bind(void 0,!0);function R(ee,de,be){if(!be||be.length<de.length)return null;let Pe;return ee?Pe=T.$3e(be,de):Pe=be.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function A(ee,de){const be=de.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Ej=A;function $(ee,de){return E(ee.toLowerCase(),de.toLowerCase(),0,0)}e.$Fj=$;function E(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]===de[Pe]){let z=null;return(z=E(ee,de,be+1,Pe+1))?r({start:Pe,end:Pe+1},z):null}return E(ee,de,be,Pe+1)}function w(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.$Gj=L;function I(ee){return 48<=ee&&ee<=57}function v(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function k(ee){return v(ee)||y.has(ee)}function p(ee,de){return ee===de||k(ee)&&k(de)}function h(ee){return w(ee)||L(ee)||I(ee)}function r(ee,de){return de.length===0?de=[ee]:ee.end===de[0].start?de[0].start=ee.start:de.unshift(ee),de}function s(ee,de){for(let be=de;be<ee.length;be++){const Pe=ee.charCodeAt(be);if(L(Pe)||I(Pe)||be>0&&!h(ee.charCodeAt(be-1)))return be}return ee.length}function o(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]!==de[Pe].toLowerCase())return null;{let z=null,J=Pe+1;for(z=o(ee,de,be+1,Pe+1);!z&&(J=s(de,J))<de.length;)z=o(ee,de,be+1,J),J++;return z===null?null:r({start:Pe,end:Pe+1},z)}}function m(ee){let de=0,be=0,Pe=0,z=0,J=0;for(let Ee=0;Ee<ee.length;Ee++)J=ee.charCodeAt(Ee),L(J)&&de++,w(J)&&be++,h(J)&&Pe++,I(J)&&z++;const se=de/ee.length,oe=be/ee.length,Z=Pe/ee.length,ge=z/ee.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Z,numericPercent:ge}}function u(ee){const{upperPercent:de,lowerPercent:be}=ee;return be===0&&de>.6}function t(ee){const{upperPercent:de,lowerPercent:be,alphaPercent:Pe,numericPercent:z}=ee;return be>.2&&de<.8&&Pe>.6&&z<.2}function n(ee){let de=0,be=0,Pe=0,z=0;for(let J=0;J<ee.length;J++)Pe=ee.charCodeAt(J),L(Pe)&&de++,w(Pe)&&be++,v(Pe)&&z++;return(de===0||be===0)&&z===0?ee.length<=30:de<=5}function c(ee,de){if(!de||(de=de.trim(),de.length===0)||!n(ee)||de.length>60)return null;const be=m(de);if(!t(be)){if(!u(be))return null;de=de.toLowerCase()}let Pe=null,z=0;for(ee=ee.toLowerCase();z<de.length&&(Pe=o(ee,de,0,z))===null;)z=s(de,z+1);return Pe}e.$Hj=c;function i(ee,de,be=!1){if(!de||de.length===0)return null;let Pe=null,z=0;for(ee=ee.toLowerCase(),de=de.toLowerCase();z<de.length&&(Pe=a(ee,de,0,z,be))===null;)z=l(de,z+1);return Pe}e.$Ij=i;function a(ee,de,be,Pe,z){if(be===ee.length)return[];if(Pe===de.length)return null;if(p(ee.charCodeAt(be),de.charCodeAt(Pe))){let J=null,se=Pe+1;if(J=a(ee,de,be+1,Pe+1,z),!z)for(;!J&&(se=l(de,se))<de.length;)J=a(ee,de,be+1,se,z),se++;return J?ee.charCodeAt(be)!==de.charCodeAt(Pe)?J:r({start:Pe,end:Pe+1},J):null}else return null}function l(ee,de){for(let be=de;be<ee.length;be++)if(k(ee.charCodeAt(be))||be>0&&k(ee.charCodeAt(be-1)))return be;return ee.length}const C=f(e.$Dj,c,A),S=f(e.$Dj,c,$),b=new D.$Dc(1e4);function g(ee,de,be=!1){if(typeof ee!="string"||typeof de!="string")return null;let Pe=b.get(ee);Pe||(Pe=new RegExp(T.$Le(ee),"i"),b.set(ee,Pe));const z=Pe.exec(de);return z?[{start:z.index,end:z.index+z[0].length}]:be?S(ee,de):C(ee,de)}e.$Jj=g;function d(ee,de){const be=re(ee,ee.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Kj=d;function P(ee,de,be,Pe,z,J){const se=Math.min(13,ee.length);for(;be<se;be++){const oe=re(ee,de,be,Pe,z,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,J]}e.$Lj=P;function N(ee){if(typeof ee>"u")return[];const de=[],be=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const z=ee[Pe]+be,J=de[de.length-1];J&&J.end===z?J.end=z+1:de.push({start:z,end:z+1})}return de}e.$Mj=N;const F=128;function M(){const ee=[],de=[];for(let be=0;be<=F;be++)de[be]=0;for(let be=0;be<=F;be++)ee.push(de.slice(0));return ee}function U(ee){const de=[];for(let be=0;be<=ee;be++)de[be]=0;return de}const j=U(2*F),O=U(2*F),K=M(),V=M(),me=M(),te=!1;function G(ee,de,be,Pe,z){function J(oe,Z,ge=" "){for(;oe.length<Z;)oe=ge+oe;return oe}let se=` |   |${Pe.split("").map(oe=>J(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?se+=" |":se+=`${de[oe-1]}|`,se+=ee[oe].slice(0,z+1).map(Z=>J(Z.toString(),3)).join("|")+`
`;return se}function Q(ee,de,be,Pe){ee=ee.substr(de),be=be.substr(Pe),console.log(G(V,ee,ee.length,be,be.length)),console.log(G(me,ee,ee.length,be,be.length)),console.log(G(K,ee,ee.length,be,be.length))}function le(ee,de){if(de<0||de>=ee.length)return!1;const be=ee.codePointAt(de);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$if(be)}}function ie(ee,de){if(de<0||de>=ee.length)return!1;switch(ee.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function ce(ee,de,be){return de[ee]!==be[ee]}function pe(ee,de,be,Pe,z,J,se=!1){for(;de<be&&z<J;)ee[de]===Pe[z]&&(se&&(j[de]=z),de+=1),z+=1;return de===be}e.$Nj=pe;var H;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(H||(H={}));var B;(function(ee){ee.Default=[-100,0];function de(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=de})(B||(e.FuzzyScore=B={}));class X{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,be){this.firstMatchCanBeWeak=de,this.boostFullMatch=be}}e.$Oj=X;function re(ee,de,be,Pe,z,J,se=X.default){const oe=ee.length>F?F:ee.length,Z=Pe.length>F?F:Pe.length;if(be>=oe||J>=Z||oe-be>Z-J||!pe(de,be,oe,z,J,Z,!0))return;Y(oe,Z,be,J,de,z);let ge=1,Ee=1,je=be,We=J;const _e=[!1];for(ge=1,je=be;je<oe;ge++,je++){const Ne=j[je],qe=O[je],Le=je+1<oe?O[je+1]:Z;for(Ee=Ne-J+1,We=Ne;We<Le;Ee++,We++){let Xe=Number.MIN_SAFE_INTEGER,he=!1;We<=qe&&(Xe=_(ee,de,je,be,Pe,z,We,Z,J,K[ge-1][Ee-1]===0,_e));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(he=!0,ue=Xe+V[ge-1][Ee-1]);const Ie=We>Ne,Ve=Ie?V[ge][Ee-1]+(K[ge][Ee-1]>0?-5:0):0,ze=We>Ne+1&&K[ge][Ee-1]>0,xe=ze?V[ge][Ee-2]+(K[ge][Ee-2]>0?-5:0):0;if(ze&&(!Ie||xe>=Ve)&&(!he||xe>=ue))V[ge][Ee]=xe,me[ge][Ee]=3,K[ge][Ee]=0;else if(Ie&&(!he||Ve>=ue))V[ge][Ee]=Ve,me[ge][Ee]=2,K[ge][Ee]=0;else if(he)V[ge][Ee]=ue,me[ge][Ee]=1,K[ge][Ee]=K[ge-1][Ee-1]+1;else throw new Error("not possible")}}if(te&&Q(ee,be,Pe,J),!_e[0]&&!se.firstMatchCanBeWeak)return;ge--,Ee--;const Ye=[V[ge][Ee],J];let it=0,et=0;for(;ge>=1;){let Ne=Ee;do{const qe=me[ge][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&de[be+ge-1]===z[J+Ee-1]&&!ce(Ne+J-1,Pe,z)&&it+1>K[ge][Ne]&&(Ne=Ee),Ne===Ee?it++:it=1,et||(et=Ne),ge--,Ee=Ne-1,Ye.push(Ee)}Z===oe&&se.boostFullMatch&&(Ye[0]+=2);const Ae=et-oe;return Ye[0]-=Ae,Ye}e.$Pj=re;function Y(ee,de,be,Pe,z,J){let se=ee-1,oe=de-1;for(;se>=be&&oe>=Pe;)z[se]===J[oe]&&(O[se]=oe,se--),oe--}function _(ee,de,be,Pe,z,J,se,oe,Z,ge,Ee){if(de[be]!==J[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===be-Pe?je=ee[be]===z[se]?7:5:ce(se,z,J)&&(se===0||!ce(se-1,z,J))?(je=ee[be]===z[se]?7:5,We=!0):le(J,se)&&(se===0||!le(J,se-1))?je=5:(le(J,se-1)||ie(J,se-1))&&(je=5,We=!0),je>1&&be===Pe&&(Ee[0]=!0),We||(We=ce(se,z,J)||le(J,se-1)||ie(J,se-1)),be===Pe?se>Z&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function x(ee,de,be,Pe,z,J,se){return ae(ee,de,be,Pe,z,J,!0,se)}e.$Qj=x;function ve(ee,de,be,Pe,z,J,se){return ae(ee,de,be,Pe,z,J,!1,se)}e.$Rj=ve;function ae(ee,de,be,Pe,z,J,se,oe){let Z=re(ee,de,be,Pe,z,J,oe);if(Z&&!se)return Z;if(ee.length>=3){const ge=Math.min(7,ee.length-1);for(let Ee=be+1;Ee<ge;Ee++){const je=fe(ee,Ee);if(je){const We=re(je,je.toLowerCase(),be,Pe,z,J,oe);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function fe(ee,de){if(de+1>=ee.length)return;const be=ee[de],Pe=ee[de+1];if(be!==Pe)return ee.slice(0,de)+Pe+be+ee.slice(de+2)}}),define(De[52],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function T(r){return f(r,0)}e.$Di=T;function f(r,s){switch(typeof r){case"object":return r===null?R(349,s):Array.isArray(r)?E(r,s):w(r,s);case"string":return $(r,s);case"boolean":return A(r,s);case"number":return R(r,s);case"undefined":return R(937,s);default:return R(617,s)}}e.$Ei=f;function R(r,s){return(s<<5)-s+r|0}e.$Fi=R;function A(r,s){return R(r?433:863,s)}function $(r,s){s=R(149417,s);for(let o=0,m=r.length;o<m;o++)s=R(r.charCodeAt(o),s);return s}e.$Gi=$;function E(r,s){return s=R(104579,s),r.reduce((o,m)=>f(m,o),s)}function w(r,s){return s=R(181387,s),Object.keys(r).sort().reduce((o,m)=>(o=$(m,o),f(r[m],o)),s)}class L{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=f(s,this.g),this.g}}e.$Hi=L;var I;(function(r){r[r.BLOCK_SIZE=64]="BLOCK_SIZE",r[r.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(r,s,o=32){const m=o-s,u=~((1<<m)-1);return(r<<s|(u&r)>>>m)>>>0}function y(r,s=0,o=r.byteLength,m=0){for(let u=0;u<o;u++)r[s+u]=m}function k(r,s,o="0"){for(;r.length<s;)r=o+r;return r}function p(r,s=32){return r instanceof ArrayBuffer?Array.from(new Uint8Array(r)).map(o=>o.toString(16).padStart(2,"0")).join(""):k((r>>>0).toString(16),s/4)}e.$Ii=p;class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const o=s.length;if(o===0)return;const m=this.p;let u=this.r,t=this.u,n,c;for(t!==0?(n=t,c=-1,t=0):(n=s.charCodeAt(0),c=0);;){let i=n;if(D.$6e(n))if(c+1<o){const a=s.charCodeAt(c+1);D.$7e(a)?(c++,i=D.$8e(n,a)):i=65533}else{t=n;break}else D.$7e(n)&&(i=65533);if(u=this.w(m,u,i),c++,c<o)n=s.charCodeAt(c);else break}this.r=u,this.u=t}w(s,o,m){return m<128?s[o++]=m:m<2048?(s[o++]=192|(m&1984)>>>6,s[o++]=128|(m&63)>>>0):m<65536?(s[o++]=224|(m&61440)>>>12,s[o++]=128|(m&4032)>>>6,s[o++]=128|(m&63)>>>0):(s[o++]=240|(m&1835008)>>>18,s[o++]=128|(m&258048)>>>12,s[o++]=128|(m&4032)>>>6,s[o++]=128|(m&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=h.g,o=this.q;for(let C=0;C<64;C+=4)s.setUint32(C,o.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)s.setUint32(C,v(s.getUint32(C-12,!1)^s.getUint32(C-32,!1)^s.getUint32(C-56,!1)^s.getUint32(C-64,!1),1),!1);let m=this.h,u=this.l,t=this.m,n=this.n,c=this.o,i,a,l;for(let C=0;C<80;C++)C<20?(i=u&t|~u&n,a=1518500249):C<40?(i=u^t^n,a=1859775393):C<60?(i=u&t|u&n|t&n,a=2400959708):(i=u^t^n,a=3395469782),l=v(m,5)+i+c+a+s.getUint32(C*4,!1)&4294967295,c=n,n=t,t=v(u,30),u=m,m=l;this.h=this.h+m&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+c&4294967295}}e.$Ji=h}),define(De[38],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(T||(T={})),function(f){const R="error",A="warning",$="warn",E="info",w="ignore";function L(v){return v?D.$2e(R,v)?f.Error:D.$2e(A,v)||D.$2e($,v)?f.Warning:D.$2e(E,v)?f.Info:f.Ignore:f.Ignore}f.fromValue=L;function I(v){switch(v){case f.Error:return R;case f.Warning:return A;case f.Info:return E;default:return w}}f.toString=I}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return k-p}value(){return this.b[this.c]}}e.$Rh=f;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.$Ve)(y,this.b,0,y.length,this.c,this.d):(0,T.$Xe)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=R;class A{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const p=this.b.charCodeAt(k);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.$Ve)(y,this.b,0,y.length,this.d,this.e):(0,T.$Xe)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var $;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})($||($={}));class E{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.$We)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.$We)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.$Ue)(y,this.c.query);if(this.d[this.e]===5)return(0,T.$Ue)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=E;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class I{static forUris(y=()=>!1,k=()=>!1){return new I(new E(y,k))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const p=k.slice(0);(0,D.$Xb)(p);for(const h of p)this.set(h,y)}else{const p=y.slice(0);(0,D.$Xb)(p);for(const h of p)this.set(h[0],h[1])}}set(y,k){const p=this.b.reset(y);let h;this.c||(this.c=new w,this.c.segment=p.value());const r=[];for(h=this.c;;){const o=p.cmp(h.segment);if(o>0)h.left||(h.left=new w,h.left.segment=p.value()),r.push([-1,h]),h=h.left;else if(o<0)h.right||(h.right=new w,h.right.segment=p.value()),r.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new w,h.mid.segment=p.value()),r.push([0,h]),h=h.mid;else break}const s=h.value;h.value=k,h.key=y;for(let o=r.length-1;o>=0;o--){const m=r[o][1];m.updateHeight();const u=m.balanceFactor();if(u<-1||u>1){const t=r[o][0],n=r[o+1][0];if(t===1&&n===1)r[o][1]=m.rotateLeft();else if(t===-1&&n===-1)r[o][1]=m.rotateRight();else if(t===1&&n===-1)m.right=r[o+1][1]=r[o+1][1].rotateRight(),r[o][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=r[o+1][1]=r[o+1][1].rotateLeft(),r[o][1]=m.rotateRight();else throw new Error;if(o>0)switch(r[o-1][0]){case-1:r[o-1][1].left=r[o][1];break;case 1:r[o-1][1].right=r[o][1];break;case 0:r[o-1][1].mid=r[o][1];break}else this.c=r[0][1]}}return s}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let p=this.c;for(;p;){const h=k.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(k.hasNext())k.next(),p=p.mid;else break}return p}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const p=this.b.reset(y),h=[];let r=this.c;for(;r;){const s=p.cmp(r.segment);if(s>0)h.push([-1,r]),r=r.left;else if(s<0)h.push([1,r]),r=r.right;else if(p.hasNext())p.next(),h.push([0,r]),r=r.mid;else break}if(r){if(k?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const s=this.f(r.right);if(s.key){const{key:o,value:m,segment:u}=s;this.e(s.key,!1),r.key=o,r.value=m,r.segment=u}}else{const s=r.left??r.right;if(h.length>0){const[o,m]=h[h.length-1];switch(o){case-1:m.left=s;break;case 0:m.mid=s;break;case 1:m.right=s;break}}else this.c=s}for(let s=h.length-1;s>=0;s--){const o=h[s][1];o.updateHeight();const m=o.balanceFactor();if(m>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),h[s][1]=o.rotateLeft()):m<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),h[s][1]=o.rotateRight()),s>0)switch(h[s-1][0]){case-1:h[s-1][1].left=h[s][1];break;case 1:h[s-1][1].right=h[s][1];break;case 0:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let p=this.c,h;for(;p;){const r=k.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(k.hasNext())k.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(y){return this.g(y,!1)}g(y,k){const p=this.b.reset(y);let h=this.c;for(;h;){const r=p.cmp(h.segment);if(r>0)h=h.left;else if(r<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this.h(h.mid):k?h.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,p]of this)y(p,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const p=k.balanceFactor();return p<-1||p>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$Vh=I}),define(De[17],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function D(u){return typeof u=="string"}e.$yf=D;function T(u){return Array.isArray(u)&&u.every(t=>D(t))}e.$zf=T;function f(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$Af=f;function R(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$Bf=R;function A(u){return typeof u=="number"&&!isNaN(u)}e.$Cf=A;function $(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Df=$;function E(u){return u===!0||u===!1}e.$Ef=E;function w(u){return typeof u>"u"}e.$Ff=w;function L(u){return!I(u)}e.$Gf=L;function I(u){return w(u)||u===null}e.$Hf=I;function v(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$If=v;function y(u){if(I(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Jf=y;function k(...u){const t=[];for(let n=0;n<u.length;n++){const c=u[n];if(I(c))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(c)}return t}e.$Kf=k;const p=Object.prototype.hasOwnProperty;function h(u){if(!f(u))return!1;for(const t in u)if(p.call(u,t))return!1;return!0}e.$Lf=h;function r(u){return typeof u=="function"}e.$Mf=r;function s(...u){return u.length>0&&u.every(r)}e.$Nf=s;function o(u,t){const n=Math.min(u.length,t.length);for(let c=0;c<n;c++)m(u[c],t[c])}e.$Of=o;function m(u,t){if(D(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(r(t)){try{if(u instanceof t)return}catch{}if(!I(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=m}),define(De[79],Ce([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const T=Object.create(null);function f($,E){if((0,D.$yf)(E)){const w=T[E];if(w===void 0)throw new Error(`${$} references an unknown codicon: ${E}`);E=w}return T[$]=E,{id:$}}function R(){return T}e.$Sj=R;function A(){return Object.values(e.$Uj)}e.$Tj=A,e.$Uj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function T(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const s=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([o,m])=>{s[o]=m&&typeof m=="object"?T(m):m}),s}e.$7m=T;function f(r){if(!r||typeof r!="object")return r;const s=[r];for(;s.length>0;){const o=s.shift();Object.freeze(o);for(const m in o)if(R.call(o,m)){const u=o[m];typeof u=="object"&&!Object.isFrozen(u)&&!(0,D.$Bf)(u)&&s.push(u)}}return r}e.$8m=f;const R=Object.prototype.hasOwnProperty;function A(r,s){return $(r,s,new Set)}e.$9m=A;function $(r,s,o){if((0,D.$Hf)(r))return r;const m=s(r);if(typeof m<"u")return m;if(Array.isArray(r)){const u=[];for(const t of r)u.push($(t,s,o));return u}if((0,D.$Af)(r)){if(o.has(r))throw new Error("Cannot clone recursive data-structure");o.add(r);const u={};for(const t in r)R.call(r,t)&&(u[t]=$(r[t],s,o));return o.delete(r),u}return r}function E(r,s,o=!0){return(0,D.$Af)(r)?((0,D.$Af)(s)&&Object.keys(s).forEach(m=>{m in r?o&&((0,D.$Af)(r[m])&&(0,D.$Af)(s[m])?E(r[m],s[m],o):r[m]=s[m]):r[m]=s[m]}),r):s}e.$0m=E;function w(r,s){if(r===s)return!0;if(r==null||s===null||s===void 0||typeof r!=typeof s||typeof r!="object"||Array.isArray(r)!==Array.isArray(s))return!1;let o,m;if(Array.isArray(r)){if(r.length!==s.length)return!1;for(o=0;o<r.length;o++)if(!w(r[o],s[o]))return!1}else{const u=[];for(m in r)u.push(m);u.sort();const t=[];for(m in s)t.push(m);if(t.sort(),!w(u,t))return!1;for(o=0;o<u.length;o++)if(!w(r[u[o]],s[u[o]]))return!1}return!0}e.$$m=w;function L(r){const s=new Set;return JSON.stringify(r,(o,m)=>{if((0,D.$Af)(m)||Array.isArray(m)){if(s.has(m))return"[Circular]";s.add(m)}return m})}e.$_m=L;function I(r,s){const o=Object.create(null);return!r||!s||Object.keys(s).forEach(u=>{const t=r[u],n=s[u];w(t,n)||(o[u]=n)}),o}e.$an=I;function v(r,s){const o=s.toLowerCase(),m=Object.keys(r).find(u=>u.toLowerCase()===o);return m?r[m]:r[s]}e.$bn=v;function y(r,s){const o=Object.create(null);for(const[m,u]of Object.entries(r))s(m,u)&&(o[m]=u);return o}e.$cn=y;function k(r){let s=[];for(;Object.prototype!==r;)s=s.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return s}e.$dn=k;function p(r){const s=[];for(const o of k(r))typeof r[o]=="function"&&s.push(o);return s}e.$en=p;function h(r,s){const o=u=>function(){const t=Array.prototype.slice.call(arguments,0);return s(u,t)},m={};for(const u of r)m[u]=o(u);return m}e.$fn=h}),define(De[59],Ce([1,0,79]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var T;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(T||(e.ThemeColor=T={}));function f(A){return{id:A}}e.$Vj=f;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(s){const o=$.exec(s.id);if(!o)return E(D.$Uj.error);const[,m,u]=o,t=["codicon","codicon-"+m];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=E;function w(s){return E(s).join(" ")}A.asClassName=w;function L(s){return"."+E(s).join(".")}A.asCSSSelector=L;function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||T.isThemeColor(s.color))}A.isThemeIcon=I;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(s){const o=v.exec(s);if(!o)return;const[,m]=o;return{id:m}}A.fromString=y;function k(s){return{id:s}}A.fromId=k;function p(s,o){let m=s.id;const u=m.lastIndexOf("~");return u!==-1&&(m=m.substring(0,u)),o&&(m=`${m}~${o}`),{id:m}}A.modify=p;function h(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}A.getModifier=h;function r(s,o){return s.id===o.id&&s.color?.id===o.color?.id}A.isEqual=r})(R||(e.ThemeIcon=R={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const R="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(r){return r.replace($,(s,o)=>o?s:`\\${s}`)}e.$Wj=E;const w=new RegExp(`\\\\${A.source}`,"g");function L(r){return r.replace(w,s=>`\\${s}`)}e.$Xj=L;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(r){return r.indexOf(R)===-1?r:r.replace(I,(s,o,m,u)=>m?s:o||u||"")}e.$Yj=v;function y(r){return r?r.replace(/\$\((.*?)\)/g,(s,o)=>` ${o} `).trim():""}e.$Zj=y;const k=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(r){k.lastIndex=0;let s="";const o=[];let m=0;for(;;){const u=k.lastIndex,t=k.exec(r),n=r.substring(u,t?.index);if(n.length>0){s+=n;for(let c=0;c<n.length;c++)o.push(m)}if(!t)break;m+=t[0].length}return{text:s,iconOffsets:o}}e.$1j=p;function h(r,s,o=!1){const{text:m,iconOffsets:u}=s;if(!u||u.length===0)return(0,D.$Jj)(r,m,o);const t=(0,T.$Je)(m," "),n=m.length-t.length,c=(0,D.$Jj)(r,t,o);if(c)for(const i of c){const a=u[i.start+n]+n;i.start+=a,i.end+=a}return c}e.$2j=h}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(R){return R<0?0:R>255?255:R|0}e.$ze=T;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Ae=f}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(f){return D.test(f)}e.$dg=T,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const R=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,w="";return w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w+="-",w+=A[R[E++]],w+=A[R[E++]],w+="-",w+=A[R[E++]],w+=A[R[E++]],w+="-",w+=A[R[E++]],w+=A[R[E++]],w+="-",w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w+=A[R[E++]],w}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ys=R;function A(I,v,y){const k={id:(0,f.$eg)(),name:I,uri:v,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$Zs=A;class ${constructor(){this.a=new Map}get size(){let v=0;for(const y of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const y=[...this.a.keys()];return T.Iterable.some(this,([k,p])=>p.asFile())&&y.push("files"),L(E(v),y)}get(v){return this.a.get(this.b(v))?.[0]}append(v,y){const k=this.a.get(v);k?k.push(y):this.a.set(this.b(v),[y])}replace(v,y){this.a.set(this.b(v),[y])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,y]of this.a)for(const k of y)yield[v,k]}b(v){return E(v)}}e.$1s=$;function E(I){return I.toLowerCase()}function w(I,v){return L(E(I),v.map(E))}e.$2s=w;function L(I,v){if(I==="*/*")return v.length>0;if(v.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,p,h]=y;return h==="*"?v.some(r=>r.startsWith(p+"/")):!1}e.$3s=Object.freeze({create:I=>(0,D.$Mb)(I.map(v=>v.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$3s.split(I).filter(v=>!v.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function T($,E,w,L=1){let I=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!I)return I=!0,v(0)},w);f($,E,L,k=>{if(!I)return I=!0,clearTimeout(y),v(k)})})}e.$gg=T;function f($,E,w,L){if(E===0)return L(0);const I=new D.Socket;I.once("connect",()=>(A(I),f($+w,E-1,w,L))),I.once("data",()=>{}),I.once("error",v=>(A(I),v.code!=="ECONNREFUSED"?f($+w,E-1,w,L):L($))),I.connect($,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R($,E,w,L="127.0.0.1"){let I=!1,v,y=1;const k=D.createServer({pauseOnConnect:!0});function p(h,r){I||(I=!0,k.removeAllListeners(),k.close(),v&&clearTimeout(v),r(h))}return new Promise(h=>{v=setTimeout(()=>{p(0,h)},w),k.on("listening",()=>{p($,h)}),k.on("error",r=>{r&&(r.code==="EADDRINUSE"||r.code==="EACCES")&&y<E?($++,y++,k.listen($,L)):p(0,h)}),k.on("close",()=>{p(0,h)}),k.listen($,L)})}e.$ig=R;function A($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=void 0;class T{constructor($){const E=(0,D.$ze)($);this.c=E,this.a=T.d(E),this.b=new Map}static d($){const E=new Uint8Array(256);return E.fill($),E}set($,E){const w=(0,D.$ze)(E);$>=0&&$<256?this.a[$]=w:this.b.set($,w)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Qs=T;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new T(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Rs=R}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;class D{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new D(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return D.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return D.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return D.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const A=f.lineNumber|0,$=R.lineNumber|0;if(A===$){const E=f.column|0,w=R.column|0;return E-w}return A-$}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new D(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$ss=D}),define(De[32],Ce([1,0,61]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;class T{constructor(R,A,$,E){R>$||R===$&&A>E?(this.startLineNumber=$,this.startColumn=E,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=$,this.endColumn=E)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,A){let $,E,w,L;return A.startLineNumber<R.startLineNumber?($=A.startLineNumber,E=A.startColumn):A.startLineNumber===R.startLineNumber?($=A.startLineNumber,E=Math.min(A.startColumn,R.startColumn)):($=R.startLineNumber,E=R.startColumn),A.endLineNumber>R.endLineNumber?(w=A.endLineNumber,L=A.endColumn):A.endLineNumber===R.endLineNumber?(w=A.endLineNumber,L=Math.max(A.endColumn,R.endColumn)):(w=R.endLineNumber,L=R.endColumn),new T($,E,w,L)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,A){let $=R.startLineNumber,E=R.startColumn,w=R.endLineNumber,L=R.endColumn;const I=A.startLineNumber,v=A.startColumn,y=A.endLineNumber,k=A.endColumn;return $<I?($=I,E=v):$===I&&(E=Math.max(E,v)),w>y?(w=y,L=k):w===y&&(L=Math.min(L,k)),$>w||$===w&&E>L?null:new T($,E,w,L)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new D.$ss(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new D.$ss(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new T(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new T(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new T(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const w=R.startLineNumber|0,L=A.startLineNumber|0;if(w===L){const I=R.startColumn|0,v=A.startColumn|0;if(I===v){const y=R.endLineNumber|0,k=A.endLineNumber|0;if(y===k){const p=R.endColumn|0,h=A.endColumn|0;return p-h}return y-k}return I-v}return w-L}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ts=T}),define(De[164],Ce([1,0,32]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class T{static insert(R,A){return{range:new D.$ts(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$us=T}),define(De[165],Ce([1,0,61,32]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends T.$ts{constructor($,E,w,L){super($,E,w,L),this.selectionStartLineNumber=$,this.selectionStartColumn=E,this.positionLineNumber=w,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return R.selectionsEqual(this,$)}static selectionsEqual($,E){return $.selectionStartLineNumber===E.selectionStartLineNumber&&$.selectionStartColumn===E.selectionStartColumn&&$.positionLineNumber===E.positionLineNumber&&$.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,$,E):new R($,E,this.startLineNumber,this.startColumn)}getPosition(){return new D.$ss(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$ss(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,E){return this.getDirection()===0?new R($,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,$,E)}static fromPositions($,E=$){return new R($.lineNumber,$.column,E.lineNumber,E.column)}static fromRange($,E){return E===0?new R($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new R($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new R($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,E){if($&&!E||!$&&E)return!1;if(!$&&!E)return!0;if($.length!==E.length)return!1;for(let w=0,L=$.length;w<L;w++)if(!this.selectionsEqual($[w],E[w]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,E,w,L,I){return I===0?new R($,E,w,L):new R(w,L,$,E)}}e.$vs=R}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0,e.$3r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.WordCharacterClass=void 0;var T;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class f extends D.$Qs{constructor($){super(0);for(let E=0,w=$.length;E<w;E++)this.set($.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ss=f;function R(A){const $={};return E=>($.hasOwnProperty(E)||($[E]=A(E)),$[E])}e.$Ts=R(A=>new f(A))}),define(De[124],Ce([1,0,51,3,76]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$4r)I.indexOf(y)>=0||(v+="\\"+y);return v+="\\s]+)",new RegExp(v,"g")}e.$5r=R();function A(I){let v=e.$5r;if(I&&I instanceof RegExp)if(I.global)v=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),v=new RegExp(I.source,y)}return v.lastIndex=0,v}e.$6r=A;const $=new f.$2c;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const v=$.unshift(I);return(0,T.$Qc)(v)}e.$7r=E;function w(I,v,y,k,p){if(p||(p=D.Iterable.first($)),y.length>p.maxLen){let m=I-p.maxLen/2;return m<0?m=0:k+=m,y=y.substring(m,I+p.maxLen/2),w(I,v,y,k,p)}const h=Date.now(),r=I-1-k;let s=-1,o=null;for(let m=1;!(Date.now()-h>=p.timeBudget);m++){const u=r-p.windowSize*m;v.lastIndex=Math.max(0,u);const t=L(v,y,r,s);if(!t&&o||(o=t,u<=0))break;s=u}if(o){const m={word:o[0],startColumn:k+1+o.index,endColumn:k+1+o.index+o[0].length};return v.lastIndex=0,m}return null}e.$8r=w;function L(I,v,y,k){let p;for(;p=I.exec(v);){const h=p.index||0;if(h<=y&&I.lastIndex>=y)return p;if(k>0&&h>k)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,w=$.notIn.length;E<w;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const w=$.findTokenIndexAtOffset(E-2),L=$.getStandardTokenType(w);return this.isOK(L)}g($,E){for(let w=$;w<=E;w++){const L=String.fromCharCode(w);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$pt=T;class f{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$qt=f;function R(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Y=e.$6Y=e.$5Y=e.State=void 0;var T;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class f{constructor(k,p,h){const r=new Uint8Array(k*p);for(let s=0,o=k*p;s<o;s++)r[s]=h;this.a=r,this.rows=k,this.cols=p}get(k,p){return this.a[k*this.cols+p]}set(k,p,h){this.a[k*this.cols+p]=h}}class R{constructor(k){let p=0,h=0;for(let s=0,o=k.length;s<o;s++){const[m,u,t]=k[s];u>p&&(p=u),m>h&&(h=m),t>h&&(h=t)}p++,h++;const r=new f(h,p,0);for(let s=0,o=k.length;s<o;s++){const[m,u,t]=k[s];r.set(m,u,t)}this.a=r,this.b=p}nextState(k,p){return p<0||p>=this.b?0:this.a.get(k,p)}}e.$5Y=R;let A=null;function $(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let w=null;function L(){if(w===null){w=new D.$Qs(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)w.set(y.charCodeAt(p),1);const k=".,;:";for(let p=0;p<k.length;p++)w.set(k.charCodeAt(p),2)}return w}class I{static a(k,p,h,r,s){let o=s-1;do{const m=p.charCodeAt(o);if(k.get(m)!==2)break;o--}while(o>r);if(r>0){const m=p.charCodeAt(r-1),u=p.charCodeAt(o);(m===40&&u===41||m===91&&u===93||m===123&&u===125)&&o--}return{range:{startLineNumber:h,startColumn:r+1,endLineNumber:h,endColumn:o+2},url:p.substring(r,o+1)}}static computeLinks(k,p=$()){const h=L(),r=[];for(let s=1,o=k.getLineCount();s<=o;s++){const m=k.getLineContent(s),u=m.length;let t=0,n=0,c=0,i=1,a=!1,l=!1,C=!1,S=!1;for(;t<u;){let b=!1;const g=m.charCodeAt(t);if(i===13){let d;switch(g){case 40:a=!0,d=0;break;case 41:d=a?0:1;break;case 91:C=!0,l=!0,d=0;break;case 93:C=!1,d=l?0:1;break;case 123:S=!0,d=0;break;case 125:d=S?0:1;break;case 39:case 34:case 96:c===g?d=1:c===39||c===34||c===96?d=0:d=1;break;case 42:d=c===42?1:0;break;case 124:d=c===124?1:0;break;case 32:d=C?0:1;break;default:d=h.get(g)}d===1&&(r.push(I.a(h,m,s,n,t)),b=!0)}else if(i===12){let d;g===91?(l=!0,d=0):d=h.get(g),d===1?b=!0:i=13}else i=p.nextState(i,g),i===0&&(b=!0);b&&(i=1,a=!1,l=!1,S=!1,n=t+1,c=g),t++}i===13&&r.push(I.a(h,m,s,n,u))}return r}}e.$6Y=I;function v(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$7Y=v}),define(De[125],Ce([1,0,24]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.$Nu=e.$Mu=e.ModelConstants=e.PositionAffinity=e.$Lu=e.TrackedRangeStickiness=e.$Ku=e.$Ju=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var f;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var $;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var w;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(w||(e.EndOfLineSequence=w={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,D.$$m)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.$Ju=L;class I{constructor(u,t){this._findMatchBrand=void 0,this.range=u,this.matches=t}}e.$Ku=I;var v;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function y(m){return m&&typeof m.read=="function"}e.$Lu=y;var k;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var p;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class h{constructor(u,t,n,c,i,a){this.identifier=u,this.range=t,this.text=n,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=i,this._isTracked=a}}e.$Mu=h;class r{constructor(u,t,n){this.regex=u,this.wordSeparators=t,this.simpleSearch=n}}e.$Nu=r;class s{constructor(u,t,n){this.reverseEdits=u,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Ou=s;function o(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Pu=o}),define(De[170],Ce([1,0,19,122]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.$Su=void 0;class f{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,w){E=(0,T.$Ae)(E);const L=this.a,I=this.b,v=w.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E),E+v),this.a.set(w,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,w){return E=(0,T.$Ae)(E),w=(0,T.$Ae)(w),this.a[E]===w?!1:(this.a[E]=w,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,w){E=(0,T.$Ae)(E),w=(0,T.$Ae)(w);const L=this.a,I=this.b;if(E>=L.length)return!1;const v=L.length-E;return w>=v&&(w=v),w===0?!1:(this.a=new Uint32Array(L.length-w),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E+w),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,T.$Ae)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),E>=this.a.length&&(E=this.a.length-1);for(let L=w;L<=E;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let w=0,L=this.a.length-1,I=0,v=0,y=0;for(;w<=L;)if(I=w+(L-w)/2|0,v=this.b[I],y=v-this.a[I],E<y)L=I-1;else if(E>=v)w=I+1;else break;return new A(I,E-y)}}e.$Su=f;class R{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const w=this.e[E],L=w>0?this.d[w-1]:0;return new A(w,E-L)}removeValues(E,w){this.a.splice(E,w),this.f(E)}insertValues(E,w){this.a=(0,D.$Wb)(this.a,E,w),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,w=this.a.length;E<w;E++){const L=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+L;for(let v=0;v<L;v++)this.e[I+v]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,w){this.a[E]!==w&&(this.a[E]=w,this.f(E))}}e.$Tu=R;class A{constructor(E,w){this.index=E,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=w}}e.$Uu=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=void 0;class R{constructor($,E,w,L){this.d=$,this.f=E,this.g=w,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const E=$.changes;for(const w of E)this.o(w.range),this.p(new T.$ss(w.range.startLineNumber,w.range.startColumn),w.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,E=this.f.length,w=new Uint32Array(E);for(let L=0;L<E;L++)w[L]=this.f[L].length+$;this.j=new f.$Su(w)}}n($,E){this.f[$]=E,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,E){if(E.length===0)return;const w=(0,D.$Pe)(E);if(w.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+w[0]+this.f[$.lineNumber-1].substring($.column-1));return}w[w.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+w[0]);const L=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this.f.splice($.lineNumber+I-1,0,w[I]),L[I-1]=w[I].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,L)}}e.$Vu=R}),define(De[172],Ce([1,0,15,167,61,32,125]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=void 0;const $=999;class E{constructor(s,o,m,u){this.searchString=s,this.isRegex=o,this.matchCase=m,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=w(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=D.$Ne(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!o)return null;let m=!this.isRegex&&!s;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new A.$Nu(o,this.wordSeparators?(0,T.$Ts)(this.wordSeparators):null,m?this.searchString:null)}}e.$uB=E;function w(r){if(!r||r.length===0)return!1;for(let s=0,o=r.length;s<o;s++){const m=r.charCodeAt(s);if(m===10)return!0;if(m===92){if(s++,s>=o)break;const u=r.charCodeAt(s);if(u===110||u===114||u===87)return!0}}return!1}e.$vB=w;function L(r,s,o){if(!o)return new A.$Ku(r,null);const m=[];for(let u=0,t=s.length;u<t;u++)m[u]=s[u];return new A.$Ku(r,m)}e.$wB=L;class I{constructor(s){const o=[];let m=0;for(let u=0,t=s.length;u<t;u++)s.charCodeAt(u)===10&&(o[m++]=u);this.a=o}findLineFeedCountBeforeOffset(s){const o=this.a;let m=0,u=o.length-1;if(u===-1||s<=o[0])return 0;for(;m<u;){const t=m+((u-m)/2>>0);o[t]>=s?u=t-1:o[t+1]>=s?(m=t,u=t):m=t+1}return m+1}}class v{static findMatches(s,o,m,u,t){const n=o.parseSearchRequest();return n?n.regex.multiline?this.b(s,m,new h(n.wordSeparators,n.regex),u,t):this.c(s,m,n,u,t):[]}static a(s,o,m,u,t,n){let c,i=0;u?(i=u.findLineFeedCountBeforeOffset(t),c=o+t+i):c=o+t;let a;if(u){const b=u.findLineFeedCountBeforeOffset(t+n.length)-i;a=c+n.length+b}else a=c+n.length;const l=s.getPositionAt(c),C=s.getPositionAt(a);return new R.$ts(l.lineNumber,l.column,C.lineNumber,C.column)}static b(s,o,m,u,t){const n=s.getOffsetAt(o.getStartPosition()),c=s.getValueInRange(o,1),i=s.getEOL()===`\r
`?new I(c):null,a=[];let l=0,C;for(m.reset(0);C=m.next(c);)if(a[l++]=L(this.a(s,n,c,i,C.index,C[0]),C,u),l>=t)return a;return a}static c(s,o,m,u,t){const n=[];let c=0;if(o.startLineNumber===o.endLineNumber){const a=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return c=this.d(m,a,o.startLineNumber,o.startColumn-1,c,n,u,t),n}const i=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);c=this.d(m,i,o.startLineNumber,o.startColumn-1,c,n,u,t);for(let a=o.startLineNumber+1;a<o.endLineNumber&&c<t;a++)c=this.d(m,s.getLineContent(a),a,0,c,n,u,t);if(c<t){const a=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);c=this.d(m,a,o.endLineNumber,0,c,n,u,t)}return n}static d(s,o,m,u,t,n,c,i){const a=s.wordSeparators;if(!c&&s.simpleSearch){const S=s.simpleSearch,b=S.length,g=o.length;let d=-b;for(;(d=o.indexOf(S,d+b))!==-1;)if((!a||p(a,o,g,d,b))&&(n[t++]=new A.$Ku(new R.$ts(m,d+1+u,m,d+1+b+u),null),t>=i))return t;return t}const l=new h(s.wordSeparators,s.regex);let C;l.reset(0);do if(C=l.next(o),C&&(n[t++]=L(new R.$ts(m,C.index+1+u,m,C.index+1+C[0].length+u),C,c),t>=i))return t;while(C);return t}static findNextMatch(s,o,m,u){const t=o.parseSearchRequest();if(!t)return null;const n=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.e(s,m,n,u):this.f(s,m,n,u)}static e(s,o,m,u){const t=new f.$ss(o.lineNumber,1),n=s.getOffsetAt(t),c=s.getLineCount(),i=s.getValueInRange(new R.$ts(t.lineNumber,t.column,c,s.getLineMaxColumn(c)),1),a=s.getEOL()===`\r
`?new I(i):null;m.reset(o.column-1);const l=m.next(i);return l?L(this.a(s,n,i,a,l.index,l[0]),l,u):o.lineNumber!==1||o.column!==1?this.e(s,new f.$ss(1,1),m,u):null}static f(s,o,m,u){const t=s.getLineCount(),n=o.lineNumber,c=s.getLineContent(n),i=this.g(m,c,n,o.column,u);if(i)return i;for(let a=1;a<=t;a++){const l=(n+a-1)%t,C=s.getLineContent(l+1),S=this.g(m,C,l+1,1,u);if(S)return S}return null}static g(s,o,m,u,t){s.reset(u-1);const n=s.next(o);return n?L(new R.$ts(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(s,o,m,u){const t=o.parseSearchRequest();if(!t)return null;const n=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.h(s,m,n,u):this.j(s,m,n,u)}static h(s,o,m,u){const t=this.b(s,new R.$ts(1,1,o.lineNumber,o.column),m,u,10*$);if(t.length>0)return t[t.length-1];const n=s.getLineCount();return o.lineNumber!==n||o.column!==s.getLineMaxColumn(n)?this.h(s,new f.$ss(n,s.getLineMaxColumn(n)),m,u):null}static j(s,o,m,u){const t=s.getLineCount(),n=o.lineNumber,c=s.getLineContent(n).substring(0,o.column-1),i=this.k(m,c,n,u);if(i)return i;for(let a=1;a<=t;a++){const l=(t+n-a-1)%t,C=s.getLineContent(l+1),S=this.k(m,C,l+1,u);if(S)return S}return null}static k(s,o,m,u){let t=null,n;for(s.reset(0);n=s.next(o);)t=L(new R.$ts(m,n.index+1,m,n.index+1+n[0].length),n,u);return t}}e.$xB=v;function y(r,s,o,m,u){if(m===0)return!0;const t=s.charCodeAt(m-1);if(r.get(t)!==0||t===13||t===10)return!0;if(u>0){const n=s.charCodeAt(m);if(r.get(n)!==0)return!0}return!1}function k(r,s,o,m,u){if(m+u===o)return!0;const t=s.charCodeAt(m+u);if(r.get(t)!==0||t===13||t===10)return!0;if(u>0){const n=s.charCodeAt(m+u-1);if(r.get(n)!==0)return!0}return!1}function p(r,s,o,m,u){return y(r,s,o,m,u)&&k(r,s,o,m,u)}e.$yB=p;class h{constructor(s,o){this._wordSeparators=s,this.a=o,this.b=-1,this.c=0}reset(s){this.a.lastIndex=s,this.b=-1,this.c=0}next(s){const o=s.length;let m;do{if(this.b+this.c===o||(m=this.a.exec(s),!m))return null;const u=m.index,t=m[0].length;if(u===this.b&&t===this.c){if(t===0){D.$9e(s,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=t,!this._wordSeparators||p(this._wordSeparators,s,o,u,t))return m}while(m);return null}}e.$zB=h}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7=e.$R7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$R7=D;class T{constructor(R){this.identifier=R}}e.$S7=T}),define(De[174],Ce([1,0,4,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Nd,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,E){return this.a.set($,E),this.handleChange([$]),(0,T.$Qc)(()=>{this.a.get($)===E&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,E){this.b.get($)?.dispose();const w=new R(this,$,E);return this.b.set($,w),(0,T.$Qc)(()=>{const L=this.b.get($);!L||L!==w||(this.b.delete($),L.dispose())})}async getOrCreate($){const E=this.get($);if(E)return E;const w=this.b.get($);return!w||w.isResolved?null:(await w.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const w=this.b.get($);return!!(!w||w.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$5s=f;class R extends T.$Sc{get isResolved(){return this.c}constructor($,E,w){super(),this.f=$,this.g=E,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class R extends T.$Sc{constructor(v,y="",k="",p=!0,h){super(),this.h=this.B(new D.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=y,this.u=k,this.w=p,this.C=h}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,y){this.C&&await this.C(v)}}e.$ui=R;class A extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Nd),this.onWillRun=this.f.event,this.m=this.B(new D.$Nd),this.onDidRun=this.m.event}async run(v,y){if(!v.enabled)return;this.f.fire({action:v});let k;try{await this.u(v,y)}catch(p){k=p}this.m.fire({action:v,error:k})}async u(v,y){await v.run(y)}}e.$vi=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let y=[];for(const k of v)k.length&&(y.length?y=[...y,new $,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=$;class E{get actions(){return this.a}constructor(v,y,k,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=y,this.class=p,this.a=k}async run(){}}e.$xi=E;class w extends R{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,f.localize(0,null),void 0,!1)}}e.$yi=w;function L(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...v)=>I.run(...v),tooltip:I.label}}e.$zi=L}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const T=60,f=T*60,R=f*24,A=R*7,$=R*30,E=R*365;function w(I,v,y,k){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,D.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(!k&&p<30)return(0,D.localize)(1,null);let h;return p<T?(h=p,v?h===1?y?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):y?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h):h===1?y?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):y?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):p<f?(h=Math.floor(p/T),v?h===1?y?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):y?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h):h===1?y?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):y?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):p<R?(h=Math.floor(p/f),v?h===1?y?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):y?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h):h===1?y?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):y?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):p<A?(h=Math.floor(p/R),v?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h)):p<$?(h=Math.floor(p/A),v?h===1?y?(0,D.localize)(30,null,h):(0,D.localize)(31,null,h):y?(0,D.localize)(32,null,h):(0,D.localize)(33,null,h):h===1?y?(0,D.localize)(34,null,h):(0,D.localize)(35,null,h):y?(0,D.localize)(36,null,h):(0,D.localize)(37,null,h)):p<E?(h=Math.floor(p/$),v?h===1?y?(0,D.localize)(38,null,h):(0,D.localize)(39,null,h):y?(0,D.localize)(40,null,h):(0,D.localize)(41,null,h):h===1?y?(0,D.localize)(42,null,h):(0,D.localize)(43,null,h):y?(0,D.localize)(44,null,h):(0,D.localize)(45,null,h)):(h=Math.floor(p/E),v?h===1?y?(0,D.localize)(46,null,h):(0,D.localize)(47,null,h):y?(0,D.localize)(48,null,h):(0,D.localize)(49,null,h):h===1?y?(0,D.localize)(50,null,h):(0,D.localize)(51,null,h):y?(0,D.localize)(52,null,h):(0,D.localize)(53,null,h))}e.$dm=w;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=L}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,179]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function R(I,v){return v&&(I.stack||I.stacktrace)?f.localize(0,null,$(I),A(I.stack)||A(I.stacktrace)):$(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function $(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function E(I=null,v=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const y=D.$Hb(I),k=E(y[0],v);return y.length>1?f.localize(4,null,k,y.length):k}if(T.$yf(I))return I;if(I.detail){const y=I.detail;if(y.error)return R(y.error,v);if(y.exception)return R(y.exception,v)}return I.stack?R(I,v):I.message?I.message:f.localize(5,null)}e.$Ai=E;function w(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.$Bi=w;function L(I,v){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=v,y}e.$Ci=L}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let T=!1,f=!1,R=!1,A=!1,$=!1,E=!1,w=!1,L=!1,I=!1,v=!1,y,k=e.$g,p=e.$g,h,r;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?s=e.$h.vscode.process:typeof process<"u"&&(s=process);const o=typeof s?.versions?.electron=="string",m=o&&s?.type==="renderer";if(typeof navigator=="object"&&!m)r=navigator.userAgent,T=r.indexOf("Windows")>=0,f=r.indexOf("Macintosh")>=0,L=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=r.indexOf("Linux")>=0,v=r?.indexOf("Mobi")>=0,E=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,k=y,p=navigator.language;else if(typeof s=="object"){T=s.platform==="win32",f=s.platform==="darwin",R=s.platform==="linux",A=R&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,w=o,I=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const S=s.env.VSCODE_NLS_CONFIG;if(S)try{const b=JSON.parse(S),g=b.availableLanguages["*"];y=b.locale,p=b.osLocale,k=g||e.$g,h=b._translationsConfigFile}catch{}$=!0}else console.error("Unable to resolve platform.");var u;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;f?n=1:T?n=3:R&&(n=2),e.$j=T,e.$k=f,e.$l=R,e.$m=A,e.$n=$,e.$o=w,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=L,e.$s=v,e.$t=I,e.$u=n,e.$v=r,e.$w=k;var c;(function(S){function b(){return e.$w}S.value=b;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=g;function d(){return e.$w==="en"}S.isDefault=d})(c||(e.Language=c={})),e.$x=y,e.$y=p,e.$z=h,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let d=0,P=S.length;d<P;d++){const N=S[d];if(N.id===g.data.vscodeScheduleAsyncWork){S.splice(d,1),N.callback();return}}});let b=0;return g=>{const d=++b;S.push({id:d,callback:g}),e.$h.postMessage({vscodeScheduleAsyncWork:d},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=f||L?2:T?1:3;let a=!0,l=!1;function C(){if(!l){l=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,a=new Uint16Array(S.buffer)[0]===(2<<8)+1}return a}e.$D=C,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const f=D.$h.vscode.process;T={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(De[16],Ce([1,0,48]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,f=97,R=90,A=122,$=46,E=47,w=92,L=58,I=63;class v extends Error{constructor(n,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let C=`The "${n}" ${l} ${a} of type ${c}`;C+=`. Received type ${typeof i}`,super(C),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function k(t,n){if(typeof t!="string")throw new v(n,"string",t)}const p=D.$dc==="win32";function h(t){return t===E||t===w}function r(t){return t===E}function s(t){return t>=T&&t<=R||t>=f&&t<=A}function o(t,n,c,i){let a="",l=0,C=-1,S=0,b=0;for(let g=0;g<=t.length;++g){if(g<t.length)b=t.charCodeAt(g);else{if(i(b))break;b=E}if(i(b)){if(!(C===g-1||S===1))if(S===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==$||a.charCodeAt(a.length-2)!==$){if(a.length>2){const d=a.lastIndexOf(c);d===-1?(a="",l=0):(a=a.slice(0,d),l=a.length-1-a.lastIndexOf(c)),C=g,S=0;continue}else if(a.length!==0){a="",l=0,C=g,S=0;continue}}n&&(a+=a.length>0?`${c}..`:"..",l=2)}else a.length>0?a+=`${c}${t.slice(C+1,g)}`:a=t.slice(C+1,g),l=g-C-1;C=g,S=0}else b===$&&S!==-1?++S:S=-1}return a}function m(t,n){y(n,"pathObject");const c=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return c?c===n.root?`${c}${i}`:`${c}${t}${i}`:i}e.$fc={resolve(...t){let n="",c="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],k(l,"path"),l.length===0)continue}else n.length===0?l=D.cwd():(l=D.env[`=${n}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===w)&&(l=`${n}\\`));const C=l.length;let S=0,b="",g=!1;const d=l.charCodeAt(0);if(C===1)h(d)&&(S=1,g=!0);else if(h(d))if(g=!0,h(l.charCodeAt(1))){let P=2,N=P;for(;P<C&&!h(l.charCodeAt(P));)P++;if(P<C&&P!==N){const F=l.slice(N,P);for(N=P;P<C&&h(l.charCodeAt(P));)P++;if(P<C&&P!==N){for(N=P;P<C&&!h(l.charCodeAt(P));)P++;(P===C||P!==N)&&(b=`\\\\${F}\\${l.slice(N,P)}`,S=P)}}}else S=1;else s(d)&&l.charCodeAt(1)===L&&(b=l.slice(0,2),S=2,C>2&&h(l.charCodeAt(2))&&(g=!0,S=3));if(b.length>0)if(n.length>0){if(b.toLowerCase()!==n.toLowerCase())continue}else n=b;if(i){if(n.length>0)break}else if(c=`${l.slice(S)}\\${c}`,i=g,g&&n.length>0)break}return c=o(c,!i,"\\",h),i?`${n}\\${c}`:`${n}${c}`||"."},normalize(t){k(t,"path");const n=t.length;if(n===0)return".";let c=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return r(l)?"\\":t;if(h(l))if(a=!0,h(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!h(t.charCodeAt(S));)S++;if(S<n&&S!==b){const g=t.slice(b,S);for(b=S;S<n&&h(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!h(t.charCodeAt(S));)S++;if(S===n)return`\\\\${g}\\${t.slice(b)}\\`;S!==b&&(i=`\\\\${g}\\${t.slice(b,S)}`,c=S)}}}else c=1;else s(l)&&t.charCodeAt(1)===L&&(i=t.slice(0,2),c=2,n>2&&h(t.charCodeAt(2))&&(a=!0,c=3));let C=c<n?o(t.slice(c),!a,"\\",h):"";return C.length===0&&!a&&(C="."),C.length>0&&h(t.charCodeAt(n-1))&&(C+="\\"),i===void 0?a?`\\${C}`:C:a?`${i}\\${C}`:`${i}${C}`},isAbsolute(t){k(t,"path");const n=t.length;if(n===0)return!1;const c=t.charCodeAt(0);return h(c)||n>2&&s(c)&&t.charCodeAt(1)===L&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,c;for(let l=0;l<t.length;++l){const C=t[l];k(C,"path"),C.length>0&&(n===void 0?n=c=C:n+=`\\${C}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++a;const l=c.length;l>1&&h(c.charCodeAt(1))&&(++a,l>2&&(h(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&h(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.$fc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n)return"";const c=e.$fc.resolve(t),i=e.$fc.resolve(n);if(c===i||(t=c.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===w;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===w;)l--;const C=l-a;let S=0;for(;S<n.length&&n.charCodeAt(S)===w;)S++;let b=n.length;for(;b-1>S&&n.charCodeAt(b-1)===w;)b--;const g=b-S,d=C<g?C:g;let P=-1,N=0;for(;N<d;N++){const M=t.charCodeAt(a+N);if(M!==n.charCodeAt(S+N))break;M===w&&(P=N)}if(N!==d){if(P===-1)return i}else{if(g>d){if(n.charCodeAt(S+N)===w)return i.slice(S+N+1);if(N===2)return i.slice(S+N)}C>d&&(t.charCodeAt(a+N)===w?P=N:N===2&&(P=3)),P===-1&&(P=0)}let F="";for(N=a+P+1;N<=l;++N)(N===l||t.charCodeAt(N)===w)&&(F+=F.length===0?"..":"\\..");return S+=P,F.length>0?`${F}${i.slice(S,b)}`:(i.charCodeAt(S)===w&&++S,i.slice(S,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$fc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===w){if(n.charCodeAt(1)===w){const c=n.charCodeAt(2);if(c!==I&&c!==$)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(s(n.charCodeAt(0))&&n.charCodeAt(1)===L&&n.charCodeAt(2)===w)return`\\\\?\\${n}`;return t},dirname(t){k(t,"path");const n=t.length;if(n===0)return".";let c=-1,i=0;const a=t.charCodeAt(0);if(n===1)return h(a)?t:".";if(h(a)){if(c=i=1,h(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!h(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&h(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!h(t.charCodeAt(S));)S++;if(S===n)return t;S!==b&&(c=i=S+1)}}}}else s(a)&&t.charCodeAt(1)===L&&(c=n>2&&h(t.charCodeAt(2))?3:2,i=c);let l=-1,C=!0;for(let S=n-1;S>=i;--S)if(h(t.charCodeAt(S))){if(!C){l=S;break}}else C=!1;if(l===-1){if(c===-1)return".";l=c}return t.slice(0,l)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let c=0,i=-1,a=!0,l;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(c=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let C=n.length-1,S=-1;for(l=t.length-1;l>=c;--l){const b=t.charCodeAt(l);if(h(b)){if(!a){c=l+1;break}}else S===-1&&(a=!1,S=l+1),C>=0&&(b===n.charCodeAt(C)?--C===-1&&(i=l):(C=-1,i=S))}return c===i?i=S:i===-1&&(i=t.length),t.slice(c,i)}for(l=t.length-1;l>=c;--l)if(h(t.charCodeAt(l))){if(!a){c=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(c,i)},extname(t){k(t,"path");let n=0,c=-1,i=0,a=-1,l=!0,C=0;t.length>=2&&t.charCodeAt(1)===L&&s(t.charCodeAt(0))&&(n=i=2);for(let S=t.length-1;S>=n;--S){const b=t.charCodeAt(S);if(h(b)){if(!l){i=S+1;break}continue}a===-1&&(l=!1,a=S+1),b===$?c===-1?c=S:C!==1&&(C=1):c!==-1&&(C=-1)}return c===-1||a===-1||C===0||C===1&&c===a-1&&c===i+1?"":t.slice(c,a)},format:m.bind(null,"\\"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const c=t.length;let i=0,a=t.charCodeAt(0);if(c===1)return h(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(h(a)){if(i=1,h(t.charCodeAt(1))){let P=2,N=P;for(;P<c&&!h(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&h(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&!h(t.charCodeAt(P));)P++;P===c?i=P:P!==N&&(i=P+1)}}}}else if(s(a)&&t.charCodeAt(1)===L){if(c<=2)return n.root=n.dir=t,n;if(i=2,h(t.charCodeAt(2))){if(c===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,C=i,S=-1,b=!0,g=t.length-1,d=0;for(;g>=i;--g){if(a=t.charCodeAt(g),h(a)){if(!b){C=g+1;break}continue}S===-1&&(b=!1,S=g+1),a===$?l===-1?l=g:d!==1&&(d=1):l!==-1&&(d=-1)}return S!==-1&&(l===-1||d===0||d===1&&l===S-1&&l===C+1?n.base=n.name=t.slice(C,S):(n.name=t.slice(C,l),n.base=t.slice(C,S),n.ext=t.slice(l,S))),C>0&&C!==i?n.dir=t.slice(0,C-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(p){const t=/\\/g;return()=>{const n=D.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let n="",c=!1;for(let i=t.length-1;i>=-1&&!c;i--){const a=i>=0?t[i]:u();k(a,"path"),a.length!==0&&(n=`${a}/${n}`,c=a.charCodeAt(0)===E)}return n=o(n,!c,"/",r),c?`/${n}`:n.length>0?n:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,c=t.charCodeAt(t.length-1)===E;return t=o(t,!n,"/",r),t.length===0?n?"/":c?"./":".":(c&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let c=0;c<t.length;++c){const i=t[c];k(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$gc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n||(t=e.$gc.resolve(t),n=e.$gc.resolve(n),t===n))return"";const c=1,i=t.length,a=i-c,l=1,C=n.length-l,S=a<C?a:C;let b=-1,g=0;for(;g<S;g++){const P=t.charCodeAt(c+g);if(P!==n.charCodeAt(l+g))break;P===E&&(b=g)}if(g===S)if(C>S){if(n.charCodeAt(l+g)===E)return n.slice(l+g+1);if(g===0)return n.slice(l+g)}else a>S&&(t.charCodeAt(c+g)===E?b=g:g===0&&(b=0));let d="";for(g=c+b+1;g<=i;++g)(g===i||t.charCodeAt(g)===E)&&(d+=d.length===0?"..":"/..");return`${d}${n.slice(l+b)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let c=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===E){if(!i){c=a;break}}else i=!1;return c===-1?n?"/":".":n&&c===1?"//":t.slice(0,c)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let c=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let C=n.length-1,S=-1;for(l=t.length-1;l>=0;--l){const b=t.charCodeAt(l);if(b===E){if(!a){c=l+1;break}}else S===-1&&(a=!1,S=l+1),C>=0&&(b===n.charCodeAt(C)?--C===-1&&(i=l):(C=-1,i=S))}return c===i?i=S:i===-1&&(i=t.length),t.slice(c,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===E){if(!a){c=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(c,i)},extname(t){k(t,"path");let n=-1,c=0,i=-1,a=!0,l=0;for(let C=t.length-1;C>=0;--C){const S=t.charCodeAt(C);if(S===E){if(!a){c=C+1;break}continue}i===-1&&(a=!1,i=C+1),S===$?n===-1?n=C:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===c+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const c=t.charCodeAt(0)===E;let i;c?(n.root="/",i=1):i=0;let a=-1,l=0,C=-1,S=!0,b=t.length-1,g=0;for(;b>=i;--b){const d=t.charCodeAt(b);if(d===E){if(!S){l=b+1;break}continue}C===-1&&(S=!1,C=b+1),d===$?a===-1?a=b:g!==1&&(g=1):a!==-1&&(g=-1)}if(C!==-1){const d=l===0&&c?1:l;a===-1||g===0||g===1&&a===C-1&&a===l+1?n.base=n.name=t.slice(d,C):(n.name=t.slice(d,a),n.base=t.slice(d,C),n.ext=t.slice(a,C))}return l>0?n.dir=t.slice(0,l-1):c&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(De[126],Ce([1,0,47,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const f=new D.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(S,b,g=!1){const d=S||"",P=b||"",N=f.value.collator.compare(d,P);return f.value.collatorIsNumeric&&N===0&&d!==P?d<P?-1:1:N}e.$hq=$;function E(S,b){const g=R.value.collator;return S=S||"",b=b||"",m(g,S,b)}e.$iq=E;function w(S,b){const g=R.value.collator;return S=S||"",b=b||"",c(S,b)||m(g,S,b)}e.$jq=w;function L(S,b){const g=R.value.collator;return S=S||"",b=b||"",n(S,b)||m(g,S,b)}e.$kq=L;function I(S,b){return S=S||"",b=b||"",S===b?0:S<b?-1:1}e.$lq=I;function v(S,b){const[g,d]=s(S),[P,N]=s(b);let F=f.value.collator.compare(d,N);if(F===0){if(f.value.collatorIsNumeric&&d!==N)return d<N?-1:1;if(F=f.value.collator.compare(g,P),f.value.collatorIsNumeric&&F===0&&g!==P)return g<P?-1:1}return F}e.$mq=v;function y(S,b){S=S||"",b=b||"";const g=o(S),d=o(b),P=R.value.collator,N=A.value.collator;return m(N,g,d)||m(P,S,b)}e.$nq=y;function k(S,b){S=S||"",b=b||"";const g=o(S),d=o(b),P=R.value.collator,N=A.value.collator;return m(N,g,d)||c(S,b)||m(P,S,b)}e.$oq=k;function p(S,b){S=S||"",b=b||"";const g=o(S),d=o(b),P=R.value.collator,N=A.value.collator;return m(N,g,d)||n(S,b)||m(P,S,b)}e.$pq=p;function h(S,b){S=S||"",b=b||"";const g=o(S).toLowerCase(),d=o(b).toLowerCase();return g!==d?g<d?-1:1:S!==b?S<b?-1:1:0}e.$qq=h;const r=/^(.*?)(\.([^.]*))?$/;function s(S,b=!1){const g=S?r.exec(S):[];let d=[g&&g[1]||"",g&&g[3]||""];return b&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function o(S){const b=S?r.exec(S):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function m(S,b,g){const d=S.compare(b,g);return d!==0?d:b.length!==g.length?b.length<g.length?-1:1:0}function u(S){const b=S.charAt(0);return b.toLocaleUpperCase()!==b}function t(S){const b=S.charAt(0);return b.toLocaleLowerCase()!==b}function n(S,b){return u(S)&&t(b)?-1:t(S)&&u(b)?1:0}function c(S,b){return t(S)&&u(b)?-1:u(S)&&t(b)?1:0}function i(S,b,g=!1){return g||(S=S&&S.toLowerCase(),b=b&&b.toLowerCase()),S===b?0:S<b?-1:1}function a(S,b,g=!1){const d=S.split(T.sep),P=b.split(T.sep),N=d.length-1,F=P.length-1;let M,U;for(let j=0;;j++){if(M=N===j,U=F===j,M&&U)return $(d[j],P[j],g);if(M)return-1;if(U)return 1;const O=i(d[j],P[j],g);if(O!==0)return O}}e.$rq=a;function l(S,b,g){const d=S.toLowerCase(),P=b.toLowerCase(),N=C(S,b,g);if(N)return N;const F=d.endsWith(g),M=P.endsWith(g);if(F!==M)return F?-1:1;const U=$(d,P);return U!==0?U:d.localeCompare(P)}e.$sq=l;function C(S,b,g){const d=S.toLowerCase(),P=b.toLowerCase(),N=d.startsWith(g),F=P.startsWith(g);if(N!==F)return N?-1:1;if(N&&F){if(d.length<P.length)return-1;if(d.length>P.length)return 1}return 0}e.$tq=C}),define(De[33],Ce([1,0,16,12,15,17]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(l){return l===47||l===92}e.$Qf=A;function $(l){return l.replace(/[\\/]/g,D.$gc.sep)}e.$Rf=$;function E(l){return l.indexOf("/")===-1&&(l=$(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Sf=E;function w(l,C=D.$gc.sep){if(!l)return"";const S=l.length,b=l.charCodeAt(0);if(A(b)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let d=3;const P=d;for(;d<S&&!A(l.charCodeAt(d));d++);if(P!==d&&!A(l.charCodeAt(d+1))){for(d+=1;d<S;d++)if(A(l.charCodeAt(d)))return l.slice(0,d+1).replace(/[\\/]/g,C)}}return C}else if(r(b)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+C:l.slice(0,2);let g=l.indexOf("://");if(g!==-1){for(g+=3;g<S;g++)if(A(l.charCodeAt(g)))return l.slice(0,g+1)}return""}e.$Tf=w;function L(l){if(!T.$j||!l||l.length<5)return!1;let C=l.charCodeAt(0);if(C!==92||(C=l.charCodeAt(1),C!==92))return!1;let S=2;const b=S;for(;S<l.length&&(C=l.charCodeAt(S),C!==92);S++);return!(b===S||(C=l.charCodeAt(S+1),isNaN(C)||C===92))}e.$Uf=L;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(l,C=T.$j){const S=C?I:v;return!(!l||l.length===0||/^\s+$/.test(l)||(S.lastIndex=0,S.test(l))||C&&y.test(l)||l==="."||l===".."||C&&l[l.length-1]==="."||C&&l.length!==l.trim().length||l.length>255)}e.$Vf=k;function p(l,C,S){const b=l===C;return!S||b?b:!l||!C?!1:(0,f.$2e)(l,C)}e.$Wf=p;function h(l,C,S,b=D.sep){if(l===C)return!0;if(!l||!C||C.length>l.length)return!1;if(S){if(!(0,f.$3e)(l,C))return!1;if(C.length===l.length)return!0;let d=C.length;return C.charAt(C.length-1)===b&&d--,l.charAt(d)===b}return C.charAt(C.length-1)!==b&&(C+=b),l.indexOf(C)===0}e.$Xf=h;function r(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Yf=r;function s(l,C){return T.$j&&l.endsWith(":")&&(l+=D.sep),(0,D.$ic)(l)||(l=(0,D.$jc)(C,l)),l=(0,D.$hc)(l),T.$j?(l=(0,f.$Ke)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,f.$Ke)(l,D.sep),l||(l=D.sep)),l}e.$Zf=s;function o(l){const C=(0,D.$hc)(l);return T.$j?l.length>3?!1:m(C)&&(l.length===2||C.charCodeAt(2)===92):C===D.$gc.sep}e.$1f=o;function m(l,C=T.$j){return C?r(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$2f=m;function u(l,C=T.$j){return m(l,C)?l[0]:void 0}e.$3f=u;function t(l,C,S){return C.length>l.length?-1:l===C?0:(S&&(l=l.toLowerCase(),C=C.toLowerCase()),l.indexOf(C))}e.$4f=t;function n(l){const C=l.split(":");let S,b,g;for(const d of C){const P=Number(d);(0,R.$Cf)(P)?b===void 0?b=P:g===void 0&&(g=P):S=S?[S,d].join(":"):d}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:b!==void 0?b:void 0,column:g!==void 0?g:b!==void 0?1:void 0}}e.$5f=n;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,C,S=8){let b="";for(let d=0;d<S;d++){let P;d===0&&T.$j&&!C&&(S===3||S===4)?P=i:P=c,b+=P.charAt(Math.floor(Math.random()*P.length))}let g;return C?g=`${C}-${b}`:g=b,l?(0,D.$jc)(l,g):g}e.$6f=a}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=void 0;const E=0,w=[E,[]];function L(K,V,me,te){if(!K||!V)return w;const G=K.length,Q=V.length;if(G<Q)return w;const le=K.toLowerCase();return I(V,me,Q,K,le,G,te)}e.$uq=L;function I(K,V,me,te,G,Q,le){const ie=[],ce=[];for(let X=0;X<me;X++){const re=X*Q,Y=re-Q,_=X>0,x=K[X],ve=V[X];for(let ae=0;ae<Q;ae++){const fe=ae>0,ee=re+ae,de=ee-1,be=Y+ae-1,Pe=fe?ie[de]:0,z=_&&fe?ie[be]:0,J=_&&fe?ce[be]:0;let se;!z&&_?se=0:se=v(x,ve,te,G,ae,J),se&&z+se>=Pe&&(le||_||G.startsWith(V,ae))?(ce[ee]=J+1,ie[ee]=z+se):(ce[ee]=E,ie[ee]=Pe)}}const pe=[];let H=me-1,B=Q-1;for(;H>=0&&B>=0;){const X=H*Q+B;ce[X]===E||(pe.push(B),H--),B--}return[ie[me*Q-1],pe.reverse()]}function v(K,V,me,te,G,Q){let le=0;if(!y(V,te[G]))return le;if(le+=1,Q>0&&(le+=Q*5),K===me[G]&&(le+=1),G===0)le+=8;else{const ie=k(me.charCodeAt(G-1));ie?le+=ie:(0,T.$Gj)(me.charCodeAt(G))&&Q===0&&(le+=2)}return le}function y(K,V){return K===V?!0:K==="/"||K==="\\"?V==="/"||V==="\\":!1}function k(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function h(K,V,me=0,te=0){const G=V;return G.values&&G.values.length>1?r(K,G.values,me,te):s(K,V,me,te)}e.$vq=h;function r(K,V,me,te){let G=0;const Q=[];for(const le of V){const[ie,ce]=s(K,le,me,te);if(typeof ie!="number")return p;G+=ie,Q.push(...ce)}return[G,S(Q)]}function s(K,V,me,te){const G=(0,T.$Pj)(V.original,V.originalLowercase,me,K,K.toLowerCase(),te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,T.$Mj)(G)]:p}const o=Object.freeze({score:0}),m=1<<18,u=1<<17,t=1<<16;function n(K,V,me,te){const G=te.values?te.values:[te];return(0,f.$Di)({[te.normalized]:{values:G.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:K,description:V,allowNonContiguousMatches:me}})}function c(K,V,me,te,G){if(!K||!V.normalized)return o;const Q=te.getItemLabel(K);if(!Q)return o;const le=te.getItemDescription(K),ie=n(Q,le,me,V),ce=G[ie];if(ce)return ce;const pe=i(Q,le,te.getItemPath(K),V,me);return G[ie]=pe,pe}e.$wq=c;function i(K,V,me,te,G){const Q=!me||!te.containsPathSeparator;return me&&(A.$l?te.pathNormalized===me:(0,$.$2e)(te.pathNormalized,me))?{score:m,labelMatch:[{start:0,end:K.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:te.values&&te.values.length>1?a(K,V,me,te.values,Q,G):l(K,V,me,te,Q,G)}function a(K,V,me,te,G,Q){let le=0;const ie=[],ce=[];for(const pe of te){const{score:H,labelMatch:B,descriptionMatch:X}=l(K,V,me,pe,G,Q);if(H===E)return o;le+=H,B&&ie.push(...B),X&&ce.push(...X)}return{score:le,labelMatch:S(ie),descriptionMatch:S(ce)}}function l(K,V,me,te,G,Q){if(G||!V){const[le,ie]=L(K,te.normalized,te.normalizedLowercase,Q&&!te.expectContiguousMatch);if(le){const ce=(0,T.$Dj)(te.normalized,K);let pe;if(ce){pe=u;const H=Math.round(te.normalized.length/K.length*100);pe+=H}else pe=t;return{score:pe+le,labelMatch:ce||C(ie)}}}if(V){let le=V;me&&(le=`${V}${R.sep}`);const ie=le.length,ce=`${le}${K}`,[pe,H]=L(ce,te.normalized,te.normalizedLowercase,Q&&!te.expectContiguousMatch);if(pe){const B=C(H),X=[],re=[];return B.forEach(Y=>{Y.start<ie&&Y.end>ie?(X.push({start:0,end:Y.end-ie}),re.push({start:Y.start,end:ie})):Y.start>=ie?X.push({start:Y.start-ie,end:Y.end-ie}):re.push(Y)}),{score:pe,labelMatch:X,descriptionMatch:re}}}return o}function C(K){const V=[];if(!K)return V;let me;for(const te of K)me&&me.end===te?me.end+=1:(me={start:te,end:te+1},V.push(me));return V}function S(K){const V=K.sort((G,Q)=>G.start-Q.start),me=[];let te;for(const G of V)!te||!b(te,G)?(te=G,me.push(G)):(te.start=Math.min(te.start,G.start),te.end=Math.max(te.end,G.end));return me}function b(K,V){return!(K.end<V.start||V.end<K.start)}function g(K,V,me,te,G,Q){const le=c(K,me,te,G,Q),ie=c(V,me,te,G,Q),ce=le.score,pe=ie.score;if((ce===m||pe===m)&&ce!==pe)return ce===m?-1:1;if(ce>t||pe>t){if(ce!==pe)return ce>pe?-1:1;if(ce<u&&pe<u){const x=P(le.labelMatch,ie.labelMatch);if(x!==0)return x}const Y=G.getItemLabel(K)||"",_=G.getItemLabel(V)||"";if(Y.length!==_.length)return Y.length-_.length}if(ce!==pe)return ce>pe?-1:1;const H=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(H&&!B)return-1;if(B&&!H)return 1;const X=d(K,le,G),re=d(V,ie,G);return X&&re&&X!==re?re>X?-1:1:N(K,V,me,G)}e.$xq=g;function d(K,V,me){let te=-1,G=-1;if(V.descriptionMatch&&V.descriptionMatch.length?te=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(te=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(G=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const Q=me.getItemDescription(K);Q&&(G+=Q.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(G=V.descriptionMatch[V.descriptionMatch.length-1].end);return G-te}function P(K,V){if(!K&&!V||(!K||!K.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!K||!K.length)return 1;const me=K[0].start,G=K[K.length-1].end-me,Q=V[0].start,ie=V[V.length-1].end-Q;return G===ie?0:ie<G?1:-1}function N(K,V,me,te){const G=te.getItemLabel(K)||"",Q=te.getItemLabel(V)||"",le=te.getItemDescription(K),ie=te.getItemDescription(V),ce=G.length+(le?le.length:0),pe=Q.length+(ie?ie.length:0);if(ce!==pe)return ce-pe;const H=te.getItemPath(K),B=te.getItemPath(V);return H&&B&&H.length!==B.length?H.length-B.length:G!==Q?(0,D.$sq)(G,Q,me.normalized):le&&ie&&le!==ie?(0,D.$sq)(le,ie,me.normalized):H&&B&&H!==B?(0,D.$sq)(H,B,me.normalized):0}function F(K){return K.startsWith('"')&&K.endsWith('"')}const M=" ";function U(K){typeof K!="string"&&(K="");const V=K.toLowerCase(),{pathNormalized:me,normalized:te,normalizedLowercase:G}=j(K),Q=me.indexOf(R.sep)>=0,le=F(K);let ie;const ce=K.split(M);if(ce.length>1)for(const pe of ce){const H=F(pe),{pathNormalized:B,normalized:X,normalizedLowercase:re}=j(pe);X&&(ie||(ie=[]),ie.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:B,normalized:X,normalizedLowercase:re,expectContiguousMatch:H}))}return{original:K,originalLowercase:V,pathNormalized:me,normalized:te,normalizedLowercase:G,values:ie,containsPathSeparator:Q,expectContiguousMatch:le}}e.$yq=U;function j(K){let V;A.$j?V=K.replace(/\//g,R.sep):V=K.replace(/\\/g,R.sep);const me=(0,$.$Me)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:me,normalizedLowercase:me.toLowerCase()}}function O(K){return Array.isArray(K)?U(K.map(V=>V.original).join(M)):U(K.original)}e.$zq=O}),define(De[97],Ce([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0,e.$Pr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const I=(0,D.$oc)(L),v=T[I.toLowerCase()];return v!==void 0?v:A(L)}e.$Qr=R;function A(L){const I=(0,D.$oc)(L);return f[I.toLowerCase()]}e.$Rr=A;function $(L){for(const I in f)if(f[I]===L)return I}e.$Sr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function w(L,I){const v=E.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:L}e.$Tr=w}),define(De[98],Ce([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var T;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(T||(e.Source=T={}));var f;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R($,...E){const w=E.reduce((v,y)=>(v[y]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys($).filter(v=>!w[v]).forEach(v=>{for(let y=0;y<L.length;y++)if(v.search(L[y])!==-1){delete $[v];break}})}e.$zl=R;function A($){$&&(delete $.DEBUG,D.$k&&delete $.DYLD_LIBRARY_PATH,D.$l&&delete $.LD_PRELOAD)}e.$Al=A}),define(De[2],Ce([1,0,16,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function $(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!f.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,a){return!i&&!a?"file":i}function w(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const L="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,C,S,b,g=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=E(a,g),this.authority=l||L,this.path=w(this.scheme,C||L),this.query=S||L,this.fragment=b||L,$(this,g))}get fsPath(){return m(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:C,path:S,query:b,fragment:g}=a;return l===void 0?l=this.scheme:l===null&&(l=L),C===void 0?C=this.authority:C===null&&(C=L),S===void 0?S=this.path:S===null&&(S=L),b===void 0?b=this.query:b===null&&(b=L),g===void 0?g=this.fragment:g===null&&(g=L),l===this.scheme&&C===this.authority&&S===this.path&&b===this.query&&g===this.fragment?this:new h(l,C,S,b,g)}static parse(a,l=!1){const C=v.exec(a);return C?new h(C[2]||L,c(C[4]||L),c(C[5]||L),c(C[7]||L),c(C[9]||L),l):new h(L,L,L,L,L)}static file(a){let l=L;if(T.$j&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const C=a.indexOf(I,2);C===-1?(l=a.substring(2),a=I):(l=a.substring(2,C),a=a.substring(C)||I)}return new h("file",l,a,L,L)}static from(a,l){return new h(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return T.$j&&a.scheme==="file"?C=y.file(D.$fc.join(m(a,!0),...l)).path:C=D.$gc.join(a.path,...l),a.with({path:C})}toString(a=!1){return u(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const l=new h(a);return l._formatted=a.external??null,l._fsPath=a._sep===p?a.fsPath??null:null,l}}else return a}}e.URI=y;function k(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=k;const p=T.$j?1:void 0;class h extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(a=!1){return a?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(i,a,l){let C,S=-1;for(let b=0;b<i.length;b++){const g=i.charCodeAt(b);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||l&&g===91||l&&g===93||l&&g===58)S!==-1&&(C+=encodeURIComponent(i.substring(S,b)),S=-1),C!==void 0&&(C+=i.charAt(b));else{C===void 0&&(C=i.substr(0,b));const d=r[g];d!==void 0?(S!==-1&&(C+=encodeURIComponent(i.substring(S,b)),S=-1),C+=d):S===-1&&(S=b)}}return S!==-1&&(C+=encodeURIComponent(i.substring(S))),C!==void 0?C:i}function o(i){let a;for(let l=0;l<i.length;l++){const C=i.charCodeAt(l);C===35||C===63?(a===void 0&&(a=i.substr(0,l)),a+=r[C]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function m(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,T.$j&&(l=l.replace(/\//g,"\\")),l}e.$wc=m;function u(i,a){const l=a?o:s;let C="",{scheme:S,authority:b,path:g,query:d,fragment:P}=i;if(S&&(C+=S,C+=":"),(b||S==="file")&&(C+=I,C+=I),b){let N=b.indexOf("@");if(N!==-1){const F=b.substr(0,N);b=b.substr(N+1),N=F.lastIndexOf(":"),N===-1?C+=l(F,!1,!1):(C+=l(F.substr(0,N),!1,!1),C+=":",C+=l(F.substr(N+1),!1,!0)),C+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?C+=l(b,!1,!0):(C+=l(b.substr(0,N),!1,!0),C+=b.substr(N))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const N=g.charCodeAt(1);N>=65&&N<=90&&(g=`/${String.fromCharCode(N+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const N=g.charCodeAt(0);N>=65&&N<=90&&(g=`${String.fromCharCode(N+32)}:${g.substr(2)}`)}C+=l(g,!0,!1)}return d&&(C+="?",C+=l(d,!1,!1)),P&&(C+="#",C+=a?P:s(P,!1,!1)),C}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(De[181],Ce([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Zp=e.$Yp=e.$Xp=void 0;function T(w){const L=w;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$Xp=T;function f(w){const L=[];let I;try{const v=JSON.parse(w.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),I=y.__$stack),L.push(...v)}catch{L.push("Unable to log remote console arguments",w.arguments)}return{args:L,stack:I}}e.$Yp=f;function R(w){if(typeof w!="string")return R(f(w).stack);const L=w;if(L){const I=A(L),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Zp=R;function A(w){if(!w)return w;const L=w.indexOf(`
`);return L===-1?w:w.substring(0,L)}function $(w,L){const{args:I,stack:v}=f(w),y=typeof I[0]=="string"&&I.length===1;let k=A(v);k&&(k=`(${k.trim()})`);let p=[];if(typeof I[0]=="string"?k&&y?p=[`%c[${L}] %c${I[0]} %c${k}`,E("blue"),E(""),E("grey")]:p=[`%c[${L}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${L}]%`,E("blue"),...I],k&&!y&&p.push(k),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,p)}e.log=$;function E(w){return`color: ${w}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function f(E){return JSON.stringify(E,A)}e.$kh=f;function R(E){let w=JSON.parse(E);return w=$(w),w}e.$lh=R;function A(E,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function $(E,w=0){if(!E||w>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof D.$be||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let L=0;L<E.length;++L)E[L]=$(E[L],w+1);else for(const L in E)Object.hasOwnProperty.call(E,L)&&(E[L]=$(E[L],w+1))}return E}e.$mh=$}),define(De[18],Ce([1,0,9,12,2]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,I,v){this.a[L]=I,this.b[L]=v}setConnectionToken(L,I){this.c[L]=I}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(h){return D.$1(h),L}const I=L.authority;let v=this.a[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const y=this.b[I],k=this.c[I];let p=`path=${encodeURIComponent(L.path)}`;return typeof k=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(k)}`),f.URI.from({scheme:T.$p?this.d:R.vscodeRemoteResource,authority:`${v}:${y}`,path:this.f,query:p})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class ${static{this.a=e.$bg}asBrowserUri(L){const I=this.b(L,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.$9f.rewrite(L):L.scheme===R.file&&(T.$n||T.$q&&T.$h.origin===`${R.vscodeFileResource}://${$.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||$.a,query:null,fragment:null}):L}asFileUri(L){const I=this.b(L,$e);return this.uriToFileUri(I)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==$.a?L.authority:null,query:null,fragment:null}):L}b(L,I){return f.URI.isUri(L)?L:f.URI.parse(I.toUrl(L))}}e.$cg=new $;var E;(function(w){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(L.get("3"));const I="vscode-coi";function v(k){let p;typeof k=="string"?p=new URL(k).searchParams:k instanceof URL?p=k.searchParams:f.URI.isUri(k)&&(p=new URL(k.toString(!0)).searchParams);const h=p?.get(I);if(h)return L.get(h)}w.getHeadersFromQuery=v;function y(k,p,h){if(!globalThis.crossOriginIsolated)return;const r=p&&h?"3":h?"2":"1";k instanceof URLSearchParams?k.set(I,r):k[I]=r}w.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,18,12,2]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class A{constructor(v,y,k){this.id=v,this.dependencies=y,this.callback=k}}class ${static{this.INSTANCE=new $}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,y,k)=>{typeof v!="string"&&(k=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new A(v,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const y=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(v){return new Promise((y,k)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const h=()=>{p.removeEventListener("load",r),p.removeEventListener("error",s)},r=o=>{h(),y(this.c.pop())},s=o=>{h(),k(o)};p.addEventListener("load",r),p.addEventListener("error",s),this.f&&(v=this.f.createScriptURL(v)),p.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(p)})}i(v){return new Promise((y,k)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),y(this.c.pop())}catch(p){k(p)}})}async j(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,h=R.URI.parse(v).fsPath,r=y.readFileSync(h).toString(),s=p.wrap(r.replace(/^#!.*/,""));return new k.Script(s).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function L(I,v,y){if(D.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const k=`${I}/${v}`;if(E.has(k))return E.get(k);let p;if(/^\w[\w\d+.-]*:\/\//.test(k))p=k;else{const o=`${y&&!f.$p?T.$_f:T.$$f}/${k}`;p=T.$cg.asBrowserUri(o).toString(!0)}const h=$.INSTANCE.load(p);return E.set(k,h),h}else return await new Promise((k,p)=>{$e([I],k,p)})}e.$vC=L}),define(De[23],Ce([1,0,33,18,16,12,15,2]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function E(y){return(0,$.$wc)(y,!0)}e.$jg=E;class w{constructor(k){this.a=k}compare(k,p,h=!1){return k===p?0:(0,A.$Ue)(this.getComparisonKey(k,h),this.getComparisonKey(p,h))}isEqual(k,p,h=!1){return k===p?!0:!k||!p?!1:this.getComparisonKey(k,h)===this.getComparisonKey(p,h)}getComparisonKey(k,p=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,p,h=!1){if(k.scheme===p.scheme){if(k.scheme===T.Schemas.file)return D.$Xf(E(k),E(p),this.a(k))&&k.query===p.query&&(h||k.fragment===p.fragment);if((0,e.$Ag)(k.authority,p.authority))return D.$Xf(k.path,p.path,this.a(k),"/")&&k.query===p.query&&(h||k.fragment===p.fragment)}return!1}joinPath(k,...p){return $.URI.joinPath(k,...p)}basenameOrAuthority(k){return(0,e.$sg)(k)||k.authority}basename(k){return f.$gc.basename(k.path)}extname(k){return f.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let p;return k.scheme===T.Schemas.file?p=$.URI.file(f.$mc(E(k))).path:(p=f.$gc.dirname(k.path),k.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),p="/")),k.with({path:p})}normalizePath(k){if(!k.path.length)return k;let p;return k.scheme===T.Schemas.file?p=$.URI.file(f.$hc(E(k))).path:p=f.$gc.normalize(k.path),k.with({path:p})}relativePath(k,p){if(k.scheme!==p.scheme||!(0,e.$Ag)(k.authority,p.authority))return;if(k.scheme===T.Schemas.file){const s=f.$lc(E(k),E(p));return R.$j?D.$Rf(s):s}let h=k.path||"/";const r=p.path||"/";if(this.a(k)){let s=0;for(const o=Math.min(h.length,r.length);s<o&&!(h.charCodeAt(s)!==r.charCodeAt(s)&&h.charAt(s).toLowerCase()!==r.charAt(s).toLowerCase());s++);h=r.substr(0,s)+h.substr(s)}return f.$gc.relative(h,r)}resolvePath(k,p){if(k.scheme===T.Schemas.file){const h=$.URI.file(f.$kc(E(k),p));return k.with({authority:h.authority,path:h.path})}return p=D.$Sf(p),k.with({path:f.$gc.resolve(k.path,p)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,p){return k===p||k!==void 0&&p!==void 0&&(0,A.$2e)(k,p)}hasTrailingPathSeparator(k,p=f.sep){if(k.scheme===T.Schemas.file){const h=E(k);return h.length>D.$Tf(h).length&&h[h.length-1]===p}else{const h=k.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,p=f.sep){return(0,e.$Bg)(k,p)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,p=f.sep){let h=!1;if(k.scheme===T.Schemas.file){const r=E(k);h=r!==void 0&&r.length===D.$Tf(r).length&&r[r.length-1]===p}else{p="/";const r=k.path;h=r.length===1&&r.charCodeAt(r.length-1)===47}return!h&&!(0,e.$Bg)(k,p)?k.with({path:k.path+"/"}):k}}e.$kg=w,e.$lg=new w(()=>!1),e.$mg=new w(y=>y.scheme===T.Schemas.file?!R.$l:!0),e.$ng=new w(y=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function L(y,k){const p=[];for(let h=0;h<y.length;h++){const r=k(y[h]);y.some((s,o)=>o===h?!1:(0,e.$pg)(r,k(s)))||p.push(y[h])}return p}e.$Eg=L;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,u]=o.split(":");m&&u&&h.set(m,u)});const s=p.path.substring(0,p.path.indexOf(";"));return s&&h.set(y.META_DATA_MIME,s),h}y.parseMetaData=k})(I||(e.DataUri=I={}));function v(y,k,p){if(k){let h=y.path;return h&&h[0]!==f.$gc.sep&&(h=f.$gc.sep+h),y.with({scheme:p,authority:k,path:h})}return y.with({scheme:p})}e.$Fg=v}),define(De[8],Ce([1,0,21,9,4,3,23,12,160]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function w(X){return!!X&&typeof X.then=="function"}e.$Gg=w;function L(X){const re=new D.$Xd,Y=X(re.token),_=new Promise((x,ve)=>{const ae=re.token.onCancellationRequested(()=>{ae.dispose(),re.dispose(),ve(new T.$5)});Promise.resolve(Y).then(fe=>{ae.dispose(),re.dispose(),x(fe)},fe=>{ae.dispose(),re.dispose(),ve(fe)})});return new class{cancel(){re.cancel()}then(x,ve){return _.then(x,ve)}catch(x){return this.then(void 0,x)}finally(x){return _.finally(x)}}}e.$Hg=L;function I(X,re,Y){return new Promise((_,x)=>{const ve=re.onCancellationRequested(()=>{ve.dispose(),_(Y)});X.then(_,x).finally(()=>ve.dispose())})}e.$Ig=I;function v(X,re){return new Promise((Y,_)=>{const x=re.onCancellationRequested(()=>{x.dispose(),_(new T.$5)});X.then(Y,_).finally(()=>x.dispose())})}e.$Jg=v;async function y(X){let re=-1;const Y=X.map((_,x)=>_.then(ve=>(re=x,ve)));try{return await Promise.race(Y)}finally{X.forEach((_,x)=>{x!==re&&_.cancel()})}}e.$Kg=y;function k(X,re,Y){let _;const x=setTimeout(()=>{_?.(void 0),Y?.()},re);return Promise.race([X.finally(()=>clearTimeout(x)),new Promise(ve=>_=ve)])}e.$Lg=k;function p(X){return new Promise((re,Y)=>{const _=X();w(_)?_.then(re,Y):re(_)})}e.$Mg=p;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const Y=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(Y,Y).then(_)})}return new Promise((Y,_)=>{this.b.then(Y,_)})}return this.a=re(),new Promise((Y,_)=>{this.a.then(x=>{this.a=null,Y(x)},x=>{this.a=null,_(x)})})}dispose(){this.f=!0}}e.$Ng=h;class r{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Og=r;class s{constructor(){this.a=new Map}queue(re,Y){const x=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(re)===x&&this.a.delete(re)});return this.a.set(re,x),x}}e.$Pg=s;const o=(X,re)=>{let Y=!0;const _=setTimeout(()=>{Y=!1,re()},X);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(_),Y=!1}}},m=X=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,X())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class u{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,Y=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((x,ve)=>{this.d=x,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=Y===E.$Kd?m(_):o(Y,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=u;class t{constructor(re){this.a=new u(re),this.b=new h}trigger(re,Y){return this.a.trigger(()=>this.b.queue(re),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=t;class n{constructor(){this.a=!1,this.b=new Promise((re,Y)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=n;class c extends n{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function i(X,re){return re?new Promise((Y,_)=>{const x=setTimeout(()=>{ve.dispose(),Y()},X),ve=re.onCancellationRequested(()=>{clearTimeout(x),ve.dispose(),_(new T.$5)})}):L(Y=>i(X,Y))}e.$Ug=i;function a(X,re=0,Y){const _=setTimeout(()=>{X(),Y&&x.dispose()},re),x=(0,R.$Qc)(()=>{clearTimeout(_),Y?.deleteAndLeak(x)});return Y?.add(x),x}e.$Vg=a;function l(X){const re=[];let Y=0;const _=X.length;function x(){return Y<_?X[Y++]():null}function ve(ae){ae!=null&&re.push(ae);const fe=x();return fe?fe.then(ve):Promise.resolve(re)}return Promise.resolve(null).then(ve)}e.$Wg=l;function C(X,re=_=>!!_,Y=null){let _=0;const x=X.length,ve=()=>{if(_>=x)return Promise.resolve(Y);const ae=X[_++];return Promise.resolve(ae()).then(ee=>re(ee)?Promise.resolve(ee):ve())};return ve()}e.$Xg=C;function S(X,re=_=>!!_,Y=null){if(X.length===0)return Promise.resolve(Y);let _=X.length;const x=()=>{_=-1;for(const ve of X)ve.cancel?.()};return new Promise((ve,ae)=>{for(const fe of X)fe.then(ee=>{--_>=0&&re(ee)?(x(),ve(ee)):_===0&&ve(Y)}).catch(ee=>{--_>=0&&(x(),ae(ee))})})}e.$Yg=S;class b{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new f.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((Y,_)=>{this.f.push({factory:re,c:Y,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const Y=re.factory();Y.then(re.c,re.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=b;class g extends b{constructor(){super(1)}}e.$1g=g;class d{constructor(){this.a=new me,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$2g=d;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new Q;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,Y=A.$lg){const _=Y.getComparisonKey(re);let x=this.a.get(_);if(!x){x=new g;const ve=this.f++,ae=f.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(ve,ae),this.a.set(_,x)}return x}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class N{constructor(re,Y){this.a=-1,typeof re=="function"&&typeof Y=="number"&&this.setIfNotSet(re,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},Y)}setIfNotSet(re,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},Y))}}e.$4g=N;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setInterval(()=>{re()},Y)}}e.$5g=F;class M{constructor(re,Y){this.b=-1,this.a=re,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=M;class U{constructor(re,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=re,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=U;class j extends M{constructor(re,Y){super(re,Y),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$8g=j;class O extends R.$Sc{constructor(re,Y){super(),this.g=re,this.h=Y,this.a=[],this.b=this.B(new R.$Tc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of re)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=X=>{(0,$.$B)(()=>{if(re)return;const Y=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$0g=(X,re)=>{const Y=requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(Y))}}}}();class K{constructor(re){this.d=!1,this.a=()=>{try{this.f=re()}catch(Y){this.g=Y}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=K;async function V(X,re,Y){let _;for(let x=0;x<Y;x++)try{return await X()}catch(ve){_=ve,await i(re)}throw _}e.$_g=V;class me{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,Y,_){return this.a={taskId:re,cancel:()=>_?.(),promise:Y},Y.then(()=>this.d(re),()=>this.d(re)),Y}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let Y,_;const x=new Promise((ve,ae)=>{Y=ve,_=ae});this.b={run:re,promise:x,promiseResolve:Y,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=me;class te{constructor(re,Y=()=>Date.now()){this.d=re,this.f=Y,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$bh=te;var G;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(G||(G={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,Y)=>{this.a=re,this.b=Y})}complete(re){return new Promise(Y=>{this.a(re),this.d={outcome:0,value:re},Y()})}error(re){return new Promise(Y=>{this.b(re),this.d={outcome:1,value:re},Y()})}cancel(){return this.error(new T.$5)}}e.$ch=Q;var le;(function(X){async function re(_){let x;const ve=await Promise.all(_.map(ae=>ae.then(fe=>fe,fe=>{x||(x=fe)})));if(typeof x<"u")throw x;return ve}X.settled=re;function Y(_){return new Promise(async(x,ve)=>{try{await _(x,ve)}catch(ae){ve(ae)}})}X.withAsyncBody=Y})(le||(e.Promises=le={}));var ie;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ie||(ie={}));class ce{static fromArray(re){return new ce(Y=>{Y.emitMany(re)})}static fromPromise(re){return new ce(async Y=>{Y.emitMany(await re)})}static fromPromises(re){return new ce(async Y=>{await Promise.all(re.map(async _=>Y.emitOne(await _)))})}static merge(re){return new ce(async Y=>{await Promise.all(re.map(async _=>{for await(const x of _)Y.emitOne(x)}))})}static{this.EMPTY=ce.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new f.$Nd,queueMicrotask(async()=>{const Y={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(re(Y)),this.j()}catch(_){this.k(_)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(re,Y){return new ce(async _=>{for await(const x of re)_.emitOne(Y(x))})}map(re){return ce.map(this,re)}static filter(re,Y){return new ce(async _=>{for await(const x of re)Y(x)&&_.emitOne(x)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,Y=>!!Y)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const Y=[];for await(const _ of re)Y.push(_);return Y}toPromise(){return ce.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$dh=ce;class pe extends ce{constructor(re,Y){super(Y),this.l=re}cancel(){this.l.cancel()}}e.$eh=pe;function H(X){const re=new D.$Xd,Y=X(re.token);return new pe(re,async _=>{const x=re.token.onCancellationRequested(()=>{x.dispose(),re.dispose(),_.reject(new T.$5)});try{for await(const ve of Y){if(re.token.isCancellationRequested)return;_.emitOne(ve)}x.dispose(),re.dispose()}catch(ve){x.dispose(),re.dispose(),_.reject(ve)}})}e.$fh=H;class B{constructor(){this.a=new Q,this.b=new ce(_=>{if(re){_.reject(re);return}return Y&&_.emitMany(Y),this.d=x=>_.reject(x),this.f=x=>_.emitOne(x),this.a.p});let re,Y;this.f=_=>{Y||(Y=[]),Y.push(_)},this.d=_=>{re||(re=_)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(re){this.d(re),this.a.complete()}emit(re){this.f(re)}}e.$gh=B}),define(De[36],Ce([1,0,19,8,33,28,16,12,15]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function w(){return Object.create(null)}e.$rj=w,e.$sj="**",e.$tj="/";const L="[/\\\\]",I="[^/\\\\]",v=/\//g;function y(me,te){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${te?`|${L}${I}+`:""})*?`}}function k(me,te){if(!me)return[];const G=[];let Q=!1,le=!1,ie="";for(const ce of me){switch(ce){case te:if(!Q&&!le){G.push(ie),ie="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":le=!0;break;case"]":le=!1;break}ie+=ce}return ie&&G.push(ie),G}e.$uj=k;function p(me){if(!me)return"";let te="";const G=k(me,e.$tj);if(G.every(Q=>Q===e.$sj))te=".*";else{let Q=!1;G.forEach((le,ie)=>{if(le===e.$sj){if(Q)return;te+=y(2,ie===G.length-1)}else{let ce=!1,pe="",H=!1,B="";for(const X of le){if(X!=="}"&&ce){pe+=X;continue}if(H&&(X!=="]"||!B)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!B?re="^":X===e.$tj?re="":re=(0,E.$Fe)(X),B+=re;continue}switch(X){case"{":ce=!0;continue;case"[":H=!0;continue;case"}":{const Y=`(?:${k(pe,",").map(_=>p(_)).join("|")})`;te+=Y,ce=!1,pe="";break}case"]":{te+="["+B+"]",H=!1,B="";break}case"?":te+=I;continue;case"*":te+=y(1);continue;default:te+=(0,E.$Fe)(X)}}ie<G.length-1&&(G[ie+1]!==e.$sj||ie+2<G.length)&&(te+=L)}Q=le===e.$sj})}return te}const h=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),n=function(){return!1},c=function(){return null};function i(me,te){if(!me)return c;let G;typeof me!="string"?G=me.pattern:G=me,G=G.trim();const Q=`${G}_${!!te.trimForExclusions}`;let le=t.get(Q);if(le)return a(le,me);let ie;return h.test(G)?le=C(G.substr(4),G):(ie=r.exec(l(G,te)))?le=S(ie[1],G):(te.trimForExclusions?o:s).test(G)?le=b(G,te):(ie=m.exec(l(G,te)))?le=g(ie[1].substr(1),G,!0):(ie=u.exec(l(G,te)))?le=g(ie[1],G,!1):le=d(G),t.set(Q,le),a(le,me)}function a(me,te){if(typeof te=="string")return me;const G=function(Q,le){return(0,f.$Xf)(Q,te.base,!$.$l)?me((0,E.$Je)(Q.substr(te.base.length),A.sep),le):null};return G.allBasenames=me.allBasenames,G.allPaths=me.allPaths,G.basenames=me.basenames,G.patterns=me.patterns,G}function l(me,te){return te.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function C(me,te){return function(G,Q){return typeof G=="string"&&G.endsWith(me)?te:null}}function S(me,te){const G=`/${me}`,Q=`\\${me}`,le=function(ce,pe){return typeof ce!="string"?null:pe?pe===me?te:null:ce===me||ce.endsWith(G)||ce.endsWith(Q)?te:null},ie=[me];return le.basenames=ie,le.patterns=[te],le.allBasenames=ie,le}function b(me,te){const G=K(me.slice(1,-1).split(",").map(pe=>i(pe,te)).filter(pe=>pe!==c),me),Q=G.length;if(!Q)return c;if(Q===1)return G[0];const le=function(pe,H){for(let B=0,X=G.length;B<X;B++)if(G[B](pe,H))return me;return null},ie=G.find(pe=>!!pe.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((pe,H)=>H.allPaths?pe.concat(H.allPaths):pe,[]);return ce.length&&(le.allPaths=ce),le}function g(me,te,G){const Q=A.sep===A.$gc.sep,le=Q?me:me.replace(v,A.sep),ie=A.sep+le,ce=A.$gc.sep+me;let pe;return G?pe=function(H,B){return typeof H=="string"&&(H===le||H.endsWith(ie)||!Q&&(H===me||H.endsWith(ce)))?te:null}:pe=function(H,B){return typeof H=="string"&&(H===le||!Q&&H===me)?te:null},pe.allPaths=[(G?"*/":"./")+me],pe}function d(me){try{const te=new RegExp(`^${p(me)}$`);return function(G){return te.lastIndex=0,typeof G=="string"&&te.test(G)?me:null}}catch{return c}}function P(me,te,G){return!me||typeof te!="string"?!1:N(me)(te,void 0,G)}e.$vj=P;function N(me,te={}){if(!me)return n;if(typeof me=="string"||F(me)){const G=i(me,te);if(G===c)return n;const Q=function(le,ie){return!!G(le,ie)};return G.allBasenames&&(Q.allBasenames=G.allBasenames),G.allPaths&&(Q.allPaths=G.allPaths),Q}return j(me,te)}e.$wj=N;function F(me){const te=me;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.$xj=F;function M(me){return me.allBasenames||[]}e.$yj=M;function U(me){return me.allPaths||[]}e.$zj=U;function j(me,te){const G=K(Object.getOwnPropertyNames(me).map(pe=>O(pe,me[pe],te)).filter(pe=>pe!==c)),Q=G.length;if(!Q)return c;if(!G.some(pe=>!!pe.requiresSiblings)){if(Q===1)return G[0];const pe=function(X,re){let Y;for(let _=0,x=G.length;_<x;_++){const ve=G[_](X,re);if(typeof ve=="string")return ve;(0,T.$Gg)(ve)&&(Y||(Y=[]),Y.push(ve))}return Y?(async()=>{for(const _ of Y){const x=await _;if(typeof x=="string")return x}return null})():null},H=G.find(X=>!!X.allBasenames);H&&(pe.allBasenames=H.allBasenames);const B=G.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return B.length&&(pe.allPaths=B),pe}const le=function(pe,H,B){let X,re;for(let Y=0,_=G.length;Y<_;Y++){const x=G[Y];x.requiresSiblings&&B&&(H||(H=(0,A.$nc)(pe)),X||(X=H.substr(0,H.length-(0,A.$oc)(pe).length)));const ve=x(pe,H,X,B);if(typeof ve=="string")return ve;(0,T.$Gg)(ve)&&(re||(re=[]),re.push(ve))}return re?(async()=>{for(const Y of re){const _=await Y;if(typeof _=="string")return _}return null})():null},ie=G.find(pe=>!!pe.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((pe,H)=>H.allPaths?pe.concat(H.allPaths):pe,[]);return ce.length&&(le.allPaths=ce),le}function O(me,te,G){if(te===!1)return c;const Q=i(me,G);if(Q===c)return c;if(typeof te=="boolean")return Q;if(te){const le=te.when;if(typeof le=="string"){const ie=(ce,pe,H,B)=>{if(!B||!Q(ce,pe))return null;const X=le.replace("$(basename)",()=>H),re=B(X);return(0,T.$Gg)(re)?re.then(Y=>Y?me:null):re?me:null};return ie.requiresSiblings=!0,ie}}return Q}function K(me,te){const G=me.filter(pe=>!!pe.basenames);if(G.length<2)return me;const Q=G.reduce((pe,H)=>{const B=H.basenames;return B?pe.concat(B):pe},[]);let le;if(te){le=[];for(let pe=0,H=Q.length;pe<H;pe++)le.push(te)}else le=G.reduce((pe,H)=>{const B=H.patterns;return B?pe.concat(B):pe},[]);const ie=function(pe,H){if(typeof pe!="string")return null;if(!H){let X;for(X=pe.length;X>0;X--){const re=pe.charCodeAt(X-1);if(re===47||re===92)break}H=pe.substr(X)}const B=Q.indexOf(H);return B!==-1?le[B]:null};ie.basenames=Q,ie.patterns=le,ie.allBasenames=Q;const ce=me.filter(pe=>!pe.basenames);return ce.push(ie),ce}function V(me,te){return(0,D.$ub)(me,te,(G,Q)=>typeof G=="string"&&typeof Q=="string"?G===Q:typeof G!="string"&&typeof Q!="string"?G.base===Q.base&&G.pattern===Q.pattern:!1)}e.$Aj=V}),define(De[80],Ce([1,0,9,161,23,15,2]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(r="",s=!1){if(this.value=r,typeof this.value!="string")throw(0,D.$7)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(r,s=0){return this.value+=v(this.supportThemeIcons?(0,T.$Wj)(r):r).replace(/([ \t]+)/g,(o,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,s){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(r,s,o){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(r),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(r,s){const o=new RegExp((0,R.$Fe)(s),"g");return r.replace(o,(m,u)=>r.charAt(u-1)!=="\\"?`\\${m}`:m)}}e.$3j=E;function w(h){return L(h)?!h.value:Array.isArray(h)?h.every(w):!0}e.$4j=w;function L(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.$5j=L;function I(h,r){return h===r?!0:!h||!r?!1:h.value===r.value&&h.isTrusted===r.isTrusted&&h.supportThemeIcons===r.supportThemeIcons&&h.supportHtml===r.supportHtml&&(h.baseUri===r.baseUri||!!h.baseUri&&!!r.baseUri&&(0,f.$og)(A.URI.from(h.baseUri),A.URI.from(r.baseUri)))}e.$6j=I;function v(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=v;function y(h){return h.replace(/"/g,"&quot;")}e.$8j=y;function k(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=k;function p(h){const r=[],s=h.split("|").map(m=>m.trim());h=s[0];const o=s[1];if(o){const m=/height=(\d+)/.exec(o),u=/width=(\d+)/.exec(o),t=m?m[1]:"",n=u?u[1]:"",c=isFinite(parseInt(n)),i=isFinite(parseInt(t));c&&r.push(`width="${n}"`),i&&r.push(`height="${t}"`)}return{href:h,dimensions:r}}e.$0j=p}),define(De[99],Ce([1,0,19,33,16,12,23,15]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function E(i,a){const{os:l,tildify:C,relative:S}=a;if(S){const d=w(i,S,l);if(typeof d=="string")return d}let b=i.fsPath;if(l===1&&!R.$j?b=b.replace(/\//g,"\\"):l!==1&&R.$j&&(b=b.replace(/\\/g,"/")),l!==1&&C?.userHome){const d=C.userHome.fsPath;let P;i.scheme!==C.userHome.scheme&&i.path.startsWith(f.$gc.sep)?P=C.userHome.with({path:i.path}).fsPath:P=i.fsPath,b=v(P,d,l)}return(l===1?f.$fc:f.$gc).normalize(L(b,l===1))}e.$rv=E;function w(i,a,l){const C=l===1?f.$fc:f.$gc,S=l===3?A.$lg:A.$ng,b=a.getWorkspace(),g=(0,D.$Ob)(b.folders);if(!g)return;i.scheme!==g.uri.scheme&&i.path.startsWith(f.$gc.sep)&&(i=g.uri.with({path:i.path}));const d=a.getWorkspaceFolder(i);if(!d)return;let P;if(S.isEqual(d.uri,i)?P="":P=S.relativePath(d.uri,i)??"",P&&(P=C.normalize(P)),b.folders.length>1&&!a.noPrefix){const N=d.name?d.name:S.basenameOrAuthority(d.uri);P=P?`${N} \u2022 ${P}`:N}return P}function L(i,a=R.$j){return(0,T.$2f)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$sv=L;let I=Object.create(null);function v(i,a,l=R.OS){if(l===1||!i||!a)return i;let C=I.original===a?I.normalized:void 0;C||(C=a,R.$j&&(C=(0,T.$Rf)(C)),C=`${(0,$.$Ke)(C,f.$gc.sep)}${f.$gc.sep}`,I={original:a,normalized:C});let S=i;return R.$j&&(S=(0,T.$Rf)(S)),(l===3?S.startsWith(C):(0,$.$3e)(S,C))?`~/${S.substr(C.length)}`:i}e.$tv=v;function y(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.$uv=y;const k="\u2026",p="\\\\",h="~";function r(i,a=f.sep){const l=new Array(i.length);let C=!1;for(let S=0;S<i.length;S++){const b=i[S];if(b===""){l[S]=`.${a}`;continue}if(!b){l[S]=b;continue}C=!0;let g="",d=b;d.indexOf(p)===0?(g=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length)):d.indexOf(a)===0?(g=d.substr(0,d.indexOf(a)+a.length),d=d.substr(d.indexOf(a)+a.length)):d.indexOf(h)===0&&(g=d.substr(0,d.indexOf(h)+h.length),d=d.substr(d.indexOf(h)+h.length));const P=d.split(a);for(let N=1;C&&N<=P.length;N++)for(let F=P.length-N;C&&F>=0;F--){C=!1;let M=P.slice(F,F+N).join(a);for(let U=0;!C&&U<i.length;U++)if(U!==S&&i[U]&&i[U].indexOf(M)>-1){const j=F+N===P.length,O=F>0&&i[U].indexOf(a)>-1?a+M:M,K=i[U].endsWith(O);C=!j||K}if(!C){let U="";(P[0].endsWith(":")||g!=="")&&(F===1&&(F=0,N++,M=P[0]+a+M),F>0&&(U=P[0]+a),U=g+U),F>0&&(U=U+k+a),U=U+M,F+N<P.length&&(U=U+a+k),l[S]=U}}C&&(l[S]=b)}return l}e.$vv=r;var s;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(i,a=Object.create(null)){const l=[];let C=!1,S="";for(const b of i)if(b==="$"||C&&b==="{")S&&l.push({value:S,type:s.TEXT}),S="",C=!0;else if(b==="}"&&C){const g=a[S];if(typeof g=="string")g.length&&l.push({value:g,type:s.VARIABLE});else if(g){const d=l[l.length-1];(!d||d.type!==s.SEPARATOR)&&l.push({value:g.label,type:s.SEPARATOR})}S="",C=!1}else S+=b;return S&&!C&&l.push({value:S,type:s.TEXT}),l.filter((b,g)=>{if(b.type===s.SEPARATOR){const d=l[g-1],P=l[g+1];return[d,P].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.$wv=o;function m(i,a){return R.$k||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$xv=m;function u(i,a){return R.$k||a?i.replace(/\(&&\w\)|&&/g,""):R.$j?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$yv=u;function t(i){return i.replace(/&/g,"&&")}e.$zv=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const l=c(i.substring(0,a));return{name:l.name,parentPath:l.parentPath+i.substring(a)}}}return c(i)}e.$Av=n;function c(i){const a=i.indexOf("/")!==-1?f.$gc:f.$fc,l=a.basename(i),C=a.dirname(i);return l.length?{name:l,parentPath:C}:{name:C,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function f(I){return I.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const y=this.a.transformIncoming(v);return y===v?v:f(T.URI.from(y))}transformOutgoing(v){const y=this.a.transformOutgoing(v);return y===v?v:f(T.URI.from(y))}transformOutgoingURI(v){const y=this.a.transformOutgoing(v);return y===v?v:T.URI.from(y)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Lm=R,e.$Mm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,v,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return v.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const p=A(I[k],v,y+1);p!==null&&(I[k]=p)}}return null}function $(I,v){const y=A(I,v,0);return y===null?I:y}e.$Nm=$;function E(I,v,y,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?T.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof D.$be)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const h=E(I[p],v,y,k+1);h!==null&&(I[p]=h)}}return null}function w(I,v){const y=E(I,v,!1,0);return y===null?I:y}e.$Om=w;function L(I,v){const y=E(I,v,!0,0);return y===null?I:y}e.$Pm=L}),define(De[29],Ce([1,0,53,63,374,8,33,77,16,12,23,2]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function y(O,K=v.UNLINK,V){if((0,A.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");return K===v.UNLINK?p(O):k(O,V)}async function k(O,K=(0,A.$6f)((0,T.tmpdir)())){try{try{await D.promises.rename(O,K)}catch(V){return V.code==="ENOENT"?void 0:p(O)}p(K).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(O){return(0,f.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function h(O){if((0,A.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function r(O,K){return m(await(K?s(O):(0,f.promisify)(D.readdir)(O)))}async function s(O){try{return await(0,f.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const K=[],V=await r(O);for(const me of V){let te=!1,G=!1,Q=!1;try{const le=await e.Promises.lstat((0,E.$jc)(O,me));te=le.isFile(),G=le.isDirectory(),Q=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}K.push({name:me,isFile:()=>te,isDirectory:()=>G,isSymbolicLink:()=>Q})}return K}function o(O){return m(D.readdirSync(O))}e.readdirSync=o;function m(O){return O.map(K=>typeof K=="string"?w.$k?(0,$.$ol)(K):K:(K.name=w.$k?(0,$.$ol)(K.name):K.name,K))}async function u(O){const K=await r(O),V=[];for(const me of K)await n.existsDirectory((0,E.$jc)(O,me))&&V.push(me);return V}function t(O,K=1e3){return new Promise(V=>{let me=!1;const te=setInterval(()=>{me||(me=!0,D.access(O,G=>{me=!1,G&&(clearInterval(te),V(void 0))}))},K)})}e.whenDeleted=t;var n;(function(O){async function K(te){let G;try{if(G=await e.Promises.lstat(te),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(w.$j&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw le}throw Q}}O.stat=K;async function V(te){try{const{stat:G,symbolicLink:Q}=await O.stat(te);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=V;async function me(te){try{const{stat:G,symbolicLink:Q}=await O.stat(te);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=me})(n||(e.SymlinkSupport=n={}));const c=new R.$3g;function i(O,K,V){return c.queueFor(I.URI.file(O),L.$mg).queue(()=>{const me=b(V);return new Promise((te,G)=>C(O,K,me,Q=>Q?G(Q):te()))})}let a=!0;function l(O){a=O}e.configureFlushOnWrite=l;function C(O,K,V,me){if(!a)return D.writeFile(O,K,{mode:V.mode,flag:V.flag},me);D.open(O,V.flag,V.mode,(te,G)=>{if(te)return me(te);D.writeFile(G,K,Q=>{if(Q)return D.close(G,()=>me(Q));D.fdatasync(G,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),l(!1)),D.close(G,ie=>me(ie))))})})}function S(O,K,V){const me=b(V);if(!a)return D.writeFileSync(O,K,{mode:me.mode,flag:me.flag});const te=D.openSync(O,me.flag,me.mode);try{D.writeFileSync(te,K);try{D.fdatasyncSync(te)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),l(!1)}}finally{D.closeSync(te)}}e.writeFileSync=S;function b(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,K,V=6e4){if(O!==K)try{w.$j&&typeof V=="number"?await d(O,K,Date.now(),V):await(0,f.promisify)(D.rename)(O,K)}catch(me){if(O.toLowerCase()!==K.toLowerCase()&&me.code==="EXDEV"||O.endsWith("."))await P(O,K,{preserveSymlinks:!1}),await y(O,v.MOVE);else throw me}}async function d(O,K,V,me,te=0){try{return await(0,f.promisify)(D.rename)(O,K)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-V>=me)throw console.error(`[node.js fs] rename failed after ${te} retries with error: ${G}`),G;if(te===0){let Q=!1;try{const{stat:le}=await n.stat(K);le.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,R.$Ug)(Math.min(100,te*10)),d(O,K,V,me,te+1)}}async function P(O,K,V){return F(O,K,{root:{source:O,target:K},options:V,handledSourcePaths:new Set})}const N=511;async function F(O,K,V){if(V.handledSourcePaths.has(O))return;V.handledSourcePaths.add(O);const{stat:me,symbolicLink:te}=await n.stat(O);if(te){if(V.options.preserveSymlinks)try{return await j(O,K,V)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(te.dangling)return}return me.isDirectory()?M(O,K,me.mode&N,V):U(O,K,me.mode&N)}async function M(O,K,V,me){await e.Promises.mkdir(K,{recursive:!0,mode:V});const te=await r(O);for(const G of te)await F((0,E.$jc)(O,G),(0,E.$jc)(K,G),me)}async function U(O,K,V){await e.Promises.copyFile(O,K),await e.Promises.chmod(K,V)}async function j(O,K,V){let me=await e.Promises.readlink(O);(0,A.$Xf)(me,V.root.source,!w.$l)&&(me=(0,E.$jc)(V.root.target,me.substr(V.root.source.length+1))),await e.Promises.symlink(me,K)}e.Promises=new class{get access(){return(0,f.promisify)(D.access)}get stat(){return(0,f.promisify)(D.stat)}get lstat(){return(0,f.promisify)(D.lstat)}get utimes(){return(0,f.promisify)(D.utimes)}get read(){return(O,K,V,me,te)=>new Promise((G,Q)=>{D.read(O,K,V,me,te,(le,ie,ce)=>le?Q(le):G({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,f.promisify)(D.readFile)}get write(){return(O,K,V,me,te)=>new Promise((G,Q)=>{D.write(O,K,V,me,te,(le,ie,ce)=>le?Q(le):G({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,f.promisify)(D.appendFile)}get fdatasync(){return(0,f.promisify)(D.fdatasync)}get truncate(){return(0,f.promisify)(D.truncate)}get copyFile(){return(0,f.promisify)(D.copyFile)}get open(){return(0,f.promisify)(D.open)}get close(){return(0,f.promisify)(D.close)}get symlink(){return(0,f.promisify)(D.symlink)}get readlink(){return(0,f.promisify)(D.readlink)}get chmod(){return(0,f.promisify)(D.chmod)}get mkdir(){return(0,f.promisify)(D.mkdir)}get unlink(){return(0,f.promisify)(D.unlink)}get rmdir(){return(0,f.promisify)(D.rmdir)}get realpath(){return(0,f.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return r}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return y}get rename(){return g}get copy(){return P}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=void 0;function $(v){if(f.$l)return v;const y=(0,T.$mc)(v);if(v===y)return v;const k=((0,T.$nc)(v)||v).toLowerCase();try{const h=(0,A.readdirSync)(y).filter(r=>r.toLowerCase()===k);if(h.length===1){const r=$(y);if(r)return(0,T.$jc)(r,h[0])}else if(h.length>1){const r=h.indexOf(k);if(r>=0){const s=$(y);if(s)return(0,T.$jc)(s,h[r])}}}catch{}return null}e.$5p=$;async function E(v){if(f.$l)return v;const y=(0,T.$mc)(v);if(v===y)return v;const k=((0,T.$nc)(v)||v).toLowerCase();try{const h=(await A.Promises.readdir(y)).filter(r=>r.toLowerCase()===k);if(h.length===1){const r=await E(y);if(r)return(0,T.$jc)(r,h[0])}else if(h.length>1){const r=h.indexOf(k);if(r>=0){const s=await E(y);if(s)return(0,T.$jc)(s,h[r])}}}catch{}return null}e.$6p=E;async function w(v){try{return await A.Promises.realpath(v)}catch{const k=I(v);return await A.Promises.access(k,D.constants.R_OK),k}}e.$7p=w;function L(v){try{return D.realpathSync(v)}catch{const k=I(v);return D.accessSync(k,D.constants.R_OK),k}}e.$8p=L;function I(v){return(0,R.$Ke)((0,T.$hc)(v),T.sep)}}),define(De[101],Ce([1,0,16,12,48,98,17,29]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(I=f.env){return I.comspec||"cmd.exe"}e.$Bl=E;function w(I){let v=[],y=!1;const k=function(p){if(y){v.push(p);return}(!I.send(p,r=>{if(r&&console.error(r),y=!1,v.length>0){const s=v.slice(0);v=[],s.forEach(o=>k(o))}})||T.$j)&&(y=!0)};return{send:k}}e.$Cl=w;var L;(function(I){async function v(y,k,p){if(D.$ic(y))return y;if(k===void 0&&(k=f.cwd()),D.$mc(y)!=="."||(p===void 0&&A.$yf(f.env.PATH)&&(p=f.env.PATH.split(D.$tc)),p===void 0||p.length===0))return D.$jc(k,y);async function r(s){if(await $.Promises.exists(s)){let o;try{o=await $.Promises.stat(s)}catch(m){m.message.startsWith("EACCES")&&(o=await $.Promises.lstat(s))}return o?!o.isDirectory():!1}return!1}for(const s of p){let o;if(D.$ic(s)?o=D.$jc(s,y):o=D.$jc(k,s,y),await r(o))return o;let m=o+".com";if(await r(m)||(m=o+".exe",await r(m)))return m}return D.$jc(k,y)}I.findExecutable=v})(L||(e.win32=L={}))});var He=this&&this.__decorate||function($e,e,D,T){var f=arguments.length,R=f<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,D,T);else for(var $=$e.length-1;$>=0;$--)(A=$e[$])&&(R=(f<3?A(R):f>3?A(e,D,R):A(e,D))||R);return f>3&&R&&Object.defineProperty(e,D,R),R};define(De[81],Ce([1,0,19,8,22,21,57,9,4,3,62,15,17]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var y;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(y||(y={}));function k(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(p||(p={}));function h(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var r;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(r||(r={}));function s(te){let G=0;for(let Q=0;;Q+=7){const le=te.read(1);if(G|=(le.buffer[0]&127)<<Q,!(le.buffer[0]&128))return G}}const o=c(0);function m(te,G){if(G===0){te.write(o);return}let Q=0;for(let ie=G;ie!==0;ie=ie>>>7)Q++;const le=f.$be.alloc(Q);for(let ie=0;G!==0;ie++)le.buffer[ie]=G&127,G=G>>>7,G>0&&(le.buffer[ie]|=128);te.write(le)}class u{constructor(G){this.b=G,this.a=0}read(G){const Q=this.b.slice(this.a,this.a+G);return this.a+=Q.byteLength,Q}}e.$nh=u;class t{constructor(){this.a=[]}get buffer(){return f.$be.concat(this.a)}write(G){this.a.push(G)}}e.$oh=t;var n;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object",te[te.Int=6]="Int"})(n||(n={}));function c(te){const G=f.$be.alloc(1);return G.writeUInt8(te,0),G}const i={Undefined:c(n.Undefined),String:c(n.String),Buffer:c(n.Buffer),VSBuffer:c(n.VSBuffer),Array:c(n.Array),Object:c(n.Object),Uint:c(n.Int)},a=typeof Buffer<"u";function l(te,G){if(typeof G>"u")te.write(i.Undefined);else if(typeof G=="string"){const Q=f.$be.fromString(G);te.write(i.String),m(te,Q.byteLength),te.write(Q)}else if(a&&Buffer.isBuffer(G)){const Q=f.$be.wrap(G);te.write(i.Buffer),m(te,Q.byteLength),te.write(Q)}else if(G instanceof f.$be)te.write(i.VSBuffer),m(te,G.byteLength),te.write(G);else if(Array.isArray(G)){te.write(i.Array),m(te,G.length);for(const Q of G)l(te,Q)}else if(typeof G=="number"&&(G|0)===G)te.write(i.Uint),m(te,G);else{const Q=f.$be.fromString(JSON.stringify(G));te.write(i.Object),m(te,Q.byteLength),te.write(Q)}}e.$ph=l;function C(te){switch(te.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return te.read(s(te)).toString();case n.Buffer:return te.read(s(te)).buffer;case n.VSBuffer:return te.read(s(te));case n.Array:{const Q=s(te),le=[];for(let ie=0;ie<Q;ie++)le.push(C(te));return le}case n.Object:return JSON.parse(te.read(s(te)).toString());case n.Int:return s(te)}}e.$qh=C;class S{constructor(G,Q,le=null,ie=1e3){this.h=G,this.j=Q,this.k=le,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(G,Q){this.b.set(G,Q),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const Q=this.o([G.type]);this.k?.logOutgoing(Q,0,1,h(G.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Q,G.id,1,h(G.type),G.data);return}}}o(G,Q=void 0){const le=new t;return l(le,G),l(le,Q),this.p(le.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Q=new u(G),le=C(Q),ie=C(Q),ce=le[0];switch(ce){case 100:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.s({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 102:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.t({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 101:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]});case 103:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]})}}s(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const le=new R.$Xd;let ie;try{ie=Q.call(this.j,G.name,G.arg,le.token)}catch(H){ie=Promise.reject(H)}const ce=G.id;ie.then(H=>{this.m({id:ce,data:H,type:201})},H=>{H instanceof Error?this.m({id:ce,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ce,data:H,type:203})}).finally(()=>{pe.dispose(),this.d.delete(G.id)});const pe=(0,w.$Qc)(()=>le.cancel());this.d.set(G.id,pe)}t(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const le=G.id,ce=Q.listen(this.j,G.name,G.arg)(pe=>this.m({id:le,data:pe,type:204}));this.d.set(G.id,ce)}u(G){const Q=this.d.get(G.id);Q&&(Q.dispose(),this.d.delete(G.id))}v(G){let Q=this.g.get(G.channelName);Q||(Q=[],this.g.set(G.channelName,Q));const le=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:G,timeoutTimer:le})}w(G){const Q=this.g.get(G);if(Q){for(const le of Q)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$rh=S;var b;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class g{constructor(G,Q=null){this.l=G,this.a=!1,this.b=r.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=Q}getChannel(G){const Q=this;return{call(le,ie,ce){return Q.a?Promise.reject(new $.$5):Q.m(G,le,ie,ce)},listen(le,ie){return Q.a?E.Event.None:Q.o(G,le,ie)}}}m(G,Q,le,ie=R.CancellationToken.None){const ce=this.g++,H={id:ce,type:100,channelName:G,name:Q,arg:le};if(ie.isCancellationRequested)return Promise.reject(new $.$5);let B;return new Promise((re,Y)=>{if(ie.isCancellationRequested)return Y(new $.$5);const _=()=>{const fe=ee=>{switch(ee.type){case 201:this.f.delete(ce),re(ee.data);break;case 202:{this.f.delete(ce);const de=new Error(ee.data.message);de.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,de.name=ee.data.name,Y(de);break}case 203:this.f.delete(ce),Y(ee.data);break}};this.f.set(ce,fe),this.p(H)};let x=null;this.b===r.Idle?_():(x=(0,T.$Hg)(fe=>this.u()),x.then(()=>{x=null,_()}));const ve=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),Y(new $.$5)},ae=ie.onCancellationRequested(ve);B=(0,w.$Pc)((0,w.$Qc)(ve),ae),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,Q,le){const ie=this.g++,pe={id:ie,type:102,channelName:G,name:Q,arg:le};let H=null;const B=new E.$Nd({onWillAddFirstListener:()=>{H=(0,T.$Hg)(re=>this.u()),H.then(()=>{H=null,this.d.add(B),this.p(pe)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),X=re=>B.fire(re.data);return this.f.set(ie,X),B.event}p(G){switch(G.type){case 100:case 102:{const Q=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Q,G.id,0,`${k(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const Q=this.q([G.type,G.id]);this.j?.logOutgoing(Q,G.id,0,k(G.type));return}}}q(G,Q=void 0){const le=new t;return l(le,G),l(le,Q),this.r(le.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Q=new u(G),le=C(Q),ie=C(Q),ce=le[0];switch(ce){case 200:return this.j?.logIncoming(G.byteLength,0,0,h(ce)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,le[1],0,h(ce),ie),this.t({type:le[0],id:le[1],data:ie})}}t(G){if(G.type===200){this.b=r.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===r.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$sh=g,He([A.$hh],g.prototype,"onDidInitializePromise",null);class d{get connections(){const G=[];return this.f.forEach(Q=>G.push(Q)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new E.$Nd,this.onDidAddConnection=this.g.event,this.h=new E.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Rc,this.j.add(G(({protocol:Q,onDidClientDisconnect:le})=>{const ie=E.Event.once(Q.onMessage);this.j.add(ie(ce=>{const pe=new u(ce),H=C(pe),B=new S(Q,H),X=new g(Q);this.a.forEach((Y,_)=>B.registerChannel(_,Y));const re={channelServer:B,channelClient:X,ctx:H};this.f.add(re),this.g.fire(re),this.j.add(le(()=>{B.dispose(),X.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(G,Q){const le=this;return{call(ie,ce,pe){let H;if((0,v.$Mf)(Q)){const X=(0,D.$4b)(le.connections.filter(Q));H=X?Promise.resolve(X):E.Event.toPromise(E.Event.filter(le.onDidAddConnection,Q))}else H=Q.routeCall(le,ie,ce);const B=H.then(X=>X.channelClient.getChannel(G));return N(B).call(ie,ce,pe)},listen(ie,ce){if((0,v.$Mf)(Q))return le.k(G,Q,ie,ce);const pe=Q.routeEvent(le,ie,ce).then(H=>H.channelClient.getChannel(G));return N(pe).listen(ie,ce)}}}k(G,Q,le,ie){const ce=this;let pe;const H=new E.$Nd({onWillAddFirstListener:()=>{pe=new w.$Rc;const B=new E.$Td,X=new Map,re=_=>{const ve=_.channelClient.getChannel(G).listen(le,ie),ae=B.add(ve);X.set(_,ae)},Y=_=>{const x=X.get(_);x&&(x.dispose(),X.delete(_))};ce.connections.filter(Q).forEach(re),E.Event.filter(ce.onDidAddConnection,Q)(re,void 0,pe),ce.onDidRemoveConnection(Y,void 0,pe),B.event(H.fire,H,pe),pe.add(B)},onDidRemoveLastListener:()=>{pe?.dispose(),pe=void 0}});return H.event}registerChannel(G,Q){this.a.set(G,Q);for(const le of this.f)le.channelServer.registerChannel(G,Q)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=d;class P{constructor(G,Q,le=null){const ie=new t;l(ie,Q),G.send(ie.buffer),this.a=new g(G,le),this.d=new S(G,Q,le)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Q){this.d.registerChannel(G,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=P;function N(te){return{call(G,Q,le){return te.then(ie=>ie.call(G,Q,le))},listen(G,Q){const le=new E.$Wd;return te.then(ie=>le.input=ie.listen(G,Q)),le.event}}}e.$vh=N;function F(te){let G=!1;return{call(Q,le,ie){return G?te.call(Q,le,ie):(0,T.$Ug)(0).then(()=>G=!0).then(()=>te.call(Q,le,ie))},listen(Q,le){if(G)return te.listen(Q,le);const ie=new E.$Wd;return(0,T.$Ug)(0).then(()=>G=!0).then(()=>ie.input=te.listen(Q,le)),ie.event}}}e.$wh=F;class M{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Q of G.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$xh=M;var U;(function(te){function G(ce,pe,H){const B=ce,X=H&&H.disableMarshalling,re=new Map;for(const Y in B)le(Y)&&re.set(Y,E.Event.buffer(B[Y],!0,void 0,pe));return new class{listen(Y,_,x){const ve=re.get(_);if(ve)return ve;if(ie(_)){const ae=B[_];if(typeof ae=="function")return ae.call(B,x)}throw new $.$bb(`Event not found: ${_}`)}call(Y,_,x){const ve=B[_];if(typeof ve=="function"){if(!X&&Array.isArray(x))for(let fe=0;fe<x.length;fe++)x[fe]=(0,L.$mh)(x[fe]);let ae=ve.apply(B,x);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new $.$bb(`Method not found: ${_}`)}}}te.fromService=G;function Q(ce,pe){const H=pe&&pe.disableMarshalling;return new Proxy({},{get(B,X){if(typeof X=="string")return pe?.properties?.has(X)?pe.properties.get(X):ie(X)?function(re){return ce.listen(X,re)}:le(X)?ce.listen(X):async function(...re){let Y;pe&&!(0,v.$Hf)(pe.context)?Y=[pe.context,...re]:Y=re;const _=await ce.call(X,Y);return H?_:(0,L.$mh)(_)};throw new $.$bb(`Property not found: ${String(X)}`)}})}te.toService=Q;function le(ce){return ce[0]==="o"&&ce[1]==="n"&&I.$1e(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&I.$1e(ce.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const G=te.toString();if(G!=="[object Object]")return G}return te}function K(te){return Array.isArray(te)?te.map(O):O(te)}function V(te,G,Q,le,ie,ce,pe){pe=K(pe);const H=j[ie],B=H[le%H.length];let X=[`%c[${te}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ce)?(X=X.concat(pe),X.push(")")):X.push(pe),console.log.apply(console,X)}class me{constructor(G,Q){this.d=G,this.f=Q,this.a=0,this.b=0}logOutgoing(G,Q,le,ie,ce){this.b+=G,V(this.d,this.b,G,Q,le,ie,ce)}logIncoming(G,Q,le,ie,ce){this.a+=G,V(this.f,this.a,G,Q,le,ie,ce)}}e.$yh=me}),define(De[82],Ce([1,0,22,4,3,81]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var $;(function(i){i.enableDiagnostics=!1,i.records=[];const a=new WeakMap;let l=0;function C(b,g){if(!a.has(b)){const d=String(++l);a.set(b,d)}return a.get(b)}function S(b,g,d,P){if(!i.enableDiagnostics)return;const N=C(b,g);if(P instanceof D.$be||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=D.$be.alloc(P.byteLength);F.set(P),i.records.push({timestamp:Date.now(),id:N,label:g,type:d,buff:F})}else i.records.push({timestamp:Date.now(),id:N,label:g,type:d,data:P})}i.traceSocketEvent=S})($||(e.SocketDiagnostics=$={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let w=null;function L(){return w||(w=D.$be.alloc(0)),w}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return L();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const g=this.a[0];return l&&(this.a.shift(),this.b-=a),g}if(this.a[0].byteLength>a){const g=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),g}const C=D.$be.alloc(a);let S=0,b=0;for(;a>0;){const g=this.a[b];if(g.byteLength>a){const d=g.slice(0,a);C.set(d,S),S+=a,l&&(this.a[b]=g.slice(a),this.b-=a),a-=a}else C.set(g,S),S+=g.byteLength,l?(this.a.shift(),this.b-=g.byteLength):b++,a-=g.byteLength}return C}}e.$zh=I;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class p{constructor(a,l,C,S){this.type=a,this.id=l,this.ack=C,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends f.$Sc{constructor(a){super(),this.f=this.B(new T.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const C=this.g.messageType,S=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new p(C,S,b,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class r{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$be.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(l,a.data)}g(a,l){const C=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,C}h(){const a=D.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class s extends f.$Sc{constructor(a){super(),this.f=new T.$Nd,this.onMessage=this.f.event,this.g=new T.$Nd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new r(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new p(1,0,0,a))}}e.$Ah=s;class o extends R.$uh{static fromSocket(a,l){return new o(new s(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,C=null){super(a,l,C),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Bh=o;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Ch=m;class u{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,C=this.a;for(;C;)a[l++]=C.data,C=C.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new u(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<n.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=n.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+n.a)*1e3;let C=0;for(let S=0;S<n.a;S++)a-this.c[S]<=l&&C++;return 1-C/n.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??n.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Rc,this.o=a.socket,this.p=this.r.add(new r(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new p(5,0,0,L());this.p.write(a),this.p.flush()}sendPause(){const a=new p(7,0,0,L());this.p.write(a)}sendResume(){const a=new p(8,0,0,L());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.r.dispose(),this.r=new f.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new r(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(C=>this.z(C))),this.r.add(this.o.onClose(C=>this.x.fire(C))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new p(3,0,this.h,L());this.p.write(a);const l=this.b.toArray();for(let C=0,S=l.length;C<S;C++)this.p.write(l[C]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const l=this.b.peek();if(l&&l.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new p(6,0,0,L())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let C=0,S=l.length;C<S;C++)this.p.write(l[C]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const l=++this.c;this.h=this.g;const C=new p(1,l,this.h,a);this.b.push(C),this.a||(this.p.write(C),this.B())}sendControl(a){const l=new p(2,0,0,a);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),l=Date.now()-a.writtenTime,C=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(l>=2e4&&C>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:C});return}const b=Math.max(2e4-l,2e4-C,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new p(3,0,this.h,L());this.p.write(a)}D(){this.h=this.g;const a=new p(9,0,this.h,L());this.p.write(a)}}e.$Dh=c}),define(De[183],Ce([1,0,49,8,22,21,181,9,4,3,24,101,98,81]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class k extends y.$rh{constructor(r){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",s=>f.$be.wrap(Buffer.from(s,"base64")))},r),process.once("disconnect",()=>this.dispose())}}e.$2p=k;class p{constructor(r,s){this.i=r,this.j=s,this.c=new Set,this.g=new Map,this.h=new E.$Nd,this.onDidProcessExit=this.h.event;const o=s&&s.timeout?s.timeout:6e4;this.b=new T.$Qg(o),this.d=null,this.f=null}getChannel(r){const s=this;return{call(o,m,u){return s.k(r,o,m,u)},listen(o,m){return s.l(r,o,m)}}}k(r,s,o,m=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject($.$6());this.b.cancel();const u=this.n(r),t=(0,T.$Hg)(i=>u.call(s,o,i)),n=m.onCancellationRequested(()=>t.cancel()),c=(0,w.$Qc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{n.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(r,s,o){if(!this.b)return E.Event.None;this.b.cancel();let m;const u=new E.$Nd({onWillAddFirstListener:()=>{m=this.n(r).listen(s,o)(u.fire,u),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const r=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,L.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,v.$Al)(s.env),this.d=(0,D.fork)(this.i,r,s);const o=new E.$Nd;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$Xp)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}o.fire(f.$be.wrap(Buffer.from(a,"base64")))});const u=this.j.useQueue?(0,I.$Cl)(this.d):this.d,t=a=>this.d&&this.d.connected&&u.send(a.buffer.toString("base64")),n=o.event,c={send:t,onMessage:n};this.f=new y.$sh(c);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(C=>(0,w.$Nc)(C)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(r){let s=this.g.get(r);return s||(s=this.m.getChannel(r),this.g.set(r,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$3p=p}),define(De[184],Ce([1,0,8,4,3,62,17]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.StorageState=e.$1o=e.StorageHint=void 0;var $;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function E(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$1o=E;var w;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(w||(e.StorageState=w={}));class L extends f.$Sc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new T.$Qd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new D.$Rg(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,p)=>this.w(p,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===w.Closed)return;let p=!1;(0,A.$Hf)(k)?p=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const p=this.f.get(y);return(0,A.$Hf)(p)?k:p}getBoolean(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:p==="true"}getNumber(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:parseInt(p,10)}getObject(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:(0,R.$lh)(p)}async set(y,k,p=!1){if(this.c===w.Closed)return;if((0,A.$Hf)(k))return this.delete(y,p);const h=(0,A.$Af)(k)||Array.isArray(k)?(0,R.$kh)(k):String(k);if(this.f.get(y)!==h)return this.f.set(y,h),this.j.set(y,h),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,k=!1){if(!(this.c===w.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$2o=L;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,p)=>this.a.set(p,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$3o=I}),define(De[185],Ce([1,0,36,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=void 0;function f(R,A,$,E,w,L){if(Array.isArray(R)){let I=0;for(const v of R){const y=f(v,A,$,E,w,L);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof R=="string")return E?R==="*"?5:R===$?10:0:0;if(R){const{language:I,pattern:v,scheme:y,hasAccessToAllModels:k,notebookType:p}=R;if(!E&&!k)return 0;p&&w&&(A=w);let h=0;if(y)if(y===A.scheme)h=10;else if(y==="*")h=5;else return 0;if(I)if(I===$)h=10;else if(I==="*")h=Math.max(h,5);else return 0;if(p)if(p===L)h=10;else if(p==="*"&&L!==void 0)h=Math.max(h,5);else return 0;if(v){let r;if(typeof v=="string"?r=v:r={...v,base:(0,T.$hc)(v.base)},r===A.fsPath||(0,D.$vj)(r,A.fsPath))h=10;else return 0}return h}else return 0}}e.$tE=f}),define(De[129],Ce([1,0,22,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20=e.$10=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function R(I){for(let v=0,y=I.length;v<y;v+=4){const k=I[v+0],p=I[v+1],h=I[v+2],r=I[v+3];I[v+0]=r,I[v+1]=h,I[v+2]=p,I[v+3]=k}}function A(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$D()||R(v),D.$be.wrap(v)}function $(I){const v=I.buffer;if(T.$D()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const y=new Uint8Array(v.byteLength);return y.set(v),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const v=new Uint32Array(w(I));let y=0;if(v[y++]=I.id,I.type==="full")v[y++]=1,v[y++]=I.data.length,v.set(I.data,y),y+=I.data.length;else{v[y++]=2,v[y++]=I.deltas.length;for(const k of I.deltas)v[y++]=k.start,v[y++]=k.deleteCount,k.data?(v[y++]=k.data.length,v.set(k.data,y),y+=k.data.length):v[y++]=0}return A(v)}e.$10=E;function w(I){let v=0;if(v+=1+1,I.type==="full")v+=1+I.data.length;else{v+=1,v+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&(v+=y.data.length)}return v}function L(I){const v=$(I);let y=0;const k=v[y++];if(v[y++]===1){const s=v[y++],o=v.subarray(y,y+s);return y+=s,{id:k,type:"full",data:o}}const h=v[y++],r=[];for(let s=0;s<h;s++){const o=v[y++],m=v[y++],u=v[y++];let t;u>0&&(t=v.subarray(y,y+u),y+=u),r[s]={start:o,deleteCount:m,data:t}}return{id:k,type:"delta",deltas:r}}e.$20=L}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=w;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(ue,Ie,Ve,ze){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ve){return Ve}}class v{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=v;function y(he,ue){if(typeof he!="object"||typeof ue!="object"||!he||!ue)return new v(ue,he!==ue);if(Array.isArray(he)||Array.isArray(ue)){const Ve=Array.isArray(he)&&Array.isArray(ue)&&D.$ub(he,ue);return new v(ue,!Ve)}let Ie=!1;for(const Ve in ue)if(ue.hasOwnProperty(Ve)){const ze=y(he[Ve],ue[Ve]);ze.didChange&&(he[Ve]=ze.newValue,Ie=!0)}return new v(he,Ie)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class p{constructor(ue,Ie,Ve,ze){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ve){return Ve}}function h(he,ue){return typeof he>"u"?ue:he==="false"?!1:!!he}e.boolean=h;class r extends p{constructor(ue,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ve),super(ue,Ie,Ve,ze)}validate(ue){return h(ue,this.defaultValue)}}function s(he,ue,Ie,Ve){if(typeof he>"u")return ue;let ze=parseInt(he,10);return isNaN(ze)?ue:(ze=Math.max(Ie,ze),ze=Math.min(Ve,ze),ze|0)}e.clampedInt=s;class o extends p{static clampedInt(ue,Ie,Ve,ze){return s(ue,Ie,Ve,ze)}constructor(ue,Ie,Ve,ze,xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=ze,rt.maximum=xe),super(ue,Ie,Ve,rt),this.minimum=ze,this.maximum=xe}validate(ue){return o.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function m(he,ue,Ie,Ve){if(typeof he>"u")return ue;const ze=u.float(he,ue);return u.clamp(ze,Ie,Ve)}e.clampedFloat=m;class u extends p{static clamp(ue,Ie,Ve){return ue<Ie?Ie:ue>Ve?Ve:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ve=parseFloat(ue);return isNaN(Ve)?Ie:Ve}constructor(ue,Ie,Ve,ze,xe){typeof xe<"u"&&(xe.type="number",xe.default=Ve),super(ue,Ie,Ve,xe),this.validationFn=ze}validate(ue){return this.validationFn(u.float(ue,this.defaultValue))}}class t extends p{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ve),super(ue,Ie,Ve,ze)}validate(ue){return t.string(ue,this.defaultValue)}}function n(he,ue,Ie,Ve){return typeof he!="string"?ue:Ve&&he in Ve?Ve[he]:Ie.indexOf(he)===-1?ue:he}e.stringSet=n;class c extends p{constructor(ue,Ie,Ve,ze,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=ze,xe.default=Ve),super(ue,Ie,Ve,xe),this.c=ze}validate(ue){return n(ue,this.defaultValue,this.c)}}class i extends I{constructor(ue,Ie,Ve,ze,xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=xe,ot.default=ze),super(ue,Ie,Ve,ot),this.c=xe,this.d=rt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function a(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ve){return Ve===0?ue.accessibilitySupport:Ve}}class C extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:$.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:h(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function b(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function d(he){switch(he){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function P(he){switch(he){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class N extends k{constructor(){super(140)}compute(ue,Ie,Ve){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),ue.extraEditorClassName&&ze.push(ue.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(110)&&ze.push("showUnused"),Ie.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class F extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(ue,Ie,Ve){return Ve&&ue.emptySelectionClipboard}}class M extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:$.localize(16,null),included:f.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:$.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:h(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(Ie.loop,this.defaultValue.loop)}}}class U extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?U.OFF:ue==="true"?U.ON:ue:ue?U.ON:U.OFF}}e.EditorFontLigatures=U;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Ie,Ve){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class O extends k{constructor(){super(50)}compute(ue,Ie,Ve){return ue.fontInfo}}class K extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(ue){const Ie=u.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(Ie,6,100)}compute(ue,Ie,Ve){return ue.fontInfo.fontSize}}class V extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(o.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class me extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ve,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ve,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ve,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ve,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ve,description:$.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:$.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:h(Ie.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:h(Ie.above,this.defaultValue.above)}}}var G;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class Q extends k{constructor(){super(143)}compute(ue,Ie,Ve){return Q.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ve=Math.floor(ue.paddingTop/ue.lineHeight);let ze=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const xe=(Ve+ue.viewLineCount+ze)/(ue.pixelRatio*ue.height),rt=Math.floor(ue.viewLineCount/xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:ze,desiredRatio:xe,minimapLineCount:rt}}static c(ue,Ie){const Ve=ue.outerWidth,ze=ue.outerHeight,xe=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ue.outerHeight===rt.outerHeight&&ue.lineHeight===rt.lineHeight&&ue.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===rt.pixelRatio&&ue.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ue.paddingTop===rt.paddingTop&&ue.paddingBottom===rt.paddingBottom&&ue.minimap.enabled===rt.minimap.enabled&&ue.minimap.side===rt.minimap.side&&ue.minimap.size===rt.minimap.size&&ue.minimap.showSlider===rt.minimap.showSlider&&ue.minimap.renderCharacters===rt.minimap.renderCharacters&&ue.minimap.maxColumn===rt.minimap.maxColumn&&ue.minimap.scale===rt.minimap.scale&&ue.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ue.isViewportWrapping===rt.isViewportWrapping,$t=ue.lineHeight,St=ue.typicalHalfwidthCharacterWidth,Yt=ue.scrollBeyondLastLine,Gt=ue.minimap.renderCharacters;let wt=xe>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const zt=ue.minimap.maxColumn,Nt=ue.minimap.size,Bt=ue.minimap.side,At=ue.verticalScrollbarWidth,Rt=ue.viewLineCount,Ot=ue.remainingWidth,Wt=ue.isViewportWrapping,Jt=Gt?2:3;let qt=Math.floor(xe*ze);const Vt=qt/xe;let Lt=!1,lt=!1,ft=Jt*wt,Tt=wt/xe,Kt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:Te,extraLinesBeyondLastLine:Se,desiredRatio:ne,minimapLineCount:Fe}=Q.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:ze,lineHeight:$t,pixelRatio:xe});if(Rt/Fe>1)Lt=!0,lt=!0,wt=1,ft=1,Tt=wt/xe;else{let Ze=!1,Je=wt+1;if(Nt==="fit"){const nt=Math.ceil((Te+Rt+Se)*ft);Wt&&ot&&Ot<=Ie.stableFitRemainingWidth?(Ze=!0,Je=Ie.stableFitMaxMinimapScale):Ze=nt>qt}if(Nt==="fill"||Ze){Lt=!0;const nt=wt;ft=Math.min($t*xe,Math.max(1,Math.floor(1/ne))),Wt&&ot&&Ot<=Ie.stableFitRemainingWidth&&(Je=Ie.stableFitMaxMinimapScale),wt=Math.min(Je,Math.max(1,Math.floor(ft/Jt))),wt>nt&&(Kt=Math.min(2,wt/nt)),Tt=wt/xe/Kt,qt=Math.ceil(Math.max(Me,Te+Rt+Se)*ft),Wt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=wt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Dt=Math.floor(zt*Tt),ct=Math.min(Dt,Math.max(0,Math.floor((Ot-At-2)*Tt/(St+Tt)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(xe*ct);const Ht=vt/xe;vt=Math.floor(vt*Kt);const Pt=Gt?1:2,Ge=Bt==="left"?0:Ve-ct-At;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:ct,minimapHeightIsEditorHeight:Lt,minimapIsSampling:lt,minimapScale:wt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(ue,Ie){const Ve=Ie.outerWidth|0,ze=Ie.outerHeight|0,xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,$t=Ie.maxDigitWidth,St=Ie.pixelRatio,Yt=Ie.viewLineCount,Gt=ue.get(135),wt=Gt==="inherit"?ue.get(134):Gt,zt=wt==="inherit"?ue.get(130):wt,Nt=ue.get(133),Bt=Ie.isDominatedByLongLines,At=ue.get(57),Rt=ue.get(67).renderType!==0,Ot=ue.get(68),Wt=ue.get(104),Jt=ue.get(83),qt=ue.get(72),Vt=ue.get(102),Lt=Vt.verticalScrollbarSize,lt=Vt.verticalHasArrows,ft=Vt.arrowSize,Tt=Vt.horizontalScrollbarSize,Kt=ue.get(43),Dt=ue.get(109)!=="never";let ct=ue.get(65);Kt&&Dt&&(ct+=16);let vt=0;if(Rt){const jt=Math.max(rt,Ot);vt=Math.round(jt*$t)}let Ht=0;At&&(Ht=xe*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Ht,Me=Ge+vt,Te=Me+ct;const Se=Ve-Ht-vt-ct;let ne=!1,Fe=!1,Ke=-1;wt==="inherit"&&Bt?(ne=!0,Fe=!0):zt==="on"||zt==="bounded"?Fe=!0:zt==="wordWrapColumn"&&(Ke=Nt);const Ze=Q.c({outerWidth:Ve,outerHeight:ze,lineHeight:xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:St,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:Lt,viewLineCount:Yt,remainingWidth:Se,isViewportWrapping:Fe},Ie.memory||new L);Ze.renderMinimap!==0&&Ze.minimapLeft===0&&(Pt+=Ze.minimapWidth,Ge+=Ze.minimapWidth,Me+=Ze.minimapWidth,Te+=Ze.minimapWidth);const Je=Se-Ze.minimapWidth,nt=Math.max(1,Math.floor((Je-Lt-2)/ot)),pt=lt?ft:0;return Fe&&(Ke=Math.max(1,nt),zt==="bounded"&&(Ke=Math.min(Ke,Nt))),{width:Ve,height:ze,glyphMarginLeft:Pt,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Me,decorationsWidth:ct,contentLeft:Te,contentWidth:Je,minimap:Ze,viewportColumn:nt,isWordWrapMinified:ne,isViewportWrapping:Fe,wrappingColumn:Ke,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Tt,overviewRuler:{top:pt,width:Lt,height:ze-2*pt,right:0}}}}e.EditorLayoutInfoComputer=Q;class le extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(ue){return n(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class ie extends I{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:$.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:h(ue.enabled,this.defaultValue.enabled)}}}class ce extends I{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:$.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:h(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:$.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:h(Ie.padding,this.defaultValue.padding)}}}class H extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):o.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ve){return Ve<0?o.clampedInt(-Ve*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class B extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>u.clamp(ue,0,150),{markdownDescription:$.localize(63,null)})}compute(ue,Ie,Ve){return ue.fontInfo.lineHeight}}class X extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:ue.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:$.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),autohide:h(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ie.scale,1,1,3),maxColumn:o.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(he){return he==="ctrlCmd"?f.$k?"metaKey":"ctrlKey":"altKey"}class Y extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:o.clampedInt(Ie.top,0,0,1e3),bottom:o.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends I{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:$.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),cycle:h(Ie.cycle,this.defaultValue.cycle)}}}class x extends k{constructor(){super(141)}compute(ue,Ie,Ve){return ue.pixelRatio}}class ve extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:$.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:$.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:$.localize(84,null)}},default:ue,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const St=ue?"on":"off";return{comments:St,strings:St,other:St}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:ze}=ue,xe=["on","inline","off"];let rt,ot,$t;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,xe),typeof ze=="boolean"?$t=ze?"on":"off":$t=n(ze,this.defaultValue.strings,xe),{other:rt,comments:ot,strings:$t}}}var ae;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ve=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ee(he){const ue=he.get(97);return ue==="editable"?he.get(90):ue!=="on"}e.filterValidationDecorations=ee;class de extends I{constructor(){const ue=[],Ie={type:"number",description:$.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:ue,description:$.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ve of ue)if(typeof Ve=="number")Ie.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const ze=Ve;Ie.push({column:o.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((Ve,ze)=>Ve.column-ze.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(he,ue){if(typeof he!="string")return ue;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:$.localize(104,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ve=o.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=o.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:h(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:o.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:h(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:$.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:$.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:$.localize(111,null)}})}applyUpdate(ue,Ie){let Ve=!1;Ie.allowedCharacters&&ue&&(T.$$m(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ue&&(T.$$m(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ve=!0));const ze=super.applyUpdate(ue,Ie);return Ve?new v(ze.newValue,!0):ze}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ve={};for(const[ze,xe]of Object.entries(ue))xe===!0&&(Ve[ze]=!0);return Ve}}class se extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:$.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(113,null),$.localize(114,null)],description:$.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:$.localize(116,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:h(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:h(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends I{constructor(){const ue={enabled:R.$3r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$3r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:$.localize(118,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(119,null),$.localize(120,null),$.localize(121,null)],default:ue.bracketPairs,description:$.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(123,null),$.localize(124,null),$.localize(125,null)],default:ue.bracketPairsHorizontal,description:$.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:$.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:$.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(129,null),$.localize(130,null),$.localize(131,null)],default:ue.highlightActiveIndentation,description:$.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(he,ue,Ie){const Ve=Ie.indexOf(he);return Ve===-1?ue:Ie[Ve]}class Ee extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(133,null),$.localize(134,null)],default:ue.insertMode,description:$.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:$.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:$.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:$.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null),$.localize(142,null)],default:ue.selectionMode,markdownDescription:$.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:$.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:$.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:$.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:$.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:$.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:h(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:h(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(Ie.showMethods,this.defaultValue.showMethods),showFunctions:h(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:h(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(Ie.showFields,this.defaultValue.showFields),showVariables:h(Ie.showVariables,this.defaultValue.showVariables),showClasses:h(Ie.showClasses,this.defaultValue.showClasses),showStructs:h(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:h(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:h(Ie.showModules,this.defaultValue.showModules),showProperties:h(Ie.showProperties,this.defaultValue.showProperties),showEvents:h(Ie.showEvents,this.defaultValue.showEvents),showOperators:h(Ie.showOperators,this.defaultValue.showOperators),showUnits:h(Ie.showUnits,this.defaultValue.showUnits),showValues:h(Ie.showValues,this.defaultValue.showValues),showConstants:h(Ie.showConstants,this.defaultValue.showConstants),showEnums:h(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:h(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(Ie.showKeywords,this.defaultValue.showKeywords),showWords:h(Ie.showWords,this.defaultValue.showWords),showColors:h(Ie.showColors,this.defaultValue.showColors),showFiles:h(Ie.showFiles,this.defaultValue.showFiles),showReferences:h(Ie.showReferences,this.defaultValue.showReferences),showFolders:h(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:h(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:h(Ie.showUsers,this.defaultValue.showUsers),showIssues:h(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(182,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:h(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(183,null),$.localize(184,null),$.localize(185,null),$.localize(186,null)],description:$.localize(187,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ye extends k{constructor(){super(144)}compute(ue,Ie,Ve){const ze=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(190,null),$.localize(191,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(194,null),$.localize(195,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$k?Ne:f.$l?qe:Ae,fontWeight:"normal",fontSize:f.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(he){return e.editorOptionsRegistry[he.id]=he,he}var Xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.occurrencesHighlight=80]="occurrencesHighlight",he[he.overviewRulerBorder=81]="overviewRulerBorder",he[he.overviewRulerLanes=82]="overviewRulerLanes",he[he.padding=83]="padding",he[he.pasteAs=84]="pasteAs",he[he.parameterHints=85]="parameterHints",he[he.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",he[he.quickSuggestions=88]="quickSuggestions",he[he.quickSuggestionsDelay=89]="quickSuggestionsDelay",he[he.readOnly=90]="readOnly",he[he.readOnlyMessage=91]="readOnlyMessage",he[he.renameOnType=92]="renameOnType",he[he.renderControlCharacters=93]="renderControlCharacters",he[he.renderFinalNewline=94]="renderFinalNewline",he[he.renderLineHighlight=95]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=97]="renderValidationDecorations",he[he.renderWhitespace=98]="renderWhitespace",he[he.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",he[he.roundedSelection=100]="roundedSelection",he[he.rulers=101]="rulers",he[he.scrollbar=102]="scrollbar",he[he.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=104]="scrollBeyondLastLine",he[he.scrollPredominantAxis=105]="scrollPredominantAxis",he[he.selectionClipboard=106]="selectionClipboard",he[he.selectionHighlight=107]="selectionHighlight",he[he.selectOnLineNumbers=108]="selectOnLineNumbers",he[he.showFoldingControls=109]="showFoldingControls",he[he.showUnused=110]="showUnused",he[he.snippetSuggestions=111]="snippetSuggestions",he[he.smartSelect=112]="smartSelect",he[he.smoothScrolling=113]="smoothScrolling",he[he.stickyScroll=114]="stickyScroll",he[he.stickyTabStops=115]="stickyTabStops",he[he.stopRenderingLineAfter=116]="stopRenderingLineAfter",he[he.suggest=117]="suggest",he[he.suggestFontSize=118]="suggestFontSize",he[he.suggestLineHeight=119]="suggestLineHeight",he[he.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",he[he.suggestSelection=121]="suggestSelection",he[he.tabCompletion=122]="tabCompletion",he[he.tabIndex=123]="tabIndex",he[he.unicodeHighlighting=124]="unicodeHighlighting",he[he.unusualLineTerminators=125]="unusualLineTerminators",he[he.useShadowDOM=126]="useShadowDOM",he[he.useTabStops=127]="useTabStops",he[he.wordBreak=128]="wordBreak",he[he.wordSeparators=129]="wordSeparators",he[he.wordWrap=130]="wordWrap",he[he.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=133]="wordWrapColumn",he[he.wordWrapOverride1=134]="wordWrapOverride1",he[he.wordWrapOverride2=135]="wordWrapOverride2",he[he.wrappingIndent=136]="wrappingIndent",he[he.wrappingStrategy=137]="wrappingStrategy",he[he.showDeprecated=138]="showDeprecated",he[he.inlayHints=139]="inlayHints",he[he.editorClassName=140]="editorClassName",he[he.pixelRatio=141]="pixelRatio",he[he.tabFocusMode=142]="tabFocusMode",he[he.layoutInfo=143]="layoutInfo",he[he.wrappingInfo=144]="wrappingInfo",he[he.defaultColorDecorators=145]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(196,null)})),acceptSuggestionOnEnter:Le(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(197,null),""],markdownDescription:$.localize(198,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",$.localize(200,null))),ariaRequired:Le(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(202,null),$.localize(203,null),""],description:$.localize(204,null)})),autoClosingComments:Le(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(205,null),$.localize(206,null),""],description:$.localize(207,null)})),autoClosingDelete:Le(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(208,null),""],description:$.localize(209,null)})),autoClosingOvertype:Le(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingQuotes:Le(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(212,null),$.localize(213,null),""],description:$.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[$.localize(215,null),$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null)],description:$.localize(220,null)})),automaticLayout:Le(new r(13,"automaticLayout",!1)),autoSurround:Le(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(221,null),$.localize(222,null),$.localize(223,null),""],description:$.localize(224,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new Z),stickyTabStops:Le(new r(115,"stickyTabStops",!1,{description:$.localize(225,null)})),codeLens:Le(new r(17,"codeLens",!0,{description:$.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:$.localize(227,null)})),codeLensFontSize:Le(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(228,null)})),colorDecorators:Le(new r(20,"colorDecorators",!0,{description:$.localize(229,null)})),colorDecoratorActivatedOn:Le(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(230,null),$.localize(231,null),$.localize(232,null)],description:$.localize(233,null)})),colorDecoratorsLimit:Le(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(234,null)})),columnSelection:Le(new r(22,"columnSelection",!1,{description:$.localize(235,null)})),comments:Le(new C),contextmenu:Le(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new r(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:$.localize(237,null)})),cursorSmoothCaretAnimation:Le(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(238,null),$.localize(239,null),$.localize(240,null)],description:$.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:$.localize(242,null)})),cursorSurroundingLines:Le(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(243,null)})),cursorSurroundingLinesStyle:Le(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(244,null),$.localize(245,null)],markdownDescription:$.localize(246,null)})),cursorWidth:Le(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(247,null)})),disableLayerHinting:Le(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new r(34,"domReadOnly",!1)),dragAndDrop:Le(new r(35,"dragAndDrop",!0,{description:$.localize(248,null)})),emptySelectionClipboard:Le(new F),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(249,null),$.localize(250,null),$.localize(251,null)],description:$.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new u(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:$.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new r(42,"fixedOverflowWidgets",!1)),folding:Le(new r(43,"folding",!0,{description:$.localize(254,null)})),foldingStrategy:Le(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),foldingHighlight:Le(new r(45,"foldingHighlight",!0,{description:$.localize(258,null)})),foldingImportsByDefault:Le(new r(46,"foldingImportsByDefault",!1,{description:$.localize(259,null)})),foldingMaximumRegions:Le(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(262,null)})),fontInfo:Le(new O),fontLigatures2:Le(new U),fontSize:Le(new K),fontWeight:Le(new V),fontVariations:Le(new j),formatOnPaste:Le(new r(55,"formatOnPaste",!1,{description:$.localize(263,null)})),formatOnType:Le(new r(56,"formatOnType",!1,{description:$.localize(264,null)})),glyphMargin:Le(new r(57,"glyphMargin",!0,{description:$.localize(265,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new r(59,"hideCursorInOverviewRuler",!1,{description:$.localize(266,null)})),hover:Le(new te),inDiffEditor:Le(new r(61,"inDiffEditor",!1)),letterSpacing:Le(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>u.clamp(he,-5,20),{description:$.localize(267,null)})),lightbulb:Le(new ie),lineDecorationsWidth:Le(new H),lineHeight:Le(new B),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new r(69,"linkedEditing",!1,{description:$.localize(268,null)})),links:Le(new r(70,"links",!0,{description:$.localize(269,null)})),matchBrackets:Le(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(270,null)})),minimap:Le(new X),mouseStyle:Le(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new u(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:$.localize(271,null)})),mouseWheelZoom:Le(new r(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(272,null)})),multiCursorMergeOverlapping:Le(new r(76,"multiCursorMergeOverlapping",!0,{description:$.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[$.localize(274,null),$.localize(275,null)],markdownDescription:$.localize(276,null)})),multiCursorPaste:Le(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(277,null),$.localize(278,null)],markdownDescription:$.localize(279,null)})),multiCursorLimit:Le(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(280,null)})),occurrencesHighlight:Le(new r(80,"occurrencesHighlight",!0,{description:$.localize(281,null)})),overviewRulerBorder:Le(new r(81,"overviewRulerBorder",!0,{description:$.localize(282,null)})),overviewRulerLanes:Le(new o(82,"overviewRulerLanes",3,0,3)),padding:Le(new Y),pasteAs:Le(new et),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(283,null),$.localize(284,null)],description:$.localize(285,null)})),definitionLinkOpensInPeek:Le(new r(87,"definitionLinkOpensInPeek",!1,{description:$.localize(286,null)})),quickSuggestions:Le(new ve),quickSuggestionsDelay:Le(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(287,null)})),readOnly:Le(new r(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new r(92,"renameOnType",!1,{description:$.localize(288,null),markdownDeprecationMessage:$.localize(289,null)})),renderControlCharacters:Le(new r(93,"renderControlCharacters",!0,{description:$.localize(290,null),restricted:!0})),renderFinalNewline:Le(new c(94,"renderFinalNewline",f.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(291,null)})),renderLineHighlight:Le(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(292,null)],description:$.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(294,null)})),renderValidationDecorations:Le(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(295,null),$.localize(296,null),$.localize(297,null),""],description:$.localize(298,null)})),revealHorizontalRightPadding:Le(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new r(100,"roundedSelection",!0,{description:$.localize(299,null)})),rulers:Le(new de),scrollbar:Le(new z),scrollBeyondLastColumn:Le(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(300,null)})),scrollBeyondLastLine:Le(new r(104,"scrollBeyondLastLine",!0,{description:$.localize(301,null)})),scrollPredominantAxis:Le(new r(105,"scrollPredominantAxis",!0,{description:$.localize(302,null)})),selectionClipboard:Le(new r(106,"selectionClipboard",!0,{description:$.localize(303,null),included:f.$l})),selectionHighlight:Le(new r(107,"selectionHighlight",!0,{description:$.localize(304,null)})),selectOnLineNumbers:Le(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(305,null),$.localize(306,null),$.localize(307,null)],description:$.localize(308,null)})),showUnused:Le(new r(110,"showUnused",!0,{description:$.localize(309,null)})),showDeprecated:Le(new r(138,"showDeprecated",!0,{description:$.localize(310,null)})),inlayHints:Le(new pe),snippetSuggestions:Le(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(311,null),$.localize(312,null),$.localize(313,null),$.localize(314,null)],description:$.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new r(113,"smoothScrolling",!1,{description:$.localize(316,null)})),stopRenderingLineAfter:Le(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ee),inlineSuggest:Le(new se),inlineCompletionsAccessibilityVerbose:Le(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(317,null)})),suggestFontSize:Le(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new r(120,"suggestOnTriggerCharacters",!0,{description:$.localize(320,null)})),suggestSelection:Le(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),tabCompletion:Le(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabIndex:Le(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new J),unusualLineTerminators:Le(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),useShadowDOM:Le(new r(126,"useShadowDOM",!0)),useTabStops:Le(new r(127,"useTabStops",!0,{description:$.localize(333,null)})),wordBreak:Le(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$4r,{description:$.localize(337,null)})),wordWrap:Le(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null),$.localize(341,null)],description:$.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(343,null)})),wordWrapOverride1:Le(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new r(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(344,null)})),pixelRatio:Le(new x),tabFocusMode:Le(new r(142,"tabFocusMode",!1,{markdownDescription:$.localize(345,null)})),layoutInfo:Le(new Q),wrappingInfo:Le(new Ye),wrappingIndent:Le(new _e),wrappingStrategy:Le(new le)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,164,32,174,187]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$kt=e.$jt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$it=e.$ht=e.SymbolKinds=e.SymbolTag=e.$gt=e.$ft=e.SymbolKind=e.$et=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$dt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ct=e.$bt=e.$at=void 0;class E{constructor(U,j,O){this.offset=U,this.type=j,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$at=E;class w{constructor(U,j){this.tokens=U,this.endState=j,this._tokenizationResultBrand=void 0}}e.$bt=w;class L{constructor(U,j){this.tokens=U,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$ct=L;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var v;(function(M){const U=new Map;U.set(0,D.$Uj.symbolMethod),U.set(1,D.$Uj.symbolFunction),U.set(2,D.$Uj.symbolConstructor),U.set(3,D.$Uj.symbolField),U.set(4,D.$Uj.symbolVariable),U.set(5,D.$Uj.symbolClass),U.set(6,D.$Uj.symbolStruct),U.set(7,D.$Uj.symbolInterface),U.set(8,D.$Uj.symbolModule),U.set(9,D.$Uj.symbolProperty),U.set(10,D.$Uj.symbolEvent),U.set(11,D.$Uj.symbolOperator),U.set(12,D.$Uj.symbolUnit),U.set(13,D.$Uj.symbolValue),U.set(15,D.$Uj.symbolEnum),U.set(14,D.$Uj.symbolConstant),U.set(15,D.$Uj.symbolEnum),U.set(16,D.$Uj.symbolEnumMember),U.set(17,D.$Uj.symbolKeyword),U.set(27,D.$Uj.symbolSnippet),U.set(18,D.$Uj.symbolText),U.set(19,D.$Uj.symbolColor),U.set(20,D.$Uj.symbolFile),U.set(21,D.$Uj.symbolReference),U.set(22,D.$Uj.symbolCustomColor),U.set(23,D.$Uj.symbolFolder),U.set(24,D.$Uj.symbolTypeParameter),U.set(25,D.$Uj.account),U.set(26,D.$Uj.issues);function j(V){let me=U.get(V);return me||(console.info("No codicon found for CompletionItemKind "+V),me=D.$Uj.symbolProperty),me}M.toIcon=j;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function K(V,me){let te=O.get(V);return typeof te>"u"&&!me&&(te=9),te}M.fromString=K})(v||(e.CompletionItemKinds=v={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var p;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var h;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(h||(e.InlineCompletionTriggerKind=h={}));class r{constructor(U,j,O,K){this.range=U,this.text=j,this.completionKind=O,this.isSnippetText=K}equals(U){return R.$ts.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$dt=r;var s;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var o;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var m;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function u(M){return M&&T.URI.isUri(M.uri)&&R.$ts.isIRange(M.range)&&(R.$ts.isIRange(M.originSelectionRange)||R.$ts.isIRange(M.targetSelectionRange))}e.$et=u;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ft={[17]:(0,$.localize)(0,null),[16]:(0,$.localize)(1,null),[4]:(0,$.localize)(2,null),[13]:(0,$.localize)(3,null),[8]:(0,$.localize)(4,null),[9]:(0,$.localize)(5,null),[21]:(0,$.localize)(6,null),[23]:(0,$.localize)(7,null),[7]:(0,$.localize)(8,null),[0]:(0,$.localize)(9,null),[11]:(0,$.localize)(10,null),[10]:(0,$.localize)(11,null),[19]:(0,$.localize)(12,null),[5]:(0,$.localize)(13,null),[1]:(0,$.localize)(14,null),[2]:(0,$.localize)(15,null),[20]:(0,$.localize)(16,null),[15]:(0,$.localize)(17,null),[18]:(0,$.localize)(18,null),[24]:(0,$.localize)(19,null),[3]:(0,$.localize)(20,null),[6]:(0,$.localize)(21,null),[14]:(0,$.localize)(22,null),[22]:(0,$.localize)(23,null),[25]:(0,$.localize)(24,null),[12]:(0,$.localize)(25,null)};function n(M,U){return(0,$.localize)(26,null,M,e.$ft[U])}e.$gt=n;var c;(function(M){M[M.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var i;(function(M){const U=new Map;U.set(0,D.$Uj.symbolFile),U.set(1,D.$Uj.symbolModule),U.set(2,D.$Uj.symbolNamespace),U.set(3,D.$Uj.symbolPackage),U.set(4,D.$Uj.symbolClass),U.set(5,D.$Uj.symbolMethod),U.set(6,D.$Uj.symbolProperty),U.set(7,D.$Uj.symbolField),U.set(8,D.$Uj.symbolConstructor),U.set(9,D.$Uj.symbolEnum),U.set(10,D.$Uj.symbolInterface),U.set(11,D.$Uj.symbolFunction),U.set(12,D.$Uj.symbolVariable),U.set(13,D.$Uj.symbolConstant),U.set(14,D.$Uj.symbolString),U.set(15,D.$Uj.symbolNumber),U.set(16,D.$Uj.symbolBoolean),U.set(17,D.$Uj.symbolArray),U.set(18,D.$Uj.symbolObject),U.set(19,D.$Uj.symbolKey),U.set(20,D.$Uj.symbolNull),U.set(21,D.$Uj.symbolEnumMember),U.set(22,D.$Uj.symbolStruct),U.set(23,D.$Uj.symbolEvent),U.set(24,D.$Uj.symbolOperator),U.set(25,D.$Uj.symbolTypeParameter);function j(O){let K=U.get(O);return K||(console.info("No codicon found for SymbolKind "+O),K=D.$Uj.symbolProperty),K}M.toIcon=j})(i||(e.SymbolKinds=i={}));class a{static asEditOperation(U){return f.$us.replace(R.$ts.lift(U.range),U.text)}}e.$ht=a;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(U){switch(U){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(U)}constructor(U){this.value=U}}e.$it=l;var C;(function(M){function U(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=U})(C||(e.Command=C={}));var S;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var b;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var g;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var d;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(d||(e.CommentState=d={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$jt=N,e.$kt=new A.$5s;var F;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(F||(e.ExternalUriOpenerPriority=F={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[227],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[228],Ce([1,0,9,190]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var f;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const I=this.d,v=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:v};this.g.push({offset:I,lexeme:v,additionalInfo:L}),this.f.push(y)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const I=this.c.substring(this.d,this.e),v=E.b.get(I);v?this.k(v):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,I=!1,v=!1;for(;;){if(L>=this.c.length){this.e=L,this.l($);return}const k=this.c.charCodeAt(L);if(I)I=!1;else if(k===47&&!v){L++;break}else k===91?v=!0:k===92?I=!0:k===93&&(v=!1);L++}for(;L<this.c.length&&E.a.has(this.c.charCodeAt(L));)L++;this.e=L;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=E}),define(De[229],Ce([1,0,23,38,193,375]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(r){return r=r.trim(),r==="*"||A.test(r)}e.$Lo=E;function w(r){if(!E(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=r.match(A);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$Mo=w;function L(r){if(!r)return null;const s=r.majorBase,o=r.majorMustEqual,m=r.minorBase;let u=r.minorMustEqual;const t=r.patchBase;let n=r.patchMustEqual;r.hasCaret&&(s===0||(u=!1),n=!1);let c=0;if(r.preRelease){const i=$.exec(r.preRelease);if(i){const[,a,l,C]=i;c=Date.UTC(Number(a),Number(l)-1,Number(C))}}return{majorBase:s,majorMustEqual:o,minorBase:m,minorMustEqual:u,patchBase:t,patchMustEqual:n,isMinimum:r.hasGreaterEquals,notBefore:c}}e.$No=L;function I(r,s,o){let m;typeof r=="string"?m=L(w(r)):m=r;let u;s instanceof Date?u=s.getTime():typeof s=="string"&&(u=new Date(s).getTime());let t;if(typeof o=="string"?t=L(w(o)):t=o,!m||!t)return!1;const n=m.majorBase,c=m.minorBase,i=m.patchBase;let a=t.majorBase,l=t.minorBase,C=t.patchBase;const S=t.notBefore;let b=t.majorMustEqual,g=t.minorMustEqual,d=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:c>l?!0:c<l||u&&u<S?!1:i>=C:(n===1&&a===0&&(!b||!g||!d)&&(a=1,l=0,C=0,b=!0,g=!1,d=!1),n<a?!1:n>a?!b:c<l?!1:c>l?!g:i<C?!1:i>C?!d:!(u&&u<S))}e.$Oo=I;function v(r,s,o,m,u){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,f.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,f.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,f.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,f.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!h(m.extensionDependencies))return t.push([T.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!h(m.activationEvents))return t.push([T.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,f.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,f.localize(9,null,"main")]),t;{const i=(0,D.$vg)(o,m.main);(0,D.$pg)(i,o)||t.push([T.default.Warning,f.localize(10,null,i.path,o.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,f.localize(11,null,"browser")]),t;{const i=(0,D.$vg)(o,m.browser);(0,D.$pg)(i,o)||t.push([T.default.Warning,f.localize(12,null,i.path,o.path)])}}if(!R.valid(m.version))return t.push([T.default.Error,f.localize(13,null)]),t;const n=[];if(!y(r,s,m,u,n))for(const i of n)t.push([T.default.Error,i]);return t}e.$Po=v;function y(r,s,o,m,u){return m||typeof o.main>"u"&&typeof o.browser>"u"?!0:p(r,s,o.engines.vscode,u)}e.$Qo=y;function k(r,s,o){return r==="*"||p(s,o,r)}e.$Ro=k;function p(r,s,o,m=[]){const u=L(w(o));if(!u)return m.push(f.localize(14,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return m.push(f.localize(15,null,o)),!1}else if(!u.majorMustEqual)return m.push(f.localize(16,null,o)),!1;return I(r,s,u)?!0:(m.push(f.localize(17,null,r,o)),!1)}function h(r){if(!Array.isArray(r))return!1;for(let s=0,o=r.length;s<o;s++)if(typeof r[s]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class D{constructor(f,R=[],A=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$Mh=D}),define(De[103],Ce([1,0,102]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const T=[];var f;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R($,E,w){E instanceof D.$Mh||(E=new D.$Mh(E,[],!!w)),T.push([$,E])}e.$wr=R;function A(){return T}e.$xr=A}),define(De[230],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class D{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$bq=D;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const $=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let $=this.a.get(A);return $||($=new D(A,R),this.a.set(A,$)),$}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,$]of this.a)R.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const $=new Set([R]),E=this.c(A,$);if(E)return E}}c(R,A){for(const[$,E]of R.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const w=this.c(E,A);if(w)return w;A.delete($)}}}e.$cq=T}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(D||(e._util=D={})),e.$Oh=f("instantiationService");function T(A,$,E){$[D.DI_TARGET]===$?$[D.DI_DEPENDENCIES].push({id:A,index:E}):($[D.DI_DEPENDENCIES]=[{id:A,index:E}],$[D.DI_TARGET]=$)}function f(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const $=function(E,w,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,E,L)};return $.toString=()=>A,D.serviceIds.set(A,$),$}e.$Ph=f;function R(A){return A}e.$Qh=R}),define(De[50],Ce([1,0,17,2,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,f.$Ph)("configurationService");function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.$ki=R;function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof T.URI)}e.$li=A;var $;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=E;function w(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$ni=w;function L(r,s){const o=Object.create(null);for(const m in r)I(o,m,r[m],s);return o}e.$oi=L;function I(r,s,o,m){const u=s.split("."),t=u.pop();let n=r;for(let c=0;c<u.length;c++){const i=u[c];let a=n[i];switch(typeof a){case"undefined":a=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${s} as ${u.slice(0,c+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=o}catch{m(`Ignoring ${s} as ${u.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${s} as ${u.join(".")} is ${JSON.stringify(n)}`)}e.$pi=I;function v(r,s){const o=s.split(".");y(r,o)}e.$qi=v;function y(r,s){const o=s.shift();if(s.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const m=r[o];typeof m=="object"&&!Array.isArray(m)&&(y(m,s),Object.keys(m).length===0&&delete r[o])}}function k(r,s,o){function m(n,c){let i=n;for(const a of c){if(typeof i!="object"||i===null)return;i=i[a]}return i}const u=s.split("."),t=m(r,u);return typeof t>"u"?o:t}e.$ri=k;function p(r,s,o){Object.keys(s).forEach(m=>{m!=="__proto__"&&(m in r?D.$Af(r[m])&&D.$Af(s[m])?p(r[m],s[m],o):o&&(r[m]=s[m]):r[m]=s[m])})}e.$si=p;function h(r){return r.replace(/[\[\]]/g,"")}e.$ti=h}),define(De[42],Ce([1,0,12,15,228,5,189,9]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",D.$k),E.set("isLinux",D.$l),E.set("isWindows",D.$j),E.set("isWeb",D.$p),E.set("isMacNative",D.$k&&!D.$p),E.set("isEdge",D.$H),E.set("isFirefox",D.$F),E.set("isChrome",D.$E),E.set("isSafari",D.$G);function w(H,B){if(E.get(H)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,B)}e.$Li=w;const L=Object.prototype.hasOwnProperty;var I;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),k=(0,A.localize)(1,null),p=(0,A.localize)(2,null),h=(0,A.localize)(3,null),r=(0,A.localize)(4,null),s=(0,A.localize)(5,null),o=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=v){this.k=B,this.d=new f.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const re=this.D(),Y=re.type===17?s:void 0;throw this.h.push({message:r,offset:re.offset,lexeme:f.$Ki.getLexeme(re),additionalInfo:Y}),u.c}return X}catch(X){if(X!==u.c)throw X;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const X=this.o();B.push(X)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const X=this.s();B.push(X)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const X=this.l();return this.A(1,h),X?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const X=this.l();return this.A(1,h),X}case 17:{const X=B.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const _=Y.lexeme,x=_.lastIndexOf("/"),ve=x===_.length-1?void 0:this.w(_.substring(x+1));let ae;try{ae=new RegExp(_.substring(1,x),ve)}catch{throw this.B("REGEX",Y)}return O.create(X,ae)}switch(Y.type){case 10:case 19:{const _=[Y.lexeme];this.z();let x=this.D(),ve=0;for(let be=0;be<Y.lexeme.length;be++)Y.lexeme.charCodeAt(be)===40?ve++:Y.lexeme.charCodeAt(be)===41&&ve--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ve++;break;case 1:ve--;break;case 10:case 18:for(let be=0;be<x.lexeme.length;be++)x.lexeme.charCodeAt(be)===40?ve++:Y.lexeme.charCodeAt(be)===41&&ve--}if(ve<0)break;_.push(f.$Ki.getLexeme(x)),this.z(),x=this.D()}const ae=_.join(""),fe=ae.lastIndexOf("/"),ee=fe===ae.length-1?void 0:this.w(ae.substring(fe+1));let de;try{de=new RegExp(ae.substring(1,fe),ee)}catch{throw this.B("REGEX",Y)}return t.regex(X,de)}case 18:{const _=Y.lexeme;this.z();let x=null;if(!(0,T.$Be)(_)){const ve=_.indexOf("/"),ae=_.lastIndexOf("/");if(ve!==ae&&ve>=0){const fe=_.slice(ve+1,ae),ee=_[ae+1]==="i"?"i":"";try{x=new RegExp(fe,ee)}catch{throw this.B("REGEX",Y)}}}if(x===null)throw this.B("REGEX",Y);return O.create(X,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Y=this.u();return t.notIn(X,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return t.equals(X,Y);switch(Y){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return t.notEquals(X,Y);switch(Y){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,Y)}}case 5:return this.z(),U.create(X,this.u());case 6:return this.z(),j.create(X,this.u());case 7:return this.z(),F.create(X,this.u());case 8:return this.z(),M.create(X,this.u());case 13:return this.z(),t.in(X,this.u());default:return t.has(X)}}case 20:throw this.h.push({message:o,offset:B.offset,lexeme:"",additionalInfo:m}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,X){if(this.C(B))return this.z();throw this.B(X,this.D())}B(B,X,re){const Y=(0,A.localize)(8,null,B,f.$Ki.getLexeme(X)),_=X.offset,x=f.$Ki.getLexeme(X);return this.h.push({message:Y,offset:_,lexeme:x,additionalInfo:re}),u.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=u;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(B){return C.create(B)}static equals(B,X){return S.create(B,X)}static notEquals(B,X){return d.create(B,X)}static regex(B,X){return O.create(B,X)}static in(B,X){return b.create(B,X)}static notIn(B,X){return g.create(B,X)}static not(B){return P.create(B)}static and(...B){return me.create(B,null,!0)}static or(...B){return te.create(B,null,!0)}static greater(B,X){return F.create(B,X)}static greaterEquals(B,X){return M.create(B,X)}static smaller(B,X){return U.create(B,X)}static smallerEquals(B,X){return j.create(B,X)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ni=t;function n(H){const B=new u({regexParsingWithErrorRecovery:!1});return H.map(X=>(B.parse(X),B.lexingErrors.length>0?B.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,A.localize)(9,null,re.additionalInfo):(0,A.localize)(10,null),offset:re.offset,length:re.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$Oi=n;function c(H,B){const X=H?H.substituteConstants():void 0,re=B?B.substituteConstants():void 0;return!X&&!re?!0:!X||!re?!1:X.equals(re)}e.$Pi=c;function i(H,B){return H.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.$Qi=a;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$Ri=l;class C{static create(B,X=null){const re=E.get(B);return typeof re=="boolean"?re?l.INSTANCE:a.INSTANCE:new C(B,X)}constructor(B,X){this.key=B,this.c=X,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?l.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Si=C;class S{static create(B,X,re=null){if(typeof X=="boolean")return X?C.create(B,re):P.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?X===(Y?"true":"false")?l.INSTANCE:a.INSTANCE:new S(B,X,re)}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const X=B?"true":"false";return this.d===X?l.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Ti=S;class b{static create(B,X){return new b(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:le(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const X=B.getValue(this.f),re=B.getValue(this.d);return Array.isArray(X)?X.includes(re):typeof re=="string"&&typeof X=="object"&&X!==null?L.call(X,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Ui=b;class g{static create(B,X){return new g(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=11,this.c=b.create(B,X)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=g;class d{static create(B,X,re=null){if(typeof X=="boolean")return X?P.create(B,re):C.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?X===(Y?"true":"false")?a.INSTANCE:l.INSTANCE:new d(B,X,re)}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const X=B?"true":"false";return this.d===X?a.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=d;class P{static create(B,X=null){const re=E.get(B);return typeof re=="boolean"?re?a.INSTANCE:l.INSTANCE:new P(B,X)}constructor(B,X){this.c=B,this.d=X,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:l.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.$Xi=P;function N(H,B){if(typeof H=="string"){const X=parseFloat(H);isNaN(X)||(H=X)}return typeof H=="string"||typeof H=="number"?B(H):a.INSTANCE}class F{static create(B,X,re=null){return N(X,Y=>new F(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Yi=F;class M{static create(B,X,re=null){return N(X,Y=>new M(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Zi=M;class U{static create(B,X,re=null){return N(X,Y=>new U(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$1i=U;class j{static create(B,X,re=null){return N(X,Y=>new j(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$2i=j;class O{static create(B,X){return new O(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const X=this.f?this.f.source:"",re=B.f?B.f.source:"";return X<re?-1:X>re?1:0}equals(B){if(B.type===this.type){const X=this.f?this.f.source:"",re=B.f?B.f.source:"";return this.d===B.d&&X===re}return!1}substituteConstants(){return this}evaluate(B){const X=B.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$3i=O;class K{static create(B){return new K(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new K(this.c.map(B))}negate(){return this.c}}e.$4i=K;function V(H){let B=null;for(let X=0,re=H.length;X<re;X++){const Y=H[X].substituteConstants();if(H[X]!==Y&&B===null){B=[];for(let _=0;_<X;_++)B[_]=H[_]}B!==null&&(B[X]=Y)}return B===null?H:B}class me{static create(B,X,re){return me.d(B,X,re)}constructor(B,X){this.expr=B,this.c=X,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Y=i(this.expr[X],B.expr[X]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(B.expr[X]))return!1;return!0}return!1}substituteConstants(){const B=V(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].evaluate(B))return!1;return!0}static d(B,X,re){const Y=[];let _=!1;for(const x of B)if(x){if(x.type===1){_=!0;continue}if(x.type===0)return a.INSTANCE;if(x.type===6){Y.push(...x.expr);continue}Y.push(x)}if(Y.length===0&&_)return l.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(i);for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];for(;Y.length>1;){const x=Y[Y.length-1];if(x.type!==9)break;Y.pop();const ve=Y.pop(),ae=Y.length===0,fe=te.create(x.expr.map(ee=>me.create([ee,ve],null,re)),null,ae);fe&&(Y.push(fe),Y.sort(i))}if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let ve=x+1;ve<Y.length;ve++)if(Y[x].negate().equals(Y[ve]))return a.INSTANCE;if(Y.length===1)return Y[0]}return new me(Y,X)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const X of this.expr)B.push(...X.keys());return B}map(B){return new me(this.expr.map(X=>X.map(B)),null)}negate(){if(!this.c){const B=[];for(const X of this.expr)B.push(X.negate());this.c=te.create(B,this,!0)}return this.c}}e.$5i=me;class te{static create(B,X,re){return te.d(B,X,re)}constructor(B,X){this.expr=B,this.c=X,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Y=i(this.expr[X],B.expr[X]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(B.expr[X]))return!1;return!0}return!1}substituteConstants(){const B=V(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let X=0,re=this.expr.length;X<re;X++)if(this.expr[X].evaluate(B))return!0;return!1}static d(B,X,re){let Y=[],_=!1;if(B){for(let x=0,ve=B.length;x<ve;x++){const ae=B[x];if(ae){if(ae.type===0){_=!0;continue}if(ae.type===1)return l.INSTANCE;if(ae.type===9){Y=Y.concat(ae.expr);continue}Y.push(ae)}}if(Y.length===0&&_)return a.INSTANCE;Y.sort(i)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let ve=x+1;ve<Y.length;ve++)if(Y[x].negate().equals(Y[ve]))return l.INSTANCE;if(Y.length===1)return Y[0]}return new te(Y,X)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const X of this.expr)B.push(...X.keys());return B}map(B){return new te(this.expr.map(X=>X.map(B)),null)}negate(){if(!this.c){const B=[];for(const X of this.expr)B.push(X.negate());for(;B.length>1;){const X=B.shift(),re=B.shift(),Y=[];for(const _ of pe(X))for(const x of pe(re))Y.push(me.create([_,x],null,!1));B.unshift(te.create(Y,null,!1))}this.c=te.create(B,this,!0)}return this.c}}e.$6i=te;class G extends C{static{this.d=[]}static all(){return G.d.values()}constructor(B,X,re){super(B,null),this.f=X,typeof re=="object"?G.d.push({...re,key:B}):re!==!0&&G.d.push({key:B,description:re,type:X!=null?typeof X:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return d.create(this.key,B)}}e.$7i=G,e.$8i=(0,R.$Ph)("contextKeyService");function Q(H,B){return H<B?-1:H>B?1:0}function le(H,B,X,re){return H<X?-1:H>X?1:B<re?-1:B>re?1:0}function ie(H,B){if(H.type===0||B.type===1)return!0;if(H.type===9)return B.type===9?ce(H.expr,B.expr):!1;if(B.type===9){for(const X of B.expr)if(ie(H,X))return!0;return!1}if(H.type===6){if(B.type===6)return ce(B.expr,H.expr);for(const X of H.expr)if(ie(X,B))return!0;return!1}return H.equals(B)}e.$9i=ie;function ce(H,B){let X=0,re=0;for(;X<H.length&&re<B.length;){const Y=H[X].cmp(B[re]);if(Y<0)return!1;Y===0&&X++,re++}return X===H.length}function pe(H){return H.type===9?H.expr:[H]}}),define(De[231],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.ConfirmResult=e.$Dv=e.$Cv=e.$Bv=void 0,e.$Bv=(0,R.$Ph)("dialogService");var w;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(w||(w={}));class L{a(h){return this.d(h,w.Confirmation)}b(h){return this.d(h,w.Prompt)}c(h){return this.d(h,w.Input)}d(h,r){const s=[];switch(r){case w.Confirmation:{const o=h;o.primaryButton?s.push(o.primaryButton):s.push((0,f.localize)(0,null)),o.cancelButton?s.push(o.cancelButton):s.push((0,f.localize)(1,null));break}case w.Prompt:{const o=h;Array.isArray(o.buttons)&&o.buttons.length>0&&s.push(...o.buttons.map(m=>m.label)),o.cancelButton&&(o.cancelButton===!0?s.push((0,f.localize)(2,null)):typeof o.cancelButton=="string"?s.push(o.cancelButton):o.cancelButton.label?s.push(o.cancelButton.label):s.push((0,f.localize)(3,null))),s.length===0&&s.push((0,f.localize)(4,null));break}case w.Input:{const o=h;o.primaryButton?s.push(o.primaryButton):s.push((0,f.localize)(5,null)),o.cancelButton?s.push(o.cancelButton):s.push((0,f.localize)(6,null));break}}return s}e(h){if(typeof h=="string")return h;if(typeof h=="number")return h===T.default.Info?"info":h===T.default.Error?"error":h===T.default.Warning?"warning":"none"}f(h,r,s){const o=[...h.buttons??[]];h.cancelButton&&typeof h.cancelButton!="string"&&typeof h.cancelButton!="boolean"&&o.push(h.cancelButton);let m=o[r]?.run({checkboxChecked:s});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:s}}}e.$Cv=L,e.$Dv=(0,R.$Ph)("fileDialogService");var I;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const v=10;function y(p){const h=[];return h.push(...p.slice(0,v).map(r=>typeof r=="string"?r:(0,D.$sg)(r))),p.length>v&&(p.length-v===1?h.push((0,f.localize)(7,null)):h.push((0,f.localize)(8,null,p.length-v))),h.push(""),h.join(`
`)}e.$Ev=y;function k(p,h){const r=(0,E.$7m)(p);let s=(r.buttons??[]).map(t=>(0,A.$yv)(t)),o=(p.buttons||[]).map((t,n)=>n),m=0,u=r.cancelId??s.length-1;if(s.length>1){const t=typeof u=="number"?s[u]:void 0;if($.$l||$.$k){if(typeof t=="string"&&s.length>1&&u!==1){s.splice(u,1),s.splice(1,0,t);const n=o[u];o.splice(u,1),o.splice(1,0,n),u=1}$.$l&&s.length>1&&(s=s.reverse(),o=o.reverse(),m=s.length-1,typeof t=="string"&&(u=m-1))}else if($.$j&&typeof t=="string"&&s.length>1&&u!==s.length-1){s.splice(u,1),s.push(t);const n=o[u];o.splice(u,1),o.push(n),u=s.length-1}}return r.buttons=s,r.defaultId=m,r.cancelId=u,r.noLink=!0,r.title=r.title||h.nameLong,{options:r,buttonIndeces:o}}e.$Fv=k}),define(De[131],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,D.$Ph)("environmentService"),e.$Xh=(0,D.$Qh)(e.$Wh)}),define(De[132],Ce([1,0,192,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function f(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=f;function R(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=R;function A(r,s){switch(r){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function $(r,s){return s==="web"&&!r.includes("web")}e.$7n=$;function E(r,s,o){return $(s,o)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===o}e.$8n=E;function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$9n=w;var L;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var I;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var v;(function(r){r.Install="install",r.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var y;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$0n=(0,T.$Ph)("extensionGalleryService");var k;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var p;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class h extends Error{constructor(s,o){super(s),this.code=o,this.name=o}}e.$$n=h,e.$_n=(0,T.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,T.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,T.$Ph)("IExtensionTipsService"),e.$eo=(0,D.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,D.localize)(1,null),original:"Preferences"}}),define(De[232],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iYb=e.$hYb=void 0,e.$hYb=(0,D.$Ph)("externalTerminal"),e.$iYb="Terminal.app"}),define(De[233],Ce([1,0,49,18,16,12,98,29,101,194,232]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=e.$d7b=void 0;const I=w.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends v{static{this.b="cmd.exe"}openTerminal(m,u){return this.spawnTerminal(D,m,E.$Bl(),u)}spawnTerminal(m,u,t,n){const c=u.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=f.$nc(c,".exe").toLowerCase();if(i==="cmder")return m.spawn(c,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return c.indexOf(" ")>=0&&a.push('""'),a.push(c),i==="wt"&&a.push("-d ."),new Promise((l,C)=>{const S=h(process),b=m.spawn(t,a,{cwd:n,env:S});b.on("error",C),b.on("exit",()=>l())})}runInTerminal(m,u,t,n,c){const i="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,l)=>{const C=`"${u} - ${I}"`,S=`""${t.join('" "')}" & pause"`,b=Object.assign({},h(process),n);Object.keys(b).filter(F=>b[F]===null).forEach(F=>delete b[F]);const g={cwd:u,env:b,windowsVerbatimArguments:!0};let d,P;f.$nc(i,".exe")==="wt"?(d=i,P=["-d",".",y.b,"/c",S]):(d=y.b,P=["/c","start",C,"/wait",i,"/c",S]),D.spawn(d,P,g).on("error",F=>{l(r(F))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$d7b=y;class k extends v{static{this.b="/usr/bin/osascript"}openTerminal(m,u){return this.spawnTerminal(D,m,u)}runInTerminal(m,u,t,n,c){const i=c.osxExec||L.$iYb;return new Promise((a,l)=>{if(i===L.$iYb||i==="iTerm.app"){const C=i===L.$iYb?"TerminalHelper":"iTermHelper",b=[T.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",m||I,"-w",u];for(const P of t)b.push("-a"),b.push(P);if(n){const P=Object.assign({},h(process),n);for(const N in P){const F=P[N];F===null?(b.push("-u"),b.push(N)):(b.push("-e"),b.push(`${N}=${F}`))}}let g="";const d=D.spawn(k.b,b);d.on("error",P=>{l(r(P))}),d.stderr.on("data",P=>{g+=P.toString()}),d.on("exit",P=>{if(P===0)a(void 0);else if(g){const N=g.split(`
`,1);l(new Error(N[0]))}else l(new Error(w.localize(1,null,C,P)))})}else l(new Error(w.localize(2,null,i)))})}spawnTerminal(m,u,t){const n=u.osxExec||L.$iYb;return new Promise((c,i)=>{const a=["-a",n];t&&a.push(t);const l=h(process),C=m.spawn("/usr/bin/open",a,{cwd:t,env:l});C.on("error",i),C.on("exit",()=>c())})}}e.$e7b=k;class p extends v{static{this.b=w.localize(3,null)}openTerminal(m,u){return this.spawnTerminal(D,m,u)}runInTerminal(m,u,t,n,c){const i=c.linuxExec?Promise.resolve(c.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,l)=>{const C=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const b=`${s(t)}; echo; read -p "${p.b}" -n1;`;C.push(`''${b}''`);const g=Object.assign({},h(process),n);Object.keys(g).filter(F=>g[F]===null).forEach(F=>delete g[F]);const d={cwd:u,env:g};let P="";const N=D.spawn(S,C,d);N.on("error",F=>{l(r(F))}),N.stderr.on("data",F=>{P+=F.toString()}),N.on("exit",F=>{if(F===0)a(void 0);else if(P){const M=P.split(`
`,1);l(new Error(M[0]))}else l(new Error(w.localize(4,null,S,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.$l)p.d=Promise.resolve("xterm");else{const m=await $.Promises.exists("/etc/debian_version");p.d=new Promise(u=>{m?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return p.d}spawnTerminal(m,u,t){const n=u.linuxExec?Promise.resolve(u.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,i)=>{n.then(a=>{const l=h(process),C=m.spawn(a,[],{cwd:t,env:l});C.on("error",i),C.on("exit",()=>c())})})}}e.$f7b=p;function h(o){const m={...o.env};return(0,A.$zl)(m),m}function r(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(w.localize(5,null,o.path)):o}function s(o){let m="";for(const u of o)u.indexOf(" ")>=0?m+='"'+u+'"':m+=u,m+=" ";return m}}),define(De[30],Ce([1,0,78,16,15,17,2,195,5,12,18,47]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,E.$Ph)("fileService");function v(ie){return ie.create===!0}e.$_j=v;var y;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function p(ie){const ce=ie;return!!ce&&typeof ce.onDidChange=="function"}e.$ak=p;var h;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function r(ie){return!!(ie.capabilities&2)}e.$bk=r;function s(ie){return!!(ie.capabilities&8)}e.$ck=s;function o(ie){return!!(ie.capabilities&131072)}e.$dk=o;function m(ie){return!!(ie.capabilities&4)}e.$ek=m;function u(ie){return!!(ie.capabilities&16)}e.$fk=u;function t(ie){return r(ie)?!!(ie.capabilities&16384):!1}e.$gk=t;function n(ie){return r(ie)?!!(ie.capabilities&32768):!1}e.$hk=n;function c(ie){return!!(ie.capabilities&65536)}e.$ik=c;function i(ie){return!!(ie.capabilities&2048)}e.$jk=i;var a;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class l extends Error{static create(ce,pe){const H=new l(ce.toString(),pe);return b(H,pe),H}constructor(ce,pe){super(ce),this.code=pe}}e.$kk=l;function C(ie,ce){return l.create(ie,ce)}e.$lk=C;function S(ie){return ie||C((0,$.localize)(0,null),a.Unknown)}e.$mk=S;function b(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.$nk=b;function g(ie){if(!ie)return a.Unknown;if(ie instanceof l)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return a.Unknown;switch(ce[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$ok=g;function d(ie){if(ie instanceof j)return ie.fileOperationResult;switch(g(ie)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$pk=d;var P;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ce,pe,H){this.resource=ce,this.operation=pe,this.target=H}isOperation(ce){return this.operation===ce}}e.$qk=N;var F;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(ce,pe){this.c=pe,this.b=void 0,this.d=new I.$V(()=>{const H=D.$Vh.forUris(()=>this.c);return H.fill(this.rawAdded.map(B=>[B,!0])),H}),this.f=new I.$V(()=>{const H=D.$Vh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(B=>[B,!0])),H}),this.g=new I.$V(()=>{const H=D.$Vh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(B=>[B,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ce){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ce,...pe){return this.h(ce,{includeChildren:!1},...pe)}affects(ce,...pe){return this.h(ce,{includeChildren:!0},...pe)}h(ce,pe,...H){if(!ce)return!1;const B=H.length>0;return!!((!B||H.includes(1))&&(this.d.value.get(ce)||pe.includeChildren&&this.d.value.findSuperstr(ce))||(!B||H.includes(0))&&(this.f.value.get(ce)||pe.includeChildren&&this.f.value.findSuperstr(ce))||(!B||H.includes(2))&&(this.g.value.findSubstr(ce)||pe.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$rk=M;function U(ie,ce,pe){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==T.sep&&(ce+=T.sep),pe?(0,f.$3e)(ie,ce):ie.indexOf(ce)===0)}e.$sk=U;class j extends Error{constructor(ce,pe,H){super(ce),this.fileOperationResult=pe,this.options=H}}e.$tk=j;class O extends j{constructor(ce,pe,H,B){super(ce,pe,B),this.fileOperationResult=pe,this.size=H}}e.$uk=O;class K extends j{constructor(ce,pe,H){super(ce,2,H),this.stat=pe}}e.$vk=K;var V;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Dk="";function te(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Ek=te;async function G(ie,ce){if(!ce.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(pe=>{const H=ce.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(H.dispose(),pe())})})}e.$Fk=G;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ce){return(0,R.$Cf)(ce)||(ce=0),ce<Q.KB?(0,$.localize)(1,null,ce.toFixed(0)):ce<Q.MB?(0,$.localize)(2,null,(ce/Q.KB).toFixed(2)):ce<Q.GB?(0,$.localize)(3,null,(ce/Q.MB).toFixed(2)):ce<Q.TB?(0,$.localize)(4,null,(ce/Q.GB).toFixed(2)):(0,$.localize)(5,null,(ce/Q.TB).toFixed(2))}}e.$Gk=Q;function le(ie){const ce=typeof ie=="string"||ie?.scheme===L.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===L.Schemas.file?1024*Q.MB:ce?10*Q.MB:w.$p?50*Q.MB:1024*Q.MB}e.$Hk=le}),define(De[234],Ce([1,0,22,9,196,30]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function A(L,I,v,y,k,p){let h;try{await $(L,I,v,y,k,p)}catch(r){h=r}finally{h&&k.errorTransformer&&(h=k.errorTransformer(h)),typeof h<"u"&&v.error(h),v.end()}}e.$Mp=A;async function $(L,I,v,y,k,p){E(p);const h=await L.open(I,{create:!1});try{E(p);let r=0,s=0,o=k&&typeof k.length=="number"?k.length:void 0,m=D.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),u=k&&typeof k.position=="number"?k.position:0,t=0;do s=await L.read(h,u,m.buffer,t,m.byteLength-t),u+=s,t+=s,r+=s,typeof o=="number"&&(o-=s),t===m.byteLength&&(await v.write(y(m)),m=D.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),t=0);while(s>0&&(typeof o!="number"||o>0)&&E(p)&&w(r,k));if(t>0){let n=t;typeof o=="number"&&(n=Math.min(t,o)),v.write(y(m.slice(0,n)))}}catch(r){throw(0,R.$mk)(r)}finally{await L.close(h)}}function E(L){if(L.isCancellationRequested)throw(0,T.$6)();return!0}function w(L,I){if(typeof I?.limits?.size=="number"&&L>I.limits.size)throw(0,R.$lk)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,36,3,16,12,2,30]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0;function E(r){return r.recursive===!0}e.$Op=E;class w extends T.$Sc{static{this.a=5}constructor(s,o,m,u){super(),this.h=s,this.j=o,this.m=m,this.n=u,this.c=this.B(new T.$Tc),this.f=void 0,this.g=0}s(){const s=new T.$Rc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(o=>this.h(o))),s.add(this.b.onDidLogMessage(o=>this.j(o))),s.add(this.b.onDidError(o=>this.t(o)))}t(s){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pp=w;class L extends w{constructor(s,o,m){super(s,o,m,{type:"node.js",restartOnError:!1})}}e.$Qp=L;class I extends w{constructor(s,o,m){super(s,o,m,{type:"universal",restartOnError:!0})}}e.$Rp=I;function v(r){return r.map(s=>({type:s.type,resource:A.URI.revive(s.resource),cId:s.cId}))}e.$Sp=v;function y(r){const s=new h;for(const o of r)s.processEvent(o);return s.coalesce()}e.$Tp=y;function k(r,s){return typeof s=="string"&&!s.startsWith(D.$sj)&&!(0,f.$ic)(s)?{base:r,pattern:s}:s}e.$Up=k;function p(r,s){const o=[];for(const m of s)o.push((0,D.$wj)(k(r,m)));return o}e.$Vp=p;class h{constructor(){this.a=new Set,this.b=new Map}c(s){return R.$l?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const o=this.b.get(this.c(s));let m=!1;if(o){const u=o.type,t=s.type;o.resource.fsPath!==s.resource.fsPath&&(s.type===2||s.type===1)?m=!0:u===1&&t===2?(this.b.delete(this.c(s)),this.a.delete(o)):u===2&&t===1?o.type=0:u===1&&t===0||(o.type=t)}else m=!0;m&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],o=[];return Array.from(this.a).filter(m=>m.type!==2?(s.push(m),!1):!0).sort((m,u)=>m.resource.fsPath.length-u.resource.fsPath.length).filter(m=>o.some(u=>(0,$.$sk)(m.resource.fsPath,u,!R.$l))?!1:(o.push(m.resource.fsPath),!0)).concat(s)}}}),define(De[235],Ce([1,0,53,8,21,33,3,77,16,12,23,2,100,29,84]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;class p extends A.$Sc{static{this.a=100}static{this.b=75}constructor(s,o,m,u){super(),this.m=s,this.n=o,this.r=m,this.s=u,this.c=this.B(new T.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$8g(t=>this.z(t),p.b)),this.g=(0,k.$Vp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Vp)(this.m.path,this.m.includes):void 0,this.j=new f.$Xd,this.ready=this.t()}async t(){try{const s=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await y.Promises.stat(s);this.B(await this.w(s,o.isDirectory()))}catch(s){s.code!=="ENOENT"?this.D(s):this.G(s)}}async u(s){let o=s.path;try{o=await y.Promises.realpath(s.path),s.path===o&&(o=await(0,v.$6p)(s.path)??s.path),s.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${o})`)}catch{}return o}async w(s,o){if(w.$k&&(0,R.$Xf)(s,"/Volumes/",!0))return this.D(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const m=new f.$Xd(this.j.token),u=new A.$Rc;try{const t=I.URI.file(this.m.path),n=(0,E.$nc)(s),c=(0,D.watch)(s);u.add((0,A.$Qc)(()=>{c.removeAllListeners(),c.close()})),this.G(`Started watching: '${s}'`);const i=new Set;if(o)try{for(const l of await y.Promises.readdir(s))i.add(l)}catch(l){this.D(l)}const a=new Map;u.add((0,A.$Qc)(()=>{for(const[,l]of a)l.dispose();a.clear()})),c.on("error",(l,C)=>{this.D(`Failed to watch ${s} for changes using fs.watch() (${l}, ${C})`),this.dispose()}),c.on("change",(l,C)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${C}`);let S="";if(C&&(S=C.toString(),w.$k&&(S=(0,$.$ol)(S))),!(!S||l!=="change"&&l!=="rename"))if(o)if(l==="rename"){a.get(S)?.dispose();const b=setTimeout(async()=>{if(a.delete(S),S===n&&!await y.Promises.exists(s)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,E.$jc)(s,S));if(m.token.isCancellationRequested)return;let d;g?i.has(S)?d=0:(d=1,i.add(S)):(i.delete(S),d=2),this.y({resource:(0,L.$vg)(t,S),type:d,cId:this.m.correlationId})},p.a);a.set(S,(0,A.$Qc)(()=>clearTimeout(b)))}else{let b;i.has(S)?b=0:(b=1,i.add(S)),this.y({resource:(0,L.$vg)(t,S),type:b,cId:this.m.correlationId})}else if(l==="rename"||S!==n){const b=setTimeout(async()=>{const g=await y.Promises.exists(s);m.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),u.add(await this.w(s,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);u.clear(),u.add((0,A.$Qc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(s)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${s} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{m.dispose(!0),u.dispose()})}y(s,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`),!o&&this.g.some(m=>m(s.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${s.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(m=>m(s.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${s.resource.fsPath}`):this.f.work(s))}z(s){const o=(0,k.$Tp)(s);if(o.length>0){if(this.s)for(const u of o)this.G(` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(s){if(w.$l)return y.Promises.exists(s);try{const o=(0,E.$nc)(s);return(await y.Promises.readdir((0,E.$mc)(s))).some(u=>u===o)}catch(o){return this.G(o),!1}}setVerboseLogging(s){this.s=s}D(s){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}F(s){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}G(s){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$9p=p;async function h(r,s,o,m,u=512){const t=await y.Promises.open(r,"r"),n=Buffer.allocUnsafe(u),c=new f.$Xd(m);let i,a=!1;const l={path:r,excludes:[],recursive:!1},C=new p(l,S=>{(async()=>{for(const{type:b}of S)if(b===0){if(a)return;a=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:g}=await y.Promises.read(t,n,0,u,null);if(!g||c.token.isCancellationRequested)break;s(n.slice(0,g))}}catch(g){i=new Error(g),c.dispose(!0)}finally{a=!1}}})()});return await C.ready,o(),new Promise((S,b)=>{c.token.onCancellationRequested(async()=>{C.dispose();try{await y.Promises.close(t)}catch(g){i=new Error(g)}i?b(i):S()})})}e.$0p=h}),define(De[236],Ce([1,0,4,36,3,12,235]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class $ extends f.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(w){const L=this.j(w),I=L.filter(y=>{const k=this.c.get(y.path);return k?!(0,T.$Aj)(k.request.excludes,y.excludes)||!(0,T.$Aj)(k.request.includes,y.includes):!0}),v=Array.from(this.c.values()).filter(({request:y})=>!L.find(k=>k.path===y.path&&(0,T.$Aj)(k.excludes,y.excludes)&&(0,T.$Aj)(k.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.h(y);for(const y of I)this.g(y)}g(w){const L=new A.$9p(w,v=>this.a.fire(v),v=>this.b.fire(v),this.f),I={request:w,instance:L};this.c.set(w.path,I)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const L=this.c.get(w);L&&(this.c.delete(w),L.instance.dispose())}j(w){const L=new Map;for(const I of w){const v=R.$l?I.path:I.path.toLowerCase();let y=L.get(I.correlationId);y||(y=new Map,L.set(I.correlationId,y)),y.set(v,I)}return Array.from(L.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,L]of this.c)L.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,L){return L?`[File Watcher (node.js)] ${w} (path: ${L.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$$p=$}),define(De[237],Ce([1,0,84,236]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class f extends D.$Qp{constructor(A,$,E){super(A,$,E),this.s()}r(A){return A.add(new T.$$p)}}e.$_p=f}),define(De[238],Ce([1,0,18,81,183,84]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class A extends R.$Rp{constructor(E,w,L){super(E,w,L),this.s()}r(E){const w=E.add(new f.$3p(D.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(w.onDidProcessExit(({code:L,signal:I})=>this.t(`terminated by itself with code ${L}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$wh)(w.getChannel("watcher")))}}e.$4p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class D{constructor(...f){this.a=new Map;for(const[R,A]of f)this.set(R,A)}set(f,R){const A=this.a.get(f);return this.a.set(f,R),A}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Nh=D}),define(De[239],Ce([1,0,8,9,3,102,230,5,104,76]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const L=!1;class I extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class v{constructor(h=new E.$Nh,r=!1,s,o=L){this.f=h,this.g=r,this.h=s,this.i=o,this.o=new Set,this.f.set($.$Oh,this),this._globalGraph=o?s?._globalGraph??new A.$cq(m=>m):void 0}createChild(h){return new v(h,this.g,this,this.i)}invokeFunction(h,...r){const s=k.traceInvocation(this.i,h);let o=!1;try{return h({get:u=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,s);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...r)}finally{o=!0,s.stop()}}createInstance(h,...r){let s,o;return h instanceof R.$Mh?(s=k.traceCreation(this.i,h.ctor),o=this.j(h.ctor,h.staticArguments.concat(r),s)):(s=k.traceCreation(this.i,h),o=this.j(h,r,s)),s.stop(),o}j(h,r=[],s){const o=$._util.getServiceDependencies(h).sort((t,n)=>t.index-n.index),m=[];for(const t of o){const n=this.m(t.id,s);n||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const u=o.length>0?o[0].index:r.length;if(r.length!==u){console.trace(`[createInstance] First service dependency of ${h.name} at position ${u+1} conflicts with ${r.length} static arguments`);const t=u-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,u)}return Reflect.construct(h,r.concat(m))}k(h,r){if(this.f.get(h)instanceof R.$Mh)this.f.set(h,r);else if(this.h)this.h.k(h,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const r=this.f.get(h);return!r&&this.h?this.h.l(h):r}m(h,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const s=this.l(h);return s instanceof R.$Mh?this.q(h,s,r.branch(h,!0)):(r.branch(h,!1),s)}q(h,r,s){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,r,s)}finally{this.o.delete(h)}}r(h,r,s){const o=new A.$cq(t=>t.id.toString());let m=0;const u=[{id:h,desc:r,_trace:s}];for(;u.length;){const t=u.pop();if(o.lookupOrInsertNode(t),m++>1e3)throw new I(o);for(const n of $._util.getServiceDependencies(t.desc.ctor)){const c=this.l(n.id);if(c||this.u(`[createInstance] ${h} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),c instanceof R.$Mh){const i={id:n.id,desc:c,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,i),u.push(i)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new I(o);break}for(const{data:n}of t){if(this.l(n.id)instanceof R.$Mh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}o.removeNode(n)}}return this.l(h)}s(h,r,s=[],o,m){if(this.f.get(h)instanceof R.$Mh)return this.t(h,r,s,o,m);if(this.h)return this.h.s(h,r,s,o,m);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(h,r,s=[],o,m){if(o){const u=new v(void 0,this.g,this,this.i);u.c=String(h);const t=new Map,n=new D.$$g(()=>{const c=u.j(r,s,m);for(const[i,a]of t){const l=c[i];if(typeof l=="function")for(const C of a)l.apply(c,C)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let C=t.get(i);return C||(C=new w.$2c,t.set(i,C)),(b,g,d)=>{const P=C.push([b,g,d]);return(0,f.$Qc)(P)}}if(i in c)return c[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),c[i]=l),l},set(c,i,a){return n.value[i]=a,!0},getPrototypeOf(c){return r.prototype}})}else return this.j(r,s,m)}u(h,r){if(r&&console.warn(h),this.g)throw new Error(h)}}e.$dq=v;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(h,r){return h?new k(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(h,r){return h?new k(1,r.name):k.c}static{this.f=0}constructor(h,r){this.type=h,this.name=r,this.g=Date.now(),this.h=[]}branch(h,r){const s=new k(3,h.toString());return this.h.push([h,r,s]),s}stop(){const h=Date.now()-this.g;k.f+=h;let r=!1;function s(m,u){const t=[],n=new Array(m+1).join("	");for(const[c,i,a]of u.h)if(i&&a){r=!0,t.push(`${n}CREATES -> ${c}`);const l=s(m+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${c}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(h>2||r)&&k.all.add(o.join(`
`))}}e.$eq=k}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,v.$Ph)("logService"),e.$$i=(0,v.$Ph)("loggerService");function y(){return new Date().toISOString()}function k(b){return(0,w.$Cf)(b)}e.$_i=k;var p;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$aj=p.Info;function h(b,g,d){switch(g){case p.Trace:b.trace(d);break;case p.Debug:b.debug(d);break;case p.Info:b.info(d);break;case p.Warning:b.warn(d);break;case p.Error:b.error(d);break;case p.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=h;function r(b,g=!1){let d="";for(let P=0;P<b.length;P++){let N=b[P];if(N instanceof Error&&(N=(0,D.$Ai)(N,g)),typeof N=="object")try{N=JSON.stringify(N)}catch{}d+=(P>0?" ":"")+N}return d}class s extends R.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new T.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==p.Off&&this.b<=g}}e.$cj=s;class o extends s{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...d){this.f(p.Trace)&&this.g(p.Trace,r([g,...d],!0))}debug(g,...d){this.f(p.Debug)&&this.g(p.Debug,r([g,...d]))}info(g,...d){this.f(p.Info)&&this.g(p.Info,r([g,...d]))}warn(g,...d){this.f(p.Warning)&&this.g(p.Warning,r([g,...d]))}error(g,...d){if(this.f(p.Error))if(g instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=g.stack,this.g(p.Error,r(P))}else this.g(p.Error,r([g,...d]))}flush(){}}e.$dj=o;class m extends s{constructor(g=e.$aj){super(),this.setLevel(g),this.g=!$.$j}trace(g,...d){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...d):console.log(`[main ${y()}]`,g,...d))}debug(g,...d){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...d):console.log(`[main ${y()}]`,g,...d))}info(g,...d){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...d):console.log(`[main ${y()}]`,g,...d))}warn(g,...d){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,g,...d):console.warn(`[main ${y()}]`,g,...d))}error(g,...d){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,g,...d):console.error(`[main ${y()}]`,g,...d))}dispose(){}flush(){}}e.$ej=m;class u extends s{constructor(g=e.$aj,d=!0){super(),this.g=d,this.setLevel(g)}trace(g,...d){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...d):console.log(g,...d))}debug(g,...d){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...d):console.log(g,...d))}info(g,...d){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...d):console.log(g,...d))}warn(g,...d){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...d):console.log(g,...d))}error(g,...d){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...d):console.error(g,...d))}dispose(){}flush(){}}e.$fj=u;class t extends s{constructor(g,d=e.$aj){super(),this.g=g,this.setLevel(d)}trace(g,...d){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(g),...d])}debug(g,...d){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(g),...d])}info(g,...d){this.f(p.Info)&&this.g.log(p.Info,[this.h(g),...d])}warn(g,...d){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(g),...d])}error(g,...d){this.f(p.Error)&&this.g.log(p.Error,[this.h(g),...d])}h(g){return typeof g=="string"?g:(0,D.$Ai)(g,this.f(p.Trace))}dispose(){}flush(){}}e.$gj=t;class n extends s{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const d of this.g)d.setLevel(g);super.setLevel(g)}trace(g,...d){for(const P of this.g)P.trace(g,...d)}debug(g,...d){for(const P of this.g)P.debug(g,...d)}info(g,...d){for(const P of this.g)P.info(g,...d)}warn(g,...d){for(const P of this.g)P.warn(g,...d)}error(g,...d){for(const P of this.g)P.error(g,...d)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.$hj=n;class c extends R.$Sc{constructor(g,d,P){if(super(),this.h=g,this.j=d,this.b=new A.$Ac,this.c=this.B(new T.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(g){return(0,w.$yf)(g)?[...this.b.values()].find(d=>d.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,d){const P=this.n(g),N=(0,w.$yf)(g)?g:d?.id??(0,f.$Di)(P.toString()).toString(16);let F=this.b.get(P)?.logger;const M=d?.logLevel==="always"?p.Trace:d?.logLevel;F||(F=this.s(P,M??this.getLogLevel(P)??this.h,{...d,id:N}));const U={logger:F,info:{resource:P,id:N,logLevel:M,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId,when:d?.when}};return this.registerLogger(U.info),this.b.set(P,U),F}n(g){return(0,w.$yf)(g)?(0,E.$vg)(this.j,`${g}.log`):g}setLogLevel(g,d){if(L.URI.isUri(g)){const P=g,N=d,F=this.b.get(P);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([P,N]))}else{this.h=g;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,d){const P=this.m(g);P&&d!==!P.info.hidden&&(P.info.hidden=!d,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,d]))}getLogLevel(g){let d;return g&&(d=this.b.get(g)?.info.logLevel),d??this.h}registerLogger(g){const d=this.b.get(g.resource);d?d.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const d=this.b.get(g);d&&(d.logger&&d.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[d.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=c;class i{constructor(){this.onDidChangeLogLevel=new T.$Nd().event}setLevel(g){}getLevel(){return p.Info}trace(g,...d){}debug(g,...d){}info(g,...d){}warn(g,...d){}error(g,...d){}critical(g,...d){}dispose(){}flush(){}}e.$jj=i;class a extends i{}e.$kj=a;function l(b){if(b.verbose)return p.Trace;if(typeof b.logLevel=="string"){const g=S(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.$aj}e.$lj=l;function C(b){switch(b){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$mj=C;function S(b){switch(b){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$nj=S,e.$oj=new I.$7i("logLevel",C(p.Info))}),define(De[240],Ce([1,0,19,8,9,4,3,16,84,14]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class L extends A.$Sc{constructor(v,y){super(),this.a=v,this.b=y,this.c=this.B(new R.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Rg(0)),this.w=[],this.y=this.B(new T.$Rg(0))}watch(v,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(v,y):this.z(v,y)}n(v,y){const k={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,D.$Ub)(this.j,k);return this.r(),(0,A.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,f.$1)(v))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Sp)(y)),y=>this.G(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.j)(0,E.$Op)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.j)(0,E.$Op)(y)&&v.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,y){const k={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,D.$Ub)(this.w,k);return this.C(),(0,A.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,f.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,E.$Sp)(v)),v=>this.G(v),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,$.$hc)(v.fsPath)}}e.$Wp=L}),define(De[241],Ce([1,0,53,376,8,28,22,4,33,3,16,12,23,96,29,197,30,234,240,41,238,237]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.$Ai)(n)}`)}})();class t extends s.$Wp{static{this.I=!1}constructor(c,i){super(c,i),this.onDidChangeCapabilities=$.Event.None,this.N=new R.$Ac(a=>v.$mg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(c){try{const{stat:i,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(c));return{type:this.M(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:h.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const i=await k.Promises.readdir(this.H(c),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let C;l.isSymbolicLink()?C=(await this.stat((0,v.$vg)(c,l.name))).type:C=this.M(l),a.push([l.name,C])}catch(C){this.a.trace(C)}})),a}catch(i){throw this.fb(i)}}M(c,i){let a;return i?.dangling?a=h.FileType.Unknown:c.isFile()?a=h.FileType.File:c.isDirectory()?a=h.FileType.Directory:a=h.FileType.Unknown,i&&(a|=h.FileType.SymbolicLink),a}async O(c){const i=this.H(c);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.N.get(c);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new f.$Sg;return this.N.set(c,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(c)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(c)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(c,i){let a;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(c)})`),a=await this.O(c));const l=this.H(c);return await k.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{a?.dispose()}}P(c){t.I&&this.a.trace(c)}readFileStream(c,i,a){const l=(0,y.$2d)(C=>A.$be.concat(C.map(S=>A.$be.wrap(S))).buffer);return(0,r.$Mp)(this,c,l,C=>C.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(c,i,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(c)?this.R(c,(0,v.$vg)((0,v.$ug)(c),`${(0,v.$sg)(c)}${a.atomic.postfix}`),i,a):this.S(c,i,a)}async Q(c){try{const i=this.H(c),{symbolicLink:a}=await k.SymlinkSupport.stat(i);if(a)return!1}catch{}return!0}async R(c,i,a,l){const C=new w.$Rc;try{C.add(await this.O(c)),C.add(await this.O(i)),await this.S(i,a,l,!0);try{await this.rename(i,c,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{C.dispose()}}async S(c,i,a,l){let C;try{const S=this.H(c);if(!a.create||!a.overwrite){if(await k.Promises.exists(S)){if(!a.overwrite)throw(0,h.$lk)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,h.$lk)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}C=await this.open(c,{create:!0,unlock:a.unlock},l),await this.write(C,0,i,0,i.byteLength)}catch(S){throw await this.gb(c,S)}finally{typeof C=="number"&&await this.close(C)}}static{this.Y=!0}static configureFlushOnWrite(c){t.Y=c}async open(c,i,a){const l=this.H(c);let C;(0,h.$_j)(i)&&!a&&(C=await this.O(c));let S;try{if((0,h.$_j)(i)&&i.unlock)try{const{stat:g}=await k.SymlinkSupport.stat(l);g.mode&128||await k.Promises.chmod(l,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let b;if((0,h.$_j)(i)){if(I.$j)try{await k.Promises.truncate(l,0),b="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}b||(b="w")}else b="r";S=await k.Promises.open(l,b)}catch(b){throw C?.dispose(),(0,h.$_j)(i)?await this.gb(c,b):this.fb(b)}if(this.U.set(S,0),(0,h.$_j)(i)&&this.X.set(S,c),C){const b=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${l})`),this.W.set(S,C),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${l})`),b.dispose())}return S}async close(c){const i=this.W.get(c);try{if(this.U.delete(c),this.X.delete(c)&&t.Y)try{await k.Promises.fdatasync(c)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(c)}catch(a){throw this.fb(a)}finally{i&&(this.W.get(c)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.W.delete(c)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),i.dispose())}}async read(c,i,a,l,C){const S=this.Z(c,i);let b=null;try{b=(await k.Promises.read(c,a,l,C,S)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(c,S,b)}return b}Z(c,i){return i===this.U.get(c)?null:i}$(c,i,a){const l=this.U.get(c);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.U.set(c,l+a):this.U.delete(c)))}async write(c,i,a,l,C){return(0,f.$_g)(()=>this.ab(c,i,a,l,C),100,3)}async ab(c,i,a,l,C){const S=this.Z(c,i);let b=null;try{b=(await k.Promises.write(c,a,l,C,S)).bytesWritten}catch(g){throw await this.gb(this.X.get(c),g)}finally{this.$(c,S,b)}return b}async mkdir(c){try{await k.Promises.mkdir(this.H(c))}catch(i){throw this.fb(i)}}async delete(c,i){try{const a=this.H(c);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,L.$jc)((0,L.$mc)(a),`${(0,L.$nc)(a)}${i.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,l)}else try{await k.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let C=!1;try{const{stat:S,symbolicLink:b}=await k.SymlinkSupport.stat(a);C=S.isDirectory()&&!b}catch{}if(C)await k.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.fb(a)}}async rename(c,i,a){const l=this.H(c),C=this.H(i);if(l!==C)try{await this.bb(c,i,"move",a.overwrite),await k.Promises.rename(l,C)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,L.$nc)(l),(0,L.$nc)((0,L.$mc)(C)),S.toString()))),this.fb(S)}}async copy(c,i,a){const l=this.H(c),C=this.H(i);if(l!==C)try{await this.bb(c,i,"copy",a.overwrite),await k.Promises.copy(l,C,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,L.$nc)(l),(0,L.$nc)((0,L.$mc)(C)),S.toString()))),this.fb(S)}}async bb(c,i,a,l){const C=this.H(c),S=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,E.$Wf)(C,S,!0)),b){if(a==="copy")throw(0,h.$lk)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const d=await this.L(c);if(!d)throw(0,h.$lk)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!l)throw(0,h.$lk)((0,p.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);d.type&h.FileType.File&&P.type&h.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,i){return this.cb(c,i,!1)}async cb(c,i,a){const l=this.H(c),C=this.H(i),S=!!(this.capabilities&1024);if((0,E.$Wf)(l,C,!S))return;const b=new w.$Rc;try{b.add(await this.O(c)),b.add(await this.O(i)),a&&await k.Promises.mkdir((0,L.$mc)(C),{recursive:!0}),await k.Promises.copyFile(l,C)}catch(g){if(g.code==="ENOENT"&&!a)return this.cb(c,i,!0);throw this.fb(g)}finally{b.dispose()}}t(c,i,a){return new m.$4p(l=>c(l),l=>i(l),a)}F(c,i,a){return new u.$_p(l=>c(l),l=>i(l),a)}fb(c){if(c instanceof h.$kk)return c;let i=c,a;switch(c.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=h.FileSystemProviderErrorCode.Unknown;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.$lk)(i,a)}async gb(c,i){let a=this.fb(i);if(c&&a.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await k.SymlinkSupport.stat(this.H(c));l.mode&128||(a=(0,h.$lk)(i,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.$aq=t}),define(De[242],Ce([1,0,3,14]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;class f extends D.$Sc{constructor(A,$=[]){super(),this.a=new T.$hj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$IN=f}),define(De[243],Ce([1,0,30,14]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;var f;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(f||(f={}));async function R(w,L,I,v,y){try{const k=await new Promise((h,r)=>{$e(["@vscode/spdlog"],h,r)});k.setFlushOn(f.Trace);const p=await k.createAsyncRotatingLogger(w,L,I,v);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(k){console.error(k)}return null}function A(w,L,I){switch(L){case T.LogLevel.Trace:w.trace(I);break;case T.LogLevel.Debug:w.debug(I);break;case T.LogLevel.Info:w.info(I);break;case T.LogLevel.Warning:w.warn(I);break;case T.LogLevel.Error:w.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function $(w,L){switch(L){case T.LogLevel.Trace:w.setLevel(f.Trace);break;case T.LogLevel.Debug:w.setLevel(f.Debug);break;case T.LogLevel.Info:w.setLevel(f.Info);break;case T.LogLevel.Warning:w.setLevel(f.Warning);break;case T.LogLevel.Error:w.setLevel(f.Error);break;case T.LogLevel.Off:w.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class E extends T.$dj{constructor(L,I,v,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(L,I,v,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&$(this.r,p)}))}async s(L,I,v,y){const k=v?6:1,p=30/k*D.$Gk.MB,h=await R(L,I,p,k,y);if(h){this.r=h,$(this.r,this.getLevel());for(const{level:r,message:s}of this.m)A(this.r,r,s);this.m=[]}}g(L,I){this.r?A(this.r,L,I):this.getLevel()<=L&&this.m.push({level:L,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$xN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function w(k,p){return p-k}E.compare=w;const L=Object.create(null);L[E.Error]=(0,T.localize)(0,null),L[E.Warning]=(0,T.localize)(1,null),L[E.Info]=(0,T.localize)(2,null);function I(k){return L[k]||""}E.toString=I;function v(k){switch(k){case D.default.Error:return E.Error;case D.default.Warning:return E.Warning;case D.default.Info:return E.Info;case D.default.Ignore:return E.Hint}}E.fromSeverity=v;function y(k){switch(k){case E.Error:return D.default.Error;case E.Warning:return D.default.Warning;case E.Info:return D.default.Info;case E.Hint:return D.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var $;(function(E){const w="";function L(v){return I(v,!0)}E.makeKey=L;function I(v,y){const k=[w];return v.source?k.push(v.source.replace("\xA6","\\\xA6")):k.push(w),v.code?typeof v.code=="string"?k.push(v.code.replace("\xA6","\\\xA6")):k.push(v.code.value.replace("\xA6","\\\xA6")):k.push(w),v.severity!==void 0&&v.severity!==null?k.push(A.toString(v.severity)):k.push(w),v.message&&y?k.push(v.message.replace("\xA6","\\\xA6")):k.push(w),v.startLineNumber!==void 0&&v.startLineNumber!==null?k.push(v.startLineNumber.toString()):k.push(w),v.startColumn!==void 0&&v.startColumn!==null?k.push(v.startColumn.toString()):k.push(w),v.endLineNumber!==void 0&&v.endLineNumber!==null?k.push(v.endLineNumber.toString()):k.push(w),v.endColumn!==void 0&&v.endColumn!==null?k.push(v.endColumn.toString()):k.push(w),k.push(w),k.join("\xA6")}E.makeKeyOptionalMessage=I})($||(e.IMarkerData=$={})),e.$_s=(0,f.$Ph)("markerService")}),define(De[244],Ce([1,0,4,38,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Zu=e.Severity=void 0,e.Severity=T.default,e.$Zu=(0,f.$Ph)("notificationService");var R;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new w,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$1u=E;class w{infinite(){}done(){}total(I){}worked(I){}}e.$2u=w}),define(De[134],Ce([1,0,15,2,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mU=e.$lU=e.$kU=e.$jU=e.$iU=void 0,e.$iU=(0,f.$Ph)("openerService");function R(w,L){return T.URI.isUri(w)?(0,D.$2e)(w.scheme,L):(0,D.$3e)(w,L+":")}e.$jU=R;function A(w,...L){return L.some(I=>R(w,I))}e.$kU=A;function $(w,L){return w.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.$lU=$;function E(w){let L;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(w.fragment);return I&&(L={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},w=w.with({fragment:""})),{selection:L,uri:w}}e.$mU=E}),define(De[245],Ce([1,0,12,48]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const R=D.$h.vscode.context.configuration();if(R)f=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:R.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(De[135],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,D.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(D,T){e(D,T,$e)}};define(De[64],Ce([1,0,8,21,3,5]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProgressLocation=e.$3u=void 0,e.$3u=(0,R.$Ph)("progressService");var A;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$4u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(v){this.b=v}report(v){this.a=v,this.b(this.a)}}e.$5u=$;class E{get value(){return this.a}constructor(v){this.e=v}report(v){this.b?this.b.push(v):this.b=[v],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const v=this.b.shift();this.a=v,await this.e(this.a)}}finally{this.c=!1;const v=this.d;this.d=void 0,v?.()}}drain(){return this.c?new Promise(v=>{const y=this.d;this.d=()=>{y?.(),v()}}):Promise.resolve()}}e.$6u=E;let w=class extends f.$Sc{constructor(v,y){super(),this.a=new D.$ch,y.withProgress(v,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$Qc)(()=>this.a.complete()))}report(v){this.b?this.b.report(v):this.c=v}};e.$7u=w,e.$7u=w=He([Be(1,e.$3u)],w);class L extends f.$Sc{constructor(v){super(),this.g=v,this.a=0,this.b=this.B(new f.$Rc)}start(v){this.stop();const y=++this.a,k=new T.$Xd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},v),this.b.add((0,f.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Qc)(()=>k.cancel())),this.b.add((0,f.$Qc)(()=>this.c?this.c.done():void 0)),{id:y,token:k.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(v){this.a===v&&this.b.clear()}}e.$8u=L,e.$9u=(0,R.$Ph)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class f{constructor(){this.a=new Map}add(A,$){D.ok(T.$yf(A)),D.ok(T.$Af($)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new f}),define(De[105],Ce([1,0,4,43]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function f($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class R{constructor(){this.b=new D.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,w){this.a[f(E)]=w,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;T.$gn.add(e.$hn.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,17,188,50,105,43]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var w;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$ln={Configuration:"base.contributions.configuration"};var L;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const I=E.$gn.as($.$hn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new T.$Nd,this.onDidSchemaChange=this.i.event,this.j=new T.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const c=new Set;this.n(t,n,c),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const c=new Set;this.o(n,c),this.n(t,!1,c),I.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const c=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.$vn.test(l)){const C=this.a.get(l),S=C?.valuesSources??new Map;if(a)for(const P of Object.keys(i[l]))S.set(P,a);const b={...C?.value||{},...i[l]};this.a.set(l,{source:a,value:b,valuesSources:S});const g=(0,A.$ti)(l),d={type:"object",default:b,description:R.localize(1,null,g),$ref:e.$sn,defaultDefaultValue:b,source:f.$yf(a)?void 0:a,defaultValueSource:a};c.push(...p(l)),this.d[l]=d,this.b.properties[l]=d}else{this.a.set(l,{value:i[l],source:a});const C=this.d[l];C&&(this.w(l,C),this.r(l,C))}this.m(c)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:c,source:i}of t)for(const a in c){const l=this.a.get(a),C=f.$yf(i)?i:i?.id,S=f.$yf(l?.source)?l?.source:l?.source?.id;if(C===S)if(n.add(a),this.a.delete(a),e.$vn.test(a))delete this.d[a],delete this.b.properties[a];else{const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}}this.u()}deltaConfiguration(t){let n=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,c){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,c),this.c.push(i),this.q(i)})}o(t,n){const c=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>c(a))};for(const i of t){c(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,c,i,a=3,l){a=f.$Hf(t.scope)?a:t.scope;const C=t.properties;if(C)for(const b in C){const g=C[b];if(n&&o(b,g)){delete C[b];continue}if(g.source=c,g.defaultDefaultValue=C[b].default,this.w(b,g),e.$vn.test(b)?g.scope=void 0:(g.scope=f.$Hf(g.scope)?a:g.scope,g.restricted=f.$Hf(g.restricted)?!!i?.includes(b):g.restricted),C[b].hasOwnProperty("included")&&!C[b].included){this.f[b]=C[b],delete C[b];continue}else this.d[b]=C[b],C[b].policy?.name&&this.e.set(C[b].policy.name,b);!C[b].deprecationMessage&&C[b].markdownDeprecationMessage&&(C[b].deprecationMessage=C[b].markdownDeprecationMessage),l.add(b)}const S=t.allOf;if(S)for(const b of S)this.p(b,n,c,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=c=>{const i=c.properties;if(i)for(const l in i)this.r(l,i[l]);c.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$mn.properties[t]=n,n.scope){case 1:e.$nn.properties[t]=n;break;case 2:e.$on.properties[t]=n;break;case 6:e.$pn.properties[t]=n;break;case 3:e.$qn.properties[t]=n;break;case 4:e.$rn.properties[t]=n;break;case 5:e.$rn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$mn.properties[t],n.scope){case 1:delete e.$nn.properties[t];break;case 2:delete e.$on.properties[t];break;case 6:delete e.$pn.properties[t];break;case 3:delete e.$qn.properties[t];break;case 4:case 5:delete e.$rn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,c={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$sn};this.w(n,c),e.$mn.properties[n]=c,e.$nn.properties[n]=c,e.$on.properties[n]=c,e.$pn.properties[n]=c,e.$qn.properties[n]=c,e.$rn.properties[n]=c}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=t,e.$nn.patternProperties[e.$un]=t,e.$on.patternProperties[e.$un]=t,e.$pn.patternProperties[e.$un]=t,e.$qn.patternProperties[e.$un]=t,e.$rn.patternProperties[e.$un]=t,this.i.fire()}w(t,n){const c=this.a.get(t);let i=c?.value,a=c?.source;f.$Ff(i)&&(i=n.defaultDefaultValue,a=void 0),f.$Ff(i)&&(i=r(n.type)),n.default=i,n.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$un=`^(${y})+$`,e.$vn=new RegExp(e.$un);function p(u){const t=[];if(e.$vn.test(u)){let n=k.exec(u);for(;n?.length;){const c=n[1].trim();c&&t.push(c),n=k.exec(u)}}return(0,D.$Mb)(t)}e.$wn=p;function h(u){return u.reduce((t,n)=>`${t}[${n}]`,"")}e.$xn=h;function r(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=r;const s=new v;E.$gn.add(e.$ln.Configuration,s);function o(u,t){return u.trim()?e.$vn.test(u)?R.localize(7,null,u):s.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):t.policy?.name&&s.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,u,t.policy?.name,s.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$zn=o;function m(){const u=[],t=s.getConfigurationProperties();for(const n of Object.keys(t))u.push([n,t[n].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$An=m}),define(De[246],Ce([1,0,19,4,157,3,28,24,17,2,50,136,43]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function y(n){return Object.isFrozen(n)?n:$.$8m(n)}class k{constructor(c={},i=[],a=[],l){this.b=c,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(i=>{if(i instanceof k)return i;const a=new p("");return a.parseRaw(i),a.configurationModel});this.f=c.reduce((i,a)=>a===i?a:i.merge(a),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,L.$ri)(this.contents,c):this.contents}inspect(c,i){const a=this.rawConfiguration.getValue(c),l=i?this.rawConfiguration.getOverrideValue(c,i):void 0,C=i?this.rawConfiguration.override(i).getValue(c):a;return{value:a,override:l,merged:C}}getOverrideValue(c,i){const a=this.i(i);return a?c?(0,L.$ri)(a,c):a:void 0}getKeysForOverrideIdentifier(c){const i=[];for(const a of this.overrides)a.identifiers.includes(c)&&i.push(...a.keys);return D.$Mb(i)}getAllOverrideIdentifiers(){const c=[];for(const i of this.overrides)c.push(...i.identifiers);return D.$Mb(c)}override(c){let i=this.a.get(c);return i||(i=this.g(c),this.a.set(c,i)),i}merge(...c){const i=$.$7m(this.contents),a=$.$7m(this.overrides),l=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const S of c)if(C.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const b of S.overrides){const[g]=a.filter(d=>D.$ub(d.identifiers,b.identifiers));g?(this.h(g.contents,b.contents),g.keys.push(...b.keys),g.keys=D.$Mb(g.keys)):a.push($.$7m(b))}for(const b of S.keys)l.indexOf(b)===-1&&l.push(b)}return new k(i,l,a,C.every(S=>S instanceof k)?void 0:C)}g(c){const i=this.i(c);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of D.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let C=this.contents[l];const S=i[l];S&&(typeof C=="object"&&typeof S=="object"?(C=$.$7m(C),this.h(C,S)):C=S),a[l]=C}return new k(a,this.keys,this.overrides)}h(c,i){for(const a of Object.keys(i)){if(a in c&&E.$Af(c[a])&&E.$Af(i[a])){this.h(c[a],i[a]);continue}c[a]=$.$7m(i[a])}}i(c){let i=null,a=null;const l=C=>{C&&(a?this.h(a,C):a=$.$7m(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===c?i=C.contents:C.identifiers.includes(c)&&l(C.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,i){this.j(c,i,!0)}setValue(c,i){this.j(c,i,!1)}removeValue(c){const i=this.keys.indexOf(c);i!==-1&&(this.keys.splice(i,1),(0,L.$qi)(this.contents,c),I.$vn.test(c)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,I.$wn)(c))),1))}j(c,i,a){(0,L.$pi)(this.contents,c,i,l=>console.error(l)),a=a||this.keys.indexOf(c)===-1,a&&this.keys.push(c),I.$vn.test(c)&&this.overrides.push({identifiers:(0,I.$wn)(c),keys:Object.keys(this.contents[c]),contents:(0,L.$oi)(this.contents[c],l=>console.error(l))})}}e.$Bn=k;class p{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,i){if(!E.$Hf(c)){const a=this.g(c);this.parseRaw(a,i)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,i){this.a=c;const{contents:a,keys:l,overrides:C,restricted:S,hasExcludedProperties:b}=this.h(c,i);this.b=new k(a,l,C,b?[c]:void 0),this.c=S||[]}g(c){let i={},a=null,l=[];const C=[],S=[];function b(d){Array.isArray(l)?l.push(d):a!==null&&(l[a]=d)}const g={onObjectBegin:()=>{const d={};b(d),C.push(l),l=d,a=null},onObjectProperty:d=>{a=d},onObjectEnd:()=>{l=C.pop()},onArrayBegin:()=>{const d=[];b(d),C.push(l),l=d,a=null},onArrayEnd:()=>{l=C.pop()},onLiteralValue:b,onError:(d,P,N)=>{S.push({error:d,offset:P,length:N})}};if(c)try{f.$4m(c,g),i=l[0]||{}}catch(d){console.error(`Error while parsing settings file ${this.f}: ${d}`),this.d=[d]}return i}h(c,i){const a=v.$gn.as(I.$ln.Configuration).getConfigurationProperties(),l=this.i(c,a,!0,i);c=l.raw;const C=(0,L.$oi)(c,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(c),b=this.j(c,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:C,keys:S,overrides:b,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(c,i,a,l){let C=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:C};const S={},b=[];for(const g in c)if(I.$vn.test(g)&&a){const d=this.i(c[g],i,!1,l);S[g]=d.raw,C=C||d.hasExcludedProperties,b.push(...d.restricted)}else{const d=i[g],P=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&b.push(g),!l.exclude?.includes(g)&&(l.include?.includes(g)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&d?.restricted))?S[g]=c[g]:C=!0}return{raw:S,restricted:b,hasExcludedProperties:C}}j(c,i){const a=[];for(const l of Object.keys(c))if(I.$vn.test(l)){const C={};for(const S in c[l])C[S]=c[l][S];a.push({identifiers:(0,I.$wn)(l),keys:Object.keys(C),contents:(0,L.$oi)(C,i)})}return a}}e.$Cn=p;class h extends R.$Sc{constructor(c,i,a,l){super(),this.c=c,this.f=i,this.g=l,this.b=this.B(new T.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&a.isEqual(C.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=h;class r{constructor(c,i,a,l,C,S,b,g,d,P,N,F,M){this.a=c,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=C,this.f=S,this.g=b,this.h=g,this.i=d,this.j=P,this.k=N,this.l=F,this.m=M}get value(){return y(this.c)}n(c,i,a){const l=c.inspect(i,a);return{get value(){return y(l.value)},get override(){return y(l.override)},get merged(){return y(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(c,i,a,l,C=new k,S=new k,b=new A.$Ac,g=new k,d=new A.$Ac){this.c=c,this.d=i,this.f=a,this.g=l,this.h=C,this.i=S,this.j=b,this.l=g,this.m=d,this.a=null,this.b=new A.$Ac,this.n=null}getValue(c,i,a){return this.q(c,i,a).getValue(c)}updateValue(c,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new k,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(c):l.setValue(c,i),a.resource||(this.a=null)}inspect(c,i,a){const l=this.q(c,i,a),C=this.u(i.resource,a),S=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const g of l.overrides)for(const d of g.identifiers)l.getOverrideValue(c,d)!==void 0&&b.add(d);return new r(c,i,l.getValue(c),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,C||void 0,S)}keys(c){const i=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,i){this.j.set(c,i),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,i){const a=[];if(!i){const{added:l,updated:C,removed:S}=u(this.c,c);i=[...l,...C,...S]}for(const l of i)for(const C of(0,I.$wn)(l)){const S=this.c.getKeysForOverrideIdentifier(C),b=c.getKeysForOverrideIdentifier(C),g=[...b.filter(d=>S.indexOf(d)===-1),...S.filter(d=>b.indexOf(d)===-1),...S.filter(d=>!$.$$m(this.c.override(C).getValue(d),c.override(C).getValue(d)))];a.push([C,g])}return this.updateDefaultConfiguration(c),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(c){const{added:i,updated:a,removed:l}=u(this.d,c),C=[...i,...a,...l];return C.length&&this.updatePolicyConfiguration(c),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:i,updated:a,removed:l,overrides:C}=u(this.applicationConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateApplicationConfiguration(c),{keys:S,overrides:C}}compareAndUpdateLocalUserConfiguration(c){const{added:i,updated:a,removed:l,overrides:C}=u(this.localUserConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateLocalUserConfiguration(c),{keys:S,overrides:C}}compareAndUpdateRemoteUserConfiguration(c){const{added:i,updated:a,removed:l,overrides:C}=u(this.remoteUserConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateRemoteUserConfiguration(c),{keys:S,overrides:C}}compareAndUpdateWorkspaceConfiguration(c){const{added:i,updated:a,removed:l,overrides:C}=u(this.workspaceConfiguration,c),S=[...i,...a,...l];return S.length&&this.updateWorkspaceConfiguration(c),{keys:S,overrides:C}}compareAndUpdateFolderConfiguration(c,i){const a=this.p.get(c),{added:l,updated:C,removed:S,overrides:b}=u(a,i),g=[...l,...C,...S];return(g.length||!a)&&this.updateFolderConfiguration(c,i),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(c){const i=this.p.get(c);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:a,updated:l,removed:C,overrides:S}=u(i,void 0);return{keys:[...a,...l,...C],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(l=l.merge(this.d)),l}r({resource:c},i){let a=this.s();if(i&&c){const l=i.getFolder(c);l&&(a=this.t(l.uri)||a);const C=this.m.get(c);C&&(a=a.merge(C))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let i=this.b.get(c);if(!i){const a=this.s(),l=this.j.get(c);l?(i=a.merge(l),this.b.set(c,i)):i=a}return i}u(c,i){if(i&&c){const a=i.getFolder(c);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,i)=>{const{contents:a,overrides:l,keys:C}=this.j.get(i);return c.push([i,{contents:a,overrides:l,keys:C}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(i=>c.add(i)),this.userConfiguration.keys.forEach(i=>c.add(i)),this.i.keys.forEach(i=>c.add(i)),this.j.forEach(i=>i.keys.forEach(a=>c.add(a))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>c.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>c.add(a))),[...c.values()]}w(c){const i=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(c).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(c).forEach(l=>i.add(l))),[...i.values()]}static parse(c){const i=this.x(c.defaults),a=this.x(c.policy),l=this.x(c.application),C=this.x(c.user),S=this.x(c.workspace),b=c.folders.reduce((g,d)=>(g.set(w.URI.revive(d[0]),this.x(d[1])),g),new A.$Ac);return new s(i,a,l,C,new k,S,b,new k,new A.$Ac)}static x(c){return new k(c.contents,c.keys,c.overrides)}}e.$En=s;function o(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const c=new Set,i=new Map;for(const l of n)l.keys.forEach(C=>c.add(C)),l.overrides.forEach(([C,S])=>{const b=(0,A.$xc)(i,C,new Set);S.forEach(g=>b.add(g))});const a=[];return i.forEach((l,C)=>a.push([C,[...l.values()]])),{keys:[...c.values()],overrides:a}}e.$Fn=o;class m{constructor(c,i,a,l){this.change=c,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const C of c.keys)this.affectedKeys.add(C);for(const[,C]of c.overrides)for(const S of C)this.affectedKeys.add(S);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(c,i){const a=this.a+c,l=this.d.indexOf(a);if(l<0)return!1;const C=l+a.length;if(C>=this.d.length)return!1;const S=this.d.charCodeAt(C);if(S!==this.b&&S!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(c,i,this.f?.workspace):void 0,g=this.g.getValue(c,i,this.h);return!$.$$m(b,g)}return!0}}e.$Gn=m;function u(n,c){const{added:i,removed:a,updated:l}=t(c?.rawConfiguration,n?.rawConfiguration),C=[],S=n?.getAllOverrideIdentifiers()||[],b=c?.getAllOverrideIdentifiers()||[];if(c){const g=b.filter(d=>!S.includes(d));for(const d of g)C.push([d,c.getKeysForOverrideIdentifier(d)])}if(n){const g=S.filter(d=>!b.includes(d));for(const d of g)C.push([d,n.getKeysForOverrideIdentifier(d)])}if(c&&n){for(const g of S)if(b.includes(g)){const d=t({contents:n.getOverrideValue(void 0,g)||{},keys:n.getKeysForOverrideIdentifier(g)},{contents:c.getOverrideValue(void 0,g)||{},keys:c.getKeysForOverrideIdentifier(g)});C.push([g,[...d.added,...d.removed,...d.updated]])}}return{added:i,removed:a,updated:l,overrides:C}}function t(n,c){const i=n?c?n.keys.filter(C=>c.keys.indexOf(C)===-1):[...n.keys]:[],a=c?n?c.keys.filter(C=>n.keys.indexOf(C)===-1):[...c.keys]:[],l=[];if(n&&c){for(const C of c.keys)if(n.keys.indexOf(C)!==-1){const S=(0,L.$ri)(c.contents,C),b=(0,L.$ri)(n.contents,C);$.$$m(S,b)||l.push(C)}}return{added:i,removed:a,updated:l}}}),define(De[247],Ce([1,0,22,4,3,82]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkb=e.$Gkb=e.$Fkb=e.$Ekb=void 0;const A=(w,L,I)=>{const v=new Uint8Array(16);for(let p=0;p<16;p++)v[p]=Math.round(Math.random()*256);const y=(0,D.$ve)(D.$be.wrap(v));return[`GET ws://localhost${w}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Ekb=A,e.$Fkb=D.$be.fromString(`\r
\r
`);async function $(w,L,I,v,y){w.write(D.$be.fromString((0,e.$Ekb)(L,I,v)));const k=new f.$Rc;try{return await new Promise((p,h)=>{let r;k.add(w.onData(s=>{r?r=D.$be.concat([r,s],r.byteLength+s.byteLength):r=s;const o=r.indexOf(e.$Fkb);if(o===-1)return;p(w),w.pauseData();const m=r.slice(o+e.$Fkb.byteLength);m.byteLength&&y.onData.fire(m)})),k.add(w.onClose(s=>h(s??new Error("socket closed")))),k.add(w.onEnd(()=>h(new Error("socket ended"))))})}catch(p){throw w.dispose(),p}finally{k.dispose()}}e.$Gkb=$;class E extends f.$Sc{constructor(L,I){super(),this.g=L,this.a=this.B(new T.$Qd),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new T.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(v=>this.a.fire(v))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,L,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Hkb=E}),define(De[65],Ce([1,0,9,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,T.$Ph)("remoteAuthorityResolverService");var f;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=R;class A{constructor(I,v){this.host=I,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var $;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends D.$bb{static isNotAvailable(I){return I instanceof E&&I._code===$.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===$.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===$.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===$.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,v=$.Unknown,y){super(I),this._message=I,this._code=v,this._detail=y,this.isHandled=v===$.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Sk=E;function w(L){const I=L.indexOf("+");return I===-1?L:L.substring(0,I)}e.$Tk=w}),define(De[66],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function T(w){return w.scheme===D.Schemas.vscodeRemote?w.authority:void 0}e.$Uk=T;function f(w){if(!w)return;const L=w.indexOf("+");return L<0?w:w.substr(0,L)}e.$Vk=f;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$Wk=R;function A(w){const{host:L,port:I}=E(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.$Xk=A;function $(w,L){let{host:I,port:v}=E(w);return typeof v>"u"&&(v=L),{host:I,port:v}}e.$Yk=$;function E(w){const L=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=w.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:w,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function R(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$4l=R,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,r){if(typeof h>"u"||h===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof h=="string"||typeof r=="string"){const s=typeof h=="string"?h:h.value,o=typeof r=="string"?r:r.value;return D.$2e(s,o)}return h._lower===r._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$6l=E;class w{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const r of h)this.add(r)}add(h){this.c.add(E.toKey(h))}delete(h){return this.c.delete(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}}e.$7l=w;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(E.toKey(h))}get(h){return this.c.get(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}set(h,r){this.c.set(E.toKey(h),r)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=L;function I(p){return v(p)}e.$9l=I;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$0l=v;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$$l=y;function k(p,h){if(h){const r=`onResolveRemoteAuthority:${(0,f.$Vk)(h)}`;return!!p.activationEvents?.includes(r)}return!1}e.$_l=k,e.$am=(0,T.$Ph)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,9,25]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const w=this.readActivationEvents(E);w.length>0&&($[T.$6l.toKey(E.identifier)]=w)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return $;for(const E in A.contributes){const w=this.a.get(E);if(!w)continue;const L=A.contributes[E],I=Array.isArray(L)?L:[L];try{w(I,$)}catch(v){(0,D.$1)(v)}}return $}}e.$XE=f,e.$YE=new f}),define(De[248],Ce([1,0,8,22,21,9,4,3,54,35,31,82,65,66]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const k=30*1e3;var p;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function h(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function r(H){const B=new f.$Xd;return setTimeout(()=>B.cancel(),H),B.token}function s(H,B){if(H.isCancellationRequested||B.isCancellationRequested)return f.CancellationToken.Cancelled;const X=new f.$Xd;return H.onCancellationRequested(()=>X.cancel()),B.onCancellationRequested(()=>X.cancel()),X.token}class o{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new $.$Rc,this.promise=new Promise((X,re)=>{this.f=X,this.g=re}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function m(H,B){const X=new o(B);return X.registerDisposable(H.onControlMessage(re=>{const Y=JSON.parse(re.toString()),_=G(Y);_?X.reject(_):X.resolve(Y)})),X.promise}function u(H,B,X,re,Y,_,x,ve){const ae=new o(ve),fe=w.$Jd.create(!1);return H.info(`Creating a socket (${x})...`),E.mark(`code/willCreateSocket/${_}`),B.connect(X,re,Y,x).then(ee=>{ae.didTimeout?(E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${_}`),H.info(`Creating a socket (${x}) was successful after ${fe.elapsed()} ms.`),ae.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) returned an error after ${fe.elapsed()} ms.`),H.error(ee),ae.reject(ee)}),ae.promise}function t(H,B){const X=new o(B);return H.then(re=>{X.didTimeout||X.resolve(re)},re=>{X.didTimeout||X.reject(re)}),X.promise}async function n(H,B,X,re){const Y=ce(H,B);H.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let _;try{_=await u(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$Wk)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,h(B),`renderer-${h(B)}-${H.reconnectionToken}`,re)}catch(ee){throw H.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ee),ee}H.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let x,ve;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(_,null),x=H.reconnectionProtocol,ve=!1):(x=new I.$Dh({socket:_}),ve=!0),H.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ae=await t(H.signService.createNewMessage((0,L.$eg)()),re),fe={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ae.data};x.sendControl(T.$be.fromString(JSON.stringify(fe)));try{const ee=await m(x,s(re,r(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const z=new Error("Unexpected handshake message");throw z.code="VSCODE_CONNECTION_ERROR",z}if(H.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await t(H.signService.validate(ae,ee.signedData),re)){const z=new Error("Refused to connect to unsupported server");throw z.code="VSCODE_CONNECTION_ERROR",z}const be=await t(H.signService.sign(ee.data),re),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:B};return X&&(Pe.args=X),H.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(T.$be.fromString(JSON.stringify(Pe))),{protocol:x,ownsProtocol:ve}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(H.logService.error(`${Y} the handshake timed out. Error:`),H.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${Y} received error control message when negotiating connection. Error:`),H.logService.error(ee)),ve&&te(x),ee}}async function c(H,B,X,re){const Y=Date.now(),_=ce(H,B),{protocol:x,ownsProtocol:ve}=await n(H,B,X,re),ae=new o(re);return ae.registerDisposable(x.onControlMessage(fe=>{const ee=JSON.parse(fe.toString()),de=G(ee);de?(H.logService.error(`${_} received error control message when negotiating connection. Error:`),H.logService.error(de),ve&&te(x),ae.reject(de)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${pe(Y)}!`),ae.resolve({protocol:x,firstMessage:ee}))})),ae.promise}async function i(H,B){const{protocol:X}=await c(H,1,void 0,B);return{protocol:X}}async function a(H,B,X){const{protocol:re,firstMessage:Y}=await c(H,2,B,X),_=Y&&Y.debugPort;return{protocol:re,debugPort:_}}async function l(H,B,X){const re=Date.now(),Y=ce(H,3),{protocol:_}=await n(H,3,B,X);return H.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${pe(re)}!`),_}async function C(H,B,X){const{connectTo:re,connectionToken:Y}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:re,connectionToken:Y,reconnectionToken:B,reconnectionProtocol:X,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function S(H,B,X){return g(H,async re=>{const{protocol:Y}=await i(re,f.CancellationToken.None);return new V(H,B,X,re.reconnectionToken,Y)})}e.$4k=S;async function b(H,B){return g(H,async X=>{const{protocol:re,debugPort:Y}=await a(X,B,f.CancellationToken.None);return new me(H,B,X.reconnectionToken,re,Y)})}e.$5k=b;async function g(H,B){for(let re=1;;re++)try{const Y=(0,L.$eg)(),_=await C(H,Y,null);return await B(_)}catch(Y){if(re<5)H.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(Y);else throw H.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(Y),K.triggerPermanentFailure(0,0,v.$Sk.isHandled(Y)),Y}}async function d(H,B,X){const re=await C(H,(0,L.$eg)(),null);return await l(re,{host:B,port:X},f.CancellationToken.None)}e.$6k=d;function P(H){return(0,D.$Hg)(B=>new Promise((X,re)=>{const Y=setTimeout(X,H*1e3);B.onCancellationRequested(()=>{clearTimeout(Y),X()})}))}var N;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(B,X){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.type=0}}e.$7k=F;class M{constructor(B,X,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.durationSeconds=re,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$8k=M;class U{constructor(B,X,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=2}}e.$9k=U;class j{constructor(B,X,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=4}}e.$0k=j;class O{constructor(B,X,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.handled=Y,this.type=3}}e.$$k=O;class K extends $.$Sc{static triggerPermanentFailure(B,X,re){this._permanentFailure=!0,this.f=B,this.g=X,this.h=re,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||K._permanentFailure}constructor(B,X,re,Y,_){super(),this.t=B,this.u=X,this.reconnectionToken=re,this.protocol=Y,this.w=_,this.m=this.B(new A.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(x=>{const ve=ie(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${ve} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ve} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ve} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(x=>{const ve=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ve} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),K.j.push(this),this.B((0,$.$Qc)(()=>{const x=K.j.indexOf(this);x>=0&&K.j.splice(x,1)})),this.n&&this.D(K.f,K.g,K.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const X=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const Y=re<X.length?X[re]:X[X.length-1];try{if(Y>0){const x=P(Y);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,x)),this.u.logService.info(`${B} waiting for ${Y} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this.u.logService.info(`${B} resolving connection...`);const _=await C(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${_.connectTo}...`),await this.G(_,r(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(v.$Sk.isTemporarilyNotAvailable(_)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,R.$4)(_)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof v.$Sk){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,v.$Sk.isHandled(_));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this.n&&!this.s)}C(B,X,re){this.w?K.triggerPermanentFailure(B,X,re):this.D(B,X,re)}D(B,X,re){this.m.fire(new O(this.reconnectionToken,B,X,re)),te(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=K;class V extends K{constructor(B,X,re,Y,_){super(1,B,Y,_,!0),this.client=this.B(new I.$Bh(_,{remoteAuthority:X,clientId:re},B.ipcLogger))}async G(B,X){await i(B,X)}}e.$al=V;class me extends K{constructor(B,X,re,Y,_){super(2,B,re,Y,!1),this.H=X,this.debugPort=_}async G(B,X){await a(B,this.H,X)}}e.$bl=me;function te(H){try{H.acceptDisconnect();const B=H.getSocket();H.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(H){if(H&&H.type==="error"){const B=new Error(`Connection error: ${H.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Q(H,B){for(;H.length<B;)H+=" ";return H}function le(H,B){return`[remote-connection][${Q(h(H),13)}][${B.substr(0,5)}\u2026]`}function ie(H,B,X){return`${le(H,B)}[${X?"reconnect":"initial"}]`}function ce(H,B){return`${ie(B,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function pe(H){return`${Date.now()-H} ms`}}),define(De[249],Ce([1,0,3,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,T.$Ph)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(A,$){return this.a[A]??=[],this.a[A].push($),(0,D.$Qc)(()=>{const E=this.a[A]?.indexOf($);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,$,E,w){const L=this.b(A);if(!L)throw new Error(`No socket factory found for ${A}`);return L.connect(A,$,E,w)}}e.$1k=f}),define(De[250],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w3b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const R=await this.c();if(R){const A=String(D.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const A=this.b.get(f.id);if(!A)return!1;this.b.delete(f.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$w3b=D}),define(De[106],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,D.$Ph)(e.$2k)}),define(De[138],Ce([1,0,250]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=void 0;class T extends D.$w3b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>$e(["vsda"],R,A))}}e.$r8b=T}),define(De[251],Ce([1,0,12,48,31]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function R(E){if(D.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,w,L,I,v,y,k,p,h){const r=Object.create(null);r["common.machineId"]=y,r["common.sqmId"]=k,r.sessionID=(0,f.$eg)()+Date.now(),r.commitHash=I,r.version=v,r["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,D.$i)(D.$u),r["common.nodePlatform"]=T.$dc,r["common.nodeArch"]=L,r["common.product"]=h||"desktop",p&&(r["common.msftInternal"]=p);let s=0;const o=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),D.$m&&(r["common.snap"]="true");const m=R(w);return m&&(r["common.platformDetail"]=m),r}e.$ho=A;function $(E){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const L=w.toLowerCase();return E.some(I=>L===I)}e.$io=$}),define(De[252],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,D.$Ph)("telemetryService"),e.$dl=(0,D.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(De[85],Ce([1,0,24,17,4,50,66,251,252]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class w{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$jo=w;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=L,e.$lo=new L;class I{async publicLog(a,l,C){}async publicLogError(a,l,C){}}e.$mo=I,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,a){return f.Event.debounce(a.onDidChangeConfiguration,(C,S)=>{const b=C?new Set([...C.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:b}},1e3,!0)(C=>{C.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.$mi)(C.source),configurationKeys:Array.from(C.affectedKeys)})})}e.$qo=v;function y(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry)}e.$ro=y;function k(i,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$so=k;function p(i){const a=i.getValue(E.$kl),l=i.getValue(E.$ll);if(i.getValue(E.$ml)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=p;function h(i){const a={},l={},C={};o(i,C);for(let S in C){S=S.length>150?S.substr(S.length-149):S;const b=C[S];typeof b=="number"?l[S]=b:typeof b=="boolean"?l[S]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${b.length}`),a[S]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(a[S]=b)}return{properties:a,measurements:l}}e.$uo=h;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const a=(0,A.$Vk)(i);return r.has(a)?a:"other"}e.$vo=s;function o(i,a,l=0,C){if(i)for(const S of Object.getOwnPropertyNames(i)){const b=i[S],g=C?C+S:S;Array.isArray(b)?a[g]=(0,D.$_m)(b):b instanceof Date?a[g]=b.toISOString():(0,T.$Af)(b)?l<2?o(b,a,l+1,g+"."):a[g]=(0,D.$_m)(b):a[g]=b}}function m(i,a){const l=i.msftInternalDomains||[],C=a.getValue("telemetry.internalTesting");return(0,$.$io)(l)||C}e.$wo=m;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$xo=u;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const C=[];for(const d of a)for(;;){const P=d.exec(i);if(!P)break;C.push([P.index,d.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(l="";;){const d=b.exec(i);if(!d)break;const P=C.some(([N,F])=>d.index<F&&N<b.lastIndex);!S.test(d[0])&&!P&&(l+=i.substring(g,d.index)+"<REDACTED: user-file-path>",g=b.lastIndex)}return g<i.length&&(l+=i.substr(g)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function c(i,a){return(0,D.$9m)(i,l=>{if(l instanceof w||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let C=l.replaceAll("%20"," ");C=t(C,a);for(const S of a)C=C.replace(S,"");return C=n(C),C}})}e.$yo=c}),define(De[253],Ce([1,0,15,132,25,12,2,9,48,85]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function L(c,i){return c.uuid&&i.uuid?c.uuid===i.uuid:c.id===i.id?!0:(0,D.$We)(c.id,i.id)===0}e.$zo=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,a,l)}static parse(i){const a=I.exec(i);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?L(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ao=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(c){const i=y.exec(c);return i&&i[1]?[h(i[1]),i[2]]:[h(c),void 0]}e.$Bo=k;function p(c,i){return`${c}.${i}`}e.$Co=p;function h(c){return c.toLowerCase()}e.$Do=h;function r(c,i){return h(p(c??f.$2l,i))}e.$Eo=r;function s(c,i){const a=[],l=C=>{for(const S of a)if(S.some(b=>L(i(b),i(C))))return S;return null};for(const C of c){const S=l(C);S?S.push(C):a.push([C])}return a}e.$Fo=s;function o(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Go=o;function m(c){return{id:new w.$jo(c.identifier.id),name:new w.$jo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Ho=m,e.$Io=new f.$6l("pprice.better-merge");function u(c,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const C=l.shift();if(C&&a.every(S=>!L(S.identifier,{id:C}))){const S=c.filter(b=>L(b.identifier,{id:C}));S.length===1&&(a.push(S[0]),l.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Jo=u;async function t(c,i){if(!R.$l)return!1;let a;try{a=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){i.debug("Error while getting the os-release file.",(0,$.$0)(C))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(c,i){const a=await t(c,i),l=(0,T.$6n)(a?"alpine":R.$u,E.$ec);return i.debug("ComputeTargetPlatform:",l),l}e.$Ko=n}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;function D(E){return[...E.entries()]}e.$kr=D;function T(E){return E?[...E.entries()]:[]}e.$lr=T;function f(E){return new Map(E)}e.$mr=f;function R(E){return new Map(E??[])}e.$nr=R;function A(E){return Array.from(E.entries()).map(w=>[w[0],D(w[1].map),T(w[1].descriptionMap)])}e.$or=A;function $(E){return new Map(E.map(w=>[w[0],{map:f(w[1]),descriptionMap:R(w[2])}]))}e.$pr=$}),define(De[255],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykb=void 0;class D{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,A=5){const $=R(E=>{const w=typeof E=="string"?E:E.data;let L=this.a.get(f);if(L){L.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(f),A);L={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),$.dispose()}},this.a.set(f,L)});return $}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$Ykb=D}),define(De[256],Ce([1,0,8,79,59,4,17,2,199,105,43]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var I;(function(m){function u(t,n){let c=t.defaults;for(;f.ThemeIcon.isThemeIcon(c);){const i=k.getIcon(c.id);if(!i)return;c=i.defaults}return c}m.getDefinition=u})(I||(e.IconContribution=I={}));var v;(function(m){function u(n){return{weight:n.weight,style:n.style,src:n.src.map(c=>({format:c.format,location:c.location.toString()}))}}m.toJSONObject=u;function t(n){const c=i=>(0,A.$yf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$yf)(i.format)&&(0,A.$yf)(i.location)))return{weight:c(n.weight),style:c(n.style),src:n.src.map(i=>({format:i.format,location:$.URI.parse(i.location)}))}}m.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class y{constructor(){this.a=new R.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,t,n,c){const i=this.b[u];if(i){if(n&&!i.description){i.description=n,this.d.properties[u].markdownDescription=`${n} $(${u})`;const C=this.e.enum.indexOf(u);C!==-1&&(this.e.enumDescriptions[C]=n),this.a.fire()}return i}const a={id:u,description:n,defaults:t,deprecationMessage:c};this.b[u]=a;const l={$ref:"#/definitions/icons"};return c&&(l.deprecationMessage=c),n&&(l.markdownDescription=`${n}: $(${u})`),this.d.properties[u]=l,this.e.enum.push(u),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const t=this.e.enum.indexOf(u);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,t){const n=this.f[u];return n||(this.f[u]=t,this.a.fire(),t)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(i,a)=>i.id.localeCompare(a.id),t=i=>{for(;f.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(i=>this.b[i]);for(const i of c.filter(a=>!!a.description).sort(u))n.push(`|<i class="${t(i)}"></i>|${i.id}|${f.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of c.filter(a=>!f.ThemeIcon.isThemeIcon(a.defaults)).sort(u))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const k=new y;L.$gn.add(e.$5v.IconContribution,k);function p(m,u,t,n){return k.registerIcon(m,u,t,n)}e.$6v=p;function h(){return k}e.$7v=h;function r(){const m=(0,T.$Sj)();for(const u in m){const t="\\"+m[u].toString(16);k.registerIcon(u,{fontCharacter:t})}}r(),e.$8v="vscode://schemas/icons";const s=L.$gn.as(w.$hn.JSONContribution);s.registerSchema(e.$8v,k.getIconSchema());const o=new D.$6g(()=>s.notifySchemaChanged(e.$8v),200);k.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$9v=p("widget-close",T.$Uj.close,(0,E.localize)(2,null)),e.$0v=p("goto-previous-location",T.$Uj.arrowUp,(0,E.localize)(3,null)),e.$$v=p("goto-next-location",T.$Uj.arrowDown,(0,E.localize)(4,null)),e.$_v=f.ThemeIcon.modify(T.$Uj.sync,"spin"),e.$aw=f.ThemeIcon.modify(T.$Uj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,f.$Ph)("tunnelService"),e.$$u=(0,f.$Ph)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(h){return!!h.forwardPort}e.$_u=E;var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function L(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(r)return{address:r[1],port:+r[2]}}e.$av=L,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.$bv.indexOf(h)>=0}e.$cv=I,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(h){return e.$dv.indexOf(h)>=0}e.$ev=v;function y(h,r,s,o){if(s===1)return!1;if(s===2&&v(r)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(m?.length===4&&parseInt(m[1])>=18)return!1}return h<1024}e.$fv=y;class k{constructor(r,s,o){this.remoteAddress=r,this.localAddress=s,this.b=o,this.a=new D.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=k;let p=class{constructor(r,s){this.j=r,this.k=s,this.a=new D.$Nd,this.onTunnelOpened=this.a.event,this.b=new D.$Nd,this.onTunnelClosed=this.b.event,this.c=new D.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const r=this.k.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.h=r.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const r=[],s=Array.from(this.e.values());for(const o of s){const m=Array.from(o.values());for(const u of m){const t=await u.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:s}of r.values())await s.then(o=>typeof o!="string"?o?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,s,o,m,u){this.p(r,s,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:s,localAddress:o,privacy:m,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,s){(v(r)||I(r))&&(r=e.$bv[0]);const o=this.r(r,s);if(o)return++o.refcount,o.value}openTunnel(r,s,o,m,u,t=!1,n,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${o} on local port ${u}.`);const i=this.f??r;if(!i)return;if(s||(s="localhost"),m||(m=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(i,s,o,m,u,t,n,c);return a?a.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,o),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.n(l);return(l.tunnelRemoteHost!==s||l.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&l.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(C),C}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const s=this.e.get(r.tunnelRemoteHost);if(s){const o=s.get(r.tunnelRemotePort);o&&(o.refcount--,await this.o(r.tunnelRemoteHost,r.tunnelRemotePort,o))}}}}async o(r,s,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${s}.`);const m=o.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(s),m}}async closeTunnel(r,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${s} `);const o=this.e.get(r);if(o&&o.has(s)){const m=o.get(s);m.refcount=0,await this.o(r,s,m)}}p(r,s,o){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(s,{refcount:1,value:o})}async q(r,s){const o=this.e.get(r);if(o){const m=o.get(s),u=m?await m.value:void 0;(!u||typeof u=="string")&&o.delete(s),o.size===0&&this.e.delete(r)}}r(r,s){const o=[r];I(r)?(o.push(...e.$bv),o.push(...e.$dv)):v(r)&&o.push(...e.$dv);const m=o.map(u=>this.e.get(u));for(const u of m){const t=u?.get(s);if(t)return t}}canTunnel(r){return!!L(r)}t(r,s,o,m,u,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${o} on local port ${m}.`);const c=o;this.i.add(c);const i=m===void 0?o:m,a={elevationRequired:u?this.isPortPrivileged(i):!1},l={remoteAddress:{host:s,port:o},localAddressPort:m,privacy:t,public:t?t!==$.Private:void 0,protocol:n},C=r.forwardPort(l,a);return C?(this.p(s,o,C),C.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),C}};e.$hv=p,e.$hv=p=He([Be(0,R.$0i),Be(1,T.$ji)],p)}),define(De[257],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,D.$Ph)("IUriIdentityService")}),define(De[258],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,D.$Ph)("editSessionIdentityService");var T;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[259],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=void 0;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.$TJ=T;function f(E){if(E.folders.length)return E.folders.every(w=>T(w.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$UJ=f;function R(E){return f(E)?.scheme}e.$VJ=R;function A(E){return f(E)?.authority}e.$WJ=A;function $(E){return f(E)!==void 0}e.$XJ=$}),define(De[44],Ce([1,0,201,16,78,23,2,5,18]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,$.$Ph)("contextService");function w(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$Zh=w;function L(i){return typeof i?.id=="string"&&!w(i)&&!v(i)}e.$1h=L,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function I(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.$nc)(i)}:a?e.$2h:e.$3h;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$4h=I;function v(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$5h=v;function y(i){const a=i;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$6h=y;var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function p(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$7h=p;function h(i){const a=i;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$8h=h;class r{constructor(a,l,C,S,b){this.h=a,this.j=C,this.k=S,this.l=b,this.c=f.$Vh.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=f.$Vh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=r;class s{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$vg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=s;function o(i){return new s({uri:i,index:0,name:(0,R.$rg)(i)},{uri:i.toString()})}e.$$h=o,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,D.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function m(i,a){return R.$mg.isEqualOrParent(i,a.untitledWorkspacesHome)}e.$di=m;function u(i){let a;return A.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===E.Schemas.tmp}e.$ei=u,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$fi}e.$gi=t;function n(i,a){return!m(i,a)&&!u(i)}e.$hi=n;function c(i){return(typeof i=="string"?(0,T.$oc)(i):(0,R.$tg)(i))===e.$ai}e.$ii=c}),define(De[260],Ce([1,0,52,4,3,23,2,200,131,30,5,14,44,28,257,8,31,15,17]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var o;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(o||(e.ProfileResourceType=o={}));function m(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$Jk=m,e.$Kk=(0,L.$Ph)("IUserDataProfilesService");function u(i,a){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:a}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:a}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=u;function t(i,a,l,C,S,b){return{id:i,name:a,location:l,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:b&&S?.useDefaultFlags?.globalState?b.globalStorageHome:(0,R.$vg)(l,"globalStorage"),settingsResource:b&&S?.useDefaultFlags?.settings?b.settingsResource:(0,R.$vg)(l,"settings.json"),keybindingsResource:b&&S?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,R.$vg)(l,"keybindings.json"),tasksResource:b&&S?.useDefaultFlags?.tasks?b.tasksResource:(0,R.$vg)(l,"tasks.json"),snippetsHome:b&&S?.useDefaultFlags?.snippets?b.snippetsHome:(0,R.$vg)(l,"snippets"),extensionsResource:b&&S?.useDefaultFlags?.extensions?b.extensionsResource:(0,R.$vg)(l,"extensions.json"),cacheHome:(0,R.$vg)(C,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Mk=t;let n=class extends f.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,C,S){super(),this.t=a,this.u=l,this.w=C,this.y=S,this.f=!0,this.h=this.B(new T.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,s.$yf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}l.push(t((0,R.$sg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},a))}}catch(b){this.y.error(b)}const C=new y.$Ac,S=new Map;if(l.length)try{const b=this.Q();if(b.workspaces)for(const[g,d]of Object.entries(b.workspaces)){const P=A.URI.parse(g),N=l.find(F=>F.id===d);N&&C.set(P,N)}if(b.emptyWindows)for(const[g,d]of Object.entries(b.emptyWindows)){const P=l.find(N=>N.id===d);P&&S.set(g,P)}}catch(b){this.y.error(b)}this.z={profiles:l,workspaces:C,emptyWindows:S}}return this.z}D(){const a=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",C=new RegExp(`${(0,r.$Fe)(l)}\\s(\\d+)`);let S=0;for(const g of this.profiles){const d=C.exec(g.name),P=d?parseInt(d[1]):0;S=P>S?P:S}const b=`${l} ${S+1}`;return this.createProfile((0,D.$Di)((0,h.$eg)()).toString(16),b,{transient:!0},a)}async createNamedProfile(a,l,C){return this.createProfile((0,D.$Di)((0,h.$eg)()).toString(16),a,l,C)}async createProfile(a,l,C,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(a,l,C);return S&&await this.setProfileForWorkspace(S,b),b}async F(a,l,C){if(!(0,s.$yf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(l);return S||(S=(async()=>{try{const b=this.profiles.find(P=>P.name===l||P.id===a);if(b)return b;const g=t(a,l,(0,R.$vg)(this.profilesHome,a),this.g,C,this.defaultProfile);await this.u.createFolder(g.location);const d=[];return this.j.fire({profile:g,join(P){d.push(P)}}),await p.Promises.settled(d),this.I([g],[],[]),g}finally{this.r.delete(l)}})(),this.r.set(l,S)),S}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let C=this.profiles.find(S=>S.id===a.id);if(!C)throw new Error(`Profile '${a.name}' does not exist`);return C=t(C.id,l.name??C.name,C.location,this.g,{shortName:l.shortName??C.shortName,icon:l.icon===null?void 0:l.icon??C.icon,transient:l.transient??C.isTransient,useDefaultFlags:l.useDefaultFlags??C.useDefaultFlags},this.defaultProfile),this.I([],[],[C]),C}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(S=>S.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const C=[];this.m.fire({profile:l,join(S){C.push(S)}});try{await Promise.allSettled(C)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(S){(0,w.$pk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=this.profiles.find(S=>S.id===l.id);if(!C)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,C)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(C=>!this.w.extUri.isEqual(C.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a);return A.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(a){return(0,v.$Zh)(a)?a.uri:(0,v.$5h)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,C){const S=[...this.profiles,...a],b=[];this.s.profiles=[];for(let g of S)g.isDefault||l.some(d=>g.id===d.id)||(g=C.find(d=>g.id===d.id)??g,g.isTransient?this.s.profiles.push(g):b.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P(b),this.z=void 0,this.J(a,l,C)}J(a,l,C){this.h.fire({added:a,removed:l,updated:C,all:this.profiles})}L(a,l,C){C=l?.isTransient?!0:C,C||this.L(a,void 0,!0);const S=this.G(a),b=C?this.s:this.C;A.URI.isUri(S)?(b.workspaces.delete(S),l&&b.workspaces.set(S,l)):(b.emptyWindows.delete(S),l&&b.emptyWindows.set(S,l)),C||this.M()}M(){const a={};for(const[C,S]of this.C.workspaces.entries())a[C.toString()]=S.id;const l={};for(const[C,S]of this.C.emptyWindows.entries())l[C.toString()]=S.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},C=this.D();if(a.workspaces)for(const[b,g]of Object.entries(a.workspaces)){const d=A.URI.parse(g);l[b]=this.w.extUri.isEqual(d,C.location)?C.id:this.w.extUri.basename(d)}const S={};if(a.emptyWindows)for(const[b,g]of Object.entries(a.emptyWindows)){const d=A.URI.parse(g);S[b]=this.w.extUri.isEqual(d,C.location)?C.id:this.w.extUri.basename(d)}return{workspaces:l,emptyWindows:S}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Nk=n,e.$Nk=n=He([Be(0,E.$Wh),Be(1,w.$$j),Be(2,k.$Ik),Be(3,I.$0i)],n);class c extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Ok=c}),define(De[261],Ce([1,0,8,4,3,54,17,184,5,260]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$6o=e.$5o=e.$4o=void 0,e.$4o="__$__isNewStorageMarker",e.$5o="__$__targetStorageMarker",e.$6o=(0,E.$Ph)("storageService");var L;(function(s){s[s.NONE=0]="NONE",s[s.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var I;(function(s){s[s.APPLICATION=-1]="APPLICATION",s[s.PROFILE=0]="PROFILE",s[s.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(s){s[s.USER=0]="USER",s[s.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(s){const o=s.get(e.$5o);if(o)try{return JSON.parse(o)}catch{}return Object.create(null)}e.$7o=y;class k extends f.$Sc{static{this.a=60*1e3}constructor(o={flushInterval:k.a}){super(),this.m=o,this.b=this.B(new T.$Qd),this.c=this.B(new T.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(o,m,u){return T.Event.filter(this.b.event,t=>t.scope===o&&(m===void 0||t.key===m),u)}n(){this.j.value=(0,D.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(o,m){const{key:u,external:t}=m;if(u===e.$5o){switch(o){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:o})}else this.b.fire({scope:o,key:u,target:this.J(o)[u],external:t})}w(o){this.f.fire({reason:o})}get(o,m,u){return this.P(m)?.get(o,u)}getBoolean(o,m,u){return this.P(m)?.getBoolean(o,u)}getNumber(o,m,u){return this.P(m)?.getNumber(o,u)}getObject(o,m,u){return this.P(m)?.getObject(o,u)}storeAll(o,m){this.y(()=>{for(const u of o)this.store(u.key,u.value,u.scope,u.target,m)})}store(o,m,u,t,n=!1){if((0,A.$Hf)(m)){this.remove(o,u,n);return}this.y(()=>{this.z(o,u,t),this.P(u)?.set(o,m,n)})}remove(o,m,u=!1){this.y(()=>{this.z(o,m,void 0),this.P(m)?.delete(o,u)})}y(o){this.b.pause(),this.c.pause();try{o()}finally{this.b.resume(),this.c.resume()}}keys(o,m){const u=[],t=this.J(o);for(const n of Object.keys(t))t[n]===m&&u.push(n);return u}z(o,m,u,t=!1){const n=this.J(m);typeof u=="number"?n[o]!==u&&(n[o]=u,this.P(m)?.set(e.$5o,JSON.stringify(n),t)):typeof n[o]=="number"&&(delete n[o],this.P(m)?.set(e.$5o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(o){switch(o){case-1:return this.I;case 0:return this.G;default:return this.D}}L(o){const m=this.P(o);return m?y(m):Object.create(null)}isNew(o){return this.getBoolean(e.$4o,o)===!0}async flush(o=L.NONE){this.f.fire({reason:o});const m=this.P(-1),u=this.P(0),t=this.P(1);switch(o){case L.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const o=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return r(o,m,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(o){return await this.flush(),this.P(o)?.optimize()}async switch(o,m){return this.w(L.NONE),(0,w.$Jk)(o)?this.R(o,m):this.S(o,m)}M(o,m){return!(o.id===m.id||p(m)&&p(o))}N(o,m,u){this.y(()=>{const t=new Set;for(const[n,c]of o)t.add(n),m.get(n)!==c&&this.u(u,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(u,{key:n,external:!0})})}}e.$8o=k;function p(s){return s.isDefault||!!s.useDefaultFlags?.globalState}e.$9o=p;class h extends k{constructor(){super(),this.U=this.B(new $.$2o(new $.$3o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$2o(new $.$3o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$2o(new $.$3o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(o=>this.u(1,o))),this.B(this.W.onDidChangeStorage(o=>this.u(0,o))),this.B(this.U.onDidChangeStorage(o=>this.u(-1,o)))}P(o){switch(o){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(o){switch(o){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(o){return!1}}e.$0o=h;async function r(s,o,m,u,t,n){const c=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,a=new Map;s.forEach((P,N)=>{i.set(N,P),a.set(N,c(P))});const l=new Map,C=new Map;o.forEach((P,N)=>{l.set(N,P),C.set(N,c(P))});const S=new Map,b=new Map;m.forEach((P,N)=>{S.set(N,P),b.set(N,c(P))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const g=[];if(i.forEach((P,N)=>{g.push({key:N,value:P})}),console.table(g),console.groupEnd(),console.log(a),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((N,F)=>{P.push({key:F,value:N})}),console.table(P),console.groupEnd(),console.log(C)}console.group(`Storage: Workspace (path: ${n})`);const d=[];S.forEach((P,N)=>{d.push({key:N,value:P})}),console.table(d),console.groupEnd(),console.log(b)}e.$$o=r}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class D{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hcc=D}),define(De[55],Ce([1,0,18,23,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=void 0;class R{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$kg($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$jcc=R,e.$kcc=(0,f.$Ph)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=void 0,e.$BM=(0,D.$Ph)("IExtHostInitDataService")}),define(De[262],Ce([1,0,207,14,242,27]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;let A=class extends f.$IN{constructor(E,w,L){const I=L.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",v=L.remote.isRemote?(0,D.localize)(0,null):E?(0,D.localize)(1,null):(0,D.localize)(2,null);super(w.createLogger(I,{name:v}))}};e.$sec=A,e.$sec=A=He([Be(1,T.$$i),Be(2,R.$BM)],A)}),define(De[263],Ce([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0;class T{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new D.$6g(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of w.values())L.complete()}catch(L){for(const I of w.values())I.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const w=new D.$ch;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Mcc=T;class f extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$Ncc=f}),define(De[264],Ce([1,0,4,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class f{constructor(A){this.c=A,this.a=new D.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,w){const I=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged($.value,E,w);this.b.fire(I)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire($.apiNotebook)}}e.$_dc=f}),define(De[20],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0,e.$lM=(0,D.$Ph)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$mM=T}),define(De[265],Ce([1,0,25,4]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class f{#e;constructor(A,$){this.b=new T.$Nd,this.onDidChange=this.b.event,this.a=D.$6l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$Ycc=f}),define(De[67],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0,e.$ucc=(0,D.$Ph)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$vcc=T}),define(De[266],Ce([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=e.$Dcb=void 0;class T{constructor(){this.buffers=[]}add(E){let w=this.buffers.indexOf(E);return w<0&&(w=this.buffers.length,this.buffers.push(E)),w}}function f($,E){if(E.serializeBuffersForPostMessage){const w=new T,I=JSON.stringify($,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(k)};if(ArrayBuffer.isView(k)){const p=R(k);if(p)return{$$vscode_array_buffer_reference$$:!0,index:w.add(k.buffer),view:{type:p,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),v=w.buffers.map(y=>{const k=new Uint8Array(y);return D.$be.wrap(k)});return{message:I,buffers:v}}else return{message:JSON.stringify($),buffers:[]}}e.$Dcb=f;function R($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const w=E.map(v=>{const y=new ArrayBuffer(v.byteLength);return new Uint8Array(y).set(v.buffer),y}),L=E.length?(v,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:p}=k,h=w[p];if(k.view)switch(k.view.type){case 1:return new Int8Array(h,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return y}:void 0;return{message:JSON.parse($,L),arrayBuffers:w}}e.$Ecb=A}),define(De[267],Ce([1,0,268,377,378,60,2,14,379]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;const w=!1;function L(o,m,u,t,n,c){const i=c.environment.useHostProxy,a=typeof i=="boolean"?i:!c.remote.isRemote,l={resolveProxy:b=>o.resolveProxy(b),lookupProxyAuthorization:h.bind(void 0,t,n,m,{},c.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(m),getSystemCertificatesV2:()=>y(m),log:(b,g,...d)=>{switch(b){case E.LogLevel.Trace:t.trace(g,...d);break;case E.LogLevel.Debug:t.debug(g,...d);break;case E.LogLevel.Info:t.info(g,...d);break;case E.LogLevel.Warning:t.warn(g,...d);break;case E.LogLevel.Error:t.error(g,...d);break;case E.LogLevel.Critical:t.error(g,...d);break;case E.LogLevel.Off:break;default:P(b,g,d);break}function P(N,F,...M){t.error("Unknown log level",N),t.error(F,...M)}},getLogLevel:()=>{const b=t.getLevel();switch(b){case $.LogLevel.Trace:return E.LogLevel.Trace;case $.LogLevel.Debug:return E.LogLevel.Debug;case $.LogLevel.Info:return E.LogLevel.Info;case $.LogLevel.Warning:return E.LogLevel.Warning;case $.LogLevel.Error:return E.LogLevel.Error;case $.LogLevel.Off:return E.LogLevel.Off;default:return g(b)}function g(d){return t.error("Unknown log level",d),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},C=(0,E.createProxyResolver)(l),S=I(l,C);return p(u,S)}e.$1ec=L;function I(o,m){return{http:Object.assign(D,(0,E.createHttpPatch)(o,D,m)),https:Object.assign(T,(0,E.createHttpPatch)(o,T,m)),net:Object.assign(R,(0,E.createNetPatch)(o,R)),tls:Object.assign(f,(0,E.createTlsPatch)(o,f))}}function v(o){const m=o.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function y(o){const m=o.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const k=new Map;function p(o,m){return o.getExtensionPathIndex().then(u=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,a,l){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const C=u.findSubstr(A.URI.file(a.filename));let S=k.get(C);if(S||k.set(C,S={}),!S[i]){const b=m[i];S[i]={...b}}return S[i]}})}async function h(o,m,u,t,n,c,i,a){const l=t[c];i&&(t[c]=i),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${l}`);const C=i||l,S=Array.isArray(C)?C:typeof C=="string"?[C]:[];if(s(m,S,n),S.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const b=await new Promise((F,M)=>{$e(["kerberos"],F,M)}),g=new URL(c),d=u.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${d}`),"Negotiate "+await(await b.initializeClient(d)).step("")}catch(b){o.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let r=!1;function s(o,m,u){r||!m.length||(r=!0,o.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:u?"remote":"local"}))}}),define(De[269],Ce([1,0,128]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;function T(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(R){return new D.$Lm(T(R))}e.$Ar=f}),define(De[139],Ce([1,0,217,17,2,3,5,43,30,18,41,176,38]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.$fE=e.EditorsOrder=e.$eE=e.CloseDirection=e.$dE=e.$cE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.EditorInputCapabilities=e.$6D=e.SaveReason=e.Verbosity=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=void 0,e.$TD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$UD={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$VD="workbench.editor.sidebysideEditor",e.$WD="workbench.editors.textDiffEditor",e.$XD="workbench.editors.binaryResourceDiffEditor";var y;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function p(ce){const pe=ce;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.$YD=p;function h(ce,pe,H){for(const B of H.visibleEditorPanes)if(B.group.id===pe&&ce.matches(B.input))return B.getViewState()}e.$ZD=h;function r(ce){if(l(ce))return!1;const pe=ce;return f.URI.isUri(pe?.resource)}e.$1D=r;function s(ce){if(l(ce))return!1;const pe=ce;return pe?.original!==void 0&&pe.modified!==void 0}e.$2D=s;function o(ce){if(l(ce)||s(ce))return!1;const pe=ce;return pe?.primary!==void 0&&pe.secondary!==void 0}e.$3D=o;function m(ce){if(l(ce))return!1;const pe=ce;return pe?pe.resource===void 0||pe.resource.scheme===w.Schemas.untitled||pe.forceUntitled===!0:!1}e.$4D=m;function u(ce){if(l(ce))return!1;const pe=ce;return f.URI.isUri(pe?.base?.resource)&&f.URI.isUri(pe?.input1?.resource)&&f.URI.isUri(pe?.input2?.resource)&&f.URI.isUri(pe?.result?.resource)}e.$5D=u;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class c{constructor(){this.a=new Map}registerSource(pe,H){let B=this.a.get(pe);return B||(B={source:pe,label:H},this.a.set(pe,B)),B.source}getSourceLabel(pe){return this.a.get(pe)?.label??pe}}e.$6D=new c;var i;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(i||(e.EditorInputCapabilities=i={}));class a extends R.$Sc{}e.$7D=a;function l(ce){return ce instanceof a}e.$8D=l;function C(ce){const pe=ce;return f.URI.isUri(pe?.preferredResource)}function S(ce){const pe=ce;return l(pe?.primary)&&l(pe?.secondary)}e.$9D=S;function b(ce){const pe=ce;return l(pe?.modified)&&l(pe?.original)}e.$0D=b;function g(ce,pe,H,B,X){return ie(B,[(0,I.$zi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const re={...H,limits:{size:Number.MAX_VALUE}};ce.openEditor(pe,re)}}),(0,I.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$$D=g;function d(ce){return l(ce?.editor)}e.$_D=d;function P(ce){const pe=ce;return d(ce)&&pe?.group!==void 0}e.$aE=P;function N(ce){const pe=ce;return typeof pe?.groupId=="number"&&l(pe.editor)}e.$bE=N;var F;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var M;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var U;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class j{getOriginalUri(pe,H){if(!pe)return;if(u(pe))return e.$dE.getOriginalUri(pe.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(pe);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getOriginalUri(X,{filterByScheme:H.filterByScheme})??this.getOriginalUri(re,{filterByScheme:H.filterByScheme});pe=H.supportSideBySide===U.PRIMARY?X:re}}if(s(pe)||o(pe)||u(pe))return;const B=C(pe)?pe.preferredResource:pe.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}a(pe){return S(pe)||o(pe)?{primary:pe.primary,secondary:pe.secondary}:b(pe)||s(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,H){if(!pe)return;if(u(pe))return e.$dE.getCanonicalUri(pe.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(pe);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getCanonicalUri(X,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:H.filterByScheme});pe=H.supportSideBySide===U.PRIMARY?X:re}}if(s(pe)||o(pe)||u(pe))return;const B=pe.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}b(pe,H){if(Array.isArray(H)){if(H.some(B=>pe.scheme===B))return pe}else if(H===pe.scheme)return pe}}var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function K(ce,pe,H,B){if(!ce.isSticky(pe))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return H===O.MOUSE||H===O.KEYBOARD;case"mouse":return H===O.MOUSE;case"keyboard":return H===O.KEYBOARD}return!1}e.$cE=K,e.$dE=new j;var V;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class me{constructor(){this.c=new Map,this.d=new Map}start(pe){const H=this.a=pe.get(A.$Oh);for(const[B,X]of this.c)this.e(B,X,H);this.c.clear()}e(pe,H,B){const X=B.createInstance(H);this.d.set(pe,X)}registerFileEditorFactory(pe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=pe}getFileEditorFactory(){return(0,T.$Jf)(this.b)}registerEditorSerializer(pe,H){if(this.c.has(pe)||this.d.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.a?this.e(pe,H,this.a):this.c.set(pe,H),(0,R.$Qc)(()=>{this.c.delete(pe),this.d.delete(pe)})}getEditorSerializer(pe){return this.d.get(typeof pe=="string"?pe:pe.typeId)}}$.$gn.add(e.$TD.EditorFactory,new me);async function te(ce,pe,H){return!ce||!ce.length?[]:await Promise.all(ce.map(async B=>{const X=f.URI.revive(B.fileUri);if(!X){H.info("Cannot resolve the path because it is not valid.",B);return}if(!await pe.canHandleResource(X)){H.info("Cannot resolve the path because it cannot be handled",B);return}let Y=B.exists,_=B.type;if(typeof Y!="boolean"||typeof _!="number")try{_=(await pe.stat(X)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Y=!0}catch(ve){H.error(ve),Y=!1}if(!Y&&B.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",B);return}if(_===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",B);return}const x={...B.options,pinned:!0};return Y?{resource:X,options:x}:{resource:X,options:x,forceUntitled:!0}}))}e.$eE=te;var G;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function Q(ce){const pe=ce;if(!pe)return!1;const H=pe;if(H.modified)return Q(H.modified);const B=pe;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$fE=Q;function le(ce){return(0,L.$Bi)(ce)}e.$gE=le;function ie(ce,pe,H){const B=(0,L.$Ci)(ce,pe);return B.forceMessage=H?.forceMessage,B.forceSeverity=H?.forceSeverity,B.allowDialog=H?.allowDialog,B}e.$hE=ie}),define(De[270],Ce([1,0,4,218,5,3,28,43,19,24,79,256]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=e.$rE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$qE=e.$pE=e.ViewContentGroups=e.$oE=e.$nE=e.ViewContainerLocation=e.Extensions=e.$mE=e.$lE=e.$kE=void 0,e.$kE="views",e.$lE=(0,T.localize)(0,null),e.$mE=(0,I.$6v)("default-view-icon",L.$Uj.window,(0,T.localize)(1,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$nE=[0,1,2];function k(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$oE=k;class p extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(c,i,a){const l=this.get(c.id);if(l)return l;const C=c;return C.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.$xc)(this.g,i,[]).push(C),a?.isDefault&&this.h.push(C),this.c.fire({viewContainer:C,viewContainerLocation:i}),C}deregisterViewContainer(c){for(const i of this.g.keys()){const a=this.g.get(i),l=a?.indexOf(c);if(l!==-1){a?.splice(l,1),a.length===0&&this.g.delete(i),this.f.fire({viewContainer:c,viewContainerLocation:i});return}}}get(c){return this.all.filter(i=>i.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(a=>a?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(i=>this.getViewContainerLocation(i)===c)}}$.$gn.add(v.ViewContainersRegistry,new p);var h;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(h||(e.ViewContentGroups=h={}));function r(n,c){const i=n.group??h.More,a=c.group??h.More;return i!==a?i.localeCompare(a):(n.order??5)-(c.order??5)}class s extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(c,i){this.registerViews2([{views:c,viewContainer:i}])}registerViews2(c){c.forEach(({views:i,viewContainer:a})=>this.r(i,a)),this.c.fire(c)}deregisterViews(c,i){const a=this.s(c,i);a.length&&this.f.fire({views:a,viewContainer:i})}moveViews(c,i){for(const a of this.m.keys())if(a!==i){const l=this.s(c,a);l.length&&(this.r(l,i),this.g.fire({views:l,from:a,to:i}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const i of this.j){const a=(this.m.get(i)||[]).filter(l=>l.id===c)[0];if(a)return a}return null}getViewContainer(c){for(const i of this.j)if((this.m.get(i)||[]).filter(l=>l.id===c)[0])return i;return null}registerViewWelcomeContent(c,i){return this.n.add(c,i),this.h.fire(c),(0,R.$Qc)(()=>{this.n.delete(c,i),this.h.fire(c)})}registerViewWelcomeContent2(c,i){const a=new Map;for(const[l,C]of i)this.n.add(c,C),a.set(l,(0,R.$Qc)(()=>{this.n.delete(c,C),this.h.fire(c)}));return this.h.fire(c),a}getViewWelcomeContent(c){const i=[];return this.n.forEach(c,a=>i.push(a)),i.sort(r)}r(c,i){let a=this.m.get(i);a||(a=[],this.m.set(i,a),this.j.push(i));for(const l of c){if(this.getView(l.id)!==null)throw new Error((0,T.localize)(2,null,l.id));a.push(l)}}s(c,i){const a=this.m.get(i);if(!a)return[];const l=[],C=[];for(const S of a)c.includes(S)?l.push(S):C.push(S);return l.length&&(C.length?this.m.set(i,C):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),l}}$.$gn.add(v.ViewsRegistry,new s),e.$pE=(0,f.$Ph)("viewsService"),e.$qE=(0,f.$Ph)("viewDescriptorService");var o;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class u{constructor(c,i){this.c=!1,this.d=!1,(0,w.$0m)(this,c),this.d=!!i,this.resolve=async a=>{if(i&&!this.c){const l=await i(a);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$rE=u;class t extends Error{constructor(c){super((0,T.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$sE=t}),define(De[271],Ce([1,0,2,32,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$TE=e.$SE=void 0;function R(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof D.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$ts.isIRange)}e.$SE=R;function A(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(R)}e.$TE=A;var $;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$UE=(0,f.$Ph)("IChatService")}),define(De[140],Ce([1,0,4,8,219]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new D.$Nd,this.n=new D.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,w,L){const I={command:$};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:$,message:(0,f.localize)(0,null,L,$)};y(k)}},L)}return w&&this.f.set(I.seq,w),I.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$Ug)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,w=this.f.get(E.request_seq);w&&(this.f.delete(E.request_seq),w(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,w)=>$.set(w,E)),await(0,T.$Ug)(500),$.forEach((E,w)=>{E({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$0cb=R}),define(De[272],Ce([1,0,220,42,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$7G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$6G=e.MemoryRangeType=e.$5G=e.State=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$3F="workbench.view.debug",e.$4F="workbench.debug.variablesView",e.$5F="workbench.debug.watchExpressionsView",e.$6F="workbench.debug.callStackView",e.$7F="workbench.debug.loadedScriptsView",e.$8F="workbench.debug.breakPointsView",e.$9F="workbench.debug.disassemblyView",e.$0F="workbench.panel.repl",e.$$F="workbench.panel.repl.view",e.$_F=new T.$7i("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$aG=new T.$7i("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$bG=new T.$7i("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$cG="debugUx",e.$dG=new T.$7i(e.$cG,"default",{type:"string",description:D.localize(3,null)}),e.$eG=new T.$7i("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$fG=new T.$7i("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$gG=new T.$7i("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$hG=new T.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$iG=new T.$7i("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$jG=new T.$7i("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$kG=new T.$7i("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$lG=new T.$7i("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$mG=new T.$7i("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$nG=new T.$7i("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$oG=new T.$7i("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$pG=new T.$7i("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$qG=new T.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$rG=new T.$7i("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$sG=new T.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$tG=new T.$7i("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$uG=new T.$7i("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$vG=new T.$7i("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$wG=new T.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$xG=new T.$7i("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$yG=new T.$7i("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$zG=new T.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$AG=new T.$7i("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.$BG=new T.$7i("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$CG=new T.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.$DG=new T.$7i("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$EG=new T.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$FG=new T.$7i("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.$GG=new T.$7i("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.$HG=new T.$7i("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.$IG=new T.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.$JG=new T.$7i("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.$KG=new T.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$LG=new T.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$MG=new T.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$NG=new T.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$OG=new T.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$PG=new T.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$QG=new T.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.$RG=new T.$7i("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.$SG=new T.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.$TG=new T.$7i("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.$UG=new T.$7i("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.$VG=new T.$7i("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.$WG=new T.$7i("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.$XG=new T.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.$YG=new T.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const R=v=>D.localize(51,null,v);e.$ZG=R,e.$1G="editor.contrib.debug",e.$2G="editor.contrib.breakpoint",e.$3G="debug",e.$4G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var A;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(A||(e.State=A={}));function $(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$5G=$;var E;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$6G="vscode-debug-memory";var w;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$7G=(0,f.$Ph)("debugService");var I;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[273],Ce([1,0,15,2,16,24,18,32,21,19]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=void 0;const L=/{([^}]+)}/g;function I(S,b,g){return S.replace(L,function(d,P){return b&&P.length>0&&P[0]!=="_"?d:g&&g.hasOwnProperty(P)?g[P]:d})}e.$rF=I;function v(S){const b={};for(const g of Object.keys(S))g.startsWith("!")||(b[g]=S[g]);return b}e.$sF=v;function y(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||y(S.parentSession))}e.$tF=y;function k(S){let b=S.configuration.type;if(b)return b==="vslsShare"&&(b=S.configuration.adapterProxy.configuration.type),(0,D.$2e)(b,"extensionhost")||(0,D.$2e)(b,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}e.$uF=k;function p(S){return S.type&&(S.label||S.program||S.runtime)}e.$vF=p;function h(S,b,g){let d,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=N.exec(S);){const M=F.index+1,U=M+F[0].length;if(M<=b&&U>=g){d=F[0],P=M;break}}if(d){const M=/\w+/g;let U=null;for(;(U=M.exec(d))&&!(U.index+1+P+U[0].length>=g););U&&(d=d.substring(0,M.lastIndex))}return d?{start:P,end:P+d.length-1}:{start:0,end:0}}e.$wF=h;async function r(S,b,g,d){if(S.evaluatableExpressionProvider.has(b)){const P=S.evaluatableExpressionProvider.ordered(b),N=(0,w.$Hb)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(b,g,d??E.CancellationToken.None)}catch{return}})));if(N.length>0){let F=N[0].expression;const M=N[0].range;return F||(F=b.getLineContent(g.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:F}}}else{const P=b.getLineContent(g.lineNumber),{start:N,end:F}=h(P,g.column,g.column),M=P.substring(N-1,F);return{matchingExpression:M,range:new $.$ts(g.lineNumber,N,g.lineNumber,N+M.length)}}return null}e.$xF=r;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(S){return!!(S&&S.match(s))}e.$yF=o;function m(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(o(S.path))return T.URI.parse(S.path);if((0,f.$ic)(S.path))return T.URI.file(S.path)}return S.path}function u(S){if(typeof S.path=="object"){const b=T.URI.revive(S.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return S.path}function t(S,b){const g=b?m:u,d=(0,R.$7m)(S);return c(d,(P,N)=>{P&&N&&(N.path=g(N))}),d}e.$zF=t;function n(S,b){const g=b?m:u,d=(0,R.$7m)(S);return c(d,(P,N)=>{!P&&N&&(N.path=g(N))}),d}e.$AF=n;function c(S,b){switch(S.type){case"event":{const g=S;switch(g.event){case"output":b(!1,g.body.source);break;case"loadedSource":b(!1,g.body.source);break;case"breakpoint":b(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=S;switch(g.command){case"setBreakpoints":b(!0,g.arguments.source);break;case"breakpointLocations":b(!0,g.arguments.source);break;case"source":b(!0,g.arguments.source);break;case"gotoTargets":b(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(d=>b(!1,d));break;default:break}break}case"response":{const g=S;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(d=>b(!1,d.source));break;case"loadedSources":g.body.sources.forEach(d=>b(!1,d));break;case"scopes":g.body.scopes.forEach(d=>b(!1,d.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(d=>b(!1,d.source));break;case"setBreakpoints":g.body.breakpoints.forEach(d=>b(!1,d.source));break;case"disassemble":g.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function i(S){return S.filter(b=>!b.presentation?.hidden).sort((b,g)=>b.presentation?g.presentation?b.presentation.group?g.presentation.group?b.presentation.group!==g.presentation.group?b.presentation.group.localeCompare(g.presentation.group):a(b.presentation.order,g.presentation.order):-1:g.presentation.group?1:a(b.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$BF=i;function a(S,b){return typeof S!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:S-b}async function l(S,b){const g=S.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(g!=="none"&&(await b.saveAll(),g==="allEditorsInActiveGroup")){const d=b.activeEditorPane;d&&d.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:d.input,groupId:d.group.id})}await S.reloadConfiguration()}e.$CF=l;const C=(S,b)=>!S||!b?S===b:S.name===b.name&&S.path===b.path&&S.sourceReference===b.sourceReference;e.$DF=C}),define(De[274],Ce([1,0,49,60,24,16,12,15,29,221,140]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=e.$Aec=e.$zec=e.$yec=void 0;class I extends L.$0cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(r,s){this.p=s,this.r=Buffer.allocUnsafe(0),this.t=-1,r.on("data",o=>this.w(o))}sendMessage(r){if(this.p){const s=JSON.stringify(r);this.p.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${I.a}${s}`,"utf8")}}w(r){for(this.r=Buffer.concat([this.r,r]);;){if(this.t>=0){if(this.r.length>=this.t){const s=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this.m.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.r.indexOf(I.a);if(s!==-1){const m=this.r.toString("utf8",0,s).split(I.b);for(const u of m){const t=u.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(s+I.a.length);continue}}break}}}e.$yec=I;class v extends I{startSession(){return new Promise((r,s)=>{let o=!1;this.x=this.y(()=>{this.v(this.x,this.x),r(),o=!0}),this.x.on("close",()=>{o?this.m.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.x.on("error",m=>{o?this.m.fire(m):s(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$zec=v;class y extends v{constructor(r){super(),this.z=r}y(r){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",r)}}e.$Aec=y;class k extends v{constructor(r){super(),this.z=r}y(r){return T.createConnection(this.z.path,r)}}e.$Bec=k;class p extends I{constructor(r,s){super(),this.y=r,this.z=s}async startSession(){const r=this.y.command,s=this.y.args,o=this.y.options||{};try{if(r)if(R.$ic(r)){if(!await E.Promises.exists(r))throw new Error(w.localize(0,null,r))}else r.indexOf("/")<0&&r.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let m=process.env;if(o.env&&Object.keys(o.env).length>0&&(m=f.$0m(f.$7m(process.env),o.env)),r==="node")if(Array.isArray(s)&&s.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(t.cwd=o.cwd);const n=D.fork(s[0],s.slice(1),t);if(!n.pid)throw new Error(w.localize(2,null,s[0]));this.x=n}else throw new Error(w.localize(3,null));else{const u={env:m};o.cwd&&(u.cwd=o.cwd),this.x=D.spawn(r,s,u)}this.x.on("error",u=>{this.m.fire(u)}),this.x.on("exit",(u,t)=>{this.n.fire(u)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",u=>{this.m.fire(u)}),this.x.stdin.on("error",u=>{this.m.fire(u)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((r,s)=>{const o=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,u,t){if(m)return s(m)});o.on("exit",r),o.on("error",s)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(r,s){if(!r)return;const o=Object.create(null);r.runtime&&(r.runtime.indexOf("./")===0?o.runtime=R.$jc(s,r.runtime):o.runtime=r.runtime),r.runtimeArgs&&(o.runtimeArgs=r.runtimeArgs),r.program&&(R.$ic(r.program)?o.program=r.program:o.program=R.$jc(s,r.program)),r.args&&(o.args=r.args);const m=r;return m.win&&(o.win=p.A(m.win,s)),m.winx86&&(o.winx86=p.A(m.winx86,s)),m.windows&&(o.windows=p.A(m.windows,s)),m.osx&&(o.osx=p.A(m.osx,s)),m.linux&&(o.linux=p.A(m.linux,s)),o}static platformAdapterExecutable(r,s){let o=Object.create(null);s=s.toLowerCase();for(const i of r)if(i.contributes){const a=i.contributes.debuggers;a&&a.length>0&&a.filter(l=>typeof l.type=="string"&&$.$2e(l.type,s)).forEach(l=>{const C=p.A(l,i.extensionLocation.fsPath);o=f.$0m(o,C,i.isBuiltin)})}let m;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=o.winx86||o.win||o.windows:A.$j?m=o.win||o.windows:A.$k?m=o.osx:A.$l&&(m=o.linux),m=m||o;const u=m.program||o.program,t=m.args||o.args,n=m.runtime||o.runtime,c=m.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(c||[]).concat(typeof u=="string"?[u]:[]).concat(t||[])};if(u)return{type:"executable",command:u,args:t||[]}}}e.$Cec=p}),define(De[275],Ce([1,0,49,33,12]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=void 0;function R(w,L){return new Promise((I,v)=>{let y="";const k=D.spawn(w,L);k.pid&&k.stdout.on("data",p=>{y+=p.toString()}),k.on("error",p=>{v(p)}),k.on("close",p=>{I(y)})})}async function A(w){if(w)if(f.$j){const L=await new Promise((I,v)=>{$e(["@vscode/windows-process-tree"],I,v)});return new Promise(I=>{L.getProcessTree(w,v=>{I(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(w)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$Dec=A;var $;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})($||($={}));function E(w,L,I,v,y){w=w.trim().toLowerCase();let k;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?k=1:w.indexOf("cmd.exe")>=0?k=0:w.indexOf("bash")>=0?k=2:f.$j?k=0:k=2;let p,h=" ";switch(k){case 1:if(p=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),v){const r=(0,T.$3f)(v);r&&(h+=`${r}:; `),h+=`cd ${p(v)}; `}if(y)for(const r in y){const s=y[r];s===null?h+=`Remove-Item env:${r}; `:h+=`\${env:${r}}='${s}'; `}if(L.length>0){const r=L.shift(),s=I?r:p(r);h+=s[0]==="'"?`& ${s} `:`${s} `;for(const o of L)h+=o==="<"||o===">"||I?o:p(o),h+=" "}break;case 0:if(p=r=>(r=r.replace(/\"/g,'""'),r=r.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(s=>r.includes(s))||r.length===0?`"${r}"`:r),v){const r=(0,T.$3f)(v);r&&(h+=`${r}: && `),h+=`cd ${p(v)} && `}if(y){h+='cmd /C "';for(const r in y){let s=y[r];s===null?h+=`set "${r}=" && `:(s=s.replace(/[&^|<>]/g,o=>`^${o}`),h+=`set "${r}=${s}" && `)}}for(const r of L)h+=r==="<"||r===">"||I?r:p(r),h+=" ";y&&(h+='"');break;case 2:{p=s=>(s=s.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),s.length===0?'""':s);const r=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(v&&(h+=`cd ${p(v)} ; `),y){h+="/usr/bin/env";for(const s in y){const o=y[s];o===null?h+=` -u ${r(s)}`:h+=` ${r(`${s}=${o}`)}`}h+=" "}for(const s of L)h+=s==="<"||s===">"||I?s:p(s),h+=" ";break}}return h}e.$Eec=E}),define(De[108],Ce([1,0,22,36,51,97,18,16,12,42]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.$vI=e.$uI=e.$tI=e.CellStatusbarAlignment=e.$sI=e.$rI=e.$qI=e.NotebookEditorPriority=e.$pI=e.$oI=e.$nI=e.$mI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$lI=e.$kI=e.$jI=e.$iI=e.CellKind=e.$hI=e.$gI=e.$fI=void 0,e.$fI="workbench.editor.notebook",e.$gI="workbench.editor.notebookTextDiffEditor",e.$hI="workbench.editor.interactive";var L;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(L||(e.CellKind=L={})),e.$iI=["application/json","application/javascript","text/html","image/svg+xml",R.$Pr.latex,R.$Pr.markdown,"image/png","image/jpeg",R.$Pr.text],e.$jI=[R.$Pr.latex,R.$Pr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Pr.text],e.$kI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$lI="_notAvailable";var I;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var p;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var h;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var r;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var s;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var o;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${K.join("")}]+`),me=7;function te(pe,H){const B=H.toString(me),re=`${B.length<K.length?K[B.length-1]:"z"}${B}s${(0,D.$ve)(D.$be.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:O.scheme,fragment:re})}O.generate=te;function G(pe){if(pe.scheme!==O.scheme)return;const H=pe.fragment.indexOf("s");if(H<0)return;const B=parseInt(pe.fragment.substring(0,H).replace(V,""),me),X=(0,D.$ue)(pe.fragment.substring(H+1)).toString();if(!isNaN(B))return{handle:B,notebook:pe.with({scheme:X,fragment:null})}}O.parse=G;function Q(pe,H){return pe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${pe.scheme!==A.Schemas.file?pe.scheme:""}`})}O.generateCellOutputUri=Q;function le(pe){if(pe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!H)return;const B=H[1]&&H[1]!==""?H[1]:void 0,X=H[2];return{outputId:B,notebook:pe.with({scheme:X||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=le;function ie(pe,H,B){return O.generate(pe,H).with({scheme:B})}O.generateCellPropertyUri=ie;function ce(pe,H){if(pe.scheme===H)return O.parse(pe.with({scheme:O.scheme}))}O.parseCellPropertyUri=ce})(o||(e.CellUri=o={}));const m=O=>E.$j?O.replace(/\//g,"\\"):O;class u{constructor(K=[],V=e.$iI){this.e=V,this.d=[...new Set(K)].map(me=>({pattern:me,matches:T.$wj(m(me))}))}sort(K){const V=new Map(f.Iterable.map(K,te=>[te,m(te)]));let me=[];for(const{matches:te}of this.d)for(const[G,Q]of V)if(te(Q)){me.push(G),V.delete(G);break}return V.size&&(me=me.concat([...V.keys()].sort((te,G)=>this.e.indexOf(te)-this.e.indexOf(G)))),me}prioritize(K,V){const me=this.f(K);if(me===-1){this.d.unshift({pattern:K,matches:T.$wj(m(K))});return}const te=new Set(V.map(Q=>this.f(Q,me)));te.delete(-1);const G=Array.from(te).sort();this.d.splice(me+1,0,...G.map(Q=>this.d[Q]));for(let Q=G.length-1;Q>=0;Q--)this.d.splice(G[Q],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,V=this.d.length){const me=m(K);for(let te=0;te<V;te++)if(this.d[te].matches(me))return te;return-1}}e.$mI=u;function t(O,K,V,me=(te,G)=>te===G){const te=[];function G(ie,ce,pe){if(ce===0&&pe.length===0)return;const H=te[te.length-1];H&&H.start+H.deleteCount===ie?(H.deleteCount+=ce,H.toInsert.push(...pe)):te.push({start:ie,deleteCount:ce,toInsert:pe})}let Q=0,le=0;for(;;){if(Q===O.length){G(Q,0,K.slice(le));break}if(le===K.length){G(Q,O.length-Q,[]);break}const ie=O[Q],ce=K[le];if(me(ie,ce)){Q+=1,le+=1;continue}V(ce)?(G(Q,1,[]),Q+=1):(G(Q,0,[ce]),le+=1)}return te}e.$nI=t,e.$oI=new w.$7i("notebookEditorCursorAtBoundary","none"),e.$pI=new w.$7i("notebookEditorCursorAtLineBoundary","none");var n;(function(O){O.default="default",O.option="option"})(n||(e.NotebookEditorPriority=n={}));function c(O){const K=O;return!!((typeof K.include=="string"||T.$xj(K.include))&&(typeof K.exclude=="string"||T.$xj(K.exclude)))}e.$qI=c;function i(O,K,V){if(Array.isArray(O.viewType)&&O.viewType.indexOf(K)>=0||O.viewType===K)return!0;if(O.filenamePattern){const me=c(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,te=c(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$vj(me,(0,$.$nc)(V.fsPath).toLowerCase()))return!(te&&T.$vj(te,(0,$.$nc)(V.fsPath).toLowerCase()))}return!1}e.$rI=i,e.$sI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static{this.d="notebook/"}static create(K){return`${l.d}${K}`}static parse(K){if(K.startsWith(l.d))return K.substring(l.d.length)}}e.$tI=l;function C(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$uI=C;const S=new TextDecoder;function b(O){const K=[];let V=!1;for(const Q of O)(K.length===0||V)&&(K.push(Q),V=!0);let me=P(K);const te=D.$be.concat(K.map(Q=>D.$be.wrap(Q))),G=j(te);return me=me||G.byteLength!==te.byteLength,{data:G,didCompression:me}}e.$vI=b,e.$wI=`${String.fromCharCode(27)}[A`;const g=e.$wI.split("").map(O=>O.charCodeAt(0)),d=10;function P(O){let K=!1;return O.forEach((V,me)=>{if(me===0||V.length<e.$wI.length)return;const te=O[me-1],G=V.subarray(0,e.$wI.length);if(G[0]===g[0]&&G[1]===g[1]&&G[2]===g[2]){const Q=te.lastIndexOf(d);if(Q===-1)return;K=!0,O[me-1]=te.subarray(0,Q),O[me]=V.subarray(e.$wI.length)}}),K}function N(O){let K=O;do O=K,K=O.replace(/[^\n]\x08/gm,"");while(K.length<O.length);return O}function F(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const K=O.match(/^(.*)\r+/m)[1];let V=O.match(/\r+(.*)$/m)[1];V=V+K.slice(V.length,K.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return O}const M="\b".charCodeAt(0),U="\r".charCodeAt(0);function j(O){return!O.buffer.includes(M)&&!O.buffer.includes(U)?O:D.$be.fromString(F(N(S.decode(O.buffer))))}}),define(De[7],Ce([1,0,19,9,80,28,97,15,17,2,31,25,30,65,108]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";var p,h,r,s,o,m,u,t,n,c,i,a,l,C,S,b,g,d;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$aM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.TestRunProfileKind=e.TestResultState=e.$TL=e.$SL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$RL=e.$QL=e.$PL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$OL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.ColorThemeKind=e.$IL=e.$HL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$GL=e.DebugConsoleMode=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$AL=e.$zL=e.FileChangeType=e.$yL=e.$xL=e.$wL=e.$vL=e.InlineCompletionTriggerKind=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.ConfigurationTarget=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$$K=e.ViewBadge=e.ProgressLocation=e.$0K=e.$9K=e.TaskScope=e.ShellQuoting=e.$8K=e.$7K=e.$6K=e.TaskPanelKind=e.TaskRevealKind=e.$5K=e.TerminalLocation=e.$4K=e.$3K=e.$2K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$1K=e.$ZK=e.$YK=e.$XK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$WK=e.StatusBarAlignment=e.ViewColumn=e.$VK=e.$UK=e.$TK=e.$SK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$RK=e.$QK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.LanguageStatusSeverity=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.CodeActionTriggerKind=e.$EK=e.$DK=e.SymbolTag=e.SymbolKind=e.$CK=e.DocumentHighlightKind=e.$BK=e.$AK=e.$zK=e.$yK=e.DiagnosticSeverity=e.DiagnosticTag=e.$xK=e.$wK=e.FileEditType=e.$vK=e.$uK=e.$tK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(q){return Object.assign(q,{apply:function(...ye){if(ye.length===0)return Reflect.construct(q,[]);{const Re=ye.length===1?[]:ye[1];return Reflect.construct(q,Re,ye[0].constructor)}},call:function(...ye){if(ye.length===0)return Reflect.construct(q,[]);{const[Re,...Qe]=ye;return Reflect.construct(q,Qe,Re.constructor)}}})}var N;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var F;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let M=p=class{static from(...W){let ye=W;return new p(function(){if(ye){for(const Re of ye)Re&&typeof Re.dispose=="function"&&Re.dispose();ye=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$mK=M,e.$mK=M=p=He([P],M);let U=h=class{static Min(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(ye)&&(ye=Qe)}return ye}static Max(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(ye)&&(ye=Qe)}return ye}static isPosition(W){if(!W)return!1;if(W instanceof h)return!0;const{line:ye,character:Re}=W;return typeof ye=="number"&&typeof Re=="number"}static of(W){if(W instanceof h)return W;if(this.isPosition(W))return new h(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ye){if(W<0)throw(0,T.$7)("line must be non-negative");if(ye<0)throw(0,T.$7)("character must be non-negative");this.c=W,this.e=ye}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ye=0){if(W===null||ye===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ye=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ye===0?this:new h(this.line+Re,this.character+ye)}with(W,ye=this.character){if(W===null||ye===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ye=typeof W.character=="number"?W.character:this.character),Re===this.line&&ye===this.character?this:new h(Re,ye)}toJSON(){return{line:this.line,character:this.character}}};e.$nK=U,e.$nK=U=h=He([P],U);let j=r=class{static isRange(W){return W instanceof r?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ye,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new U(W,ye),at=new U(Re,Qe)):U.isPosition(W)&&U.isPosition(ye)&&(tt=U.of(W),at=U.of(ye)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ye=U.Max(W.start,this.c),Re=U.Min(W.end,this.e);if(!ye.isAfter(Re))return new r(ye,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ye=U.Min(W.start,this.c),Re=U.Max(W.end,this.end);return new r(ye,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ye=this.end){if(W===null||ye===null)throw(0,T.$7)();let Re;return W?U.isPosition(W)?Re=W:(Re=W.start||this.start,ye=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ye.isEqual(this.end)?this:new r(Re,ye)}toJSON(){return[this.start,this.end]}};e.$oK=j,e.$oK=j=r=He([P],j);let O=s=class extends j{static isSelection(W){return W instanceof s?!0:W?j.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ye,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new U(W,ye),at=new U(Re,Qe)):U.isPosition(W)&&U.isPosition(ye)&&(tt=U.of(W),at=U.of(ye)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$pK=O,e.$pK=O=s=He([P],O);const K=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,T.$7)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye,Re){if(typeof W!="string"||W.length===0)throw(0,T.$7)("host");if(typeof ye!="number"||ye===0||Math.round(ye)!==ye)throw(0,T.$7)("port");typeof Re<"u"&&K(Re),this.host=W,this.port=Math.round(ye),this.connectionToken=Re}}e.$qK=V;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye){this.makeConnection=W,this.connectionToken=ye,typeof ye<"u"&&K(ye)}}e.$rK=me;class te extends Error{static NotAvailable(W,ye){return new te(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ye)}static TemporarilyNotAvailable(W){return new te(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ye=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ye,this._detail=Re,Object.setPrototypeOf(this,te.prototype)}}e.$sK=te;var G;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var Q;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let le=o=class{static isTextEdit(W){return W instanceof o?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ye){return new o(W,ye)}static insert(W,ye){return o.replace(new j(W,W),ye)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const ye=new o(new j(new U(0,0),new U(0,0)),"");return ye.newEol=W,ye}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,T.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$7)("newEol");this.f=W}constructor(W,ye){this.c=W,this.e=ye}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$tK=le,e.$tK=le=o=He([P],le);let ie=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ye){return new m(W,ye)}static insertCells(W,ye){return new m(new xt(W,W),ye)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,ye){const Re=new m(new xt(W,W),[]);return Re.newCellMetadata=ye,Re}static updateNotebookMetadata(W){const ye=new m(new xt(0,0),[]);return ye.newNotebookMetadata=W,ye}constructor(W,ye){this.range=W,this.newCells=ye}};e.$uK=ie,e.$uK=ie=m=He([P],ie);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?j.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,ye){return new ce(W,ye)}static insert(W,ye){return ce.replace(new j(W,W),ye)}constructor(W,ye){this.range=W,this.snippet=ye}}e.$vK=ce;var pe;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ye,Re,Qe){this.c.push({_type:1,from:W,to:ye,options:Re,metadata:Qe})}createFile(W,ye,Re){this.c.push({_type:1,from:void 0,to:W,options:ye,metadata:Re})}deleteFile(W,ye,Re){this.c.push({_type:1,from:W,to:void 0,options:ye,metadata:Re})}e(W,ye,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ye},notebookMetadata:ye})}f(W,ye,Re,Qe){const tt=ye.start,at=ye.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,ye,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ye,metadata:Re}})}replace(W,ye,Re,Qe){this.c.push({_type:2,uri:W,edit:new le(ye,Re),metadata:Qe})}insert(W,ye,Re,Qe){this.replace(W,new j(ye,ye),Re,Qe)}delete(W,ye,Re){this.replace(W,ye,"",Re)}has(W){return this.c.some(ye=>ye._type===2&&ye.uri.toString()===W.toString())}set(W,ye){if(ye)for(const Re of ye){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,ie.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ce.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,D.$Ib)(this.c)}}get(W){const ye=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ye.push(Re.edit);return ye}entries(){const W=new R.$Ac;for(const ye of this.c)if(ye._type===2){let Re=W.get(ye.uri);Re||(Re=[ye.uri,[]],W.set(ye.uri,Re)),Re[1].push(ye.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$wK=H,e.$wK=H=He([P],H);let B=u=class{static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=u.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ye=this.e++){if(typeof W=="function"){const Re=new u;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=u.c(W);return this.value+="${",this.value+=ye,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ye=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ye,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ye){if(typeof ye=="function"){const Re=new u;Re.e=this.e,ye(Re),this.e=Re.e,ye=Re.value}else typeof ye=="string"&&(ye=ye.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ye&&(this.value+=":",this.value+=ye),this.value+="}",this}};e.$xK=B,e.$xK=B=u=He([P],B);var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var re;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Y=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&w.URI.isUri(W.uri):!1}constructor(W,ye){if(this.uri=W,ye)if(j.isRange(ye))this.range=j.of(ye);else if(U.isPosition(ye))this.range=new j(ye,ye);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$yK=Y,e.$yK=Y=t=He([P],Y);let _=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&w.URI.isUri(W.location.uri):!1}constructor(W,ye){this.location=W,this.message=ye}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.location.range.isEqual(ye.location.range)&&W.location.uri.toString()===ye.location.uri.toString()}};e.$zK=_,e.$zK=_=He([P],_);let x=class{constructor(W,ye,Re=re.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ye)throw new TypeError("message must be set");this.range=W,this.message=ye,this.severity=Re}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.severity===ye.severity&&W.code===ye.code&&W.severity===ye.severity&&W.source===ye.source&&W.range.isEqual(ye.range)&&(0,D.$ub)(W.tags,ye.tags)&&(0,D.$ub)(W.relatedInformation,ye.relatedInformation,_.isEqual)}};e.$AK=x,e.$AK=x=He([P],x);let ve=class{constructor(W,ye){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ye}};e.$BK=ve,e.$BK=ve=He([P],ve);var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let fe=class{constructor(W,ye=ae.Text){this.range=W,this.kind=ye}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$CK=fe,e.$CK=fe=He([P],fe);var ee;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var de;(function(q){q[q.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ye,Re,Qe,tt){this.name=W,this.kind=ye,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof Y?this.location=Qe:Re instanceof j&&(this.location=new Y(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$DK=be,e.$DK=be=n=He([P],be);let Pe=c=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(c.validate)}constructor(W,ye,Re,Qe,tt){this.name=W,this.detail=ye,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],c.validate(this)}};e.$EK=Pe,e.$EK=Pe=c=He([P],Pe);var z;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let J=class{constructor(W,ye){this.title=W,this.kind=ye}};e.$FK=J,e.$FK=J=He([P],J);let se=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$GK=se,e.$GK=se=i=He([P],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,ye){if(this.range=W,this.parent=ye,ye&&!ye.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$HK=oe,e.$HK=oe=He([P],oe);class Z{constructor(W,ye,Re,Qe,tt,at){this.kind=W,this.name=ye,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$IK=Z;class ge{constructor(W,ye){this.fromRanges=ye,this.from=W}}e.$JK=ge;class Ee{constructor(W,ye){this.fromRanges=ye,this.to=W}}e.$KK=Ee;var je;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,ye){this.range=W,this.command=ye}get isResolved(){return!!this.command}};e.$LK=We,e.$LK=We=He([P],We);let _e=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ye=!1){this.#e=new f.$3j(W,{supportThemeIcons:ye})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ye){return this.#e.appendCodeblock(ye??"",W),this}};e.$MK=_e,e.$MK=_e=a=He([P],_e);let Ye=class{constructor(W,ye){this.label=W,this.documentation=ye}};e.$NK=Ye,e.$NK=Ye=He([P],Ye);let it=class{constructor(W,ye){this.label=W,this.documentation=ye,this.parameters=[]}};e.$OK=it,e.$OK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$PK=et,e.$PK=et=He([P],et);var Ae;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$QK=qe,e.$QK=qe=He([P],qe);let Le=class{constructor(W,ye,Re){this.position=W,this.label=ye,this.kind=Re}};e.$RK=Le,e.$RK=Le=He([P],Le);var Xe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var he;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var ue;(function(q){q[q.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,ye){this.label=W,this.kind=ye}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$SK=Ie,e.$SK=Ie=He([P],Ie);let Ve=class{constructor(W=[],ye=!1){this.items=W,this.isIncomplete=ye}};e.$TK=Ve,e.$TK=Ve=He([P],Ve);let ze=class{constructor(W,ye,Re){this.insertText=W,this.range=ye,this.command=Re}};e.$UK=ze,e.$UK=ze=He([P],ze);let xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$VK=xe,e.$VK=xe=He([P],xe);var rt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function $t(q,W){return`${I.$6l.toKey(q)}.${W}`}e.$WK=$t;var St;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Yt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Gt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var wt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var zt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Nt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(q){function W(ye){switch(ye){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Bt;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(q){function W(ye){switch(ye){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(W,ye){if(ye&&!w.URI.isUri(ye))throw(0,T.$7)("target");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.target=ye}};e.$XK=At,e.$XK=At=He([P],At);let Rt=class{constructor(W,ye,Re,Qe){this.red=W,this.green=ye,this.blue=Re,this.alpha=Qe}};e.$YK=Rt,e.$YK=Rt=He([P],Rt);let Ot=class{constructor(W,ye){if(ye&&!(ye instanceof Rt))throw(0,T.$7)("color");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.color=ye}};e.$ZK=Ot,e.$ZK=Ot=He([P],Ot);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$7)("label");this.label=W}};e.$1K=Wt,e.$1K=Wt=He([P],Wt);var Jt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var Vt;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Lt{constructor(W,ye,Re){if(this.startIndex=W,this.length=ye,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$7)("startIndex");if(typeof ye!="number"||ye<1)throw(0,T.$7)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$7)("tooltip")}}e.$2K=Lt;class lt{constructor(W){this.uri=W}}e.$3K=lt;class ft{constructor(W){this.terminalCommand=W}}e.$4K=ft;var Tt;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class Kt{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$7)("options")}}e.$5K=Kt;var Dt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var ct;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(ct||(e.TaskPanelKind=ct={}));let vt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,ye){if(this.label=ye,typeof W!="string"||typeof ye!="string")throw(0,T.$7)("name");this.c=W}get id(){return this.c}};e.$6K=vt,e.$6K=vt=l=He([P],vt);function Ht(q){let W="";for(let ye=0;ye<q.length;ye++)W+=q[ye].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ye,Re){if(typeof W!="string")throw(0,T.$7)("process");this.e=[],this.c=W,ye!==void 0&&(Array.isArray(ye)?(this.e=ye,this.f=Re):this.f=ye)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ye of this.e)W.push(ye);return Ht(W)}};e.$7K=Pt,e.$7K=Pt=He([P],Pt);let Ge=class{constructor(W,ye,Re){if(this.f=[],Array.isArray(ye)){if(!W)throw(0,T.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W,this.f=ye,this.g=Re}else{if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W,this.g=ye}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ye of this.f)W.push(typeof ye=="string"?ye:ye.value);return Ht(W)}};e.$8K=Ge,e.$8K=Ge=He([P],Ge);var Me;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var Te;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class Se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.$eg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$9K=Se;let ne=class{static{C=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ye,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let dt;typeof ye=="string"?(this.m=this.name=ye,this.t=this.source=Re,this.execution=Qe,dt=tt,this.j=!0):ye===Te.Global||ye===Te.Workspace?(this.target=ye,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at):(this.target=ye,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:C.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:C.f,id:this.n.computeId()}:this.n instanceof Se?this.k={type:C.c,id:this.n.computeId()}:this.k={type:C.g,id:(0,L.$eg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$7)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$7)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ye=this.k.type;(C.g===ye||C.e===ye||C.f===ye||C.c===ye)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$7)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$0K=ne,e.$0K=ne=C=He([P],ne);var Fe;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Ke;(function(q){function W(ye){const Re=ye;return(0,E.$Cf)(Re.value)?Re.tooltip&&!(0,E.$yf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}q.isViewBadge=W})(Ke||(e.ViewBadge=Ke={}));let Ze=S=class{static isTreeItem(W,ye){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Cf)(Re.checkboxState)?Re.checkboxState:(0,E.$Af)(Re.checkboxState)&&(0,E.$Cf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Cf)(Re.checkboxState)&&(0,E.$Af)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==nt.Checked&&Qe!==nt.Unchecked||tt!==void 0&&!(0,E.$yf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$yf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$yf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$yf)(Re.iconPath)&&!w.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$yf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$yf)(Qe.light)&&!w.URI.isUri(Qe.light)&&!(0,E.$yf)(Qe.dark)&&!w.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$yf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!w.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$yf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Je.None&&Re.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$yf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ye=Je.None){this.collapsibleState=ye,w.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$$K=Ze,e.$$K=Ze=S=He([P],Ze);var Je;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var nt;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$_K=pt,e.$_K=pt=He([P],pt);class jt extends pt{}e.$aL=jt;class kt extends jt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$bL=kt;class ht{constructor(W,ye,Re,Qe){this.name=W,this.uri=ye,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$cL=ht;let gt=class{#e=new Map;constructor(W){for(const[ye,Re]of W??[]){const Qe=this.#e.get(this.#t(ye));Qe?Qe.push(Re):this.#e.set(this.#t(ye),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ye){this.#e.set(this.#t(W),[ye])}forEach(W,ye){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(ye,tt,Re,this)}*[Symbol.iterator](){for(const[W,ye]of this.#e)for(const Re of ye)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$dL=gt,e.$dL=gt=He([P],gt);let yt=class{constructor(W){this.insertText=W}};e.$eL=yt,e.$eL=yt=He([P],yt);let mi=class{constructor(W,ye){this.label=ye,this.insertText=W}};e.$fL=mi,e.$fL=mi=He([P],mi);let Ct=class{constructor(W,ye){this.id=W,this.color=ye}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$gL=Ct,e.$gL=Ct=He([P],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$hL=Di,e.$hL=Di=He([P],Di);var ui;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=w.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ye){if(typeof W!="string"&&(!W||!w.URI.isUri(W)&&!w.URI.isUri(W.uri)))throw(0,T.$7)("base");if(typeof ye!="string")throw(0,T.$7)("pattern");typeof W=="string"?this.baseUri=w.URI.file(W):w.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ye}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iL=$i,e.$iL=$i=He([P],$i);const It=new WeakMap;function fn(q,W){It.set(q,W)}e.$jL=fn;let ri=class{constructor(W,ye,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ye=="string"&&(this.condition=ye),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,L.$eg)()),this.c}};e.$kL=ri,e.$kL=ri=He([P],ri);let Et=class extends ri{constructor(W,ye,Re,Qe,tt){if(super(ye,Re,Qe,tt),W===null)throw(0,T.$7)("location");this.location=W}};e.$lL=Et,e.$lL=Et=He([P],Et);let bi=class extends ri{constructor(W,ye,Re,Qe,tt){super(ye,Re,Qe,tt),this.functionName=W}};e.$mL=bi,e.$mL=bi=He([P],bi);let wi=class extends ri{constructor(W,ye,Re,Qe,tt,at,dt){if(super(Qe,tt,at,dt),!ye)throw(0,T.$7)("dataId");this.label=W,this.dataId=ye,this.canPersist=Re}};e.$nL=wi,e.$nL=wi=He([P],wi);let si=class{constructor(W,ye,Re){this.command=W,this.args=ye||[],this.options=Re}};e.$oL=si,e.$oL=si=He([P],si);let Ci=class{constructor(W,ye){this.port=W,this.host=ye}};e.$pL=Ci,e.$pL=Ci=He([P],Ci);let Ii=class{constructor(W){this.path=W}};e.$qL=Ii,e.$qL=Ii=He([P],Ii);let Mt=class{constructor(W){this.implementation=W}};e.$rL=Mt,e.$rL=Mt=He([P],Mt);let vi=class{constructor(W,ye,Re){this.session=W,this.threadId=ye,this.frameId=Re}};e.$sL=vi,e.$sL=vi=He([P],vi);let Pi=class{constructor(W,ye){this.session=W,this.threadId=ye}};e.$tL=Pi,e.$tL=Pi=He([P],Pi);let oi=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$uL=oi,e.$uL=oi=He([P],oi);var li;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ut=class{constructor(W,ye){this.range=W,this.text=ye}};e.$vL=ut,e.$vL=ut=He([P],ut);let Ai=class{constructor(W,ye,Re=!0){this.range=W,this.variableName=ye,this.caseSensitiveLookup=Re}};e.$wL=Ai,e.$wL=Ai=He([P],Ai);let Zt=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$xL=Zt,e.$xL=Zt=He([P],Zt);let ii=class{constructor(W,ye){this.frameId=W,this.stoppedLocation=ye}};e.$yL=ii,e.$yL=ii=He([P],ii);var Ri;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=b=class extends Error{static FileExists(W){return new b(W,v.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,v.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,v.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,v.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,v.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,v.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(W,ye=v.FileSystemProviderErrorCode.Unknown,Re){super(w.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,v.$nk)(this,ye),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$zL=Li,e.$zL=Li=b=He([P],Li);let Mi=class{constructor(W,ye,Re){this.start=W,this.end=ye,this.kind=Re}};e.$AL=Mi,e.$AL=Mi=He([P],Mi);var Xi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Yi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Ti;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(W,ye=[]){this.tokenTypes=W,this.tokenModifiers=ye}}e.$BL=gn;function Ni(q){return typeof q>"u"||(0,E.$zf)(q)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ye=0,Re=W.tokenTypes.length;ye<Re;ye++)this.j.set(W.tokenTypes[ye],ye);for(let ye=0,Re=W.tokenModifiers.length;ye<Re;ye++)this.k.set(W.tokenModifiers[ye],ye)}}push(W,ye,Re,Qe,tt){if(typeof W=="number"&&typeof ye=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ye,Re,Qe,tt);if(j.isRange(W)&&typeof ye=="string"&&Ni(Re))return this.m(W,ye,Re);throw(0,T.$7)()}m(W,ye,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ye))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(ye);let Ut=0;if(Re)for(const Xt of Re){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(Qe,tt,at,dt,Ut)}n(W,ye,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&ye<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let at=W,dt=ye;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=ye}static o(W){const ye=[],Re=W.length/5|0;for(let dt=0;dt<Re;dt++)ye[dt]=dt;ye.sort((dt,Ut)=>{const Xt=W[5*dt],ei=W[5*Ut];if(Xt===ei){const ti=W[5*dt+1],ni=W[5*Ut+1];return ti-ni}return Xt-ei});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let dt=0;dt<Re;dt++){const Ut=5*ye[dt],Xt=W[Ut+0],ei=W[Ut+1],ti=W[Ut+2],ni=W[Ut+3],Ji=W[Ut+4],In=Xt-tt,Fn=In===0?ei-at:ei,Qi=5*dt;Qe[Qi+0]=In,Qe[Qi+1]=Fn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,tt=Xt,at=ei}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(hi.o(this.g),W)}}e.$CL=hi;class Oi{constructor(W,ye){this.resultId=ye,this.data=W}}e.$DL=Oi;class mn{constructor(W,ye,Re){this.start=W,this.deleteCount=ye,this.data=Re}}e.$EL=mn;class di{constructor(W,ye){this.resultId=ye,this.edits=W}}e.$FL=di;var Zi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$GL=ji,e.$GL=ji=He([P],ji);var xi;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(W){if(typeof W.badge=="string"){let ye=(0,$.$_e)(W.badge,0);if(ye<W.badge.length&&(ye+=(0,$.$_e)(W.badge,ye)),W.badge.length>ye)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ye,Re){this.badge=W,this.tooltip=ye,this.color=Re}}e.$HL=$n;let Ui=class{constructor(W){this.kind=W}};e.$IL=Ui,e.$IL=Ui=He([P],Ui);var gi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ye){if(W<0)throw(0,T.$7)("start must be positive");if(ye<0)throw(0,T.$7)("end must be positive");W<=ye?(this.c=W,this.e=ye):(this.c=ye,this.e=W)}with(W){let ye=this.c,Re=this.e;return W.start!==void 0&&(ye=W.start),W.end!==void 0&&(Re=W.end),ye===this.c&&Re===this.e?this:new xt(ye,Re)}}e.$JL=xt;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ye=>pi.isNotebookCellData(ye))}static isNotebookCellData(W){return!0}constructor(W,ye,Re,Qe,tt,at,dt){this.kind=W,this.value=ye,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,pi.validate(this)}}e.$KL=pi;class bn{constructor(W){this.cells=W}}e.$LL=bn;class Qt{static isNotebookCellOutputItem(W){return W instanceof Qt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ye={name:W.name,message:W.message,stack:W.stack};return Qt.json(ye,"application/vnd.code.notebook.error")}static stdout(W){return Qt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Qt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ye="application/octet-stream"){return new Qt(W,ye)}static#e=new TextEncoder;static text(W,ye=A.$Pr.text){const Re=Qt.#e.encode(String(W));return new Qt(Re,ye)}static json(W,ye="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Qt.text(Re,ye)}constructor(W,ye){this.data=W,this.mime=ye;const Re=(0,A.$Tr)(ye,!0);if(!Re)throw new Error(`INVALID mime type: ${ye}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$ML=Qt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ye=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],dt=(0,A.$Tr)(at.mime);if(!Re.has(dt)||(0,k.$uI)(dt)){Re.add(dt);continue}Qe.add(tt),ye&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,ye,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ye=="string"?(this.id=ye,this.metadata=Re):(this.id=(0,L.$eg)(),this.metadata=ye??Re)}}e.$NL=yi;var en;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(W,ye){this.text=W,this.alignment=ye}}e.$OL=rn;var Ue;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ue||(e.NotebookControllerAffinity=Ue={}));var _t;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(W,ye=[]){this.uri=W,this.provides=(0,D.$3b)(ye)}}e.$PL=sn;class mt{constructor(W){this.label=W}}e.$QL=mt;let zi=class{constructor(W,ye){this.label=W,this.timestamp=ye}};e.$RL=zi,e.$RL=zi=He([P],zi);var on;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class ki{constructor(W,ye){this.ranges=W,this.wordPattern=ye}}e.$SL=ki;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$TL=wn;var cn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Si=class{constructor(W=void 0,ye=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=ye,this.profile=Re,this.continuous=Qe}};e.$UL=Si,e.$UL=Si=He([P],Si);let Wi=g=class{static diff(W,ye,Re){const Qe=new g(W);return Qe.expectedOutput=ye,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$VL=Wi,e.$VL=Wi=g=He([P],Wi);let qi=class{constructor(W){this.id=W}};e.$WL=qi,e.$WL=qi=He([P],qi);let ci=class{constructor(W,ye){this.covered=W,this.total=ye}};e.$XL=ci,e.$XL=ci=He([P],ci);let Vi=d=class{static fromDetails(W,ye){const Re=new ci(0,0),Qe=new ci(0,0),tt=new ci(0,0);for(const dt of ye)if("branches"in dt){Re.total+=1,Re.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)Qe.total+=1,Qe.covered+=Ut.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new d(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ye,at}constructor(W,ye,Re,Qe){this.uri=W,this.statementCoverage=ye,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$YL=Vi,e.$YL=Vi=d=He([P],Vi);let Ki=class{constructor(W,ye,Re=[]){this.executionCount=W,this.location=ye,this.branches=Re}};e.$ZL=Ki,e.$ZL=Ki=He([P],Ki);let Hi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$1L=Hi,e.$1L=Hi=He([P],Hi);let Gi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$2L=Gi,e.$2L=Gi=He([P],Gi);var ln;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class we{constructor(W,ye,Re,Qe,tt,at){this.kind=W,this.name=ye,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$3L=we;class ke{constructor(W){this.uri=W}}e.$4L=ke;class Oe{constructor(W,ye){this.original=W,this.modified=ye}}e.$5L=Oe;class st{constructor(W,ye,Re,Qe){this.base=W,this.input1=ye,this.input2=Re,this.result=Qe}}e.$6L=st;class bt{constructor(W,ye){this.uri=W,this.viewType=ye}}e.$7L=bt;class Ft{constructor(W){this.viewType=W}}e.$8L=Ft;class Pn{constructor(W,ye){this.uri=W,this.notebookType=ye}}e.$9L=Pn;class An{constructor(W,ye,Re){this.original=W,this.modified=ye,this.notebookType=Re}}e.$0L=An;class Rn{constructor(){}}e.$$L=Rn;class Ln{constructor(W,ye){this.uri=W,this.inputBoxUri=ye}}e.$_L=Ln;var vn;(function(q){q[q.Down=0]="Down",q[q.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var pn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var yn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.Assistant=2]="Assistant",q[q.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Mn{constructor(W,ye){this.role=W,this.content=ye}}e.$aM=Mn;var Sn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(q){q[q.Started=1]="Started",q[q.Recognizing=2]="Recognizing",q[q.Recognized=3]="Recognized",q[q.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(De[141],Ce([1,0,58,18,15,171,124,7,19]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=void 0;const w=new Map;function L(k,p){p?w.set(k,p):w.delete(k)}e.$nM=L;function I(k){return w.get(k)}class v extends R.$Vu{constructor(p,h,r,s,o,m,u,t){super(h,r,s,o),this.c=p,this.m=m,this.q=u,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$ub)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===T.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(h){return h?p.s(h):p.getText()},get eol(){return p.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(h){return p.t(h)},offsetAt(h){return p.u(h)},positionAt(h){return p.v(h)},validateRange(h){return p.w(h)},validatePosition(h){return p.x(h)},getWordRangeAtPosition(h,r){return p.y(h,r)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,D.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,D.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const h=this.w(p);if(h.isEmpty)return"";if(h.isSingleLine)return this.f[h.start.line].substring(h.start.character,h.end.character);const r=this.g,s=h.start.line,o=h.end.line,m=[];m.push(this.f[s].substring(h.start.character));for(let u=s+1;u<o;u++)m.push(this.f[u]);return m.push(this.f[o].substring(0,h.end.character)),m.join(r)}t(p){let h;if(p instanceof $.$nK?h=p.line:typeof p=="number"&&(h=p),typeof h!="number"||h<0||h>=this.f.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new y(h,this.f[h],h===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const h=this.j.getIndexOf(p),r=this.f[h.index].length;return new $.$nK(h.index,Math.min(h.remainder,r))}w(p){if(!(p instanceof $.$oK))throw new Error("Invalid argument");const h=this.x(p.start),r=this.x(p.end);return h===p.start&&r===p.end?p:new $.$oK(h.line,h.character,r.line,r.character)}x(p){if(!(p instanceof $.$nK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:h,character:r}=p,s=!1;if(h<0)h=0,r=0,s=!0;else if(h>=this.f.length)h=this.f.length-1,r=this.f[h].length,s=!0;else{const o=this.f[h].length;r<0?(r=0,s=!0):r>o&&(r=o,s=!0)}return s?new $.$nK(h,r):p}y(p,h){const r=this.x(p);if(!h)h=I(this.m);else if((0,f.$Oe)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const s=(0,A.$8r)(r.character+1,(0,A.$6r)(h),this.f[r.line],0);if(s)return new $.$oK(r.line,s.startColumn-1,r.line,s.endColumn-1)}}e.$oM=v;class y{constructor(p,h,r){this.a=p,this.b=h,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$oK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$oK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pM=y}),define(De[276],Ce([1,0,7,20,4]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;let R=class{constructor($){this.a=new D.$IL(D.ColorThemeKind.Dark),this.b=new f.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=D.ColorThemeKind.Light;break;case"hcDark":E=D.ColorThemeKind.HighContrast;break;case"hcLight":E=D.ColorThemeKind.HighContrastLight;break;default:E=D.ColorThemeKind.Dark}this.a=new D.$IL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Udc=R,e.$Udc=R=He([Be(0,T.$lM)],R)}),define(De[277],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=e.CellExecutionUpdateType=void 0;var T;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$yI=(0,D.$Ph)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class f{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new f([$]);const w=[A.id];for(let L=E;L&&L.id!==$;L=L.parent)w.push(L.id);return w.push($),new f(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new f(A.split("\0"))}static join(A,$){return new f([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:f.isChild(A,$)?2:f.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$dJ=f}),define(De[87],Ce([1,0,2,32,68]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$jJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$iJ=e.$hJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$gJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$fJ=e.$eJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$eJ=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$fJ=E;var w;(function(S){S.serialize=b=>({range:b.range.toJSON(),uri:b.uri.toJSON()}),S.deserialize=b=>({range:T.$ts.lift(b.range),uri:D.URI.revive(b.uri)})})(w||(e.IRichLocation=w={}));var L;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(L||(e.TestMessageType=L={}));var I;(function(S){S.serialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&w.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&w.deserialize(b.location)})})(I||(e.ITestErrorMessage=I={}));const v=(S,b)=>`${b?"s":"e"}${S}`;e.$gJ=v;var y;(function(S){S.serialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&w.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&w.deserialize(b.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(S){S.serialize=b=>b.type===0?I.serialize(b):y.serialize(b),S.deserialize=b=>b.type===0?I.deserialize(b):y.deserialize(b)})(k||(e.ITestMessage=k={}));var p;(function(S){S.serializeWithoutMessages=b=>({state:b.state,duration:b.duration,messages:[]}),S.serialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.serialize)}),S.deserialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.deserialize)})})(p||(e.ITestTaskState=p={}));const h="\0",r=(S,b)=>S+h+b;e.$hJ=r;const s=S=>{const b=S.indexOf(h);return{ctrlId:S.slice(0,b),tagId:S.slice(b+1)}};e.$iJ=s;var o;(function(S){S.serialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?.toJSON(),range:b.range?.toJSON()||null,description:b.description,error:b.error,sortText:b.sortText}),S.deserialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?D.URI.revive(b.uri):void 0,range:b.range?T.$ts.lift(b.range):null,description:b.description,error:b.error,sortText:b.sortText})})(o||(e.ITestItem=o={}));var m;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var u;(function(S){S.serialize=b=>({expand:b.expand,item:o.serialize(b.item)}),S.deserialize=b=>({controllerId:f.$dJ.root(b.item.extId),expand:b.expand,item:o.deserialize(b.item)})})(u||(e.InternalTestItem=u={}));var t;(function(S){S.serialize=b=>{let g;return b.item&&(g={},b.item.label!==void 0&&(g.label=b.item.label),b.item.tags!==void 0&&(g.tags=b.item.tags),b.item.busy!==void 0&&(g.busy=b.item.busy),b.item.uri!==void 0&&(g.uri=b.item.uri?.toJSON()),b.item.range!==void 0&&(g.range=b.item.range?.toJSON()),b.item.description!==void 0&&(g.description=b.item.description),b.item.error!==void 0&&(g.error=b.item.error),b.item.sortText!==void 0&&(g.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:g}},S.deserialize=b=>{let g;return b.item&&(g={},b.item.label!==void 0&&(g.label=b.item.label),b.item.tags!==void 0&&(g.tags=b.item.tags),b.item.busy!==void 0&&(g.busy=b.item.busy),b.item.range!==void 0&&(g.range=b.item.range?T.$ts.lift(b.item.range):null),b.item.description!==void 0&&(g.description=b.item.description),b.item.error!==void 0&&(g.error=b.item.error),b.item.sortText!==void 0&&(g.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:g}}})(t||(e.ITestItemUpdate=t={}));const n=(S,b)=>{b.expand!==void 0&&(S.expand=b.expand),b.item!==void 0&&(S.item=S.item?Object.assign(S.item,b.item):b.item)};e.$jJ=n;var c;(function(S){S.serializeWithoutMessages=b=>({...u.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serializeWithoutMessages)}),S.serialize=b=>({...u.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serialize)}),S.deserialize=b=>({...u.deserialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(S){S.deserialize=b=>b.op===0?{op:b.op,item:u.deserialize(b.item)}:b.op===1?{op:b.op,item:t.deserialize(b.item)}:b.op===2?{op:b.op,uri:D.URI.revive(b.uri),docv:b.docv}:b,S.serialize=b=>b.op===0?{op:b.op,item:u.serialize(b.item)}:b.op===1?{op:b.op,item:t.serialize(b.item)}:b})(l||(e.TestsDiffOp=l={}));class C{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(b){const g=this.o();for(const d of b)switch(d.op){case 0:this.j(u.deserialize(d.item),g);break;case 1:this.k(t.deserialize(d.item),g);break;case 3:this.l(d.itemId,g);break;case 5:this.m(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this.c.set(d.tag.id,d.tag);break;case 7:this.c.delete(d.id);break}g.complete?.()}j(b,g){const d=f.$dJ.parentId(b.item.extId)?.toString();let P;if(!d)P=this.p(b),this.f.add(P),this.d.set(b.item.extId,P);else if(this.d.has(d)){const N=this.d.get(d);N.children.add(b.item.extId),P=this.p(b,N),this.d.set(b.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(b)}`);return}return g.add?.(P),b.expand===2&&this.g++,P}k(b,g){const d=this.d.get(b.extId);if(d)return b.expand!==void 0&&(d.expand===2&&this.g--,b.expand===2&&this.g++),(0,e.$jJ)(d,b),g.update?.(d),d}l(b,g){const d=this.d.get(b);if(!d)return;const P=f.$dJ.parentId(d.item.extId)?.toString();P?this.d.get(P).children.delete(d.item.extId):this.f.delete(d);const N=[[b]];for(;N.length;)for(const F of N.pop()){const M=this.d.get(F);M&&(N.push(M.children),this.d.delete(F),g.remove?.(M,M!==d),M.expand===2&&this.g--)}}m(b){}updatePendingRoots(b){this.h+=b}o(){return{}}}e.$kJ=C}),define(De[109],Ce([1,0,8,4,3,58,87,68]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.TestItemEventOp=void 0;var E;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const w=(s,o)=>s===o,I=Object.entries({range:(s,o)=>s===o?!0:!s||!o?!1:s.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(s,o)=>!(s.length!==o.length||s.some(m=>!o.includes(m)))}),v=(s,o)=>{let m;for(const[u,t]of I)t(s[u],o[u])||(m?m[u]=o[u]:m={[u]:o[u]});return m};class y extends f.$Sc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new D.$6g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===o.uri){m.docv=o.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===o.item.extId){(0,A.$jJ)(m.item,o.item);return}if(m.op===0&&m.item.item.extId===o.item.extId){(0,A.$jJ)(m.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,m){const u=this.tree.get(o);if(u){if((u.expandLevels===void 0||m>u.expandLevels)&&(u.expandLevels=m),u.expand===1){const t=this.L(u);return t.isOpen()?this.J(u,m-1):t.wait().then(()=>this.J(u,m-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.J(u,m-1)):this.J(u,m-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,m){switch(m.op){case 3:this.N($.$dJ.joinToString(o.fullId,m.id));break;case 0:this.y(m.item,o);break;case 5:for(const u of m.ops)this.u(o,u);break;case 1:this.z(m.new,m.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:m.update}});break;case 6:this.w(o.actual.uri);break;default:(0,R.$4c)(m)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,m){const u=$.$dJ.fromExtHostTestItem(o,this.root.id,m?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(o.id);let n=this.tree.get(u.toString());if(!n){n={fullId:u,actual:o,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(o,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(o)}}),this.H(o,n,m);return}if(n.actual===o){this.G(o,n,m);return}if(n.actual.uri?.toString()!==o.uri?.toString())return this.N(u.toString()),this.y(o,m);const c=this.s.getChildren(n.actual),i=n.actual,a=v(this.s.toITestItem(i),this.s.toITestItem(o));this.s.getApiFor(i).listener=void 0,n.actual=o,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.z(o.tags,i.tags,u.toString()),delete a.tags),this.u(n,{op:4,update:a})),this.H(o,n,m);for(const[l,C]of c)this.s.getChildren(o).get(C.id)||this.N($.$dJ.joinToString(u,C.id));this.w(n.actual.uri)}z(o,m,u){const t=new Set(m.map(n=>n.id));for(const n of o)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:u,item:{tags:o.map(n=>(0,A.$hJ)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(o){const m=this.j.get(o.id);m?m.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$hJ)(this.s.controllerId,o.id)}}))}D(o){const m=this.j.get(o);m&&!--m.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$hJ)(this.s.controllerId,o)}))}F(o,m){this.s.getApiFor(o).parent=m&&m.actual!==this.root?m.actual:void 0}G(o,m,u){this.F(o,u);const t=this.s.getApiFor(o);t.parent=u?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(o,m,u){this.G(o,m,u);for(const[t,n]of this.s.getChildren(o))this.y(n,m)}I(o){let m;this.h?o.resolveBarrier?m=o.resolveBarrier.isOpen()?3:2:m=o.actual.canResolveChildren?1:0:m=0,m!==o.expand&&(o.expand=m,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:m}}),m===1&&o.expandLevels!==void 0&&this.L(o))}J(o,m){if(m<0)return;const u=[];for(const[t,n]of this.s.getChildren(o.actual)){const c=this.expand($.$dJ.joinToString(o.fullId,n.id),m);(0,D.$Gg)(c)&&u.push(c)}if(u.length)return Promise.all(u).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const n=new D.$Sg;return n.open(),n}o.expand=2,this.M(o);const m=o.resolveBarrier=new D.$Sg,u=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(n){u(n)}return(0,D.$Gg)(t)?t.catch(u).then(()=>{m.open(),this.I(o)}):(m.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const m=this.tree.get(o);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const u=[m];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,c]of this.s.getChildren(t.actual))u.push(this.tree.get($.$dJ.joinToString(t.fullId,c.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$bM=y;class k extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$cM=k;class p extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dM=p;class h extends Error{constructor(o,m,u){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${u}".`)}}e.$eM=h;const r=(s,o,m)=>{let u=new Map;return{get size(){return u.size},forEach(t,n){for(const c of u.values())t.call(n,c,this)},[Symbol.iterator](){return u.entries()},replace(t){const n=new Map,c=new Set(u.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof m))throw new p(a.id);const l=o(a).controllerId;if(l!==s.controllerId)throw new h(a.id,l,s.controllerId);if(n.has(a.id))throw new k(a.id);n.set(a.id,a),c.delete(a.id),i.ops.push({op:0,item:a})}for(const a of c.keys())i.ops.push({op:3,id:a});s.listener?.(i),u=n},add(t){if(!(t instanceof m))throw new p(t.id);u.set(t.id,t),s.listener?.({op:0,item:t})},delete(t){u.delete(t)&&s.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$fM=r}),define(De[142],Ce([1,0,109]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=void 0;const T=new WeakMap,f=(A,$)=>{const E={controllerId:$};return T.set(A,E),E};e.$gM=f;const R=A=>{const $=T.get(A);if(!$)throw new D.$dM(A?.id||"<unknown>");return $};e.$hM=R}),define(De[110],Ce([1,0,18,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpb=e.$cpb=e.$bpb=e.$apb=e.$_ob=void 0,e.$_ob="vscode-cdn.net",e.$apb=`vscode-resource.${e.$_ob}`,e.$bpb=`'self' https://*.${e.$_ob}`;function f($,E){return $.scheme===D.Schemas.http||$.scheme===D.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===D.Schemas.file&&($=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:E.authority,path:$.path})),T.URI.from({scheme:D.Schemas.https,authority:`${$.scheme}+${R($.authority)}.${e.$apb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$cpb=f;function R($){return $.replace(/./g,E=>{const w=E.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?E:"-"+w.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,w)=>String.fromCharCode(parseInt(w,16)))}e.$dpb=A}),define(De[278],Ce([1,0,4,3,110]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class R{constructor($,E,w){this.d=$,this.e=E,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const I of this.c.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,w,L,I){let v;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){v=o;break}if(!v)throw new Error("not a visible editor");const y=this,k=this.a++,p=new D.$Nd,h=new D.$Nd,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,f.$cpb)(o,y.f)}get cspSource(){return f.$bpb}set options(o){this.b=o,y.d.$setOptions(k,o)}get options(){return this.b}set html(o){this.a=o,y.d.$setHtml(k,o)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(o){return y.d.$postMessage(k,o)}},s=new class{constructor(){this.editor=$,this.line=E,this.height=w,this.webview=r,this.onDidDispose=h.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),h.fire(),h.dispose(),p.dispose())}};return this.d.$createEditorInset(k,v.id,v.value.document.uri,E+1,w,L||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:$,inset:s,onDidReceiveMessage:p}),s}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$sdc=R}),define(De[279],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.VariableKind=e.$0M=void 0,e.$0M=(0,D.$Ph)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class f extends Error{constructor(A,$){super($),this.variable=A}}e.$$M=f}),define(De[280],Ce([1,0,16,48,17,24,12,99,224,279,15]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,p,h){this.h=new Map,this.a=y,this.b=k,this.g=p,h&&(this.c=h.then(r=>this.i(r)))}i(y){if(A.$j){const k=Object.create(null);return Object.keys(y).forEach(p=>{k[p.toLowerCase()]=y[p]}),k}return y}resolveWithEnvironment(y,k,p){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,p)}async resolveAsync(y,k){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,k)}async j(y,k,p,h){const r=R.$7m(k);A.$j&&r.windows?Object.keys(r.windows).forEach(o=>r[o]=r.windows[o]):A.$k&&r.osx?Object.keys(r.osx).forEach(o=>r[o]=r.osx[o]):A.$l&&r.linux&&Object.keys(r.linux).forEach(o=>r[o]=r.linux[o]),delete r.windows,delete r.osx,delete r.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,y?y.uri:void 0,r,p,h)}async resolveAnyAsync(y,k,p){return this.j(y,k,p)}async resolveAnyMap(y,k,p){const h=new Map;return{newConfig:await this.j(y,k,p,h),resolvedVariables:h}}resolveWithInteractionReplace(y,k,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,p,h,r){if(f.$yf(p))return this.m(y,k,p,h,r);if(Array.isArray(p))return Promise.all(p.map(s=>this.l(y,k,s,h,r)));if(f.$Af(p)){const s=Object.create(null),o=await Promise.all(Object.keys(p).map(async m=>[await this.m(y,k,m,h,r),await this.l(y,k,p[m],h,r)]));for(const[m,u]of o)s[m]=u;return s}return p}m(y,k,p,h,r){return(0,L.$Te)(p,I.VARIABLE_REGEXP,async(s,o)=>{if(o.includes(I.VARIABLE_LHS))return s;let m=await this.o(y,s,o,k,h);return r?.set(o,m),m!==s&&f.$yf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(y,k,m,h,r)),m})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,p,h,r){let s;const o=p.split(":");o.length>1&&(p=o[0],s=o[1]);const m=n=>{const c=this.a.getFilePath();if(c)return(0,$.$sv)(c);throw new w.$$M(n,(0,E.localize)(0,null,k))},u=n=>{const c=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,$.$sv)(i)}throw new w.$$M(n,(0,E.localize)(1,null,k,D.$nc(c)))},t=n=>{if(s){const c=this.a.getFolderUri(s);if(c)return c;throw new w.$$M(n,(0,E.localize)(2,null,k,s))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new w.$$M(n,(0,E.localize)(3,null,k)):new w.$$M(n,(0,E.localize)(4,null,k))};switch(p){case"env":if(s){if(y.env){const n=y.env[A.$j?s.toLowerCase():s];if(f.$yf(n))return n}return""}throw new w.$$M(w.VariableKind.Env,(0,E.localize)(5,null,k));case"config":if(s){const n=this.a.getConfigurationValue(h,s);if(f.$Hf(n))throw new w.$$M(w.VariableKind.Config,(0,E.localize)(6,null,k,s));if(f.$Af(n))throw new w.$$M(w.VariableKind.Config,(0,E.localize)(7,null,k,s));return n}throw new w.$$M(w.VariableKind.Config,(0,E.localize)(8,null,k));case"command":return this.p(w.VariableKind.Command,k,s,r,"command");case"input":return this.p(w.VariableKind.Input,k,s,r,"input");case"extensionInstallFolder":if(s){const n=await this.a.getExtension(s);if(!n)throw new w.$$M(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,k,s));return this.n(n.extensionLocation)}throw new w.$$M(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,k));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,$.$sv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return h||s?(0,$.$sv)(this.n(t(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$sv)(D.$nc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new w.$$M(w.VariableKind.UserHome,(0,E.localize)(11,null,k))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new w.$$M(w.VariableKind.LineNumber,(0,E.localize)(12,null,k))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new w.$$M(w.VariableKind.SelectedText,(0,E.localize)(13,null,k))}case"file":return m(w.VariableKind.File);case"fileWorkspaceFolder":return u(w.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||s?D.$lc(this.n(t(w.VariableKind.RelativeFile)),m(w.VariableKind.RelativeFile)):m(w.VariableKind.RelativeFile);case"relativeFileDirname":{const n=D.$mc(m(w.VariableKind.RelativeFileDirname));if(h||s){const c=D.$lc(this.n(t(w.VariableKind.RelativeFileDirname)),n);return c.length===0?".":c}return n}case"fileDirname":return D.$mc(m(w.VariableKind.FileDirname));case"fileExtname":return D.$oc(m(w.VariableKind.FileExtname));case"fileBasename":return D.$nc(m(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=D.$nc(m(w.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-D.$oc(n).length)}case"fileDirnameBasename":return D.$nc(D.$mc(m(w.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||k}case"execInstallFolder":{const n=this.a.getAppRoot();return n||k}case"pathSeparator":return D.sep;default:try{const n=s?`${p}:${s}`:p;return this.p(w.VariableKind.Unknown,k,n,r,void 0)}catch{return k}}}}p(y,k,p,h,r){if(p&&h){const s=r===void 0?h[p]:h[r+":"+p];if(typeof s=="string")return s;throw new w.$$M(y,(0,E.localize)(14,null,k))}return k}}e.$mN=I}),define(De[143],Ce([1,0,5,139]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.OpenEditorContext=e.GroupsOrder=e.$oC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$nC=void 0,e.$nC=(0,D.$Ph)("editorGroupsService");var f;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EVEN=1]="EVEN",k[k.TOGGLE=2]="TOGGLE"})($||(e.GroupsArrangement=$={}));var E;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function w(k){const p=k;return(0,T.$8D)(p?.editor)&&(0,T.$8D)(p?.replacement)}e.$oC=w;var L;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function v(k){const p=k;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$pC=v;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$qC=y}),define(De[281],Ce([1,0,5,143]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=void 0,e.$rC=(0,D.$Ph)("editorService"),e.$sC=-1,e.$tC=-2;function f(R){const A=R;return typeof R=="number"||(0,T.$pC)(A)}e.$uC=f}),define(De[13],Ce([1,0,19,22,162,75,80,28,158,62,97,24,17,2,32,83,133,142,139,108,68,87,281,7]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kM=e.$jM=e.MarkdownString=e.$iM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ke,positionLineNumber:Ze,positionColumn:Je}=ne,nt=new n.$nK(Fe-1,Ke-1),pt=new n.$nK(Ze-1,Je-1);return new n.$pK(nt,pt)}Me.to=Te;function Se(ne){const{anchor:Fe,active:Ke}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Me.from=Se})(c||(e.Selection=c={}));var i;(function(Me){function Te(ne){if(!ne)return;const{start:Fe,end:Ke}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Me.from=Te;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ke,endLineNumber:Ze,endColumn:Je}=ne;return new n.$oK(Fe-1,Ke-1,Ze-1,Je-1)}Me.to=Se})(i||(e.Range=i={}));var a;(function(Me){function Te(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(a||(e.TokenType=a={}));var l;(function(Me){function Te(ne){return new n.$nK(ne.lineNumber-1,ne.column-1)}Me.to=Te;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Se})(l||(e.Position=l={}));var C;(function(Me){function Te(Fe,Ke,Ze){return(0,D.$Hb)((0,D.$3b)(Fe).map(Je=>Se(Je,Ke,Ze)))}Me.from=Te;function Se(Fe,Ke,Ze){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ze?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ke),pattern:Xe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ze?.isBuiltin}}function ne(Fe,Ke){return Ke&&typeof Fe=="string"?Ke.transformOutgoingScheme(Fe):Fe}})(C||(e.DocumentSelector=C={}));var S;(function(Me){function Te(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(S||(e.DiagnosticTag=S={}));var b;(function(Me){function Te(ne){let Fe;return ne.code&&((0,v.$yf)(ne.code)||(0,v.$Cf)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...i.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:d.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(g.from),tags:Array.isArray(ne.tags)?(0,D.$Hb)(ne.tags.map(S.from)):void 0}}Me.from=Te;function Se(ne){const Fe=new n.$AK(i.to(ne),ne.message,d.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,v.$yf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(g.to),Fe.tags=ne.tags&&(0,D.$Hb)(ne.tags.map(S.to)),Fe}Me.to=Se})(b||(e.Diagnostic=b={}));var g;(function(Me){function Te(ne){return{...i.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Te;function Se(ne){return new n.$zK(new n.$yK(ne.resource,i.to(ne)),ne.message)}Me.to=Se})(g||(e.DiagnosticRelatedInformation=g={}));var d;(function(Me){function Te(ne){switch(ne){case n.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Me.from=Te;function Se(ne){switch(ne){case h.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Se})(d||(e.DiagnosticSeverity=d={}));var P;(function(Me){function Te(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.$tC:t.$sC}Me.from=Te;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(P||(e.ViewColumn=P={}));function N(Me){return typeof Me.range<"u"}function F(Me){return Me.length===0?!0:!!N(Me[0])}e.$iM=F;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let nt;if(Se(Je)){const{language:ht,value:gt}=Je;nt={value:"```"+ht+`
`+gt+"\n```\n"}}else n.$MK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const jt=ht=>{try{let gt=y.URI.parse(ht,!0);gt=gt.with({query:Fe(gt.query,pt)}),pt[ht]=gt}catch{}return""},kt=new E.marked.Renderer;return kt.link=jt,kt.image=ht=>typeof ht=="string"?jt(A.$0j(ht).href):"",(0,E.marked)(nt.value,{renderer:kt}),nt}Me.from=ne;function Fe(Je,nt){if(!Je)return Je;let pt;try{pt=(0,w.$lh)(Je)}catch{}if(!pt)return Je;let jt=!1;return pt=(0,I.$9m)(pt,kt=>{if(y.URI.isUri(kt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ht]=kt,jt=!0,ht}else return}),jt?JSON.stringify(pt):Je}function Ke(Je){const nt=new n.$MK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,nt}Me.to=Ke;function Ze(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=Ze})(M||(e.MarkdownString=M={}));function U(Me){return F(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$jM=U;function j(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$kM=j;var O;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?j(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var K;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?O.from(Se.before):void 0,after:Se.after?O.from(Se.after):void 0}}Me.from=Te})(K||(e.ThemableDecorationRenderOptions=K={}));var V;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(V||(e.DecorationRangeBehavior=V={}));var me;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?V.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?O.from(Se.before):void 0,after:Se.after?O.from(Se.after):void 0}}Me.from=Te})(me||(e.DecorationRenderOptions=me={}));var te;(function(Me){function Te(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:i.from(ne.range)}}Me.from=Te;function Se(ne){const Fe=new n.$tK(i.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:et.to(ne.eol),Fe}Me.to=Se})(te||(e.TextEdit=te={}));var G;(function(Me){function Te(ne,Fe){const Ke={edits:[]};if(ne instanceof n.$wK){const Ze=new $.$Bc;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,T.$ve)(T.$be.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:te.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Me.from=Te;function Se(ne){const Fe=new n.$wK,Ke=new $.$Ac;for(const Ze of ne.edits)if(Ze.textEdit){const Je=Ze,nt=y.URI.revive(Je.resource),pt=i.to(Je.textEdit.range),jt=Je.textEdit.text,kt=Je.textEdit.insertAsSnippet;let ht;kt?ht=n.$vK.replace(pt,new n.$xK(jt)):ht=n.$tK.replace(pt,jt);const gt=Ke.get(nt);gt?gt.push(ht):Ke.set(nt,[ht])}else Fe.renameFile(y.URI.revive(Ze.oldResource),y.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Je]of Ke)Fe.set(Ze,Je);return Fe}Me.to=Se})(G||(e.WorkspaceEdit=G={}));var Q;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function ne(Fe){for(const Ke in Te)if(Te[Ke]===Fe)return Number(Ke);return n.SymbolKind.Property}Me.to=ne})(Q||(e.SymbolKind=Q={}));var le;(function(Me){function Te(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Me.to=Se})(le||(e.SymbolTag=le={}));var ie;(function(Me){function Te(ne){return{name:ne.name,kind:Q.from(ne.kind),tags:ne.tags&&ne.tags.map(le.from),containerName:ne.containerName,location:X.from(ne.location)}}Me.from=Te;function Se(ne){const Fe=new n.$DK(ne.name,Q.to(ne.kind),ne.containerName,X.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(le.to),Fe}Me.to=Se})(ie||(e.WorkspaceSymbol=ie={}));var ce;(function(Me){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),kind:Q.from(ne.kind),tags:ne.tags?.map(le.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Me.from=Te;function Se(ne){const Fe=new n.$EK(ne.name,ne.detail,Q.to(ne.kind),i.to(ne.range),i.to(ne.selectionRange));return(0,D.$Lb)(ne.tags)&&(Fe.tags=ne.tags.map(le.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Me.to=Se})(ce||(e.DocumentSymbol=ce={}));var pe;(function(Me){function Te(ne){const Fe=new n.$IK(Q.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,name:ne.name,detail:ne.detail,kind:Q.from(ne.kind),uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(le.from)}}Me.from=Se})(pe||(e.CallHierarchyItem=pe={}));var H;(function(Me){function Te(Se){return new n.$JK(pe.to(Se.from),Se.fromRanges.map(ne=>i.to(ne)))}Me.to=Te})(H||(e.CallHierarchyIncomingCall=H={}));var B;(function(Me){function Te(Se){return new n.$KK(pe.to(Se.to),Se.fromRanges.map(ne=>i.to(ne)))}Me.to=Te})(B||(e.CallHierarchyOutgoingCall=B={}));var X;(function(Me){function Te(ne){return{range:ne.range&&i.from(ne.range),uri:ne.uri}}Me.from=Te;function Se(ne){return new n.$yK(y.URI.revive(ne.uri),i.to(ne.range))}Me.to=Se})(X||(e.location=X={}));var re;(function(Me){function Te(ne){const Fe=ne,Ke=ne;return{originSelectionRange:Fe.originSelectionRange?i.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ke.uri,range:i.from(Fe.targetRange?Fe.targetRange:Ke.range),targetSelectionRange:Fe.targetSelectionRange?i.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:i.to(ne.range),targetSelectionRange:ne.targetSelectionRange?i.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?i.to(ne.originSelectionRange):void 0}}Me.to=Se})(re||(e.DefinitionLink=re={}));var Y;(function(Me){function Te(ne){return{range:i.from(ne.range),contents:M.fromMany(ne.contents)}}Me.from=Te;function Se(ne){return new n.$BK(ne.contents.map(M.to),i.to(ne.range))}Me.to=Se})(Y||(e.Hover=Y={}));var _;(function(Me){function Te(ne){return{range:i.from(ne.range),expression:ne.expression}}Me.from=Te;function Se(ne){return new n.$uL(i.to(ne.range),ne.expression)}Me.to=Se})(_||(e.EvaluatableExpression=_={}));var x;(function(Me){function Te(ne){if(ne instanceof n.$vL)return{type:"text",range:i.from(ne.range),text:ne.text};if(ne instanceof n.$wL)return{type:"variable",range:i.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.$xL)return{type:"expression",range:i.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(ne){switch(ne.type){case"text":return{range:i.to(ne.range),text:ne.text};case"variable":return{range:i.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:i.to(ne.range),expression:ne.expression}}}Me.to=Se})(x||(e.InlineValue=x={}));var ve;(function(Me){function Te(ne){return{frameId:ne.frameId,stoppedLocation:i.from(ne.stoppedLocation)}}Me.from=Te;function Se(ne){return new n.$yL(ne.frameId,i.to(ne.stoppedLocation))}Me.to=Se})(ve||(e.InlineValueContext=ve={}));var ae;(function(Me){function Te(ne){return{range:i.from(ne.range),kind:ne.kind}}Me.from=Te;function Se(ne){return new n.$CK(i.to(ne.range),ne.kind)}Me.to=Se})(ae||(e.DocumentHighlight=ae={}));var fe;(function(Me){function Te(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(fe||(e.CompletionTriggerKind=fe={}));var ee;(function(Me){function Te(Se){return{triggerKind:fe.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(ee||(e.CompletionContext=ee={}));var de;(function(Me){function Te(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Se})(de||(e.CompletionItemTag=de={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Te.get(Ke)??9}Me.from=Se;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Fe(Ke){return ne.get(Ke)??n.CompletionItemKind.Property}Me.to=Fe})(be||(e.CompletionItemKind=be={}));var Pe;(function(Me){function Te(Se,ne){const Fe=new n.$SK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=be.to(Se.kind),Fe.tags=Se.tags?.map(de.to),Fe.detail=Se.detail,Fe.documentation=A.$5j(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.$ts.isIRange(Se.range)?Fe.range=i.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new n.$xK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof n.$oK?new n.$tK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ke=>te.to(Ke))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var z;(function(Me){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:M.fromStrict(ne.documentation)}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?M.to(ne.documentation):ne.documentation}}Me.to=Se})(z||(e.ParameterInformation=z={}));var J;(function(Me){function Te(ne){return{label:ne.label,documentation:M.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(z.from):[],activeParameter:ne.activeParameter}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?M.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(z.to):[],activeParameter:ne.activeParameter}}Me.to=Se})(J||(e.SignatureInformation=J={}));var se;(function(Me){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(J.from):[]}}Me.from=Te;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(J.to):[]}}Me.to=Se})(se||(e.SignatureHelp=se={}));var oe;(function(Me){function Te(Se,ne){const Fe=new n.$RK(l.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Z.to.bind(void 0,Se)),ne.kind&&ge.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(te.to),Fe.tooltip=A.$5j(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Te})(oe||(e.InlayHint=oe={}));var Z;(function(Me){function Te(Se,ne){const Fe=new n.$QK(ne.label);return Fe.tooltip=A.$5j(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,p.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=X.to(ne.location)),Fe}Me.to=Te})(Z||(e.InlayHintLabelPart=Z={}));var ge;(function(Me){function Te(ne){return ne}Me.from=Te;function Se(ne){return ne}Me.to=Se})(ge||(e.InlayHintKind=ge={}));var Ee;(function(Me){function Te(ne){return{range:i.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Te;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new n.$XK(i.to(ne.range),Fe)}Me.to=Se})(Ee||(e.DocumentLink=Ee={}));var je;(function(Me){function Te(ne){const Fe=new n.$1K(ne.label);return ne.textEdit&&(Fe.textEdit=te.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ke=>te.to(Ke))),Fe}Me.to=Te;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?te.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>te.from(Fe)):void 0}}Me.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Te(ne){return new n.$YK(ne[0],ne[1],ne[2],ne[3])}Me.to=Te;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Se})(We||(e.Color=We={}));var _e;(function(Me){function Te(ne){return{range:i.from(ne.range)}}Me.from=Te;function Se(ne){return new n.$HK(i.to(ne.range))}Me.to=Se})(_e||(e.SelectionRange=_e={}));var Ye;(function(Me){function Te(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Me.from=Te;function Se(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Me){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=qe.from(ne.kind)),Fe}Me.from=Te;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=qe.to(ne.kind)),Fe}Me.to=Se})(Ne||(e.FoldingRange=Ne={}));var qe;(function(Me){function Te(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return p.$it.Comment;case n.FoldingRangeKind.Imports:return p.$it.Imports;case n.FoldingRangeKind.Region:return p.$it.Region}}Me.from=Te;function Se(ne){if(ne)switch(ne.value){case p.$it.Comment.value:return n.FoldingRangeKind.Comment;case p.$it.Imports.value:return n.FoldingRangeKind.Imports;case p.$it.Region.value:return n.FoldingRangeKind.Region}}Me.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?s.$UD.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Xe;(function(Me){function Te(Ke){return Ke instanceof n.$iL?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ne(Ke)?new n.$iL(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Me.from=Te;function Se(Ke){const Ze=Ke;return Ze?y.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function ne(Ke){const Ze=Ke;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(Ke){return typeof Ke=="string"?Ke:new n.$iL(y.URI.revive(Ke.baseUri),Ke.pattern)}Me.to=Fe})(Xe||(e.GlobPattern=Xe={}));var he;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:Xe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Te})(he||(e.LanguageSelector=he={}));var ue;(function(Me){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&y.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(Ze=>Ze instanceof n.$oK)))}Me.is=Te;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ke=>({uri:y.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(Ze=>i.from(Ze))})))}}Me.from=Se})(ue||(e.MappedEditsContext=ue={}));var Ie;(function(Me){function Te(ne){return{start:ne.start,end:ne.end}}Me.from=Te;function Se(ne){return new n.$JL(ne.start,ne.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Me){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Te;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var ze;(function(Me){function Te(Se){if(Se===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===o.NotebookCellExecutionState.Pending)return;if(Se===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var xe;(function(Me){function Te(ne){switch(ne){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}Me.from=Te;function Se(ne){switch(ne){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Se})(xe||(e.NotebookCellKind=xe={}));var rt;(function(Me){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ke of ne.cells)n.$KL.validate(Ke),Fe.cells.push(ot.from(Ke));return Fe}Me.from=Te;function Se(ne){const Fe=new n.$LL(ne.cells.map(ot.to));return(0,v.$Lf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Me){function Te(ne){return{cellKind:xe.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ve.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(St.from):[]}}Me.from=Te;function Se(ne){return new n.$KL(xe.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(St.to):void 0,ne.metadata,ne.internalMetadata?Ve.to(ne.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var $t;(function(Me){function Te(ne){return{mime:ne.mime,valueBytes:T.$be.wrap(ne.data)}}Me.from=Te;function Se(ne){return new n.$ML(ne.valueBytes.buffer,ne.mime)}Me.to=Se})($t||(e.NotebookCellOutputItem=$t={}));var St;(function(Me){function Te(ne){return{outputId:ne.id,items:ne.items.map($t.from),metadata:ne.metadata}}Me.from=Te;function Se(ne){const Fe=ne.items.map($t.to);return new n.$NL(Fe,ne.outputId,ne.metadata)}Me.to=Se})(St||(e.NotebookCellOutput=St={}));var Yt;(function(Me){function Te(Fe){return ne(Fe)?{include:Xe.from(Fe.include)??void 0,exclude:Xe.from(Fe.exclude)??void 0}:Xe.from(Fe)??void 0}Me.from=Te;function Se(Fe){return ne(Fe)?{include:Xe.to(Fe.include),exclude:Xe.to(Fe.exclude)}:Xe.to(Fe)}Me.to=Se;function ne(Fe){const Ke=Fe;return Ke?!(0,v.$Hf)(Ke.include)&&!(0,v.$Hf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Gt;(function(Me){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ke,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Gt||(e.NotebookStatusBarItem=Gt={}));var wt;(function(Me){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ke,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(wt||(e.NotebookKernelSourceAction=wt={}));var zt;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(zt||(e.NotebookDocumentContentOptions=zt={}));var Nt;(function(Me){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Te;function Se(ne){return new n.$PL(y.URI.revive(ne.uri),ne.provides)}Me.to=Se})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Me){function Te(ne){return{message:M.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:i.from(ne.location.range),uri:ne.location.uri}}}Me.from=Te;function Se(ne){const Fe=new n.$VL(typeof ne.message=="string"?ne.message:M.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?X.to(ne.location):void 0,Fe}Me.to=Se})(Bt||(e.TestMessage=Bt={}));var At;(function(Me){Me.namespace=u.$hJ,Me.denamespace=u.$iJ})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(ne){const Fe=(0,r.$hM)(ne).controllerId;return{extId:m.$dJ.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ke=>At.namespace(Fe,Ke.id)),range:k.$ts.lift(i.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&M.fromStrict(ne.error)||null}}Me.from=Te;function Se(ne){return{parent:void 0,error:void 0,id:m.$dJ.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ke}=At.denamespace(Fe);return new n.$WL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(ne){return{id:ne.id}}Me.from=Te;function Se(ne){return new n.$WL(ne.id)}Me.to=Se}(At||(e.TestTag=At={}));var Ot;(function(Me){const Te=(ne,Fe)=>{const Ke=[];for(const[Je,nt]of Fe)m.$dJ.compare(nt.item.extId,Je)===2&&(Fe.delete(Je),Ke.push(nt));const Ze={...Rt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:Ke.map(Je=>Te(Je,Fe))};for(const Je of Ze.children)Je.parent=Ze;return Ze};function Se(ne){const Fe=[],Ke=new Map;for(const Ze of ne.items){Ke.set(Ze.item.extId,Ze);const Je=m.$dJ.root(Ze.item.extId);ne.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:ne.completedAt,results:Fe.map(Ze=>Te(Ze,Ke))}}Me.to=Se})(Ot||(e.TestResults=Ot={}));var Wt;(function(Me){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?l.from(Ke):i.from(Ke)}function ne(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Se(Ze.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Me.fromDetailed=ne;function Fe(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Me){function Te(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Jt||(e.CodeActionTriggerKind=Jt={}));var qt;(function(Me){function Te(ne){const Fe=new n.$3L(Q.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,kind:Q.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(le.from)}}Me.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var Vt;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(Vt||(e.ViewBadge=Vt={}));var Lt;(function(Me){function Te(Ke,Ze,Je){const nt=Ze.fileData;return nt?new n.$bL(new n.$cL(nt.name,y.URI.revive(nt.uri),nt.id,(0,R.$db)(()=>Je(nt.id)))):Ke===L.$Pr.uriList&&Ze.uriListData?new n.$aL(Fe(Ze.uriListData)):new n.$aL(Ze.asString)}Me.to=Te;async function Se(Ke,Ze){const Je=await Ze.asString();if(Ke===L.$Pr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const nt=Ze.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Se;function ne(Ke){return f.$3s.split(Ke).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return y.URI.parse(Ze)}catch{}return Ze})}function Fe(Ke){return f.$3s.create(Ke.map(Ze=>typeof Ze=="string"?Ze:y.URI.revive(Ze)))}})(Lt||(e.DataTransferItem=Lt={}));var lt;(function(Me){function Te(ne,Fe){const Ke=ne.items.map(([Ze,Je])=>[Ze,Lt.to(Ze,Je,Fe)]);return new n.$dL(Ke)}Me.toDataTransfer=Te;async function Se(ne){const Fe={items:[]},Ke=[];for(const[Ze,Je]of ne)Ke.push((async()=>{Fe.items.push([Ze,await Lt.from(Ze,Je)])})());return await Promise.all(Ke),Fe}Me.from=Se})(lt||(e.DataTransfer=lt={}));var ft;(function(Me){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Te;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Se})(ft||(e.ChatReplyFollowup=ft={}));var Tt;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:ft.from(Se)}Me.from=Te})(Tt||(e.ChatFollowup=Tt={}));var Kt;(function(Me){function Te(ne){const Fe=new n.$aM(Dt.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Te;function Se(ne){return{role:Dt.from(ne.role),content:ne.content,name:ne.name}}Me.from=Se})(Kt||(e.ChatMessage=Kt={}));var Dt;(function(Me){function Te(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Se(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Se})(Dt||(e.ChatMessageRole=Dt={}));var ct;(function(Me){function Te(Fe){const Ke={};for(const Ze of Object.keys(Fe))Ke[Ze]=Fe[Ze].map(Me.to);return Ke}Me.objectTo=Te;function Se(Fe){return{level:vt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Se;function ne(Fe){return{level:vt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(ct||(e.ChatVariable=ct={}));var vt;(function(Me){function Te(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Se(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(vt||(e.ChatVariableLevel=vt={}));var Ht;(function(Me){function Te(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Pt;(function(Me){function Te(Se){return"placeholder"in Se&&"resolvedContent"in Se?{placeholder:Se.placeholder}:"responseId"in Se?{requestId:Se.responseId}:"content"in Se?{content:"markdownContent"in Se?Se.markdownContent:typeof Se.content=="string"?Se.content:M.from(Se.content)}:"documents"in Se?{documents:Se.documents.map(ne=>({uri:ne.uri,version:ne.version,ranges:ne.ranges.map(Fe=>i.from(Fe))}))}:"reference"in Se?{reference:"uri"in Se.reference?{uri:Se.reference.uri,range:i.from(Se.reference.range)}:Se.reference}:"inlineReference"in Se?{inlineReference:"uri"in Se.inlineReference?{uri:Se.inlineReference.uri,range:i.from(Se.inlineReference.range)}:Se.inlineReference,title:Se.title}:Se}Me.from=Te})(Pt||(e.ChatResponseProgress=Pt={}));var Ge;(function(Me){function Te(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Me.from=Te})(Ge||(e.TerminalQuickFix=Ge={}))}),define(De[282],Ce([1,0,2,9,7,13,76]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class ${constructor(w,L,I,v={timeout:1500,errors:3}){this.c=w,this.d=L,this.f=I,this.g=v,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(L,I,v)=>{const k={dispose:this.a.push([L,I,w])};return Array.isArray(v)&&v.push(k),k}}async $participateInSave(w,L){const I=D.URI.revive(w);let v=!1;const y=setTimeout(()=>v=!0,this.g.timeout),k=[];try{for(const p of[...this.a]){if(v)break;const h=this.d.getDocument(I),r=await this.h(p,{document:h,reason:R.TextDocumentSaveReason.to(L)});k.push(r)}}finally{clearTimeout(y)}return k}h([w,L,I],v){const y=this.b.get(w);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,w,L,v).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const p=this.b.get(w);this.b.set(w,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,L,I,v){const y=[],k=Date.now(),{document:p,reason:h}=v,{version:r}=p,s=Object.freeze({document:p,reason:h,waitUntil(o){if(Object.isFrozen(y))throw(0,T.$8)("waitUntil can not be called async");y.push(Promise.resolve(o))}});try{L.apply(I,[s])}catch(o){return Promise.reject(o)}return Object.freeze(y),new Promise((o,m)=>{const u=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(u),o(t)}).catch(t=>{clearTimeout(u),m(t)})}).then(o=>{const m={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(t=>t instanceof f.$tK))for(const{newText:t,newEol:n,range:c}of u)m.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:t,eol:n&&R.EndOfLine.from(n)}});if(m.edits.length!==0)return r===p.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$Dcc=$}),define(De[283],Ce([1,0,18,2,13,7,108]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0;class ${constructor(I,v,y,k){this.start=I,this.deletedCount=v,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new R.$JL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,v,y){this.notebook=I,this.h=v,this.j=y,this.handle=y.handle,this.uri=T.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,v,y){const k=y.map(f.NotebookCellOutputItem.to),p=this.a.find(h=>h.id===I);if(p&&(v||(p.items.length=0),p.items.push(...k),p.items.length>1&&p.items.every(h=>A.$uI(h.mime)))){const h=new Map,r=[];p.items.forEach(s=>{let o;h.has(s.mime)?o=h.get(s.mime):(o=[],h.set(s.mime,o),r.push(s.mime)),o.push(s.data)}),p.items.length=0,r.forEach(s=>{const o=A.$vI(h.get(s));p.items.push({mime:s,data:o.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Qdc=E;class w{static{this.a=0}constructor(I,v,y,k,p){this.k=I,this.l=v,this.m=y,this.uri=k,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,v={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,v,y){this.g=I.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const r of I.rawEvents)r.kind===A.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,k.contentChanges):r.kind===A.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,k.contentChanges):r.kind===A.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),p.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===A.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),p.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),p.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),p.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),p.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const h=new Map;for(let r=0;r<p.length;r++){const s=p[r],o=h.get(s.cell);if(o===void 0){const m=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});h.set(s.cell,m-1)}else k.cellChanges[o]={...k.cellChanges[o],...s}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let v=I.start|0,y=I.end|0;return v<0&&(v=0),y>this.b.length&&(y=this.b.length),I.with({start:v,end:y})}p(I){I=this.o(I);const v=[];for(let y=I.start;y<I.end;y++)v.push(this.b[y]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,v,y){if(this.j)return;const k=[],p=[],h=[];if(I.reverse().forEach(r=>{const o=r[2].map(t=>{const n=new E(this,this.l,t);return v||p.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new $(r[0],r[1],[],o),u=this.b.splice(r[0],r[1],...o);for(const t of u)h.push(t.uri),m.deletedItems.push(t.apiCell);k.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:h}),y)for(const r of k)y.push(r.asApiEvent())}s(I,v,y,k){const p=this.b.splice(I,v);this.b.splice(y,0,...p);const h=[new $(I,v,p.map(r=>r.apiCell),[]),new $(y,0,[],p)];for(const r of h)k.push(r.asApiEvent())}t(I,v){this.b[I].setOutputs(v)}u(I,v,y,k){this.b[I].setOutputItems(v,y,k)}v(I,v){const y=this.b[I];y.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(y.uri,v)}w(I,v){const y=this.b[I];y.apiCell.mime=v}x(I,v){this.b[I].setMetadata(v)}y(I,v){this.b[I].setInternalMetadata(v)}getCellFromApiCell(I){return this.b.find(v=>v.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(v=>v.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Rdc=w}),define(De[284],Ce([1,0,4,2,13,7]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class A{constructor(E,w,L,I={timeout:1500,errors:3}){this.b=E,this.c=w,this.d=L,this.f=I,this.a=new D.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(w,L,I)=>{const v=function(k){w.call(L,k)};return v.extension=E,this.a.event(v,void 0,I)}}async $participateInSave(E,w,L){const I=T.URI.revive(E),v=this.c.getNotebookDocument(I);if(!v)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:f.TextDocumentSaveReason.to(w)},L,async(p,h)=>{const r=Date.now(),s=await await Promise.resolve(p);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!L.isCancellationRequested&&s&&(s instanceof R.$wK?y.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const p of y){const{edits:h}=f.WorkspaceEdit.from(p);k.edits=k.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$fec=A}),define(De[144],Ce([1,0,9,13,7]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,w,L,I,v){this.id=$,this.f=E,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=L,this.c=v}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(f.$JL.isNotebookRange))throw(0,D.$7)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,w){$.f.$tryRevealRange($.id,T.NotebookRange.from(E),w??f.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Sdc=R}),define(De[285],Ce([1,0,9,4,14,13]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;let A=class{constructor(E,w){this.c=E,this.d=w,this.a=new T.$Nd({onListenerError:D.$2}),this.b=new T.$Nd({onListenerError:D.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,w);const L=this.d.getEditorById(E);w.visibleRanges&&L._acceptVisibleRanges(w.visibleRanges.ranges.map(R.NotebookRange.to)),w.selections&&L._acceptSelections(w.selections.selections.map(R.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const w in E)this.d.getEditorById(w)._acceptViewColumn(R.ViewColumn.to(E[w]))}};e.$$dc=A,e.$$dc=A=He([Be(0,f.$0i)],A)}),define(De[286],Ce([1,0,13,64,209,21,57,9]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class E{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,y,k){const p=this.b++,{title:h,location:r,cancellable:s}=y,o={label:(0,f.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(p,{location:D.ProgressLocation.from(r),title:h,source:o,cancellable:s},v.isUnderDevelopment?void 0:v.identifier.value).catch($.$2),this.d(p,k,!!s)}d(v,y,k){let p;k&&(p=new R.$Xd,this.c.set(v,p));const h=s=>{this.a.$progressEnd(s),this.c.delete(s),p?.dispose()};let r;try{r=y(new L(this.a,v),k&&p?p.token:R.CancellationToken.None)}catch(s){throw h(v),s}return r.then(s=>h(v),s=>h(v)),r}$acceptProgressCanceled(v){const y=this.c.get(v);y&&(y.cancel(),this.c.delete(v))}}e.$cdc=E;function w(I,v){return I.message=v.message,typeof v.increment=="number"&&(typeof I.increment=="number"?I.increment+=v.increment:I.increment=v.increment),I}class L extends T.$5u{constructor(v,y){super(k=>this.throttledReport(k)),this.c=v,this.d=y}throttledReport(v){this.c.$progressReport(this.d,v)}}He([(0,A.$jh)(100,(I,v)=>w(I,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,32,142,68,109,87,13,2]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=e.$xM=void 0;const w=(o,m,u,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(c){if(!u(n,c)){const i=n;n=c,o.listener?.(t(c,i))}}}},L=(o,m)=>o===m,I={range:(o,m)=>o===m?!0:!o||!m?!1:o.isEqual(m),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(o,m)=>!(o.length!==m.length||o.some(u=>!m.find(t=>u.id===t.id)))},v=o=>m=>({op:4,update:o(m)}),y=(o,m)=>({range:(()=>{let u;const t=v(n=>({range:D.$ts.lift($.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return u},set(n){o.listener?.({op:6}),I.range(u,n)||(u=n,o.listener?.(t(n)))}}})(),label:w(o,m,I.label,v(u=>({label:u}))),description:w(o,void 0,I.description,v(u=>({description:u}))),sortText:w(o,void 0,I.sortText,v(u=>({sortText:u}))),canResolveChildren:w(o,!1,I.canResolveChildren,u=>({op:2,state:u})),busy:w(o,!1,I.busy,v(u=>({busy:u}))),error:w(o,void 0,I.error,v(u=>({error:$.MarkdownString.fromStrict(u)||null}))),tags:w(o,[],I.tags,(u,t)=>({op:1,new:u.map($.TestTag.from),old:t.map($.TestTag.from)}))}),k=o=>{const m=f.$dJ.fromString(o.extId),u=new h(m.controllerId,m.localId,o.label,E.URI.revive(o.uri)||void 0);return u.range=$.Range.to(o.range||void 0),u.description=o.description||void 0,u.sortText=o.sortText||void 0,u.tags=o.tags.map(t=>$.TestTag.to({id:(0,A.$iJ)(t).tagId})),u},p=o=>{let m;for(const u of o.tests){const t=k(u.item);(0,T.$hM)(t).parent=m,m=t}return m};e.$xM=p;class h{constructor(m,u,t,n){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const c=(0,T.$gM)(this,m);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof r?void 0:c.parent}},children:{value:(0,R.$fM)(c,T.$hM,h),enumerable:!0,writable:!1},...y(c,t)})}}e.$yM=h;class r extends h{constructor(m,u){super(m,m,u,void 0),this._isRoot=!0}}e.$zM=r;class s extends R.$bM{constructor(m,u,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:T.$hM,getChildren:n=>n.children,root:new r(m,u),toITestItem:$.TestItem.from})}}e.$AM=s}),define(De[146],Ce([1,0,58,9,119,13,7]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0;class ${static{this.c=new f.$qM("TextEditorDecorationType")}constructor(v,y,k){const p=$.c.nextId();v.$registerTextEditorDecorationType(y.identifier,p,R.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:p,dispose(){v.$removeTextEditorDecorationType(p)}})}}e.$sM=$;class E{constructor(v,y){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,y){this.k();let k=null;if(v instanceof A.$nK)k=new A.$oK(v,v);else if(v instanceof A.$oK)k=v;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert(v,y){this.k(),this.l(new A.$oK(v,v),y,!0)}delete(v){this.k();let y=null;if(v instanceof A.$oK)y=v;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(v,y,k){const p=this.c.validateRange(v);this.g.push({range:p,text:y,forceMoveMarkers:k})}setEndOfLine(v){if(this.k(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=v}}class w{constructor(v,y,k,p){this.c=v,this.d=y,this._accept(k),this.e=p;const h=this;this.value={get tabSize(){return h.f},set tabSize(r){h.m(r)},get indentSize(){return h.g},set indentSize(r){h.o(r)},get insertSpaces(){return h.h},set insertSpaces(r){h.q(r)},get cursorStyle(){return h.j},set cursorStyle(r){h.s(r)},get lineNumbers(){return h.k},set lineNumbers(r){h.t(r)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}m(v){const y=this.l(v);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}o(v){const y=this.n(v);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(v){return v==="auto"?"auto":v==="false"?!1:!!v}q(v){const y=this.p(v);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const y={};let k=!1;if(typeof v.tabSize<"u"){const p=this.l(v.tabSize);p==="auto"?(k=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,k=!0,y.tabSize=p)}if(typeof v.indentSize<"u"){const p=this.n(v.indentSize);p==="tabSize"?(k=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,k=!0,y.indentSize=p)}if(typeof v.insertSpaces<"u"){const p=this.p(v.insertSpaces);p==="auto"?(k=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,k=!0,y.insertSpaces=p)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,k=!0,y.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,k=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(v,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(k)})}}e.$tM=w;class L{constructor(v,y,k,p,h,r,s,o){this.id=v,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=h,this.d=new w(this.j,this.id,r,k),this.e=s,this.f=o;const m=this;this.value=Object.freeze({get document(){return p.value},set document(u){throw new T.$9("document")},get selection(){return m.c&&m.c[0]},set selection(u){if(!(u instanceof A.$pK))throw(0,T.$7)("selection");m.c=[u],m.l()},get selections(){return m.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.$pK)))throw(0,T.$7)("selections");m.c=u,m.l()},get visibleRanges(){return m.e},set visibleRanges(u){throw new T.$9("visibleRanges")},get options(){return m.d.value},set options(u){m.g||m.d.assign(u)},get viewColumn(){return m.f},set viewColumn(u){throw new T.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(p.value,t);return u(n),m.m(n)},insertSnippet(u,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=m.c.map(i=>R.Range.from(i));else if(t instanceof A.$nK){const{lineNumber:i,column:a}=R.Position.from(t);c=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.$oK)c=[R.Range.from(t)];else{c=[];for(const i of t)if(i instanceof A.$oK)c.push(R.Range.from(i));else{const{lineNumber:a,column:l}=R.Position.from(i);c.push({startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l})}}return y.$tryInsertSnippet(v,p.value.version,u.value,c,n)},setDecorations(u,t){const n=t.length===0;n&&!m.h.has(u.key)||(n?m.h.delete(u.key):m.h.add(u.key),m.n(()=>{if(R.$iM(t))return y.$trySetDecorations(v,u.key,R.$jM(t));{const c=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const l=t[i];c[4*i]=l.start.line+1,c[4*i+1]=l.start.character+1,c[4*i+2]=l.end.line+1,c[4*i+3]=l.end.character+1}return y.$trySetDecorationsFast(v,u.key,c)}}))},revealRange(u,t){m.n(()=>y.$tryRevealRange(v,R.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){y.$tryShowEditor(v,R.ViewColumn.from(u))},hide(){y.$tryHideEditor(v)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,D.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,D.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,D.ok)(!this.g),this.f=v}_acceptSelections(v){(0,D.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const y=v.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(h=>h.range);k.sort((h,r)=>h.end.line===r.end.line?h.end.character===r.end.character?h.start.line===r.start.line?h.start.character-r.start.character:h.start.line-r.start.line:h.end.character-r.end.character:h.end.line-r.end.line);for(let h=0,r=k.length-1;h<r;h++){const s=k[h].end;if(k[h+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$uM=L}),define(De[147],Ce([1,0,5,131]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=void 0,e.$HJ=(0,D.$Qh)(T.$Wh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=e.$A4b=e.$z4b=e.$y4b=e.$x4b=e.$w4b=void 0;class A{constructor(r,s){this.versionId=r,this.removedDueToLooping=s}}e.$w4b=A;class ${static isHostExtension(r,s,o){if(s.getExtensionDescription(r))return!1;const m=o.getExtensionDescription(r);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(r,s){this.j=r,this.c=new T.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=s,this.k()}k(){this.e.sort(k),this.f=new D.$8l,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const s=this.j.readActivationEvents(r);if(Array.isArray(s))for(let o of s)o==="onUri"&&(o=`onUri:${D.$6l.toKey(r.identifier)}`),this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,s){this.e=p(this.e,s),this.e=this.e.concat(r);const o=$.l(this.e);return this.e=p(this.e,o.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(r){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,c){this.addNode(n),this.addNode(c),this.c.has(n)?this.c.get(n).push(c):this.c.set(n,[c])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,c){const i=s.getArcs(n);for(let a=0;a<i.length;a++)if(!c.has(i[a]))return!1;return!0}getNodes(){return this.e}},o=new D.$8l;for(const n of r)if(o.set(n.identifier,n),n.extensionDependencies)for(const c of n.extensionDependencies)s.addArc(D.$6l.toKey(n.identifier),D.$6l.toKey(c));const m=new Set;s.getNodes().filter(n=>s.getArcs(n).length===0).forEach(n=>m.add(n));const u=s.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<u.length;n++){const c=u[n];s.hasOnlyGoodArcs(c,m)&&(u.splice(n,1),n--,m.add(c),t=!0)}}while(t);return u.map(n=>o.get(n))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const s=this.h.get(r);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const s=this.f.get(r);return s||void 0}getExtensionDescriptionByUUID(r){for(const s of this.g)if(s.uuid===r)return s}getExtensionDescriptionByIdOrUUID(r,s){return this.getExtensionDescription(r)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$x4b=$;class E{constructor(r,s){this.versionId=r,this.extensions=s}}e.$y4b=E,e.$z4b={readActivationEvents:h=>h.activationEvents};class w{constructor(r){this.d=new v,this.c=new $(r,[])}async acquireLock(r){const s=await this.d.acquire(r);return new L(this,s)}deltaExtensions(r,s,o){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,o)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,s){return this.c.getExtensionDescriptionByIdOrUUID(r,s)}}e.$A4b=w;class L extends R.$Sc{constructor(r,s){super(),this.f=r,this.c=!1,this.B(s)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$B4b=L;class I{constructor(r){this.name=r,this.promise=new Promise((s,o)=>{this.c=s})}resolve(r){this.c(r)}}class v{constructor(){this.c=[],this.d=!1}async acquire(r){const s=new I(r);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let s=!0;const o=setTimeout(()=>{s&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{s&&(clearTimeout(o),s=!1,this.d=!1,this.e())};r.resolve((0,R.$Qc)(m))}}var y;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(y||(y={}));function k(h,r){const s=h.isBuiltin?0:h.isUnderDevelopment?2:1,o=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(s!==o)return s-o;const m=f.$gc.basename(h.extensionLocation.path),u=f.$gc.basename(r.extensionLocation.path);return m<u?-1:m>u?1:0}function p(h,r){const s=new D.$7l(r);return h.filter(o=>!s.has(o.identifier))}}),define(De[287],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$xm=T;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$ym=f;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$zm=R;function A(L){delete L[T.ENV_KEY],delete L[f.ENV_KEY],delete L[R.ENV_KEY]}function $(L,I){A(I),L.serialize(I)}e.$Am=$;function E(L){if(L[T.ENV_KEY])return w(L,new T(L[T.ENV_KEY]));if(L[f.ENV_KEY])return w(L,new f);if(L[R.ENV_KEY])return w(L,new R);throw new Error("No connection information defined in environment!")}e.$Bm=E;function w(L,I){return A(L),I}}),define(De[111],Ce([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var f;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(w){const L=D.$be.alloc(1);switch(w){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$bm=A;function $(w,L){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$cm=$;var E;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,14,27,111,66,85,24,2,3,211]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=e.$CM=void 0;let y=class extends I.$Sc{constructor(r,s){super(),this.s=r,this.t=s,this.a=this.B(new T.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=s.createLogger(this.m,{id:E.$oo,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(o=>{(0,f.$_i)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,s,o){const m=this.getTelemetryDetails(),u=new k(s,o,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(r,s,o){this.f=r,this.g=s,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const s=Object.create(null);switch(s["common.extname"]=`${r.publisher}.${r.name}`,s["common.extversion"]=r.version,s["common.vscodemachineid"]=this.s.telemetryInfo.machineId,s["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,s["common.vscodeversion"]=this.s.version,s["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),s["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:s["common.uikind"]="web";break;case A.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,$.$Vk)((0,E.$vo)(this.s.remote.authority)),s}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const s=this.getTelemetryDetails();this.r.forEach((o,m)=>{const u=o.filter(t=>!t.isDisposed);u.length===0?this.r.delete(m):this.r.set(m,u)}),this.r.forEach(o=>{for(const m of o)m.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,s){const m=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(r.value),!1;let u=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(s),u=!0);return u}};e.$CM=y,e.$CM=y=He([Be(0,R.$BM),Be(1,f.$$i)],y);class k{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,s,o,m,u,t,n){this.g=o,this.h=m,this.i=u,this.j=t,this.a=new T.$Nd,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(r,s){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let s="properties"in r?r.properties??{}:r;return s=(0,E.$yo)(s,[]),this.c&&(s=(0,w.$0m)(s,this.c)),this.b||(s=(0,w.$0m)(s,this.j)),"properties"in r?r.properties=s:r=s,r}k(r,s){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(r,s),this.h.trace(r,s))}logUsage(r,s){this.d.isUsageEnabled&&this.k(r,s)}logError(r,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,s);else{const o={name:r.name,message:r.message,stack:r.stack,cause:r.cause},m=(0,E.$yo)(o,[]),u=new Error(m.message,{cause:m.cause});u.stack=m.stack,u.name=m.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData(u,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const r=this,s={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$DM=k;function p(h){const r=Date.now()-new Date(h).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$EM=p,e.$FM=(0,D.$Ph)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,253,137,25,5]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mF=e.$lF=e.$kF=e.ActivationKind=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.ExtensionHostStartup=e.$eF=e.$dF=e.$cF=e.$bF=void 0,e.$bF=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$cF="extensions.webWorker",e.$dF=(0,$.$Ph)("extensionService");class E{constructor(u){this.dependency=u}}e.$eF=E;var w;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,n){this.c=u,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$YE.createActivationEventsMap(this.d)}}set(u,t,n){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const c=[],i=[],a=[],l=[],C=I(this.d),S=I(t),b=(F,M)=>F.extensionLocation.toString()===M.extensionLocation.toString()||F.isBuiltin===M.isBuiltin||F.isUserBuiltin===M.isUserBuiltin||F.isUnderDevelopment===M.isUnderDevelopment;for(const F of this.d){const M=S.get(F.identifier);if(!M){c.push(F.identifier),C.delete(F.identifier);continue}if(!b(F,M)){c.push(F.identifier),C.delete(F.identifier);continue}}for(const F of t){const M=C.get(F.identifier);if(!M){i.push(F);continue}if(!b(M,F)){c.push(M.identifier),C.delete(M.identifier);continue}}const g=new A.$7l(this.e),d=new A.$7l(n);for(const F of this.e)d.has(F)||a.push(F);for(const F of n)g.has(F)||l.push(F);const P=R.$YE.createActivationEventsMap(i),N={versionId:u,toRemove:c,toAdd:i,addActivationEvents:P,myToRemove:a,myToAdd:l};return this.delta(N),N}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:c,myToAdd:i}=u,a=new A.$7l(t),l=new A.$7l(c);for(let C=0;C<this.d.length;C++)a.has(this.d[C].identifier)&&(this.d.splice(C,1),C--);for(let C=0;C<this.e.length;C++)l.has(this.e[C])&&(this.e.splice(C,1),C--);for(const C of n)this.d.push(C);for(const C of i)this.e.push(C);return u}containsExtension(u){for(const t of this.e)if(A.$6l.equals(t,u))return!0;return!1}}e.$fF=L;function I(m){const u=new A.$8l;for(const t of m)u.set(t.identifier,t);return u}function v(m,u){return m.enabledApiProposals?m.enabledApiProposals.includes(u):!1}e.$gF=v;function y(m,u){if(!v(m,u))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$hF=y;class k{constructor(u,t,n,c){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=c}}e.$iF=k;class p{constructor(u,t){this.description=u,this.value=t}}e.$jF=p;var h;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,f.$Eo)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$kF=r;function s(m,u){return{identifier:new A.$6l((0,f.$Co)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!u,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$lF=s;class o{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$mF=o}),define(De[288],Ce([1,0,9,148,25,26,14,8]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=e.$Ecc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(r,s,o,m){this.startup=r,this.codeLoadingTime=s,this.activateCallTime=o,this.activateResolvedTime=m}}e.$Ecc=E;class w{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,s){return r===-1||s===-1?-1:s-r}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Fcc=w;class L{constructor(r,s,o,m,u,t){this.activationFailed=r,this.activationFailedError=s,this.activationTimes=o,this.module=m,this.exports=u,this.subscriptions=t}}e.$Gcc=L;class I extends L{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hcc=I;class v extends L{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Icc=v;class y extends L{constructor(r){super(!0,r,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(r,s,o,m){this.g=m,this.a=r,this.b=s,this.c=o,this.d=new f.$8l,this.f=Object.create(null)}dispose(){for(const[r,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const r=[];for(const[s,o]of this.d)r.push(o.wait());await Promise.all(r)}isActivated(r){const s=this.d.get(r);return!!(s&&s.value)}getActivatedExtension(r){const s=this.d.get(r);if(!s||!s.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return s.value}async activateByEvent(r,s){if(this.f[r])return;const o=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(o.map(m=>({id:m.identifier,reason:{startup:s,extensionId:m.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,s){const o=this.a.getExtensionDescription(r);if(!o)throw new Error(`Extension '${r}' is not known`);return this.h([{id:o.identifier,reason:s}])}async h(r){const s=r.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(s.map(o=>o.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const s=this.a.getExtensionDescription(r.id);if(!s){const u=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new y(u));return this.c.onExtensionActivationError(r.id,u,new R.$eF(r.id.value)),t}const o=[],m=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const u of m){if(this.m(u))continue;const t=this.d.get(u);if(t){o.push(t);continue}if(this.l(u)){o.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:r.reason}));continue}const n=this.a.getExtensionDescription(u);if(n){if(!n.main&&!n.browser)continue;o.push(this.j({id:n.identifier,reason:r.reason}));continue}const c=s.displayName||s.identifier.value,i=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${u}'`),a=this.k(r,s.displayName,[],new y(i));return this.c.onExtensionActivationError(s.identifier,i,new R.$eF(u)),a}return this.k(r,s.displayName,o,null)}k(r,s,o,m){const u=new p(r.id,s,r.reason,o,m,this.c,this.g);return this.d.set(r.id,u),u}l(r){return T.$x4b.isHostExtension(r,this.a,this.b)}m(r){const s=this.b.getExtensionDescription(r);return s?!s.main&&!s.browser:!1}};e.$Jcc=k,e.$Jcc=k=He([Be(3,A.$0i)],k);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,s,o,m,u,t,n){this.c=r,this.d=s,this.f=o,this.g=m,this.h=u,this.j=t,this.k=n,this.a=new $.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const s=this.g[r];if(s.value&&!s.value.activationFailed){this.g.splice(r,1),r--;continue}if(s.value&&s.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);o.detail=s.value.activationFailedError,this.h=new y(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const s=new Error;if(r&&r.name&&(s.name=r.name),r&&r.message?s.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(s.stack=r.stack),this.h=new y(s),this.b&&D.$4(r))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};p=He([Be(6,A.$0i)],p)}),define(De[289],Ce([1,0,213,23,2,4,3,270,8,7,17,19,13,80,21,173,26]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;function r(m,u){if((0,L.$yf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class s extends A.$Sc{constructor(u,t,n){super(),this.f=u,this.g=t,this.h=n,this.a=new Map,this.b=new p.$R7;function c(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>c(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(a=>c(a)?this.r(a):a):i})}registerTreeDataProvider(u,t,n){const c=this.createTreeView(u,{treeDataProvider:t},n);return{dispose:()=>c.dispose()}}createTreeView(u,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,C=this.m(u,t,n),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:i,hasHandleDrag:a,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(u,S),g={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,h.$hF)(n,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,h.$hF)(n,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(d){(0,y.$5j)(d)&&(0,h.$hF)(n,"treeViewMarkdownMessage"),C.message=d},get title(){return C.title},set title(d){C.title=d},get description(){return C.description},set description(d){C.description=d},get badge(){return C.badge},set badge(d){d!==void 0&&w.ViewBadge.isViewBadge(d)?C.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(C.badge=void 0)},reveal:(d,P)=>C.reveal(d,P),dispose:async()=>{await b,this.a.delete(u),C.dispose()}};return this.B(g),g}$getChildren(u,t){const n=this.a.get(u);return n?n.getChildren(t):Promise.reject(new $.$sE(u))}async $handleDrop(u,t,n,c,i,a,l,C){const S=this.a.get(u);if(!S)return Promise.reject(new $.$sE(u));const b=v.DataTransfer.toDataTransfer(n,async g=>(await this.f.$resolveDropFileData(u,t,g)).buffer);return l===u&&C&&await this.j(b,S,C,i,a),S.onDrop(b,c,i)}async j(u,t,n,c,i){const a=this.b.removeDragOperationTransfer(i);if(a)(await a)?.forEach((l,C)=>{l&&u.set(C,l)});else if(i&&t.handleDrag){const l=t.handleDrag(n,u,c);this.b.addDragOperationTransfer(i,l),await l}return u}async $handleDrag(u,t,n,c){const i=this.a.get(u);if(!i)return Promise.reject(new $.$sE(u));const a=await this.j(new w.$dL,i,t,c,n);if(!(!a||c.isCancellationRequested))return v.DataTransfer.from(a)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new $.$sE(u);return t.hasResolve}$resolve(u,t,n){const c=this.a.get(u);if(!c)throw new $.$sE(u);return c.resolveTreeItem(t,n)}$setExpanded(u,t,n){const c=this.a.get(u);if(!c)throw new $.$sE(u);c.setExpanded(t,n)}$setSelectionAndFocus(u,t,n){const c=this.a.get(u);if(!c)throw new $.$sE(u);c.setSelectionAndFocus(t,n)}$setVisible(u,t){const n=this.a.get(u);if(!n){if(!t)return;throw new $.$sE(u)}n.setVisible(t)}$changeCheckboxState(u,t){const n=this.a.get(u);if(!n)throw new $.$sE(u);n.setCheckboxState(t)}m(u,t,n){const c=this.B(new o(u,t,this.f,this.g.converter,this.h,n));return this.a.set(u,c),c}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$jdc=s;class o extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,L.$Hf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,n,c,i,a){if(super(),this.I=u,this.J=n,this.L=c,this.M=i,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$Xd,a.contributes&&a.contributes.views)for(const b in a.contributes.views)for(const g of a.contributes.views[b])g.id===u&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let l,C;const S=R.Event.debounce(this.F.event,(b,g)=>(b||(b={message:!1,elements:[]}),g.element!==!1&&(l||(l=new Promise(d=>C=d),this.G=this.G.then(()=>l)),Array.isArray(g.element)?b.elements.push(...g.element):b.elements.push(g.element)),g.message&&(b.message=!0),b),200,!0);this.B(S(({message:b,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const d=C;return l=null,this.$(g).then(()=>d())})),b&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let n=this.X(u);return n||(n=await this.Y(t)),n?n.map(c=>c.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const n=(0,L.$Hf)(t.select)?!0:t.select,c=(0,L.$Hf)(t.focus)?!1:t.focus,i=(0,L.$Hf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(a=>this.W(u,a[a.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:a.map(C=>C.item)},{select:n,focus:c,expand:i})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:n,focus:c,expand:i})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=v.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const n=this.getExtensionElement(u);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(u,t){const n=!(0,I.$ub)(this.s,u);this.s=u;const c=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async n=>{const c=this.getExtensionElement(n.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(u,t,n){const c=[];for(const i of u){const a=this.getExtensionElement(i);a&&c.push(a)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,n){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,E.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(c,u,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(u);if(n){const c=this.m.get(n);if(c){const i=await this.f.resolveTreeItem(c.extensionItem,n,t)??c.extensionItem;return this.hb(i),c.item.tooltip=this.eb(i.tooltip),c.item.command=this.fb(c.disposableStore,i.command),c.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(c=>(n.push(c),n))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Mg)(()=>this.f.getParent(u))}W(u,t){const n=this.m.get(u);return n?Promise.resolve(n):(0,E.$Mg)(()=>this.f.getTreeItem(u)).then(c=>this.kb(u,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(c);if(i){const a=this.m.get(i);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const n=this.getExtensionElement(u);t=n?this.m.get(n):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new k.$Xd(this.Z.token);try{const n=u?this.m.get(u):void 0,c=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Hb)(c||[]).map(async a=>{const l=await this.f.getTreeItem(a);return l&&!t.token.isCancellationRequested?this.db(a,l,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Hb)(i)}finally{t.dispose()}}$(u){if(u.some(n=>!n))return this.Z.dispose(!0),this.Z=new k.$Xd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(u);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(u){const t=new Set,n=u.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let a=i;for(;a&&a.parent&&n.findIndex(l=>a&&a.parent&&l&&l.item.handle===a.parent.item.handle)===-1;){const l=this.j.get(a.parent.item.handle);a=l?this.m.get(l):void 0}a&&!a.parent&&t.add(i.item.handle)}const c=[];return t.forEach(i=>{const a=this.j.get(i);if(a){const l=this.m.get(a);l&&(!l.parent||!t.has(l.parent.item.handle))&&c.push(i)}}),c}bb(u){const t={};return Promise.all(u.map(n=>this.cb(n).then(c=>{c&&(t[n]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Mg)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const i=this.ib(t,c,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(u,t,n){const c=this.ib(u,t,n);if(t.id&&this.j.has(c.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(u,c),this.qb(c,n),c}eb(u){return w.$MK.isMarkdownString(u)?v.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,n,c;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,n=u.checkboxState.tooltip,c=u.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:c}}hb(u){if(!w.$$K.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,n){this.hb(t);const c=this.B(new A.$Rc),i=this.kb(u,t,n),a=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,L.$Hf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(u){return u.iconPath instanceof w.$gL?u.iconPath:void 0}kb(u,{id:t,label:n,resourceUri:c},i,a){if(t)return`${o.b}/${t}`;const l=r(n,this.N),C=i?i.item.handle:o.a;let S=l?l.label:c?(0,T.$sg)(c):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const b=this.m.has(u)?this.m.get(u).item.handle:void 0,g=this.X(i)||[];let d,P=0;do{if(d=`${C}/${P}:${S}`,a||!this.j.has(d)||b===d)break;P++}while(P<=g.length);return d}lb(u){if(u.iconPath&&!(u.iconPath instanceof w.$gL))return typeof u.iconPath=="string"||f.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof w.$gL)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return f.URI.isUri(u)?u:f.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,n,c){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(u,t);const i=this.X(c)||[],a=i.filter(l=>l.item.handle===n.item.handle)[0];a&&i.splice(i.indexOf(a),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const n of t.children){const c=this.j.get(n.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const n of t.children){const c=this.j.get(n.item.handle);c&&this.sb(c)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[290],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[291],Ce([1,0,225,9,38,132,105,43,25,290,135,137]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0;const v=$.$gn.as(A.$hn.JSONContribution);class y{constructor(u,t,n){this.a=u,this.b=t,this.c=n}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(f.default.Error,u)}warn(u){this.d(f.default.Warning,u)}info(u){this.d(f.default.Info,u)}}e.$8E=y;class k{static a(u){const t=new E.$7l;for(let n=0,c=u.length;n<c;n++)t.add(u[n].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new k(t,[]);if(!t||!t.length)return new k([],u);const n=this.a(u),c=this.a(t),i=t.filter(l=>!n.has(l.description.identifier)),a=u.filter(l=>!c.has(l.description.identifier));return new k(i,a)}constructor(u,t){this.added=u,this.removed=t}}e.$9E=k;class p{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=k.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,T.$1)(u)}}}e.$0E=p;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$$E={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$5l},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Xn}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Xn}},extensionKind:{description:D.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new p(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&I.$YE.register(u.extensionPoint,u.activationEventsGenerator),e.$$E.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,v.registerSchema(r,e.$$E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$_E=s;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$gn.add(o.ExtensionsRegistry,new s),e.$aF=$.$gn.as(o.ExtensionsRegistry),v.registerSchema(r,e.$$E),v.registerSchema(L.$qj,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(De[292],Ce([1,0,222,17,24,291,42,4]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var w;(function(v){function y(k,p,h){if(!k)return;const r=T.$yf(k.type)?k.type:void 0;if(!r||r.length===0){h.error(D.localize(3,null));return}const s=[];if(Array.isArray(k.required))for(const o of k.required)T.$yf(o)&&s.push(o);return{extensionId:p.value,taskType:r,required:s,properties:k.properties?f.$7m(k.properties):{},when:k.when?A.$Ni.deserialize(k.when):void 0}}v.from=y})(w||(w={}));const L=R.$aF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,y)=>{for(const k of v)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new $.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{L.setHandler((p,h)=>{this.c=void 0;try{for(const r of h.removed){const s=r.value;for(const o of s)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const r of h.added){const s=r.value;for(const o of s){const m=w.from(o,r.description.identifier,r.collector);m&&(this.a[m.taskType]=m)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const p={type:"object",additionalProperties:!1};k.required.length>0&&(p.required=k.required.slice(0)),k.properties!==void 0?p.properties=f.$7m(k.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[k.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$RF=new I}),define(De[293],Ce([1,0,223,17,23,24,42,292]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2F=e.JsonSchemaVersion=e.ExecutionEngine=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VF=e.ShellQuoting=e.$UF=e.$TF=e.$SF=void 0,e.$SF="settings",e.$TF=new A.$7i("taskRunning",!1,D.localize(0,null)),e.$UF={value:D.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$VF="$customized",function(j){function O(K){if(!K)return j.Strong;switch(K.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=O}(E||(e.ShellQuoting=E={}));var w;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var L;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(L||(e.RevealKind=L={})),function(j){function O(K){switch(K.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=O}(L||(e.RevealKind=L={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function O(K){switch(K.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=O}(I||(e.RevealProblemKind=I={}));var v;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(v||(e.PanelKind=v={})),function(j){function O(K){switch(K.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=O}(v||(e.PanelKind=v={}));var y;(function(j){j.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(j){function O(V){switch(V.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=O;function K(V){switch(V){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=K}(k||(e.RuntimeType=k={}));var p;(function(j){function O(K){return T.$yf(K)?K:K.value}j.value=O})(p||(e.CommandString=p={}));var h;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function O(V){return V===j.Clean._id||V===j.Build._id||V===j.Rebuild._id||V===j.Test._id}j.is=O;function K(V){if(V!==void 0)return T.$yf(V)?O(V)?{_id:V,isDefault:!1}:void 0:V}j.from=K})(h||(e.TaskGroup=h={}));var r;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var s;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function O(K){switch(K){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=O})(s||(e.TaskSourceKind=s={}));var o;(function(j){j.parallel="parallel",j.sequence="sequence"})(o||(e.DependsOrder=o={}));var m;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var u;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(O,K,V,me,te,G){this._label="",this._id=O,K&&(this._label=K),V&&(this.type=V),this.runOptions=me,this.configurationProperties=te,this._source=G}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,K=!1){if(O===void 0)return!1;if(T.$yf(O))return O===this._label||O===this.configurationProperties.identifier||K&&O===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$WF=t;class n extends t{constructor(O,K,V,me,te,G,Q,le){super(O,V,void 0,Q,le,K),this.command={},this._source=K,this.hasDefinedMatchers=G,te&&(this.command=te)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case k.Shell:K="shell";break;case k.Process:K="process";break;case k.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(O){return O instanceof n}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let K=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(K+=this._source.kind);const V={type:e.$VF,folder:O,id:K};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new n(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$XF=n;class c extends t{constructor(O,K,V,me,te,G,Q){super(O,V,me,G,Q,K),this._source=K,this.configures=te}static is(O){return O instanceof c}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let K=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(K+=this._source.kind);const V={type:e.$VF,folder:O,id:K};return JSON.stringify(V)}}e.$YF=c;class i extends t{constructor(O,K,V,me,te,G,Q,le,ie){super(O,V,me,le,ie,K),this.defines=te,this.hasDefinedMatchers=Q,this.command=G,this.icon=ie.icon,this.hide=ie.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof i}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new i(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$ZF=i;class a extends t{constructor(O,K,V,me,te,G){super(O,V,me,te,G,K),this._source=K}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$1F=a;var l;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(j){j._default=j.Terminal}(l||(e.ExecutionEngine=l={}));var C;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class S{constructor(O){this.c=new Map;for(let K=0;K<O.length;K++)this.c.set(O[K].uri.toString(),K)}compare(O,K){const V=O.getWorkspaceFolder(),me=K.getWorkspaceFolder();if(V&&me){let te=this.c.get(V.uri.toString());te=te===void 0?0:te+1;let G=this.c.get(me.uri.toString());return G=G===void 0?0:G+1,te===G?O._label.localeCompare(K._label):te-G}else return!V&&me?-1:V&&!me?1:0}}e.$2F=S;var b;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(b||(e.TaskEventKind=b={}));var g;(function(j){j.SingleRun="singleRun",j.Background="background"})(g||(e.TaskRunType=g={}));var d;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(d||(e.TaskRunSource=d={}));var P;(function(j){function O(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function K(le,ie,ce){return{...O(le),kind:"start",terminalId:ie,resolvedVariables:ce}}j.start=K;function V(le,ie,ce){return{...O(le),kind:"processStarted",terminalId:ie,processId:ce}}j.processStarted=V;function me(le,ie,ce){return{...O(le),kind:"processEnded",terminalId:ie,exitCode:ce}}j.processEnded=me;function te(le,ie,ce){return{...O(le),kind:"terminated",exitReason:ce,terminalId:ie}}j.terminated=te;function G(le,ie,ce){return{...O(ie),kind:le,terminalId:ce}}j.general=G;function Q(){return{kind:"changed"}}j.changed=Q})(P||(e.TaskEvent=P={}));var N;(function(j){function O(V){const me=Object.keys(V).sort();let te="";for(const G of me){let Q=V[G];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),te+=G+","+Q+","}return te}function K(V){const te={_key:O(V),type:V.taskType};return Object.assign(te,V),te}j.create=K})(N||(e.KeyedTaskIdentifier=N={}));var F;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(F||(e.TaskSettingId=F={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var U;(function(j){function O(K,V){const me=$.$RF.get(K.type);if(me===void 0){const le=R.$7m(K);return delete le._key,N.create(le)}const te=Object.create(null);te.type=me.taskType;const G=new Set;me.required.forEach(le=>G.add(le));const Q=me.properties;for(const le of Object.keys(Q)){const ie=K[le];if(ie!=null)te[le]=ie;else if(G.has(le)){const ce=Q[le];if(ce.default!==void 0)te[le]=R.$7m(ce.default);else switch(ce.type){case"boolean":te[le]=!1;break;case"number":case"integer":te[le]=0;break;case"string":te[le]="";break;default:V.error(D.localize(2,null,JSON.stringify(K,void 0,0),le));return}}}return N.create(te)}j.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(De[294],Ce([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=e.$C4b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$C4b=T;class f extends T{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$D4b=f}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class D{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++D.count}}e.$nv=D;const T=[];function f($){const E=new D($);return T[E.nid]=E,E}e.$ov=f;function R($){return T[$].sid}e.$pv=R;class A{constructor(E){this.value=E}}e.$qv=A}),define(De[6],Ce([1,0,69]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$kK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$jK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var f;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var w;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static{this.a=0}static mixin(h){return h._id=I.a++,h}}e.$jK=I;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$kK={MainThreadAuthentication:(0,D.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,D.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,D.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$ov)("MainThreadClipboard"),MainThreadCommands:(0,D.$ov)("MainThreadCommands"),MainThreadComments:(0,D.$ov)("MainThreadComments"),MainThreadConfiguration:(0,D.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,D.$ov)("MainThreadConsole"),MainThreadDebugService:(0,D.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,D.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,D.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$ov)("MainThreadLanguages"),MainThreadLogger:(0,D.$ov)("MainThreadLogger"),MainThreadMessageService:(0,D.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,D.$ov)("MainThreadOutputService"),MainThreadProgress:(0,D.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$ov)("MainThreadSecretState"),MainThreadStorage:(0,D.$ov)("MainThreadStorage"),MainThreadSpeech:(0,D.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,D.$ov)("MainThreadSCM"),MainThreadSearch:(0,D.$ov)("MainThreadSearch"),MainThreadShare:(0,D.$ov)("MainThreadShare"),MainThreadTask:(0,D.$ov)("MainThreadTask"),MainThreadWindow:(0,D.$ov)("MainThreadWindow"),MainThreadLabelService:(0,D.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,D.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$ov)("MainThreadInteractive"),MainThreadChat:(0,D.$ov)("MainThreadChat"),MainThreadInlineChat:(0,D.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,D.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$ov)("MainThreadTimeline"),MainThreadTesting:(0,D.$ov)("MainThreadTesting"),MainThreadLocalization:(0,D.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$ov)("MainThreadIssueReporter")},e.$lK={ExtHostCommands:(0,D.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,D.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,D.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,D.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$ov)("ExtHostStatusBar"),ExtHostShare:(0,D.$ov)("ExtHostShare"),ExtHostExtensionService:(0,D.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,D.$ov)("ExtHostSCM"),ExtHostSearch:(0,D.$ov)("ExtHostSearch"),ExtHostTask:(0,D.$ov)("ExtHostTask"),ExtHostWorkspace:(0,D.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,D.$ov)("ExtHostWindow"),ExtHostWebviews:(0,D.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$ov)("ExtHostProgress"),ExtHostComments:(0,D.$ov)("ExtHostComments"),ExtHostSecretState:(0,D.$ov)("ExtHostSecretState"),ExtHostStorage:(0,D.$ov)("ExtHostStorage"),ExtHostUrls:(0,D.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,D.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,D.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$ov)("ExtHostChat"),ExtHostChatAgents:(0,D.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,D.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,D.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$ov)("ExtHostTimeline"),ExtHostTesting:(0,D.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,D.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$ov)("ExtHostIssueReporter")}}),define(De[295],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$kK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiRelatedInformationProvider(w,$),new T.$mK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$lec=f}),define(De[89],Ce([1,0,5,14,6,20]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=e.$ncc=void 0,e.$ncc=(0,D.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(E,w){this.c=w,this.a=new Set,this.b=E.getProxy(f.$kK.MainThreadTelemetry)}report(E,w,L){const I=this.d(E,w);this.a.has(I)||(this.a.add(I),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:E}))}d(E,w){return`${E}-${w.identifier.value}`}};e.$occ=A,e.$occ=A=He([Be(0,R.$lM),Be(1,T.$0i)],A),e.$pcc=Object.freeze(new class{report($,E,w){}})}),define(De[296],Ce([1,0,4,6,7,25]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new D.$Nd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=w.getProxy(T.$kK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,L,I,v={}){const y=R.$6l.toKey(w.identifier),k=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${L} ${k}`,async()=>{await this.a.$ensureProvider(L);const p=w.displayName||w.name;return this.a.$getSession(L,I,y,p,v)})}async getSessions(w,L,I){const v=R.$6l.toKey(w.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${v} ${y}`,async()=>{await this.a.$ensureProvider(L);const k=w.displayName||w.name;return this.a.$getSessions(L,I,v,k)})}async removeSession(w,L){const I=this.b.get(w);return I?I.provider.removeSession(L):this.a.$removeSession(w,L)}registerAuthenticationProvider(w,L,I,v){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:L,provider:I,options:v??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===w)||this.c.push({id:w,label:L});const y=I.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(w,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(w,L,v?.supportsMultipleAccounts??!1),new f.$mK(()=>{y.dispose(),this.b.delete(w);const k=this.c.findIndex(p=>p.id===w);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,L,I){const v=this.b.get(w);if(v)return Promise.resolve(v.provider.createSession(L,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,L){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,L){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,L){return this.d.fire({provider:{id:w,label:L}}),Promise.resolve()}}e.$Vdc=A;class ${constructor(){this.a=new Map}getOrCreate(w,L){const I=this.a.get(w);if(I)return I;const v=L().finally(()=>this.a.delete(w));return this.a.set(w,v),v}}}),define(De[297],Ce([1,0,6,20,13]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;let R=class{constructor($,E){this.a=$.getProxy(D.$kK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>E.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,w){const L=f.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,w?.isRefactoring??!1)}};e.$2dc=R,e.$2dc=R=He([Be(0,T.$lM)],R)}),define(De[298],Ce([1,0,8,4,51,3,35,202,6,13]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class L{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=L.a++}}class I{static{this.a=0}constructor(y,k){this.h=k,this.b=new Map,this.d=new Map,this.e=new T.$Nd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$kK.MainThreadChat)}registerChatProvider(y,k,p){const h=new L(y,p);return this.b.set(h.handle,h),this.g.$registerChatProvider(h.handle,k),(0,R.$Qc)(()=>{this.g.$unregisterChatProvider(h.handle),this.b.delete(h.handle)})}transferChatSession(y,k){const p=f.Iterable.find(this.d.keys(),h=>this.d.get(h)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,k)}sendInteractiveRequestToProvider(y,k){this.g.$sendRequestToProvider(y,k)}async $prepareChat(y,k,p){const h=this.b.get(y);if(!h)return;const r=await h.provider.prepareSession(k,p);if(!r)return;const s=I.a++;return this.d.set(s,r),{id:s,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $provideWelcomeMessage(y,k){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const h=await p.provider.provideWelcomeMessage(k);if(h)return h.map(r=>typeof r=="string"?r:r.map(s=>w.ChatReplyFollowup.from(s)))}async $provideFollowups(y,k,p){const h=this.b.get(y);if(!h)return;const r=this.d.get(k);return!r||!h.provider.provideFollowups?void 0:(await h.provider.provideFollowups(r,p))?.map(o=>w.ChatFollowup.from(o))}async $provideSampleQuestions(y,k){const p=this.b.get(y);if(!p||!p.provider.provideSampleQuestions)return;const h=await p.provider.provideSampleQuestions(k);if(h)return h?.map(r=>w.ChatReplyFollowup.from(r))}$removeRequest(y,k,p){const h=this.b.get(y);if(!h)return;const r=this.d.get(k);r&&h.provider.removeRequest&&h.provider.removeRequest(r,p)}async $provideReply(y,k,p,h){const r=this.b.get(y);if(!r)return;const s=this.d.get(k);if(!s)return;const o={session:s,message:p.message,variables:{}};if(p.variables)for(const i of Object.keys(p.variables))o.variables[i]=p.variables[i].map(w.ChatVariable.to);const m=A.$Jd.create(!1);let u;const t={report:i=>{if(h.isCancellationRequested)return;typeof u>"u"&&(u=m.elapsed());const a=w.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const l=Promise.all([this.g.$acceptResponseProgress(y,k,a),i.resolvedContent]);(0,D.$Ig)(l,h).then(C=>{if(!C)return;const[S,b]=C;this.g.$acceptResponseProgress(y,k,b,S??void 0)})}else this.g.$acceptResponseProgress(y,k,a)}};let n;try{n=await r.provider.provideResponseWithProgress(o,t,h),n||(n={errorDetails:{message:(0,$.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,$.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(s.saveState&&this.d.has(k)){const i=s.saveState();this.g.$acceptChatState(k,i)}}catch(i){this.h.warn(i)}const c={firstProgress:u??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:c}}async $provideSlashCommands(y,k,p){const h=this.b.get(y);if(!h)return;const r=this.d.get(k);return!r||!h.provider.provideSlashCommands?void 0:(await h.provider.provideSlashCommands(r,p))?.map(o=>({...o,kind:w.CompletionItemKind.from(o.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$dec=I}),define(De[299],Ce([1,0,8,3,64,6,13,7]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class E{static{this.a=0}constructor(I,v,y){this.d=v,this.e=y,this.b=new Map,this.c=I.getProxy(R.$kK.MainThreadChatAgents)}registerAgent(I,v,y,k){const p=E.a++;return this.b.set(p,{extension:I,agent:y}),this.c.$registerAgent(p,v,k),(0,T.$Qc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(I,v,y,k,p){const h=this.b.get(I);if(!h){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let r=!1;function s(){if(r)throw new Error("Only valid while executing the command")}const o=new D.$ch;p.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.d.allowListExtensionWhile(h.extension,o.p);const m=h.agent({role:$.ChatMessageRole.User,content:y},{history:k.history.map(A.ChatMessage.to)},new f.$5u(u=>{s(),this.c.$handleProgressChunk(v,{content:w(u.message)?u.message:u.message.value})}),p);try{return await(0,D.$Ig)(Promise.resolve(m).then(u=>{if(u&&"followUp"in u)return{followUp:u?.followUp?.map(n=>A.ChatFollowup.from(n))}}),p)}finally{r=!0,o.complete()}}}e.$nec=E;function w(L){return!!L&&typeof L=="object"&&"treeData"in L}}),define(De[300],Ce([1,0,8,21,41,4,35,17,203,64,6,13,7,271,26]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class p{static{this.a=0}constructor(s,o,m){this.i=o,this.j=m,this.b=new Map,this.g=new Map,this.h=new Map,this.d=s.getProxy(L.$kK.MainThreadChatAgents2)}createChatAgent(s,o,m){const u=p.a++,t=new h(s,o,this.d,u,m);return this.b.set(u,t),this.d.$registerAgent(u,o,{}),t.apiAgent}async $invokeAgent(s,o,m,u,t,n){this.g.delete(o);const c=this.b.get(s);if(!c)throw new Error(`[CHAT](${s}) CANNOT invoke agent because the agent is not registered`);let i=!1;function a(){if(i)throw new Error("Only valid while executing the command")}const l=new D.$ch;n.onCancellationRequested(()=>l.complete()),setTimeout(()=>l.complete(),10*1e3),this.i.allowListExtensionWhile(c.extension.identifier,l.p);const C=u.command?await c.validateSlashCommand(u.command):void 0,S=A.$Jd.create(!1);let b;try{const g=c.invoke({prompt:u.message,variables:I.ChatVariable.objectTo(u.variables),slashCommand:C},{history:t.history.map(I.ChatMessage.to)},new w.$5u(d=>{a(),typeof b>"u"&&(b=S.elapsed());const P=I.ChatResponseProgress.from(d);if("placeholder"in d&&"resolvedContent"in d){const N=Promise.all([this.d.$handleProgressChunk(m,P),d.resolvedContent]);(0,D.$Ig)(N,n).then(F=>{if(!F)return;const[M,U]=F;this.d.$handleProgressChunk(m,U,M??void 0)})}else this.d.$handleProgressChunk(m,P)}),n);return await(0,D.$Ig)(Promise.resolve(g).then(d=>{if(d){this.g.set(o,d);let P=this.h.get(o);P||(P=new Map,this.h.set(o,P)),P.set(m,d);const N={firstProgress:b,totalElapsed:S.elapsed()};return{errorDetails:d.errorDetails,timings:N}}else this.g.delete(o)}),n)}catch(g){return this.j.error(g,c.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,f.$Ai)(g)),responseIsIncomplete:!0}}}finally{i=!0,l.complete()}}$releaseSession(s){this.g.delete(s),this.h.delete(s)}async $provideSlashCommands(s,o){const m=this.b.get(s);return m?m.provideSlashCommand(o):[]}$provideFollowups(s,o,m){const u=this.b.get(s);if(!u)return Promise.resolve([]);const t=this.g.get(o);return t?u.provideFollowups(t,m):Promise.resolve([])}$acceptFeedback(s,o,m,u){const t=this.b.get(s);if(!t)return;const n=this.h.get(o)?.get(m);if(!n)return;let c;switch(u){case y.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case y.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}t.acceptFeedback(Object.freeze({result:n,kind:c}))}$acceptAction(s,o,m,u){const t=this.b.get(s);if(!t)return;const n=this.h.get(o)?.get(m);n&&u.action.kind!=="vote"&&t.acceptAction(Object.freeze({action:u.action,result:n}))}}e.$oec=p;class h{constructor(s,o,m,u,t){this.extension=s,this.m=o,this.n=m,this.o=u,this.q=t,this.k=new R.$Nd,this.l=new R.$Nd}acceptFeedback(s){this.k.fire(s)}acceptAction(s){this.l.fire(s)}async validateSlashCommand(s){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$If)(this.b));const o=this.b.find(m=>m.name===s);if(!o)throw new Error(`Unknown slashCommand: ${s}`);return o}async provideSlashCommand(s){if(!this.a)return[];const o=await this.a.provideSlashCommands(s);return o?(this.b=o,o.map(m=>({name:m.name,description:m.description}))):[]}async provideFollowups(s,o){if(!this.d)return[];const m=await this.d.provideFollowups(s,o);return m?m.map(u=>I.ChatFollowup.from(u)):[]}get apiAgent(){let s=!1,o=!1;const m=()=>{s||o||(o=!0,queueMicrotask(()=>{this.n.$updateAgent(this.o,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j}),o=!1}))},u=this;return{get name(){return u.m},get description(){return u.g??""},set description(t){u.g=t,m()},get fullName(){return u.h??u.extension.displayName??u.extension.name},set fullName(t){u.h=t,m()},get iconPath(){return u.i},set iconPath(t){u.i=t,m()},get slashCommandProvider(){return u.a},set slashCommandProvider(t){u.a=t,m()},get followupProvider(){return u.d},set followupProvider(t){u.d=t,m()},get isDefault(){return(0,k.$hF)(u.extension,"defaultChatAgent"),u.j},set isDefault(t){(0,k.$hF)(u.extension,"defaultChatAgent"),u.j=t,m()},get onDidReceiveFeedback(){return u.k.event},onDidPerformAction:(0,k.$gF)(this.extension,"chatAgents2Additions")?this.l.event:void 0,dispose(){s=!0,u.a=void 0,u.d=void 0,u.k.dispose(),u.n.$unregisterAgent(u.o)}}}invoke(s,o,m,u){return this.q(s,o,m,u)}}}),define(De[301],Ce([1,0,21,3,6,13,64,25,8,4]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class L{constructor(k,p){this.stream=new E.$gh,this.stream=p??new E.$gh;const h=this;this.apiObj={option:k,response:h.stream.asyncIterable}}}class I{constructor(k,p){this.a=new w.$Nd,this.b=new Map,this.c=new E.$gh,this.d=!1;const h=this;this.apiObject={result:k,response:h.c.asyncIterable,onDidStartResponseStream:h.a.event,cancel(){p.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,r]of this.b)r.stream.complete();else this.c.complete()})}handleFragment(k){if(this.d)return;let p=this.b.get(k.index);p||(this.b.size===0?p=new L(k.index,this.c):p=new L(k.index),this.b.set(k.index,p),this.a.fire(p.apiObj)),p.stream.emit(k.part)}}class v{static{this.a=1}constructor(k,p){this.d=p,this.c=new Map,this.e=new Map,this.f=new $.$8l,this.b=k.getProxy(f.$kK.MainThreadChatProvider)}registerProvider(k,p,h,r){const s=v.a++;return this.c.set(s,{extension:k,provider:h}),this.b.$registerProvider(s,p,{extension:k,displayName:r.name??k.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(s),this.c.delete(s)})}async $provideChatResponse(k,p,h,r,s){const o=this.c.get(k);if(!o)return;const m=new A.$6u(async u=>{if(s.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(p,{index:u.index,part:u.part})});return o.provider.provideChatResponse(h.map(R.ChatMessage.to),r,m,s)}allowListExtensionWhile(k,p){this.f.set(k,p),p.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,p){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const h=this;return{get isRevoked(){return!h.f.has(k)},makeRequest(r,s,o){if(!h.f.has(k))throw new Error("Access to chat has been revoked");const m=new D.$Xd(o),u=Math.random()*1e6|0,t=h.b.$fetchResponse(k,p,u,r.map(R.ChatMessage.from),s??{},m.token),n=new I(t,m);return h.e.set(u,{res:n}),t.finally(()=>{h.e.delete(u)}),n.apiObject}}}async $handleResponseFragment(k,p){const h=this.e.get(k);h&&h.res.handleFragment(p)}}e.$iec=v}),define(De[302],Ce([1,0,3,6,9,13]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$kK.MainThreadChatVariables)}async $resolveVariable(E,w,L){const I=this.b.get(E);if(I)try{const v=await I.resolver.resolve(I.data.name,{message:w},L);if(v)return v.map(R.ChatVariable.from)}catch(v){(0,f.$2)(v)}}registerVariableResolver(E,w,L,I){const v=A.a++;return this.b.set(v,{extension:E.identifier,data:{name:w,description:L},resolver:I}),this.c.$registerVariable(v,{name:w,description:L}),(0,D.$Qc)(()=>{this.b.delete(v),this.c.$unregisterVariable(v)})}}e.$kec=A}),define(De[303],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class T{constructor(R){const A=R.getProxy(D.$kK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$scc=T}),define(De[34],Ce([1,0,17,7,13,24,6,19,14,62,32,61,2,3,5,20,145,22,69,41,35,85,88]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=void 0;let n=class{#e;#t;#i;constructor(S,b,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$kK.MainThreadCommands),this.d=b,this.#i=g,this.#t=S.getProxy(A.$kK.MainThreadTelemetry),this.converter=new c(this,d=>{const P=this.c.get(d);return P?.result===a.Void?P:void 0},b),this.f=[{processArgument(d){return(0,w.$mh)(d)}},{processArgument(d){return(0,R.$9m)(d,function(P){if(L.$ts.isIRange(P))return f.Range.to(P);if(I.$ss.isIPosition(P))return f.Position.to(P);if(L.$ts.isIRange(P.range)&&v.URI.isUri(P.uri))return f.location.to(P);if(P instanceof r.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const b=this.registerCommand(!1,S.id,async(...g)=>{const d=S.args.map((N,F)=>{if(!N.validate(g[F]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof g[F]=="object"?JSON.stringify(g[F],null,"	"):g[F]} `);return N.convert(g[F])}),P=await this.executeCommand(S.internalId,...d);return S.result.convert(P,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new T.$mK(()=>{b.dispose(),this.c.delete(S.id)})}registerCommand(S,b,g,d,P,N){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:g,thisArg:d,metadata:P,extension:N}),S&&this.#e.$registerCommand(b),new T.$mK(()=>{this.b.delete(b)&&S&&this.#e.$unregisterCommand(b)})}executeCommand(S,...b){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,b,!0)}async g(S,b,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,b,!1);{let d=!1;const P=(0,R.$9m)(b,function(N){if(N instanceof T.$nK)return f.Position.from(N);if(N instanceof T.$oK)return f.Range.from(N);if(N instanceof T.$yK)return f.location.from(N);if(T.$JL.isNotebookRange(N))return f.NotebookRange.from(N);if(N instanceof ArrayBuffer)return d=!0,r.$be.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return d=!0,r.$be.wrap(N);if(N instanceof r.$be)return d=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(S,d?new s.$qv(P):P,g);return(0,w.$mh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,b,!1);throw N}}}async h(S,b,g){const d=this.b.get(S);if(!d)throw new Error("Unknown command");const{callback:P,thisArg:N,metadata:F}=d;if(F?.args)for(let U=0;U<F.args.length;U++)try{(0,D.$Pf)(b[U],F.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${F.args[U].name}' - ${F.args[U].description}`)}const M=m.$Jd.create();try{return await P.apply(N,b)}catch(U){if(S===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...b);j&&(S=j.command)}if(this.d.error(U,S,d.extension?.identifier),!g)throw U;if(d.extension?.identifier){const j=this.#i.onExtensionError(d.extension.identifier,U);this.d.trace("forwarded error to extension?",j,d.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ai)(U)),this.id=S,this.source=d.extension?.displayName??d.extension?.name}}}finally{this.j(d,S,M.elapsed())}}j(S,b,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new u.$jo(b),duration:g})}$executeContributedCommand(S,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?(b=b.map(d=>this.f.reduce((P,N)=>N.processArgument(P,g.extension?.identifier),d)),this.h(S,b,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(b=>(S&&(b=b.filter(g=>g[0]!=="_")),b))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[b,g]of this.b){const{metadata:d}=g;d&&(S[b]=d)}return Promise.resolve(S)}};e.$GM=n,e.$GM=n=He([Be(0,p.$lM),Be(1,E.$0i),Be(2,t.$FM)],n),e.$HM=(0,k.$Ph)("IExtHostCommands");class c{constructor(S,b,g){this.d=S,this.f=b,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,b){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const d=this.f(S.command);if(d)g.id=d.internalId,g.arguments=d.args.map((P,N)=>P.convert(S.arguments&&S.arguments[N]));else if((0,$.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),b.add((0,y.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),g.$ident=P,g.id=this.delegatingCommandId,g.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const b=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$IM=c;class i{static{this.Uri=new i("uri","Uri of a text document",S=>v.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>T.$nK.isPosition(S),f.Position.from)}static{this.Range=new i("range","A range in a text document",S=>T.$oK.isRange(S),f.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>T.$pK.isSelection(S),f.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,b=>Array.isArray(b)&&b.every(g=>S.validate(g)),b=>b.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof T.$IK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof T.$3L,f.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",S=>S instanceof h.$yM,f.TestItem.from)}constructor(S,b,g,d){this.name=S,this.description=b,this.validate=g,this.convert=d}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,b){return new i(S??this.name,b??this.description,this.validate,this.convert)}}e.$JM=i;class a{static{this.Void=new a("no result",S=>S)}constructor(S,b){this.description=S,this.convert=b}}e.$KM=a;class l{constructor(S,b,g,d,P){this.id=S,this.internalId=b,this.description=g,this.args=d,this.result=P}}e.$LM=l}),define(De[304],Ce([1,0,19,18,2,83,129,42,134,34,13,7]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;const v=[new w.$LM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of DocumentHighlight-instances.",k(L.DocumentHighlight.to))),new w.$LM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.$JM.Uri],new w.$KM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,r)=>{if((0,D.$Kb)(h))return;class s extends I.$DK{static to(m){const u=new s(m.name,L.SymbolKind.to(m.kind),m.containerName||"",new I.$yK(r[0],L.Range.to(m.range)));return u.detail=m.detail,u.range=u.location.range,u.selectionRange=L.Range.to(m.selectionRange),u.children=m.children?m.children.map(s.to):[],u}}return h.map(s.to)})),new w.$LM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.$JM.Uri,new w.$JM("options","Formatting options",h=>!0,h=>h)],new w.$KM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new w.$LM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.$JM.Uri,w.$JM.Range,new w.$JM("options","Formatting options",h=>!0,h=>h)],new w.$KM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new w.$LM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.$JM.Uri,w.$JM.Position,new w.$JM("ch","Trigger character",h=>typeof h=="string",h=>h),new w.$JM("options","Formatting options",h=>!0,h=>h)],new w.$KM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new w.$LM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$LM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$LM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$LM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$LM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Location-instances.",k(L.location.to))),new w.$LM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of Hover-instances.",k(L.Hover.to))),new w.$LM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.$JM.Uri,new w.$JM("position","A position in a text document",h=>Array.isArray(h)&&h.every(r=>I.$nK.isPosition(r)),h=>h.map(L.Position.from))],new w.$KM("A promise that resolves to an array of ranges.",h=>h.map(r=>{let s;for(const o of r.reverse())s=new I.$HK(L.Range.to(o),s);return s}))),new w.$LM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.$JM.String.with("query","Search string")],new w.$KM("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(L.WorkspaceSymbol.to))),new w.$LM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(L.CallHierarchyItem.to))),new w.$LM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.$JM.CallHierarchyItem],new w.$KM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(L.CallHierarchyIncomingCall.to))),new w.$LM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.$JM.CallHierarchyItem],new w.$KM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(L.CallHierarchyOutgoingCall.to))),new w.$LM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:L.Range.to(h.range),placeholder:h.text}})),new w.$LM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.$JM.Uri,w.$JM.Position,w.$JM.String.with("newName","The new symbol name")],new w.$KM("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return L.WorkspaceEdit.to(h)}})),new w.$LM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.$JM.Uri,w.$JM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.$KM("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(L.DocumentLink.to))),new w.$LM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.$JM.Uri],new w.$KM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new I.$BL(h.tokenTypes,h.tokenModifiers)})),new w.$LM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.$JM.Uri],new w.$KM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const r=(0,A.$20)(h);if(r.type==="full")return new I.$DL(r.data,void 0)})),new w.$LM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.$JM.Uri,w.$JM.Range.optional()],new w.$KM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new I.$BL(h.tokenTypes,h.tokenModifiers)})),new w.$LM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.$JM.Uri,w.$JM.Range],new w.$KM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const r=(0,A.$20)(h);if(r.type==="full")return new I.$DL(r.data,void 0)})),new w.$LM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.$JM.Uri,w.$JM.Position,w.$JM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.$JM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.$KM("A promise that resolves to a CompletionList-instance.",(h,r,s)=>{if(!h)return new I.$TK([]);const o=h.suggestions.map(m=>L.CompletionItem.to(m,s));return new I.$TK(o,h.incomplete)})),new w.$LM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.$JM.Uri,w.$JM.Position,w.$JM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.$KM("A promise that resolves to SignatureHelp.",h=>{if(h)return L.SignatureHelp.to(h)})),new w.$LM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.$JM.Uri,w.$JM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.$KM("A promise that resolves to an array of CodeLens-instances.",(h,r,s)=>k(o=>new I.$LK(L.Range.to(o.range),o.command&&s.fromInternal(o.command)))(h))),new w.$LM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.$JM.Uri,new w.$JM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>I.$oK.isRange(h),h=>I.$pK.isSelection(h)?L.Selection.from(h):L.Range.from(h)),w.$JM.String.with("kind","Code action kind to return code actions for").optional(),w.$JM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.$KM("A promise that resolves to an array of Command-instances.",(h,r,s)=>k(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(o.command)}else{const m=new I.$FK(o.title,o.kind?new I.$GK(o.kind):void 0);return o.edit&&(m.edit=L.WorkspaceEdit.to(o.edit)),o.command&&(m.command=s.fromInternal(o.command)),m.isPreferred=o.isPreferred,m}})(h))),new w.$LM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.$JM.Uri],new w.$KM("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(r=>new I.$ZK(L.Range.to(r.range),L.Color.to(r.color))):[])),new w.$LM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.$JM("color","The color to show and insert",h=>h instanceof I.$YK,L.Color.from),new w.$JM("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:L.Range.from(h.range)}))],new w.$KM("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(L.ColorPresentation.to):[])),new w.$LM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.$JM.Uri,w.$JM.Range],new w.$KM("A promise that resolves to an array of Inlay objects",(h,r,s)=>h.map(L.InlayHint.to.bind(void 0,s)))),new w.$LM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.$JM.Uri],new w.$KM("A promise that resolves to an array of FoldingRange objects",(h,r)=>{if(h)return h.map(L.FoldingRange.to)})),new w.$LM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.$KM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(r=>L.NotebookExclusiveDocumentPattern.to(r))})))),new w.$LM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.$JM.Uri,w.$JM.Range,new w.$JM("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof I.$oK,h=>L.InlineValueContext.from(h))],new w.$KM("A promise that resolves to an array of InlineValue objects",h=>h.map(L.InlineValue.to))),new w.$LM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.$JM("uriOrString","Uri-instance or string (only http/https)",h=>f.URI.isUri(h)||typeof h=="string"&&(0,E.$kU)(h,T.Schemas.http,T.Schemas.https),h=>h),new w.$JM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional(),w.$JM.String.with("label","").optional()],w.$KM.Void),new w.$LM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.$JM.Uri.with("resource","Resource to open"),w.$JM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new w.$JM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional()],w.$KM.Void),new w.$LM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.$JM.Uri.with("left","Left-hand side resource of the diff editor"),w.$JM.Uri.with("right","Right-hand side resource of the diff editor"),w.$JM.String.with("title","Human readable title for the diff editor").optional(),new w.$JM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)]).optional()],w.$KM.Void),new w.$LM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.$JM.Uri,w.$JM.Position],new w.$KM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new w.$LM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.$JM.TypeHierarchyItem],new w.$KM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new w.$LM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.$JM.TypeHierarchyItem],new w.$KM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new w.$LM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.$JM.TestItem],w.$KM.Void),new w.$LM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.$JM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.$KM.Void),new w.$LM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.$JM.String.with("name","The context key name"),new w.$JM("value","The context key value",()=>!0,h=>h)],w.$KM.Void),new w.$LM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[w.$JM.Uri,w.$JM.StringArray,new w.$JM("MappedEditsContext","Mapped Edits Context",h=>L.MappedEditsContext.is(h),h=>L.MappedEditsContext.from(h))],new w.$KM("A promise that resolves to a workspace edit or null",h=>h?L.WorkspaceEdit.to(h):null))];class y{static register(r){v.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",$.$Oi)}}e.$rcc=y;function k(h){return r=>{if(Array.isArray(r))return r.map(h)}}function p(h){if(!Array.isArray(h))return;const r=[];for(const s of h)R.$et(s)?r.push(L.DefinitionLink.to(s)):r.push(L.location.to(s));return r}}),define(De[305],Ce([1,0,8,57,4,3,2,83,25,13,7,6,26]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;function y(k,p,h){const r=k.getProxy(I.$kK.MainThreadComments);class s{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$8l,p.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const C=this.b.get(l.handle);return C?C.value:l}else if(l&&l.$mid===7){const C=this.b.get(l.commentControlHandle);if(!C)return l;const S=C.getCommentThread(l.commentThreadHandle);return S?S.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const C=this.b.get(l.thread.commentControlHandle);if(!C)return l;const S=C.getCommentThread(l.thread.commentThreadHandle);return S?l.$mid===8?S.value:{thread:S.value,text:l.text}:l}else if(l&&l.$mid===10){const C=this.b.get(l.thread.commentControlHandle);if(!C)return l;const S=C.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.commentUniqueId,g=S.getCommentByUniqueId(b);return g||l}else if(l&&l.$mid===11){const C=this.b.get(l.thread.commentControlHandle);if(!C)return l;const S=C.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.text,g=l.commentUniqueId,d=S.getCommentByUniqueId(g);return d?(typeof d.body=="string"?d.body=b:d.body=new L.$MK(b),d):l}return l}})}createCommentController(l,C,S){const b=s.a++,g=new m(l,b,C,S);this.b.set(g.handle,g);const d=this.c.get(l.identifier)||[];return d.push(g),this.c.set(l.identifier,d),g.value}async $createCommentThreadTemplate(l,C,S){const b=this.b.get(l);b&&b.$createCommentThreadTemplate(C,S)}async $updateCommentThreadTemplate(l,C,S){const b=this.b.get(l);b&&b.$updateCommentThreadTemplate(C,S)}$deleteCommentThread(l,C){this.b.get(l)?.$deleteCommentThread(C)}$provideCommentingRanges(l,C,S){const b=this.b.get(l);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const g=h.getDocument(A.URI.revive(C));return(0,D.$Mg)(async()=>{const d=await b.commentingRangeProvider.provideCommentingRanges(g,S);let P;return Array.isArray(d)?P={ranges:d,fileComments:!1}:d?P={ranges:d.ranges||[],fileComments:d.fileComments||!1}:P=d??void 0,P}).then(d=>{let P;return d&&(P={ranges:d.ranges.map(N=>w.Range.from(N)),fileComments:d.fileComments}),P})}$toggleReaction(l,C,S,b,g){const d=this.b.get(l);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,D.$Mg)(()=>{const P=d.getCommentThread(C);if(P){const N=P.getCommentByUniqueId(b.uniqueIdInThread);if(d!==void 0&&N&&d.reactionHandler)return d.reactionHandler(N,n(g))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,C,S,b,g,d,P,N){this.m=C,this.n=S,this.o=b,this.p=g,this.q=d,this.extensionDescription=P,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Tc,this.l.value=new R.$Rc,this.n===void 0&&(this.n=`${l}.${this.handle}`),r.$createCommentThread(C,this.handle,this.n,this.o,w.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this.i.push({dispose:()=>{r.$deleteCommentThread(C,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(M){F.range=M},get comments(){return F.comments},set comments(M){F.comments=M},get collapsibleState(){return F.collapsibleState},set collapsibleState(M){F.collapsibleState=M},get canReply(){return F.canReply},set canReply(M){F.canReply=M},get contextValue(){return F.contextValue},set contextValue(M){F.contextValue=M},get label(){return F.label},set label(M){F.label=M},get state(){return F.state},set state(M){F.state=M},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Rc);const l=S=>Object.prototype.hasOwnProperty.call(this.b,S),C={};l("range")&&(C.range=w.Range.from(this.p)),l("label")&&(C.label=this.label),l("contextValue")&&(C.contextValue=this.contextValue??null),l("comments")&&(C.comments=this.q.map(S=>u(this,S,this.k,this.extensionDescription))),l("collapsibleState")&&(C.collapseState=c(this.g)),l("canReply")&&(C.canReply=this.canReply),l("state")&&(C.state=i(this.h)),l("isTemplate")&&(C.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(l){for(const C of this.k){const S=C[0],b=C[1];if(l===b)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}He([(0,T.$ih)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,C,S,b){this.f=l,this.g=C,this.h=S,this.i=b,this.a=new Map,r.$registerCommentController(this.handle,S,b,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(d){g.options=d},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(d){g.commentingRangeProvider=d},get reactionHandler(){return g.reactionHandler},set reactionHandler(d){g.reactionHandler=d},createCommentThread(d,P,N){return g.createCommentThread(d,P,N).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(l,C,S){C===void 0&&(0,v.$hF)(this.f,"fileComments");const b=new o(this.id,this.handle,void 0,l,C,S,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(l,C){const S=new o(this.id,this.handle,void 0,A.URI.revive(l),w.Range.to(C),[],this.f,!0);return S.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(l,C){const S=this.a.get(l);S&&(S.range=w.Range.to(C))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function u(a,l,C,S){let b=C.get(l);return b||(b=++a.commentHandle,C.set(l,b)),l.state!==void 0&&(0,v.$hF)(S,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:b,body:typeof l.body=="string"?l.body:w.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(g=>t(g)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?w.$kM(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function c(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new s}e.$tcc=y}),define(De[306],Ce([1,0,24,6,27,20]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let A=class{constructor(L,I){this.a=L.getProxy(T.$kK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,I){const v=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,I,y,arguments)}})}e(L,I,v,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this.b)}),this.c&&this.f(L,v,y)}};e.$rec=A,e.$rec=A=He([Be(0,R.$lM),Be(1,f.$BM)],A);const $=1e5;function E(w,L){const I=[];if(w.length)for(let v=0;v<w.length;v++){let y=w[v];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}I.push(y)}if(L){const v=new Error().stack;v&&I.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,D.$_m)(I);return v.length>$?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,26]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0;let y=class{static{v=this}static{this.c=0}static{this.d=250}constructor(p,h){this.h=h,this.f=new Map,this.g=p.getProxy(T.$kK.MainThreadDecorations)}registerFileDecorationProvider(p,h){const r=v.c++;this.f.set(r,{provider:p,extensionDescription:h}),this.g.$registerDecorationProvider(r,h.identifier.value);const s=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(r,null);return}const m=(0,E.$3b)(o);if(m.length<=v.d){this.g.$onDidChange(r,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,m.length);const u=m.map(c=>({uri:c,rank:(0,w.$Ge)(c.path,"/")})),t=(0,E.$zb)(u,(c,i)=>c.rank-i.rank||(0,w.$Ue)(c.uri.path,i.uri.path)),n=[];e:for(const c of t){let i;for(const a of c){const l=(0,L.$mc)(a.uri.path);if(i!==l&&(i=l,n.push(a.uri)>=v.d))break e}}this.g.$onDidChange(r,n)});return new f.$mK(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(p,h,r){if(!this.f.has(p))return Object.create(null);const s=Object.create(null),{provider:o,extensionDescription:m}=this.f.get(p);return await Promise.all(h.map(async u=>{try{const{uri:t,id:n}=u,c=await Promise.resolve(o.provideFileDecoration(D.URI.revive(t),r));if(!c)return;try{f.$HL.validate(c),c.badge&&typeof c.badge!="string"&&(0,I.$hF)(m,"codiconDecoration"),s[n]=[c.propagate,c.tooltip,c.badge,c.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),s}};e.$udc=y,e.$udc=y=v=He([Be(0,A.$lM),Be(1,$.$0i)],y),e.$vdc=(0,R.$Ph)("IExtHostDecorations")}),define(De[307],Ce([1,0,204,133,2,6,7,13,4,14,28,55]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;class y{#e;#t;#i;constructor(h,r,s,o,m,u,t,n){this.d=h,this.e=r,this.f=s,this.g=o,this.h=m,this.c=!1,this.f=Math.max(o,s),this.#i=new L.$Ac(c=>u.getComparisonKey(c)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(h,r){if(!h){this.clear();return}this.j();let s=[];if(f.URI.isUri(h)){if(!r){this.delete(h);return}this.#i.set(h,r.slice()),s=[h]}else if(Array.isArray(h)){s=[];let u;h=[...h].sort(y.k);for(const t of h){const[n,c]=t;if((!u||n.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=n,s.push(n),this.#i.set(n,[])),c)this.#i.get(n)?.push(...c);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(s),!this.#e)return;const o=[];let m=0;for(const u of s){let t=[];const n=this.#i.get(u);if(n)if(n.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const a of n)if(a.severity===c[i]&&t.push({...$.Diagnostic.from(a),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(u)}));if(o.push([u,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,o)}delete(h){this.j(),this.#t.fire([h]),this.#i.delete(h),this.#e?.$changeMany(this.e,[[h,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(h,r){this.j();for(const[s,o]of this)h.call(r,s,o,this)}*[Symbol.iterator](){this.j();for(const h of this.#i.keys())yield[h,this.get(h)]}get(h){this.j();const r=this.#i.get(h);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(h){return this.j(),Array.isArray(this.#i.get(h))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(h,r){return h[0].toString()<r[0].toString()?-1:h[0].toString()>r[0].toString()?1:0}}e.$lcc=y;let k=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(h){const r=new L.$Ac;for(const s of h)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(h,r,s,o){this.j=r,this.k=s,this.l=o,this.g=new Map,this.h=new E.$Rd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,v._mapper),this.f=h.getProxy(R.$kK.MainThreadDiagnostics)}createDiagnosticCollection(h,r){const{g:s,f:o,h:m,j:u,k:t,l:n}=this,c=new class{$changeMany(l,C){o.$changeMany(l,C),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,l,C.length===0?"CLEARING":C)}$clear(l){o.$clear(l),u.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,l)}dispose(){o.dispose()}};let i;if(!r)r="_generated_diagnostic_collection_name_#"+v.c++,i=r;else if(!s.has(r))i=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do i=r+v.c++;while(s.has(i))}return new class extends y{constructor(){super(r,i,v.e,v.d,l=>n.getDocument(l)?.version,t.extUri,c,m),s.set(i,this)}dispose(){super.dispose(),s.delete(i)}}}getDiagnostics(h){if(h)return this.m(h);{const r=new Map,s=[];for(const o of this.g.values())o.forEach((m,u)=>{let t=r.get(m.toString());typeof t>"u"&&(t=s.length,r.set(m.toString(),t),s.push([m,[]])),s[t][1]=s[t][1].concat(...u)});return s}}m(h){let r=[];for(const s of this.g.values())s.has(h)&&(r=r.concat(s.get(h)));return r}$acceptMarkersChange(h){if(!this.n){const r="_generated_mirror",s=new y(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of h)this.n.set(f.URI.revive(r),s.map($.Diagnostic.to))}};e.$mcc=k,e.$mcc=k=v=He([Be(1,w.$0i),Be(2,I.$kcc)],k)}),define(De[308],Ce([1,0,2,6,26]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class R{constructor($){this.a=$.getProxy(T.$kK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,f.$hF)($,"showLocal"),this.a.$showOpenDialog(E).then(w=>w?w.map(L=>D.URI.revive(L)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?D.URI.revive(E):void 0)}}e.$Bcc=R}),define(De[309],Ce([1,0,9,2,7,6,18,21,15]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class w{static{this.a=0}constructor(I,v,y){this.d=v,this.e=y,this.b=new Map,this.c=I.getProxy(R.$kK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=w.a++;this.b.set(y,v),this.c.$registerTextContentProvider(y,I);let k;return typeof v.onDidChange=="function"&&(k=v.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(h=>{if(!h&&typeof h!="string")return;const r=this.d.getDocument(p);if(!r)return;const s=(0,E.$Pe)(h);if(!r.equalLines(s))return this.c.$onVirtualDocumentChange(p,h)},D.$1)})),new f.$mK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,v){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(T.URI.revive(v),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$Ccc=w}),define(De[310],Ce([1,0,4,3,2,6,141,13,17,24,7,9]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class v{constructor(k,p){this.a=new D.$Nd({onListenerError:I.$2}),this.b=new D.$Nd({onListenerError:I.$2}),this.c=new D.$Nd({onListenerError:I.$2}),this.d=new D.$Nd({onListenerError:I.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=k.getProxy(R.$kK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(h=>{for(const r of h)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const r of h)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let h=this.h.get(k.toString());return h||(h=this.f.$tryOpenDocument(k).then(r=>{this.h.delete(k.toString());const s=f.URI.revive(r);return(0,E.$Jf)(this.g.getDocument(s))},r=>(this.h.delete(k.toString()),Promise.reject(r))),this.h.set(k.toString(),h)),h}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>f.URI.revive(p))}$acceptModelLanguageChanged(k,p){const h=f.URI.revive(k),r=this.g.getDocument(h);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(p),this.a.fire(r.document)}$acceptModelSaved(k){const p=f.URI.revive(k),h=this.g.getDocument(p);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(k,p){const h=f.URI.revive(k),r=this.g.getDocument(h);if(!r)throw new Error("unknown document");r._acceptIsDirty(p),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,h){const r=f.URI.revive(k),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(h),s.onEvents(p);let o;p.isUndoing?o=L.TextDocumentChangeReason.Undo:p.isRedoing&&(o=L.TextDocumentChangeReason.Redo),this.c.fire((0,w.$8m)({document:s.document,contentChanges:p.changes.map(m=>({range:$.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:o}))}setWordDefinitionFor(k,p){(0,A.$nM)(k,p)}}e.$icc=v}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,146,13,14,28,18,51,47]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;class r{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor(m,u){this.h=m,this.i=u,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new T.$Nd,this.e=new T.$Nd,this.f=new T.$Nd,this.g=new T.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const u=[],t=[],n=[];if(m.removedDocuments)for(const c of m.removedDocuments){const i=R.URI.revive(c),a=this.c.get(i);a?.unref()&&(this.c.delete(i),u.push(a.value))}if(m.addedDocuments)for(const c of m.addedDocuments){const i=R.URI.revive(c.uri);let a=this.c.get(i);if(a&&i.scheme!==k.Schemas.vscodeNotebookCell&&i.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new r(new E.$oM(this.h.getProxy($.$kK.MainThreadDocuments),i,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(i,a),t.push(a.value)),a.ref()}if(m.removedEditors)for(const c of m.removedEditors){const i=this.b.get(c);this.b.delete(c),i&&n.push(i)}if(m.addedEditors)for(const c of m.addedEditors){const i=R.URI.revive(c.documentUri);D.ok(this.c.has(i),`document '${i}' does not exist`),D.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const a=this.c.get(i).value,l=new L.$uM(c.id,this.h.getProxy($.$kK.MainThreadTextEditors),this.i,new h.$V(()=>a.document),c.selections.map(I.Selection.to),c.options,c.visibleRanges.map(C=>I.Range.to(C)),typeof c.editorPosition=="number"?I.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,l)}m.newActiveEditor!==void 0&&(D.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,f.$Nc)(u),(0,f.$Nc)(n),m.removedDocuments&&this.e.fire(u),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return p.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const u=this.b.get(this.a);return m?u:u?.value}allEditors(){return[...this.b.values()]}};e.$vM=s,e.$vM=s=He([Be(0,w.$lM),Be(1,v.$0i)],s),e.$wM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0,e.$zdc=(0,A.$Ph)("IExtHostEditorTabs");class I{constructor(h,r,s){this.e=s,this.d=r,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,r={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$4L(f.URI.revive(this.b.input.uri));case 2:return new $.$5L(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new $.$6L(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new $.$7L(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$8L(this.b.input.viewType);case 4:return new $.$9L(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$0L(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$$L;case 9:return new $.$_L(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(h,r){this.c=[],this.d="",this.b=h,this.e=r;for(const s of h.tabs)s.isActive&&(this.d=s.id),this.c.push(new I(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,r={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return D.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(s=>s.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(s=>s.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const s=new I(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,s),h.tabDto.isActive&&(this.d=s.tabId),s}else if(h.kind===1){const s=this.c.splice(h.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(h.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,s),s}const r=this.c.find(s=>s.tabId===h.tabDto.id);if(!r)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(h.tabDto),r}activeTabId(){return this.d}}let y=class{constructor(h){this.b=new R.$Nd,this.c=new R.$Nd,this.e=[],this.a=h.getProxy(T.$kK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,r={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(s=>s.apiObject))},get activeTabGroup(){const s=h.d;return(0,w.$Jf)(h.e.find(m=>m.groupId===s)?.apiObject)},close:async(s,o)=>{const m=Array.isArray(s)?s:[s];return m.length?k(m[0])?this.j(m,o):this.i(m,o):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(h){const r=new Set(this.e.map(c=>c.groupId)),s=new Set(h.map(c=>c.groupId)),o=(0,L.$K)(r,s),m=this.e.filter(c=>o.removed.includes(c.groupId)).map(c=>c.apiObject),u=[],t=[];this.e=h.map(c=>{const i=new v(c,()=>this.d);return o.added.includes(i.groupId)?u.push(i.apiObject):t.push(i.apiObject),i});const n=(0,w.$Jf)(h.find(c=>c.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:u,closed:m,changed:t}))}$acceptTabGroupUpdate(h){const r=this.e.find(s=>s.groupId===h.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const r=this.e.find(o=>o.groupId===h.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const s=r.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(h){for(const r of this.e)for(const s of r.tabs)if(s.apiObject===h)return s}h(h){return this.e.find(r=>r.apiObject===h)}async i(h,r){const s=[];for(const o of h){const m=this.g(o);if(!m)throw new Error("Tab close: Invalid tab not found!");s.push(m.tabId)}return this.a.$closeTab(s,r)}async j(h,r){const s=[];for(const o of h){const m=this.h(o);if(!m)throw new Error("Group close: Invalid group not found!");s.push(m.groupId)}return this.a.$closeGroup(s,r)}};e.$Adc=y,e.$Adc=y=He([Be(0,E.$lM)],y);function k(p){return p.tabs!==void 0}}),define(De[311],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$kK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const L=await w.provideEmbeddingVector($,E);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(A,$,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiEmbeddingVectorProvider($,w),new T.$mK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$mec=f}),define(De[312],Ce([1,0,2,6,3,7,13,169,15,22,26,80]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class v{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const h=this.a.indexOf(p);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),h=[];let r,s,o=14,m=14;for(const u of p){let t=r?(0,E.$4e)(r,u):0;for(t===0?s=1:s=m;t<u.length;t++)t+1===u.length?(o=m,m=9):m+=1,h.push([s,u.toUpperCase().charCodeAt(t),m]),h.push([s,u.toLowerCase().charCodeAt(t),m]),s=m;r=u,m=o}h.push([9,58,10]),h.push([10,47,12]),this.b=new $.$5Y(h)}}provideDocumentLinks(p){this.c();const h=[],r=$.$6Y.computeLinks({getLineContent(s){return p.lineAt(s-1).text},getLineCount(){return p.lineCount}},this.b);for(const s of r){const o=A.DocumentLink.to(s);o.target&&h.push(o)}return h}}class y{constructor(p,h){this.i=h,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(T.$kK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,h,r,s={}){if(y.j(r),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const o=this.h++;this.b.add(h),this.d.add(h),this.c.set(o,r);let m=2;s.isCaseSensitive&&(m+=1024),s.isReadonly&&(m+=2048),typeof r.copy=="function"&&(m+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,L.$hF)(p,"fsChunks"),m+=4);let u;s.isReadonly&&(0,I.$5j)(s.isReadonly)&&((0,L.$hF)(p,"readonlyMessage"),u={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(o,h,m,u).catch(n=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${h}`),console.error(n)});const t=r.onDidChangeFile(n=>{const c=[];for(const i of n){const{uri:a,type:l}=i;if(a.scheme!==h)continue;let C;switch(l){case R.FileChangeType.Changed:C=0;break;case R.FileChangeType.Created:C=1;break;case R.FileChangeType.Deleted:C=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:a,type:C})}this.a.$onFileSystemChange(o,c)});return(0,f.$Qc)(()=>{t.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:h,ctime:r,mtime:s,size:o,permissions:m}=p;return{type:h,ctime:r,mtime:s,size:o,permissions:m}}$stat(p,h){return Promise.resolve(this.l(p).stat(D.URI.revive(h))).then(r=>y.k(r))}$readdir(p,h){return Promise.resolve(this.l(p).readDirectory(D.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this.l(p).readFile(D.URI.revive(h))).then(r=>w.$be.wrap(r))}$writeFile(p,h,r,s){return Promise.resolve(this.l(p).writeFile(D.URI.revive(h),r.buffer,s))}$delete(p,h,r){return Promise.resolve(this.l(p).delete(D.URI.revive(h),r))}$rename(p,h,r,s){return Promise.resolve(this.l(p).rename(D.URI.revive(h),D.URI.revive(r),s))}$copy(p,h,r,s){const o=this.l(p);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(D.URI.revive(h),D.URI.revive(r),s))}$mkdir(p,h){return Promise.resolve(this.l(p).createDirectory(D.URI.revive(h)))}$watch(p,h,r,s){const o=this.l(p).watch(D.URI.revive(r),s);this.f.set(h,o)}$unwatch(p,h){const r=this.f.get(h);r&&(r.dispose(),this.f.delete(h))}$open(p,h,r){const s=this.l(p);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(D.URI.revive(h),r))}$close(p,h){const r=this.l(p);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(h))}$read(p,h,r,s){const o=this.l(p);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const m=w.$be.alloc(s);return Promise.resolve(o.read(h,r,m.buffer,0,s)).then(u=>m.slice(0,u))}$write(p,h,r,s){const o=this.l(p);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(h,r,s.buffer,0,s.byteLength))}l(p){const h=this.c.get(p);if(!h){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return h}}e.$9cc=y}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,8,23,18]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;let k=y=class{constructor(h,r){this.b=new Map,this.c=new L.$3g,this.a=h.getProxy(D.$kK.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(o){try{let m;const u=s.b.get(o.scheme);return u?(await s.a.$ensureActivation(o.scheme),m=await u.impl.stat(o)):m=await s.a.$stat(o),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){y.e(m)}},async readDirectory(o){try{const m=s.b.get(o.scheme);return m?(await s.a.$ensureActivation(o.scheme),(await m.impl.readDirectory(o)).slice()):await s.a.$readdir(o)}catch(m){return y.e(m)}},async createDirectory(o){try{const m=s.b.get(o.scheme);return m&&!m.isReadonly?(await s.a.$ensureActivation(o.scheme),await s.d(m.impl,m.extUri,o)):await s.a.$mkdir(o)}catch(m){return y.e(m)}},async readFile(o){try{const m=s.b.get(o.scheme);return m?(await s.a.$ensureActivation(o.scheme),(await m.impl.readFile(o)).slice()):(await s.a.$readFile(o)).buffer}catch(m){return y.e(m)}},async writeFile(o,m){try{const u=s.b.get(o.scheme);return u&&!u.isReadonly?(await s.a.$ensureActivation(o.scheme),await s.d(u.impl,u.extUri,u.extUri.dirname(o)),await s.c.queueFor(o).queue(()=>Promise.resolve(u.impl.writeFile(o,m,{create:!0,overwrite:!0})))):await s.a.$writeFile(o,R.$be.wrap(m))}catch(u){return y.e(u)}},async delete(o,m){try{const u=s.b.get(o.scheme);return u&&!u.isReadonly?(await s.a.$ensureActivation(o.scheme),await u.impl.delete(o,{recursive:!1,...m})):await s.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(u){return y.e(u)}},async rename(o,m,u){try{return await s.a.$rename(o,m,{overwrite:!1,...u})}catch(t){return y.e(t)}},async copy(o,m,u){try{return await s.a.$copy(o,m,{overwrite:!1,...u})}catch(t){return y.e(t)}},isWritableFileSystem(o){const m=r.getCapabilities(o);if(typeof m=="number")return!(m&2048)}})}async d(h,r,s){const o=[];for(;!r.isEqual(s,r.dirname(s));)try{if(!((await h.stat(s)).type&T.FileType.Directory))throw f.$zL.FileExists(`Unable to create folder '${s.scheme===v.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$ok(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;o.push(r.basename(s)),s=r.dirname(s)}for(let m=o.length-1;m>=0;m--){s=r.joinPath(s,o[m]);try{await h.createDirectory(s)}catch(u){if(T.$ok(u)!==T.FileSystemProviderErrorCode.FileExists)throw u}}}static e(h){if(h instanceof f.$zL)throw h;if(h instanceof T.$kk)switch(h.code){case T.FileSystemProviderErrorCode.FileExists:throw f.$zL.FileExists(h.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$zL.FileNotFound(h.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$zL.FileNotADirectory(h.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$zL.FileIsADirectory(h.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$zL.NoPermissions(h.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$zL.Unavailable(h.message);default:throw new f.$zL(h.message,h.name)}if(!(h instanceof Error))throw new f.$zL(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw f.$zL.Unavailable(h.message);switch(h.name){case T.FileSystemProviderErrorCode.FileExists:throw f.$zL.FileExists(h.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$zL.FileNotFound(h.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$zL.FileNotADirectory(h.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$zL.FileIsADirectory(h.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$zL.NoPermissions(h.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$zL.Unavailable(h.message);default:throw new f.$zL(h.message,h.name)}}addFileSystemProvider(h,r,s){return this.b.set(h,{impl:r,extUri:s?.isCaseSensitive?I.$lg:I.$ng,isReadonly:!!s?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(h))}getFileSystemProviderExtUri(h){return this.b.get(h)?.extUri??I.$lg}};e.$Occ=k,e.$Occ=k=y=He([Be(0,$.$lM),Be(1,E.$kcc)],k),e.$Pcc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(De[313],Ce([1,0,4,36,2,6,13,7,47]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,p,h,r,s){this.a=Math.random(),this.b=new D.$Nd,this.c=new D.$Nd,this.d=new D.$Nd,this.h=0,s?.ignoreCreateEvents&&(this.h+=1),s?.ignoreChangeEvents&&(this.h+=2),s?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$wj)(r),m=typeof r=="string",u=h(t=>{if(!(typeof t.session=="number"&&t.session!==this.a)){if(!s?.ignoreCreateEvents)for(const n of t.created){const c=f.URI.revive(n);o(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.b.fire(c)}if(!s?.ignoreChangeEvents)for(const n of t.changed){const c=f.URI.revive(n);o(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.c.fire(c)}if(!s?.ignoreDeleteEvents)for(const n of t.deleted){const c=f.URI.revive(n);o(c.fsPath)&&(!m||k.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=$.$mK.from(this.i(y,p,r,s),this.b,this.c,this.d,u)}i(y,k,p,h){const r=$.$mK.from();if(typeof p=="string")return r;const s=y.getProxy(R.$kK.MainThreadFileSystemEventService);let o=!1;return(p.pattern.includes(T.$sj)||p.pattern.includes(T.$tj))&&(o=!0),s.$watch(k.identifier.value,this.a,p.baseUri,{recursive:o,excludes:h?.excludes??[]}),$.$mK.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(f.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,k,p){this.j=y,this.k=k,this.l=p,this.a=new D.$Nd,this.b=new D.$Nd,this.c=new D.$Nd,this.d=new D.$Nd,this.g=new D.$Pd,this.h=new D.$Pd,this.i=new D.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,p,h){return new w(this.j,y,k,this.a.event,A.GlobPattern.from(p),h)}$onFileEvent(y){this.a.fire(new L(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(p=>({oldUri:f.URI.revive(p.source),newUri:f.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(p=>f.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(p=>f.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(p,h,r)=>{const s=function(m){p.call(h,m)};return s.extension=y,k.event(s,void 0,r)}}async $onWillRunFileOperation(y,k,p,h){switch(y){case 2:return await this.n(this.g,{files:k.map(r=>({oldUri:f.URI.revive(r.source),newUri:f.URI.revive(r.target)}))},p,h);case 1:return await this.n(this.i,{files:k.map(r=>f.URI.revive(r.target))},p,h);case 0:case 3:return await this.n(this.h,{files:k.map(r=>f.URI.revive(r.target))},p,h)}}async n(y,k,p,h){const r=new Set,s=[];if(await y.fireAsync(k,h,async(m,u)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof $.$wK&&(s.push([u.extension,n]),r.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",u.extension.identifier)}),h.isCancellationRequested||s.length===0)return;const o={edits:[]};for(const[,m]of s){const{edits:u}=A.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(u)}return{edit:o,extensionNames:Array.from(r)}}}e.$0cc=I}),define(De[314],Ce([1,0,3,2,6,13,7,34,8]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class w{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=w.a++}}class L{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,k,p,h){this.f=p,this.g=h,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$kK.MainThreadInlineChat),k.registerApiCommand(new $.$LM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$JM("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?R.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?R.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?R.Position.from(r.position):void 0}})],$.$KM.Void))}registerProvider(y,k,p){const h=new w(y,k);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,p.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(y,k,p,h){const r=this.b.get(y);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(T.URI.revive(k)),o=R.Selection.to(p),m=await r.provider.prepareInteractiveEditorSession({document:s,selection:o},h);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=I.a++;return this.d.set(u,new L(m)),{id:u,placeholder:m.placeholder,input:m.input,slashCommands:m.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(m.wholeRange),message:m.message}}async $provideResponse(y,k,p,h){const r=this.b.get(y);if(!r)return;const s=this.d.get(k.id);if(!s)return;const o={prompt:p.prompt,selection:R.Selection.to(p.selection),wholeRange:R.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let m=!1;const u={report:async l=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");m||h.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:l.message,edits:l.edits?.map(R.TextEdit.from),slashCommand:l.slashCommand?.command,markdownFragment:A.$MK.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(s.session,o,u,h));let n;try{n=await(0,E.$Ig)(t,h)}finally{m=!0}if(!n)return;const c=s.responses.push(n)-1,i={wholeRange:R.Range.from(n.wholeRange),placeholder:n.placeholder};if(I.h(n))return{...i,id:c,type:"message",message:R.MarkdownString.from(n.contents)};const{edits:a}=n;return a instanceof A.$wK?{...i,id:c,type:"bulkEdit",edits:R.WorkspaceEdit.from(a)}:{...i,id:c,type:"editorEdit",edits:a.map(R.TextEdit.from)}}$handleFeedback(y,k,p,h){const r=this.b.get(y),s=this.d.get(k),o=s?.responses[p];if(r&&o){const m=R.InteractiveEditorResponseFeedbackKind.to(h);r.provider.handleInteractiveEditorResponseFeedback?.(s.session,o,m)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$eec=I}),define(De[315],Ce([1,0,2,34]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class f{constructor(A,$,E,w,L){this.a=$,this.b=E,this.c=w;const I=new T.$LM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$JM("showOptions","Show Options",v=>!0,v=>v),new T.$JM("resource","Interactive resource Uri",v=>!0,v=>v),new T.$JM("controllerId","Notebook controller Id",v=>!0,v=>v),new T.$JM("title","Interactive editor title",v=>!0,v=>v)],new T.$KM("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const y=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,$,E,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$aec=f}),define(De[316],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class f{constructor(A){this.a=new Map,this.b=A.getProxy(D.$kK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const w=await E.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.b.$registerIssueUriRequestHandler(E),new T.$mK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$gec=f}),define(De[317],Ce([1,0,3,6]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class f{constructor(A){this.b=0,this.a=A.getProxy(T.$kK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$tdc=f}),define(De[318],Ce([1,0,2,24,13,7,83,6,15,32,19,17,165,21,25,3,129,119,107,35,9,8,26,206]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class c{constructor(z,J){this.d=z,this.e=J}async provideDocumentSymbols(z,J){const se=this.d.getDocument(z),oe=await this.e.provideDocumentSymbols(se,J);if(!(0,L.$Kb)(oe))return oe[0]instanceof R.$EK?oe.map(f.DocumentSymbol.from):c.f(oe)}static f(z){z=z.slice(0).sort((oe,Z)=>{let ge=oe.location.range.start.compareTo(Z.location.range.start);return ge===0&&(ge=Z.location.range.end.compareTo(oe.location.range.end)),ge});const J=[],se=[];for(const oe of z){const Z={name:oe.name||"!!MISSING: name!!",kind:f.SymbolKind.from(oe.kind),tags:oe.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:f.Range.from(oe.location.range),selectionRange:f.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Z),J.push(Z);break}const ge=se[se.length-1];if(w.$ts.containsRange(ge.range,Z.range)&&!w.$ts.equalsRange(ge.range,Z.range)){ge.children?.push(Z),se.push(Z);break}se.pop()}}return J}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,J,se){this.g=z,this.h=J,this.j=se,this.e=new s.$hcc("CodeLens"),this.f=new Map}async provideCodeLenses(z,J){const se=this.g.getDocument(z),oe=await this.j.provideCodeLenses(se,J);if(!oe||J.isCancellationRequested)return;const Z=this.e.add(oe),ge=new p.$Rc;this.f.set(Z,ge);const Ee={cacheId:Z,lenses:[]};for(let je=0;je<oe.length;je++)Ee.lenses.push({cacheId:[Z,je],range:f.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,ge)});return Ee}async resolveCodeLens(z,J){const se=z.cacheId&&this.e.get(...z.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,J),oe||(oe=se),J.isCancellationRequested)return;const Z=z.cacheId&&this.f.get(z.cacheId[0]);if(Z)return z.command=this.h.toInternal(oe.command??i.d,Z),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function a(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class l{constructor(z,J){this.d=z,this.e=J}async provideDefinition(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideDefinition(oe,Z,se);return a(ge)}}class C{constructor(z,J){this.d=z,this.e=J}async provideDeclaration(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideDeclaration(oe,Z,se);return a(ge)}}class S{constructor(z,J){this.d=z,this.e=J}async provideImplementation(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideImplementation(oe,Z,se);return a(ge)}}class b{constructor(z,J){this.d=z,this.e=J}async provideTypeDefinition(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideTypeDefinition(oe,Z,se);return a(ge)}}class g{constructor(z,J){this.d=z,this.e=J}async provideHover(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideHover(oe,Z,se);if(!(!ge||(0,L.$Kb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(Z)),ge.range||(ge.range=new R.$oK(Z,Z)),f.Hover.from(ge)}}class d{constructor(z,J){this.d=z,this.e=J}async provideEvaluatableExpression(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideEvaluatableExpression(oe,Z,se);if(ge)return f.EvaluatableExpression.from(ge)}}class P{constructor(z,J){this.d=z,this.e=J}async provideInlineValues(z,J,se,oe){const Z=this.d.getDocument(z),ge=await this.e.provideInlineValues(Z,f.Range.to(J),f.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(Ee=>f.InlineValue.from(Ee))}}class N{constructor(z,J){this.d=z,this.e=J}async provideDocumentHighlights(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideDocumentHighlights(oe,Z,se);if(Array.isArray(ge))return ge.map(f.DocumentHighlight.from)}}class F{constructor(z,J){this.d=z,this.e=J}async provideLinkedEditingRanges(z,J,se){const oe=this.d.getDocument(z),Z=f.Position.to(J),ge=await this.e.provideLinkedEditingRanges(oe,Z,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,L.$Hb)(ge.ranges.map(f.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(z,J){this.d=z,this.e=J}async provideReferences(z,J,se,oe){const Z=this.d.getDocument(z),ge=f.Position.to(J),Ee=await this.e.provideReferences(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.location.from)}}class U{static{this.d=1e3}constructor(z,J,se,oe,Z,ge,Ee){this.g=z,this.h=J,this.j=se,this.k=oe,this.l=Z,this.m=ge,this.n=Ee,this.e=new s.$hcc("CodeAction"),this.f=new Map}async provideCodeActions(z,J,se,oe){const Z=this.g.getDocument(z),ge=v.$vs.isISelection(J)?f.Selection.to(J):f.Range.to(J),Ee=[];for(const et of this.j.getDiagnostics(z))if(ge.intersection(et.range)&&Ee.push(et)>U.d)break;const je={diagnostics:Ee,only:se.only?new R.$GK(se.only):void 0,triggerKind:f.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(Z,ge,je,oe);if(!(0,L.$Lb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Ye=new p.$Rc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(U.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$gF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(z,J){const[se,oe]=z,Z=this.e.get(se,oe);if(!Z||U.o(Z))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(Z,J)??Z;let Ee;ge.edit&&(Ee=f.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(se);We&&(je=this.h.toInternal(ge.command,We))}return{edit:Ee,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class j{static toInternalProviderId(z,J){return z+"."+J}constructor(z,J,se,oe,Z){this.d=z,this.e=J,this.f=se,this.g=oe,this.h=Z}async prepareDocumentPaste(z,J,se,oe){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(z),ge=J.map(We=>f.Range.to(We)),Ee=f.DataTransfer.toDataTransfer(se,()=>{throw new m.$$});if(await this.f.prepareDocumentPaste(Z,ge,Ee,oe),oe.isCancellationRequested)return;const je=Array.from(Ee).filter(([,We])=>!(We instanceof R.$aL));return f.DataTransfer.from(je)}async providePasteEdits(z,J,se,oe,Z){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),Ee=se.map(_e=>f.Range.to(_e)),je=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,Ee,je,Z);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(z,J){this.d=z,this.e=J}async provideDocumentFormattingEdits(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentFormattingEdits(oe,J,se);if(Array.isArray(Z))return Z.map(f.TextEdit.from)}}class K{constructor(z,J){this.d=z,this.e=J}async provideDocumentRangeFormattingEdits(z,J,se,oe){const Z=this.d.getDocument(z),ge=f.Range.to(J),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,J,se,oe){(0,I.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(z),ge=J.map(f.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}}class V{constructor(z,J){this.d=z,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,J,se,oe,Z){const ge=this.d.getDocument(z),Ee=f.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ge,Ee,se,oe,Z);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class me{constructor(z,J){this.e=z,this.f=J,this.d=new s.$hcc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,J){const se=await this.e.provideWorkspaceSymbols(z,J);if(!(0,L.$Lb)(se))return{symbols:[]};const oe=this.d.add(se),Z={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const Ee=se[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...f.WorkspaceSymbol.from(Ee),cacheId:[oe,ge]})}return Z}async resolveWorkspaceSymbol(z,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const se=this.d.get(...z.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,J);return oe&&(0,T.$0m)(z,f.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class te{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,J,se){this.d=z,this.e=J,this.f=se}async provideRenameEdits(z,J,se,oe){const Z=this.d.getDocument(z),ge=f.Position.to(J);try{const Ee=await this.e.provideRenameEdits(Z,ge,se,oe);return Ee?f.WorkspaceEdit.from(Ee):void 0}catch(Ee){const je=te.g(Ee);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(z,J,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(z),Z=f.Position.to(J);try{const ge=await this.e.prepareRename(oe,Z,se);let Ee,je;if(R.$oK.isRange(ge)?(Ee=ge,je=oe.getText(ge)):(0,I.$Af)(ge)&&(Ee=ge.range,je=ge.placeholder),!Ee||!je)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Ee),text:je}}catch(ge){const Ee=te.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class G{constructor(z,J){this.resultId=z,this.tokens=J}}class Q{constructor(z,J){this.f=z,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,J,se){const oe=this.f.getDocument(z),Z=J!==0?this.d.get(J):null;let ge=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Z.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return Z&&this.d.delete(J),ge?(ge=Q.h(ge),this.o(Q.n(Z,ge),ge)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return Q.j(z)?Q.k(z)?z:new R.$DL(new Uint32Array(z.data),z.resultId):Q.l(z)?Q.m(z)?z:new R.$FL(z.edits.map(J=>new R.$EL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(z,J){if(!Q.j(J)||!z||!z.tokens)return J;const se=z.tokens,oe=se.length,Z=J.data,ge=Z.length;let Ee=0;const je=Math.min(oe,ge);for(;Ee<je&&se[Ee]===Z[Ee];)Ee++;if(Ee===oe&&Ee===ge)return new R.$FL([],J.resultId);let We=0;const _e=je-Ee;for(;We<_e&&se[oe-We-1]===Z[ge-We-1];)We++;return new R.$FL([{start:Ee,deleteCount:oe-Ee-We,data:Z.subarray(Ee,ge-We)}],J.resultId)}o(z,J){if(Q.j(z)){const se=this.e++;return this.d.set(se,new G(z.resultId,z.data)),(0,h.$10)({id:se,type:"full",data:z.data})}if(Q.l(z)){const se=this.e++;return Q.j(J)?this.d.set(se,new G(J.resultId,J.data)):this.d.set(se,new G(z.resultId)),(0,h.$10)({id:se,type:"delta",deltas:(z.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class le{constructor(z,J){this.d=z,this.e=J}async provideDocumentRangeSemanticTokens(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentRangeSemanticTokens(oe,f.Range.to(J),se);return Z?this.f(Z):null}f(z){return(0,h.$10)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,J,se,oe,Z){this.f=z,this.g=J,this.h=se,this.j=oe,this.k=Z,this.d=new s.$hcc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,J,se,oe){const Z=this.f.getDocument(z),ge=f.Position.to(J),Ee=Z.getWordRangeAtPosition(ge)||new R.$oK(ge,ge),je=Ee.with({end:ge}),We=new o.$Jd,_e=await this.h.provideCompletionItems(Z,ge,oe,f.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Ye=Array.isArray(_e)?new R.$TK(_e):_e,it=ie.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new p.$Rc;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:f.Range.from(Ee),insert:f.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Le=Ye.items[qe],Xe=this.l(Le,[it,qe],je,Ee);Ae.push(Xe)}return Ne}async resolveCompletionItem(z,J){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...z);if(!se)return;const oe=this.l(se,z),Z=await this.h.resolveCompletionItem(se,J);if(!Z)return;const ge=this.l(Z,z);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,T.$$m)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,J,se,oe){const Z=this.e.get(J[0]);if(!Z)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(z.command,Z),Ee={x:J,a:z.label,b:z.kind!==void 0?f.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(f.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:f.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(f.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=z.textEdit.newText):typeof z.insertText=="string"?Ee.h=z.insertText:z.insertText instanceof R.$xK&&(Ee.h=z.insertText.value,Ee.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),R.$oK.isRange(je)?Ee.j=f.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(Ee.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),Ee}}class ce{async provideInlineCompletions(z,J,se,oe){}disposeCompletions(z){}handleDidShowCompletionItem(z,J,se){}handlePartialAccept(z,J,se){}}class pe extends ce{constructor(z,J,se,oe){super(),this.f=z,this.g=J,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$gF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$gF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,J,se,oe){const Z=this.g.getDocument(z),ge=f.Position.to(J),Ee=await this.h.provideInlineCompletionItems(Z,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:f.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const je=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new p.$Rc),Ne=this.j.toInternal(et.command,Ye));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?f.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new p.$Rc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,J,se){const oe=this.d.get(z)?.items[J];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(z,J,se){const oe=this.d.get(z)?.items[J];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const J=this.e++;return this.d.set(J,z),J}disposeReferenceId(z){const J=this.d.get(z);return this.d.delete(z),J}get(z){return this.d.get(z)}}class B{constructor(z,J){this.e=z,this.f=J,this.d=new s.$hcc("SignatureHelp")}async provideSignatureHelp(z,J,se,oe){const Z=this.e.getDocument(z),ge=f.Position.to(J),Ee=this.g(se),je=await this.f.provideSignatureHelp(Z,ge,oe,Ee);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(z){let J;if(z.activeSignatureHelp){const se=f.SignatureHelp.to(z.activeSignatureHelp),oe=this.d.get(z.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=se.activeSignature,J.activeParameter=se.activeParameter):J=se}return{...z,activeSignatureHelp:J}}releaseSignatureHelp(z){this.d.delete(z)}}class X{constructor(z,J,se,oe,Z){this.f=z,this.g=J,this.h=se,this.j=oe,this.k=Z,this.d=new s.$hcc("InlayHints"),this.e=new Map}async provideInlayHints(z,J,se){const oe=this.f.getDocument(z),Z=f.Range.to(J),ge=await this.h.provideInlayHints(oe,Z,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(se.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new p.$Rc);const je={hints:[],cacheId:Ee};for(let We=0;We<ge.length;We++)this.l(ge[We],Z)&&je.hints.push(this.m(ge[We],[Ee,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(z,J){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.h.resolveInlayHint(se,J);if(oe&&this.l(oe))return this.m(oe,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,J){return z.label.length===0||Array.isArray(z.label)&&z.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(J&&!J.contains(z.position))}m(z,J){const se=this.e.get(J[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:J,tooltip:f.MarkdownString.fromStrict(z.tooltip),position:f.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(f.TextEdit.from),kind:z.kind&&f.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?oe.label=z.label:oe.label=z.label.map(Z=>{const ge={label:Z.value};return ge.tooltip=f.MarkdownString.fromStrict(Z.tooltip),R.$yK.isLocation(Z.location)&&(ge.location=f.location.from(Z.location)),Z.command&&(ge.command=this.g.toInternal(Z.command,se)),ge}),oe}}class re{constructor(z,J){this.e=z,this.f=J,this.d=new s.$hcc("DocumentLink")}async provideLinks(z,J){const se=this.e.getDocument(z),oe=await this.f.provideDocumentLinks(se,J);if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(re.g).map(f.DocumentLink.from)};{const Z=this.d.add(oe),ge={links:[],cacheId:Z};for(let Ee=0;Ee<oe.length;Ee++){if(!re.g(oe[Ee]))continue;const je=f.DocumentLink.from(oe[Ee]);je.cacheId=[Z,Ee],ge.links.push(je)}return ge}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,J){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.f.resolveDocumentLink(se,J);if(!(!oe||!re.g(oe)))return f.DocumentLink.from(oe)}releaseLinks(z){this.d.delete(z)}}class Y{constructor(z,J){this.d=z,this.e=J}async provideColors(z,J){const se=this.d.getDocument(z),oe=await this.e.provideDocumentColors(se,J);return Array.isArray(oe)?oe.map(ge=>({color:f.Color.from(ge.color),range:f.Range.from(ge.range)})):[]}async provideColorPresentations(z,J,se){const oe=this.d.getDocument(z),Z=f.Range.to(J.range),ge=f.Color.to(J.color),Ee=await this.e.provideColorPresentations(ge,{document:oe,range:Z},se);if(Array.isArray(Ee))return Ee.map(f.ColorPresentation.from)}}class _{constructor(z,J){this.d=z,this.e=J}async provideFoldingRanges(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideFoldingRanges(oe,J,se);if(Array.isArray(Z))return Z.map(f.FoldingRange.from)}}class x{constructor(z,J,se){this.d=z,this.e=J,this.f=se}async provideSelectionRanges(z,J,se){const oe=this.d.getDocument(z),Z=J.map(f.Position.to),ge=await this.e.provideSelectionRanges(oe,Z,se);if(!(0,L.$Lb)(ge))return[];if(ge.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let je=0;je<Z.length;je++){const We=[];Ee.push(We);let _e=Z[je],Ye=ge[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return Ee}}class ve{constructor(z,J){this.f=z,this.g=J,this.d=new r.$qM(""),this.e=new Map}async prepareSession(z,J,se){const oe=this.f.getDocument(z),Z=f.Position.to(J),ge=await this.g.prepareCallHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(je=>this.h(Ee,je)):[this.h(Ee,ge)]}async provideCallsTo(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(Z)return Z.map(ge=>({from:this.h(z,ge.from),fromRanges:ge.fromRanges.map(Ee=>f.Range.from(Ee))}))}async provideCallsFrom(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(Z)return Z.map(ge=>({to:this.h(z,ge.to),fromRanges:ge.fromRanges.map(Ee=>f.Range.from(Ee))}))}releaseSession(z){this.e.delete(z)}h(z,J){const se=this.e.get(z),oe=f.CallHierarchyItem.from(J,z,se.size.toString(36));return se.set(oe._itemId,J),oe}j(z,J){return this.e.get(z)?.get(J)}}class ae{constructor(z,J){this.f=z,this.g=J,this.d=new r.$qM(""),this.e=new Map}async prepareSession(z,J,se){const oe=this.f.getDocument(z),Z=f.Position.to(J),ge=await this.g.prepareTypeHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(je=>this.h(Ee,je)):[this.h(Ee,ge)]}async provideSupertypes(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(oe,se);if(Z)return Z.map(ge=>this.h(z,ge))}async provideSubtypes(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(oe,se);if(Z)return Z.map(ge=>this.h(z,ge))}releaseSession(z){this.e.delete(z)}h(z,J){const se=this.e.get(z),oe=f.TypeHierarchyItem.from(J,z,se.size.toString(36));return se.set(oe._itemId,J),oe}j(z,J){return this.e.get(z)?.get(J)}}class fe{static toInternalProviderId(z,J){return z+"."+J}constructor(z,J,se,oe,Z){this.d=z,this.e=J,this.f=se,this.g=oe,this.h=Z}async provideDocumentOnDropEdits(z,J,se,oe,Z){const ge=this.e.getDocument(J),Ee=f.Position.to(se),je=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,Ee,je,Z);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(z,J){this.d=z,this.e=J}async provideMappedEdits(z,J,se,oe){const Z=D.URI.revive(z),ge=this.d.getDocument(Z),Ee=se.documents.map(_e=>_e.map(Ye=>({uri:D.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>f.Range.to(it))}))),je={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,je,oe);return We?f.WorkspaceEdit.from(We):null}}class de{constructor(z,J){this.adapter=z,this.extension=J}}class be{static{this.d=0}constructor(z,J,se,oe,Z,ge,Ee,je){this.g=J,this.h=se,this.j=oe,this.k=Z,this.l=ge,this.m=Ee,this.n=je,this.f=new Map,this.e=z.getProxy($.$kK.MainThreadLanguageFeatures)}o(z,J){return f.DocumentSelector.from(z,this.g,J)}p(z){return new R.$mK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,J,se,oe,Z,ge=!1){const Ee=this.f.get(z);if(!Ee||!(Ee.adapter instanceof J))return oe;const je=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,m.$4)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Z)?(0,u.$Jg)(We,Z):We}t(z,J){const se=this.q();return this.f.set(se,new de(z,J)),se}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,se,oe){const Z=this.t(new c(this.h,se),z),ge=oe&&oe.label||be.u(z);return this.e.$registerDocumentSymbolProvider(Z,this.o(J,z),ge),this.p(Z)}$provideDocumentSymbols(z,J,se){return this.s(z,c,oe=>oe.provideDocumentSymbols(D.URI.revive(J),se),void 0,se)}registerCodeLensProvider(z,J,se){const oe=this.q(),Z=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new i(this.h,this.j.converter,se),z)),this.e.$registerCodeLensSupport(oe,this.o(J,z),Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Z));ge=R.$mK.from(ge,Ee)}return ge}$provideCodeLenses(z,J,se){return this.s(z,i,oe=>oe.provideCodeLenses(D.URI.revive(J),se),void 0,se)}$resolveCodeLens(z,J,se){return this.s(z,i,oe=>oe.resolveCodeLens(J,se),void 0,void 0)}$releaseCodeLenses(z,J){this.s(z,i,se=>Promise.resolve(se.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(z,J,se){const oe=this.t(new l(this.h,se),z);return this.e.$registerDefinitionSupport(oe,this.o(J,z)),this.p(oe)}$provideDefinition(z,J,se,oe){return this.s(z,l,Z=>Z.provideDefinition(D.URI.revive(J),se,oe),[],oe)}registerDeclarationProvider(z,J,se){const oe=this.t(new C(this.h,se),z);return this.e.$registerDeclarationSupport(oe,this.o(J,z)),this.p(oe)}$provideDeclaration(z,J,se,oe){return this.s(z,C,Z=>Z.provideDeclaration(D.URI.revive(J),se,oe),[],oe)}registerImplementationProvider(z,J,se){const oe=this.t(new S(this.h,se),z);return this.e.$registerImplementationSupport(oe,this.o(J,z)),this.p(oe)}$provideImplementation(z,J,se,oe){return this.s(z,S,Z=>Z.provideImplementation(D.URI.revive(J),se,oe),[],oe)}registerTypeDefinitionProvider(z,J,se){const oe=this.t(new b(this.h,se),z);return this.e.$registerTypeDefinitionSupport(oe,this.o(J,z)),this.p(oe)}$provideTypeDefinition(z,J,se,oe){return this.s(z,b,Z=>Z.provideTypeDefinition(D.URI.revive(J),se,oe),[],oe)}registerHoverProvider(z,J,se,oe){const Z=this.t(new g(this.h,se),z);return this.e.$registerHoverProvider(Z,this.o(J,z)),this.p(Z)}$provideHover(z,J,se,oe){return this.s(z,g,Z=>Z.provideHover(D.URI.revive(J),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(z,J,se,oe){const Z=this.t(new d(this.h,se),z);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(J,z)),this.p(Z)}$provideEvaluatableExpression(z,J,se,oe){return this.s(z,d,Z=>Z.provideEvaluatableExpression(D.URI.revive(J),se,oe),void 0,oe)}registerInlineValuesProvider(z,J,se,oe){const Z=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,se),z);this.e.$registerInlineValuesProvider(ge,this.o(J,z),Z);let Ee=this.p(ge);if(Z!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=R.$mK.from(Ee,je)}return Ee}$provideInlineValues(z,J,se,oe,Z){return this.s(z,P,ge=>ge.provideInlineValues(D.URI.revive(J),se,oe,Z),void 0,Z)}registerDocumentHighlightProvider(z,J,se){const oe=this.t(new N(this.h,se),z);return this.e.$registerDocumentHighlightProvider(oe,this.o(J,z)),this.p(oe)}$provideDocumentHighlights(z,J,se,oe){return this.s(z,N,Z=>Z.provideDocumentHighlights(D.URI.revive(J),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(z,J,se){const oe=this.t(new F(this.h,se),z);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(J,z)),this.p(oe)}$provideLinkedEditingRanges(z,J,se,oe){return this.s(z,F,async Z=>{const ge=await Z.provideLinkedEditingRanges(D.URI.revive(J),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?be.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(z,J,se){const oe=this.t(new M(this.h,se),z);return this.e.$registerReferenceSupport(oe,this.o(J,z)),this.p(oe)}$provideReferences(z,J,se,oe,Z){return this.s(z,M,ge=>ge.provideReferences(D.URI.revive(J),se,oe,Z),void 0,Z)}registerCodeActionProvider(z,J,se,oe){const Z=new p.$Rc,ge=this.t(new U(this.h,this.j.converter,this.k,se,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(ge,this.o(J,z),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},be.u(z),!!se.resolveCodeAction),Z.add(this.p(ge)),Z}$provideCodeActions(z,J,se,oe,Z){return this.s(z,U,ge=>ge.provideCodeActions(D.URI.revive(J),se,oe,Z),void 0,Z)}$resolveCodeAction(z,J,se){return this.s(z,U,oe=>oe.resolveCodeAction(J,se),{},void 0)}$releaseCodeActions(z,J){this.s(z,U,se=>Promise.resolve(se.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(z,J,se){const oe=this.t(new O(this.h,se),z);return this.e.$registerDocumentFormattingSupport(oe,this.o(J,z),z.identifier,z.displayName||z.name),this.p(oe)}$provideDocumentFormattingEdits(z,J,se,oe){return this.s(z,O,Z=>Z.provideDocumentFormattingEdits(D.URI.revive(J),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(z,J,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Z=this.t(new K(this.h,se),z);return this.e.$registerRangeFormattingSupport(Z,this.o(J,z),z.identifier,z.displayName||z.name,oe),this.p(Z)}$provideDocumentRangeFormattingEdits(z,J,se,oe,Z){return this.s(z,K,ge=>ge.provideDocumentRangeFormattingEdits(D.URI.revive(J),se,oe,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(z,J,se,oe,Z){return this.s(z,K,ge=>ge.provideDocumentRangesFormattingEdits(D.URI.revive(J),se,oe,Z),void 0,Z)}registerOnTypeFormattingEditProvider(z,J,se,oe){const Z=this.t(new V(this.h,se),z);return this.e.$registerOnTypeFormattingSupport(Z,this.o(J,z),oe,z.identifier),this.p(Z)}$provideOnTypeFormattingEdits(z,J,se,oe,Z,ge){return this.s(z,V,Ee=>Ee.provideOnTypeFormattingEdits(D.URI.revive(J),se,oe,Z,ge),void 0,ge)}registerWorkspaceSymbolProvider(z,J){const se=this.t(new me(J,this.l),z);return this.e.$registerNavigateTypeSupport(se,typeof J.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(z,J,se){return this.s(z,me,oe=>oe.provideWorkspaceSymbols(J,se),{symbols:[]},se)}$resolveWorkspaceSymbol(z,J,se){return this.s(z,me,oe=>oe.resolveWorkspaceSymbol(J,se),void 0,void 0)}$releaseWorkspaceSymbols(z,J){this.s(z,me,se=>se.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(z,J,se){const oe=this.t(new te(this.h,se,this.l),z);return this.e.$registerRenameSupport(oe,this.o(J,z),te.supportsResolving(se)),this.p(oe)}$provideRenameEdits(z,J,se,oe,Z){return this.s(z,te,ge=>ge.provideRenameEdits(D.URI.revive(J),se,oe,Z),void 0,Z)}$resolveRenameLocation(z,J,se,oe){return this.s(z,te,Z=>Z.resolveRenameLocation(D.URI.revive(J),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(z,J,se,oe){const Z=this.t(new Q(this.h,se),z),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(J,z),oe,ge);let Ee=this.p(Z);if(ge){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=R.$mK.from(Ee,je)}return Ee}$provideDocumentSemanticTokens(z,J,se,oe){return this.s(z,Q,Z=>Z.provideDocumentSemanticTokens(D.URI.revive(J),se,oe),null,oe)}$releaseDocumentSemanticTokens(z,J){this.s(z,Q,se=>se.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,J,se,oe){const Z=this.t(new le(this.h,se),z);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(J,z),oe),this.p(Z)}$provideDocumentRangeSemanticTokens(z,J,se,oe){return this.s(z,le,Z=>Z.provideDocumentRangeSemanticTokens(D.URI.revive(J),se,oe),null,oe)}registerCompletionItemProvider(z,J,se,oe){const Z=this.t(new ie(this.h,this.j.converter,se,this.m,z),z);return this.e.$registerCompletionsProvider(Z,this.o(J,z),oe,ie.supportsResolving(se),z.identifier),this.p(Z)}$provideCompletionItems(z,J,se,oe,Z){return this.s(z,ie,ge=>ge.provideCompletionItems(D.URI.revive(J),se,oe,Z),void 0,Z)}$resolveCompletionItem(z,J,se){return this.s(z,ie,oe=>oe.resolveCompletionItem(J,se),void 0,se)}$releaseCompletionItems(z,J){this.s(z,ie,se=>se.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(z,J,se,oe){const Z=new pe(z,this.h,se,this.j.converter),ge=this.t(Z,z);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,z),Z.supportsHandleEvents,k.$6l.toKey(z.identifier.value),oe?.yieldTo?.map(Ee=>k.$6l.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(z,J,se,oe,Z){return this.s(z,ce,ge=>ge.provideInlineCompletions(D.URI.revive(J),se,oe,Z),void 0,Z)}$handleInlineCompletionDidShow(z,J,se,oe){this.s(z,ce,async Z=>{Z.handleDidShowCompletionItem(J,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,J,se,oe){this.s(z,ce,async Z=>{Z.handlePartialAccept(J,se,oe)},void 0,void 0)}$freeInlineCompletionsList(z,J){this.s(z,ce,async se=>{se.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(z,J,se,oe){const Z=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new B(this.h,se),z);return this.e.$registerSignatureHelpProvider(ge,this.o(J,z),Z),this.p(ge)}$provideSignatureHelp(z,J,se,oe,Z){return this.s(z,B,ge=>ge.provideSignatureHelp(D.URI.revive(J),se,oe,Z),void 0,Z)}$releaseSignatureHelp(z,J){this.s(z,B,se=>se.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(z,J,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new X(this.h,this.j.converter,se,this.l,z),z);this.e.$registerInlayHintsProvider(Z,this.o(J,z),typeof se.resolveInlayHint=="function",oe,be.u(z));let ge=this.p(Z);if(oe!==void 0){const Ee=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));ge=R.$mK.from(ge,Ee)}return ge}$provideInlayHints(z,J,se,oe){return this.s(z,X,Z=>Z.provideInlayHints(D.URI.revive(J),se,oe),void 0,oe)}$resolveInlayHint(z,J,se){return this.s(z,X,oe=>oe.resolveInlayHint(J,se),void 0,se)}$releaseInlayHints(z,J){this.s(z,X,se=>se.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(z,J,se){const oe=this.t(new re(this.h,se),z);return this.e.$registerDocumentLinkProvider(oe,this.o(J,z),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(z,J,se){return this.s(z,re,oe=>oe.provideLinks(D.URI.revive(J),se),void 0,se,J.scheme==="output")}$resolveDocumentLink(z,J,se){return this.s(z,re,oe=>oe.resolveLink(J,se),void 0,void 0,!0)}$releaseDocumentLinks(z,J){this.s(z,re,se=>se.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(z,J,se){const oe=this.t(new Y(this.h,se),z);return this.e.$registerDocumentColorProvider(oe,this.o(J,z)),this.p(oe)}$provideDocumentColors(z,J,se){return this.s(z,Y,oe=>oe.provideColors(D.URI.revive(J),se),[],se)}$provideColorPresentations(z,J,se,oe){return this.s(z,Y,Z=>Z.provideColorPresentations(D.URI.revive(J),se,oe),void 0,oe)}registerFoldingRangeProvider(z,J,se){const oe=this.q(),Z=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new _(this.h,se),z)),this.e.$registerFoldingRangeProvider(oe,this.o(J,z),z.identifier,Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));ge=R.$mK.from(ge,Ee)}return ge}$provideFoldingRanges(z,J,se,oe){return this.s(z,_,Z=>Z.provideFoldingRanges(D.URI.revive(J),se,oe),void 0,oe)}registerSelectionRangeProvider(z,J,se){const oe=this.t(new x(this.h,se,this.l),z);return this.e.$registerSelectionRangeProvider(oe,this.o(J,z)),this.p(oe)}$provideSelectionRanges(z,J,se,oe){return this.s(z,x,Z=>Z.provideSelectionRanges(D.URI.revive(J),se,oe),[],oe)}registerCallHierarchyProvider(z,J,se){const oe=this.t(new ve(this.h,se),z);return this.e.$registerCallHierarchyProvider(oe,this.o(J,z)),this.p(oe)}$prepareCallHierarchy(z,J,se,oe){return this.s(z,ve,Z=>Promise.resolve(Z.prepareSession(D.URI.revive(J),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(z,J,se,oe){return this.s(z,ve,Z=>Z.provideCallsTo(J,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(z,J,se,oe){return this.s(z,ve,Z=>Z.provideCallsFrom(J,se,oe),void 0,oe)}$releaseCallHierarchy(z,J){this.s(z,ve,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(z,J,se){const oe=this.t(new ae(this.h,se),z);return this.e.$registerTypeHierarchyProvider(oe,this.o(J,z)),this.p(oe)}$prepareTypeHierarchy(z,J,se,oe){return this.s(z,ae,Z=>Promise.resolve(Z.prepareSession(D.URI.revive(J),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(z,J,se,oe){return this.s(z,ae,Z=>Z.provideSupertypes(J,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(z,J,se,oe){return this.s(z,ae,Z=>Z.provideSubtypes(J,se,oe),void 0,oe)}$releaseTypeHierarchy(z,J){this.s(z,ae,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(z,J,se,oe){const Z=this.q();this.f.set(Z,new de(new fe(this.e,this.h,se,Z,z),z));const ge=(0,t.$gF)(z,"dropMetadata")&&oe?fe.toInternalProviderId(z.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(J,z),ge,(0,t.$gF)(z,"dropMetadata")?oe:void 0),this.p(Z)}$provideDocumentOnDropEdits(z,J,se,oe,Z,ge){return this.s(z,fe,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(J,D.URI.revive(se),oe,Z,ge)),void 0,void 0)}registerMappedEditsProvider(z,J,se){const oe=this.t(new ee(this.h,se),z);return this.e.$registerMappedEditsProvider(oe,this.o(J,z)),this.p(oe)}$provideMappedEdits(z,J,se,oe,Z){return this.s(z,ee,ge=>Promise.resolve(ge.provideMappedEdits(J,se,oe,Z)),null,Z)}registerDocumentPasteEditProvider(z,J,se,oe){const Z=this.q();this.f.set(Z,new de(new j(this.e,this.h,se,Z,z),z));const ge=j.toInternalProviderId(z.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Z,this.o(J,z),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(z,J,se,oe,Z){return this.s(z,j,ge=>ge.prepareDocumentPaste(D.URI.revive(J),se,oe,Z),void 0,Z)}$providePasteEdits(z,J,se,oe,Z,ge){return this.s(z,j,Ee=>Ee.providePasteEdits(J,D.URI.revive(se),oe,Z,ge),void 0,ge)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(J=>R.SyntaxTokenType.toString(J)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,J,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Oe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(J,oe):this.h.setWordDefinitionFor(J,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Z=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?be.w(se.wordPattern):void 0,indentationRules:se.indentationRules?be.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?be.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?be.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,J,ge),this.p(Z)}$setWordDefinitions(z){for(const J of z)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$qcc=be}),define(De[319],Ce([1,0,6,13,7,38,8,3,26]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class w{constructor(I,v,y,k){this.c=v,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(D.$kK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,v){await this.a.$changeLanguage(I,v);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,v){const y=I.version,k=T.Position.from(v),p=await this.a.$tokensAtPosition(I.uri,k),h={type:f.StandardTokenType.Other,range:I.getWordRangeAtPosition(v)??new f.$oK(v.line,v.character,v.line,v.character)};if(!p)return h;const r={range:T.Range.to(p.range),type:T.TokenType.to(p.type)};return!r.range.contains(v)||y!==I.version?h:r}createLanguageStatusItem(I,v,y){const k=this.f++,p=this.a,h=this.g,r=`${I.identifier.value}/${v}`;if(h.has(r))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);h.add(r);const s={selector:y,id:v,name:I.displayName??I.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const m=new $.$Rc,u=()=>{if(o?.dispose(),!h.has(r)){console.warn(`LanguageStatusItem (${v}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$Vg)(()=>{m.clear(),this.a.$setLanguageStatus(k,{id:r,name:s.name??I.displayName??I.name,source:I.displayName??I.name,selector:T.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===f.LanguageStatusSeverity.Error?R.default.Error:s.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:s.command&&this.d.toInternal(s.command,m),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},t={dispose(){m.dispose(),o?.dispose(),p.$removeLanguageStatus(k),h.delete(r)},get id(){return s.id},get name(){return s.name},set name(n){s.name=n,u()},get selector(){return s.selector},set selector(n){s.selector=n,u()},get text(){return s.text},set text(n){s.text=n,u()},set text2(n){(0,E.$hF)(I,"languageStatusText"),s.text=n,u()},get text2(){return(0,E.$hF)(I,"languageStatusText"),s.text},get detail(){return s.detail},set detail(n){s.detail=n,u()},get severity(){return s.severity},set severity(n){s.severity=n,u()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(n){s.accessibilityInformation=n,u()},get command(){return s.command},set command(n){s.command=n,u()},get busy(){return s.busy},set busy(n){s.busy=n,u()}};return u(),t}}e.$$cc=w}),define(De[112],Ce([1,0,12,15,2,5,14,6,27,20]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=void 0;let L=class{constructor(v,y,k){this.f=k,this.d=new Map,this.a=y.getProxy($.$kK.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===D.$g}getMessage(v,y){const{message:k,args:p,comment:h}=y;if(this.c)return(0,T.$De)(k,p??{});let r=k;h&&h.length>0&&(r+=`/${Array.isArray(h)?h.join(""):h}`);const s=this.d.get(v)?.contents[r];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,T.$De)(s??k,p??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let y;const k=await this.g(v);if(!k){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(k),h=JSON.parse(p);y=v.isBuiltin?h.contents?.bundle:h}catch(p){this.f.error(`Failed to load translations for ${v.identifier.value} from ${k}: ${p.message}`);return}y&&this.d.set(v.identifier.value,{contents:y,uri:k})}async g(v){if(v.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return f.URI.revive(y)}return v.l10n?f.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Zcc=L,e.$Zcc=L=He([Be(0,E.$BM),Be(1,w.$lM),Be(2,A.$0i)],L),e.$1cc=(0,R.$Ph)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,27,20,2,62]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;let E=class extends D.$ij{constructor(I,v){super(v.logLevel,v.logsLocation,v.loggers.map(y=>(0,$.$mh)(y))),this.r=I.getProxy(T.$kK.MainThreadLogger)}$setLogLevel(I,v){v?this.setLogLevel(A.URI.revive(v),I):this.setLogLevel(I)}setVisibility(I,v){super.setVisibility(I,v),this.r.$setVisibility(I,v)}s(I,v,y){return new w(this.r,I,v,y)}};e.$qec=E,e.$qec=E=He([Be(0,R.$lM),Be(1,f.$BM)],E);class w extends D.$dj{constructor(I,v,y,k){super(k?.logLevel==="always"),this.r=I,this.s=v,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(v,k).then(()=>{this.u(this.n),this.m=!0})}g(I,v){const y=[[I,v]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0,e.$2cc=(0,T.$Ph)("IExtHostManagedSockets");let $=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$kK.MainThreadManagedSockets)}setFactory(I,v){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const v=++this.b,y=await this.c.makeConnection(),k=new f.$Rc;return this.d.set(v,new w(v,y,k)),k.add((0,f.$Qc)(()=>this.d.delete(v))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),k.dispose()})),k.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(v,p?.stack??p?.message),k.dispose()})),k.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(v,A.$be.wrap(p)))),v}$remoteSocketWrite(I,v){this.d.get(I)?.actual.send(v.buffer)}$remoteSocketEnd(I){const v=this.d.get(I);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$3cc=$,e.$3cc=$=He([Be(0,R.$lM)],$);class E{constructor(I,v){this.socketFactoryId=I,this.makeConnection=v}}class w extends f.$Sc{constructor(I,v,y){super(),this.socketId=I,this.actual=v,this.B(y)}}}),define(De[320],Ce([1,0,6,14,26]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;function R($){return $&&$.title}let A=class{constructor(E,w){this.b=w,this.a=E.getProxy(D.$kK.MainThreadMessageService)}showMessage(E,w,L,I,v){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let k;typeof I=="string"||R(I)?k=[I,...v]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,k=v),y.useCustom&&(0,f.$hF)(E,"resolvers");const p=[];for(let h=0;h<k.length;h++){const r=k[h];if(typeof r=="string")p.push({title:r,handle:h,isCloseAffordance:!1});else if(typeof r=="object"){const{title:s,isCloseAffordance:o}=r;p.push({title:s,isCloseAffordance:!!o,handle:h})}else this.b.warn("Invalid message item:",r)}return this.a.$showMessage(w,L,y,p).then(h=>{if(typeof h=="number")return k[h]})}};e.$_cc=A,e.$_cc=A=He([Be(1,T.$0i)],A)}),define(De[321],Ce([1,0,208,22,4,3,28,15,17,2,30,107,6,34,13,7,69,283,144,9,24,18]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,i,a,l,C){this.q=a,this.r=l,this.s=C,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new f.$Nd({onListenerError:o.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Nd({onListenerError:o.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Nd({onListenerError:o.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Nd({onListenerError:o.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$hcc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=c.getProxy(v.$kK.MainThreadNotebook),this.c=c.getProxy(v.$kK.MainThreadNotebookDocuments),this.d=c.getProxy(v.$kK.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const b=S.notebookEditor?.notebookUri,g=S.cell.handle,P=this.g.get(b)?.getCell(g);if(P)return P.apiCell}if(S&&S.$mid===14){const b=S.uri,g=this.g.get(b);if(g)return g.apiNotebook}return S}}),t.A(i)}getEditorById(c){const i=this.h.get(c);if(!i)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(c){for(const[i,a]of this.h)if(a.apiEditor===c)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,i){const a=this.g.get(c);if(!a&&!i)throw new Error(`NO notebook document for '${c}'`);return a}static t(c,i){if(!i)return;const a=i.filenamePattern.map(l=>k.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(i.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:i.displayName,filenamePattern:a,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,i,a){const l=t.a++,C=typeof a.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(l,a),this.b.$registerNotebookCellStatusBarItemProvider(l,C,i);let S;return C!==void 0&&(S=a.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(C))),new p.$mK(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,C),S?.dispose()})}async createNotebookDocument(c){const i=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&k.NotebookData.from(c.content)});return w.URI.revive(i)}async openNotebookDocument(c){const i=this.g.get(c);if(i)return i.apiNotebook;const a=await this.c.$tryOpenNotebook(c),l=this.g.get(w.URI.revive(a));return(0,E.$Jf)(l?.apiNotebook)}async showNotebookDocument(c,i){w.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof i=="object"?a={position:k.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(k.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:a={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,a),C=l&&this.h.get(l)?.apiEditor;if(C)return C;throw l?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,i,a,l){const C=this.f.get(c),S=w.URI.revive(i),b=this.g.get(S);if(!b||!C)return;const g=b.getCellFromIndex(a);if(!g)return;const d=await C.provideCellStatusBarItems(g.apiCell,l);if(!d)return;const P=new R.$Rc,N=this.p.add([P]),M=(Array.isArray(d)?d:[d]).map(U=>k.NotebookStatusBarItem.from(U,this.i,P));return{cacheId:N,items:M}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,i,a,l,C){if((0,$.$Be)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:i,serializer:a,options:l}),this.b.$registerNotebookSerializer(S,{id:c.identifier,location:c.extensionLocation},i,k.NotebookDocumentContentOptions.from(l),t.t(c,C)),(0,R.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(c,i,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const C=await l.serializer.deserializeNotebook(i.buffer,a);return new h.$qv(k.NotebookData.from(C))}async $notebookToData(c,i,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const C=await l.serializer.serializeNotebook(k.NotebookData.to(i.value),a);return T.$be.wrap(C)}async $saveNotebook(c,i,a,l,C){const S=w.URI.revive(i),b=this.w.get(c);if(!b)throw new Error("NO serializer found");const g=this.g.get(S);if(!g)throw new Error("Document NOT found");if(g.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new L.$tk((0,D.localize)(0,null,this.y(S)),6);await this.x(S,l);const d={metadata:(0,m.$cn)(g.apiNotebook.metadata,U=>!(b.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of g.apiNotebook.getCells()){const j=new p.$KL(U.kind,U.document.getText(),U.document.languageId,U.mime,b.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);j.metadata=(0,m.$cn)(U.metadata,O=>!(b.options?.transientCellMetadata??{})[O]),d.cells.push(j)}const P=await b.serializer.serializeNotebook(d,C);await this.s.value.writeFile(S,P);const N=this.s.getFileSystemProviderExtUri(S.scheme),F=await this.s.value.stat(S);return{name:N.basename(S),isFile:(F.type&L.FileType.File)!==0,isDirectory:(F.type&L.FileType.Directory)!==0,isSymbolicLink:(F.type&L.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((F.permissions??0)&L.FilePermission.Locked),etag:L.$Ek({mtime:F.mtime,size:F.size}),children:void 0}}async x(c,i){const a=await this.s.value.stat(c);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==L.$Dk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==L.$Ek({mtime:i.mtime,size:a.size}))throw new L.$tk((0,D.localize)(1,null),3,i)}y(c){return c.scheme===u.Schemas.file?c.fsPath:c.toString()}z(c,i,a){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const l=new s.$Sdc(i,this.d,c,a.visibleRanges.map(k.NotebookRange.to),a.selections.map(k.NotebookRange.to),typeof a.viewColumn=="number"?k.ViewColumn.to(a.viewColumn):void 0);this.h.set(i,l)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const l=w.URI.revive(a),C=this.g.get(l);C&&(C.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:C.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(C.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===l.toString()&&this.h.delete(S.id)}if(c.value.addedDocuments){const a=[];for(const l of c.value.addedDocuments){const C=w.URI.revive(l.uri);if(this.g.has(C))throw new Error(`adding EXISTING notebook ${C} `);const S=new r.$Rdc(this.c,this.q,this.r,C,l);a.push(...l.cells.map(b=>r.$Qdc.asModelAddData(S.apiNotebook,b))),this.g.get(C)?.dispose(),this.g.set(C,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(S.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this.h.has(a.id))return;const l=w.URI.revive(a.documentUri),C=this.g.get(l);C&&this.z(C,a.id,a)}const i=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const l=this.h.get(a);l&&(this.h.delete(a),this.k?.id===l.id&&(this.k=void 0),i.push(l))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const a=new Set;this.l.forEach(l=>a.add(l.id));for(const l of this.h.values()){const C=a.has(l.id);l._acceptVisibility(C)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(c){const i=y.$JM.String.with("notebookType","A notebook type"),a=new y.$LM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.$JM("data","Bytes to convert to data",C=>C instanceof Uint8Array,C=>T.$be.wrap(C))],new y.$KM("Notebook Data",C=>k.NotebookData.to(C.value))),l=new y.$LM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.$JM("NotebookData","Notebook data to convert to bytes",C=>!0,C=>new h.$qv(k.NotebookData.from(C)))],new y.$KM("Bytes",C=>C.buffer));c.registerApiCommand(a),c.registerApiCommand(l)}}e.$Tdc=t}),define(De[322],Ce([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,110,277,26,69]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0;let o=class{constructor(l,C,S,b,g){this.l=C,this.m=S,this.n=b,this.o=g,this.b=new $.$Ac,this.c=new $.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new R.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=l.getProxy(I.$kK.MainThreadNotebookKernels);const d=new v.$LM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$JM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.m.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],v.$KM.Void);this.n.registerApiCommand(d)}createNotebookController(l,C,S,b,g,d){for(const le of this.i.values())if(le.controller.id===C&&w.$6l.equals(l.identifier,le.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const P=this.j++,N=this;this.o.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${C}`);const F=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let M=!1;const U=new R.$Nd,j=new R.$Nd,O={id:i(l.identifier,C),notebookType:S,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:b||l.identifier.value,preloads:d?d.map(y.NotebookRendererScript.from):[]};let K=g??F,V;this.a.$addKernel(P,O).catch(le=>{console.log(le),M=!0});let me=0;const te=()=>{if(M)return;const le=++me;Promise.resolve().then(()=>{le===me&&this.a.$updateKernel(P,O)})},G=new $.$Ac,Q={get id(){return C},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return O.label},set label(le){O.label=le??l.displayName??l.name,te()},get detail(){return O.detail??""},set detail(le){O.detail=le,te()},get description(){return O.description??""},set description(le){O.description=le,te()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(le){O.supportedLanguages=le,te()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(le){O.supportsExecutionOrder=le,te()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(le){K=le??F},get interruptHandler(){return V},set interruptHandler(le){V=le,O.supportsInterrupt=!!le,te()},createNotebookCellExecution(le){if(M)throw new Error("notebook controller is DISPOSED");if(!G.has(le.notebook.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return N._createNotebookCellExecution(le,i(l.identifier,this.id))},createNotebookExecution(le){if((0,r.$hF)(l,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!G.has(le.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.uri.toString()}`);return N._createNotebookExecution(le,i(l.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${P}], DISPOSED`),M=!0,this.i.delete(P),U.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(le,ie){ie===k.NotebookControllerAffinity2.Hidden&&(0,r.$hF)(l,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,le.uri,ie)},onDidReceiveMessage:j.event,postMessage(le,ie){return(0,r.$hF)(l,"notebookMessaging"),N.a.$postMessage(P,ie&&N.m.getIdByEditor(ie),le)},asWebviewUri(le){return(0,r.$hF)(l,"notebookMessaging"),(0,p.$cpb)(le,N.l.remote)}};return this.i.set(P,{extensionId:l.identifier,controller:Q,onDidReceiveMessage:j,onDidChangeSelection:U,associatedNotebooks:G}),Q}getIdByController(l){for(const[C,S]of this.i)if(S.controller===l)return i(S.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,C){const S=this.f++,b=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(S,C);const g={dispose:()=>{this.e.delete(S),b.a.$removeKernelDetectionTask(S)}};return this.e.set(S,g),g}registerKernelSourceActionProvider(l,C,S){const b=this.h++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?b:void 0,d=this;this.g.set(b,S),this.o.trace(`NotebookKernelSourceActionProvider[${b}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(b,b,C);let P;return g!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete(b),d.a.$removeKernelSourceActionProvider(b,b),P?.dispose()}}}async $provideKernelSourceActions(l,C){const S=this.g.get(l);if(S){const b=new A.$Rc;return(await S.provideNotebookKernelSourceActions(C)??[]).map(d=>y.NotebookKernelSourceAction.from(d,this.n.converter,b))}return[]}$acceptNotebookAssociation(l,C,S){const b=this.i.get(l);if(b){const g=this.m.getNotebookDocument(E.URI.revive(C));S?b.associatedNotebooks.set(g.uri,!0):b.associatedNotebooks.delete(g.uri),this.o.trace(`NotebookController[${l}] ASSOCIATE notebook`,g.uri.toString(),S),b.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(l,C,S){const b=this.i.get(l);if(!b)return;const g=this.m.getNotebookDocument(E.URI.revive(C)),d=[];for(const P of S){const N=g.getCell(P);N&&d.push(N.apiCell)}try{this.o.trace(`NotebookController[${l}] EXECUTE cells`,g.uri.toString(),d.length),await b.controller.executeHandler.call(b.controller,d,g.apiNotebook,b.controller)}catch(P){this.o.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,C,S){const b=this.i.get(l);if(!b)return;const g=this.m.getNotebookDocument(E.URI.revive(C));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,g.apiNotebook);else for(const d of S){const P=g.getCell(d);P&&this.b.get(P.uri)?.cancel()}if(b.controller.interruptHandler){const d=this.c.get(g.uri);S.length&&Array.isArray(d)&&d.length&&d.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(l,C,S){const b=this.i.get(l);if(!b)return;const g=this.m.getEditorById(C);b.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(l,C,S){const g=this.m.getNotebookDocument(E.URI.revive(l)).getCell(C);if(g){const d=S?y.NotebookCellExecutionState.to(S):k.NotebookCellExecutionState.Idle;d!==void 0&&this.k.fire({cell:g.apiCell,state:d})}}_createNotebookCellExecution(l,C){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this.m.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!b)throw new Error("invalid cell");if(this.b.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const g=new u(C,b,this.a);this.b.set(b.uri,g);const d=g.onDidChangeState(()=>{g.state===m.Resolved&&(g.dispose(),d.dispose(),this.b.delete(b.uri))});return g.asApiObject()}_createNotebookExecution(l,C){const S=this.m.getNotebookDocument(l.uri),b=l.getCells().find(P=>{const N=S.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if(b)throw new Error(`duplicate cell execution for ${b.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new n(C,S,this.a),d=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),d.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,d]),g.asApiObject()}};e.$8dc=o,e.$8dc=o=He([Be(4,L.$0i)],o);var m;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(m||(m={}));class u extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,C,S){super(),this.m=C,this.n=S,this.b=u.a++,this.c=new R.$Nd,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new f.$Xd),this.h=new c(10,b=>this.s(b)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const C=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new s.$qv(C))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let C=this.m;if(l&&(C=this.m.notebook.getCellFromApiCell(l)),!C)throw new Error("INVALID cell");return C.handle}y(l){return l.map(C=>{const S=k.$NL.ensureUniqueMimeTypes(C.items,!0);return S===C.items?y.NotebookCellOutput.from(C):y.NotebookCellOutput.from({items:S,id:C.id,metadata:C.metadata})})}async z(l,C,S){const b=this.w(C),g=this.y((0,D.$3b)(l));return this.r({editType:h.CellExecutionUpdateType.Output,cellHandle:b,append:S,outputs:g})}async C(l,C,S){return l=k.$NL.ensureUniqueMimeTypes((0,D.$3b)(l),!0),this.r({editType:h.CellExecutionUpdateType.OutputItems,items:l.map(y.NotebookCellOutputItem.from),outputId:C.id,append:S})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(S){l.j=S,l.s([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(S){if(l.f===m.Resolved||l.f===m.Started)throw new Error("Cannot call start again");l.f=m.Started,l.c.fire(),l.s({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,b){if(l.f===m.Resolved)throw new Error("Cannot call resolve twice");l.f=m.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new s.$qv({runEndTime:b,lastRunSuccess:S}))},clearOutput(S){return l.t(),l.z([],S,!1)},appendOutput(S,b){return l.t(),l.z(S,b,!0)},replaceOutput(S,b){return l.t(),l.z(S,b,!1)},appendOutputItems(S,b){return l.t(),l.C(S,b,!0)},replaceOutputItems(S,b){return l.t(),l.C(S,b,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,C,S){super(),this.h=C,this.j=S,this.b=n.a++,this.c=new R.$Nd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$Xd),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(l,C){this.e=l,this.f=C,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$ch,this.b=Date.now(),(0,T.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const C=this.a;return this.a=[],this.f(C).finally(()=>l.complete())}}function i(a,l){return`${a.value}/${l}`}e.$9dc=i}),define(De[323],Ce([1,0,4,6,144]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class R{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(T.$kK.MainThreadNotebookRenderers)}$postRendererMessage($,E,w){const L=this.c.getEditorById($);this.a.get(E)?.fire({editor:L.apiEditor,message:w})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,I,v)=>this.d(E).event(L,I,v),postMessage:(L,I)=>{f.$Sdc.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const v=I&&f.$Sdc.apiEditorsToExtHost.get(I);return this.b.$postMessage(v?.id,E,L)}}}d($){let E=this.a.get($);return E||(E=new D.$Nd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$0dc=R}),define(De[324],Ce([1,0,3,17,2,26,6]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class ${constructor(w){this.b=new Map,this.a=w.getProxy(A.$kK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,L,I){if((0,R.$hF)(w,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,I),this.a.$registerProfileContentHandler(L,I.name,I.description,w.identifier.value),(0,D.$Qc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(w,L,I,v){const y=this.b.get(w);if(!y)throw new Error(`Unknown handler with id: ${w}`);return y.saveProfile(L,I,v)}async $readProfile(w,L,I){const v=this.b.get(w);if(!v)throw new Error(`Unknown handler with id: ${w}`);return v.readProfile((0,T.$yf)(L)?L:f.URI.revive(L),I)}}e.$bec=$}),define(De[325],Ce([1,0,2,6,8,13]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class A{static{this.a=0}constructor(E,w){this.d=w,this.c=new Map,this.b=E.getProxy(T.$kK.MainThreadQuickDiff)}$provideOriginalResource(E,w,L){const I=D.URI.revive(w),v=this.c.get(E);return v?(0,f.$Mg)(()=>v.provideOriginalResource(I,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,w,L,I){const v=A.a++;return this.c.set(v,w),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(E,this.d),L,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$cec=A}),define(De[326],Ce([1,0,21,4,3,6,2,7,9,19,38,59,26,13]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;function k(p,h,r){const s=p.getProxy(R.$kK.MainThreadQuickOpen);class o{constructor(C,S){this.e=new Map,this.f=0,this.a=C,this.b=S}showQuickPick(C,S,b,g=D.CancellationToken.None){this.c=void 0;const d=Promise.resolve(S),P=++this.f,N=s.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},g),F={},M=N.then(()=>F);return Promise.race([M,d]).then(U=>{if(U===F)return;const j=(0,v.$gF)(C,"quickPickItemTooltip");return d.then(O=>{const K=[];for(let V=0;V<O.length;V++){const me=O[V];if(typeof me=="string")K.push({label:me,handle:V});else if(me.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:me.label});else{me.tooltip&&!j&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const te=me.iconPath?c(me.iconPath):void 0;K.push({label:me.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(me.tooltip):void 0,handle:V})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=V=>{b.onDidSelectItem(O[V])}),s.$setItems(P,K),N.then(V=>{if(typeof V=="number")return O[V];if(Array.isArray(V))return V.map(me=>O[me])})})}).then(void 0,U=>{if(!(0,E.$4)(U))return s.$setError(P,U),Promise.reject(U)})}$onItemSelected(C){this.c?.(C)}showInput(C,S=D.CancellationToken.None){return this.d=C?.validateInput,s.$input(C,typeof this.d=="function",S).then(void 0,b=>{if(!(0,E.$4)(b))return Promise.reject(b)})}async $validateInput(C){if(!this.d)return;const S=await this.d(C);if(!S||typeof S=="string")return S;let b;switch(S.severity){case $.InputBoxValidationSeverity.Info:b=L.default.Info;break;case $.InputBoxValidationSeverity.Warning:b=L.default.Warning;break;case $.InputBoxValidationSeverity.Error:b=L.default.Error;break;default:b=S.message?L.default.Error:L.default.Ignore;break}return{content:S.message,severity:b}}async showWorkspaceFolderPick(C,S=D.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!b)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(d=>d.uri.toString()===b.uri.toString())}createQuickPick(C){const S=new i(C,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(C){const S=new a(C,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(C,S){this.e.get(C)?._fireDidChangeValue(S)}$onDidAccept(C){this.e.get(C)?._fireDidAccept()}$onDidChangeActive(C,S){const b=this.e.get(C);b instanceof i&&b._fireDidChangeActive(S)}$onDidChangeSelection(C,S){const b=this.e.get(C);b instanceof i&&b._fireDidChangeSelection(S)}$onDidTriggerButton(C,S){this.e.get(C)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(C,S,b){const g=this.e.get(C);g instanceof i&&g._fireDidTriggerItemButton(S,b)}$onDidHide(C){this.e.get(C)?._fireDidHide()}}class m{static{this.a=1}constructor(C,S){this.x=C,this.y=S,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Nd,this.q=new T.$Nd,this.r=new T.$Nd,this.s=new T.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(C){this.b=C,this.z({title:C})}get step(){return this.c}set step(C){this.c=C,this.z({step:C})}get totalSteps(){return this.d}set totalSteps(C){this.d=C,this.z({totalSteps:C})}get enabled(){return this.g}set enabled(C){this.g=C,this.z({enabled:C})}get busy(){return this.j}set busy(C){this.j=C,this.z({busy:C})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(C){this.k=C,this.z({ignoreFocusOut:C})}get value(){return this.l}set value(C){this.l=C,this.z({value:C})}get placeholder(){return this.m}set placeholder(C){this.m=C,this.z({placeholder:C})}get buttons(){return this.n}set buttons(C){this.n=C.slice(),this.o.clear(),C.forEach((S,b)=>{const g=S===$.$GL.Back?-1:b;this.o.set(g,S)}),this.z({buttons:C.map((S,b)=>({...c(S.iconPath),tooltip:S.tooltip,handle:S===$.$GL.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(C){this.l=C,this.q.fire(C)}_fireDidTriggerButton(C){const S=this.o.get(C);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(C){if(!this.v){for(const S of Object.keys(C)){const b=C[S];this.u[S]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}function u(l){if(l instanceof $.$gL)return{id:l.id};const C=n(l),S=t(l);return{dark:typeof C=="string"?A.URI.file(C):C,light:typeof S=="string"?A.URI.file(S):S}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function n(l){return typeof l=="object"&&"dark"in l?l.dark:l}function c(l){const C=u(l);let S,b;return"id"in C?b=I.ThemeIcon.asClassName(C):S=C,{iconPath:S,iconClass:b}}class i extends m{constructor(C,S){super(C.identifier,S),this.O=C,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Nd,this.L=[],this.M=new T.$Nd,this.N=new T.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(C){this.B=C.slice(),this.C.clear(),this.D.clear(),C.forEach((g,d)=>{this.C.set(d,g),this.D.set(g,d)});const S=(0,v.$gF)(this.O,"quickPickItemTooltip"),b=[];for(let g=0;g<C.length;g++){const d=C[g];if(d.kind===$.QuickPickItemKind.Separator)b.push({type:"separator",label:d.label});else{d.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=d.iconPath?c(d.iconPath):void 0;b.push({handle:g,label:d.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((N,F)=>({...c(N.iconPath),tooltip:N.tooltip,handle:F}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(C){this.E=C,this.z({canSelectMany:C})}get matchOnDescription(){return this.F}set matchOnDescription(C){this.F=C,this.z({matchOnDescription:C})}get matchOnDetail(){return this.G}set matchOnDetail(C){this.G=C,this.z({matchOnDetail:C})}get sortByLabel(){return this.H}set sortByLabel(C){this.H=C,this.z({sortByLabel:C})}get keepScrollPosition(){return this.I}set keepScrollPosition(C){this.I=C,this.z({keepScrollPosition:C})}get activeItems(){return this.J}set activeItems(C){this.J=C.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(C){this.L=C.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(C){const S=(0,w.$Hb)(C.map(b=>this.C.get(b)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(C){const S=(0,w.$Hb)(C.map(b=>this.C.get(b)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(C,S){const b=this.C.get(C);if(!b||!b.buttons||!b.buttons.length)return;const g=b.buttons[S];g&&this.N.fire({button:g,item:b})}}class a extends m{constructor(C,S){super(C.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(C){this.B=C,this.z({password:C})}get prompt(){return this.C}set prompt(C){this.C=C,this.z({prompt:C})}get valueSelection(){return this.D}set valueSelection(C){this.D=C,this.z({valueSelection:C})}get validationMessage(){return this.E}set validationMessage(C){this.E=C,C?typeof C=="string"?this.z({validationMessage:C,severity:L.default.Error}):this.z({validationMessage:C.message,severity:C.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new o(h,r)}e.$ddc=k}),define(De[327],Ce([1,0,2,4,57,3,8,6,19,126,14,25,59,13,26,18]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0;function r(g){if(g)return typeof g.iconPath=="string"?D.URI.file(g.iconPath):D.URI.isUri(g.iconPath)||v.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function s(g){if(g.icon){if(D.URI.isUri(g.icon))return g.icon;if(v.ThemeIcon.isThemeIcon(g.icon))return g.icon;{const d=g.icon;return{light:d.light,dark:d.dark}}}else return}function o(g,d){if(!g.iconPath&&!d.iconPath)return 0;if(g.iconPath){if(!d.iconPath)return 1}else return-1;const P=typeof g.iconPath=="string"?g.iconPath:D.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,N=typeof d.iconPath=="string"?d.iconPath:D.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,w.$rq)(P,N)}function m(g,d){let P=0;if(g.strikeThrough!==d.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==d.faded)return g.faded?1:-1;if(g.tooltip!==d.tooltip)return(g.tooltip||"").localeCompare(d.tooltip||"");if(P=o(g,d),P!==0)return P;if(g.light&&d.light)P=o(g.light,d.light);else{if(g.light)return 1;if(d.light)return-1}if(P!==0)return P;if(g.dark&&d.dark)P=o(g.dark,d.dark);else{if(g.dark)return 1;if(d.dark)return-1}return P}function u(g,d){if(g.command!==d.command)return g.command<d.command?-1:1;if(g.title!==d.title)return g.title<d.title?-1:1;if(g.tooltip!==d.tooltip){if(g.tooltip!==void 0&&d.tooltip!==void 0)return g.tooltip<d.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(g.arguments===d.arguments)return 0;if(g.arguments)if(d.arguments){if(g.arguments.length!==d.arguments.length)return g.arguments.length-d.arguments.length}else return 1;else return-1;for(let P=0;P<g.arguments.length;P++){const N=g.arguments[P],F=d.arguments[P];if(N!==F)return N<F?-1:1}return 0}function t(g,d){let P=(0,w.$rq)(g.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(P!==0)return P;if(g.command&&d.command)P=u(g.command,d.command);else{if(g.command)return 1;if(d.command)return-1}if(P!==0)return P;if(g.decorations&&d.decorations)P=m(g.decorations,d.decorations);else{if(g.decorations)return 1;if(d.decorations)return-1}return P}function n(g,d){for(let P=0;P<g.length;P++)if(g[P]!==d[P])return!1;return!0}function c(g,d){return g.command===d.command&&g.title===d.title&&g.tooltip===d.tooltip&&(g.arguments&&d.arguments?n(g.arguments,d.arguments):g.arguments===d.arguments)}function i(g,d){return(0,E.$ub)(g,d,c)}function a(g,d){return g===d?!0:!g||!d?!1:g.id===d.id&&g.label===d.label&&g.upstream?.id===d.upstream?.id&&g.upstream?.label===d.upstream?.label}class l{#e;#t;get value(){return this.d}set value(d){d=d??"",this.#e.$setInputBoxValue(this.l,d),this.n(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){this.#e.$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,k.$hF)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,k.$hF)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,this.#e.$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,this.#e.$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,this.#e.$setInputBoxVisibility(this.l,d))}get document(){return(0,k.$hF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(d,P,N,F,M){this.k=d,this.l=F,this.m=M,this.d="",this.e=new T.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=N}showValidationMessage(d,P){(0,k.$hF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,d,P)}$onInputBoxValueChange(d){this.n(d)}n(d){this.d=d,this.e.fire(d)}}e.$edc=l;class C{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,P,N,F,M){this.q=d,this.s=P,this.t=N,this.u=F,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=C.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,P){const N=this.h.get(d);return N?(0,A.$Mg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(t),N=(0,E.$Db)(this.o,d,t).map(U=>{const j=U.toInsert.map(O=>{const K=this.e++;this.g.set(K,O);const V=O.resourceUri;let me;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const X=new R.$Rc;me=this.s.converter.toInternal(O.command,X),this.j.set(K,X)}else this.h.set(K,O.command);const te=r(O.decorations),G=O.decorations&&r(O.decorations.light)||te,Q=O.decorations&&r(O.decorations.dark)||te,le=[G,Q],ie=O.decorations&&O.decorations.tooltip||"",ce=O.decorations&&!!O.decorations.strikeThrough,pe=O.decorations&&!!O.decorations.faded,H=O.contextValue||"";return{rawResource:[K,V,le,ie,ce,pe,H,me],handle:K}});return{start:U.start,deleteCount:U.deleteCount,toInsert:j}}),F=N.map(({start:U,deleteCount:j,toInsert:O})=>[U,j,O.map(K=>K.rawResource)]),M=N.reverse();for(const{start:U,deleteCount:j,toInsert:O}of M){const K=O.map(me=>me.handle),V=this.n.splice(U,j,...K);for(const me of V)this.g.delete(me),this.h.delete(me),this.j.get(me)?.dispose(),this.j.delete(me)}return this.o=d,F}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,this.#e.$updateSourceControl(this.x,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let P;(0,k.$gF)(this.y,"quickDiffProvider")&&(P=d?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!d,quickDiffLabel:P})}get historyProvider(){return(0,k.$hF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(d){(0,k.$hF)(this.y,"scmHistoryProvider"),this.j=d,this.k.value=new R.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!d}),d&&(this.k.value.add(d.onDidChangeCurrentHistoryItemGroup(()=>{a(this.l,d?.currentHistoryItemGroup)||(this.l=d?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(d.onDidChangeActionButton(()=>{(0,k.$hF)(this.y,"scmActionButton"),this.m.value=new R.$Rc;const P=d.actionButton!==void 0?{command:this.z.converter.toInternal(d.actionButton.command,this.m.value),description:d.actionButton.description,enabled:d.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(d){d!==this.n&&(this.n=d,this.#e.$updateSourceControl(this.x,{commitTemplate:d}))}get acceptInputCommand(){return this.p}set acceptInputCommand(d){this.o.value=new R.$Rc,this.p=d;const P=this.z.converter.toInternal(d,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,k.$hF)(this.y,"scmActionButton"),this.s}set actionButton(d){(0,k.$hF)(this.y,"scmActionButton"),this.q.value=new R.$Rc,this.s=d;const P=d!==void 0?{command:this.z.converter.toInternal(d.command,this.q.value),secondaryCommands:d.secondaryCommands?.map(N=>N.map(F=>this.z.converter.toInternal(F,this.q.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(d){if(this.u&&d&&i(this.u,d))return;this.t.value=new R.$Rc,this.u=d;const P=(d||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(d,P,N,F,M,U,j){this.y=d,this.z=F,this.A=M,this.B=U,this.C=j,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Tc,this.m=new R.$Tc,this.n=void 0,this.o=new R.$Tc,this.p=void 0,this.q=new R.$Tc,this.t=new R.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=N;const O=D.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new l(d,P,this.#e,this.x,O),this.#e.$registerSourceControl(this.x,M,U,j,O)}createResourceGroup(d,P){const N=new C(this.#e,this.z,this.x,d,P),F=T.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const d=[],P=[];for(const[N,F]of this.D){F.dispose();const M=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.E.delete(N),M.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),d.push([N.handle,N.id,N.label,N.features]);const U=N._takeResourceStateSnapshot();U.length>0&&P.push([N.handle,U]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,d,P),this.D.clear()}eventuallyUpdateResourceStates(){const d=[];this.E.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&d.push([P.handle,N])}),d.length>0&&this.#e.$spliceResourceStates(this.x,d),this.E.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.v=d,this.w.fire(d)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$ih)(100)],S.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$ih)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(d,P,N,F){this.l=P,this.m=N,this.n=F,this.g=new Map,this.h=new I.$8l,this.j=new T.$Nd,this.e=d.getProxy($.$kK.MainThreadSCM),this.f=d.getProxy($.$kK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const U=this.g.get(M.sourceControlHandle);if(!U)return M;const j=U.getResourceGroup(M.groupHandle);return j?j.getResourceState(M.handle):M}else if(M&&M.$mid===4){const U=this.g.get(M.sourceControlHandle);return U?U.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const U=this.g.get(M.handle);return U||M}return M}})}createSourceControl(d,P,N,F){this.n.trace("ExtHostSCM#createSourceControl",d.identifier.value,P,N,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const M=h.d++,U=new S(d,this.m,this.e,this.l,P,N,F);this.g.set(M,U);const j=this.h.get(d.identifier)||[];return j.push(U),this.h.set(d.identifier,j),U}getLastInputBox(d){this.n.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const P=this.h.get(d.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(d,P,N){const F=D.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",d,F.toString());const M=this.g.get(d);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>M.quickDiffProvider.provideOriginalResource(F,N)).then(U=>U||null)}$onInputBoxValueChange(d,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",d);const N=this.g.get(d);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(d,P,N,F){this.n.trace("ExtHostSCM#$executeResourceCommand",d,P,N);const M=this.g.get(d);if(!M)return Promise.resolve(void 0);const U=M.getResourceGroup(P);return U?U.$executeResourceCommand(N,F):Promise.resolve(void 0)}$validateInput(d,P,N){this.n.trace("ExtHostSCM#$validateInput",d);const F=this.g.get(d);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>F.inputBox.validateInput(P,N)).then(M=>{if(!M)return Promise.resolve(void 0);const U=y.MarkdownString.fromStrict(M.message);return U?Promise.resolve([U,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(d,P,N){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupBase(P,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(d,P,N,F){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,N,F)??void 0}async $provideHistoryItems(d,P,N,F){return(await this.g.get(d)?.historyProvider?.provideHistoryItems(P,N,F))?.map(j=>({id:j.id,parentIds:j.parentIds,label:j.label,description:j.description,icon:s(j),timestamp:j.timestamp}))??void 0}async $provideHistoryItemChanges(d,P,N){return await this.g.get(d)?.historyProvider?.provideHistoryItemChanges(P,N)??void 0}};e.$fdc=b,e.$fdc=b=h=He([Be(3,L.$0i)],b)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;class R{constructor($){this.b=new T.$Nd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(D.$kK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,w){return this.a.$setPassword($,E,w)}delete($,E){return this.a.$deletePassword($,E)}}e.$Wcc=R,e.$Xcc=(0,f.$Ph)("IExtHostSecretState")}),define(De[328],Ce([1,0,6,13,2]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class R{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(D.$kK.MainThreadShare)}async $provideShare($,E,w){return await this.c.get($)?.provideShare({selection:T.Range.to(E.selection),resourceUri:f.URI.revive(E.resourceUri)},w)??void 0}registerShareProvider($,E){const w=R.a++;return this.c.set(w,E),this.b.$registerShareProvider(w,T.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$hec=R}),define(De[329],Ce([1,0,21,3,6]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class R{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(f.$kK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const w=this.c.get($);if(!w)return;const L=new T.$Rc,I=new D.$Xd;this.d.set(E,I);const v=L.add(w.provideSpeechToTextSession(I.token));L.add(v.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),L.add(I.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,w){const L=R.a++;return this.c.set(L,w),this.b.$registerProvider(L,E,{extension:$,displayName:$.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$jec=R}),define(De[330],Ce([1,0,7,6,210,3,13,17]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$hL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$hL("statusBarItem.warningForeground")]])}#e;#t;constructor(v,y,k,p,h,r=D.StatusBarAlignment.Left,s){if(this.i=!1,this.k="",this.q=new R.$Rc,this.#e=v,this.#t=y,h&&p){this.c=(0,D.$WK)(p.identifier,h);const o=k.get(this.c);o&&(r=o.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,s=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=h,this.g=r,this.h=this.u(s)}u(v){if((0,$.$Cf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!E.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new R.$Rc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let y;this.m?y=this.m:y=(0,f.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,y,this.k,p,this.r?.internal,k,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$gdc=E;class w{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const y={message:v};return this.b.unshift(y),this.c(),new D.$mK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(v,y){this.e=new Map,this.a=v.getProxy(T.$kK.MainThreadStatusBar),this.b=y,this.c=new w(this)}$acceptStaticEntries(v){for(const y of v)this.e.set(y.entryId,y)}createStatusBarEntry(v,y,k,p){return new E(this.a,this.b,this.e,v,y,k,p)}setStatusBarMessage(v,y){const k=this.c.setMessage(v);let p;return typeof y=="number"?p=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new D.$mK(()=>{k.dispose(),clearTimeout(p)})}}e.$hdc=L}),define(De[115],Ce([1,0,6,4,5]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0;class R{constructor($,E){this.c=E,this.b=new T.$Nd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(D.$kK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,w){const L=await this.a.$initializeExtensionStorage($,E);let I;return L&&(I=this.d($,E,L)),I||w}setValue($,E,w){return this.a.$setValue($,E,w)}$acceptValue($,E,w){const L=this.d($,E,w);L&&this.b.fire({shared:$,key:E,value:L})}d($,E,w){try{return JSON.parse(w)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${L}`)}}}e.$Kcc=R,e.$Lcc=(0,f.$Ph)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,D.$Ph)("IExtensionStoragePaths");let $=class{constructor(w,L,I){this.d=L,this.f=I,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,L=await this.g(w);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(A.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Rcc=$,e.$Rcc=$=He([Be(0,T.$BM),Be(1,f.$0i),Be(2,R.$Pcc)],$)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,212,9,254,21,31,255,59,8,13,34]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=e.$Tcc=e.$Scc=void 0,e.$Scc=(0,f.$Ph)("IExtHostTerminalService");class o{constructor(b,g,d,P){this.l=b,this._id=g,this.m=d,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(F=>this.f=F);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(F,M=!0){N.q(),N.l.$sendText(N._id,F,M)},show(F){N.q(),N.l.$show(N._id,F)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(b,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??void 0,env:b.env??void 0,icon:a(b.iconPath)??void 0,color:p.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(b.location,g?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,g,d,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:d,color:p.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(b,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,g){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in b?{viewColumn:r.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,g){this.h=Object.freeze({code:b,reason:g})}setDimensions(b,g){return b===this.d&&g===this.g||b===0||g===0?!1:(this.d=b,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(g=>{g!==b&&(this.b=Promise.resolve(b))})}}e.$Tcc=o;class m{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new D.$Nd,this.onProcessData=this.a.event,this.b=new D.$Nd,this.d=new D.$Nd,this.onDidChangeProperty=this.d.event,this.f=new D.$Nd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,g){this.g.setDimensions?.({columns:b,rows:g})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends $.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,g,d){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Nd,this.onDidChangeShell=this.N.event,this.O=new D.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=d.getProxy(T.$kK.MainThreadTerminalService),this.y=new k.$Ykb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const N=F=>{const M=F;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=N(P[F]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,g){const d=new o(this.a,(0,y.$eg)(),b,b.name),P=new m(b.pty);return d.createExtensionTerminal(b.location,this.R(b,g).resolvedExtHostIdentifier,a(b.iconPath),l(b.color)).then(N=>{const F=this.S(N,P);this.h[N]=F}),this.f.push(d),d.value}R(b,g){if(g=g||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const d=b.location.parentTerminal;if(d){const P=this.f.find(N=>N.value===d);P&&(g.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?g.location=b.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(b,g){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new m(g),N=this.S(b,P);this.h[b]=N}async $acceptActiveTerminalChanged(b){const g=this.b;if(b===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const d=this.W(b);d&&(this.b=d,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,g){const d=this.W(b);d&&this.O.fire({terminal:d.value,data:g})}async $acceptTerminalDimensions(b,g,d){const P=this.W(b);P&&P.setDimensions(g,d)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,g){const d=this.W(b);d&&this.P.fire({terminal:d.value,...g})}async $acceptTerminalMaximumDimensions(b,g,d){this.g.get(b)?.resize(g,d)}async $acceptTerminalTitleChange(b,g){const d=this.W(b);d&&(d.name=g)}async $acceptTerminalClosed(b,g,d){const P=this.Y(this.f,b);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(g,d),this.H.fire(N.value)}}$acceptTerminalOpened(b,g,d,P){if(g){const M=this.Y(this.f,g);if(M!==null){this.f[M]._id=b,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new o(this.a,b,N,d);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(b,g){this.W(b)?._setProcessId(g)}async $startExtensionTerminal(b,g){const d=this.W(b);if(!d)return{message:(0,w.localize)(0,null,b)};d.isOpen||await new Promise(N=>{const F=this.onDidOpenTerminal(async M=>{M===d.value&&(F.dispose(),N())})});const P=this.g.get(b);P?P.startSendingEvents(g):this.j[b]={initialDimensions:g}}S(b,g){const d=new $.$Rc;d.add(g.onProcessReady(N=>this.a.$sendProcessReady(b,N.pid,N.cwd,N.windowsPty))),d.add(g.onDidChangeProperty(N=>this.a.$sendProcessProperty(b,N))),this.y.startBuffering(b,g.onProcessData),d.add(g.onProcessExit(N=>this.U(b,N))),this.g.set(b,g);const P=this.j[b];return P&&g instanceof m&&(g.startSendingEvents(P.initialDimensions),delete this.j[b]),d}$acceptProcessAckDataEvent(b,g){this.g.get(b)?.acknowledgeDataEvent(g)}$acceptProcessInput(b,g){this.g.get(b)?.input(g)}$acceptTerminalInteraction(b){const g=this.W(b);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(b,g){this.W(b)?.setSelection(g)}$acceptProcessResize(b,g,d){try{this.g.get(b)?.resize(g,d)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,g){this.g.get(b)?.shutdown(g)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(g=>this.a.$sendProcessProperty(b,{type:"cwd",value:g}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new E.$mK(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,g,d){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,d),this.a.$registerProfileProvider(g,b.identifier.value),new E.$mK(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(b,g,d){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,d),this.a.$registerQuickFixProvider(b,g),new E.$mK(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,g){const d=new v.$Xd().token;if(d.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const N=await P.provideTerminalQuickFixes(g,d);if(N===null||Array.isArray(N)&&N.length===0)return;const F=new $.$Rc;if(this.w.value=F,!Array.isArray(N))return N?r.TerminalQuickFix.from(N,this.Q.converter,F):void 0;const M=[];for(const U of N){const j=r.TerminalQuickFix.from(U,this.Q.converter,F);j&&M.push(j)}return M}async $createContributedProfileTerminal(b,g){const d=new v.$Xd().token;let P=await this.C.get(b)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(b,g){const d=this.W(b);if(!d)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const N=new v.$Xd;this.G.set(b,N);const F=[],M={terminal:d.value,line:g},U=[];for(const K of this.z)U.push(h.Promises.withAsyncBody(async V=>{N.token.onCancellationRequested(()=>V({provider:K,links:[]}));const me=await K.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||V({provider:K,links:me})}));const j=await Promise.all(U);if(N.token.isCancellationRequested)return[];const O=new Map;for(const K of j)K&&K.links.length>0&&F.push(...K.links.map(V=>{const me={id:u++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return O.set(me.id,{provider:K.provider,link:V}),me}));return this.F.set(b,O),F}$activateLink(b,g){const d=this.F.get(b)?.get(g);d&&d.provider.handleTerminalLink(d.link)}U(b,g){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const d=this.h[b];d&&(d.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,g)}W(b){return this.X(this.f,b)}X(b,g){const d=this.Y(b,g);return d!==null?b[d]:null}Y(b,g){const d=b.findIndex(P=>P._id===g);return d===-1?null:d}getEnvironmentVariableCollection(b){let g=this.n.get(b.identifier.value);return g||(g=new n,this.$(b.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(b,g){const d=(0,I.$kr)(g.map),P=(0,I.$lr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(b,g.persistent,d.length===0?void 0:d,P)}$initEnvironmentVariableCollections(b){b.forEach(g=>{const d=g[0],P=new n(g[1]);this.$(d,P)})}$acceptDefaultProfile(b,g){const d=this.s;this.s=b,this.u=g,d?.path!==b.path&&this.N.fire(b.path)}$(b,g){this.n.set(b,g),g.onDidChangeCollection(()=>{this.Z(b,g)})}};e.$Ucc=t,e.$Ucc=t=He([Be(1,s.$HM),Be(2,A.$lM)],t);class n{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Nd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const g=this.h(b);let d=this.a.get(g);return d||(d=new c(this,b),this.a.set(g,d),d.onDidChangeCollection(()=>this.d.fire())),d}replace(b,g,d,P){this.f(b,{value:g,type:E.EnvironmentVariableMutatorType.Replace,options:d??{applyAtProcessCreation:!0},scope:P})}append(b,g,d,P){this.f(b,{value:g,type:E.EnvironmentVariableMutatorType.Append,options:d??{applyAtProcessCreation:!0},scope:P})}prepend(b,g,d,P){this.f(b,{value:g,type:E.EnvironmentVariableMutatorType.Prepend,options:d??{applyAtProcessCreation:!0},scope:P})}f(b,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const d=this.g(b,g.scope),P=this.map.get(d),N=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==g.value||P.type!==g.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const F=this.g(b,g.scope),M={variable:b,...g,options:N};this.map.set(F,M),this.d.fire()}}get(b,g){const d=this.g(b,g),P=this.map.get(d);return P?C(P):void 0}g(b,g){const d=this.h(g);return d.length?`${b}:::${d}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const g=new Map;for(const[d,P]of this.map)this.h(P.scope)===this.h(b)&&g.set(P.variable,C(P));return g}delete(b,g){const d=this.g(b,g);this.map.delete(d),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[g,d]of this.map)d.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(g);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,g){const d=this.h(g),P=this.descriptionMap.get(d);if(!P||P.description!==b){let N;typeof b=="string"?N=b:N=b?.value.split(`

`)[0];const F={description:N,scope:g};this.descriptionMap.set(d,F),this.d.fire()}}getDescription(b){const g=this.h(b);return this.descriptionMap.get(g)?.description}k(b){const g=this.h(b);this.descriptionMap.delete(g)}}class c{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,g){this.b=b,this.d=g,this.a=new D.$Nd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,g,d){this.b.replace(b,g,d,this.d)}append(b,g,d){this.b.append(b,g,d,this.d)}prepend(b,g,d){this.b.prepend(b,g,d,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,g){this.b.getVariableMap(this.d).forEach((d,P)=>b.call(g,P,d,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(b,g){super(!1,b,g)}createTerminal(b,g,d){throw new L.$_}createTerminalFromOptions(b,g){throw new L.$_}};e.$Vcc=i,e.$Vcc=i=He([Be(0,s.$HM),Be(1,A.$lM)],i);function a(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function l(S){return p.ThemeColor.isThemeColor(S)?S:void 0}function C(S){const b={...S};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(De[331],Ce([1,0,118,8,22,21,4,75,52,3,24,17,31,6,20,145,13,7,68,109,87]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=e.$4dc=e.$3dc=void 0;let u=class{constructor(F,M,U){this.j=U,this.c=new A.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=F.getProxy(y.$kK.MainThreadTesting),this.h=new g(this.f),this.g=new i(this.f),M.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const O=j,K=O.tests[O.tests.length-1].item.extId;return this.d.get(s.$dJ.root(K))?.collection.tree.get(K)?.actual??(0,p.$xM)(j)}case 18:{const{extId:O,message:K}=j;return{test:this.d.get(s.$dJ.root(O))?.collection.tree.get(O)?.actual,message:h.TestMessage.to(K)}}default:return j}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await M.executeCommand("_testing.getExplorerSelection"),O=K=>{const V=this.d.get(s.$dJ.root(K));if(V)return s.$dJ.isRoot(K)?V.controller:V.collection.tree.get(K)?.actual};return{include:j?.include.map(O).filter(I.$Gf)||[],exclude:j?.exclude.map(O).filter(I.$Gf)||[]}})}createTestController(F,M,U,j){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const O=new w.$Rc,K=O.add(new p.$AM(M,U,this.j));K.root.label=U;const V=new Map,me=this.f,te={items:K.root.children,get label(){return U},set label(Q){U=Q,K.root.label=Q,me.$updateController(M,{label:U})},get refreshHandler(){return j},set refreshHandler(Q){j=Q,me.$updateController(M,{canRefresh:!!Q})},get id(){return M},createRunProfile:(Q,le,ie,ce,pe,H)=>{let B=(0,E.$Di)(Q);for(;V.has(B);)B++;return new d(this.f,V,M,B,Q,le,ie,ce,pe,H)},createTestItem(Q,le,ie){return new p.$yM(M,Q,le,ie)},createTestRun:(Q,le,ie=!0)=>this.g.createTestRun(F,M,K,Q,le,ie),invalidateTestResults:Q=>{if(Q===void 0)this.f.$markTestRetired(void 0);else{const le=Q instanceof Array?Q:[Q];this.f.$markTestRetired(le.map(ie=>s.$dJ.fromExtHostTestItem(ie,M).toString()))}},set resolveHandler(Q){K.resolveHandler=Q},get resolveHandler(){return K.resolveHandler},dispose:()=>{O.dispose()}};me.$registerTestController(M,U,!!j),O.add((0,w.$Qc)(()=>me.$unregisterTestController(M)));const G={controller:te,collection:K,profiles:V,extension:F};return this.d.set(M,G),O.add((0,w.$Qc)(()=>this.d.delete(M))),O.add(K.onDidGenerateDiff(Q=>me.$publishDiff(M,Q.map(m.TestsDiffOp.serialize)))),te}createTestObserver(){return this.h.checkout()}async runTests(F,M=R.CancellationToken.None){const U=a(F);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(O=>s.$dJ.fromExtHostTestItem(O,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:P[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:F.exclude?.map(O=>O.id)},M)}$syncTests(){for(const{collection:F}of this.d.values())F.flushDiff();return Promise.resolve()}$provideFileCoverage(F,M,U){return(0,D.$rb)(this.g.trackers,O=>O.id===F?O.getCoverage(M):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(F,M,U,j){return(0,D.$rb)(this.g.trackers,K=>K.id===F?K.getCoverage(M):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(F,M){this.d.get(F)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(F,M){await this.d.get(F)?.controller.refreshHandler?.(M)}$publishTestResults(F){this.results=Object.freeze(F.map(M=>(0,L.$8m)(h.TestResults.to(M))).concat(this.results).sort((M,U)=>U.completedAt-M.completedAt).slice(0,32)),this.c.fire()}async $expandTest(F,M){const U=this.d.get(s.$dJ.fromString(F).controllerId)?.collection;U&&(await U.expand(F,M<0?1/0:M),U.flushDiff())}$acceptDiff(F){this.h.applyDiff(F.map(m.TestsDiffOp.deserialize))}async $runControllerTests(F,M){return Promise.all(F.map(U=>this.k(U,!1,M)))}async $startContinuousRun(F,M){const U=new R.$Xd(M),j=await Promise.all(F.map(O=>this.k(O,!0,U.token)));return!M.isCancellationRequested&&!j.some(O=>O.error)&&await new Promise(O=>M.onCancellationRequested(O)),U.dispose(!0),j}async k(F,M,U){const j=this.d.get(F.controllerId);if(!j)return{};const{collection:O,profiles:K,extension:V}=j,me=K.get(F.profileId);if(!me)return{};const te=F.testIds.map(ie=>O.tree.get(ie)).filter(I.$Gf),G=F.excludeExtIds.map(ie=>j.collection.tree.get(ie)).filter(I.$Gf).filter(ie=>te.some(ce=>ce.fullId.compare(ie.fullId)===2));if(!te.length)return{};const Q=new r.$UL(te.some(ie=>ie.actual instanceof p.$zM)?void 0:te.map(ie=>ie.actual),G.map(ie=>ie.actual),me,M),le=(0,m.$fJ)(F)&&this.g.prepareForMainThreadTestRun(Q,l.fromInternal(F,j.collection),V,U);try{return await me.runHandler(Q,U),{}}catch(ie){return{error:String(ie)}}finally{le&&(le.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.g.cancelAllRuns():this.g.cancelRunById(F)}};e.$3dc=u,e.$3dc=u=He([Be(0,k.$lM)],u);const t=1e4;var n;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(n||(n={}));class c extends w.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(F,M,U){super(),this.m=F,this.s=M,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Nd),this.onEnd=this.j.event,this.h=this.B(new R.$Xd(U));const j=this.B(new T.$6g(()=>this.u(),t));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(F){return this.f.get(F)?.coverage}createRun(F){const M=this.m.id,U=this.m.controllerId,j=(0,v.$eg)(),O=new C(this.s,M,j),K=G=>(Q,...le)=>{if(me){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.m.isIncluded(Q)&&(this.y(Q),G(Q,...le))},V=(G,Q)=>{const le=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(G.uri&&G.range){const ie={range:h.Range.from(G.range),uri:G.uri};for(const ce of le)ce.location=ce.location||ie}this.s.$appendTestMessagesInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),le)};let me=!1;const te={isPersisted:this.m.isPersisted,token:this.h.token,name:F,get coverageProvider(){return O.coverageProvider},set coverageProvider(G){O.coverageProvider=G},enqueued:K(G=>{this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),1)}),skipped:K(G=>{this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),5)}),started:K(G=>{this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),2)}),errored:K((G,Q,le)=>{V(G,Q),this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),6,le)}),failed:K((G,Q,le)=>{V(G,Q),this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,U).toString(),4,le)}),passed:K((G,Q)=>{this.s.$updateTestStateInRun(M,j,s.$dJ.fromExtHostTestItem(G,this.m.controllerId).toString(),3,Q)}),appendOutput:(G,Q,le)=>{me||(le&&(this.m.isIncluded(le)?this.y(le):le=void 0),this.s.$appendOutputToRun(M,j,f.$be.fromString(G),Q&&h.location.from(Q),le&&s.$dJ.fromExtHostTestItem(le,U).toString()))},end:()=>{me||(me=!0,this.s.$finishedTestRunTask(M,j),this.f.delete(j),this.f.size||this.w())}};return this.f.set(j,{run:te,coverage:O}),this.s.$startedTestRunTask(M,{id:j,name:F,running:!0}),te}u(){for(const{run:F}of this.f.values())F.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(F){if(!(F instanceof p.$yM))throw new o.$dM(F.id);if(this.g.has(s.$dJ.fromExtHostTestItem(F,this.m.controllerId).toString()))return;const M=[],U=this.m.colllection.root;for(;;){const j=h.TestItem.from(F);if(M.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),F===U))break;F=F.parent||U}this.s.$addTestsToRun(this.m.controllerId,this.m.id,M)}dispose(){this.w(),super.dispose()}}class i{get trackers(){return this.c.values()}constructor(F){this.d=F,this.c=new Map}prepareForMainThreadTestRun(F,M,U,j){return this.f(F,M,U,j)}cancelRunById(F){for(const M of this.c.values())if(M.id===F){M.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,M,U,j,O,K){const V=this.c.get(j);if(V)return V.createRun(O);const me=l.fromPublic(M,U,j,K),te=a(j);this.d.$startedExtensionTestRun({controllerId:M,continuous:!!j.continuous,profile:te&&{group:P[te.kind],id:te.profileId},exclude:j.exclude?.map(Q=>s.$dJ.fromExtHostTestItem(Q,U.root.id).toString())??[],id:me.id,include:j.include?.map(Q=>s.$dJ.fromExtHostTestItem(Q,U.root.id).toString())??[U.root.id],persist:K});const G=this.f(j,me,F);return A.Event.once(G.onEnd)(()=>{this.d.$finishedExtensionTestRun(me.id),G.dispose()}),G.createRun(O)}f(F,M,U,j){const O=new c(M,this.d,j);return this.c.set(F,O),A.Event.once(O.onEnd)(()=>this.c.delete(F)),O}}e.$4dc=i;const a=N=>{if(N.profile){if(!(N.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class l{static fromPublic(F,M,U,j){return new l(F,(0,v.$eg)(),U.include?.map(O=>s.$dJ.fromExtHostTestItem(O,F).toString())??[F],U.exclude?.map(O=>s.$dJ.fromExtHostTestItem(O,F).toString())??[],j,M)}static fromInternal(F,M){return new l(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,M)}constructor(F,M,U,j,O,K){this.controllerId=F,this.id=M,this.isPersisted=O,this.colllection=K,this.c=U.map(V=>V+"\0"),this.d=j.map(V=>V+"\0")}isIncluded(F){const M=s.$dJ.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const U of this.d)if(M===U||M.startsWith(U))return!1;for(const U of this.c)if(M===U||M.startsWith(U))return!0;return!1}}e.$5dc=l;class C{set coverageProvider(F){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");F&&(this.c=F,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(F,M,U){this.f=F,this.g=M,this.h=U}async provideFileCoverage(F){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(F))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(M){throw this.d=void 0,M}}async resolveFileCoverage(F,M){const U=await this.d;let j=U?.[F];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[F]=await this.c.resolveFileCoverage?.(j,M)??j),j.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(F){this.h=F,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,h.TestItem.toPlain(F.item)),this.c.has(F)||this.d.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.d.delete(F);const M=s.$dJ.parentId(F.item.extId);if(M&&this.g.has(M.toString())){this.g.add(F.item.extId);return}this.f.add(F)}getChangeEvent(){const{c:F,d:M,f:U}=this;return{get added(){return[...F].map(j=>j.revived)},get updated(){return[...M].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends m.$kJ{constructor(){super(...arguments),this.q=new A.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(F){return this.d.get(F)}getMirroredTestDataByReference(F){return this.d.get(F.id)}p(F,M){return{...F,revived:h.TestItem.toPlain(F.item),depth:M?M.depth+1:0,children:new Set}}o(){return new S(this.q)}}class g{constructor(F){this.d=F}checkout(){this.c||(this.c=this.f());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(M=>M.revived)},dispose:(0,$.$db)(()=>{--F.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}f(){const F=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:F}}}class d{#e;#t;get label(){return this.d}set label(F){F!==this.d&&(this.d=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:F}))}get isDefault(){return this.f}set isDefault(F){F!==this.f&&(this.f=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?h.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}constructor(F,M,U,j,O,K,V,me=!1,te=void 0,G=!1){this.controllerId=U,this.profileId=j,this.d=O,this.kind=K,this.runHandler=V,this.f=me,this._tag=te,this.g=G,this.#e=F,this.#t=M,M.set(j,this);const Q=P[K];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);this.#e.$publishTestRunProfile({profileId:j,controllerId:U,tag:te?h.TestTag.namespace(this.controllerId,te.id):null,label:O,group:Q,isDefault:me,hasConfigurationHandler:!1,supportsContinuousRun:G})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$6dc=d;const P={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(De[332],Ce([1,0,19,9,4,6,146,13,7]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class w{constructor(I,v){this.i=v,this.a=new f.$Nd({onListenerError:T.$2}),this.b=new f.$Nd({onListenerError:T.$2}),this.c=new f.$Nd({onListenerError:T.$2}),this.d=new f.$Nd({onListenerError:T.$2}),this.f=new f.$Nd({onListenerError:T.$2}),this.g=new f.$Nd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(R.$kK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const v=this.i.allEditors();return I?v:v.map(y=>y.value)}async showTextDocument(I,v,y){let k;typeof v=="number"?k={position:$.ViewColumn.from(v),preserveFocus:y}:typeof v=="object"?k={position:$.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?$.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:k={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,k),h=p&&this.i.getEditor(p);if(h)return h.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,v){return new A.$sM(this.h,I,v).value}$acceptEditorPropertiesChanged(I,v){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if(v.options&&y._acceptOptions(v.options),v.selections){const k=v.selections.selections.map($.Selection.to);y._acceptSelections(k)}if(v.visibleRanges){const k=D.$Hb(v.visibleRanges.map($.Range.to));y._acceptVisibleRanges(k)}if(v.options&&this.b.fire({textEditor:y.value,options:{...v.options,lineNumbers:$.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const k=E.TextEditorSelectionChangeKind.fromValue(v.selections.source),p=v.selections.selections.map($.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:k})}if(v.visibleRanges){const k=D.$Hb(v.visibleRanges.map($.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(I){for(const v in I){const y=this.i.getEditor(v);if(!y)throw new Error("Unknown text editor");const k=$.ViewColumn.to(I[v]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$idc=w}),define(De[333],Ce([1,0,2,5,6,3,7,13,25,17]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0,e.$Wdc=(0,T.$Ph)("IExtHostTimeline");class L{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$kK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(p,h)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$6l.equals(h,this.b.get(p.source)?.extension)){const r=p.uri===void 0?void 0:D.URI.revive(p.uri);return this.c.get(p.source)?.get(I(r))?.get(p.handle)}else return;return p}})}async $getTimeline(y,k,p,h){return this.b.get(y)?.provider.provideTimeline(D.URI.revive(k),p,h)}registerTimelineProvider(y,k,p,h){const r=new R.$Rc,s=this.d(k.id,h,r).bind(this);let o;k.onDidChange&&(o=k.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:k.id}),this));const m=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(u,t,n){t?.resetCache&&(r.clear(),m.get(k.id)?.clear());const c=await k.provideTimeline(u,t,n);if(c==null)return;const i=s(u,t);return{...c,source:k.id,items:c.items.map(i)}},dispose(){for(const u of m.values())u.get(k.id)?.clear();o?.dispose(),r.dispose()}},p)}d(y,k,p){return(h,r)=>{let s;if(r?.cacheResults){let o=this.c.get(y);o===void 0&&(o=new Map,this.c.set(y,o));const m=I(h);s=o.get(m),s===void 0&&(s=new Map,o.set(m,s))}return o=>{const{iconPath:m,...u}=o,t=`${y}|${o.id??o.timestamp}`;s?.set(t,o);let n,c,i;o.iconPath&&(m instanceof A.$gL?i={id:m.id,color:m.color}:D.URI.isUri(m)?(n=m,c=m):{light:n,dark:c}=m);let a;return A.$MK.isMarkdownString(u.tooltip)?a=$.MarkdownString.from(u.tooltip):(0,w.$yf)(u.tooltip)?a=u.tooltip:A.$MK.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=$.MarkdownString.from(u.detail)):(0,w.$yf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=u.detail),{...u,id:u.id??void 0,handle:t,source:y,command:o.command?k.toInternal(o.command,p):void 0,icon:n,iconDark:c,themeIcon:i,tooltip:a,accessibilityInformation:o.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,R.$Qc)(()=>{for(const h of this.c.values())h.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Xdc=L;function I(v){return v?.toString()}}),define(De[73],Ce([1,0,21,4,3,214,5,14,86,6,27,20,7]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cwb=e.$bwb=e.TunnelDtoConverter=void 0;class y extends E.$gv{}var k;(function(h){function r(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:o.protocol}}h.fromApiTunnel=r;function s(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==E.TunnelPrivacyId.ConstantPrivate&&o.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}h.fromServiceTunnel=s})(k||(e.TunnelDtoConverter=k={})),e.$bwb=(0,A.$Ph)("IExtHostTunnelService");let p=class extends f.$Sc{constructor(r,s,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(w.$kK.MainThreadTunnelService)}async openTunnel(r,s){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const o=await this.a.$openTunnel(s,r.displayName);if(o){const m=new y(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,s){const o=this.u();return this.r.set(o,{selector:r,provider:s}),this.a.$registerPortsAttributesProvider(r,o),new v.$mK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(r,s,o,m,u){const t=[];for(const c of r){const i=this.r.get(c);if(!i)return[];t.push(...await Promise.all(s.map(async a=>{let l;try{l=await i.provider.providePortAttributes({port:a,pid:o,commandLine:m},u)}catch{l=await i.provider.providePortAttributes(a,o,m,u)}return{providedAttributes:l,port:a}})))}const n=t.filter(c=>!!c.providedAttributes);return n.length>0?n.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,u)=>await r.provideTunnel(m,u,new D.$Xd().token)??void 0;const o=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,f.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,s){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const o=r.tunnelFactory??(s?this.w(s):void 0);if(o){this.b=o;let m=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const u=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,f.$Qc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,s){if(this.g.has(r.host)){const o=this.g.get(r.host);o.has(r.port)&&(s&&o.get(r.port).disposeListener.dispose(),await o.get(r.port).tunnel.dispose(),o.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,s){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(r,s);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const m=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const u=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:m,disposeListener:u}),k.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(r){const s=await Promise.all(r.map(m=>this.f(m.host,m.port,m.detail??""))),o=r.filter((m,u)=>s[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(m=>m.port).join(", ")} to ${o.map(m=>m.port).join(", ")}`),o}};e.$cwb=p,e.$cwb=p=He([Be(0,I.$lM),Be(1,L.$BM),Be(2,$.$0i)],p)}),define(De[334],Ce([1,0,3,18,2,6]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(R.$kK.MainThreadUriOpeners)}registerExternalUriOpener(E,w,L,I){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const v=I.schemes.find(y=>!A.a.has(y));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(w,L),this.b.$registerUriOpener(w,I.schemes,E,I.label),(0,D.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(E,w,L){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const v=f.URI.revive(w);return I.canOpenExternalUri(v,L)}async $openUri(E,w,L){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(f.URI.revive(w.resolvedUri),{sourceUri:f.URI.revive(w.sourceUri)},L)}}e.$7dc=A}),define(De[335],Ce([1,0,6,2,3,9,25]),function($e,e,D,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class ${static{this.a=0}constructor(w){this.c=new A.$7l,this.d=new Map,this.b=w.getProxy(D.$kK.MainThreadUrls)}registerUriHandler(w,L){const I=w.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const v=$.a++;return this.c.add(I),this.d.set(v,L),this.b.$registerUriHandler(v,I,w.displayName||w.name),(0,f.$Qc)(()=>{this.c.delete(I),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(w,L){const I=this.d.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(L))}catch(v){(0,R.$1)(v)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$kdc=$}),define(De[91],Ce([1,0,4,3,18,24,2,229,266,110,6]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=e.$ndc=e.$mdc=e.$ldc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,u,t,n,c,i,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Nd,this._onDidDispose=this.#h.event,this.#e=m,this.#t=u,this.#r=t,this.#l=n,this.#u=c,this.#n=i,this.#c=v(i),this.#d=y(i),this.#i=a}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.$cpb)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===f.Schemas.https||m.scheme===f.Schemas.http){let u=m.toString();return u.endsWith("/")||(u+="/"),u+" "+w.$bpb}return w.$bpb}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),R.$$m(this.#r,m)||this.#t.$setOptions(this.#e,h(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const u=(0,E.$Dcb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const u=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,c,i,a,l,C)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),b=(0,w.$cpb)(S,{isRemote:u,authority:t}).toString();return`${c}${b}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,c,i,a,l,C)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),b=(0,w.$cpb)(S,{isRemote:u,authority:t}).toString();return`${c}${b}${C}`})}}e.$ldc=I;function v(o){try{const m=(0,$.$No)((0,$.$Mo)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$mdc=v;function y(o){try{const m=(0,$.$No)((0,$.$Mo)(o.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class k extends T.$Sc{constructor(m,u,t,n,c){super(),this.c=u,this.f=t,this.g=n,this.h=c,this.b=new Map,this.a=m.getProxy(L.$kK.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,u,t){const n=this.j(m);if(n){const{message:c}=(0,E.$Ecb)(u,t.value);n._onMessageEmitter.fire(c)}}$onMissingCsp(m,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,u,t){const n=new I(m,this.a,r(u),this.c,this.f,t,this.h);this.b.set(m,n);const c=n._onDidDispose(()=>{c.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$ndc=k;function p(o){return{id:o.identifier,location:o.extensionLocation}}e.$odc=p;function h(o,m,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||s(o,m)}}e.$pdc=h;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>A.URI.from(m))}}function s(o,m){return[...(m?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(De[336],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class y{constructor(n,c){this.document=n,this.b=c,this.a=1,this.c=new L.$hcc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,c){await this.f(n).undo(),c||this.disposeBackup()}async redo(n,c){await this.f(n).redo(),c||this.disposeBackup()}disposeEdits(n){for(const c of n)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=u(this.document.uri)+this.a++;return(0,A.$vg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const c=this.c.get(n,0);if(!c)throw new Error("No edit found");return c}}class k{constructor(){this.a=new Map}get(n,c){return this.a.get(this.b(n,c))}add(n,c,i){const a=this.b(n,c.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${n} resource:${c.uri}`);const l=new y(c,i);return this.a.set(a,l),l}delete(n,c){const i=this.b(n,c.uri);this.a.delete(i)}b(n,c){return`${n}@@@${c}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class h{constructor(){this.a=new Map}addTextProvider(n,c,i){return this.b(0,n,c,i)}addCustomProvider(n,c,i){return this.b(1,n,c,i)}get(n){return this.a.get(n)}b(n,c,i,a){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:n,extension:i,provider:a}),new v.$mK(()=>this.a.delete(c))}}class r{constructor(n,c,i,a,l){this.d=c,this.f=i,this.g=a,this.h=l,this.b=new h,this.c=new k,this.a=n.getProxy(I.$kK.MainThreadCustomEditors)}registerCustomEditorProvider(n,c,i,a){const l=new f.$Rc;return o(i)?(l.add(this.b.addTextProvider(c,n,i)),this.a.$registerTextEditorProvider((0,w.$odc)(n),c,a.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,w.$mdc)(n))):(l.add(this.b.addCustomProvider(c,n,i)),s(i)&&l.add(i.onDidChangeCustomDocument(C=>{const S=this.i(c,C.document.uri);if(m(C)){const b=S.addEdit(C);this.a.$onDidEdit(C.document.uri,c,b,C.label)}else this.a.$onContentChange(C.document.uri,c)})),this.a.$registerCustomEditorProvider((0,w.$odc)(n),c,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,w.$mdc)(n))),v.$mK.from(l,new v.$mK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(n,c,i,a,l){const C=this.b.get(c);if(!C)throw new Error(`No provider found for '${c}'`);if(C.type!==1)throw new Error(`Invalid provide type for '${c}'`);const S=$.URI.revive(n),b=await C.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:a?.buffer},l);let g;return s(C.provider)&&this.f&&(g=this.f.workspaceValue(C.extension)??this.f.globalValue(C.extension)),this.c.add(c,b,g),{editable:s(C.provider)}}async $disposeCustomDocument(n,c){const i=this.b.get(c);if(!i)throw new Error(`No provider found for '${c}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${c}'`);const a=$.URI.revive(n),{document:l}=this.i(c,a);this.c.delete(c,l),l.dispose()}async $resolveCustomEditor(n,c,i,a,l,C){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const b=E.ViewColumn.to(l),g=this.g.createNewWebview(c,a.contentOptions,S.extension),d=this.h.createNewWebviewPanel(c,i,a.title,b,a.options,g,a.active),P=$.URI.revive(n);switch(S.type){case 1:{const{document:N}=this.i(i,P);return S.provider.resolveCustomEditor(N,d,C)}case 0:{const N=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(N,d,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,c,i){this.i(c,n).disposeEdits(i)}async $onMoveCustomEditor(n,c,i){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this.h.getWebviewPanel(n);if(!l)throw new Error("No webview found");const C=$.URI.revive(c),S=this.d.getDocument(C);await a.provider.moveCustomTextEditor(S,l,D.CancellationToken.None)}async $undo(n,c,i,a){return this.i(c,n).undo(i,a)}async $redo(n,c,i,a){return this.i(c,n).redo(i,a)}async $revert(n,c,i){const a=this.i(c,n);await this.j(c).revertCustomDocument(a.document,i),a.disposeBackup()}async $onSave(n,c,i){const a=this.i(c,n);await this.j(c).saveCustomDocument(a.document,i),a.disposeBackup()}async $onSaveAs(n,c,i,a){const l=this.i(c,n);return this.j(c).saveCustomDocumentAs(l.document,$.URI.revive(i),a)}async $backup(n,c,i){const a=this.i(c,n),C=await this.j(c).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},i);return a.updateBackup(C),C.id}i(n,c){const i=this.c.get(n,$.URI.revive(c));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!s(i))throw new Error("Custom document is not editable");return i}}e.$1dc=r;function s(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const n=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Di)(n)+""}}),define(De[337],Ce([1,0,4,3,2,31,13,91,6,7]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class L extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(k,p,h,r){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new D.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=p,this.#l=h,this.#i=r.viewType,this.#u=r.panelOptions,this.#r=r.viewColumn,this.#n=r.title,this.#a=r.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#s}set iconPath(k){this.c(),this.#s!==k&&(this.#s=k,this.#t.$setIconPath(this.#e,f.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(k){this.#c||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#a=k.active,this.#o=k.visible,this.#r=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$Sc{static c(){return(0,R.$eg)()}constructor(k,p,h){super(),this.j=p,this.m=h,this.g=new Map,this.h=new Map,this.f=k.getProxy(E.$kK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,p,h,r,s={}){const o=typeof r=="object"?r.viewColumn:r,m={viewColumn:A.ViewColumn.from(o),preserveFocus:typeof r=="object"&&!!r.preserveFocus},u=(0,$.$mdc)(k),t=I.c();this.f.$createWebviewPanel((0,$.$odc)(k),t,p,{title:h,panelOptions:v(s),webviewOptions:(0,$.$pdc)(k,this.m,s),serializeBuffersForPostMessage:u},m);const n=this.j.createNewWebview(t,s,k);return this.createNewWebviewPanel(t,p,h,o,s,n,!0)}$onDidChangeWebviewPanelViewStates(k){const p=Object.keys(k);p.sort((h,r)=>{const s=k[h],o=k[r];return s.active?1:o.active?-1:+s.visible-+o.visible});for(const h of p){const r=this.getWebviewPanel(h);if(!r)continue;const s=k[h];r._updateViewState({active:s.active,visible:s.visible,viewColumn:A.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,p,h){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:h,extension:k}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,$.$mdc)(k)}),new w.$mK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(k,p,h,r){const s=this.h.get(p);if(!s)throw new Error(`No serializer found for '${p}'`);const{serializer:o,extension:m}=s,u=this.j.createNewWebview(k,h.webviewOptions,m),t=this.createNewWebviewPanel(k,p,h.title,r,h.panelOptions,u,h.active);await o.deserializeWebviewPanel(t,h.state)}createNewWebviewPanel(k,p,h,r,s,o,m){const u=new L(k,this.f,o,{viewType:p,title:h,viewColumn:r,panelOptions:s,active:m});return this.g.set(k,u),u}getWebviewPanel(k){return this.g.get(k)}}e.$Zdc=I;function v(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[338],Ce([1,0,4,3,91,13,6,7]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class E extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,v,y,k,p,h){super(),this.#u=!1,this.#a=this.B(new D.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new D.$Nd),this.onDidDispose=this.#c.event,this.#i=y,this.#s=k,this.#e=I,this.#t=v,this.#l=p,this.#n=h}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class w{constructor(I,v){this.d=v,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$kK.MainThreadWebviewViews)}registerWebviewViewProvider(I,v,y,k){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,f.$odc)(I),v,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$mdc)(I)}),new $.$mK(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(I,v,y,k,p){const h=this.b.get(v);if(!h)throw new Error(`No view provider found for '${v}'`);const{provider:r,extension:s}=h,o=this.d.createNewWebview(I,{},s),m=new E(I,this.a,v,y,o,!0);this.c.set(I,m),await r.resolveWebviewView(m,{state:k},p)}async $onDidChangeWebviewViewVisibility(I,v){this.e(I)._setVisible(v)}async $disposeWebviewView(I){const v=this.e(I);this.c.delete(I),v.dispose(),this.d.deleteWebview(I)}e(I){const v=this.c.get(I);if(!v)throw new Error("No webview found");return v}}e.$Ydc=w}),define(De[151],Ce([1,0,4,6,2,18,15,5,20,26]),function($e,e,D,T,f,R,A,$,E,w){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0;let I=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,w.$hF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new D.$Nd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=y.getProxy(T.$kK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let p;if(typeof y=="string"){p=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Be)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,k)}async asExternalUri(y,k){if((0,A.$Be)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,k);return f.URI.from(p)}};e.$qdc=I,e.$qdc=I=L=He([Be(0,E.$lM)],I),e.$rdc=(0,$.$Ph)("IExtHostWindow")}),define(De[339],Ce([1,0,306,27,20]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;const R=1024*1024;let A=class extends D.$rec{constructor(E,w){super(E,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,w,L){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,L),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,w){const L=process[E],I=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,k,p)=>{if(!this.g){v+=y.toString(k);const h=v.length>R?v.length:v.lastIndexOf(`
`);h!==-1&&(console[w](v.slice(0,h)),v=v.slice(h+1))}I.call(L,y,k,p)}})}};e.$3ec=A,e.$3ec=A=He([Be(0,f.$lM),Be(1,T.$BM)],A)}),define(De[340],Ce([1,0,72,18,14,241,30,12]),function($e,e,D,T,f,R,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;let E=class{constructor(I,v){I.addFileSystemProvider(T.Schemas.file,new w(v),{isCaseSensitive:$.$l})}};e.$4ec=E,e.$4ec=E=He([Be(0,D.$Pcc),Be(1,f.$0i)],E);class w{constructor(I){this.b=I,this.a=new R.$aq(this.b)}async stat(I){const v=await this.a.stat(I);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,v,y){return this.a.writeFile(I,v,{...y,unlock:!1,atomic:!1})}delete(I,v){return this.a.delete(I,{...v,useTrash:!1,atomic:!1})}rename(I,v,y){return this.a.rename(I,v,y)}copy(I,v,y){return this.a.copy(I,v,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,v){throw new Error("Method not implemented.")}}}),define(De[341],Ce([1,0,16,63,31,34,3,6,2,20]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;let L=class extends A.$Sc{constructor(v,y){super();const k=v.getProxy($.$kK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const h=E.URI.file((0,D.$jc)((0,T.tmpdir)(),(0,f.$eg)()));return await k.$download(p,h),h})}};e.$2ec=L,e.$2ec=L=He([Be(0,w.$lM),Be(1,R.$HM)],L)}),define(De[342],Ce([1,0,150,18,243,31]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class A extends D.$qec{s(E,w,L){return E.scheme===T.Schemas.file?new f.$xN(L?.name||(0,R.$eg)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,w):super.s(E,w,L)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$cfc=A}),define(De[343],Ce([1,0,53,16,2,90,3,18,8,29]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class L extends R.$Rcc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==$.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const c=n.fsPath;let i=0;do{let a;i===0?a=c:a=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${i}`:`${c}-${i}`,await I(a);const l=T.$jc(a,"vscode.lock"),C=await p(this.d,l,!1);if(C)return this.i=C,process.on("exit",()=>{C.dispose()}),f.URI.file(a);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$bfc=L;async function I(u){try{await w.Promises.stat(u);return}catch{}try{await w.Promises.mkdir(u,{recursive:!0})}catch{}}const v=1e3,y=10*60*1e3;class k extends A.$Sc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$5g),this.a.cancelAndSet(async()=>{const c=await h(t,n);(!c||c.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function p(u,t,n){try{const i={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){u.error(i)}const c=await h(u,t);return!c||c.pid!==process.pid?n?(u.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),o(u,t)):(u.info(`Lock '${t}': Lock acquired.`),new k(u,t))}async function h(u,t){let n;try{n=await w.Promises.readFile(t)}catch(c){return u.error(c),null}try{return JSON.parse(String(n))}catch(c){return u.error(c),null}}async function r(u,t){let n;try{n=await w.Promises.stat(t)}catch(c){return u.error(c),0}return n.mtime.getTime()}function s(u){try{return process.kill(u,0),!0}catch{return!1}}async function o(u,t){const n=await h(u,t);if(!n)return u.info(`Lock '${t}': Could not read pid of lock holder.`),m(u,t);if(n.willReleaseAt){let C=n.willReleaseAt-Date.now();if(C<5e3){for(C>0?u.info(`Lock '${t}': The lockfile is scheduled to be released in ${C} ms.`):u.info(`Lock '${t}': The lockfile is scheduled to have been released.`);C>0;){if(await(0,E.$Ug)(Math.min(100,C)),await r(u,t)===0)return m(u,t);C=n.willReleaseAt-Date.now()}return m(u,t)}}if(!s(n.pid))return u.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(u,t);const c=await r(u,t),i=Date.now()-c;if(i<=y)return u.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;u.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Ug)(2e3);const a=await r(u,t),l=Date.now()-a;return l<=y?(u.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(u.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(u,t))}async function m(u,t){u.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return p(u,t,!0)}}),define(De[344],Ce([1,0,31,20,45,34]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;let A=class extends f.$Ucc{constructor(E,w){super(!0,E,w)}createTerminal(E,w,L){return this.createTerminalFromOptions({name:E,shellPath:w,shellArgs:L})}createTerminalFromOptions(E,w){const L=new f.$Tcc(this.a,(0,D.$eg)(),E,E.name);return this.f.push(L),L.create(E,this.R(E,w)),L.value}};e.$wec=A,e.$wec=A=He([Be(0,R.$HM),Be(1,T.$lM)],A)}),define(De[345],Ce([1,0,8,22,21,9,4,3,128,294,69]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$G4b=e.ResponsiveState=e.RequestInitiator=e.$F4b=e.$E4b=void 0;function v(d,P){try{return JSON.stringify(d,P)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class p{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function h(d,P=null,N=!1){const F=[];return{jsonString:(N?v:JSON.stringify)(d,(U,j)=>{if(typeof j>"u")return k;if(typeof j=="object"){if(j instanceof T.$be){const O=F.push(j)-1;return{[y]:O}}if(P)return P(U,j)}return j}),referencedBuffers:F}}e.$E4b=h;function r(d,P,N){return JSON.parse(d,(F,M)=>{if(M){const U=M[y];if(typeof U=="number")return P[U];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$F4b=r;function s(d,P){return JSON.stringify(d,P)}function o(d){return d?(P,N)=>N&&N.$mid===1?d.transformOutgoing(N):N:null}var m;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var u;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},n=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class i extends $.$Sc{static{I=n}static{this.a=3*1e3}constructor(P,N=null,F=null){super(),this[I]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=F,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,U=L.$nv.count;M<U;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$6g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(R.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Om)(P,this.g):P}getProxy(P){const{nid:N,sid:F}=P;return this.s[N]||(this.s[N]=this.J(N,F)),this.s[N]}J(P,N){const F={get:(M,U)=>(typeof U=="string"&&!M[U]&&U.charCodeAt(0)===36&&(M[U]=(...j)=>this.U(P,U,j)),U===c?N:M[U])};return new Proxy(Object.create(null),F)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,F=P.length;N<F;N++){const M=P[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,F=l.read(P,0),M=F.readUInt8(),U=F.readUInt32();switch(M){case 1:case 2:{let{rpcId:j,method:O,args:K}=S.deserializeRequestJSONArgs(F);this.g&&(K=(0,E.$Om)(K,this.g)),this.M(N,U,j,O,K,M===2);break}case 3:case 4:{let{rpcId:j,method:O,args:K}=S.deserializeRequestMixedArgs(F);this.g&&(K=(0,E.$Om)(K,this.g)),this.M(N,U,j,O,K,M===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let j=S.deserializeReplyOKJSON(F);this.g&&(j=(0,E.$Om)(j,this.g)),this.O(N,U,j);break}case 10:{const j=S.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(N,U,j);break}case 8:{const j=S.deserializeReplyOKVSBuffer(F);this.O(N,U,j);break}case 11:{let j=S.deserializeReplyErrError(F);this.g&&(j=(0,E.$Om)(j,this.g)),this.P(N,U,j);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,F,M,U,j){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,L.$pv)(F)}.${M}(`,U);const O=String(N);let K,V;if(j){const te=new f.$Xd;U.push(te.token),K=this.Q(F,M,U),V=()=>te.cancel()}else K=this.Q(F,M,U),V=t;this.u[O]=V;const me=S.serializeAcknowledged(N);this.f?.logOutgoing(me.byteLength,N,1,"ack"),this.c.send(me),K.then(te=>{delete this.u[O];const G=S.serializeReplyOK(N,te,this.h);this.f?.logOutgoing(G.byteLength,N,1,"reply:",te),this.c.send(G)},te=>{delete this.u[O];const G=S.serializeReplyErr(N,te);this.f?.logOutgoing(G.byteLength,N,1,"replyErr:",te),this.c.send(G)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const F=String(N);this.u[F]?.()}O(P,N,F){this.f?.logIncoming(P,N,0,"receiveReply:",F);const M=String(N);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M],U.resolveOk(F)}P(P,N,F){this.f?.logIncoming(P,N,0,"receiveReplyErr:",F);const M=String(N);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M];let j;F&&(F.$isError?(j=new Error,j.name=F.name,j.message=F.message,j.stack=F.stack):j=F),U.resolveErr(j)}Q(P,N,F){try{return Promise.resolve(this.S(P,N,F))}catch(M){return Promise.reject(M)}}S(P,N,F){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,L.$pv)(P));const U=M[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$pv)(P));return U.apply(M,F)}U(P,N,F){if(this.j)return new w.$D4b;let M=null;if(F.length>0&&f.CancellationToken.isCancellationToken(F[F.length-1])&&(M=F.pop()),M&&M.isCancellationRequested)return Promise.reject(R.$6());const U=S.serializeRequestArguments(F,this.h),j=++this.t,O=String(j),K=new w.$C4b,V=new $.$Rc;M&&V.add(M.onCancellationRequested(()=>{const te=S.serializeCancel(j);this.f?.logOutgoing(te.byteLength,j,0,"cancel"),this.c.send(S.serializeCancel(j))})),this.w[O]=new a(K,V),this.F(j);const me=S.serializeRequest(j,P,N,U,!!M);return this.f?.logOutgoing(me.byteLength,j,0,`request: ${(0,L.$pv)(P)}.${N}(`,F),this.c.send(me),K}}e.$G4b=i;class a{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,N,F){const M=new l(T.$be.alloc(F+1+4),0);return M.writeUInt8(P),M.writeUInt32(N),M}static read(P,N){return new l(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let F=0,M=P.length;F<M;F++){const U=P[F];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let j=0;j<U.buffers.length;++j)N+=this.sizeVSBuffer(U.buffers[j]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,F=P.length;N<F;N++){const M=P[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let U=0;U<M.buffers.length;++U)this.writeBuffer(M.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:N[F]=this.readLongString();break;case 2:N[F]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),j=this.readLongString(),O=[];for(let K=0;K<U;++K)O.push(this.readVSBuffer());N[F]=new L.$qv(r(j,O,null));break}case 4:N[F]=void 0;break}return N}}var C;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(C||(C={}));class S{static a(P){for(let N=0,F=P.length;N<F;N++)if(P[N]instanceof T.$be||P[N]instanceof L.$qv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const F=[];for(let M=0,U=P.length;M<U;M++){const j=P[M];if(j instanceof T.$be)F[M]={type:2,value:j};else if(typeof j>"u")F[M]={type:4};else if(j instanceof L.$qv){const{jsonString:O,referencedBuffers:K}=h(j.value,N);F[M]={type:3,value:T.$be.fromString(O),buffers:K}}else F[M]={type:1,value:T.$be.fromString(s(j,N))}}return{type:1,args:F}}return{type:0,args:s(P,N)}}static serializeRequest(P,N,F,M,U){switch(M.type){case 0:return this.b(P,N,F,M.args,U);case 1:return this.c(P,N,F,M.args,U)}}static b(P,N,F,M,U){const j=T.$be.fromString(F),O=T.$be.fromString(M);let K=0;K+=l.sizeUInt8(),K+=l.sizeShortString(j),K+=l.sizeLongString(O);const V=l.alloc(U?2:1,P,K);return V.writeUInt8(N),V.writeShortString(j),V.writeLongString(O),V.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),F=P.readShortString(),M=P.readLongString();return{rpcId:N,method:F,args:JSON.parse(M)}}static c(P,N,F,M,U){const j=T.$be.fromString(F);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(j),O+=l.sizeMixedArray(M);const K=l.alloc(U?4:3,P,O);return K.writeUInt8(N),K.writeShortString(j),K.writeMixedArray(M),K.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),F=P.readShortString(),M=P.readMixedArray(),U=new Array(M.length);for(let j=0,O=M.length;j<O;j++){const K=M[j];typeof K=="string"?U[j]=JSON.parse(K):U[j]=K}return{rpcId:N,method:F,args:U}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,N,F){if(typeof N>"u")return this.d(P);if(N instanceof T.$be)return this.e(P,N);if(N instanceof L.$qv){const{jsonString:M,referencedBuffers:U}=h(N.value,F,!0);return this.g(P,M,U)}else return this.f(P,v(N,F))}static d(P){return l.alloc(7,P,0).buffer}static e(P,N){let F=0;F+=l.sizeVSBuffer(N);const M=l.alloc(8,P,F);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const F=T.$be.fromString(N);let M=0;M+=l.sizeLongString(F);const U=l.alloc(9,P,M);return U.writeLongString(F),U.buffer}static g(P,N,F){const M=T.$be.fromString(N);let U=0;U+=l.sizeUInt32,U+=l.sizeLongString(M);for(const O of F)U+=l.sizeVSBuffer(O);const j=l.alloc(10,P,U);j.writeUInt32(F.length),j.writeLongString(M);for(const O of F)j.writeBuffer(O);return j.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const F=P.readUInt32(),M=P.readLongString(),U=[];for(let j=0;j<F;++j)U.push(P.readVSBuffer());return new L.$qv(r(M,U,N))}static serializeReplyErr(P,N){const F=N?v(R.$3(N),null):void 0;if(typeof F!="string")return this.h(P);const M=T.$be.fromString(F);let U=0;U+=l.sizeLongString(M);const j=l.alloc(11,P,U);return j.writeLongString(M),j.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return l.alloc(12,P,0).buffer}}var b;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var g;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(g||(g={}))}),define(De[346],Ce([1,0,4,43,42,5]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GJ=e.$FJ=e.OutputChannelUpdateMode=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=void 0,e.$vJ="text/x-code-output",e.$wJ="output",e.$xJ="Log",e.$yJ="text/x-code-log-output",e.$zJ="log",e.$AJ="workbench.panel.output",e.$BJ=new f.$7i("inOutput",!1),e.$CJ=new f.$7i("activeLogOutput",!1),e.$DJ=new f.$7i("outputView.scrollLock",!1),e.$EJ=(0,R.$Ph)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$FJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new D.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(L=>w.push(L)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$gn.add(e.$FJ.OutputChannels,new $),e.$GJ=new f.$7i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,346,72,27,55,178,22,17,30,4,3]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0;class r extends A.$dj{get disposed(){return this.n}constructor(u,t,n,c,i){super(),this.id=u,this.name=t,this.r=n,this.s=c,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=v.$be.fromString(t).byteLength,(0,A.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class s extends r{appendLine(u){this.append(u)}}let o=class{constructor(u,t,n,c,i,a){this.i=t,this.j=n,this.k=c,this.l=i,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(D.$kK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(u,t,n){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,i=(0,y.$yf)(t)?t:void 0;if((0,y.$yf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const l=this.i.environment.extensionLogLevel?.find(([S])=>R.$6l.equals(n.identifier,S))?.[1];l&&(a=(0,A.$nj)(l));const C=c?this.o(u,a,n):this.n(u,i,n);return C.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),c?this.r(u,a??this.m.getLevel(),C):this.q(u,C)}async n(u,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,i=this.k.extUri.joinPath(c,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(u,i,t,n.identifier.value);return new r(l,u,a,this.a,n)}async o(u,t,n){const c=await this.p(n),i=u.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(c,`${i}.log`),l=`${n.identifier.value}.${i}`,C=this.l.createLogger(a,{id:l,name:u,logLevel:t,extensionId:n.identifier.value});return new s(l,u,C,this.a,n)}p(u){let t=this.d.get(u.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(c){if((0,k.$ok)(c)!==k.FileSystemProviderErrorCode.FileExists)throw c}return n})())}return t}q(u,t){let n=!1;const c=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return u},append(i){c(),t.then(a=>a.append(i))},appendLine(i){c(),t.then(a=>a.appendLine(i))},clear(){c(),t.then(i=>i.clear())},replace(i){c(),t.then(a=>a.replace(i))},show(i,a){c(),t.then(l=>l.show(i,a))},hide(){c(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(u,t,n){const c=new h.$Rc,i=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},a=c.add(new p.$Nd);function l(C){t=C,a.fire(C)}return n.then(C=>{c.add(C),C.logLevel!==t&&l(C.logLevel),c.add(C.onDidChangeLogLevel(S=>l(S)))}),{...this.q(u,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(C,...S){i(),n.then(b=>b.trace(C,...S))},debug(C,...S){i(),n.then(b=>b.debug(C,...S))},info(C,...S){i(),n.then(b=>b.info(C,...S))},warn(C,...S){i(),n.then(b=>b.warn(C,...S))},error(C,...S){i(),n.then(b=>b.error(C,...S))},dispose(){c.dispose()}}}};e.$adc=o,e.$adc=o=He([Be(0,f.$lM),Be(1,w.$BM),Be(2,E.$Pcc),Be(3,L.$kcc),Be(4,A.$$i),Be(5,A.$0i)],o),e.$bdc=(0,T.$Ph)("IExtHostOutputService")}),define(De[347],Ce([1,0,5,8]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,D.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await f.getRoundTripTime();if(E===void 0)return;R=Math.min(R,E/2),await(0,T.$Ug)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[348],Ce([1,0,33,18,16,12,23,2,5,259,44,147,347]),function($e,e,D,T,f,R,A,$,E,w,L,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$YJ=void 0,e.$YJ=(0,E.$Ph)("pathService");let k=y=class{constructor(h,r,s,o){this.d=h,this.e=r,this.f=s,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??h})()}hasValidBasename(h,r,s){return typeof r=="string"||typeof r>"u"?this.a.then(o=>this.h(h,o,r)):this.h(h,r,s)}h(h,r,s){return h.scheme===T.Schemas.file||h.scheme===T.Schemas.vscodeRemote?(0,D.$Vf)(s??(0,A.$sg)(h),r===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,r){if(h.remoteAuthority)return T.Schemas.vscodeRemote;const s=(0,w.$VJ)(r.getWorkspace());if(s)return s;const o=r.getWorkspace().folders[0];if(o)return o.uri.scheme;const m=r.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?f.$fc:f.$gc)}async fileURI(h){let r="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const o=h.indexOf("/",2);o===-1?(r=h.substring(2),h="/"):(r=h.substring(2,o),h=h.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:r,path:h,query:"",fragment:""})}};e.$ZJ=k,e.$ZJ=k=y=He([Be(1,v.$tm),Be(2,I.$HJ),Be(3,L.$Yh)],k)}),define(De[349],Ce([1,0,226,19,57,4,52,3,2,50,231,14,65,261,86,44,147,26,21,17,24,42]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=e.OnPortForward=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.TunnelSource=e.TunnelCloseReason=e.$KJ=e.$JJ=e.$IJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$IJ="onTunnel",e.$JJ=new u.$7i("forwardedPortsViewEnabled",!1,D.localize(0,null));function c(N){const F=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}e.$KJ=c;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$LJ={source:a.User,description:D.localize(1,null)},e.$MJ={source:a.Auto,description:D.localize(2,null)};function l(N,F,M){const U=N.get(S(F,M));if(U)return U;if((0,k.$cv)(F))for(const j of k.$bv){const O=S(j,M);if(N.has(O))return N.get(O)}else if((0,k.$ev)(F))for(const j of k.$dv){const O=S(j,M);if(N.has(O))return N.get(O)}}e.$NJ=l;function C(N,F,M){const U=l(N,F,M);if(U)return U;const j=(0,k.$ev)(F)?"localhost":(0,k.$cv)(F)?"0.0.0.0":void 0;if(j)return l(N,j,M)}e.$OJ=C;function S(N,F){return N+":"+F}e.$PJ=S;var b;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(b||(e.OnPortForward=b={}));function g(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$QJ=g;class d extends $.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new R.$Nd,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(M=>{(M.affectsConfiguration(d.c)||M.affectsConfiguration(d.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,M,U){let j=this.w(F,M,U,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const K=this.j[j];K.key===F?(O.onAutoForward=K.onAutoForward??O.onAutoForward,O.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:O.elevateIfNeeded,O.label=K.label??O.label,O.requireLocalPort=K.requireLocalPort,O.protocol=K.protocol):(O.onAutoForward=O.onAutoForward??K.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:K.elevateIfNeeded,O.label=O.label??K.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??K.protocol),j=this.w(F,M,U,this.j,j+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,o.$yf)(F.host)&&(0,o.$Cf)(F.port)}w(F,M,U,j,O){if(O>=j.length)return-1;const K=!(0,k.$cv)(M)&&!(0,k.$ev)(M),me=j.slice(O).findIndex(te=>(0,o.$Cf)(te.key)?K?!1:te.key===F:this.t(te.key)?K?!1:F>=te.key.start&&F<=te.key.end:this.u(te.key)?F===te.key.port&&M===te.key.host:U?te.key.test(U):!1);return me>=0?me+O:-1}y(){const F=this.r.getValue(d.c);if(!F||!(0,o.$Af)(F))return[];const M=[];for(const j in F){if(j===void 0)continue;const O=F[j];let K;if(Number(j))K=Number(j);else if((0,o.$yf)(j))if(d.g.test(j)){const V=j.match(d.g);K={start:Number(V[1]),end:Number(V[2])}}else if(d.h.test(j)){const V=j.match(d.h);K={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(j)}catch{}V&&(K=V)}K&&M.push({key:K,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const U=this.r.getValue(d.f);return U&&(this.m={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.z(M)}z(F){function M(U,j){return(0,o.$Cf)(U.key)?U.key:j.t(U.key)?U.key.start:j.u(U.key)?U.key.port:Number.MAX_VALUE}return F.sort((U,j)=>M(U,this)-M(j,this))}C(){return this.m}static providedActionToAction(F){switch(F){case k.ProvidedOnAutoForward.Notify:return b.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case k.ProvidedOnAutoForward.Silent:return b.Silent;case k.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(F,M,U){const O=this.r.inspect(d.c).userRemoteValue;let K;!O||!(0,o.$Af)(O)?K={}:K=(0,m.$7m)(O),K[`${F}`]||(K[`${F}`]={});for(const V in M)K[`${F}`][V]=M[V];return this.r.updateValue(d.c,K,U)}}e.$RJ=d;let P=class extends $.$Sc{constructor(F,M,U,j,O,K,V,me,te,G){super(),this.H=F,this.I=M,this.J=U,this.L=j,this.M=O,this.N=K,this.O=V,this.P=me,this.Q=te,this.R=G,this.c=new Map,this.g=new R.$Nd,this.onForwardPort=this.g.event,this.h=new R.$Nd,this.onClosePort=this.h.event,this.j=new R.$Nd,this.onPortName=this.j.event,this.n=new R.$Nd,this.onCandidatesChanged=this.n.event,this.t=new R.$Nd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Nd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new d(U),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Q=>{const le=await this.getAttributes(Q.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of Q)if(ie.localAddress){const ce=S(ie.tunnelRemoteHost,ie.tunnelRemotePort),pe=C(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:le?.get(ie.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,le?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:ie.privacy,source:e.$LJ}),this.f.set(ce,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Q=>{const le=S(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!C(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!C(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!C(this.c,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const ie=C(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),ce=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(le,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:ce?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,ce),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:Q.privacy,source:e.$LJ})}await this.$(),this.f.set(le,Q),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(Q=>this.W(Q,i.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$IJ))?(this.R.createKey(e.$JJ.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,M){const U=S(F.host,F.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.$(),this.h.fire(F))}X(F,M){if(F.startsWith("http"))return E.URI.parse(F);const U=M?.protocol??"http";return E.URI.parse(`${U}://${F}`)}async Y(){const F=this.N.getWorkspace(),M=F.configuration?(0,A.$Di)(F.configuration.path):F.folders.length>0?(0,A.$Di)(F.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const F=this.I.get(n,1);if(F)return this.I.remove(n,1),await this.$(),F;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const M=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(U=>U.remotePort).join(", ")}`);for(const U of M){const j=C(this.detected,U.remoteHost,U.remotePort);U.source.source!==a.Extension&&!j||U.source.source===a.Extension&&j?await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===a.Extension&&!j&&this.D.set(S(U.remoteHost,U.remotePort),U)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Y();this.w=this.B(new $.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=JSON.stringify(Array.from(this.forwarded.values()));if(F!==this.y){this.y=F;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(F,M,U){if(!F.tunnelLocalPort||!U?.requireLocalPort||F.tunnelLocalPort===M)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const O=D.localize(3,null,M,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(O)}async forward(F,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(F,M)}async cb(F,M){await this.Q.activateByEvent(e.$IJ);const U=C(this.forwarded,F.remote.host,F.remote.port);M=M??(M!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const j=F.local!==void 0?F.local:F.remote.port;let O;if(U)return this.eb(U,F,M);{const K=this.L.remoteAuthority,V=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,me=S(F.remote.host,F.remote.port);this.c.set(me,!0),F=this.db(me,F);const te=await this.H.openTunnel(V,F.remote.host,F.remote.port,void 0,j,F.elevateIfNeeded?F.elevateIfNeeded:M?.elevateIfNeeded,F.privacy,M?.protocol);if(typeof te=="string")O=te;else if(te&&te.localAddress){const G=C(this.m??new Map,F.remote.host,F.remote.port),Q=te.protocol?te.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:M?.protocol??k.TunnelProtocol.Http,le={remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localPort:te.tunnelLocalPort,name:M?.label??F.name,closeable:!0,localAddress:te.localAddress,protocol:Q,localUri:await this.X(te.localAddress,M),runningProcess:G?.detail,hasRunningProcess:!!G,pid:G?.pid,source:F.source??e.$LJ,privacy:te.privacy};return this.forwarded.set(me,le),this.f.set(me,te),this.c.delete(me),await this.$(),await this.bb(te,j,M),this.g.fire(le),te}this.c.delete(me)}return O}db(F,M){const U=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(U){const j=U.get(F);U.delete(F),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async eb(F,M,U){const j=U?.label??M.name;let O;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(O||(O={}));let K=O.None;switch(j!==F.name&&(F.name=j,K=O.Fire),(U?.protocol||F.protocol!==k.TunnelProtocol.Http)&&U?.protocol!==F.protocol&&(M.source=F.source,K=O.Reopen),M.privacy&&F.privacy!==M.privacy&&(K=O.Reopen),K){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(F.remoteHost,F.remotePort,i.User),await this.cb(M,U)}return C(this.f,M.remote.host,M.remote.port)}async name(F,M,U){const j=C(this.forwarded,F,M),O=S(F,M);if(j){j.name=U,await this.$(),this.j.fire({host:F,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=U,this.j.fire({host:F,port:M}))}async close(F,M,U){const j=S(F,M),O=this.forwarded.get(j);return U===i.AutoForwardEnd&&O&&O.source.source===a.Auto&&this.F.set(j,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(F,M),this.W({host:F,port:M},U)}address(F,M){const U=S(F,M);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const M of F){const U=C(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:S(M.localAddress.host,M.localAddress.port);this.detected.set(S(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:k.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let M=F;this.r&&(M=await this.r(F));const U=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(j=>j.port).join(", ")}`),this.n.fire(U)}fb(F){const M=this.m??new Map,U=new Map;return this.m=U,F.forEach(j=>{const O=S(j.host,j.port);U.set(O,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(O)&&M.delete(O);const K=C(this.forwarded,j.host,j.port);K&&(K.runningProcess=j.detail,K.hasRunningProcess=!0,K.pid=j.pid)}),M.forEach((j,O)=>{const K=c(O);if(!K)return;const V=C(this.forwarded,K.host,K.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const me=C(this.detected,K.host,K.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const F=Array.from(this.forwarded.values()),M=await this.getAttributes(F.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(M)for(const U of F){const j=M.get(U.remotePort);(j?.protocol||U.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},j),j&&j.label&&j.label!==U.name&&await this.name(U.remoteHost,U.remotePort,j.label)}}async getAttributes(F,M=!0){const U=new Map,j=new Map;F.forEach(te=>{const G=C(this.m??new Map,k.$bv[0],te.port)??te;if(G){U.set(te.port,G);const Q=g(G)?G.pid:void 0;j.has(Q)||j.set(Q,[]),j.get(Q)?.push(te.port)}});const O=new Map;if(F.forEach(te=>{const G=this.configPortsAttributes.getAttributes(te.port,te.host,U.get(te.port)?.detail);G&&O.set(te.port,G)}),this.G.length===0||!M)return O.size>0?O:void 0;const K=await Promise.all((0,T.$Rb)(this.G.map(te=>Array.from(j.entries()).map(G=>{const Q=G[1],le=U.get(Q[0]);return te.providePortAttributes(Q,le?.pid,le?.detail,new s.$Xd().token)})))),V=new Map;if(K.forEach(te=>te.forEach(G=>{G&&V.set(G.port,G)})),!O&&!V)return;const me=new Map;return F.forEach(te=>{const G=O.get(te.port),Q=V.get(te.port);me.set(te.port,{elevateIfNeeded:G?.elevateIfNeeded,label:G?.label,onAutoForward:G?.onAutoForward??d.providedActionToAction(Q?.autoForwardAction),requireLocalPort:G?.requireLocalPort,protocol:G?.protocol})}),me}addAttributesProvider(F){this.G.push(F)}};e.$SJ=P,He([(0,f.$ih)(1e3)],P.prototype,"$",null),e.$SJ=P=He([Be(0,k.$0u),Be(1,y.$6o),Be(2,w.$ji),Be(3,h.$HJ),Be(4,v.$Pk),Be(5,p.$Yh),Be(6,I.$0i),Be(7,L.$Bv),Be(8,r.$dF),Be(9,u.$8i)],P)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GI=e.$FI=void 0;class D{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new D(0,0)}with(A){return new D(0,0)}}e.$FI=D;class T{constructor(A,$,E,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,$),this.end=new D(E,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$GI=T;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(De[37],Ce([1,0,19,36,24,33,15,5,16,9,92,8]),function($e,e,D,T,f,R,A,$,E,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.SearchErrorCode=e.$VI=e.$UI=e.SearchSortOrder=e.ViewMode=e.$TI=e.$SI=e.$RI=e.$QI=e.SearchCompletionExitCode=e.$PI=e.$OI=e.$NI=e.QueryType=e.SearchProviderType=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$HI="workbench.view.search",e.$II="workbench.panel.search",e.$JI="workbench.view.search",e.$KI="search-result",e.$LI="search.exclude";const v="\u27EA ",y=" characters skipped \u27EB",k=(v.length+y.length+5)*2;e.$MI=(0,$.$Ph)("searchService");var p;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(p||(e.SearchProviderType=p={}));var h;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(h||(e.QueryType=h={}));function r(Q){return!!Q.preview}e.$NI=r;function s(Q){return!!Q.resource}e.$OI=s;function o(Q){return!!Q.message}e.$PI=o;var m;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class u{constructor(le){this.resource=le,this.results=[]}}e.$QI=u;class t{constructor(le,ie,ce,pe){this.ranges=ie,this.webviewIndex=pe;const H=Array.isArray(ie)?ie:[ie];if(ce&&ce.matchLines===1&&n(H)){le=(0,A.$rf)(le,ce.matchLines);let B="",X=0,re=0;const Y=Math.floor(ce.charsPerLine/5),_=[];for(const x of H){const ve=Math.max(x.startColumn-Y,0),ae=x.startColumn+ce.charsPerLine;if(ve>re+Y+k){const fe=v+(ve-re)+y;B+=fe+le.slice(ve,ae),X+=ve-(re+fe.length)}else B+=le.slice(re,ae);_.push(new i(0,x.startColumn-X,x.endColumn-X)),re=ae}this.preview={text:B,matches:Array.isArray(this.ranges)?_:_[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:le,matches:(0,D.$2b)(ie,X=>new c(X.startLineNumber-B,X.startColumn,X.endLineNumber-B,X.endColumn))}}}}e.$RI=t;function n(Q){const le=Q[0].startLineNumber;for(const ie of Q)if(ie.startLineNumber!==le||ie.endLineNumber!==le)return!1;return!0}class c{constructor(le,ie,ce,pe){this.startLineNumber=le,this.startColumn=ie,this.endLineNumber=ce,this.endColumn=pe}}e.$SI=c;class i extends c{constructor(le,ie,ce){super(le,ie,le,ce)}}e.$TI=i;var a;(function(Q){Q.List="list",Q.Tree="tree"})(a||(e.ViewMode=a={}));var l;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function C(Q,le=!0){const ie=Q&&Q.files&&Q.files.exclude,ce=le&&Q&&Q.search&&Q.search.exclude;if(!ie&&!ce)return;if(!ie||!ce)return ie||ce;let pe=Object.create(null);return pe=f.$0m(pe,f.$7m(ie)),pe=f.$0m(pe,f.$7m(ce),!0),pe}e.$UI=C;function S(Q,le){return Q.excludePattern&&T.$vj(Q.excludePattern,le)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&T.$vj(Q.includePattern,le)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ie=>{const ce=ie.folder.fsPath;if(R.$Xf(le,ce)){const pe=E.$lc(ce,le);return!ie.includePattern||!!T.$vj(ie.includePattern,pe)}else return!1}):!1:!0}e.$VI=S;var b;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class g extends Error{constructor(le,ie){super(le),this.code=ie}}e.$WI=g;function d(Q){const le=Q.message;if((0,w.$4)(Q))return new g(le,b.canceled);try{const ie=JSON.parse(le);return new g(ie.message,ie.code)}catch{return new g(le,b.other)}}e.$XI=d;function P(Q){const le={message:Q.message,code:Q.code};return new Error(JSON.stringify(le))}e.$YI=P;function N(Q){return Q.type==="error"?!0:Q.type==="success"}e.$ZI=N;function F(Q){return Q.type==="success"}e.$1I=F;function M(Q){return!!Q.path}e.$2I=M;function U(Q,le){const ie=Q.searchPath?Q.searchPath:Q.relativePath;return(0,A.$of)(ie,le)}e.$3I=U;class j{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$4I=j;function O(Q,le){const ie={...Q||{},...le||{}};return Object.keys(ie).filter(ce=>{const pe=ie[ce];return typeof pe=="boolean"&&pe})}e.$5I=O;class K{constructor(le,ie){this.c=null,this.a={...le.excludePattern||{},...ie.excludePattern||{}},this.b=T.$wj(this.a);let ce=le.includePattern;ie.includePattern&&(ce?ce={...ce,...ie.includePattern}:ce=ie.includePattern),ce&&(this.c=T.$wj(ce))}matchesExcludesSync(le,ie,ce){return!!(this.b&&this.b(le,ie,ce))}includedInQuerySync(le,ie,ce){return!(this.b&&this.b(le,ie,ce)||this.c&&!this.c(le,ie,ce))}includedInQuery(le,ie,ce){const pe=this.b(le,ie,ce),H=()=>this.c?!!this.c(le,ie,ce):!0;return(0,I.$Gg)(pe)?pe.then(B=>B?!1:H()):H()}hasSiblingExcludeClauses(){return V(this.a)}}e.$6I=K;function V(Q){for(const le in Q)if(typeof Q[le]!="boolean")return!0;return!1}function me(Q){if(!Q)return;let le;return ie=>(le||(le=(Q()||Promise.resolve([])).then(ce=>ce?G(ce):{})),le.then(ce=>!!ce[ie]))}e.$7I=me;function te(Q){if(!Q)return;let le;return ie=>{if(!le){const ce=Q();le=ce?G(ce):{}}return!!le[ie]}}e.$8I=te;function G(Q){const le={};for(const ie of Q)le[ie]=!0;return le}}),define(De[39],Ce([1,0,19,8,21,4,3,78,18,120,23,15,2,215,5,14,244,44,55,27,20,13,7,67,37,6]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;function a(N,F,M){return new L.$kg(U=>b(U,M)).isEqual(N,F)}function l(N,F,M){return a(N.uri,F.uri,M)?0:(0,I.$Ue)(N.uri.toString(),F.uri.toString())}function C(N,F,M){return N.index!==F.index?N.index<F.index?-1:1:a(N.uri,F.uri,M)?(0,I.$Ue)(N.name,F.name):(0,I.$Ue)(N.uri.toString(),F.uri.toString())}function S(N,F,M,U){const j=N.slice(0).sort((K,V)=>M(K,V,U)),O=F.slice(0).sort((K,V)=>M(K,V,U));return(0,D.$Eb)(j,O,(K,V)=>M(K,V,U))}function b(N,F){const M=F.getCapabilities(N.scheme);return!(M&&M&1024)}class g extends r.$9h{static toExtHostWorkspace(F,M,U,j){if(!F)return{workspace:null,added:[],removed:[]};const{id:O,name:K,folders:V,configuration:me,transient:te,isUntitled:G}=F,Q=[],le=M;M?V.forEach((H,B)=>{const X=v.URI.revive(H.uri),re=g.o(U||M,X,j);re?(re.name=H.name,re.index=H.index,Q.push(re)):Q.push({uri:X,name:H.name,index:B})}):Q.push(...V.map(({uri:H,name:B,index:X})=>({uri:v.URI.revive(H),name:B,index:X}))),Q.sort((H,B)=>H.index<B.index?-1:1);const ie=new g(O,K,Q,!!te,me?v.URI.revive(me):null,!!G,H=>b(H,j)),{added:ce,removed:pe}=S(le?le.workspaceFolders:[],ie.workspaceFolders,l,j);return{workspace:ie,added:ce,removed:pe}}static o(F,M,U){for(let j=0;j<F.folders.length;j++){const O=F.workspaceFolders[j];if(a(O.uri,M,U))return O}}constructor(F,M,U,j,O,K,V){super(F,U.map(me=>new r.$0h(me)),j,O,V),this.t=M,this.u=K,this.q=[],this.s=$.$Vh.forUris(V),U.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,M){return M&&this.s.get(F)&&(F=(0,L.$ug)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let d=class{constructor(F,M,U,j,O){this.c=new R.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Pd,this.B=new Map,this.h=j,this.s=U,this.t=O,this.j=new w.$Ql,this.k=new T.$Sg,this.o=F.getProxy(i.$kK.MainThreadWorkspace),this.q=F.getProxy(i.$kK.MainThreadMessageService);const K=M.workspace;this.l=K?new g(K.id,K.name,[],!!K.transient,K.configuration?v.URI.revive(K.configuration):null,!!K.isUntitled,V=>b(V,U)):void 0}$initializeWorkspace(F,M){this.v=M,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:E.Schemas.untitled,path:(0,L.$sg)((0,L.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,M,U,...j){const O=[];if(Array.isArray(j)&&j.forEach(G=>{v.URI.isUri(G.uri)&&!O.some(Q=>a(Q.uri,G.uri,this.s))&&O.push({uri:G.uri,name:G.name||(0,L.$rg)(G.uri)})}),this.n||[M,U].some(G=>typeof G!="number"||G<0)||U===0&&O.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(M+U>K.length)return!1;const V=K.slice(0);V.splice(M,U,...O.map(G=>({uri:G.uri,name:G.name||(0,L.$rg)(G.uri),index:void 0})));for(let G=0;G<V.length;G++){const Q=V[G];if(V.some((le,ie)=>ie!==G&&a(Q.uri,le.uri,this.s)))return!1}V.forEach((G,Q)=>G.index=Q);const{added:me,removed:te}=S(K,V,C,this.s);if(me.length===0&&te.length===0)return!1;if(this.o){const G=F.displayName||F.name;this.o.$updateWorkspaceFolders(G,M,U,O).then(void 0,Q=>{this.n=void 0;const le={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(h.Severity.Error,(0,y.localize)(0,null,G,Q.toString()),le,[])})}return this.y(V),!0}getWorkspaceFolder(F,M){if(this.x)return this.x.getWorkspaceFolder(F,M)}async getWorkspaceFolder2(F,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,M)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,M){let U,j="";if(typeof F=="string"?(U=v.URI.file(F),j=F):typeof F<"u"&&(U=F,j=F.fsPath),!U)return j;const O=this.getWorkspaceFolder(U,!0);if(!O)return j;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let K=(0,L.$xg)(O.uri,U);return M&&O.name&&(K=`${O.name}/${K}`),K}y(F){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:M,added:U,removed:j}=g.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:j}))}findFiles(F,M,U,j,O=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let K;if(M===null?K=!1:M&&(typeof M=="string"?K=M:K=M.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:me}=P(u.GlobPattern.from(F));return this.o.$startFileSearch(V??null,me??null,K??null,U??null,O).then(te=>Array.isArray(te)?te.map(G=>v.URI.revive(G)):[])}async findTextInFiles(F,M,U,j,O=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),V=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:me,folder:te}=P(u.GlobPattern.from(M.include)),G=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Q={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:V,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:me,excludePattern:G},le=!1;if(this.u[K]=ie=>{if(le)return;const ce=v.URI.revive(ie.resource);ie.results.forEach(pe=>{(0,c.$NI)(pe)?U({uri:ce,preview:{text:pe.preview.text,matches:(0,D.$2b)(pe.preview.matches,H=>new t.$oK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))},ranges:(0,D.$2b)(pe.ranges,H=>new t.$oK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))}):U({uri:ce,text:pe.text,lineNumber:pe.lineNumber})})},O.isCancellationRequested)return{};try{const ie=await this.o.$startTextSearch(F,te??null,Q,K,O);return delete this.u[K],ie||{}}catch(ie){throw delete this.u[K],ie}}$handleTextSearchResult(F,M){this.u[M]?.(F)}async save(F){const M=await this.o.$save(F,{saveAs:!1});return v.URI.revive(M)}async saveAs(F){const M=await this.o.$save(F,{saveAs:!0});return v.URI.revive(M)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,M){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,M);const U=this.t.transformOutgoingScheme(F),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,U),(0,A.$Qc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(F,M){this.h.info("Getting edit session identifier for workspaceFolder",F);const U=await this.resolveWorkspaceFolder(v.URI.revive(F));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const O=await j.provideEditSessionIdentity(U,M);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(F,M,U,j){this.h.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(v.URI.revive(F));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const K=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!K),!K)return;const V=await K.provideEditSessionIdentityMatch?.(M,U,j);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(F){return(M,U,j)=>{const O=function(V){M.call(U,V)};return O.extension=F,this.A.event(O,void 0,j)}}async $onWillCreateEditSessionIdentity(F,M,U){const j=await this.resolveWorkspaceFolder(v.URI.revive(F));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},M,async(O,K)=>{const V=Date.now();await Promise.resolve(O),Date.now()-V>U&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(F,M){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,M);const U=this.t.transformOutgoingScheme(F),j=this.z++;return this.o.$registerCanonicalUriProvider(j,U),(0,A.$Qc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(F,M,U){const j=this.B.get(F.scheme);if(!j)return;const O=await j.provideCanonicalUri?.(v.URI.revive(F),M,U);if(O)return O}async $provideCanonicalUri(F,M,U){return this.provideCanonicalUri(v.URI.revive(F),{targetScheme:M},U)}};e.$wcc=d,e.$wcc=d=He([Be(0,m.$lM),Be(1,o.$BM),Be(2,s.$kcc),Be(3,p.$0i),Be(4,n.$ucc)],d),e.$xcc=(0,k.$Ph)("IExtHostWorkspace");function P(N){let F,M;return N&&(typeof N=="string"?F=N:(F=N.pattern,M=v.URI.revive(N.baseUri))),{includePattern:F,folder:M}}}),define(De[40],Ce([1,0,24,4,39,6,7,246,136,17,8,5,20,14,2]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=e.$ycc=void 0;function p(n,c){if(c){const i=c.split(".");let a=n;for(let l=0;a&&l<i.length;l++)a=a[i[l]];return a}}function h(n){return n instanceof k.URI}function r(n){return n&&n.uri instanceof k.URI&&n.languageId&&typeof n.languageId=="string"}function s(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&n.uri instanceof k.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(h(n))return{resource:n};if(r(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(s(n))return{overrideIdentifier:n.languageId};if(o(n))return{resource:n.uri};if(n===null)return{resource:null}}let u=class{constructor(c,i,a){this.a=c.getProxy(R.$kK.MainThreadConfiguration),this.c=i,this.b=a,this.d=new L.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(c,i))}};e.$ycc=u,e.$ycc=u=He([Be(0,v.$lM),Be(1,f.$xcc),Be(2,y.$0i)],u);class t{constructor(c,i,a,l){this.a=new T.$Nd,this.b=c,this.f=l,this.c=i,this.e=$.$En.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,i){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$En.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(i,a))}getConfiguration(c,i,a){const l=m(i)||{},C=this.g(c?p(this.e.getValue(void 0,l,this.c.workspace),c):this.e.getValue(void 0,l,this.c.workspace));c&&this.h(c,l,a?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(g){return typeof p(C,g)<"u"},get:(g,d)=>{this.h(c?`${c}.${g}`:g,l,a?.identifier);let P=p(C,g);if(typeof P>"u")P=d;else{let N;const F=(M,U)=>{if((0,w.$Af)(M)){let j;const O=()=>{N=N||(0,D.$7m)(C),j=j||p(N,U)};return new Proxy(M,{get:(K,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return O(),()=>j;if(N)return j=j||p(N,U),j[V];const me=K[V];return typeof V=="string"?F(me,`${U}.${V}`):me},set:(K,V,me)=>(O(),j&&(j[V]=me),!0),deleteProperty:(K,V)=>(O(),j&&delete j[V],!0),defineProperty:(K,V,me)=>(O(),j&&Object.defineProperty(j,V,me),!0)})}return Array.isArray(M)?(0,D.$7m)(M):M};P=F(P,g)}return P},update:(g,d,P,N)=>{g=c?`${c}.${g}`:g;const F=S(P);return d!==void 0?this.b.$updateConfigurationOption(F,g,d,l,N):this.b.$removeConfigurationOption(F,g,l,N)},inspect:g=>{g=c?`${c}.${g}`:g;const d=this.e.inspect(g,l,this.c.workspace);if(d)return{key:g,defaultValue:(0,D.$7m)(d.policy?.value??d.default?.value),globalValue:(0,D.$7m)(d.user?.value??d.application?.value),workspaceValue:(0,D.$7m)(d.workspace?.value),workspaceFolderValue:(0,D.$7m)(d.workspaceFolder?.value),defaultLanguageValue:(0,D.$7m)(d.default?.override),globalLanguageValue:(0,D.$7m)(d.user?.override??d.application?.override),workspaceLanguageValue:(0,D.$7m)(d.workspace?.override),workspaceFolderLanguageValue:(0,D.$7m)(d.workspaceFolder?.override),languageIds:(0,D.$7m)(d.overrideIdentifiers)}}};return typeof C=="object"&&(0,D.$0m)(b,C,!1),Object.freeze(b)}g(c){const i=a=>(0,w.$Af)(a)?new Proxy(a,{get:(l,C)=>i(l[C]),set:(l,C,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(l,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(l,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(c)}h(c,i,a){const l=E.$vn.test(c)?4:this.d.get(c),C=a?`[${a.value}] `:"";if(l===4){typeof i?.resource>"u"&&this.f.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this.f.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,i){const a=new $.$Gn(c,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,C)=>a.affectsConfiguration(l,m(C))})}k(c){return c.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.$zcc=t,e.$Acc=(0,I.$Ph)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,293,9]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=e.$wdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(F){function M(j){if(j!=null)return j}F.from=M;function U(j){if(j!=null)return j}F.to=U})(u||(u={}));var t;(function(F){function M(j){if(j!=null)return j}F.from=M;function U(j){if(j!=null)return j}F.to=U})(t||(t={}));var n;(function(F){function M(j){if(j!=null)return j}F.from=M;function U(j){if(j!=null)return j}F.to=U})(n||(n={}));var c;(function(F){function M(O){if(O){const K=O;return K&&!!K.process}else return!1}F.is=M;function U(O){if(O==null)return;const K={process:O.process,args:O.args};return O.options&&(K.options=n.from(O.options)),K}F.from=U;function j(O){if(O!=null)return new A.$7K(O.process,O.args,O.options)}F.to=j})(c||(c={}));var i;(function(F){function M(j){if(j!=null)return j}F.from=M;function U(j){if(j!=null)return j}F.to=U})(i||(i={}));var a;(function(F){function M(O){if(O){const K=O;return K&&(!!K.commandLine||!!K.command)}else return!1}F.is=M;function U(O){if(O==null)return;const K={};return O.commandLine!==void 0?K.commandLine=O.commandLine:(K.command=O.command,K.args=O.args),O.options&&(K.options=i.from(O.options)),K}F.from=U;function j(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$8K(O.commandLine,O.options):new A.$8K(O.command,O.args?O.args:[],O.options)}F.to=j})(a||(a={}));var l;(function(F){function M(O){if(O){const K=O;return K&&K.customExecution==="customExecution"}else return!1}F.is=M;function U(O){return{customExecution:"customExecution"}}F.from=U;function j(O,K){return K.get(O)}F.to=j})(l||(e.CustomExecutionDTO=l={}));var C;(function(F){function M(U,j){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?O=j.workspaceFile:O=o.$SF),{id:U._id,workspaceFolder:O}}F.from=M})(C||(e.TaskHandleDTO=C={}));var S;(function(F){function M(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}F.from=M})(S||(S={}));var b;(function(F){function M(O,K){if(O==null)return[];const V=[];for(const me of O){const te=U(me,K);te&&V.push(te)}return V}F.fromMany=M;function U(O,K){if(O==null)return;let V;O.execution instanceof A.$7K?V=c.from(O.execution):O.execution instanceof A.$8K?V=a.from(O.execution):O.execution&&O.execution instanceof A.$9K&&(V=l.from(O.execution));const me=u.from(O.definition);let te;return O.scope?typeof O.scope=="number"?te=O.scope:te=O.scope.uri:te=A.TaskScope.Workspace,!me||!te?void 0:{_id:O._id,definition:me,name:O.name,source:{extensionId:K.identifier.value,label:O.source,scope:te},execution:V,isBackground:O.isBackground,group:S.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}F.from=U;async function j(O,K,V){if(O==null)return;let me;c.is(O.execution)?me=c.to(O.execution):a.is(O.execution)?me=a.to(O.execution):l.is(O.execution)&&(me=l.to(O._id,V));const te=u.to(O.definition);let G;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?G=O.source.scope:G=await K.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):G=A.TaskScope.Workspace),!te||!G)return;const Q=new A.$0K(te,G,O.name,O.source.label,me,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=A.$6K.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new A.$6K(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}F.to=j})(b||(e.TaskDTO=b={}));var g;(function(F){function M(j){return j}F.from=M;function U(j){if(j)return Object.assign(Object.create(null),j)}F.to=U})(g||(g={}));class d{#e;constructor(M,U,j){this._id=U,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,U,j,O,K,V,me,te){this.q=new f.$Nd,this.r=new f.$Nd,this.s=new f.$Nd,this.t=new f.$Nd,this.a=M.getProxy(R.$kK.MainThreadTask),this.b=j,this.c=O,this.d=K,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,U,j){if(!j)return new A.$mK(()=>{});const O=this.w();return this.j.set(O,{type:U,provider:j,extension:M}),this.a.$registerTaskProvider(O,U),new A.$mK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,U){this.a.$registerTaskSystem(M,U)}fetchTasks(M){return this.a.$fetchTasks(g.from(M)).then(async U=>{const j=[];for(const O of U){const K=await b.to(O,this.b,this.m);K&&j.push(K)}return j})}get taskExecutions(){const M=[];return this.k.forEach(U=>M.push(U)),M}terminateTask(M){if(!(M instanceof d))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,U,j){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(U,await O.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const U=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const U=await this.y(M.id);this.s.fire({execution:U,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const U=await this.y(M.id);this.t.fire({execution:U,exitCode:M.exitCode})}$provideTasks(M,U){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const O=[],K=(0,T.$Mg)(()=>j.provider.provideTasks(L.CancellationToken.None)).then(V=>this.u(U,O,j,V));return new Promise(V=>{K.then(me=>{Promise.all(O).then(()=>{V(me)})})})}async $resolveTask(M,U){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(U.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${j.type}].`);const O=await b.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const K=await j.provider.resolveTask(O,L.CancellationToken.None);if(!K)return;this.z(K,j);const V=b.from(K,j.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(V.execution)&&await this.x(V,K,!0),await this.v(V)}w(){return this.h++}async x(M,U,j){const O=await this.a.$createTaskId(M);!j&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async y(M,U){if(typeof M=="string"){const K=this.l.get(M);if(!K)throw new m.$bb("Unexpected: The specified task is missing an execution");return K}const j=this.l.get(M.id);if(j)return j;const O=new Promise((K,V)=>{function me(te,G,Q){Q?K(new d(te,G.id,Q)):V("Unexpected: Task does not exist.")}U?me(this,M,U):b.to(M.task,this.b,this.m).then(te=>me(this,M,te))});return this.l.set(M.id,O),O.then(K=>(this.k.set(M.id,K),K),K=>Promise.reject(K))}z(M,U){M._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let O=j.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=j.next()}};e.$wdc=P,e.$wdc=P=He([Be(0,v.$lM),Be(1,y.$BM),Be(2,$.$xcc),Be(3,E.$wM),Be(4,w.$Acc),Be(5,I.$Scc),Be(6,r.$0i),Be(7,s.$ncc)],P);let N=class extends P{constructor(M,U,j,O,K,V,me,te){super(M,U,j,O,K,V,me,te),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:h.$i(0)})}async executeTask(M,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const j=b.from(U,M);if(j===void 0)throw new Error("Task is not valid");if(l.is(j.execution))await this.x(j,U,!1);else throw new m.$_;const O=await this.y(await this.a.$getTaskExecution(j),U);return this.a.$executeTask(j).catch(K=>{throw new Error(K)}),O}u(M,U,j,O){const K=[];if(O)for(const V of O){this.z(V,j),(!V.definition||!M[V.definition.type])&&this.f.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const me=b.from(V,j.extension);me&&l.is(me.execution)?(K.push(me),U.push(this.x(me,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:j.extension}}async v(M){if(l.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,U,j){}};e.$xdc=N,e.$xdc=N=He([Be(0,v.$lM),Be(1,y.$BM),Be(2,$.$xcc),Be(3,E.$wM),Be(4,w.$Acc),Be(5,I.$Scc),Be(6,r.$0i),Be(7,s.$ncc)],N),e.$ydc=(0,k.$Ph)("IExtHostTask")}),define(De[350],Ce([1,0,16,21,41,36,23,35,37]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class w{constructor(v,y,k){this.k=v,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.$wj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.$wj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const y=this.k.folderQueries||[];return new Promise((k,p)=>{const h=r=>{this.f++,v(r)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const s=r.toString(),o=D.$nc(s);this.j&&this.j(s,o)||this.v(h,{base:r,basename:o})}),Promise.all(y.map(r=>this.p(r,h))).then(r=>{k({limitHit:this.e,stats:r[0]||void 0})},r=>{p(new Error((0,f.$Ai)(r)))})})}async p(v,y){const k=new T.$Xd,p=this.q(v),h=this.r(),r=new E.$6I(this.k,v),s=!r.hasSiblingExcludeClauses();let o;try{this.h.add(k),o=$.$Jd.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,k.token),u=o.elapsed(),t=$.$Jd.create();return this.g&&!this.e||(m&&m.forEach(n=>{const c=D.$gc.relative(v.folder.path,n.path);if(s){const i=D.$nc(n.path);this.v(y,{base:v.folder,relativePath:c,basename:i});return}this.s(h,v.folder,c,y)}),this.g&&!this.e)?null:(this.u(h,r,y),{providerTime:u,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(v){const y=(0,E.$5I)(this.k.includePattern,v.includePattern),k=(0,E.$5I)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:k,includes:y,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},y,k,p){if(k===this.a){const r=D.$nc(this.a);this.v(p,{base:y,relativePath:this.a,basename:r})}function h(r){const s=D.$nc(r),o=D.$mc(r);let m=v[o];m||(m=v[o]=[],h(o)),m.push({base:y,relativePath:r,basename:s})}h(k)}u({rootEntries:v,pathToEntries:y},k,p){const h=this,r=this.a;function s(o){const m=(0,E.$8I)(()=>o.map(u=>u.basename));for(let u=0,t=o.length;u<t;u++){const n=o[u],{relativePath:c,basename:i}=n;if(k.matchesExcludesSync(c,i,r!==i?m:void 0))continue;const a=y[c];if(a)s(a);else{if(c===r)continue;h.v(p,n)}if(h.e)break}}s(v)}v(v,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(y))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,y,k,p){const h=this.c(v.cacheKey),r=new w(v,y,h&&h.token);let s=0;const o=m=>{s+=m.length,k(m.map(u=>this.d(u)))};return this.e(r,L.a,o,p).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:m.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new T.$Xd),this.b.get(v)}d(v){return v.relativePath?{resource:A.$vg(v.base,v.relativePath)}:{resource:v.base}}e(v,y,k,p){const h=p.onCancellationRequested(()=>{v.cancel()}),r=o=>{o&&(s.push(o),y>0&&s.length>=y&&(k(s),s=[]))};let s=[];return v.search(r).then(o=>(s.length&&k(s),h.dispose(),o),o=>(s.length&&k(s),h.dispose(),Promise.reject(o)))}}e.$Idc=L}),define(De[351],Ce([1,0,19,74,36,99,28,18,16,23,15,17,2,172,227,50,14,44,143,348,37]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=void 0;let u=class{constructor(g,d,P,N,F){this.a=g,this.b=d,this.c=P,this.d=N,this.e=F}text(g,d,P={}){g=this.f(g,P);const N=this.a.getValue(),F=d&&d.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(d?.map(r.$$h),P),type:2,contentPattern:g,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(g,d){const P=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const N={...g,wordSeparators:P.editor.wordSeparators};return this.j(g,d)&&(N.isCaseSensitive=!0),this.k(g)&&(N.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),N}file(g,d={}){return{...this.h(g,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}g(g,d){return g?(g=Array.isArray(g)?g.map(a):a(g),d?this.parseSearchPaths(g):{pattern:n(...Array.isArray(g)?g:[g])}):{}}h(g=[],d={}){const P=this.g(d.includePattern,d.expandPatterns),N=this.g(d.excludePattern,d.expandPatterns),F=g.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,d,N)):g.map(O=>this.r(O,d,N,F))).filter(O=>!!O),U={_reason:d._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const O=D.$Hb(D.$Rb(this.c.groups.map(me=>me.editors.map(te=>te.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const K=O.filter(me=>(0,m.$VI)(U,me.fsPath)),V=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...U,...V}}const j=d.extraFileResources&&d.extraFileResources.filter(O=>(0,m.$VI)(U,O.fsPath));return U.extraFileResources=j&&j.length?j:void 0,U}i(g){const d=[],P=new A.$Ac,N={};let F=!1;return g.forEach(M=>{if(M.scheme===$.Schemas.walkThrough)return;if((0,w.$zg)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$mc(M.fsPath)});let O=P.get(j);O||(F=!0,O={folder:j,includePattern:{}},d.push(O),P.set(j,O));const K=E.$lc(j.fsPath,M.fsPath);(0,I.$Jf)(O.includePattern)[K.replace(/\\/g,"/")]=!0}else M.fsPath&&(F=!0,N[M.fsPath]=!0)}),{folderQueries:d,includePattern:N,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(g,d){if(d.isSmartCase){if(g.isRegExp){if(L.$pf(g.pattern,!0))return!0}else if(L.$pf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,y.$vB)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const d=V=>E.$ic(V)||/^\.\.?([\/\\]|$)/.test(V),N=(Array.isArray(g)?g:c(g)).map(V=>{const me=this.e.resolvedUserHome;return me?(0,R.$uv)(V,me.scheme===$.Schemas.file?me.fsPath:me.path):V}),F=T.$J(N,V=>d(V)?"searchPaths":"exprSegments"),M=(F.exprSegments||[]).map(V=>L.$Ke(V,"/")).map(V=>L.$Ke(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),U={},j=this.m(F.searchPaths||[]);j&&j.length&&(U.searchPaths=j);const O=D.$Rb(M),K=n(...O);return K&&(U.pattern=K),U}l(g,d){return d.disregardExcludeSettings?void 0:(0,m.$UI)(g,!d.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const d=g.flatMap(N=>{let{pathPortion:F,globPortion:M}=t(N);return M&&(M=l(M)),this.n(F).flatMap(j=>this.o(j,M))}),P=new Map;return d.forEach(N=>{const F=N.searchPath.toString(),M=P.get(F);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):P.set(F,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(P.values())}n(g){if(E.$ic(g)){const d=this.b.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==$.Schemas.file?[{searchPath:d[0].uri.with({path:g})}]:[{searchPath:v.URI.file(E.$hc(g))}]}if(this.b.getWorkbenchState()===2){const d=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const N=E.$gc.resolve(d.path,g);return[{searchPath:d.with({path:N})}]}const P=l(g);return[{searchPath:d,pattern:P}]}else{if(g==="./"||g===".\\")return[];{const d=g.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(F=>{const M=d.match(new RegExp(`^${L.$Fe(F.name)}(?:/(.*)|$)`));return M?{match:M,folder:F}:null}).filter(I.$Gf);if(N.length)return N.map(F=>{const M=F.match[1];return{searchPath:F.folder.uri,pattern:M&&l(M)}});{const F=g.match(/\.[\/\\](.+)[\/\\]?/),M=F?F[1]:g,U=k.localize(0,null,M);throw new Error(U)}}}}o(g,d){const P=g.pattern&&d?`${g.pattern}/${d}`:g.pattern||d,N=[{searchPath:g.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:g.searchPath,pattern:P+"/**"}),N}q(g,d,P){const N=this.r((0,r.$$h)(g.searchPath),d,P,!1);return N?{...N,includePattern:g.pattern}:null}r(g,d,P,N){let F;const M=v.URI.isUri(g)?g:g.uri;if(P.searchPaths){const V=P.searchPaths.filter(me=>(0,w.$og)(me.searchPath,M))[0];if(V&&!V.pattern)return null;V&&(F=V.pattern)}const U=this.a.getValue({resource:M}),O={...this.l(U,d)||{},...F||{}},K=v.URI.isUri(g)?(0,w.$sg)(g):g.name;return{folder:M,folderName:N?K:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!U.search.followSymlinks}}};e.$1J=u,e.$1J=u=He([Be(0,p.$ji),Be(1,r.$Yh),Be(2,s.$nC),Be(3,h.$0i),Be(4,o.$YJ)],u);function t(b){const g=b.match(/[\*\{\}\(\)\[\]\?]/);if(g){const d=g.index,P=b.substr(0,d).match(/[/|\\][^/\\]*$/);if(P){let N=b.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function n(...b){return b.length?b.reduce((g,d)=>(g[d]=!0,g),Object.create(null)):void 0}function c(b){return f.$uj(b,",").map(g=>g.trim()).filter(g=>!!g.length)}function i(b){return[`**/${b}/**`,`**/${b}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function a(b){return b.replace(/\\/g,"/")}function l(b){return a(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(b){return b.replace(/([?*[\]])/g,"[$1]")}function S(b,g){b=D.$Mb(b,N=>N.toString());const d=[],P=g.getWorkspace();return b&&b.forEach(N=>{let F;if(g.getWorkbenchState()===2)F=(0,w.$xg)(P.folders[0].uri,N),F&&F!=="."&&(F="./"+F);else{const M=g.getWorkspaceFolder(N);if(M){const U=M.name;if(P.folders.filter(O=>O.name===U).length===1){const O=(0,w.$xg)(M.uri,N);O===""?F=`./${M.name}`:F=`./${M.name}/${O}`}else F=N.fsPath}}F&&d.push(C(F))}),d}e.$2J=S}),define(De[352],Ce([1,0,23,2,21,9,5,351,37,44]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flb=e.$Elb=void 0;const L=7e3;function I(p,h){const r=h.activationEvents;if(!r)return Promise.resolve(void 0);const s=[],o=[];for(const i of r)if(/^workspaceContains:/.test(i)){const a=i.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||p.forceUsingSearch?o.push(a):s.push(a)}if(s.length===0&&o.length===0)return Promise.resolve(void 0);let m;const u=new Promise((i,a)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(s.map(i=>v(p,i,t))).then(()=>{}),c=y(p,h.identifier,o,t);return Promise.all([n,c]).then(()=>{m(void 0)}),u}e.$Elb=I;async function v(p,h,r){for(const s of p.folders)if(await p.exists(D.$vg(T.URI.revive(s),h))){r(`workspaceContains:${h}`);return}}async function y(p,h,r,s){if(r.length===0)return Promise.resolve(void 0);const o=new f.$Xd,m=p.checkExists(p.folders,r,o.token),u=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},L);let t=!1;try{t=await m}catch(n){R.$4(n)||R.$1(n)}o.dispose(),clearTimeout(u),t&&s(`workspaceContains:${r.join(",")}`)}function k(p,h,r,s){const o=p.get(A.$Oh),m=p.get(E.$MI),t=o.createInstance($.$1J).file(h.map(n=>(0,w.$$h)(T.URI.revive(n))),{_reason:"checkExists",includePattern:r,exists:!0});return m.fileSearch(t,s).then(n=>!!n.limitHit,n=>R.$4(n)?!1:Promise.reject(n))}e.$Flb=k}),define(De[46],Ce([1,0,205,16,54,23,8,3,78,2,14,6,40,288,115,39,26,148,9,25,22,263,7,65,5,27,90,20,104,73,45,4,352,114,265,18,112,35,12,113]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n,c,i,a,l,C,S,b,g,d,P,N,F,M,U,j,O){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=e.$5cc=e.$4cc=void 0,e.$4cc=(0,c.$Ph)("IHostUtils");let V=K=class extends $.$Sc{constructor(H,B,X,re,Y,_,x,ve,ae,fe,ee,de){super(),this.X=de,this.a=this.B(new g.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=X,this.f=x,this.j=re,this.m=Y,this.s=_,this.t=ae,this.u=fe,this.w=ee,this.y=this.g.getProxy(I.$kK.MainThreadWorkspace),this.z=this.g.getProxy(I.$kK.MainThreadTelemetry),this.C=this.g.getProxy(I.$kK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ce(this.f.extensions.activationEvents),this.L=new r.$x4b(this.I,this.f.extensions.allExtensions);const be=new o.$7l(this.f.extensions.myExtensions);this.J=new r.$x4b(this.I,le(this.L,be)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${G(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${G(this.J)}`)),this.M=new k.$Kcc(this.g,this.s),this.N=new P.$Wcc(this.g),this.O=ve,this.h=H.createChild(new C.$Nh([k.$Lcc,this.M],[P.$Xcc,this.N])),this.P=this.B(new y.$Jcc(this.J,this.L,{onExtensionActivationError:(Pe,z,J)=>{this.C.$onExtensionActivationError(Pe,s.$3(z),J)},actualActivateExtension:async(Pe,z)=>{if(r.$x4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,z),new y.$Icc;const J=this.J.getExtensionDescription(Pe);return this.db(J,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){s.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this.cb(Y))}catch{}await Promise.all(H)}terminate(H,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),s.setUnexpectedErrorHandler(re=>{this.s.error(re)}),this.g.dispose();const X=this.Y();Promise.race([(0,A.$Ug)(5e3),X]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const B=await this.C.$getExtension(H);return B&&{...B,identifier:new o.$6l(B.identifier.value),extensionLocation:w.URI.revive(B.extensionLocation)}}Z(H,B){return this.P.activateByEvent(H,B)}$(H,B){return this.P.activateById(H,B)}activateByIdWithErrors(H,B){return this.$(H,B).then(()=>{const X=this.P.getActivatedExtension(H);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===F.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(H.fsPath);return w.URI.file(B)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new ie(H))),this.Q}async bb(H){const B=E.$Vh.forUris(X=>R.$mg.ignorePathCasing(X));return await Promise.all(H.map(async X=>{if(this.ub(X)){const re=await this.ab(X.extensionLocation);B.set(re,X)}})),B}cb(H){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return B;const X=this.P.getActivatedExtension(H);if(!X)return B;try{typeof X.module.deactivate=="function"&&(B=Promise.resolve(X.module.deactivate()).then(void 0,re=>(this.s.error(re),Promise.resolve(void 0))))}catch(re){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(re)}try{(0,$.$Nc)(X.subscriptions)}catch(re){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(re)}return B}async db(H,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,B).then(X=>{const re=X.activationTimes;return this.C.$onDidActivateExtension(H.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,B),this.eb(H,B,"success",re),X},X=>{throw this.eb(H,B,"failure"),X})}eb(H,B,X,re){const Y=te(H,B);this.z.$publicLog2("extensionActivationTimes",{...Y,...re||{},outcome:X})}fb(H,B){const X=te(H,B);this.z.$publicLog2("activatePlugin",X);const re=this.ub(H);if(!re)return Promise.resolve(new y.$Hcc(y.$Ecc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${H.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const Y=new y.$Fcc(B.startup);return Promise.all([this.vb(H,(0,R.$vg)(H.extensionLocation,re),Y),this.gb(H)]).then(_=>(f.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),K.hb(this.s,H.identifier,_[0],_[1],Y))).then(_=>(f.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),_))}gb(H){const B=new u.$Ncc(H,this.M),X=new u.$Mcc(H.identifier.value,!1,this.M),re=new N.$Ycc(H,this.N),Y=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([B.whenReady,X.whenReady,this.O.whenReady]).then(()=>{const x=this;let ve,ae;const fe=(0,h.$gF)(H,"ipc")?this.f.messagePorts?.get(o.$6l.toKey(H.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:X,secrets:re,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(ee){return T.$jc(H.extensionLocation.fsPath,ee)},get storagePath(){return x.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return x.O.globalValue(H).fsPath},get logPath(){return T.$jc(x.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return w.URI.joinPath(x.f.logsLocation,H.identifier.value)},get storageUri(){return x.O.workspaceValue(H)},get globalStorageUri(){return x.O.globalValue(H)},get extensionMode(){return Y},get extension(){return ve===void 0&&(ve=new Q(x,H.identifier,H,_,!1)),ve},get extensionRuntime(){return(0,h.$hF)(H,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ae){if(!fe)return;const ee=g.Event.buffer(g.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ae={onDidReceiveMessage:ee,postMessage:fe.postMessage.bind(fe)}}return ae}})})}static hb(H,B,X,re,Y){return X=X||{activate:void 0,deactivate:void 0},this.ib(H,B,X,re,Y).then(_=>new y.$Gcc(!1,null,Y.build(),X,_,re.subscriptions))}static ib(H,B,X,re,Y){if(typeof X.activate=="function")try{Y.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${B.value}`);const _=typeof global=="object"?global:self,x=X.activate.apply(_,[re]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(x).then(ve=>(Y.activateResolveStop(),ve))}catch(_){return Promise.reject(_)}else return Promise.resolve(X)}jb(H,B){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:B}).then(void 0,X=>{this.s.error(X)})}kb(H,B=0){const re=Date.now();(0,j.$B)(()=>{for(let Y=B;Y<H.length;Y+=1){const _=H[Y];for(const x of _.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-re>50){this.kb(H,Y);break}else this.jb(_,x)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(H=>{const B=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this.J.getAllExtensionDescriptions();if(B)this.kb(X);else for(const re of X)if(re.activationEvents)for(const Y of re.activationEvents)Y==="onStartupFinished"&&this.jb(re,Y)})}mb(){const H=this.Z("*",!0).then(void 0,_=>{this.s.error(_)});this.B(this.j.onDidChangeWorkspace(_=>this.nb(_.added)));const B=this.j.workspace?this.j.workspace.folders:[],X=this.nb(B),re=this.pb(),Y=Promise.all([re,H,X]).then(()=>{});return Promise.race([Y,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),Y}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(H,B))).then(()=>{})}async ob(H,B){if(this.isActivated(B.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,re={logService:this.s,folders:H.map(_=>_.uri),forceUsingSearch:X||!this.c.fsExists,exists:_=>this.c.fsExists(_.fsPath),checkExists:(_,x,ve)=>this.y.$checkExists(_,x,ve)},Y=await(0,d.$Elb)(re,B);if(Y)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Y.activationEvent}).then(void 0,_=>this.s.error(_))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:B}=this.f.environment;if(!H||!B)throw new Error(D.localize(0,null));const X=await this.vb(null,B,new y.$Fcc(!1));if(!X||typeof X.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((re,Y)=>{const _=(ae,fe)=>{ae?(j.$t&&this.s.error("Test runner called back with error",ae),Y(ae)):(j.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),re(typeof fe=="number"&&fe>0?1:0))},x=(0,R.$jg)(B),ve=X.run(x,_);ve&&ve.then&&ve.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),re(0)}).catch(ae=>{j.$t&&this.s.error("Test runner finished with error",ae),Y(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,B){return this.R[H]=B,(0,$.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:B}=await this.sb(H);return B?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const B=H.indexOf("+");if(B===-1)throw new t.$sK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const X=H.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.R[X]}}async $resolveAuthority(H,B){const X=U.$Jd.create(!1),re=()=>`[resolveAuthority(${(0,n.$Tk)(H)},${B})][${X.elapsed()}ms] `,Y=oe=>this.s.info(`${re()}${oe}`),_=oe=>this.s.warn(`${re()}${oe}`),x=(oe,Z=void 0)=>this.s.error(`${re()}${oe}`,Z),ve=oe=>{if(oe instanceof t.$sK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ae=async oe=>{Y(`activating resolver for ${oe}...`);const{resolver:Z,authorityPrefix:ge}=await this.sb(oe);if(!Z)throw x(`no resolver for ${ge}`),new t.$sK(`No remote extension installed to resolve ${ge}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:ge,remoteAuthority:oe}},fe=H.split(/@|%40/g).reverse();Y(`activating remote resolvers ${fe.join(" -> ")}`);let ee;try{ee=await Promise.all(fe.map(ae)).catch(async oe=>{if(!(oe instanceof t.$sK)||oe._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return _(`resolving nested authorities failed: ${oe.message}`),[await ae(H)]})}catch(oe){return ve(oe)}const de=new A.$5g;de.cancelAndSet(()=>Y("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:Z,resolver:ge,remoteAuthority:Ee}]of ee.entries())try{if(oe===ee.length-1)Y("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Z}`),be=await ge.resolve(Ee,{resolveAttempt:B,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${Z}`),Y("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$rK.isManagedResolvedAuthority(be)?be:void 0));else{if(Y(`invoking resolveExecServer() for ${Ee}`),f.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await ge.resolveExecServer?.(Ee,{resolveAttempt:B,execServer:Pe}),!Pe)throw new t.$sK(`Exec server was not available for ${Ee}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${Z}`),x("returned an error",je),de.dispose(),ve(je)}de.dispose();const z={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},J={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};Y(`returned ${t.$rK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let se;if(t.$rK.isManagedResolvedAuthority(be)){const oe=B;this.X.setFactory(oe,be.makeConnection),se={authority:H,connectTo:new n.$Qk(oe),connectionToken:be.connectionToken}}else se={authority:H,connectTo:new n.$Rk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:se,options:J,tunnelInformation:z}}}async $getCanonicalURI(H,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Tk)(H)})`);const{resolver:X}=await this.sb(H);if(!X)return null;const re=w.URI.revive(B);if(typeof X.getCanonicalURI>"u")return re;const Y=await(0,A.$Mg)(()=>X.getCanonicalURI(re));return Y||re}$startExtensionHost(H){H.toAdd.forEach(re=>re.extensionLocation=w.URI.revive(re.extensionLocation));const{globalRegistry:B,myExtensions:X}=me(this.I,this.L,this.J,H);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${G(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${G(this.J)}`)),this.rb()}$activateByEvent(H,B){return B===1?this.D.wait().then(X=>this.Z(H,!1)):this.G.wait().then(X=>this.Z(H,!1))}async $activate(H,B){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,B),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(_=>_.extensionLocation=w.URI.revive(_.extensionLocation));const{globalRegistry:B,myExtensions:X}=me(this.I,this.L,this.J,H),re=await this.bb(X);return(await this.getExtensionPathIndex()).setSearchTree(re),this.L.set(B.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${G(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${G(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const B=m.$be.alloc(H),X=Math.random()%256;for(let re=0;re<H;re++)B.writeUInt8(X,re);return B}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$5cc=V,e.$5cc=V=K=He([Be(0,c.$Oh),Be(1,e.$4cc),Be(2,l.$lM),Be(3,p.$xcc),Be(4,v.$Acc),Be(5,L.$0i),Be(6,i.$BM),Be(7,a.$Qcc),Be(8,S.$bwb),Be(9,b.$Scc),Be(10,M.$1cc),Be(11,O.$2cc)],V);function me(pe,H,B,X){pe.addActivationEvents(X.addActivationEvents);const re=new r.$x4b(pe,H.getAllExtensionDescriptions());re.deltaExtensions(X.toAdd,X.toRemove);const Y=new o.$7l(B.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of X.myToRemove)Y.delete(x);for(const x of X.myToAdd)Y.add(x);const _=le(re,Y);return{globalRegistry:re,myExtensions:_}}function te(pe,H){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function G(pe){return pe.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$6cc=(0,c.$Ph)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(H,B,X,re,Y){this.#e=H,this.#t=B,this.#i=X.identifier,this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=T.$hc((0,R.$jg)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=re,this.isFromDifferentExtensionHost=Y}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$7cc=Q;function le(pe,H){return pe.getAllExtensionDescriptions().filter(B=>H.has(B.identifier))}class ie{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$8cc=ie;class ce{constructor(H){this.a=new o.$8l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const B of Object.keys(H))this.a.set(B,H[B])}}}),define(De[353],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;let p=class{constructor(m,u,t,n,c,i,a){this.c=m,this.d=u,this.e=t,this.f=n,this.g=c,this.h=i,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new r(this.c,u,this.d,m,this.i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(s,u,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const u of m.nodeModuleName)this.a.set(u,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(u=>m.alternativeModuleName(u))}};e.$tec=p,e.$tec=p=He([Be(2,L.$Oh),Be(3,R.$Acc),Be(4,I.$6cc),Be(5,w.$BM),Be(6,v.$0i)],p);let h=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&k.a.size){const u=(0,y.$Fe)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${c}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const u=this.b.exec(this.c(m));if(!u)return;const[,t,n,c]=u,i=k.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+c}c(m){return m.replace(/\\/g,"/")}};h=k=He([Be(0,w.$BM)],h);class r{constructor(m,u,t,n,c){this.c=m,this.d=u,this.e=t,this.f=n,this.g=c,this.nodeModuleName="vscode",this.a=new $.$8l}load(m,u){const t=this.d.findSubstr(u);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((c,i)=>n+=`	${i} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$bF,this.e,this.f)}return this.b}}let s=class{constructor(m,u,t){this.e=m,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$kK.MainThreadTelemetry);const n=t.getProxy(f.$kK.MainThreadWindow);this.c=(c,i)=>{const a=T.URI.parse(c);return i?this.g(c,i):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,c,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?n.$openUri(a,c,{}):this.g(c,i)}}load(m,u,t){const n=this.e.findSubstr(u);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,u){return this.i(),this.b(m,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=He([Be(2,E.$lM)],s)}),define(De[56],Ce([1,0,47,3,16,48,5,70,71,46,7,39,280,40]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=e.$Bdc=void 0,e.$Bdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class k extends v.$mN{constructor(r,s,o,m,u,t,n){function c(){if(o){const i=o.activeEditor();if(i)return i.document.uri;const a=m.tabGroups.all.find(l=>l.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof L.$5L||a.input instanceof L.$0L)return a.input.modified;if(a.input instanceof L.$4L||a.input instanceof L.$9L||a.input instanceof L.$7L)return a.input.uri}}}super({getFolderUri:i=>{const a=t.folders.filter(l=>l.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,a)=>u.getConfiguration(void 0,i).get(a),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=c();if(i)return f.$hc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const i=c();if(i){const a=s.getWorkspaceFolder(i);if(a)return f.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(o){const i=o.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(o){const i=o.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>r.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let p=class extends T.$Sc{constructor(r,s,o,m,u){super(),this.b=r,this.c=s,this.g=o,this.h=m,this.j=u,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Cdc=p,e.$Cdc=p=He([Be(0,w.$6cc),Be(1,I.$xcc),Be(2,$.$wM),Be(3,y.$Acc),Be(4,E.$zdc)],p)}),define(De[94],Ce([1,0,8,4,2,5,6,71,46,20,7,39,140,273,40,56]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=e.$Ddc=void 0,e.$Ddc=(0,R.$Ph)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,c,i,a,l,C){this.E=c,this.F=i,this.G=a,this.H=l,this.I=C,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Nd,this.n=new T.$Nd,this.o=new T.$Nd,this.u=new T.$Nd,this.k=n.getProxy(A.$kK.MainThreadDebugService),this.y=new T.$Nd,this.A=new T.$Nd,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(b=>{this.J(S)}),this.J(S)})}asDebugSourceUri(n,c){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let a=`debug:${encodeURIComponent(i.path||"")}`,l="?";return c&&(a+=`${l}session=${encodeURIComponent(c.id)}`,l="&"),a+=`${l}ref=${i.sourceReference}`,f.URI.parse(a)}else{if(i.path)return f.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const c=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const a=i.contributes.debuggers;if(a&&a.length>0)for(const l of a)(0,y.$vF)(l)&&c.push(l.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(c=>n.push(c)),n}addBreakpoints(n){const c=n.filter(l=>{const C=l.id;return this.w.has(C)?!1:(this.w.set(C,l),!0)});this.U(c,[],[]);const i=[],a=new Map;for(const l of c)if(l instanceof L.$lL){let C=a.get(l.location.uri.toString());C||(C={type:"sourceMulti",uri:l.location.uri,lines:[]},a.set(l.location.uri.toString(),C),i.push(C)),C.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof L.$mL&&i.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const c=n.filter(C=>this.w.delete(C.id));this.U([],c,[]);const i=c.filter(C=>C instanceof L.$lL).map(C=>C.id),a=c.filter(C=>C instanceof L.$mL).map(C=>C.id),l=c.filter(C=>C instanceof L.$nL).map(C=>C.id);return this.k.$unregisterBreakpoints(i,a,l)}startDebugging(n,c,i){return this.k.$startDebugging(n?n.uri:void 0,c,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,c,i){if(!c)return new L.$mK(()=>{});const a=this.d++;return this.f.push({type:n,handle:a,provider:c}),this.k.$registerDebugConfigurationProvider(n,i,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,a),new L.$mK(()=>{this.f=this.f.filter(l=>l.provider!==c),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,c,i){if(!i)return new L.$mK(()=>{});if(!this.Q(n,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:c,handle:a,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(c,a),new L.$mK(()=>{this.h=this.h.filter(l=>l.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,c){if(!c)return new L.$mK(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:c}),new L.$mK(()=>{this.j=this.j.filter(a=>a.factory!==c)})}async $runInTerminal(n,c){return Promise.resolve(void 0)}async $substituteVariables(n,c){let i;const a=await this.W(n);return a&&(i={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,c)}K(n,c){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,c){const i=this,a=await this.V(c);return this.S(this.N(a.type),a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const C=this.M(l),S=this.K(C,a);if(!S)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const b=S;return this.B.set(n,b),this.R(a).then(g=>(g&&this.C.set(n,g),b.onMessage(async d=>{if(d.type==="request"&&d.command==="handshake"){const P=d,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const F=await this.D.sign(P.arguments.value);N.body={signature:F},b.sendResponse(N)}else throw new Error("no signer")}catch(F){N.success=!1,N.message=F.message,b.sendResponse(N)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(d),d=(0,y.$AF)(d,!0),i.k.$acceptDAMessage(n,d)}),b.onError(d=>{g&&g.onError&&g.onError(d),this.k.$acceptDAError(n,d.name,d.message,d.stack)}),b.onExit(d=>{g&&g.onExit&&g.onExit(d??void 0,void 0),this.k.$acceptDAExit(n,d??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),b.startSession()))})}$sendDAMessage(n,c){c=(0,y.$zF)(c,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(c),this.B.get(n)?.sendMessage(c)}$stopDASession(n){const c=this.C.get(n);this.C.delete(n),c&&c.onWillStopSession&&c.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const c=[],i=[],a=[];if(n.added)for(const l of n.added){const C=l.id;if(C&&!this.w.has(C)){let S;if(l.type==="function")S=new L.$mL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")S=new L.$nL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const b=f.URI.revive(l.uri);S=new L.$lL(new L.$yK(b,new L.$nK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,L.$jL)(S,C),this.w.set(C,S),c.push(S)}}if(n.removed)for(const l of n.removed){const C=this.w.get(l);C&&(this.w.delete(l),i.push(C))}if(n.changed){for(const l of n.changed)if(l.id){const C=this.w.get(l.id);if(C){if(C instanceof L.$mL&&l.type==="function"){const S=C;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.functionName=l.functionName}else if(C instanceof L.$lL&&l.type==="source"){const S=C;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.location=new L.$yK(f.URI.revive(l.uri),new L.$nK(l.line,l.character))}a.push(C)}}}this.U(c,i,a)}async $acceptStackFrameFocus(n){let c;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?c=new L.$tL(i,n.threadId):c=new L.$sL(i,n.threadId,n.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(n,c,i){return(0,D.$Mg)(async()=>{const a=this.P(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(c);return a.provideDebugConfigurations(l,i)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,c,i,a){return(0,D.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.W(c);return l.resolveDebugConfiguration(C,i,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,c,i,a){return(0,D.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.W(c);return l.resolveDebugConfigurationWithSubstitutedVariables(C,i,a)})}async $provideDebugAdapter(n,c){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(c);return this.S(i,a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(n){const c=await this.V(n);this.m.fire(c)}async $acceptDebugSessionTerminated(n){const c=await this.V(n);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,c){(await this.V(n))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(n,c){const a={session:await this.V(n),event:c.event,body:c.body};this.u.fire(a)}M(n){if(n instanceof L.$oL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof L.$pL)return{type:"server",port:n.port,host:n.host};if(n instanceof L.$qL)return{type:"pipeServer",path:n.path};if(n instanceof L.$rL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const c=this.h.filter(i=>i.type===n);if(c.length>0)return c[0].factory}O(n){const c=this.h.filter(i=>i.handle===n);if(c.length>0)return c[0].factory}P(n){const c=this.f.filter(i=>i.handle===n);if(c.length>0)return c[0].provider}Q(n,c){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const a of i)if(a.label&&a.type&&a.type===c)return!0}}return!1}R(n){const i=n.configuration.type,a=this.j.filter(l=>l.type===i||l.type==="*").map(l=>(0,D.$Mg)(()=>l.factory.createDebugAdapterTracker(n)).then(C=>C,C=>null));return Promise.race([Promise.all(a).then(l=>{const C=l.filter(S=>!!S);if(C.length>0)return new o(C)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(n,c){const i=c.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new L.$pL(i));if(n){const l=await this.F.getExtensionRegistry();return(0,D.$Mg)(()=>n.createDebugAdapterDescriptor(c,this.T(c,l))).then(C=>{if(C)return C})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,a))}T(n,c){}U(n,c,i){(n.length>0||c.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:c,changed:i}))}async V(n){if(n)if(typeof n=="string"){const c=this.l.get(n);if(c)return c}else{let c=this.l.get(n.id);if(!c){const i=await this.W(n.folderUri),a=n.parent?this.l.get(n.parent):void 0;c=new r(this.k,n.id,n.type,n.name,i,n.configuration,a),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(n){if(n){const c=f.URI.revive(n);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$Edc=h,e.$Edc=h=He([Be(0,w.$lM),Be(1,I.$xcc),Be(2,E.$6cc),Be(3,k.$Acc),Be(4,$.$zdc),Be(5,p.$Bdc)],h);class r{constructor(n,c,i,a,l,C,S){this.d=n,this.f=c,this.g=i,this.h=a,this.i=l,this.j=C,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,c){return this.d.$customDebugAdapterRequest(this.f,n,c)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$Fdc=r;class s{constructor(n){this.value=Object.freeze({append(c){n.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$Gdc=s;class o{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(c=>c.onError?c.onError(n):void 0)}onExit(n,c){this.d.forEach(i=>i.onExit?i.onExit(n,c):void 0)}}class m extends v.$0cb{constructor(n){super(),this.h=n,n.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(n,c,i,a,l,C){super(n,c,i,a,l,C)}};e.$Hdc=u,e.$Hdc=u=He([Be(0,w.$lM),Be(1,I.$xcc),Be(2,E.$6cc),Be(3,k.$Acc),Be(4,$.$zdc),Be(5,p.$Bdc)],u)}),define(De[354],Ce([1,0,9,54,2,6,345,14,103,104,27,239,20,67,46,88]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=void 0;class h{static async installEarlyHandler(o){Error.stackTraceLimit=100;const m=o.get($.$0i),t=o.get(v.$lM).getProxy(R.$kK.MainThreadErrors);D.setUnexpectedErrorHandler(n=>{m.error(n);const c=D.$3(n);t.$onUnexpectedError(c)})}static async installFullHandler(o){const m=o.get($.$0i),u=o.get(v.$lM),t=o.get(k.$6cc),n=o.get(p.$FM),c=u.getProxy(R.$kK.MainThreadExtensionService),i=u.getProxy(R.$kK.MainThreadErrors),a=await t.getExtensionPathIndex(),l=new WeakMap;function C(g,d){if(l.has(g))return l.get(g).stack;let P="",N,F;for(const U of d)P+=`
	at ${U.toString()}`,F=U.getFileName(),!N&&F&&(N=a.findSubstr(f.URI.file(F)));const M=`${g.name||"Error"}: ${g.message||""}${P}`;return l.set(g,{extensionIdentifier:N?.identifier,stack:M}),M}const S=Symbol("prepareStackTrace wrapped");let b=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(g){if(g===C||!g||g[S]){b=g||C;return}b=function(d,P){return C(d,P),g.call(Error,d,P)},Object.assign(b,{[S]:!0})}}),D.setUnexpectedErrorHandler(g=>{m.error(g);const d=D.$3(g),P=l.get(g);if(!P?.extensionIdentifier){i.$onUnexpectedError(d);return}c.$onExtensionRuntimeError(P.extensionIdentifier,d);const N=n.onExtensionError(P.extensionIdentifier,g);m.trace("forwarded error to extension?",N,P)})}}e.$uec=h;class r{constructor(o,m,u,t,n){this.a=u,this.b=new A.$G4b(o,null,t),m=r.e(m,this.b);const c=new w.$Nh(...(0,E.$xr)());c.set(L.$BM,{_serviceBrand:void 0,...m,messagePorts:n}),c.set(v.$lM,new v.$mM(this.b)),c.set(y.$ucc,new y.$vcc(t)),c.set(k.$4cc,u);const i=new I.$dq(c,!0);i.invokeFunction(h.installEarlyHandler),this.d=i.invokeFunction(a=>a.get($.$0i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(a=>a.get(k.$6cc)),this.c.initialize(),i.invokeFunction(h.installFullHandler)}async asBrowserUri(o){const m=this.b.getProxy(R.$kK.MainThreadExtensionService);return f.URI.revive(await m.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,m){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=f.URI.revive(m.transformIncomingURIs(o.environment.appRoot));const u=o.environment.extensionDevelopmentLocationURI;return u&&(o.environment.extensionDevelopmentLocationURI=u.map(t=>f.URI.revive(m.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=f.URI.revive(m.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=f.URI.revive(m.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=f.URI.revive(m.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=f.URI.revive(m.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=f.URI.revive(m.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=f.URI.revive(m.transformIncomingURIs(o.logsLocation)),o.workspace=m.transformIncomingURIs(o.workspace),o}}e.$vec=r}),define(De[355],Ce([1,0,8,12,216,233,138,94,71,46,20,45,7,56,39,274,275,40]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let s=class extends $.$Edc{constructor(n,c,i,a,l,C,S){super(n,c,i,a,C,S),this.Z=l,this.X=new u}K(n,c){switch(n.type){case"server":return new p.$Aec(n);case"pipeServer":return new p.$Bec(n);case"executable":return new p.$Cec(n,c.type)}return super.K(n,c)}T(n,c){const i=p.$Cec.platformAdapterExecutable(c.getAllExtensionDescriptions(),n.type);if(i)return new v.$oL(i.command,i.args,i.options)}L(){return new A.$r8b}async $runInTerminal(n,c){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),C=n.title||f.localize(0,null),S=JSON.stringify({shell:a,shellArgs:l});let b=await this.X.checkout(S,C),g,d=!1;if(b)g=n.cwd;else{const M={shellPath:a,shellArgs:l,cwd:n.cwd,name:C,iconPath:new v.$gL("debug")};d=!0,b=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(b,S)}b.show(!0);const P=await b.processId;d?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?b.sendText("cls"):a.indexOf("bash")>=0?b.sendText("clear"):T.$j?b.sendText("cls"):b.sendText("clear"));const N=(0,h.$Eec)(a,n.args,!!n.argsCanBeInterpretedByShell,g,n.env);b.sendText(N);const F=this.onDidTerminateDebugSession(M=>{M.id===c&&(this.X.free(b),F.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,c)}};e.$Fec=s,e.$Fec=s=He([Be(0,L.$lM),Be(1,k.$xcc),Be(2,w.$6cc),Be(3,r.$Acc),Be(4,I.$Scc),Be(5,E.$zdc),Be(6,y.$Bdc)],s);let o;function m(t,n){if(!o)if(T.$j)o=new R.$d7b;else if(T.$k)o=new R.$e7b;else if(T.$l)o=new R.$f7b;else throw new Error("external terminals not supported on this platform");const c=n.getConfiguration("terminal");return o.runInTerminal(t.title,t.cwd,t.args,t.env||{},c.external||{})}class u{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,c){const a=[...this.b.entries()].map(([l,C])=>(0,D.$Hg)(async S=>{if(l.name!==c||C.lastUsedAt!==-1&&await(0,h.$Dec)(await l.processId))return null;const b=Date.now();return C.lastUsedAt+u.a>b||S.isCancellationRequested||C.config!==n?null:(C.lastUsedAt=b,l)}));return await(0,D.$Yg)(a,l=>!!l)}insert(n,c){this.b.set(n,{lastUsedAt:Date.now(),config:c})}free(n){const c=this.b.get(n);c&&(c.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[356],Ce([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let o=class extends v.$wdc{constructor(u,t,n,c,i,a,l,C,S){super(u,t,n,c,i,a,l,C),this.B=n,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const c=v.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(c);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(i,t);return this.a.$executeTask(c).catch(()=>{}),a}else{const c=v.TaskDTO.from(t,u);if(c===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(c.execution)&&await this.x(c,t,!1);const i=await this.y(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),i}}u(u,t,n,c){const i=[];if(c)for(const a of c){this.z(a,n),(!a.definition||!u[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const l=v.TaskDTO.from(a,n.extension);l&&(i.push(l),v.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,a,!0)))}return{tasks:i,extension:n.extension}}async v(u){return u}async F(u){let t=u&&u.length>0?u[0]:void 0;if(!t){const n=T.URI.file((0,r.homedir)());t=new E.$0h({uri:n,name:h.$sg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(u,t){const n=T.URI.revive(u),c={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),a=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),C=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const S of t.variables)c.variables[S]=await l.resolveAsync(C,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(D.$tc);for(let b=0;b<S.length;b++)S[b]=await l.resolveAsync(C,S[b])}c.process=await f.win32.findExecutable(await l.resolveAsync(C,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(C,t.process.cwd):void 0,S)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(u,t,n){return f.win32.findExecutable(u,t,n)}};e.$xec=o,e.$xec=o=He([Be(0,L.$lM),Be(1,I.$BM),Be(2,R.$xcc),Be(3,A.$wM),Be(4,$.$Acc),Be(5,w.$Scc),Be(6,k.$0i),Be(7,p.$ncc),Be(8,s.$Bdc)],o)}),define(De[357],Ce([1,0,63,56]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class f extends T.$Cdc{m(){return(0,D.homedir)()}}e.$dfc=f}),define(De[153],Ce([1,0,19,8,21,41,18,16,23,2,37]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=e.$Kdc=e.$Jdc=void 0;class I{constructor(s,o,m,u){this.d=s,this.e=o,this.f=m,this.g=u,this.a=null,this.b=!1,this.c=0}search(s,o){const m=this.d.folderQueries||[],u=new f.$Xd(o);return new Promise((t,n)=>{this.a=new y(s);let c=!1;const i=(a,l)=>{if(!c&&!this.b){const C=this.h(a);p(a)&&typeof this.d.maxResults=="number"&&this.c+C>this.d.maxResults&&(this.b=!0,c=!0,u.cancel(),a=this.j(a,this.d.maxResults-this.c));const S=this.h(a);this.c+=S,(S>0||!p(a))&&this.a.add(a,l)}};Promise.all(m.map((a,l)=>this.k(a,C=>i(C,l),u.token))).then(a=>{u.dispose(),this.a.flush();const l=a.some(C=>!!C&&!!C.limitHit);t({limitHit:this.b||l,messages:(0,D.$Rb)(a.map(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[])),stats:{type:this.g}})},a=>{u.dispose();const l=(0,R.$Ai)(a);n(new Error(l))})})}h(s){return p(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,o){const m=Array.isArray(s.ranges)?s.ranges:[s.ranges],u=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:m.slice(0,o),preview:{matches:u.slice(0,o),text:s.preview.text},uri:s.uri}}async k(s,o,m){const u=new L.$6I(this.d,s),t=[],n={report:a=>{if(!this.l(a))return;const l=s.folder.scheme===A.Schemas.file?(0,L.$7I)(()=>this.f.readdir(E.$ug(a.uri))):void 0,C=E.$xg(s.folder,a.uri);if(C){const S=u.includedInQuery(C,$.$nc(C),l);(0,T.$Gg)(S)?t.push(S.then(b=>{b&&o(a)})):S&&o(a)}}},c=this.n(s),i=await this.e.provideTextSearchResults(v(this.d.contentPattern),c,n,m);return t.length&&await Promise.all(t),i}l(s){if(p(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const o=(0,L.$5I)(this.d.includePattern,s.includePattern),m=(0,L.$5I)(this.d.excludePattern,s.excludePattern),u={folder:w.URI.from(s.folder),excludes:m,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$Jdc=I;function v(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class y{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new h(512,o=>this.g(o))}add(s,o){this.d&&(this.b!==o||!E.$og(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:s.uri,results:[]}),this.d.results.push(k(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$Kdc=y;function k(r){return p(r)?{preview:{matches:(0,D.$2b)(r.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:r.preview.text},ranges:(0,D.$2b)(r.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function p(r){return!!r.preview}e.$Ldc=p;class h{static{this.a=4e3}static{this.b=50}constructor(s,o){this.g=s,this.h=o,this.c=0,this.d=[],this.e=0}addItem(s,o){s&&this.j(s,o)}addItems(s,o){s&&this.k(s,o)}j(s,o){this.d.push(s),this.e+=o,this.l()}k(s,o){this.d=this.d.concat(s),this.e+=o,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Mdc=h}),define(De[95],Ce([1,0,3,6,5,350,20,67,14,2,153]),function($e,e,D,T,f,R,A,$,E,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=void 0,e.$Ndc=(0,f.$Ph)("IExtHostSearch");let I=class{constructor(p,h,r){this.k=p,this.l=h,this.n=r,this.c=this.k.getProxy(T.$kK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Idc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,h){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const r=this.d++;return this.e.set(r,h),this.c.$registerTextSearchProvider(r,this.o(p)),(0,D.$Qc)(()=>{this.g.delete(p),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(p,h){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const r=this.d++;return this.h.set(r,h),this.c.$registerFileSearchProvider(r,this.o(p)),(0,D.$Qc)(()=>{this.i.delete(p),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(p,h,r,s){const o=v(r),m=this.h.get(p);if(m)return this.j.fileSearch(o,m,u=>{this.c.$handleFileMatch(p,h,u.map(t=>t.resource))},s);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,h,r,s){const o=this.e.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const m=v(r);return this.q(m,o).search(t=>this.c.$handleTextMatch(p,h,t),s)}$enableExtensionHostSearch(){}q(p,h){return new L.$Jdc(p,h,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$Odc=I,e.$Odc=I=He([Be(0,A.$lM),Be(1,$.$ucc),Be(2,E.$0i)],I);function v(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(p=>w.URI.revive(p))}}e.$Pdc=v;function y(k){return{...k,folder:w.URI.revive(k.folder)}}}),define(De[358],Ce([1,0,21,9,4,38,2,130,125,168,185,30,6,111,304,303,34,305,40,307,308,309,282,310,70,46,312,313,318,319,320,152,286,326,327,330,115,45,332,289,13,7,85,335,91,151,39,25,278,317,66,149,93,94,95,14,67,20,27,321,276,73,89,296,333,90,72,338,336,337,297,55,331,334,114,71,88,322,92,323,18,134,285,264,315,3,26,272,112,258,324,325,298,314,284,316,113,328,301,329,302,295,311,299,300]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n,c,i,a,l,C,S,b,g,d,P,N,F,M,U,j,O,K,V,me,te,G,Q,le,ie,ce,pe,H,B,X,re,Y,_,x,ve,ae,fe,ee,de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We,_e,Ye,it,et,Ae,Ne,qe,Le,Xe,he,ue,Ie,Ve,ze,xe,rt,ot,$t,St,Yt,Gt,wt,zt,Nt,Bt,At,Rt,Ot,Wt,Jt,qt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;function Lt(lt){const ft=lt.get(ae.$BM),Tt=lt.get(je.$kcc),Kt=lt.get(se.$Pcc),Dt=lt.get(i.$6cc),ct=lt.get(le.$xcc),vt=lt.get(et.$FM),Ht=lt.get(s.$Acc),Pt=lt.get(x.$ucc),Ge=lt.get(ve.$lM),Me=lt.get(M.$Lcc),Te=lt.get(J.$Qcc),Se=lt.get(_.$$i),ne=lt.get(_.$0i),Fe=lt.get(de.$bwb),Ke=lt.get(be.$ncc),Ze=lt.get(Q.$rdc),Je=lt.get(Ye.$Xcc),nt=lt.get(it.$zdc),pt=lt.get(Nt.$2cc);Ge.set(v.$lK.ExtHostFileSystemInfo,Tt),Ge.set(v.$lK.ExtHostLogLevelServiceShape,Se),Ge.set(v.$lK.ExtHostWorkspace,ct),Ge.set(v.$lK.ExtHostConfiguration,Ht),Ge.set(v.$lK.ExtHostExtensionService,Dt),Ge.set(v.$lK.ExtHostStorage,Me),Ge.set(v.$lK.ExtHostTunnelService,Fe),Ge.set(v.$lK.ExtHostWindow,Ze),Ge.set(v.$lK.ExtHostSecretState,Je),Ge.set(v.$lK.ExtHostTelemetry,vt),Ge.set(v.$lK.ExtHostEditorTabs,nt),Ge.set(v.$lK.ExtHostManagedSockets,pt);const jt=Ge.set(v.$lK.ExtHostDecorations,lt.get(B.$vdc)),kt=Ge.set(v.$lK.ExtHostDocumentsAndEditors,lt.get(c.$wM)),ht=Ge.set(v.$lK.ExtHostCommands,lt.get(h.$HM)),gt=Ge.set(v.$lK.ExtHostTerminalService,lt.get(U.$Scc)),yt=Ge.set(v.$lK.ExtHostDebugService,lt.get(re.$Ddc)),mi=Ge.set(v.$lK.ExtHostSearch,lt.get(Y.$Ndc)),Ct=Ge.set(v.$lK.ExtHostTask,lt.get(X.$ydc)),Di=Ge.set(v.$lK.ExtHostOutputService,lt.get(g.$bdc)),ui=Ge.set(v.$lK.ExtHostLocalization,lt.get(rt.$1cc)),$i=Ge.set(v.$lK.ExtHostUrls,new te.$kdc(Ge)),It=Ge.set(v.$lK.ExtHostDocuments,new n.$icc(Ge,kt)),fn=Ge.set(v.$lK.ExtHostDocumentContentProviders,new u.$Ccc(Ge,kt,ne)),ri=Ge.set(v.$lK.ExtHostDocumentSaveParticipant,new t.$Dcc(ne,It,Ge.getProxy(v.$kK.MainThreadBulkEdits))),Et=Ge.set(v.$lK.ExtHostNotebook,new fe.$Tdc(Ge,ht,kt,It,Kt)),bi=Ge.set(v.$lK.ExtHostNotebookDocuments,new ue.$_dc(Et)),wi=Ge.set(v.$lK.ExtHostNotebookEditors,new he.$$dc(ne,Et)),si=Ge.set(v.$lK.ExtHostNotebookKernels,new Ae.$8dc(Ge,ft,Et,ht,ne)),Ci=Ge.set(v.$lK.ExtHostNotebookRenderers,new qe.$0dc(Ge,Et)),Ii=Ge.set(v.$lK.ExtHostNotebookDocumentSaveParticipant,new wt.$fec(ne,Et,Ge.getProxy(v.$kK.MainThreadBulkEdits))),Mt=Ge.set(v.$lK.ExtHostEditors,new j.$idc(Ge,kt)),vi=Ge.set(v.$lK.ExtHostTreeViews,new O.$jdc(Ge.getProxy(v.$kK.MainThreadTreeViews),ht,ne)),Pi=Ge.set(v.$lK.ExtHostEditorInsets,new ce.$sdc(Ge.getProxy(v.$kK.MainThreadEditorInsets),Mt,ft.remote)),oi=Ge.set(v.$lK.ExtHostDiagnostics,new o.$mcc(Ge,ne,Tt,kt)),li=Ge.set(v.$lK.ExtHostLanguages,new S.$$cc(Ge,It,ht.converter,Pt)),ut=Ge.set(v.$lK.ExtHostLanguageFeatures,new C.$qcc(Ge,Pt,It,ht,oi,ne,Ke,vt)),Ai=Ge.set(v.$lK.ExtHostFileSystem,new a.$9cc(Ge,ut)),Zt=Ge.set(v.$lK.ExtHostFileSystemEventService,new l.$0cc(Ge,ne,kt)),ii=Ge.set(v.$lK.ExtHostQuickOpen,(0,P.$ddc)(Ge,ct,ht)),Ri=Ge.set(v.$lK.ExtHostSCM,new N.$fdc(Ge,ht,It,ne)),Li=Ge.set(v.$lK.ExtHostQuickDiff,new St.$cec(Ge,Pt)),Mi=Ge.set(v.$lK.ExtHostShare,new Bt.$hec(Ge,Pt)),Xi=Ge.set(v.$lK.ExtHostComments,(0,r.$tcc)(Ge,ht,It)),Fi=Ge.set(v.$lK.ExtHostProgress,new d.$cdc(Ge.getProxy(v.$kK.MainThreadProgress))),Yi=Ge.set(v.$lK.ExtHosLabelService,new pe.$tdc(Ge)),Ti=Ge.set(v.$lK.ExtHostTheming,new ee.$Udc(Ge)),ai=Ge.set(v.$lK.ExtHostAuthentication,new Pe.$Vdc(Ge)),gn=Ge.set(v.$lK.ExtHostTimeline,new z.$Xdc(Ge,ht)),Ni=Ge.set(v.$lK.ExtHostWebviews,new G.$ndc(Ge,ft.remote,ct,ne,Ke)),hi=Ge.set(v.$lK.ExtHostWebviewPanels,new ge.$Zdc(Ge,Ni,ct)),Oi=Ge.set(v.$lK.ExtHostCustomEditors,new Z.$1dc(Ge,It,Te,Ni,hi)),mn=Ge.set(v.$lK.ExtHostWebviewViews,new oe.$Ydc(Ge,Ni)),di=Ge.set(v.$lK.ExtHostTesting,new We.$3dc(Ge,ht,kt)),Zi=Ge.set(v.$lK.ExtHostUriOpeners,new _e.$7dc(Ge)),ji=Ge.set(v.$lK.ExtHostProfileContentHandlers,new $t.$bec(Ge));Ge.set(v.$lK.ExtHostInteractive,new Ie.$aec(Ge,Et,kt,ht,ne));const xi=Ge.set(v.$lK.ExtHostInlineChat,new Gt.$eec(Ge,ht,It,ne)),fi=Ge.set(v.$lK.ExtHostChatProvider,new At.$iec(Ge,ne)),_i=Ge.set(v.$lK.ExtHostChatAgents,new qt.$nec(Ge,fi,ne)),$n=Ge.set(v.$lK.ExtHostChatAgents2,new Vt.$oec(Ge,fi,ne)),Ui=Ge.set(v.$lK.ExtHostChatVariables,new Ot.$kec(Ge)),gi=Ge.set(v.$lK.ExtHostChat,new Yt.$dec(Ge,ne)),xt=Ge.set(v.$lK.ExtHostAiRelatedInformation,new Wt.$lec(Ge)),pi=Ge.set(v.$lK.ExtHostAiEmbeddingVector,new Jt.$mec(Ge)),bn=Ge.set(v.$lK.ExtHostIssueReporter,new zt.$gec(Ge)),Qt=Ge.set(v.$lK.ExtHostStatusBar,new F.$hdc(Ge,ht.converter)),yi=Ge.set(v.$lK.ExtHostSpeech,new Rt.$jec(Ge)),en=Object.values(v.$lK);Ge.assertRegistered(en);const tn=new Ee.$2dc(Ge,kt),nn=new p.$scc(Ge),Ei=new b.$_cc(Ge,ne),rn=new m.$Bcc(Ge);return k.$rcc.register(ht),function(Ue,_t,sn){const mt=function(){let we=!Ue.isUnderDevelopment;function ke(){we||(ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const bt=st;typeof bt.scheme>"u"&&ke(),typeof bt.exclusive=="boolean"&&(0,ze.$hF)(Ue,"documentFiltersExclusive")}return st}}(),zi={getSession(we,ke,Oe){return ai.getSession(Ue,we,ke,Oe)},getSessions(we,ke){return(0,ze.$hF)(Ue,"authGetSessions"),ai.getSessions(Ue,we,ke)},async hasSession(we,ke){return(0,ze.$hF)(Ue,"authSession"),!!await ai.getSession(Ue,we,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(we,ke,Oe,st){return ai.registerAuthenticationProvider(we,ke,Oe,st)}},on={registerCommand(we,ke,Oe){return ht.registerCommand(!0,we,ke,Oe,void 0,Ue)},registerTextEditorCommand(we,ke,Oe){return ht.registerCommand(!0,we,(...st)=>{const bt=Mt.getActiveTextEditor();if(!bt){ne.warn("Cannot execute "+we+" because there is no active text editor.");return}return bt.edit(Ft=>{ke.apply(Oe,[bt,Ft,...st])}).then(Ft=>{Ft||ne.warn("Edits from command "+we+" were not applied.")},Ft=>{ne.warn("An error occurred while running command "+we,Ft)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,ke,Oe)=>((0,ze.$hF)(Ue,"diffCommand"),ht.registerCommand(!0,we,async(...st)=>{const bt=kt.activeEditor(!0);if(!bt){ne.warn("Cannot execute "+we+" because there is no active text editor.");return}const Ft=await Mt.getDiffInformation(bt.id);ke.apply(Oe,[Ft,...st])},void 0,void 0,Ue)),executeCommand(we,...ke){return ht.executeCommand(we,...ke)},getCommands(we=!1){return ht.getCommands(we)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$hF)(Ue,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$hF)(Ue,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$EM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return et.$DM.validateSender(we),vt.instantiateLogger(Ue,we,ke)},openExternal(we,ke){return Ze.openUri(we,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===ft.environment.appUriScheme)return $i.createAppUri(we);try{return await Ze.asExternalUri(we,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Xe.$jU)(we,Le.Schemas.http)||(0,Xe.$jU)(we,Le.Schemas.https))return we;throw ke}},get remoteName(){return(0,H.$Vk)(ft.remote.authority)},get remoteAuthority(){return(0,ze.$hF)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return ne.getLevel()},get onDidChangeLogLevel(){return ne.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,ze.$hF)(Ue,"handleIssueUri"),bn.registerIssueUriRequestHandler(Ue,we)},get appQuality(){return(0,ze.$hF)(Ue,"resolvers"),ft.quality},get appCommit(){return(0,ze.$hF)(Ue,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(we,ke,Oe){return di.createTestController(Ue,we,ke,Oe)},createTestObserver(){return(0,ze.$hF)(Ue,"testObserver"),di.createTestObserver()},runTests(we){return(0,ze.$hF)(Ue,"testObserver"),di.runTests(we)},get onDidChangeTestResults(){return(0,ze.$hF)(Ue,"testObserver"),di.onResultsChanged},get testResults(){return(0,ze.$hF)(Ue,"testObserver"),di.results}},ki=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,wn={getExtension(we,ke){(0,ze.$gF)(Ue,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(we);if(Oe)return new i.$7cc(Dt,Ue.identifier,Oe,ki,!1);if(ke){const st=_t.all.getExtensionDescription(we);if(st)return new i.$7cc(Dt,Ue.identifier,st,ki,!0)}},get all(){const we=[];for(const ke of _t.mine.getAllExtensionDescriptions())we.push(new i.$7cc(Dt,Ue.identifier,ke,ki,!1));return we},get allAcrossExtensionHosts(){(0,ze.$hF)(Ue,"extensionsAny");const we=new ie.$7l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!we.has(Oe.identifier);ke.push(new i.$7cc(Dt,Ue.identifier,Oe,ki,st))}return ke},get onDidChange(){return(0,ze.$gF)(Ue,"extensionsAny")?f.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(we){return oi.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:we=>oi.getDiagnostics(we),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(we,ke){return li.changeLanguage(we.uri,ke)},match(we,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,L.$tE)(K.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,ke,Oe){return ut.registerCodeActionProvider(Ue,mt(we),ke,Oe)},registerDocumentPasteEditProvider(we,ke,Oe){return(0,ze.$hF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,mt(we),ke,Oe)},registerCodeLensProvider(we,ke){return ut.registerCodeLensProvider(Ue,mt(we),ke)},registerDefinitionProvider(we,ke){return ut.registerDefinitionProvider(Ue,mt(we),ke)},registerDeclarationProvider(we,ke){return ut.registerDeclarationProvider(Ue,mt(we),ke)},registerImplementationProvider(we,ke){return ut.registerImplementationProvider(Ue,mt(we),ke)},registerTypeDefinitionProvider(we,ke){return ut.registerTypeDefinitionProvider(Ue,mt(we),ke)},registerHoverProvider(we,ke){return ut.registerHoverProvider(Ue,mt(we),ke,Ue.identifier)},registerEvaluatableExpressionProvider(we,ke){return ut.registerEvaluatableExpressionProvider(Ue,mt(we),ke,Ue.identifier)},registerInlineValuesProvider(we,ke){return ut.registerInlineValuesProvider(Ue,mt(we),ke,Ue.identifier)},registerDocumentHighlightProvider(we,ke){return ut.registerDocumentHighlightProvider(Ue,mt(we),ke)},registerLinkedEditingRangeProvider(we,ke){return ut.registerLinkedEditingRangeProvider(Ue,mt(we),ke)},registerReferenceProvider(we,ke){return ut.registerReferenceProvider(Ue,mt(we),ke)},registerRenameProvider(we,ke){return ut.registerRenameProvider(Ue,mt(we),ke)},registerDocumentSymbolProvider(we,ke,Oe){return ut.registerDocumentSymbolProvider(Ue,mt(we),ke,Oe)},registerWorkspaceSymbolProvider(we){return ut.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,ke){return ut.registerDocumentFormattingEditProvider(Ue,mt(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,mt(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,mt(we),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,mt(we),ke,Oe)},registerDocumentRangeSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,mt(we),ke,Oe)},registerSignatureHelpProvider(we,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,mt(we),ke,Oe):ut.registerSignatureHelpProvider(Ue,mt(we),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(we,ke,...Oe){return ut.registerCompletionItemProvider(Ue,mt(we),ke,Oe)},registerInlineCompletionItemProvider(we,ke,Oe){return ke.handleDidShowCompletionItem&&(0,ze.$hF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$hF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,ze.$hF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,mt(we),ke,Oe)},registerDocumentLinkProvider(we,ke){return ut.registerDocumentLinkProvider(Ue,mt(we),ke)},registerColorProvider(we,ke){return ut.registerColorProvider(Ue,mt(we),ke)},registerFoldingRangeProvider(we,ke){return ut.registerFoldingRangeProvider(Ue,mt(we),ke)},registerSelectionRangeProvider(we,ke){return ut.registerSelectionRangeProvider(Ue,we,ke)},registerCallHierarchyProvider(we,ke){return ut.registerCallHierarchyProvider(Ue,we,ke)},registerTypeHierarchyProvider(we,ke){return ut.registerTypeHierarchyProvider(Ue,we,ke)},setLanguageConfiguration:(we,ke)=>ut.setLanguageConfiguration(Ue,we,ke),getTokenInformationAtPosition(we,ke){return(0,ze.$hF)(Ue,"tokenInformation"),li.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return ut.registerInlayHintsProvider(Ue,we,ke)},createLanguageStatusItem(we,ke){return li.createLanguageStatusItem(Ue,we,ke)},registerDocumentDropEditProvider(we,ke,Oe){return ut.registerDocumentOnDropEditProvider(Ue,we,ke,(0,ze.$gF)(Ue,"dropMetadata")?Oe:void 0)}},un={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(we,ke,Oe){const st=await(A.URI.isUri(we)?Promise.resolve(Si.openTextDocument(we)):Promise.resolve(we));return Mt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(we){return Mt.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,ke,Oe){return Mt.onDidChangeActiveTextEditor(we,ke,Oe)},onDidChangeVisibleTextEditors(we,ke,Oe){return Mt.onDidChangeVisibleTextEditors(we,ke,Oe)},onDidChangeTextEditorSelection(we,ke,Oe){return Mt.onDidChangeTextEditorSelection(we,ke,Oe)},onDidChangeTextEditorOptions(we,ke,Oe){return Mt.onDidChangeTextEditorOptions(we,ke,Oe)},onDidChangeTextEditorVisibleRanges(we,ke,Oe){return Mt.onDidChangeTextEditorVisibleRanges(we,ke,Oe)},onDidChangeTextEditorViewColumn(we,ke,Oe){return Mt.onDidChangeTextEditorViewColumn(we,ke,Oe)},onDidCloseTerminal(we,ke,Oe){return gt.onDidCloseTerminal(we,ke,Oe)},onDidOpenTerminal(we,ke,Oe){return gt.onDidOpenTerminal(we,ke,Oe)},onDidChangeActiveTerminal(we,ke,Oe){return gt.onDidChangeActiveTerminal(we,ke,Oe)},onDidChangeTerminalDimensions(we,ke,Oe){return(0,ze.$hF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(we,ke,Oe)},onDidChangeTerminalState(we,ke,Oe){return gt.onDidChangeTerminalState(we,ke,Oe)},onDidWriteTerminalData(we,ke,Oe){return(0,ze.$hF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(we,ke,Oe)},onDidExecuteTerminalCommand(we,ke,Oe){return(0,ze.$hF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(we,ke,Oe)},get state(){return Ze.getState(Ue)},onDidChangeWindowState(we,ke,Oe){return Ze.onDidChangeWindowState(we,ke,Oe)},showInformationMessage(we,...ke){return Ei.showMessage(Ue,R.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return Ei.showMessage(Ue,R.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return Ei.showMessage(Ue,R.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Oe){return ii.showQuickPick(Ue,we,ke,Oe)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ii.showInput(we,ke)},showOpenDialog(we){return rn.showOpenDialog(Ue,we)},showSaveDialog(we){return rn.showSaveDialog(we)},createStatusBarItem(we,ke,Oe){let st,bt,Ft;return typeof we=="string"?(st=we,bt=ke,Ft=Oe):(bt=we,Ft=ke),Qt.createStatusBarEntry(Ue,st,bt,Ft)},setStatusBarMessage(we,ke){return Qt.setStatusBarMessage(we,ke)},withScmProgress(we){return Ke.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Fi.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(ke,Oe)=>we({report(st){}}))},withProgress(we,ke){return Fi.withProgress(Ue,we,ke)},createOutputChannel(we,ke){return Di.createOutputChannel(we,ke,Ue)},createWebviewPanel(we,ke,Oe,st){return hi.createWebviewPanel(Ue,we,ke,Oe,st)},createWebviewTextEditorInset(we,ke,Oe,st){return(0,ze.$hF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(we,ke,Oe,st,Ue)},createTerminal(we,ke,Oe){return typeof we=="object"?"pty"in we?gt.createExtensionTerminal(we):gt.createTerminalFromOptions(we):gt.createTerminal(we,ke,Oe)},registerTerminalLinkProvider(we){return gt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return gt.registerProfileProvider(Ue,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,ze.$hF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(we,Ue.identifier.value,ke)},registerTreeDataProvider(we,ke){return vi.registerTreeDataProvider(we,ke,Ue)},createTreeView(we,ke){return vi.createTreeView(we,ke,Ue)},registerWebviewPanelSerializer:(we,ke)=>hi.registerWebviewPanelSerializer(Ue,we,ke),registerCustomEditorProvider:(we,ke,Oe={})=>Oi.registerCustomEditorProvider(Ue,we,ke,Oe),registerFileDecorationProvider(we){return jt.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return $i.registerUriHandler(Ue,we)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Oe){return Ti.onDidChangeActiveColorTheme(we,ke,Oe)},registerWebviewViewProvider(we,ke,Oe){return mn.registerWebviewViewProvider(Ue,we,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Oe){return Et.onDidChangeActiveNotebookEditor(we,ke,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Oe){return wi.onDidChangeNotebookEditorSelection(we,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(we,ke,Oe){return wi.onDidChangeNotebookEditorVisibleRanges(we,ke,Oe)},showNotebookDocument(we,ke){return Et.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Oe){return(0,ze.$hF)(Ue,"externalUriOpener"),Zi.registerExternalUriOpener(Ue.identifier,we,ke,Oe)},registerProfileContentHandler(we,ke){return(0,ze.$hF)(Ue,"profileContentHandlers"),ji.registrProfileContentHandler(Ue,we,ke)},registerQuickDiffProvider(we,ke,Oe,st){return(0,ze.$hF)(Ue,"quickDiffProvider"),Li.registerQuickDiffProvider(mt(we),ke,Oe,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(we,ke){return(0,ze.$hF)(Ue,"shareProvider"),Mi.registerShareProvider(mt(we),ke)}},Si={get rootPath(){return Ke.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(we){throw new T.$9("rootPath")},getWorkspaceFolder(we){return ct.getWorkspaceFolder(we)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(we){throw new T.$9("name")},get workspaceFile(){return ct.workspaceFile},set workspaceFile(we){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(we,ke,...Oe)=>ct.updateWorkspaceFolders(Ue,we,ke||0,...Oe),onDidChangeWorkspaceFolders:function(we,ke,Oe){return ct.onDidChangeWorkspace(we,ke,Oe)},asRelativePath:(we,ke)=>ct.getRelativePath(we,ke),findFiles:(we,ke,Oe,st)=>ct.findFiles(we,ke,Oe,Ue.identifier,st),findTextInFiles:(we,ke,Oe,st)=>{(0,ze.$hF)(Ue,"findTextInFiles");let bt,Ft;return typeof ke=="object"?(bt=ke,Ft=Oe):(bt={},Ft=ke,st=Oe),ct.findTextInFiles(we,bt||{},Ft,Ue.identifier,st)},save:we=>((0,ze.$hF)(Ue,"saveEditor"),ct.save(we)),saveAs:we=>((0,ze.$hF)(Ue,"saveEditor"),ct.saveAs(we)),saveAll:we=>ct.saveAll(we),applyEdit(we,ke){return tn.applyWorkspaceEdit(we,Ue,ke)},createFileSystemWatcher:(we,ke,Oe,st)=>{let bt;return typeof ke=="boolean"?bt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st}:ke&&((0,ze.$hF)(Ue,"createFileSystemWatcher"),bt=ke),Zt.createFileSystemWatcher(ct,Ue,we,bt)},get textDocuments(){return It.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$9("textDocuments")},openTextDocument(we){let ke;const Oe=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(we,ke,Oe)=>It.onDidAddDocument(we,ke,Oe),onDidCloseTextDocument:(we,ke,Oe)=>It.onDidRemoveDocument(we,ke,Oe),onDidChangeTextDocument:(we,ke,Oe)=>It.onDidChangeDocument(we,ke,Oe),onDidSaveTextDocument:(we,ke,Oe)=>It.onDidSaveDocument(we,ke,Oe),onWillSaveTextDocument:(we,ke,Oe)=>ri.getOnWillSaveTextDocumentEvent(Ue)(we,ke,Oe),get notebookDocuments(){return Et.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Oe;if(A.URI.isUri(we))Oe=we,await Et.openNotebookDocument(we);else if(typeof we=="string")Oe=A.URI.revive(await Et.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,ke,Oe){return bi.onDidSaveNotebookDocument(we,ke,Oe)},onDidChangeNotebookDocument(we,ke,Oe){return bi.onDidChangeNotebookDocument(we,ke,Oe)},onWillSaveNotebookDocument(we,ke,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(Ue)(we,ke,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Oe,st){return Et.registerNotebookSerializer(Ue,we,ke,Oe,(0,ze.$gF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Oe)=>sn.onDidChangeConfiguration(we,ke,Oe),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,sn.getConfiguration(we,ke,Ue)},registerTextDocumentContentProvider(we,ke){return fn.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(Ke.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Ue,we,ke)),registerFileSystemProvider(we,ke,Oe){return(0,Ve.$Pc)(Ai.registerFileSystemProvider(Ue,we,ke,Oe),Kt.addFileSystemProvider(we,ke,Oe))},get fs(){return Kt.value},registerFileSearchProvider:(we,ke)=>((0,ze.$hF)(Ue,"fileSearchProvider"),mi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,ze.$hF)(Ue,"textSearchProvider"),mi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,ze.$hF)(Ue,"resolvers"),Dt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,ze.$hF)(Ue,"resolvers"),Yi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,ze.$hF)(Ue,"resolvers"),Dt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Oe)=>Zt.onDidCreateFile(we,ke,Oe),onDidDeleteFiles:(we,ke,Oe)=>Zt.onDidDeleteFile(we,ke,Oe),onDidRenameFiles:(we,ke,Oe)=>Zt.onDidRenameFile(we,ke,Oe),onWillCreateFiles:(we,ke,Oe)=>Zt.getOnWillCreateFileEvent(Ue)(we,ke,Oe),onWillDeleteFiles:(we,ke,Oe)=>Zt.getOnWillDeleteFileEvent(Ue)(we,ke,Oe),onWillRenameFiles:(we,ke,Oe)=>Zt.getOnWillRenameFileEvent(Ue)(we,ke,Oe),openTunnel:we=>((0,ze.$hF)(Ue,"tunnels"),Fe.openTunnel(Ue,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$hF)(Ue,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(we,ke,Oe)=>((0,ze.$hF)(Ue,"tunnels"),Fe.onDidChangeTunnels(we,ke,Oe)),registerPortAttributesProvider:(we,ke)=>((0,ze.$hF)(Ue,"portsAttributes"),Fe.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,ze.$hF)(Ue,"tunnelFactory"),Fe.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,ze.$hF)(Ue,"timeline"),gn.registerTimelineProvider(we,ke,Ue.identifier,ht.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:we=>((0,ze.$hF)(Ue,"workspaceTrust"),ct.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Oe)=>ct.onDidGrantWorkspaceTrust(we,ke,Oe),registerEditSessionIdentityProvider:(we,ke)=>((0,ze.$hF)(Ue,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Oe)=>((0,ze.$hF)(Ue,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(Ue)(we,ke,Oe)),registerCanonicalUriProvider:(we,ke)=>((0,ze.$hF)(Ue,"canonicalUriProvider"),ct.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Oe)=>((0,ze.$hF)(Ue,"canonicalUriProvider"),ct.provideCanonicalUri(we,ke,Oe))},Wi={get inputBox(){return Ke.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Ue)},createSourceControl(we,ke,Oe){return Ri.createSourceControl(Ue,we,ke,Oe)}},qi={createCommentController(we,ke){return Xi.createCommentController(Ue,we,ke)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(we,ke,Oe){return yt.onDidStartDebugSession(we,ke,Oe)},onDidTerminateDebugSession(we,ke,Oe){return yt.onDidTerminateDebugSession(we,ke,Oe)},onDidChangeActiveDebugSession(we,ke,Oe){return yt.onDidChangeActiveDebugSession(we,ke,Oe)},onDidReceiveDebugSessionCustomEvent(we,ke,Oe){return yt.onDidReceiveDebugSessionCustomEvent(we,ke,Oe)},onDidChangeBreakpoints(we,ke,Oe){return yt.onDidChangeBreakpoints(we,ke,Oe)},onDidChangeStackFrameFocus(we,ke,Oe){return(0,ze.$hF)(Ue,"debugFocus"),yt.onDidChangeStackFrameFocus(we,ke,Oe)},registerDebugConfigurationProvider(we,ke,Oe){return yt.registerDebugConfigurationProvider(we,ke,Oe||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return yt.registerDebugAdapterDescriptorFactory(Ue,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return yt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?yt.startDebugging(we,ke,{parentSession:Oe}):yt.startDebugging(we,ke,Oe||{})},stopDebugging(we){return yt.stopDebugging(we)},addBreakpoints(we){return yt.addBreakpoints(we)},removeBreakpoints(we){return yt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return yt.asDebugSourceUri(we,ke)}},Vi={registerTaskProvider:(we,ke)=>Ct.registerTaskProvider(Ue,we,ke),fetchTasks:we=>Ct.fetchTasks(we),executeTask:we=>Ct.executeTask(Ue,we),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(we,ke,Oe)=>Ct.onDidStartTask(we,ke,Oe),onDidEndTask:(we,ke,Oe)=>Ct.onDidEndTask(we,ke,Oe),onDidStartTaskProcess:(we,ke,Oe)=>Ct.onDidStartTaskProcess(we,ke,Oe),onDidEndTaskProcess:(we,ke,Oe)=>Ct.onDidEndTaskProcess(we,ke,Oe)},Ki={createNotebookController(we,ke,Oe,st,bt){return si.createNotebookController(Ue,we,ke,Oe,st,(0,ze.$gF)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>Et.registerNotebookCellStatusBarItemProvider(Ue,we,ke),createRendererMessaging(we){return Ci.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,ze.$hF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,ke){return(0,ze.$hF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Oe){return(0,ze.$hF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(we,ke,Oe)}},Hi={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return ui.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return ui.getMessage(Ue.identifier.value,we[0])},get bundle(){return ui.getBundle(Ue.identifier.value)},get uri(){return ui.getBundleUri(Ue.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,ze.$hF)(Ue,"interactive"),xi.registerProvider(Ue,we,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(we,ke){return(0,ze.$hF)(Ue,"interactive"),gi.registerChatProvider(Ue,we,ke)},sendInteractiveRequestToProvider(we,ke){return(0,ze.$hF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,ze.$hF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,ke){return(0,ze.$hF)(Ue,"interactive"),gi.transferChatSession(we,ke)}},ln={getRelatedInformation(we,ke){return(0,ze.$hF)(Ue,"aiRelatedInformation"),xt.getRelatedInformation(Ue,we,ke)},registerRelatedInformationProvider(we,ke){return(0,ze.$hF)(Ue,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Ue,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,ze.$hF)(Ue,"aiRelatedInformation"),pi.registerEmbeddingVectorProvider(Ue,we,ke)}},hn={registerChatResponseProvider(we,ke,Oe){return(0,ze.$hF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,we,ke,Oe)},requestChatAccess(we){return(0,ze.$hF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,ke,Oe){return(0,ze.$hF)(Ue,"chatVariables"),Ui.registerVariableResolver(Ue,we,ke,Oe)},registerMappedEditsProvider(we,ke){return(0,ze.$hF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,we,ke)},createChatAgent(we,ke){return(0,ze.$hF)(Ue,"chatAgents2"),$n.createChatAgent(Ue,we,ke)},registerAgent(we,ke,Oe){return(0,ze.$hF)(Ue,"chatAgents"),_i.registerAgent(Ue.identifier,we,ke,Oe)}},dn={registerSpeechProvider(we,ke){return(0,ze.$hF)(Ue,"speech"),yi.registerProvider(Ue.identifier,we,ke)}};return{version:ft.version,ai:ln,authentication:zi,commands:on,comments:qi,chat:hn,debug:ci,env:Bi,extensions:wn,interactive:Gi,l10n:Hi,languages:cn,notebooks:Ki,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:Si,Breakpoint:V.$kL,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatAgentResultFeedbackKind:V.ChatAgentResultFeedbackKind,ChatMessage:V.$aM,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.$JK,CallHierarchyItem:V.$IK,CallHierarchyOutgoingCall:V.$KK,CancellationError:T.$5,CancellationTokenSource:D.$Xd,CandidatePortSource:v.CandidatePortSource,CodeAction:V.$FK,CodeActionKind:V.$GK,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$LK,Color:V.$YK,ColorInformation:V.$ZK,ColorPresentation:V.$1K,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$SK,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$TK,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$9K,DebugAdapterExecutable:V.$oL,DebugAdapterInlineImplementation:V.$rL,DebugAdapterNamedPipeServer:V.$qL,DebugAdapterServer:V.$pL,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$AK,DiagnosticRelatedInformation:V.$zK,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$mK,DocumentHighlight:V.$CK,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$XK,DocumentSymbol:V.$EK,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$uL,InlineValueText:V.$vL,InlineValueVariableLookup:V.$wL,InlineValueEvaluatableExpression:V.$xL,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:f.$Nd,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$HL,FileDecoration2:V.$HL,FileSystemError:V.$zL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.$AL,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$mL,InlineCompletionItem:V.$UK,InlineCompletionList:V.$VK,Hover:V.$BK,IndentAction:w.IndentAction,Location:V.$yK,MarkdownString:V.$MK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$NK,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$nK,ProcessExecution:V.$7K,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$GL,Range:V.$oK,RelativePattern:V.$iL,Selection:V.$pK,SelectionRange:V.$HK,SemanticTokens:V.$DL,SemanticTokensBuilder:V.$CL,SemanticTokensEdit:V.$EL,SemanticTokensEdits:V.$FL,SemanticTokensLegend:V.$BL,ShellExecution:V.$8K,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$PK,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$OK,SnippetString:V.$xK,SourceBreakpoint:V.$lL,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$DK,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$0K,TaskGroup:V.$6K,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$2K,TerminalQuickFixExecuteTerminalCommand:V.$4K,TerminalQuickFixOpener:V.$3K,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$5K,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$tK,SnippetTextEdit:V.$vK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$hL,ThemeIcon:V.$gL,TreeItem:V.$$K,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$3L,UIKind:y.UIKind,Uri:A.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$wK,DocumentDropEdit:V.$eL,DocumentPasteEdit:V.$fL,InlayHint:V.$RK,InlayHintLabelPart:V.$QK,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$sK,ResolvedAuthority:V.$qK,ManagedResolvedAuthority:V.$rK,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$RL,NotebookRange:V.$JL,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$KL,NotebookData:V.$LL,NotebookRendererScript:V.$PL,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$NL,NotebookCellOutputItem:V.$ML,NotebookCellStatusBarItem:V.$OL,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$uK,NotebookKernelSourceAction:V.$QL,PortAttributes:V.$TL,LinkedEditingRanges:V.$SL,TestResultState:V.TestResultState,TestRunRequest:V.$UL,TestMessage:V.$VL,TestMessage2:V.$VL,TestTag:V.$WL,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:V.$dL,DataTransferItem:V.$_K,CoveredCount:V.$XL,FileCoverage:V.$YL,StatementCoverage:V.$ZL,BranchCoverage:V.$1L,FunctionCoverage:V.$2L,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$4L,TabInputTextDiff:V.$5L,TabInputTextMerge:V.$6L,TabInputCustom:V.$7L,TabInputNotebook:V.$9L,TabInputNotebookDiff:V.$0L,TabInputWebview:V.$8L,TabInputTerminal:V.$$L,TabInputInteractiveWindow:V.$_L,TelemetryTrustedValue:me.$jo,LogLevel:_.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$sL,ThreadFocus:V.$tL,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus}}}e.$pec=Lt}),define(De[359],Ce([1,0,103,152,39,149,40,34,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$wr)(i.$1cc,i.$Zcc,1),(0,D.$wr)(n.$$i,t.$qec,1),(0,D.$wr)(p.$ncc,p.$occ,1),(0,D.$wr)($.$HM,$.$GM,0),(0,D.$wr)(A.$Acc,A.$ycc,0),(0,D.$wr)(r.$Pcc,r.$Occ,0),(0,D.$wr)(I.$Ddc,I.$Hdc,0),(0,D.$wr)(R.$vdc,R.$udc,0),(0,D.$wr)(E.$wM,E.$vM,0),(0,D.$wr)(a.$2cc,a.$3cc,0),(0,D.$wr)(s.$kcc,s.$jcc,0),(0,D.$wr)(T.$bdc,T.$adc,1),(0,D.$wr)(v.$Ndc,v.$Odc,0),(0,D.$wr)(y.$Lcc,y.$Kcc,0),(0,D.$wr)(L.$ydc,L.$xdc,0),(0,D.$wr)(w.$Scc,w.$Vcc,0),(0,D.$wr)(k.$bwb,k.$cwb,0),(0,D.$wr)(h.$rdc,h.$qdc,0),(0,D.$wr)(f.$xcc,f.$wcc,0),(0,D.$wr)(o.$Xcc,o.$Wcc,0),(0,D.$wr)(m.$FM,m.$CM,0),(0,D.$wr)(u.$zdc,u.$Adc,0),(0,D.$wr)(c.$Bdc,c.$Cdc,0)}),define(De[116],Ce([1,0,19,14,37,92]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=e.$Gec=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$Gec=A;function $(I,v,y,k){const p=(0,D.$2b)(y,E),h=new f.$RI(v,p,k),r=h.preview.matches;return{ranges:(0,D.$2b)(p,w),uri:I,preview:{text:h.preview.text,matches:(0,D.$2b)(r,w)}}}e.$Hec=$;function E(I){return new f.$SI(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new R.$GI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(v,y){this.a=v,this.b=y}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$Iec=L,e.$Iec=L=He([Be(1,T.$0i)],L)}),define(De[360],Ce([1,0,49,16,77,33,12,15,116,361]),function($e,e,D,T,f,R,A,$,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=e.$Jec=void 0;const L=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,m,u,t){const n=v(o,m,u,t),c=m.folder.fsPath;return{cmd:D.spawn(L,n.args,{cwd:c}),rgDiskPath:L,siblingClauses:n.siblingClauses,rgArgs:n,cwd:c}}e.$Jec=I;function v(o,m,u,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];k([m],u,!1).forEach(i=>{const a=(0,E.$Gec)(i);if(n.push("-g",a),A.$k){const l=(0,f.$pl)(a);l!==a&&n.push("-g",l)}});const c=y([m],t,void 0,!1);return c.globArgs.forEach(i=>{const a=`!${(0,E.$Gec)(i)}`;if(n.push("-g",a),A.$k){const l=(0,f.$pl)(a);l!==a&&n.push("-g",l)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),o.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:c.siblingClauses}}function y(o,m,u,t=!0){const n=[];let c={};return o.forEach(i=>{const a=Object.assign({},i.excludePattern||{},m||{}),l=p(a,t?i.folder.fsPath:void 0,u);n.push(...l.globArgs),l.siblingClauses&&(c=Object.assign(c,l.siblingClauses))}),{globArgs:n,siblingClauses:c}}function k(o,m,u=!0){const t=[];return o.forEach(n=>{const c=Object.assign({},m||{},n.includePattern||{}),i=p(c,u?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function p(o,m,u){const t=[],n={};return Object.keys(o).forEach(c=>{if(u&&u.has(c)||!c)return;const i=o[c];c=r(m?h(m,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof i=="boolean"&&i?(c.startsWith("\\\\")&&(c+="**"),t.push(s(c))):i&&i.when&&(n[c]=i)}),{globArgs:t,siblingClauses:n}}function h(o,m){return T.$ic(m)?m:T.$jc(o,m)}e.$Kec=h;function r(o){return o=$.$Ke(o,"\\"),$.$Ke(o,"/")}function s(o){return R.$Tf(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.$Lec=s}),define(De[362],Ce([1,0,49,53,16,363,19,41,36,77,33,12,35,15,17,29,37,360,127]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0;const o=new Set;process.on("exit",()=>{o.forEach(c=>c())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$wj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,s.$yq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$wj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(a=>{const l=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),C=a.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==C).forEach(S=>{(0,L.$Xf)(S,C)&&(l[f.$lc(C,S)]=!0)}),this.t.set(C,new t(l,C))})}cancel(){this.l=!0,o.forEach(i=>i())}walk(i,a,l,C,S){if(this.m=v.$Jd.create(!1),this.l)return S(null,this.j);a.forEach(b=>{const g=f.$nc(b.fsPath);this.u&&this.u(b.fsPath,g)||this.J(l,{relativePath:b.fsPath,searchPath:void 0})}),this.r=v.$Jd.create(!1),this.w(i,(b,g)=>{this.x(this.y,this,b,l,C,d=>{if(d){const P=(0,$.$Ai)(d);console.error(P),this.q.push(P),g(d,void 0)}else g(null,void 0)})},(b,g)=>{this.m.stop();const d=b?A.$Hb(b)[0]:null;S(d,this.j)})}w(i,a,l){const C=new Array(i.length),S=new Array(i.length);let b=!1,g=0;if(i.length===0)return l(null,[]);i.forEach((d,P)=>{a(d,(N,F)=>{if(N?(b=!0,C[P]=null,S[P]=N):(C[P]=F,S[P]=null),++g===i.length)return l(b?S:null,C)})})}x(i,a,...l){try{i.apply(a,l)}catch(C){l[l.length-1](C)}}y(i,a,l,C){const S=i.folder.fsPath,b=I.$k,g=()=>M&&M.kill();o.add(g);let d=K=>{o.delete(g),d=()=>{},C(K)},P="";const N=this.D(),F=(0,r.$Jec)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=F.cmd,U=!Object.keys(F.siblingClauses).length,j=F.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let O=`${F.rgDiskPath} ${j}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),l({message:O}),this.s=0,this.z(M,"utf8",l,(K,V,me)=>{if(K){d(K);return}if(this.j){d();return}const G=(P+(b?w.$ol(V||""):V)).split(`
`);if(me){const Q=G.length;G[Q-1]=G[Q-1].trim(),G[Q-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){d(new Error("Splitting up files failed"));return}if(this.s+=G.length,U){for(const Q of G)if(this.J(a,{base:S,relativePath:Q,searchPath:this.N(i,Q)}),this.j){g();break}(me||this.j)&&d();return}this.G(i,N,S,G,a),me&&(this.H(N,S,a),d())})}spawnFindCmd(i){const a=this.t.get(i.folder.fsPath),l=a.getBasenameTerms(),C=a.getPathTerms(),S=["-L","."];if(l.length||C.length){S.push("-not","(","(");for(const b of l)S.push("-name",b),S.push("-o");for(const b of C)S.push("-path",b),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),D.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,a,l){let C="";this.z(i,a,()=>{},(S,b,g)=>{if(S){l(S);return}C+=b,g&&l(null,C)})}z(i,a,l,C){let S=(d,P,N)=>{(d||N)&&(S=()=>{},this.r?.stop()),C(d,P,N)},b=!1;i.stdout?(this.A(i.stdout,a,S),i.stdout.once("data",()=>b=!0)):l({message:"stdout is null"});let g;i.stderr?g=this.B(i.stderr):l({message:"stderr is null"}),i.on("error",d=>{S(d)}),i.on("close",d=>{let P;!b&&(P=this.C(g,a))&&n(P)?S(new Error(`command failed with error code ${d}: ${this.C(g,a)}`)):(this.g&&d===0&&(this.j=!0),S(null,"",!0))})}A(i,a,l){const C=new R.StringDecoder(a);return i.on("data",S=>{l(null,C.write(S))}),C}B(i){const a=[];return i.on("data",l=>{a.push(l)}),a}C(i,a){const l=new R.StringDecoder(a);return i.map(C=>l.write(C)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:a},l,C,S){C.indexOf(this.b)!==-1&&this.J(S,{base:l,relativePath:this.b,searchPath:this.N(i,this.b)});const b=g=>{const d=f.$nc(g),P=f.$mc(g);let N=a[P];N||(N=a[P]=[],b(P)),N.push({base:l,relativePath:g,basename:d,searchPath:this.N(i,g)})};C.forEach(b)}H({rootEntries:i,pathToEntries:a},l,C){const S=this,b=this.t.get(l),g=this.b;function d(P){S.o++;const N=(0,h.$8I)(()=>P.map(F=>F.basename));for(let F=0,M=P.length;F<M;F++){const U=P[F],{relativePath:j,basename:O}=U;if(b.test(j,O,g!==O?N:void 0))continue;const K=a[j];if(K)d(K);else{if(S.p++,j===g)continue;S.J(C,U)}if(S.j)break}}d(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,a,l,C,S){const b=i.folder,g=(0,h.$8I)(()=>l);this.w(l,(d,P)=>{if(this.l||this.j)return P(null);const N=a?[a,d].join(f.sep):d;if(this.t.get(i.folder.fsPath).test(N,d,this.a.filePattern!==d?g:void 0))return P(null);const F=[b.fsPath,N].join(f.sep);T.lstat(F,(M,U)=>{if(M||this.l||this.j)return P(null);this.L(F,U,(j,O)=>j||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(F,U,(K,V)=>K||this.l||this.j||(V=V||"",this.v[V])?P(null):(this.v[V]=!0,p.Promises.readdir(F).then(me=>{if(this.l||this.j)return P(null);this.I(i,N,me,C,te=>P(te||null))},me=>{P(null)})))):(this.p++,N===this.b||this.h&&k.$Cf(O.size)&&O.size>this.h||this.J(C,{base:b.fsPath,relativePath:N,searchPath:this.N(i,N)}),P(null,void 0)))})},d=>{const P=d&&A.$Hb(d);return S(P&&P.length>0?P[0]:void 0)})}J(i,a){this.K(a)&&(!this.d||this.d(a.relativePath,f.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(a))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.$3I)(i,this.c)}return!0}L(i,a,l){return a.isSymbolicLink()?T.stat(i,l):l(null,a)}M(i,a,l){return a.isSymbolicLink()?T.realpath(i,(C,S)=>C?l(C):l(null,S)):l(null,i)}N(i,a){return i.folderName?f.$jc(i.folderName,a):a}}e.$Mec=m;class u{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,a,l){this.c.walk(this.a,this.b,i,a,(C,S)=>{l(C,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Nec=u;class t{constructor(i,a){this.expression=i,this.c=a,this.d(i)}d(i){let a,l;Object.keys(i).filter(C=>i[C]).forEach(C=>{f.$ic(C)?(a=a||E.$rj(),a[C]=i[C]):(l=l||E.$rj(),l[C]=i[C])}),this.a=a&&E.$wj(a,{trimForExclusions:!0}),this.b=l&&E.$wj(l,{trimForExclusions:!0})}test(i,a,l){return this.b&&this.b(i,a,l)||this.a&&this.a(f.$jc(this.c,i),a,l)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$yj(this.a)),this.b&&i.push(...E.$yj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$zj(this.a)),this.b&&i.push(...E.$zj(this.b)),i}}function n(c){const i=c.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return y.$qf(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(De[364],Ce([1,0,96,22,182,21]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.$HC=e.$GC=e.$FC=e.$EC=e.DecodeStreamErrorKind=e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=void 0,e.$wC="utf8",e.$xC="utf8bom",e.$yC="utf16be",e.$zC="utf16le";function A(a){return[e.$wC,e.$xC,e.$yC,e.$zC].some(l=>l===a)}e.$AC=A,e.$BC=[254,255],e.$CC=[255,254],e.$DC=[239,187,191];const $=512,E=512,w=512*8,L=512*128;var I;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class v extends Error{constructor(l,C){super(l),this.decodeStreamErrorKind=C}}e.$EC=v;class y{static async create(l){let C;if(l!==e.$wC)C=(await(0,f.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(l));else{const S=new TextDecoder;C={write(b){return S.decode(b,{stream:!0})},end(){return S.decode()}}}return new y(C)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function k(a,l){const C=l.minBytesRequiredForDetection??l.guessEncoding?w:E;return new Promise((S,b)=>{const g=(0,D.$2d)(U=>U.join("")),d=[];let P=0,N;const F=new R.$Xd,M=async()=>{try{const U=await i({buffer:T.$be.concat(d),bytesRead:P},l.guessEncoding);if(U.seemsBinary&&l.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);U.encoding=await l.overwriteEncoding(U.encoding),N=await y.create(U.encoding);const j=N.write(T.$be.concat(d).buffer);g.write(j),d.length=0,P=0,S({stream:g,detected:U})}catch(U){F.cancel(),g.destroy(),b(U)}};(0,D.$6d)(a,{onData:async U=>{N?g.write(N.write(U.buffer)):(d.push(U),P+=U.byteLength,P>=C&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:U=>g.error(U),onEnd:async()=>{N||await M(),g.end(N?.end())}},F.token)})}e.$FC=k;async function p(a,l,C){const b=(await(0,f.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(l),C);let g=!1,d=!1;return{read(){if(d)return null;const P=a.read();if(typeof P!="string"){if(d=!0,!g&&C?.addBOM)switch(l){case e.$wC:case e.$xC:return T.$be.wrap(Uint8Array.from(e.$DC));case e.$yC:return T.$be.wrap(Uint8Array.from(e.$BC));case e.$zC:return T.$be.wrap(Uint8Array.from(e.$CC))}const N=b.end();return N&&N.length>0?(g=!0,T.$be.wrap(N)):null}return g=!0,T.$be.wrap(b.write(P))}}}e.$GC=p;async function h(a){return(await(0,f.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(a))}e.$HC=h;function r(a){return a===e.$xC||a===null?e.$wC:a}e.$IC=r;function s(a,l){if(!a||l<e.$BC.length)return null;const C=a.readUInt8(0),S=a.readUInt8(1);if(C===e.$BC[0]&&S===e.$BC[1])return e.$yC;if(C===e.$CC[0]&&S===e.$CC[1])return e.$zC;if(l<e.$DC.length)return null;const b=a.readUInt8(2);return C===e.$DC[0]&&S===e.$DC[1]&&b===e.$DC[2]?e.$xC:null}e.$JC=s;const o=["ascii","utf-16","utf-32"];async function m(a){const l=await(0,f.$vC)("jschardet","dist/jschardet.min.js"),C=a.slice(0,L),S=n(C.buffer),b=l.detect(S);if(!b||!b.encoding)return null;const g=b.encoding.toLowerCase();return 0<=o.indexOf(g)?null:t(b.encoding)}const u={ibm866:"cp866",big5:"cp950"};function t(a){const l=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return u[l]||l}function n(a){let l="";for(let C=0;C<a.length;C++)l+=String.fromCharCode(a[C]);return l}function c(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=a.match(/windows(\d+)/);return l?"windows-"+l[1]:a}}}e.$KC=c;function i({buffer:a,bytesRead:l},C){let S=s(a,l),b=!1;if(S!==e.$yC&&S!==e.$zC&&a){let g=!0,d=!0,P=!1;for(let N=0;N<l&&N<$;N++){const F=N%2===1,M=a.readUInt8(N)===0;if(M&&(P=!0),g&&(F&&!M||!F&&M)&&(g=!1),d&&(F&&M||!F&&!M)&&(d=!1),M&&!g&&!d)break}P&&(g?S=e.$zC:d?S=e.$yC:b=!0)}return C&&!b&&!S&&a?m(a.slice(0,l)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:b,encoding:S}}e.$LC=i,e.$MC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,364,29,153]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class R extends f.$Jdc{constructor($,E,w=T,L="searchProcess"){super($,E,{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$KC)(I)},L)}}e.$Vec=R}),define(De[155],Ce([1,0,49,380,363,19,74,36,16,15,2,37,92,381,361,116]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=e.$Rec=e.$Qec=e.$Pec=e.$Oec=void 0;const h=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class r{constructor(d){this.a=d}provideTextSearchResults(d,P,N,F){return this.a.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,U)=>{F.onCancellationRequested(()=>Q());const j=n(d,P),O=P.folder.fsPath,K=j.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${h} ${K}
 - cwd: ${O}`);let V=D.spawn(h,j,{cwd:O});V.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),U((0,I.$YI)(new I.$WI(H&&H.message,I.SearchErrorCode.rgProcessError)))});let me=!1;const te=new m(P.maxResults,O,P.previewOptions);te.on("result",H=>{me=!0,ie="",N.report(H)});let G=!1;const Q=()=>{G=!0,V?.kill(),te?.cancel()};let le=!1;te.on("hitLimit",()=>{le=!0,Q()});let ie="";V.stdout.on("data",H=>{te.handleData(H),me||(ie+=H)});let ce=!1;V.stdout.once("data",()=>ce=!0);let pe="";V.stderr.on("data",H=>{const B=H.toString();this.a.appendLine(B),pe.length+B.length<1e6&&(pe+=B)}),V.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),G)M({limitHit:le});else{te.flush(),V=null;let H;pe&&!ce&&(H=s(pe))?U((0,I.$YI)(new I.$WI(H.message,H.code))):M({limitHit:le})}})})}}e.$Oec=r;function s(g){const d=g.split(`
`),P=d[0].trim();if(d.some(F=>F.startsWith("regex parse error")))return new I.$WI(o(d),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$WI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$WI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$WI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$WI(P,I.SearchErrorCode.regexParseError)}function o(g){const d=["Regex parse error"],P=g.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const F=N.split(":")[1];d.push(":"+F)}}return d.join("")}class m extends T.EventEmitter{constructor(d,P,N){super(),this.g=d,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(d,P){return super.on(d,P),this}handleData(d){if(this.b)return;const P=typeof d=="string"?d:this.d.write(d);this.k(P)}k(d){let P=d.indexOf(`
`);const N=this.a+d;if(P>=0)P+=this.a.length;else{this.a=N;return}let F=0;for(;P>=0;)this.m(N.substring(F,P).trim()),F=P+1,P=N.indexOf(`
`,F);this.a=N.substring(F)}m(d){if(this.b||!d)return;let P;try{P=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(P.type==="match"){const N=u(P.data.path),F=L.URI.file(E.$jc(this.h,N)),M=this.n(P.data,F);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=u(P.data.path),F=L.URI.file(E.$jc(this.h,N));this.o(P.data,F).forEach(U=>this.p(U))}}n(d,P){const N=d.line_number-1,F=u(d.lines),M=Buffer.from(F);let U=0,j=0,O=N;d.submatches.length===0&&d.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const K=(0,R.$Hb)(d.submatches.map((V,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=u(V.match),G=M.slice(U,V.start).toString(),Q=t(G),le=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+j,ie=t(te),ce=Q.numLines+O,pe=ie.numLines+ce,H=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+le;return U=V.end,j=H,O=pe,new v.$GI(ce,le,pe,H)}));return(0,p.$Hec)(P,F,K,this.j)}o(d,P){const N=u(d.lines),F=d.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,U)=>({text:M,uri:P,lineNumber:F+U}))}p(d){this.emit("result",d)}}e.$Pec=m;function u(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const d=/\n/g;let P=0,N=-1,F;for(;F=d.exec(g);)P++,N=F.index;const M=N>=0?g.length-N-1:g.length;return{numLines:P,lastLineLength:M}}function n(g,d){const P=["--hidden","--no-require-git"];P.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:F}=(0,A.$J)(d.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const U=new Set;F.forEach(j=>{U.add(j)}),P.push("-g","!*"),U.forEach(j=>{c(j).map(p.$Gec).forEach(O=>{P.push("-g",O)})})}N&&N.length&&N.forEach(U=>{P.push("-g",U)}),d.excludes.map(p.$Gec).forEach(U=>P.push("-g",`!${U}`)),d.maxFileSize&&P.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),d.followSymlinks&&P.push("--follow"),d.encoding&&d.encoding!=="utf8"&&P.push("--encoding",d.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,w.$Fe)(g.pattern),g.isRegExp=!0),d.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),g.isRegExp&&(g.pattern=i(g.pattern),P.push("--engine","auto"));let M;if(g.isWordMatch){const j=(0,w.$Ne)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",j)}else if(g.isRegExp){let U=l(g.pattern);U=C(U),P.push("--regexp",U)}else M=g.pattern,P.push("--fixed-strings");return P.push("--no-config"),d.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),g.isMultiline&&P.push("--multiline"),d.beforeContext&&P.push("--before-context",d.beforeContext+""),d.afterContext&&P.push("--after-context",d.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$Qec=n;function c(g){return b(g).flatMap(P=>{const N=(0,$.$uj)(P,"/");return N.map((F,M)=>N.slice(0,M+1).join("/"))})}function i(g){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(d);)g=g.replace(d,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(P);)g=g.replace(P,"$1\\x{$2}");return g}e.$Rec=i;const a=g=>g.type==="Assertion"&&g.kind==="lookbehind";function l(g){let d;try{d=new y.RegExpParser().parsePattern(g)}catch{return g}let P="",N=0;const F=(j,O,K)=>{P+=g.slice(N,j)+K,N=O},M=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=M[0];if(!O)F(j.start,j.end,"\\r?\\n");else if(!M.some(a))if(O.type==="CharacterClass")if(O.negate){const K=g.slice(O.start+2,j.start)+g.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?F(O.start,O.end,K?`[^${K}]`:"."):F(O.start,O.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=g.slice(O.start+1,j.start)+g.slice(j.end,O.end-1);F(O.start,O.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else O.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){a(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(d),P+=g.slice(N),P}e.$Sec=l;function C(g){return g.replace(/\n/g,"\\r?\\n")}e.$Tec=C;function S(g){let d=!1,P=!1,N="",F="";for(let M=0;M<g.length;M++){const U=g[M];switch(U){case"\\":P?(d?F+="\\"+U:N+="\\"+U,P=!1):P=!0;break;case"{":if(P)d?F+=U:N+=U,P=!1;else{if(d)return{strInBraces:N+"{"+F+"{"+g.substring(M+1)};d=!0}break;case"}":if(P)d?F+=U:N+=U,P=!1;else{if(d)return{fixedStart:N,strInBraces:F,fixedEnd:g.substring(M+1)};N+=U}break;default:d?F+=(P?"\\":"")+U:N+=(P?"\\":"")+U,P=!1;break}}return{strInBraces:N+(d?"{"+F:"")}}function b(g){const{fixedStart:d,strInBraces:P,fixedEnd:N}=S(g);if(d===void 0||N===void 0)return[P];let F=(0,$.$uj)(P,",");F.length||(F=[""]);const M=b(N);return F.flatMap(U=>{const j=d+U;return M.map(O=>j+O)})}e.$Uec=b}),define(De[365],Ce([1,0,21,155,64,18]),function($e,e,D,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class A{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,L,I,v){const y=new T.$Oec(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const k={...L,folder:L.folder.with({scheme:R.Schemas.file})},p=new f.$5u(h=>I.report({...h,uri:h.uri.with({scheme:L.folder.scheme})}));return this.c(v,h=>y.provideTextSearchResults(w,k,p,h))}else return this.c(v,k=>y.provideTextSearchResults(w,L,I,k))}async c(w,L){const I=$(w);this.a.add(I);const v=await L(I.token);return this.a.delete(I),v}d(){this.a.forEach(w=>w.cancel())}}e.$Yec=A;function $(E){const w=new D.$Xd;return E.onCancellationRequested(()=>w.cancel()),w}}),define(De[366],Ce([1,0,29,155,154]),function($e,e,D,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class R{constructor(E){this.a=E}search(E,w,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){L({message:y})}},v=new f.$Vec(this.a,new T.$Oec(I),D);return new Promise((y,k)=>v.search(p=>{w(p.map(A))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),k))}}e.$Wec=R;function A($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((E,w)=>{if(w.ranges){const L=w;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(De[367],Ce([1,0,19,8,9,4,127,16,35,2,30,37,362,366]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class k{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let u;const t=r(m),n=new R.$Nd({onDidAddFirstListener:()=>{u=(0,T.$Hg)(c=>this.doFileSearchWithEngine(v.$Nec,t,i=>n.fire(i),c)),u.then(c=>n.fire(c),c=>n.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{u.cancel()}});return n.event}textSearch(m){let u;const t=r(m),n=new R.$Nd({onDidAddFirstListener:()=>{u=(0,T.$Hg)(c=>this.f(t,i=>n.fire(i),c)),u.then(c=>n.fire(c),c=>n.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{u.cancel()}});return n.event}f(m,u,t){return m.maxFileSize=this.g().maxFileSize,new y.$Wec(m).search(t,u,u)}g(){return{maxFileSize:16*L.$Gk.GB}}doFileSearch(m,u,t){return this.doFileSearchWithEngine(v.$Nec,m,u,t)}doFileSearchWithEngine(m,u,t,n,c=k.a){let i=0;const a=C=>{Array.isArray(C)?(i+=C.length,t(C.map(S=>this.h(S)))):C.relativePath?(i++,t(this.h(C))):t(C)};if(u.sortByScore){let C=this.l(u,a,n);if(!C){const S=u.maxResults?Object.assign({},u,{maxResults:null}):u,b=new m(S);C=this.j(b,u,t,a,n)}return new Promise((S,b)=>{C.then(([g,d])=>{const P=d.map(N=>this.h(N));this.o(P,t,c),S(g)},b)})}const l=new m(u);return this.r(l,a,c,n).then(C=>({limitHit:C.limitHit,type:"success",stats:{detailStats:C.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,$.$jc)(m.base,m.relativePath):m.relativePath}}j(m,u,t,n,c){const i=new R.$Nd;let a=(0,T.$Hg)(C=>{let S=[];const b=g=>{Array.isArray(g)?S=g:(n(g),i.fire(g))};return this.r(m,b,-1,C).then(g=>[g,S])}),l;if(u.cacheKey){l=this.k(u.cacheKey);const C={promise:a,event:i.event,resolved:!1};l.resultsToSearchCache[u.filePattern||""]=C,a.then(()=>{C.resolved=!0},S=>{delete l.resultsToSearchCache[u.filePattern||""]}),a=this.s(a)}return a.then(([C,S])=>{const b=l?l.scorerCache:Object.create(null),g=(typeof u.maxResults!="number"||u.maxResults>0)&&E.$Jd.create(!1);return this.n(u,S,b,c).then(d=>{const P=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:C.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:u.folderQueries.length,resultCount:d.length},messages:C.messages,limitHit:C.limitHit||typeof u.maxResults=="number"&&S.length>u.maxResults},d]})})}k(m){const u=this.b[m];return u||(this.b[m]=new p)}l(m,u,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const c=this.q(n,m.filePattern||"",u,t);if(c)return c.then(([i,a,l])=>{const C=E.$Jd.create(!1);return this.n(m,a,n.scorerCache,t).then(S=>{const b=C.elapsed(),g={fromCache:!0,detailStats:l,type:this.d,resultCount:a.length,sortingTime:b};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&a.length>m.maxResults,stats:g},S]})})}n(m,u,t,n){const c=(0,A.$yq)(m.filePattern||""),i=(l,C)=>(0,A.$xq)(l,C,c,!0,h,t),a=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return D.$Gb(u,i,a,1e4,n)}o(m,u,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)u(m.slice(n,n+t));else u(m)}q(m,u,t,n){const c=E.$Jd.create(!1),i=u.indexOf($.sep)>=0;let a;for(const b in m.resultsToSearchCache)if(u.startsWith(b)){if(i&&b.indexOf($.sep)<0&&b!=="")continue;const g=m.resultsToSearchCache[b];a={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!a)return null;const l=c.elapsed(),C=E.$Jd.create(!1),S=a.event(t);return n&&n.onCancellationRequested(()=>{S.dispose()}),a.promise.then(([b,g])=>{if(n&&n.isCancellationRequested)throw(0,f.$6)();const d=[],P=(0,A.$yq)(u).normalizedLowercase;for(const N of g)(0,I.$3I)(N,P)&&d.push(N);return[b,d,{cacheWasResolved:a.resolved,cacheLookupTime:l,cacheFilterTime:C.elapsed(),cacheEntryCount:g.length}]})}r(m,u,t,n){return new Promise((c,i)=>{let a=[];n?.onCancellationRequested(()=>m.cancel()),m.search(l=>{l&&(t?(a.push(l),t>0&&a.length>=t&&(u(a),a=[])):u(l))},l=>{u(l)},(l,C)=>{a.length&&u(a),l?i(l):c(C)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,t){return m.then(u,t)}catch(u){return this.then(void 0,u)}finally(u){return m.finally(u)}}}}e.$Xec=k;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(o){return(0,$.$nc)(o.relativePath)}getItemDescription(o){return(0,$.$mc)(o.relativePath)}getItemPath(o){return o.relativePath}};function r(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(s),extraFileResources:o.extraFileResources&&o.extraFileResources.map(m=>w.URI.revive(m))}}function s(o){return{...o,folder:w.URI.revive(o.folder)}}}),define(De[368],Ce([1,0,3,18,2,29,14,27,20,95,67,37,367,365,116,154]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;let h=class extends w.$Odc{constructor(s,o,m,u){super(s,m,u),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new k.$Iec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new y.$Yec(t))),o.remote.isRemote&&o.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const s=new k.$Iec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new y.$Yec(s))),this.x.add(this.z(T.Schemas.file,new v.$Xec("fileSearchProvider")))}z(s,o){const m=this.d++;return this.v=o,this.t=m,this.c.$registerFileSearchProvider(m,this.o(s)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(s,o,m,u){const t=(0,w.$Pdc)(m);return s===this.t?this.A(s,o,t,u):super.$provideFileSearchResults(s,o,m,u)}A(s,o,m,u){const t=n=>{if((0,I.$2I)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(s,o,n.map(c=>f.URI.file(c.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,u)}$clearCache(s){return this.v?.clearCache(s),super.$clearCache(s)}q(s,o){return new p.$Vec(s,o,void 0,"textSearchProvider")}};e.$Zec=h,e.$Zec=h=He([Be(0,E.$lM),Be(1,$.$BM),Be(2,L.$ucc),Be(3,A.$0i)],h)}),define(De[117],Ce([1,0,382,60,63,383,22,9,4,3,16,12,31,81,82]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class p{traceSocketEvent(g,d){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,d)}constructor(g,d=""){this.f=!0,this.debugLabel=d,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,$.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const d=P=>{this.traceSocketEvent("read",P),g(A.$be.wrap(P))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(g){const d=P=>{g({type:0,hadError:P,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(g){const d=()=>{g()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,$.$1)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,$.$1)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Eh=p;var h;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var r;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(r||(r={}));class s extends w.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,d){this.socket.traceSocketEvent(g,d)}constructor(g,d,P,N){super(),this.f=this.B(new E.$Nd),this.g=this.B(new E.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,d,P,N,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,$.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new k.$zh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let d=0;for(;d<g.byteLength;)this.a.writeMessage(g.slice(d,Math.min(d+262144,g.byteLength)),{compressed:!0,opcode:2}),d+=262144}m(g,{compressed:d,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let N=2;g.byteLength<126?N+=0:g.byteLength<2**16?N+=2:N+=8;const F=A.$be.alloc(N),M=d?64:0,U=P&15;if(F.writeUInt8(128|M|U,0),g.byteLength<126)F.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){F.writeUInt8(126,1);let j=1;F.writeUInt8(g.byteLength>>>8&255,++j),F.writeUInt8(g.byteLength>>>0&255,++j)}else{F.writeUInt8(127,1);let j=1;F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(g.byteLength>>>24&255,++j),F.writeUInt8(g.byteLength>>>16&255,++j),F.writeUInt8(g.byteLength>>>8&255,++j),F.writeUInt8(g.byteLength>>>0&255,++j)}this.socket.write(A.$be.concat([F,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const d=this.b.peek(this.j.readLen),P=d.readUInt8(0),N=(P&128)>>>7,F=(P&64)>>>6,M=P&15,U=d.readUInt8(1),j=(U&128)>>>7,O=U&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const d=this.b.read(this.j.readLen),P=d.readUInt8(1),N=(P&128)>>>7;let F=P&127,M=1;F===126?F=d.readUInt8(++M)*2**8+d.readUInt8(++M):F===127&&(F=d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M));let U=0;N&&(U=d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const d=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),t(d,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(d,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(d,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=s;class o extends w.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$be.alloc(0)}constructor(g,d,P,N,F,M){super(),this.n=g,this.r=F,this.s=M,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,d?(this.b=this.B(new m(this.n,N,P,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(g,d){this.g.push({data:g,options:d}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:d}=this.g.shift();if(this.f&&d.compressed){const P=await this.w(this.f,g);this.s(P,d)}else this.s(g,{...d,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,d){return new Promise((P,N)=>{g.write(d),g.flush(F=>P(F))})}acceptFrame(g,d,P){this.h.push({data:g,isCompressed:d,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const d=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(d)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,d,P){return new Promise((N,F)=>{g.write(d),P&&g.write(A.$be.fromByteArray([0,0,255,255])),g.flush(M=>N(M))})}}class m extends w.$Sc{get recordedInflateBytes(){return this.j?A.$be.concat(this.f):A.$be.alloc(0)}constructor(g,d,P,N){super(),this.h=g,this.j=d,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(A.$be.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const d=A.$be.concat(this.g);this.g.length=0,g(d)})}}class u extends w.$Sc{constructor(g,d){super(),this.g=g,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$be.wrap(P))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let d=A.$be.concat(this.f);this.f.length=0,d=d.slice(0,d.byteLength-4),g(d)})}}function t(b,g){if(g===0)return;const d=b.byteLength>>>2;for(let j=0;j<d;j++){const O=b.readUInt32BE(j*4);b.writeUInt32BE(O^g,j*4)}const P=d*4,N=b.byteLength-P,F=g>>>24&255,M=g>>>16&255,U=g>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(P)^F,P),N>=2&&b.writeUInt8(b.readUInt8(P+1)^M,P+1),N>=3&&b.writeUInt8(b.readUInt8(P+2)^U,P+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function c(){const b=(0,v.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,f.tmpdir)(),d=(0,L.$jc)(g,`vscode-ipc-${b}.sock`);return a(d),d}e.$Hh=c;function i(b,g,d){const P=(0,D.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${d}-${g}-sock`;const N=d.substr(0,4),F=g.substr(0,6),M=P.substr(0,8);let U;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?U=(0,L.$jc)(e.$Gh,`vscode-${M}-${N}-${F}.sock`):U=(0,L.$jc)(b,`${N}-${F}.sock`),a(U),U}e.$Ih=i;function a(b){const g=n[I.$u];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class l extends y.$th{static b(g){const d=E.Event.fromNodeEventEmitter(g,"connection");return E.Event.map(d,P=>({protocol:new k.$Ah(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(g){super(l.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=l;function C(b){return new Promise((g,d)=>{const P=(0,T.createServer)();P.on("error",d),P.listen(b,()=>{P.removeListener("error",d),g(new l(P))})})}e.$Kh=C;function S(b,g){return new Promise((d,P)=>{const N=(0,T.createConnection)(b,()=>{N.removeListener("error",P),d(k.$Bh.fromSocket(new p(N,`ipc-client${g}`),g))});N.once("error",P)})}e.$Lh=S}),define(De[369],Ce([1,0,60,63,163,117,8,3,12,50,14,135,248,249,106,86,22]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=e.$n8b=e.$m8b=void 0;async function r(t,n,c,i,a){let l;for(let C=3;C&&(l?.dispose(),l=await new s(t,n,c,i,a).waitForReady(),!(a&&f.$hg[a]||!f.$hg[l.tunnelLocalPort]));C--);return l}class s extends $.$Sc{constructor(n,c,i,a,l){super(),this.m=c,this.n=l,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=D.createServer(),this.c=new A.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=C=>this.r(C),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,c=(0,p.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,f.$ig)(n,2,1e3,c),a=null;return this.b.listen(i,this.m),await this.c.wait(),a=this.b.address(),a||(i=0,this.b.listen(i,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(n){n.pause();const c=(0,p.$cv)(this.tunnelRemoteHost)||(0,p.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$6k)(this.a,c,this.tunnelRemotePort),a=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&n.write(l.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),a instanceof R.$Eh?a.socket.destroy():a.end()}),a instanceof R.$Eh?this.t(n,a):this.s(n,a),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),a.end()})}s(n,c){c.onClose(()=>n.destroy()),c.onEnd(()=>n.end()),c.onData(i=>n.write(i.buffer)),n.on("data",i=>c.write(h.$be.wrap(i))),n.resume()}t(n,c){const i=c.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$m8b=s;let o=class extends p.$hv{constructor(n,c,i,a,l){super(c,l),this.u=n,this.v=i,this.w=a}isPortPrivileged(n){return(0,p.$fv)(n,this.l,E.OS,T.release())}s(n,c,i,a,l,C,S,b){const g=this.r(c,i);if(g)return++g.refcount,g.value;if((0,p.$_u)(n))return this.t(n,c,i,l,C,S,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${i} on local port ${l}.`);const d={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=r(d,a,c,i,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(c,i,P),P}}};e.$n8b=o,e.$n8b=o=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,k.$3k),Be(3,I.$pj),Be(4,w.$ji)],o);let m=class extends o{constructor(n,c,i,a,l){super(n,c,i,a,l)}};e.$o8b=m,e.$o8b=m=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,k.$3k),Be(3,I.$pj),Be(4,w.$ji)],m);let u=class extends $.$Sc{constructor(n,c,i,a,l){super(),this.b=n,this.c=c,this.f=i,this.g=a,this.h=l,this.a=new Map}async openTunnel(n,c,i,a,l,C,S,b,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${a} on local port ${C}.`),!this.a.has(n)){const d=new m(this.b,this.c,this.g,this.f,this.h);this.B(d),this.a.set(n,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(c,i,a,l,C,S,b,g)}};e.$p8b=u,e.$p8b=u=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,I.$pj),Be(3,k.$3k),Be(4,w.$ji)],u)}),define(De[370],Ce([1,0,117,268,53,34,2,14,44]),function($e,e,D,T,f,R,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;class w{constructor(v,y,k){this.b=v,this.c=y,this.f=k,this.a=T.createServer((p,h)=>this.h(p,h)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,y){const k=(h,r)=>{y.writeHead(h,{"content-type":"application/json"}),y.end(JSON.stringify(r||null),s=>s&&this.c.error(s))},p=[];v.setEncoding("utf8"),v.on("data",h=>p.push(h)),v.on("end",async()=>{try{const h=JSON.parse(p.join(""));let r;switch(h.type){case"open":r=await this.i(h);break;case"openExternal":r=await this.j(h);break;case"status":r=await this.l(h);break;case"extensionManagement":r=await this.k(h);break;default:k(404,`Unknown message type: ${h.type}`);break}k(200,r)}catch(h){const r=h instanceof Error?h.message:JSON.stringify(h);k(500,r),this.c.error("Error while processing pipe request",h)}})}async i(v){const{fileURIs:y,folderURIs:k,forceNewWindow:p,diffMode:h,mergeMode:r,addMode:s,forceReuseWindow:o,gotoLineMode:m,waitMarkerFilePath:u,remoteAuthority:t}=v,n=[];if(Array.isArray(k))for(const l of k)try{n.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(y))for(const l of y)try{(0,E.$ii)(l)?n.push({workspaceUri:A.URI.parse(l)}):n.push({fileUri:A.URI.parse(l)})}catch{}const c=u?A.URI.file(u):void 0,a={forceNewWindow:p,diffMode:h,mergeMode:r,addMode:s,gotoLineMode:m,forceReuseWindow:o,preferNewWindow:!o&&!c&&!s,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,a)}async j(v){for(const y of v.uris){const k=A.URI.parse(y),p=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const y=p=>p?.map(h=>/\.vsix$/i.test(h)?A.URI.parse(h):h),k={list:v.list,install:y(v.install),uninstall:y(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$MM=w;let L=class extends w{constructor(v,y){super(v,y,(0,D.$Hh)())}};e.$NM=L,e.$NM=L=He([Be(0,R.$HM),Be(1,$.$0i)],L)}),define(De[371],Ce([1,0,54,358,353,267,46,341,2,18,7,370,100,339,340]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class p extends f.$tec{j(){const s=this,o=globalThis._VSCODE_NODE_MODULES.module,m=o._load;o._load=function(c,i,a){return c=t(c),s.a.has(c)?s.a.get(c).load(c,E.URI.file((0,v.$8p)(i.filename)),l=>m.apply(this,[l,i,a])):m.apply(this,arguments)};const u=o._resolveLookupPaths;o._resolveLookupPaths=(n,c)=>u.call(this,t(n),c);const t=n=>{for(const c of s.b){const i=c(n);if(i){n=i;break}}return n}}}class h extends A.$5cc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$3ec);const s=this.h.invokeFunction(T.$pec);if(this.h.createInstance($.$2ec),this.f.remote.isRemote&&this.f.remote.authority){const u=this.h.createInstance(I.$NM);process.env.VSCODE_IPC_HOOK_CLI=u.ipcHandlePath}this.h.createInstance(k.$4ec),await this.h.createInstance(p,s,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,R.$1ec)(this.j,m,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(s){return s.main}async vb(s,o,m){if(o.scheme!==w.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let u=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const t=s?.identifier.value;s&&await this.w.initializeLocalizedMessages(s);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),u=$e.__$__nodeRequire(o.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return u}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const o in s){const m=s[o];m===null?delete process.env[o]:process.env[o]=m}}}e.$5ec=h}),define(De[372],Ce([1,0,49,22,4,3,120,12,23,2,29,14,247,65,106,86,369,27,20,73,349]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=e.$$ec=e.$0ec=e.$9ec=e.$8ec=e.$7ec=e.$6ec=void 0;function u(g){const d=g.trim().split(`
`),P=[];return d.forEach(F=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((F,M)=>(F[M.socket]=M,F),{})}e.$6ec=u;function t(...g){const d=[].concat(...g.map(c));return[...new Map(d.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$7ec=t;function n(g){let d="";if(g.length===8)for(let P=g.length-2;P>=0;P-=2)d+=parseInt(g.substr(P,2),16),P!==0&&(d+=".");else for(let P=0;P<g.length;P+=8){const N=g.substring(P,P+8);let F="";for(let M=8;M>=2;M-=2)F+=N.substring(M-2,M),(M===6||M===2)&&(F=parseInt(F,16).toString(16),d+=`${F}`,F="",P+M!==g.length-6&&(d+=":"))}return d}e.$8ec=n;function c(g){const d=g.trim().split(`
`),P=d.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return d.map(F=>F.trim().split(/\s+/).reduce((M,U,j)=>(M[P[j]||j]=U,M),{}))}e.$9ec=c;function i(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function a(g){const d=g.trim().split(`
`),P=[];return d.forEach(N=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}e.$0ec=a;async function l(g,d,P){const N=P.reduce((M,U)=>(M[U.pid]=U,M),{}),F=[];return g.forEach(({socket:M,ip:U,port:j})=>{const O=d[M]?d[M].pid:void 0,K=O?N[O]?.cmd:void 0;O&&K&&!i(K)&&F.push({host:U,port:j,detail:K,pid:O})}),F}e.$$ec=l;function C(g,d,P){const N=new Map,F=a(d);for(const M of g){const U=P.get(M.port);if(U){N.set(M.port,U);continue}const j=F.find(O=>O.cmd.includes(`${M.port}`));if(j){let O=j,K;do K=F.find(V=>V.ppid===O.pid),K&&(O=K);while(K);N.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$_ec=C;let S=class extends o.$cwb{constructor(d,P,N,F){super(d,P,N),this.D=P,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,$.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(d){if(d&&this.C)return;this.C=d;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$Rl;let F=0;for(;this.C;){const M=new Date().getTime(),U=(await this.I()).filter(K=>(0,p.$cv)(K.host)||(0,p.$ev)(K.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(K=>K.port).join(", ")}`);const j=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),F++>3&&N.update(j),(!P||JSON.stringify(P)!==JSON.stringify(U))&&(P=U,await this.a.$onFoundNewCandidates(P));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(K=>setTimeout(()=>K(),O))}}G(d){return Math.max(d*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(d=>d.port).join(", ")}`)}async I(){let d="",P="";try{d=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(d,P),F=await new Promise(te=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,Q,le)=>{te(Q)})}),M=u(F),U=await L.Promises.readdir("/proc"),j=[];for(const te of U)try{const G=Number(te),Q=E.$vg(w.URI.file("/proc"),te);if((await L.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(G)){const ie=await L.Promises.readlink(E.$vg(Q,"cwd").fsPath),ce=await L.Promises.readFile(E.$vg(Q,"cmdline").fsPath,"utf8");j.push({pid:G,cwd:ie,cmd:ce})}}catch{}const O=[],K=N.filter(te=>{const G=M[te.socket];return G||O.push(te),G}),V=l(K,M,j);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const te=await new Promise(G=>{(0,D.exec)("ps -F -A -l | grep root",(Q,le,ie)=>{G(le)})});this.z=C(O,te,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(G=>G.port).join(", ")}`)}return V.then(te=>me?te.concat(me):te)}w(d){return async P=>{const N=new h.$m8b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,U,j,O){const K=await d.makeConnection();return b.connect(K,U,j,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Qk(0),connectionToken:d.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const F=new f.$Nd;return{localAddress:(0,m.$KJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{N.dispose(),F.fire(),F.dispose()}}}}};e.$afc=S,e.$afc=S=He([Be(0,s.$lM),Be(1,r.$BM),Be(2,I.$0i),Be(3,k.$3k)],S);class b extends v.$Hkb{static connect(d,P,N,F){const M=new R.$Rc,U={onClose:M.add(new f.$Nd),onData:M.add(new f.$Nd),onEnd:M.add(new f.$Nd)};M.add(d.onDidReceiveMessage(O=>U.onData.fire(T.$be.wrap(O)))),M.add(d.onDidEnd(()=>U.onEnd.fire())),M.add(d.onDidClose(O=>U.onClose.fire({type:0,error:O,hadError:!!O})));const j=new b(d,F,U);return j.B(M),(0,v.$Gkb)(j,P,N,F,U)}constructor(d,P,N){super(P,N),this.n=d}write(d){this.n.send(d.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[373],Ce([1,0,103,344,356,355,368,371,372,94,46,95,93,45,73,90,343,342,14,357,56,262,102,106,138]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r,s,o,m,u,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$wr)(L.$6cc,$.$5ec,0),(0,D.$wr)(s.$$i,r.$cfc,1),(0,D.$wr)(s.$0i,new t.$Mh(u.$sec,[!1],!0)),(0,D.$wr)(n.$3k,c.$r8b,1),(0,D.$wr)(p.$Qcc,h.$bfc,0),(0,D.$wr)(w.$Ddc,R.$Fec,0),(0,D.$wr)(I.$Ndc,A.$Zec,0),(0,D.$wr)(v.$ydc,f.$xec,0),(0,D.$wr)(y.$Scc,T.$wec,0),(0,D.$wr)(k.$bwb,E.$afc,0),(0,D.$wr)(m.$Bdc,o.$dfc,0)}),define(De[384],Ce([1,0,60,385,54,9,82,117,245,111,354,22,29,100,8,130,269,287,359,373]),function($e,e,D,T,f,R,A,$,E,w,L,I,v,y,k,p,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const s=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,l=a._load;a._load=function(C){if(C==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const o=process.exit.bind(process);function m(a){process.exit=function(l){if(a)o(l);else{const C=new Error("An extension called process.exit() and this was prevented.");console.warn(C.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let u=function(a){o()};function t(){const a=(0,r.$Bm)(process.env);if(a.type===3)return new Promise((l,C)=>{const S=b=>{const g=b[0],d=new A.$Ch;g.on("message",P=>d.fire(I.$be.wrap(P.data))),g.on("close",()=>{u("renderer closed the MessagePort")}),g.start(),l({onMessage:d.event,send:P=>g.postMessage(P.buffer)})};process.parentPort.on("message",b=>S(b.ports))});if(a.type===2)return new Promise((l,C)=>{let S=null;const b=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),g=108e5,d=3e5,P=new k.$7g(()=>u("renderer disconnected for too long (1)"),g),N=new k.$7g(()=>u("renderer disconnected for too long (2)"),d);process.on("message",(M,U)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const j=I.$be.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new $.$Eh(U,"extHost-socket");else{const K=I.$be.wrap(Buffer.from(M.inflateBytes,"base64"));O=new $.$Fh(new $.$Eh(U,"extHost-socket"),M.permessageDeflate,K,!1)}S?(P.cancel(),N.cancel(),S.beginAcceptReconnection(O,j),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(b),S=new A.$Dh({socket:O,initialChunk:j}),S.sendResume(),S.onDidDispose(()=>u("renderer disconnected")),l(S),S.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;P.isScheduled()&&N.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const l=a.pipeName;return new Promise((C,S)=>{const b=D.createConnection(l,()=>{b.removeListener("error",S);const g=new A.$Dh({socket:new $.$Eh(b,"extHost-renderer")});g.sendResume(),C(g)});b.once("error",S),b.on("close",()=>{u("renderer closed the socket")})})}}async function n(){const a=await t();return new class{constructor(){this.a=new A.$Ch,this.onMessage=this.a.event,this.b=!1,a.onMessage(l=>{(0,w.$cm)(l,2)?(this.b=!0,u("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||a.send(l)}async drain(){if(a.drain)return a.drain()}}}function c(a){return new Promise(l=>{const C=a.onMessage(S=>{C.dispose();const b=JSON.parse(S.toString()),g=b.commit,d=E.default.commit;if(g&&d&&g!==d&&o(55),b.parentPid){let P=0;setInterval(function(){try{process.kill(b.parentPid,0),P=0}catch(F){F&&F.code==="EPERM"?(P++,P>=3&&u(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):u(`parent process ${b.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(b.parentPid)}catch(F){(0,R.$1)(F)}}a.send((0,w.$bm)(0)),l({protocol:a,initData:b})});a.send((0,w.$bm)(1))})}async function i(){const a=[];process.on("unhandledRejection",(P,N)=>{a.push(N),setTimeout(()=>{const F=a.indexOf(N);F>=0&&N.catch(M=>{a.splice(F,1),(0,R.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,R.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const N=a.indexOf(P);N>=0&&a.splice(N,1)}),process.on("uncaughtException",function(P){(0,R.$Z)(P)||(0,R.$1)(P)}),f.mark("code/extHost/willConnectToRenderer");const l=await n();f.mark("code/extHost/didConnectToRenderer");const C=await c(l);f.mark("code/extHost/didWaitForInitData");const{initData:S}=C;m(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=s.useHostProxy!==void 0?s.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,p.boolean)(s.skipWorkspaceStorageLock,!1);const b=new class{constructor(){this.pid=process.pid}exit(N){o(N)}fsExists(N){return v.Promises.exists(N)}fsRealpath(N){return(0,y.$7p)(N)}};let g=null;S.remote.authority&&s.transformURIs&&(g=(0,h.$Ar)(S.remote.authority));const d=new L.$vec(C.protocol,S,b,g);u=P=>d.terminate(P)}i().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8e11b537e3b091a8b52c7179fb623ecdeecaf4ea/core/vs/workbench/api/node/extensionHostProcess.js.map
